// Copyright 2021 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated code. DO NOT EDIT!

namespace Google.Apis.Compute.v1
{
    /// <summary>The Compute Service.</summary>
    public class ComputeService : Google.Apis.Services.BaseClientService
    {
        /// <summary>The API version.</summary>
        public const string Version = "v1";

        /// <summary>The discovery version used to generate this service.</summary>
        public static Google.Apis.Discovery.DiscoveryVersion DiscoveryVersionUsed = Google.Apis.Discovery.DiscoveryVersion.Version_1_0;

        /// <summary>Constructs a new service.</summary>
        public ComputeService() : this(new Google.Apis.Services.BaseClientService.Initializer())
        {
        }

        /// <summary>Constructs a new service.</summary>
        /// <param name="initializer">The service initializer.</param>
        public ComputeService(Google.Apis.Services.BaseClientService.Initializer initializer) : base(initializer)
        {
            AcceleratorTypes = new AcceleratorTypesResource(this);
            Addresses = new AddressesResource(this);
            Autoscalers = new AutoscalersResource(this);
            BackendBuckets = new BackendBucketsResource(this);
            BackendServices = new BackendServicesResource(this);
            DiskTypes = new DiskTypesResource(this);
            Disks = new DisksResource(this);
            ExternalVpnGateways = new ExternalVpnGatewaysResource(this);
            FirewallPolicies = new FirewallPoliciesResource(this);
            Firewalls = new FirewallsResource(this);
            ForwardingRules = new ForwardingRulesResource(this);
            GlobalAddresses = new GlobalAddressesResource(this);
            GlobalForwardingRules = new GlobalForwardingRulesResource(this);
            GlobalNetworkEndpointGroups = new GlobalNetworkEndpointGroupsResource(this);
            GlobalOperations = new GlobalOperationsResource(this);
            GlobalOrganizationOperations = new GlobalOrganizationOperationsResource(this);
            HealthChecks = new HealthChecksResource(this);
            HttpHealthChecks = new HttpHealthChecksResource(this);
            HttpsHealthChecks = new HttpsHealthChecksResource(this);
            Images = new ImagesResource(this);
            InstanceGroupManagers = new InstanceGroupManagersResource(this);
            InstanceGroups = new InstanceGroupsResource(this);
            InstanceTemplates = new InstanceTemplatesResource(this);
            Instances = new InstancesResource(this);
            InterconnectAttachments = new InterconnectAttachmentsResource(this);
            InterconnectLocations = new InterconnectLocationsResource(this);
            Interconnects = new InterconnectsResource(this);
            LicenseCodes = new LicenseCodesResource(this);
            Licenses = new LicensesResource(this);
            MachineTypes = new MachineTypesResource(this);
            NetworkEndpointGroups = new NetworkEndpointGroupsResource(this);
            Networks = new NetworksResource(this);
            NodeGroups = new NodeGroupsResource(this);
            NodeTemplates = new NodeTemplatesResource(this);
            NodeTypes = new NodeTypesResource(this);
            PacketMirrorings = new PacketMirroringsResource(this);
            Projects = new ProjectsResource(this);
            RegionAutoscalers = new RegionAutoscalersResource(this);
            RegionBackendServices = new RegionBackendServicesResource(this);
            RegionCommitments = new RegionCommitmentsResource(this);
            RegionDiskTypes = new RegionDiskTypesResource(this);
            RegionDisks = new RegionDisksResource(this);
            RegionHealthCheckServices = new RegionHealthCheckServicesResource(this);
            RegionHealthChecks = new RegionHealthChecksResource(this);
            RegionInstanceGroupManagers = new RegionInstanceGroupManagersResource(this);
            RegionInstanceGroups = new RegionInstanceGroupsResource(this);
            RegionInstances = new RegionInstancesResource(this);
            RegionNetworkEndpointGroups = new RegionNetworkEndpointGroupsResource(this);
            RegionNotificationEndpoints = new RegionNotificationEndpointsResource(this);
            RegionOperations = new RegionOperationsResource(this);
            RegionSslCertificates = new RegionSslCertificatesResource(this);
            RegionTargetHttpProxies = new RegionTargetHttpProxiesResource(this);
            RegionTargetHttpsProxies = new RegionTargetHttpsProxiesResource(this);
            RegionUrlMaps = new RegionUrlMapsResource(this);
            Regions = new RegionsResource(this);
            Reservations = new ReservationsResource(this);
            ResourcePolicies = new ResourcePoliciesResource(this);
            Routers = new RoutersResource(this);
            Routes = new RoutesResource(this);
            SecurityPolicies = new SecurityPoliciesResource(this);
            Snapshots = new SnapshotsResource(this);
            SslCertificates = new SslCertificatesResource(this);
            SslPolicies = new SslPoliciesResource(this);
            Subnetworks = new SubnetworksResource(this);
            TargetGrpcProxies = new TargetGrpcProxiesResource(this);
            TargetHttpProxies = new TargetHttpProxiesResource(this);
            TargetHttpsProxies = new TargetHttpsProxiesResource(this);
            TargetInstances = new TargetInstancesResource(this);
            TargetPools = new TargetPoolsResource(this);
            TargetSslProxies = new TargetSslProxiesResource(this);
            TargetTcpProxies = new TargetTcpProxiesResource(this);
            TargetVpnGateways = new TargetVpnGatewaysResource(this);
            UrlMaps = new UrlMapsResource(this);
            VpnGateways = new VpnGatewaysResource(this);
            VpnTunnels = new VpnTunnelsResource(this);
            ZoneOperations = new ZoneOperationsResource(this);
            Zones = new ZonesResource(this);
        }

        /// <summary>Gets the service supported features.</summary>
        public override System.Collections.Generic.IList<string> Features => new string[0];

        /// <summary>Gets the service name.</summary>
        public override string Name => "compute";

        /// <summary>Gets the service base URI.</summary>
        public override string BaseUri =>
        #if NETSTANDARD1_3 || NETSTANDARD2_0 || NET45
            BaseUriOverride ?? "https://compute.googleapis.com/compute/v1/";
        #else
            "https://compute.googleapis.com/compute/v1/";
        #endif

        /// <summary>Gets the service base path.</summary>
        public override string BasePath => "compute/v1/";

        #if !NET40
        /// <summary>Gets the batch base URI; <c>null</c> if unspecified.</summary>
        public override string BatchUri => "https://compute.googleapis.com/batch/compute/v1";

        /// <summary>Gets the batch base path; <c>null</c> if unspecified.</summary>
        public override string BatchPath => "batch/compute/v1";
        #endif

        /// <summary>Available OAuth 2.0 scopes for use with the Compute Engine API.</summary>
        public class Scope
        {
            /// <summary>View and manage your data across Google Cloud Platform services</summary>
            public static string CloudPlatform = "https://www.googleapis.com/auth/cloud-platform";

            /// <summary>View and manage your Google Compute Engine resources</summary>
            public static string Compute = "https://www.googleapis.com/auth/compute";

            /// <summary>View your Google Compute Engine resources</summary>
            public static string ComputeReadonly = "https://www.googleapis.com/auth/compute.readonly";

            /// <summary>Manage your data and permissions in Google Cloud Storage</summary>
            public static string DevstorageFullControl = "https://www.googleapis.com/auth/devstorage.full_control";

            /// <summary>View your data in Google Cloud Storage</summary>
            public static string DevstorageReadOnly = "https://www.googleapis.com/auth/devstorage.read_only";

            /// <summary>Manage your data in Google Cloud Storage</summary>
            public static string DevstorageReadWrite = "https://www.googleapis.com/auth/devstorage.read_write";
        }

        /// <summary>Available OAuth 2.0 scope constants for use with the Compute Engine API.</summary>
        public static class ScopeConstants
        {
            /// <summary>View and manage your data across Google Cloud Platform services</summary>
            public const string CloudPlatform = "https://www.googleapis.com/auth/cloud-platform";

            /// <summary>View and manage your Google Compute Engine resources</summary>
            public const string Compute = "https://www.googleapis.com/auth/compute";

            /// <summary>View your Google Compute Engine resources</summary>
            public const string ComputeReadonly = "https://www.googleapis.com/auth/compute.readonly";

            /// <summary>Manage your data and permissions in Google Cloud Storage</summary>
            public const string DevstorageFullControl = "https://www.googleapis.com/auth/devstorage.full_control";

            /// <summary>View your data in Google Cloud Storage</summary>
            public const string DevstorageReadOnly = "https://www.googleapis.com/auth/devstorage.read_only";

            /// <summary>Manage your data in Google Cloud Storage</summary>
            public const string DevstorageReadWrite = "https://www.googleapis.com/auth/devstorage.read_write";
        }

        /// <summary>Gets the AcceleratorTypes resource.</summary>
        public virtual AcceleratorTypesResource AcceleratorTypes { get; }

        /// <summary>Gets the Addresses resource.</summary>
        public virtual AddressesResource Addresses { get; }

        /// <summary>Gets the Autoscalers resource.</summary>
        public virtual AutoscalersResource Autoscalers { get; }

        /// <summary>Gets the BackendBuckets resource.</summary>
        public virtual BackendBucketsResource BackendBuckets { get; }

        /// <summary>Gets the BackendServices resource.</summary>
        public virtual BackendServicesResource BackendServices { get; }

        /// <summary>Gets the DiskTypes resource.</summary>
        public virtual DiskTypesResource DiskTypes { get; }

        /// <summary>Gets the Disks resource.</summary>
        public virtual DisksResource Disks { get; }

        /// <summary>Gets the ExternalVpnGateways resource.</summary>
        public virtual ExternalVpnGatewaysResource ExternalVpnGateways { get; }

        /// <summary>Gets the FirewallPolicies resource.</summary>
        public virtual FirewallPoliciesResource FirewallPolicies { get; }

        /// <summary>Gets the Firewalls resource.</summary>
        public virtual FirewallsResource Firewalls { get; }

        /// <summary>Gets the ForwardingRules resource.</summary>
        public virtual ForwardingRulesResource ForwardingRules { get; }

        /// <summary>Gets the GlobalAddresses resource.</summary>
        public virtual GlobalAddressesResource GlobalAddresses { get; }

        /// <summary>Gets the GlobalForwardingRules resource.</summary>
        public virtual GlobalForwardingRulesResource GlobalForwardingRules { get; }

        /// <summary>Gets the GlobalNetworkEndpointGroups resource.</summary>
        public virtual GlobalNetworkEndpointGroupsResource GlobalNetworkEndpointGroups { get; }

        /// <summary>Gets the GlobalOperations resource.</summary>
        public virtual GlobalOperationsResource GlobalOperations { get; }

        /// <summary>Gets the GlobalOrganizationOperations resource.</summary>
        public virtual GlobalOrganizationOperationsResource GlobalOrganizationOperations { get; }

        /// <summary>Gets the HealthChecks resource.</summary>
        public virtual HealthChecksResource HealthChecks { get; }

        /// <summary>Gets the HttpHealthChecks resource.</summary>
        public virtual HttpHealthChecksResource HttpHealthChecks { get; }

        /// <summary>Gets the HttpsHealthChecks resource.</summary>
        public virtual HttpsHealthChecksResource HttpsHealthChecks { get; }

        /// <summary>Gets the Images resource.</summary>
        public virtual ImagesResource Images { get; }

        /// <summary>Gets the InstanceGroupManagers resource.</summary>
        public virtual InstanceGroupManagersResource InstanceGroupManagers { get; }

        /// <summary>Gets the InstanceGroups resource.</summary>
        public virtual InstanceGroupsResource InstanceGroups { get; }

        /// <summary>Gets the InstanceTemplates resource.</summary>
        public virtual InstanceTemplatesResource InstanceTemplates { get; }

        /// <summary>Gets the Instances resource.</summary>
        public virtual InstancesResource Instances { get; }

        /// <summary>Gets the InterconnectAttachments resource.</summary>
        public virtual InterconnectAttachmentsResource InterconnectAttachments { get; }

        /// <summary>Gets the InterconnectLocations resource.</summary>
        public virtual InterconnectLocationsResource InterconnectLocations { get; }

        /// <summary>Gets the Interconnects resource.</summary>
        public virtual InterconnectsResource Interconnects { get; }

        /// <summary>Gets the LicenseCodes resource.</summary>
        public virtual LicenseCodesResource LicenseCodes { get; }

        /// <summary>Gets the Licenses resource.</summary>
        public virtual LicensesResource Licenses { get; }

        /// <summary>Gets the MachineTypes resource.</summary>
        public virtual MachineTypesResource MachineTypes { get; }

        /// <summary>Gets the NetworkEndpointGroups resource.</summary>
        public virtual NetworkEndpointGroupsResource NetworkEndpointGroups { get; }

        /// <summary>Gets the Networks resource.</summary>
        public virtual NetworksResource Networks { get; }

        /// <summary>Gets the NodeGroups resource.</summary>
        public virtual NodeGroupsResource NodeGroups { get; }

        /// <summary>Gets the NodeTemplates resource.</summary>
        public virtual NodeTemplatesResource NodeTemplates { get; }

        /// <summary>Gets the NodeTypes resource.</summary>
        public virtual NodeTypesResource NodeTypes { get; }

        /// <summary>Gets the PacketMirrorings resource.</summary>
        public virtual PacketMirroringsResource PacketMirrorings { get; }

        /// <summary>Gets the Projects resource.</summary>
        public virtual ProjectsResource Projects { get; }

        /// <summary>Gets the RegionAutoscalers resource.</summary>
        public virtual RegionAutoscalersResource RegionAutoscalers { get; }

        /// <summary>Gets the RegionBackendServices resource.</summary>
        public virtual RegionBackendServicesResource RegionBackendServices { get; }

        /// <summary>Gets the RegionCommitments resource.</summary>
        public virtual RegionCommitmentsResource RegionCommitments { get; }

        /// <summary>Gets the RegionDiskTypes resource.</summary>
        public virtual RegionDiskTypesResource RegionDiskTypes { get; }

        /// <summary>Gets the RegionDisks resource.</summary>
        public virtual RegionDisksResource RegionDisks { get; }

        /// <summary>Gets the RegionHealthCheckServices resource.</summary>
        public virtual RegionHealthCheckServicesResource RegionHealthCheckServices { get; }

        /// <summary>Gets the RegionHealthChecks resource.</summary>
        public virtual RegionHealthChecksResource RegionHealthChecks { get; }

        /// <summary>Gets the RegionInstanceGroupManagers resource.</summary>
        public virtual RegionInstanceGroupManagersResource RegionInstanceGroupManagers { get; }

        /// <summary>Gets the RegionInstanceGroups resource.</summary>
        public virtual RegionInstanceGroupsResource RegionInstanceGroups { get; }

        /// <summary>Gets the RegionInstances resource.</summary>
        public virtual RegionInstancesResource RegionInstances { get; }

        /// <summary>Gets the RegionNetworkEndpointGroups resource.</summary>
        public virtual RegionNetworkEndpointGroupsResource RegionNetworkEndpointGroups { get; }

        /// <summary>Gets the RegionNotificationEndpoints resource.</summary>
        public virtual RegionNotificationEndpointsResource RegionNotificationEndpoints { get; }

        /// <summary>Gets the RegionOperations resource.</summary>
        public virtual RegionOperationsResource RegionOperations { get; }

        /// <summary>Gets the RegionSslCertificates resource.</summary>
        public virtual RegionSslCertificatesResource RegionSslCertificates { get; }

        /// <summary>Gets the RegionTargetHttpProxies resource.</summary>
        public virtual RegionTargetHttpProxiesResource RegionTargetHttpProxies { get; }

        /// <summary>Gets the RegionTargetHttpsProxies resource.</summary>
        public virtual RegionTargetHttpsProxiesResource RegionTargetHttpsProxies { get; }

        /// <summary>Gets the RegionUrlMaps resource.</summary>
        public virtual RegionUrlMapsResource RegionUrlMaps { get; }

        /// <summary>Gets the Regions resource.</summary>
        public virtual RegionsResource Regions { get; }

        /// <summary>Gets the Reservations resource.</summary>
        public virtual ReservationsResource Reservations { get; }

        /// <summary>Gets the ResourcePolicies resource.</summary>
        public virtual ResourcePoliciesResource ResourcePolicies { get; }

        /// <summary>Gets the Routers resource.</summary>
        public virtual RoutersResource Routers { get; }

        /// <summary>Gets the Routes resource.</summary>
        public virtual RoutesResource Routes { get; }

        /// <summary>Gets the SecurityPolicies resource.</summary>
        public virtual SecurityPoliciesResource SecurityPolicies { get; }

        /// <summary>Gets the Snapshots resource.</summary>
        public virtual SnapshotsResource Snapshots { get; }

        /// <summary>Gets the SslCertificates resource.</summary>
        public virtual SslCertificatesResource SslCertificates { get; }

        /// <summary>Gets the SslPolicies resource.</summary>
        public virtual SslPoliciesResource SslPolicies { get; }

        /// <summary>Gets the Subnetworks resource.</summary>
        public virtual SubnetworksResource Subnetworks { get; }

        /// <summary>Gets the TargetGrpcProxies resource.</summary>
        public virtual TargetGrpcProxiesResource TargetGrpcProxies { get; }

        /// <summary>Gets the TargetHttpProxies resource.</summary>
        public virtual TargetHttpProxiesResource TargetHttpProxies { get; }

        /// <summary>Gets the TargetHttpsProxies resource.</summary>
        public virtual TargetHttpsProxiesResource TargetHttpsProxies { get; }

        /// <summary>Gets the TargetInstances resource.</summary>
        public virtual TargetInstancesResource TargetInstances { get; }

        /// <summary>Gets the TargetPools resource.</summary>
        public virtual TargetPoolsResource TargetPools { get; }

        /// <summary>Gets the TargetSslProxies resource.</summary>
        public virtual TargetSslProxiesResource TargetSslProxies { get; }

        /// <summary>Gets the TargetTcpProxies resource.</summary>
        public virtual TargetTcpProxiesResource TargetTcpProxies { get; }

        /// <summary>Gets the TargetVpnGateways resource.</summary>
        public virtual TargetVpnGatewaysResource TargetVpnGateways { get; }

        /// <summary>Gets the UrlMaps resource.</summary>
        public virtual UrlMapsResource UrlMaps { get; }

        /// <summary>Gets the VpnGateways resource.</summary>
        public virtual VpnGatewaysResource VpnGateways { get; }

        /// <summary>Gets the VpnTunnels resource.</summary>
        public virtual VpnTunnelsResource VpnTunnels { get; }

        /// <summary>Gets the ZoneOperations resource.</summary>
        public virtual ZoneOperationsResource ZoneOperations { get; }

        /// <summary>Gets the Zones resource.</summary>
        public virtual ZonesResource Zones { get; }
    }

    /// <summary>A base abstract class for Compute requests.</summary>
    public abstract class ComputeBaseServiceRequest<TResponse> : Google.Apis.Requests.ClientServiceRequest<TResponse>
    {
        /// <summary>Constructs a new ComputeBaseServiceRequest instance.</summary>
        protected ComputeBaseServiceRequest(Google.Apis.Services.IClientService service) : base(service)
        {
        }

        /// <summary>Data format for the response.</summary>
        [Google.Apis.Util.RequestParameterAttribute("alt", Google.Apis.Util.RequestParameterType.Query)]
        public virtual System.Nullable<AltEnum> Alt { get; set; }

        /// <summary>Data format for the response.</summary>
        public enum AltEnum
        {
            /// <summary>Responses with Content-Type of application/json</summary>
            [Google.Apis.Util.StringValueAttribute("json")]
            Json,
        }

        /// <summary>Selector specifying which fields to include in a partial response.</summary>
        [Google.Apis.Util.RequestParameterAttribute("fields", Google.Apis.Util.RequestParameterType.Query)]
        public virtual string Fields { get; set; }

        /// <summary>
        /// API key. Your API key identifies your project and provides you with API access, quota, and reports. Required
        /// unless you provide an OAuth 2.0 token.
        /// </summary>
        [Google.Apis.Util.RequestParameterAttribute("key", Google.Apis.Util.RequestParameterType.Query)]
        public virtual string Key { get; set; }

        /// <summary>OAuth 2.0 token for the current user.</summary>
        [Google.Apis.Util.RequestParameterAttribute("oauth_token", Google.Apis.Util.RequestParameterType.Query)]
        public virtual string OauthToken { get; set; }

        /// <summary>Returns response with indentations and line breaks.</summary>
        [Google.Apis.Util.RequestParameterAttribute("prettyPrint", Google.Apis.Util.RequestParameterType.Query)]
        public virtual System.Nullable<bool> PrettyPrint { get; set; }

        /// <summary>
        /// An opaque string that represents a user for quota purposes. Must not exceed 40 characters.
        /// </summary>
        [Google.Apis.Util.RequestParameterAttribute("quotaUser", Google.Apis.Util.RequestParameterType.Query)]
        public virtual string QuotaUser { get; set; }

        /// <summary>Deprecated. Please use quotaUser instead.</summary>
        [Google.Apis.Util.RequestParameterAttribute("userIp", Google.Apis.Util.RequestParameterType.Query)]
        public virtual string UserIp { get; set; }

        /// <summary>Initializes Compute parameter list.</summary>
        protected override void InitParameters()
        {
            base.InitParameters();
            RequestParameters.Add("alt", new Google.Apis.Discovery.Parameter
            {
                Name = "alt",
                IsRequired = false,
                ParameterType = "query",
                DefaultValue = "json",
                Pattern = null,
            });
            RequestParameters.Add("fields", new Google.Apis.Discovery.Parameter
            {
                Name = "fields",
                IsRequired = false,
                ParameterType = "query",
                DefaultValue = null,
                Pattern = null,
            });
            RequestParameters.Add("key", new Google.Apis.Discovery.Parameter
            {
                Name = "key",
                IsRequired = false,
                ParameterType = "query",
                DefaultValue = null,
                Pattern = null,
            });
            RequestParameters.Add("oauth_token", new Google.Apis.Discovery.Parameter
            {
                Name = "oauth_token",
                IsRequired = false,
                ParameterType = "query",
                DefaultValue = null,
                Pattern = null,
            });
            RequestParameters.Add("prettyPrint", new Google.Apis.Discovery.Parameter
            {
                Name = "prettyPrint",
                IsRequired = false,
                ParameterType = "query",
                DefaultValue = "true",
                Pattern = null,
            });
            RequestParameters.Add("quotaUser", new Google.Apis.Discovery.Parameter
            {
                Name = "quotaUser",
                IsRequired = false,
                ParameterType = "query",
                DefaultValue = null,
                Pattern = null,
            });
            RequestParameters.Add("userIp", new Google.Apis.Discovery.Parameter
            {
                Name = "userIp",
                IsRequired = false,
                ParameterType = "query",
                DefaultValue = null,
                Pattern = null,
            });
        }
    }

    /// <summary>The "acceleratorTypes" collection of methods.</summary>
    public class AcceleratorTypesResource
    {
        private const string Resource = "acceleratorTypes";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public AcceleratorTypesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of accelerator types.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of accelerator types.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.AcceleratorTypeAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/acceleratorTypes";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified accelerator type.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="acceleratorType">Name of the accelerator type to return.</param>
        public virtual GetRequest Get(string project, string zone, string acceleratorType)
        {
            return new GetRequest(service, project, zone, acceleratorType);
        }

        /// <summary>Returns the specified accelerator type.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.AcceleratorType>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string acceleratorType) : base(service)
            {
                Project = project;
                Zone = zone;
                AcceleratorType = acceleratorType;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the accelerator type to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("acceleratorType", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string AcceleratorType { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/acceleratorTypes/{acceleratorType}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("acceleratorType", new Google.Apis.Discovery.Parameter
                {
                    Name = "acceleratorType",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves a list of accelerator types that are available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>Retrieves a list of accelerator types that are available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.AcceleratorTypeList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/acceleratorTypes";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "addresses" collection of methods.</summary>
    public class AddressesResource
    {
        private const string Resource = "addresses";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public AddressesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of addresses.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of addresses.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.AddressAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/addresses";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified address resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="address">Name of the address resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string address)
        {
            return new DeleteRequest(service, project, region, address);
        }

        /// <summary>Deletes the specified address resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string address) : base(service)
            {
                Project = project;
                Region = region;
                Address = address;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the address resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("address", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Address { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/addresses/{address}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("address", new Google.Apis.Discovery.Parameter
                {
                    Name = "address",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified address resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="address">Name of the address resource to return.</param>
        public virtual GetRequest Get(string project, string region, string address)
        {
            return new GetRequest(service, project, region, address);
        }

        /// <summary>Returns the specified address resource.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Address>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string address) : base(service)
            {
                Project = project;
                Region = region;
                Address = address;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the address resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("address", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Address { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/addresses/{address}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("address", new Google.Apis.Discovery.Parameter
                {
                    Name = "address",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates an address resource in the specified project by using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Address body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates an address resource in the specified project by using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Address body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Address Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/addresses";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of addresses contained within the specified region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves a list of addresses contained within the specified region.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.AddressList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/addresses";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "autoscalers" collection of methods.</summary>
    public class AutoscalersResource
    {
        private const string Resource = "autoscalers";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public AutoscalersResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of autoscalers.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of autoscalers.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.AutoscalerAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/autoscalers";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified autoscaler.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        /// <param name="autoscaler">Name of the autoscaler to delete.</param>
        public virtual DeleteRequest Delete(string project, string zone, string autoscaler)
        {
            return new DeleteRequest(service, project, zone, autoscaler);
        }

        /// <summary>Deletes the specified autoscaler.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string zone, string autoscaler) : base(service)
            {
                Project = project;
                Zone = zone;
                Autoscaler = autoscaler;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the autoscaler to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("autoscaler", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Autoscaler { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/autoscalers/{autoscaler}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("autoscaler", new Google.Apis.Discovery.Parameter
                {
                    Name = "autoscaler",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified autoscaler resource. Gets a list of available autoscalers by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        /// <param name="autoscaler">Name of the autoscaler to return.</param>
        public virtual GetRequest Get(string project, string zone, string autoscaler)
        {
            return new GetRequest(service, project, zone, autoscaler);
        }

        /// <summary>
        /// Returns the specified autoscaler resource. Gets a list of available autoscalers by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Autoscaler>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string autoscaler) : base(service)
            {
                Project = project;
                Zone = zone;
                Autoscaler = autoscaler;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the autoscaler to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("autoscaler", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Autoscaler { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/autoscalers/{autoscaler}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("autoscaler", new Google.Apis.Discovery.Parameter
                {
                    Name = "autoscaler",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Creates an autoscaler in the specified project using the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Autoscaler body, string project, string zone)
        {
            return new InsertRequest(service, body, project, zone);
        }

        /// <summary>Creates an autoscaler in the specified project using the data included in the request.</summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Autoscaler body, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Autoscaler Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/autoscalers";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of autoscalers contained within the specified zone.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>Retrieves a list of autoscalers contained within the specified zone.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.AutoscalerList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/autoscalers";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates an autoscaler in the specified project using the data included in the request. This method supports
        /// PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.Autoscaler body, string project, string zone)
        {
            return new PatchRequest(service, body, project, zone);
        }

        /// <summary>
        /// Updates an autoscaler in the specified project using the data included in the request. This method supports
        /// PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Autoscaler body, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the autoscaler to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("autoscaler", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Autoscaler { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Autoscaler Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/autoscalers";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("autoscaler", new Google.Apis.Discovery.Parameter
                {
                    Name = "autoscaler",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Updates an autoscaler in the specified project using the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.Autoscaler body, string project, string zone)
        {
            return new UpdateRequest(service, body, project, zone);
        }

        /// <summary>Updates an autoscaler in the specified project using the data included in the request.</summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Autoscaler body, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the autoscaler to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("autoscaler", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Autoscaler { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Autoscaler Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/autoscalers";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("autoscaler", new Google.Apis.Discovery.Parameter
                {
                    Name = "autoscaler",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "backendBuckets" collection of methods.</summary>
    public class BackendBucketsResource
    {
        private const string Resource = "backendBuckets";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public BackendBucketsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Adds a key for validating requests with signed URLs for this backend bucket.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="backendBucket">
        /// Name of the BackendBucket resource to which the Signed URL Key should be added. The name should conform to
        /// RFC1035.
        /// </param>
        public virtual AddSignedUrlKeyRequest AddSignedUrlKey(Google.Apis.Compute.v1.Data.SignedUrlKey body, string project, string backendBucket)
        {
            return new AddSignedUrlKeyRequest(service, body, project, backendBucket);
        }

        /// <summary>Adds a key for validating requests with signed URLs for this backend bucket.</summary>
        public class AddSignedUrlKeyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddSignedUrlKey request.</summary>
            public AddSignedUrlKeyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SignedUrlKey body, string project, string backendBucket) : base(service)
            {
                Project = project;
                BackendBucket = backendBucket;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// Name of the BackendBucket resource to which the Signed URL Key should be added. The name should conform
            /// to RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("backendBucket", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendBucket { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SignedUrlKey Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addSignedUrlKey";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendBuckets/{backendBucket}/addSignedUrlKey";

            /// <summary>Initializes AddSignedUrlKey parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendBucket", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendBucket",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified BackendBucket resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="backendBucket">Name of the BackendBucket resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string backendBucket)
        {
            return new DeleteRequest(service, project, backendBucket);
        }

        /// <summary>Deletes the specified BackendBucket resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string backendBucket) : base(service)
            {
                Project = project;
                BackendBucket = backendBucket;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the BackendBucket resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendBucket", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendBucket { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendBuckets/{backendBucket}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendBucket", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendBucket",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes a key for validating requests with signed URLs for this backend bucket.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="backendBucket">
        /// Name of the BackendBucket resource to which the Signed URL Key should be added. The name should conform to
        /// RFC1035.
        /// </param>
        /// <param name="keyName">The name of the Signed URL Key to delete.</param>
        public virtual DeleteSignedUrlKeyRequest DeleteSignedUrlKey(string project, string backendBucket, string keyName)
        {
            return new DeleteSignedUrlKeyRequest(service, project, backendBucket, keyName);
        }

        /// <summary>Deletes a key for validating requests with signed URLs for this backend bucket.</summary>
        public class DeleteSignedUrlKeyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new DeleteSignedUrlKey request.</summary>
            public DeleteSignedUrlKeyRequest(Google.Apis.Services.IClientService service, string project, string backendBucket, string keyName) : base(service)
            {
                Project = project;
                BackendBucket = backendBucket;
                KeyName = keyName;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// Name of the BackendBucket resource to which the Signed URL Key should be added. The name should conform
            /// to RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("backendBucket", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendBucket { get; private set; }

            /// <summary>The name of the Signed URL Key to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("keyName", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string KeyName { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "deleteSignedUrlKey";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendBuckets/{backendBucket}/deleteSignedUrlKey";

            /// <summary>Initializes DeleteSignedUrlKey parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendBucket", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendBucket",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("keyName", new Google.Apis.Discovery.Parameter
                {
                    Name = "keyName",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified BackendBucket resource. Gets a list of available backend buckets by making a list()
        /// request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="backendBucket">Name of the BackendBucket resource to return.</param>
        public virtual GetRequest Get(string project, string backendBucket)
        {
            return new GetRequest(service, project, backendBucket);
        }

        /// <summary>
        /// Returns the specified BackendBucket resource. Gets a list of available backend buckets by making a list()
        /// request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.BackendBucket>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string backendBucket) : base(service)
            {
                Project = project;
                BackendBucket = backendBucket;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the BackendBucket resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendBucket", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendBucket { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendBuckets/{backendBucket}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendBucket", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendBucket",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a BackendBucket resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.BackendBucket body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a BackendBucket resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.BackendBucket body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.BackendBucket Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendBuckets";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of BackendBucket resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of BackendBucket resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.BackendBucketList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendBuckets";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the specified BackendBucket resource with the data included in the request. This method supports
        /// PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="backendBucket">Name of the BackendBucket resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.BackendBucket body, string project, string backendBucket)
        {
            return new PatchRequest(service, body, project, backendBucket);
        }

        /// <summary>
        /// Updates the specified BackendBucket resource with the data included in the request. This method supports
        /// PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.BackendBucket body, string project, string backendBucket) : base(service)
            {
                Project = project;
                BackendBucket = backendBucket;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the BackendBucket resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendBucket", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendBucket { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.BackendBucket Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendBuckets/{backendBucket}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendBucket", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendBucket",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Updates the specified BackendBucket resource with the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="backendBucket">Name of the BackendBucket resource to update.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.BackendBucket body, string project, string backendBucket)
        {
            return new UpdateRequest(service, body, project, backendBucket);
        }

        /// <summary>Updates the specified BackendBucket resource with the data included in the request.</summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.BackendBucket body, string project, string backendBucket) : base(service)
            {
                Project = project;
                BackendBucket = backendBucket;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the BackendBucket resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendBucket", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendBucket { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.BackendBucket Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendBuckets/{backendBucket}";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendBucket", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendBucket",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "backendServices" collection of methods.</summary>
    public class BackendServicesResource
    {
        private const string Resource = "backendServices";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public BackendServicesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Adds a key for validating requests with signed URLs for this backend service.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="backendService">
        /// Name of the BackendService resource to which the Signed URL Key should be added. The name should conform to
        /// RFC1035.
        /// </param>
        public virtual AddSignedUrlKeyRequest AddSignedUrlKey(Google.Apis.Compute.v1.Data.SignedUrlKey body, string project, string backendService)
        {
            return new AddSignedUrlKeyRequest(service, body, project, backendService);
        }

        /// <summary>Adds a key for validating requests with signed URLs for this backend service.</summary>
        public class AddSignedUrlKeyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddSignedUrlKey request.</summary>
            public AddSignedUrlKeyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SignedUrlKey body, string project, string backendService) : base(service)
            {
                Project = project;
                BackendService = backendService;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// Name of the BackendService resource to which the Signed URL Key should be added. The name should conform
            /// to RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("backendService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendService { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SignedUrlKey Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addSignedUrlKey";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendServices/{backendService}/addSignedUrlKey";

            /// <summary>Initializes AddSignedUrlKey parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendService", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves the list of all BackendService resources, regional and global, available to the specified project.
        /// </summary>
        /// <param name="project">Name of the project scoping this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>
        /// Retrieves the list of all BackendService resources, regional and global, available to the specified project.
        /// </summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.BackendServiceAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Name of the project scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/backendServices";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified BackendService resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="backendService">Name of the BackendService resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string backendService)
        {
            return new DeleteRequest(service, project, backendService);
        }

        /// <summary>Deletes the specified BackendService resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string backendService) : base(service)
            {
                Project = project;
                BackendService = backendService;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the BackendService resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendService { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendServices/{backendService}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendService", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes a key for validating requests with signed URLs for this backend service.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="backendService">
        /// Name of the BackendService resource to which the Signed URL Key should be added. The name should conform to
        /// RFC1035.
        /// </param>
        /// <param name="keyName">The name of the Signed URL Key to delete.</param>
        public virtual DeleteSignedUrlKeyRequest DeleteSignedUrlKey(string project, string backendService, string keyName)
        {
            return new DeleteSignedUrlKeyRequest(service, project, backendService, keyName);
        }

        /// <summary>Deletes a key for validating requests with signed URLs for this backend service.</summary>
        public class DeleteSignedUrlKeyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new DeleteSignedUrlKey request.</summary>
            public DeleteSignedUrlKeyRequest(Google.Apis.Services.IClientService service, string project, string backendService, string keyName) : base(service)
            {
                Project = project;
                BackendService = backendService;
                KeyName = keyName;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// Name of the BackendService resource to which the Signed URL Key should be added. The name should conform
            /// to RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("backendService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendService { get; private set; }

            /// <summary>The name of the Signed URL Key to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("keyName", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string KeyName { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "deleteSignedUrlKey";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendServices/{backendService}/deleteSignedUrlKey";

            /// <summary>Initializes DeleteSignedUrlKey parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendService", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("keyName", new Google.Apis.Discovery.Parameter
                {
                    Name = "keyName",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified BackendService resource. Gets a list of available backend services.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="backendService">Name of the BackendService resource to return.</param>
        public virtual GetRequest Get(string project, string backendService)
        {
            return new GetRequest(service, project, backendService);
        }

        /// <summary>Returns the specified BackendService resource. Gets a list of available backend services.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.BackendService>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string backendService) : base(service)
            {
                Project = project;
                BackendService = backendService;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the BackendService resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendService { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendServices/{backendService}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendService", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Gets the most recent health check results for this BackendService.  Example request body:  { "group":
        /// "/zones/us-east1-b/instanceGroups/lb-backend-example" }
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project"><c>null</c></param>
        /// <param name="backendService">
        /// Name of the BackendService resource to which the queried instance belongs.
        /// </param>
        public virtual GetHealthRequest GetHealth(Google.Apis.Compute.v1.Data.ResourceGroupReference body, string project, string backendService)
        {
            return new GetHealthRequest(service, body, project, backendService);
        }

        /// <summary>
        /// Gets the most recent health check results for this BackendService.  Example request body:  { "group":
        /// "/zones/us-east1-b/instanceGroups/lb-backend-example" }
        /// </summary>
        public class GetHealthRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.BackendServiceGroupHealth>
        {
            /// <summary>Constructs a new GetHealth request.</summary>
            public GetHealthRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ResourceGroupReference body, string project, string backendService) : base(service)
            {
                Project = project;
                BackendService = backendService;
                Body = body;
                InitParameters();
            }

            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the BackendService resource to which the queried instance belongs.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendService { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ResourceGroupReference Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getHealth";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendServices/{backendService}/getHealth";

            /// <summary>Initializes GetHealth parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendService", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a BackendService resource in the specified project using the data included in the request. For more
        /// information, see  Backend services overview.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.BackendService body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a BackendService resource in the specified project using the data included in the request. For more
        /// information, see  Backend services overview.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.BackendService body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.BackendService Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendServices";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of BackendService resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of BackendService resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.BackendServiceList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendServices";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Patches the specified BackendService resource with the data included in the request. For more information,
        /// see  Backend services overview. This method supports PATCH semantics and uses the JSON merge patch format
        /// and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="backendService">Name of the BackendService resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.BackendService body, string project, string backendService)
        {
            return new PatchRequest(service, body, project, backendService);
        }

        /// <summary>
        /// Patches the specified BackendService resource with the data included in the request. For more information,
        /// see  Backend services overview. This method supports PATCH semantics and uses the JSON merge patch format
        /// and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.BackendService body, string project, string backendService) : base(service)
            {
                Project = project;
                BackendService = backendService;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the BackendService resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendService { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.BackendService Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendServices/{backendService}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendService", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets the Google Cloud Armor security policy for the specified backend service. For more information, see
        /// Google Cloud Armor Overview
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="backendService">
        /// Name of the BackendService resource to which the security policy should be set. The name should conform to
        /// RFC1035.
        /// </param>
        public virtual SetSecurityPolicyRequest SetSecurityPolicy(Google.Apis.Compute.v1.Data.SecurityPolicyReference body, string project, string backendService)
        {
            return new SetSecurityPolicyRequest(service, body, project, backendService);
        }

        /// <summary>
        /// Sets the Google Cloud Armor security policy for the specified backend service. For more information, see
        /// Google Cloud Armor Overview
        /// </summary>
        public class SetSecurityPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetSecurityPolicy request.</summary>
            public SetSecurityPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SecurityPolicyReference body, string project, string backendService) : base(service)
            {
                Project = project;
                BackendService = backendService;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// Name of the BackendService resource to which the security policy should be set. The name should conform
            /// to RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("backendService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendService { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SecurityPolicyReference Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setSecurityPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendServices/{backendService}/setSecurityPolicy";

            /// <summary>Initializes SetSecurityPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendService", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the specified BackendService resource with the data included in the request. For more information,
        /// see Backend services overview.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="backendService">Name of the BackendService resource to update.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.BackendService body, string project, string backendService)
        {
            return new UpdateRequest(service, body, project, backendService);
        }

        /// <summary>
        /// Updates the specified BackendService resource with the data included in the request. For more information,
        /// see Backend services overview.
        /// </summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.BackendService body, string project, string backendService) : base(service)
            {
                Project = project;
                BackendService = backendService;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the BackendService resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendService { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.BackendService Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/backendServices/{backendService}";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("backendService", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "diskTypes" collection of methods.</summary>
    public class DiskTypesResource
    {
        private const string Resource = "diskTypes";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public DiskTypesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of disk types.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of disk types.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.DiskTypeAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/diskTypes";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified disk type. Gets a list of available disk types by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="diskType">Name of the disk type to return.</param>
        public virtual GetRequest Get(string project, string zone, string diskType)
        {
            return new GetRequest(service, project, zone, diskType);
        }

        /// <summary>
        /// Returns the specified disk type. Gets a list of available disk types by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.DiskType>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string diskType) : base(service)
            {
                Project = project;
                Zone = zone;
                DiskType = diskType;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the disk type to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("diskType", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string DiskType { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/diskTypes/{diskType}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("diskType", new Google.Apis.Discovery.Parameter
                {
                    Name = "diskType",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves a list of disk types available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>Retrieves a list of disk types available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.DiskTypeList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/diskTypes";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "disks" collection of methods.</summary>
    public class DisksResource
    {
        private const string Resource = "disks";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public DisksResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Adds existing resource policies to a disk. You can only add one policy which will be applied to this disk
        /// for scheduling snapshot creation.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="disk">The disk name for this request.</param>
        public virtual AddResourcePoliciesRequest AddResourcePolicies(Google.Apis.Compute.v1.Data.DisksAddResourcePoliciesRequest body, string project, string zone, string disk)
        {
            return new AddResourcePoliciesRequest(service, body, project, zone, disk);
        }

        /// <summary>
        /// Adds existing resource policies to a disk. You can only add one policy which will be applied to this disk
        /// for scheduling snapshot creation.
        /// </summary>
        public class AddResourcePoliciesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddResourcePolicies request.</summary>
            public AddResourcePoliciesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.DisksAddResourcePoliciesRequest body, string project, string zone, string disk) : base(service)
            {
                Project = project;
                Zone = zone;
                Disk = disk;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The disk name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("disk", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Disk { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.DisksAddResourcePoliciesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addResourcePolicies";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/disks/{disk}/addResourcePolicies";

            /// <summary>Initializes AddResourcePolicies parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("disk", new Google.Apis.Discovery.Parameter
                {
                    Name = "disk",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves an aggregated list of persistent disks.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of persistent disks.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.DiskAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/disks";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Creates a snapshot of a specified persistent disk.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="disk">Name of the persistent disk to snapshot.</param>
        public virtual CreateSnapshotRequest CreateSnapshot(Google.Apis.Compute.v1.Data.Snapshot body, string project, string zone, string disk)
        {
            return new CreateSnapshotRequest(service, body, project, zone, disk);
        }

        /// <summary>Creates a snapshot of a specified persistent disk.</summary>
        public class CreateSnapshotRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new CreateSnapshot request.</summary>
            public CreateSnapshotRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Snapshot body, string project, string zone, string disk) : base(service)
            {
                Project = project;
                Zone = zone;
                Disk = disk;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the persistent disk to snapshot.</summary>
            [Google.Apis.Util.RequestParameterAttribute("disk", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Disk { get; private set; }

            /// <summary>
            /// [Input Only] Whether to attempt an application consistent snapshot by informing the OS to prepare for
            /// the snapshot process. Currently only supported on Windows instances using the Volume Shadow Copy Service
            /// (VSS).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("guestFlush", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> GuestFlush { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Snapshot Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "createSnapshot";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/disks/{disk}/createSnapshot";

            /// <summary>Initializes CreateSnapshot parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("disk", new Google.Apis.Discovery.Parameter
                {
                    Name = "disk",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("guestFlush", new Google.Apis.Discovery.Parameter
                {
                    Name = "guestFlush",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Deletes the specified persistent disk. Deleting a disk removes its data permanently and is irreversible.
        /// However, deleting a disk does not delete any snapshots previously made from the disk. You must separately
        /// delete snapshots.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="disk">Name of the persistent disk to delete.</param>
        public virtual DeleteRequest Delete(string project, string zone, string disk)
        {
            return new DeleteRequest(service, project, zone, disk);
        }

        /// <summary>
        /// Deletes the specified persistent disk. Deleting a disk removes its data permanently and is irreversible.
        /// However, deleting a disk does not delete any snapshots previously made from the disk. You must separately
        /// delete snapshots.
        /// </summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string zone, string disk) : base(service)
            {
                Project = project;
                Zone = zone;
                Disk = disk;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the persistent disk to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("disk", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Disk { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/disks/{disk}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("disk", new Google.Apis.Discovery.Parameter
                {
                    Name = "disk",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns a specified persistent disk. Gets a list of available persistent disks by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="disk">Name of the persistent disk to return.</param>
        public virtual GetRequest Get(string project, string zone, string disk)
        {
            return new GetRequest(service, project, zone, disk);
        }

        /// <summary>
        /// Returns a specified persistent disk. Gets a list of available persistent disks by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Disk>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string disk) : base(service)
            {
                Project = project;
                Zone = zone;
                Disk = disk;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the persistent disk to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("disk", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Disk { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/disks/{disk}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("disk", new Google.Apis.Discovery.Parameter
                {
                    Name = "disk",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual GetIamPolicyRequest GetIamPolicy(string project, string zone, string resource)
        {
            return new GetIamPolicyRequest(service, project, zone, resource);
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        public class GetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new GetIamPolicy request.</summary>
            public GetIamPolicyRequest(Google.Apis.Services.IClientService service, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Requested IAM Policy version.</summary>
            [Google.Apis.Util.RequestParameterAttribute("optionsRequestedPolicyVersion", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> OptionsRequestedPolicyVersion { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/disks/{resource}/getIamPolicy";

            /// <summary>Initializes GetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("optionsRequestedPolicyVersion", new Google.Apis.Discovery.Parameter
                {
                    Name = "optionsRequestedPolicyVersion",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates a persistent disk in the specified project using the data in the request. You can create a disk from
        /// a source (sourceImage, sourceSnapshot, or sourceDisk) or create an empty 500 GB data disk by omitting all
        /// properties. You can also create a disk that is larger than the default size by specifying the sizeGb
        /// property.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Disk body, string project, string zone)
        {
            return new InsertRequest(service, body, project, zone);
        }

        /// <summary>
        /// Creates a persistent disk in the specified project using the data in the request. You can create a disk from
        /// a source (sourceImage, sourceSnapshot, or sourceDisk) or create an empty 500 GB data disk by omitting all
        /// properties. You can also create a disk that is larger than the default size by specifying the sizeGb
        /// property.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Disk body, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Source image to restore onto a disk. This field is optional.</summary>
            [Google.Apis.Util.RequestParameterAttribute("sourceImage", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string SourceImage { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Disk Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/disks";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("sourceImage", new Google.Apis.Discovery.Parameter
                {
                    Name = "sourceImage",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of persistent disks contained within the specified zone.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>Retrieves a list of persistent disks contained within the specified zone.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.DiskList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/disks";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Removes resource policies from a disk.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="disk">The disk name for this request.</param>
        public virtual RemoveResourcePoliciesRequest RemoveResourcePolicies(Google.Apis.Compute.v1.Data.DisksRemoveResourcePoliciesRequest body, string project, string zone, string disk)
        {
            return new RemoveResourcePoliciesRequest(service, body, project, zone, disk);
        }

        /// <summary>Removes resource policies from a disk.</summary>
        public class RemoveResourcePoliciesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new RemoveResourcePolicies request.</summary>
            public RemoveResourcePoliciesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.DisksRemoveResourcePoliciesRequest body, string project, string zone, string disk) : base(service)
            {
                Project = project;
                Zone = zone;
                Disk = disk;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The disk name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("disk", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Disk { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.DisksRemoveResourcePoliciesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "removeResourcePolicies";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/disks/{disk}/removeResourcePolicies";

            /// <summary>Initializes RemoveResourcePolicies parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("disk", new Google.Apis.Discovery.Parameter
                {
                    Name = "disk",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Resizes the specified persistent disk. You can only increase the size of the disk.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="disk">The name of the persistent disk.</param>
        public virtual ResizeRequest Resize(Google.Apis.Compute.v1.Data.DisksResizeRequest body, string project, string zone, string disk)
        {
            return new ResizeRequest(service, body, project, zone, disk);
        }

        /// <summary>Resizes the specified persistent disk. You can only increase the size of the disk.</summary>
        public class ResizeRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Resize request.</summary>
            public ResizeRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.DisksResizeRequest body, string project, string zone, string disk) : base(service)
            {
                Project = project;
                Zone = zone;
                Disk = disk;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the persistent disk.</summary>
            [Google.Apis.Util.RequestParameterAttribute("disk", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Disk { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.DisksResizeRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "resize";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/disks/{disk}/resize";

            /// <summary>Initializes Resize parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("disk", new Google.Apis.Discovery.Parameter
                {
                    Name = "disk",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetIamPolicyRequest SetIamPolicy(Google.Apis.Compute.v1.Data.ZoneSetPolicyRequest body, string project, string zone, string resource)
        {
            return new SetIamPolicyRequest(service, body, project, zone, resource);
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        public class SetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new SetIamPolicy request.</summary>
            public SetIamPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ZoneSetPolicyRequest body, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ZoneSetPolicyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/disks/{resource}/setIamPolicy";

            /// <summary>Initializes SetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Sets the labels on a disk. To learn more about labels, read the Labeling Resources documentation.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetLabelsRequest SetLabels(Google.Apis.Compute.v1.Data.ZoneSetLabelsRequest body, string project, string zone, string resource)
        {
            return new SetLabelsRequest(service, body, project, zone, resource);
        }

        /// <summary>
        /// Sets the labels on a disk. To learn more about labels, read the Labeling Resources documentation.
        /// </summary>
        public class SetLabelsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetLabels request.</summary>
            public SetLabelsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ZoneSetLabelsRequest body, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ZoneSetLabelsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setLabels";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/disks/{resource}/setLabels";

            /// <summary>Initializes SetLabels parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string zone, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, zone, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/disks/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "externalVpnGateways" collection of methods.</summary>
    public class ExternalVpnGatewaysResource
    {
        private const string Resource = "externalVpnGateways";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public ExternalVpnGatewaysResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified externalVpnGateway.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="externalVpnGateway">Name of the externalVpnGateways to delete.</param>
        public virtual DeleteRequest Delete(string project, string externalVpnGateway)
        {
            return new DeleteRequest(service, project, externalVpnGateway);
        }

        /// <summary>Deletes the specified externalVpnGateway.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string externalVpnGateway) : base(service)
            {
                Project = project;
                ExternalVpnGateway = externalVpnGateway;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the externalVpnGateways to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("externalVpnGateway", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string ExternalVpnGateway { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/externalVpnGateways/{externalVpnGateway}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("externalVpnGateway", new Google.Apis.Discovery.Parameter
                {
                    Name = "externalVpnGateway",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified externalVpnGateway. Get a list of available externalVpnGateways by making a list()
        /// request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="externalVpnGateway">Name of the externalVpnGateway to return.</param>
        public virtual GetRequest Get(string project, string externalVpnGateway)
        {
            return new GetRequest(service, project, externalVpnGateway);
        }

        /// <summary>
        /// Returns the specified externalVpnGateway. Get a list of available externalVpnGateways by making a list()
        /// request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ExternalVpnGateway>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string externalVpnGateway) : base(service)
            {
                Project = project;
                ExternalVpnGateway = externalVpnGateway;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the externalVpnGateway to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("externalVpnGateway", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string ExternalVpnGateway { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/externalVpnGateways/{externalVpnGateway}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("externalVpnGateway", new Google.Apis.Discovery.Parameter
                {
                    Name = "externalVpnGateway",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
            }
        }

        /// <summary>
        /// Creates a ExternalVpnGateway in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.ExternalVpnGateway body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a ExternalVpnGateway in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ExternalVpnGateway body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ExternalVpnGateway Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/externalVpnGateways";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of ExternalVpnGateway available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of ExternalVpnGateway available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ExternalVpnGatewayList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/externalVpnGateways";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets the labels on an ExternalVpnGateway. To learn more about labels, read the Labeling Resources
        /// documentation.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetLabelsRequest SetLabels(Google.Apis.Compute.v1.Data.GlobalSetLabelsRequest body, string project, string resource)
        {
            return new SetLabelsRequest(service, body, project, resource);
        }

        /// <summary>
        /// Sets the labels on an ExternalVpnGateway. To learn more about labels, read the Labeling Resources
        /// documentation.
        /// </summary>
        public class SetLabelsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetLabels request.</summary>
            public SetLabelsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.GlobalSetLabelsRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.GlobalSetLabelsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setLabels";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/externalVpnGateways/{resource}/setLabels";

            /// <summary>Initializes SetLabels parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/externalVpnGateways/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "firewallPolicies" collection of methods.</summary>
    public class FirewallPoliciesResource
    {
        private const string Resource = "firewallPolicies";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public FirewallPoliciesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Inserts an association for the specified firewall policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="firewallPolicy">Name of the firewall policy to update.</param>
        public virtual AddAssociationRequest AddAssociation(Google.Apis.Compute.v1.Data.FirewallPolicyAssociation body, string firewallPolicy)
        {
            return new AddAssociationRequest(service, body, firewallPolicy);
        }

        /// <summary>Inserts an association for the specified firewall policy.</summary>
        public class AddAssociationRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddAssociation request.</summary>
            public AddAssociationRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.FirewallPolicyAssociation body, string firewallPolicy) : base(service)
            {
                FirewallPolicy = firewallPolicy;
                Body = body;
                InitParameters();
            }

            /// <summary>Name of the firewall policy to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewallPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string FirewallPolicy { get; private set; }

            /// <summary>
            /// Indicates whether or not to replace it if an association of the attachment already exists. This is false
            /// by default, in which case an error will be returned if an association already exists.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("replaceExistingAssociation", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReplaceExistingAssociation { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.FirewallPolicyAssociation Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addAssociation";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{firewallPolicy}/addAssociation";

            /// <summary>Initializes AddAssociation parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("firewallPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewallPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
                RequestParameters.Add("replaceExistingAssociation", new Google.Apis.Discovery.Parameter
                {
                    Name = "replaceExistingAssociation",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Inserts a rule into a firewall policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="firewallPolicy">Name of the firewall policy to update.</param>
        public virtual AddRuleRequest AddRule(Google.Apis.Compute.v1.Data.FirewallPolicyRule body, string firewallPolicy)
        {
            return new AddRuleRequest(service, body, firewallPolicy);
        }

        /// <summary>Inserts a rule into a firewall policy.</summary>
        public class AddRuleRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddRule request.</summary>
            public AddRuleRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.FirewallPolicyRule body, string firewallPolicy) : base(service)
            {
                FirewallPolicy = firewallPolicy;
                Body = body;
                InitParameters();
            }

            /// <summary>Name of the firewall policy to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewallPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string FirewallPolicy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.FirewallPolicyRule Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addRule";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{firewallPolicy}/addRule";

            /// <summary>Initializes AddRule parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("firewallPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewallPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Copies rules to the specified firewall policy.</summary>
        /// <param name="firewallPolicy">Name of the firewall policy to update.</param>
        public virtual CloneRulesRequest CloneRules(string firewallPolicy)
        {
            return new CloneRulesRequest(service, firewallPolicy);
        }

        /// <summary>Copies rules to the specified firewall policy.</summary>
        public class CloneRulesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new CloneRules request.</summary>
            public CloneRulesRequest(Google.Apis.Services.IClientService service, string firewallPolicy) : base(service)
            {
                FirewallPolicy = firewallPolicy;
                InitParameters();
            }

            /// <summary>Name of the firewall policy to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewallPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string FirewallPolicy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>The firewall policy from which to copy rules.</summary>
            [Google.Apis.Util.RequestParameterAttribute("sourceFirewallPolicy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string SourceFirewallPolicy { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "cloneRules";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{firewallPolicy}/cloneRules";

            /// <summary>Initializes CloneRules parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("firewallPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewallPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("sourceFirewallPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "sourceFirewallPolicy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified policy.</summary>
        /// <param name="firewallPolicy">Name of the firewall policy to delete.</param>
        public virtual DeleteRequest Delete(string firewallPolicy)
        {
            return new DeleteRequest(service, firewallPolicy);
        }

        /// <summary>Deletes the specified policy.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string firewallPolicy) : base(service)
            {
                FirewallPolicy = firewallPolicy;
                InitParameters();
            }

            /// <summary>Name of the firewall policy to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewallPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string FirewallPolicy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{firewallPolicy}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("firewallPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewallPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified firewall policy.</summary>
        /// <param name="firewallPolicy">Name of the firewall policy to get.</param>
        public virtual GetRequest Get(string firewallPolicy)
        {
            return new GetRequest(service, firewallPolicy);
        }

        /// <summary>Returns the specified firewall policy.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.FirewallPolicy>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string firewallPolicy) : base(service)
            {
                FirewallPolicy = firewallPolicy;
                InitParameters();
            }

            /// <summary>Name of the firewall policy to get.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewallPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string FirewallPolicy { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{firewallPolicy}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("firewallPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewallPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
            }
        }

        /// <summary>Gets an association with the specified name.</summary>
        /// <param name="firewallPolicy">Name of the firewall policy to which the queried rule belongs.</param>
        public virtual GetAssociationRequest GetAssociation(string firewallPolicy)
        {
            return new GetAssociationRequest(service, firewallPolicy);
        }

        /// <summary>Gets an association with the specified name.</summary>
        public class GetAssociationRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.FirewallPolicyAssociation>
        {
            /// <summary>Constructs a new GetAssociation request.</summary>
            public GetAssociationRequest(Google.Apis.Services.IClientService service, string firewallPolicy) : base(service)
            {
                FirewallPolicy = firewallPolicy;
                InitParameters();
            }

            /// <summary>Name of the firewall policy to which the queried rule belongs.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewallPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string FirewallPolicy { get; private set; }

            /// <summary>The name of the association to get from the firewall policy.</summary>
            [Google.Apis.Util.RequestParameterAttribute("name", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Name { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getAssociation";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{firewallPolicy}/getAssociation";

            /// <summary>Initializes GetAssociation parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("firewallPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewallPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
                RequestParameters.Add("name", new Google.Apis.Discovery.Parameter
                {
                    Name = "name",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual GetIamPolicyRequest GetIamPolicy(string resource)
        {
            return new GetIamPolicyRequest(service, resource);
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        public class GetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new GetIamPolicy request.</summary>
            public GetIamPolicyRequest(Google.Apis.Services.IClientService service, string resource) : base(service)
            {
                Resource = resource;
                InitParameters();
            }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Requested IAM Policy version.</summary>
            [Google.Apis.Util.RequestParameterAttribute("optionsRequestedPolicyVersion", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> OptionsRequestedPolicyVersion { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{resource}/getIamPolicy";

            /// <summary>Initializes GetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
                RequestParameters.Add("optionsRequestedPolicyVersion", new Google.Apis.Discovery.Parameter
                {
                    Name = "optionsRequestedPolicyVersion",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Gets a rule of the specified priority.</summary>
        /// <param name="firewallPolicy">Name of the firewall policy to which the queried rule belongs.</param>
        public virtual GetRuleRequest GetRule(string firewallPolicy)
        {
            return new GetRuleRequest(service, firewallPolicy);
        }

        /// <summary>Gets a rule of the specified priority.</summary>
        public class GetRuleRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.FirewallPolicyRule>
        {
            /// <summary>Constructs a new GetRule request.</summary>
            public GetRuleRequest(Google.Apis.Services.IClientService service, string firewallPolicy) : base(service)
            {
                FirewallPolicy = firewallPolicy;
                InitParameters();
            }

            /// <summary>Name of the firewall policy to which the queried rule belongs.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewallPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string FirewallPolicy { get; private set; }

            /// <summary>The priority of the rule to get from the firewall policy.</summary>
            [Google.Apis.Util.RequestParameterAttribute("priority", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> Priority { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getRule";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{firewallPolicy}/getRule";

            /// <summary>Initializes GetRule parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("firewallPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewallPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
                RequestParameters.Add("priority", new Google.Apis.Discovery.Parameter
                {
                    Name = "priority",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Creates a new policy in the specified project using the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.FirewallPolicy body)
        {
            return new InsertRequest(service, body);
        }

        /// <summary>Creates a new policy in the specified project using the data included in the request.</summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.FirewallPolicy body) : base(service)
            {
                Body = body;
                InitParameters();
            }

            /// <summary>
            /// Parent ID for this request. The ID can be either be "folders/[FOLDER_ID]" if the parent is a folder or
            /// "organizations/[ORGANIZATION_ID]" if the parent is an organization.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("parentId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string ParentId { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.FirewallPolicy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("parentId", new Google.Apis.Discovery.Parameter
                {
                    Name = "parentId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Lists all the policies that have been configured for the specified project.</summary>
        public virtual ListRequest List()
        {
            return new ListRequest(service);
        }

        /// <summary>Lists all the policies that have been configured for the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.FirewallPolicyList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service) : base(service)
            {
                InitParameters();
            }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>Parent ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("parentId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string ParentId { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("parentId", new Google.Apis.Discovery.Parameter
                {
                    Name = "parentId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Lists associations of a specified target, i.e., organization or folder.</summary>
        public virtual ListAssociationsRequest ListAssociations()
        {
            return new ListAssociationsRequest(service);
        }

        /// <summary>Lists associations of a specified target, i.e., organization or folder.</summary>
        public class ListAssociationsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.FirewallPoliciesListAssociationsResponse>
        {
            /// <summary>Constructs a new ListAssociations request.</summary>
            public ListAssociationsRequest(Google.Apis.Services.IClientService service) : base(service)
            {
                InitParameters();
            }

            /// <summary>The target resource to list associations. It is an organization, or a folder.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetResource", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string TargetResource { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listAssociations";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/listAssociations";

            /// <summary>Initializes ListAssociations parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("targetResource", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetResource",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Moves the specified firewall policy.</summary>
        /// <param name="firewallPolicy">Name of the firewall policy to update.</param>
        public virtual MoveRequest Move(string firewallPolicy)
        {
            return new MoveRequest(service, firewallPolicy);
        }

        /// <summary>Moves the specified firewall policy.</summary>
        public class MoveRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Move request.</summary>
            public MoveRequest(Google.Apis.Services.IClientService service, string firewallPolicy) : base(service)
            {
                FirewallPolicy = firewallPolicy;
                InitParameters();
            }

            /// <summary>Name of the firewall policy to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewallPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string FirewallPolicy { get; private set; }

            /// <summary>The new parent of the firewall policy.</summary>
            [Google.Apis.Util.RequestParameterAttribute("parentId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string ParentId { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "move";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{firewallPolicy}/move";

            /// <summary>Initializes Move parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("firewallPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewallPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
                RequestParameters.Add("parentId", new Google.Apis.Discovery.Parameter
                {
                    Name = "parentId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Patches the specified policy with the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="firewallPolicy">Name of the firewall policy to update.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.FirewallPolicy body, string firewallPolicy)
        {
            return new PatchRequest(service, body, firewallPolicy);
        }

        /// <summary>Patches the specified policy with the data included in the request.</summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.FirewallPolicy body, string firewallPolicy) : base(service)
            {
                FirewallPolicy = firewallPolicy;
                Body = body;
                InitParameters();
            }

            /// <summary>Name of the firewall policy to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewallPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string FirewallPolicy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.FirewallPolicy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{firewallPolicy}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("firewallPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewallPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Patches a rule of the specified priority.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="firewallPolicy">Name of the firewall policy to update.</param>
        public virtual PatchRuleRequest PatchRule(Google.Apis.Compute.v1.Data.FirewallPolicyRule body, string firewallPolicy)
        {
            return new PatchRuleRequest(service, body, firewallPolicy);
        }

        /// <summary>Patches a rule of the specified priority.</summary>
        public class PatchRuleRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new PatchRule request.</summary>
            public PatchRuleRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.FirewallPolicyRule body, string firewallPolicy) : base(service)
            {
                FirewallPolicy = firewallPolicy;
                Body = body;
                InitParameters();
            }

            /// <summary>Name of the firewall policy to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewallPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string FirewallPolicy { get; private set; }

            /// <summary>The priority of the rule to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("priority", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> Priority { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.FirewallPolicyRule Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patchRule";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{firewallPolicy}/patchRule";

            /// <summary>Initializes PatchRule parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("firewallPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewallPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
                RequestParameters.Add("priority", new Google.Apis.Discovery.Parameter
                {
                    Name = "priority",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Removes an association for the specified firewall policy.</summary>
        /// <param name="firewallPolicy">Name of the firewall policy to update.</param>
        public virtual RemoveAssociationRequest RemoveAssociation(string firewallPolicy)
        {
            return new RemoveAssociationRequest(service, firewallPolicy);
        }

        /// <summary>Removes an association for the specified firewall policy.</summary>
        public class RemoveAssociationRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new RemoveAssociation request.</summary>
            public RemoveAssociationRequest(Google.Apis.Services.IClientService service, string firewallPolicy) : base(service)
            {
                FirewallPolicy = firewallPolicy;
                InitParameters();
            }

            /// <summary>Name of the firewall policy to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewallPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string FirewallPolicy { get; private set; }

            /// <summary>Name for the attachment that will be removed.</summary>
            [Google.Apis.Util.RequestParameterAttribute("name", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Name { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "removeAssociation";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{firewallPolicy}/removeAssociation";

            /// <summary>Initializes RemoveAssociation parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("firewallPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewallPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
                RequestParameters.Add("name", new Google.Apis.Discovery.Parameter
                {
                    Name = "name",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes a rule of the specified priority.</summary>
        /// <param name="firewallPolicy">Name of the firewall policy to update.</param>
        public virtual RemoveRuleRequest RemoveRule(string firewallPolicy)
        {
            return new RemoveRuleRequest(service, firewallPolicy);
        }

        /// <summary>Deletes a rule of the specified priority.</summary>
        public class RemoveRuleRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new RemoveRule request.</summary>
            public RemoveRuleRequest(Google.Apis.Services.IClientService service, string firewallPolicy) : base(service)
            {
                FirewallPolicy = firewallPolicy;
                InitParameters();
            }

            /// <summary>Name of the firewall policy to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewallPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string FirewallPolicy { get; private set; }

            /// <summary>The priority of the rule to remove from the firewall policy.</summary>
            [Google.Apis.Util.RequestParameterAttribute("priority", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> Priority { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "removeRule";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{firewallPolicy}/removeRule";

            /// <summary>Initializes RemoveRule parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("firewallPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewallPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
                RequestParameters.Add("priority", new Google.Apis.Discovery.Parameter
                {
                    Name = "priority",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetIamPolicyRequest SetIamPolicy(Google.Apis.Compute.v1.Data.GlobalOrganizationSetPolicyRequest body, string resource)
        {
            return new SetIamPolicyRequest(service, body, resource);
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        public class SetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new SetIamPolicy request.</summary>
            public SetIamPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.GlobalOrganizationSetPolicyRequest body, string resource) : base(service)
            {
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.GlobalOrganizationSetPolicyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{resource}/setIamPolicy";

            /// <summary>Initializes SetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string resource)
        {
            return new TestIamPermissionsRequest(service, body, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string resource) : base(service)
            {
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/firewallPolicies/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(firewallPolicies/)?[0-9]{0,20}",
                });
            }
        }
    }

    /// <summary>The "firewalls" collection of methods.</summary>
    public class FirewallsResource
    {
        private const string Resource = "firewalls";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public FirewallsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified firewall.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="firewall">Name of the firewall rule to delete.</param>
        public virtual DeleteRequest Delete(string project, string firewall)
        {
            return new DeleteRequest(service, project, firewall);
        }

        /// <summary>Deletes the specified firewall.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string firewall) : base(service)
            {
                Project = project;
                Firewall = firewall;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the firewall rule to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewall", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Firewall { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/firewalls/{firewall}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("firewall", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewall",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified firewall.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="firewall">Name of the firewall rule to return.</param>
        public virtual GetRequest Get(string project, string firewall)
        {
            return new GetRequest(service, project, firewall);
        }

        /// <summary>Returns the specified firewall.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Firewall>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string firewall) : base(service)
            {
                Project = project;
                Firewall = firewall;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the firewall rule to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewall", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Firewall { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/firewalls/{firewall}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("firewall", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewall",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Creates a firewall rule in the specified project using the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Firewall body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>Creates a firewall rule in the specified project using the data included in the request.</summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Firewall body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Firewall Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/firewalls";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of firewall rules available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of firewall rules available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.FirewallList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/firewalls";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the specified firewall rule with the data included in the request. This method supports PATCH
        /// semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="firewall">Name of the firewall rule to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.Firewall body, string project, string firewall)
        {
            return new PatchRequest(service, body, project, firewall);
        }

        /// <summary>
        /// Updates the specified firewall rule with the data included in the request. This method supports PATCH
        /// semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Firewall body, string project, string firewall) : base(service)
            {
                Project = project;
                Firewall = firewall;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the firewall rule to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewall", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Firewall { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Firewall Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/firewalls/{firewall}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("firewall", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewall",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the specified firewall rule with the data included in the request. Note that all fields will be
        /// updated if using PUT, even fields that are not specified. To update individual fields, please use PATCH
        /// instead.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="firewall">Name of the firewall rule to update.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.Firewall body, string project, string firewall)
        {
            return new UpdateRequest(service, body, project, firewall);
        }

        /// <summary>
        /// Updates the specified firewall rule with the data included in the request. Note that all fields will be
        /// updated if using PUT, even fields that are not specified. To update individual fields, please use PATCH
        /// instead.
        /// </summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Firewall body, string project, string firewall) : base(service)
            {
                Project = project;
                Firewall = firewall;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the firewall rule to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("firewall", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Firewall { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Firewall Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/firewalls/{firewall}";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("firewall", new Google.Apis.Discovery.Parameter
                {
                    Name = "firewall",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "forwardingRules" collection of methods.</summary>
    public class ForwardingRulesResource
    {
        private const string Resource = "forwardingRules";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public ForwardingRulesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of forwarding rules.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of forwarding rules.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ForwardingRuleAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/forwardingRules";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified ForwardingRule resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="forwardingRule">Name of the ForwardingRule resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string forwardingRule)
        {
            return new DeleteRequest(service, project, region, forwardingRule);
        }

        /// <summary>Deletes the specified ForwardingRule resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string forwardingRule) : base(service)
            {
                Project = project;
                Region = region;
                ForwardingRule = forwardingRule;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the ForwardingRule resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("forwardingRule", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string ForwardingRule { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/forwardingRules/{forwardingRule}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("forwardingRule", new Google.Apis.Discovery.Parameter
                {
                    Name = "forwardingRule",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified ForwardingRule resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="forwardingRule">Name of the ForwardingRule resource to return.</param>
        public virtual GetRequest Get(string project, string region, string forwardingRule)
        {
            return new GetRequest(service, project, region, forwardingRule);
        }

        /// <summary>Returns the specified ForwardingRule resource.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ForwardingRule>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string forwardingRule) : base(service)
            {
                Project = project;
                Region = region;
                ForwardingRule = forwardingRule;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the ForwardingRule resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("forwardingRule", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string ForwardingRule { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/forwardingRules/{forwardingRule}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("forwardingRule", new Google.Apis.Discovery.Parameter
                {
                    Name = "forwardingRule",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a ForwardingRule resource in the specified project and region using the data included in the
        /// request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.ForwardingRule body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a ForwardingRule resource in the specified project and region using the data included in the
        /// request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ForwardingRule body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ForwardingRule Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/forwardingRules";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves a list of ForwardingRule resources available to the specified project and region.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>
        /// Retrieves a list of ForwardingRule resources available to the specified project and region.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ForwardingRuleList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/forwardingRules";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the specified forwarding rule with the data included in the request. This method supports PATCH
        /// semantics and uses the JSON merge patch format and processing rules. Currently, you can only patch the
        /// network_tier field.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="forwardingRule">Name of the ForwardingRule resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.ForwardingRule body, string project, string region, string forwardingRule)
        {
            return new PatchRequest(service, body, project, region, forwardingRule);
        }

        /// <summary>
        /// Updates the specified forwarding rule with the data included in the request. This method supports PATCH
        /// semantics and uses the JSON merge patch format and processing rules. Currently, you can only patch the
        /// network_tier field.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ForwardingRule body, string project, string region, string forwardingRule) : base(service)
            {
                Project = project;
                Region = region;
                ForwardingRule = forwardingRule;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the ForwardingRule resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("forwardingRule", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string ForwardingRule { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ForwardingRule Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/forwardingRules/{forwardingRule}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("forwardingRule", new Google.Apis.Discovery.Parameter
                {
                    Name = "forwardingRule",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets the labels on the specified resource. To learn more about labels, read the Labeling Resources
        /// documentation.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetLabelsRequest SetLabels(Google.Apis.Compute.v1.Data.RegionSetLabelsRequest body, string project, string region, string resource)
        {
            return new SetLabelsRequest(service, body, project, region, resource);
        }

        /// <summary>
        /// Sets the labels on the specified resource. To learn more about labels, read the Labeling Resources
        /// documentation.
        /// </summary>
        public class SetLabelsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetLabels request.</summary>
            public SetLabelsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionSetLabelsRequest body, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionSetLabelsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setLabels";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/forwardingRules/{resource}/setLabels";

            /// <summary>Initializes SetLabels parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Changes target URL for forwarding rule. The new target should be of the same type as the old target.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="forwardingRule">Name of the ForwardingRule resource in which target is to be set.</param>
        public virtual SetTargetRequest SetTarget(Google.Apis.Compute.v1.Data.TargetReference body, string project, string region, string forwardingRule)
        {
            return new SetTargetRequest(service, body, project, region, forwardingRule);
        }

        /// <summary>
        /// Changes target URL for forwarding rule. The new target should be of the same type as the old target.
        /// </summary>
        public class SetTargetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetTarget request.</summary>
            public SetTargetRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetReference body, string project, string region, string forwardingRule) : base(service)
            {
                Project = project;
                Region = region;
                ForwardingRule = forwardingRule;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the ForwardingRule resource in which target is to be set.</summary>
            [Google.Apis.Util.RequestParameterAttribute("forwardingRule", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string ForwardingRule { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetReference Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setTarget";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/forwardingRules/{forwardingRule}/setTarget";

            /// <summary>Initializes SetTarget parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("forwardingRule", new Google.Apis.Discovery.Parameter
                {
                    Name = "forwardingRule",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "globalAddresses" collection of methods.</summary>
    public class GlobalAddressesResource
    {
        private const string Resource = "globalAddresses";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public GlobalAddressesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified address resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="address">Name of the address resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string address)
        {
            return new DeleteRequest(service, project, address);
        }

        /// <summary>Deletes the specified address resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string address) : base(service)
            {
                Project = project;
                Address = address;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the address resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("address", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Address { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/addresses/{address}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("address", new Google.Apis.Discovery.Parameter
                {
                    Name = "address",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified address resource. Gets a list of available addresses by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="address">Name of the address resource to return.</param>
        public virtual GetRequest Get(string project, string address)
        {
            return new GetRequest(service, project, address);
        }

        /// <summary>
        /// Returns the specified address resource. Gets a list of available addresses by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Address>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string address) : base(service)
            {
                Project = project;
                Address = address;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the address resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("address", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Address { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/addresses/{address}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("address", new Google.Apis.Discovery.Parameter
                {
                    Name = "address",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates an address resource in the specified project by using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Address body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates an address resource in the specified project by using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Address body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Address Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/addresses";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of global addresses.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves a list of global addresses.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.AddressList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/addresses";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "globalForwardingRules" collection of methods.</summary>
    public class GlobalForwardingRulesResource
    {
        private const string Resource = "globalForwardingRules";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public GlobalForwardingRulesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified GlobalForwardingRule resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="forwardingRule">Name of the ForwardingRule resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string forwardingRule)
        {
            return new DeleteRequest(service, project, forwardingRule);
        }

        /// <summary>Deletes the specified GlobalForwardingRule resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string forwardingRule) : base(service)
            {
                Project = project;
                ForwardingRule = forwardingRule;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the ForwardingRule resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("forwardingRule", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string ForwardingRule { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/forwardingRules/{forwardingRule}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("forwardingRule", new Google.Apis.Discovery.Parameter
                {
                    Name = "forwardingRule",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified GlobalForwardingRule resource. Gets a list of available forwarding rules by making a
        /// list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="forwardingRule">Name of the ForwardingRule resource to return.</param>
        public virtual GetRequest Get(string project, string forwardingRule)
        {
            return new GetRequest(service, project, forwardingRule);
        }

        /// <summary>
        /// Returns the specified GlobalForwardingRule resource. Gets a list of available forwarding rules by making a
        /// list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ForwardingRule>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string forwardingRule) : base(service)
            {
                Project = project;
                ForwardingRule = forwardingRule;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the ForwardingRule resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("forwardingRule", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string ForwardingRule { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/forwardingRules/{forwardingRule}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("forwardingRule", new Google.Apis.Discovery.Parameter
                {
                    Name = "forwardingRule",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a GlobalForwardingRule resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.ForwardingRule body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a GlobalForwardingRule resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ForwardingRule body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ForwardingRule Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/forwardingRules";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of GlobalForwardingRule resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves a list of GlobalForwardingRule resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ForwardingRuleList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/forwardingRules";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the specified forwarding rule with the data included in the request. This method supports PATCH
        /// semantics and uses the JSON merge patch format and processing rules. Currently, you can only patch the
        /// network_tier field.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="forwardingRule">Name of the ForwardingRule resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.ForwardingRule body, string project, string forwardingRule)
        {
            return new PatchRequest(service, body, project, forwardingRule);
        }

        /// <summary>
        /// Updates the specified forwarding rule with the data included in the request. This method supports PATCH
        /// semantics and uses the JSON merge patch format and processing rules. Currently, you can only patch the
        /// network_tier field.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ForwardingRule body, string project, string forwardingRule) : base(service)
            {
                Project = project;
                ForwardingRule = forwardingRule;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the ForwardingRule resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("forwardingRule", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string ForwardingRule { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ForwardingRule Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/forwardingRules/{forwardingRule}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("forwardingRule", new Google.Apis.Discovery.Parameter
                {
                    Name = "forwardingRule",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets the labels on the specified resource. To learn more about labels, read the Labeling Resources
        /// documentation.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetLabelsRequest SetLabels(Google.Apis.Compute.v1.Data.GlobalSetLabelsRequest body, string project, string resource)
        {
            return new SetLabelsRequest(service, body, project, resource);
        }

        /// <summary>
        /// Sets the labels on the specified resource. To learn more about labels, read the Labeling Resources
        /// documentation.
        /// </summary>
        public class SetLabelsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetLabels request.</summary>
            public SetLabelsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.GlobalSetLabelsRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.GlobalSetLabelsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setLabels";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/forwardingRules/{resource}/setLabels";

            /// <summary>Initializes SetLabels parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Changes target URL for the GlobalForwardingRule resource. The new target should be of the same type as the
        /// old target.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="forwardingRule">Name of the ForwardingRule resource in which target is to be set.</param>
        public virtual SetTargetRequest SetTarget(Google.Apis.Compute.v1.Data.TargetReference body, string project, string forwardingRule)
        {
            return new SetTargetRequest(service, body, project, forwardingRule);
        }

        /// <summary>
        /// Changes target URL for the GlobalForwardingRule resource. The new target should be of the same type as the
        /// old target.
        /// </summary>
        public class SetTargetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetTarget request.</summary>
            public SetTargetRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetReference body, string project, string forwardingRule) : base(service)
            {
                Project = project;
                ForwardingRule = forwardingRule;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the ForwardingRule resource in which target is to be set.</summary>
            [Google.Apis.Util.RequestParameterAttribute("forwardingRule", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string ForwardingRule { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetReference Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setTarget";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/forwardingRules/{forwardingRule}/setTarget";

            /// <summary>Initializes SetTarget parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("forwardingRule", new Google.Apis.Discovery.Parameter
                {
                    Name = "forwardingRule",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "globalNetworkEndpointGroups" collection of methods.</summary>
    public class GlobalNetworkEndpointGroupsResource
    {
        private const string Resource = "globalNetworkEndpointGroups";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public GlobalNetworkEndpointGroupsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Attach a network endpoint to the specified network endpoint group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="networkEndpointGroup">
        /// The name of the network endpoint group where you are attaching network endpoints to. It should comply with
        /// RFC1035.
        /// </param>
        public virtual AttachNetworkEndpointsRequest AttachNetworkEndpoints(Google.Apis.Compute.v1.Data.GlobalNetworkEndpointGroupsAttachEndpointsRequest body, string project, string networkEndpointGroup)
        {
            return new AttachNetworkEndpointsRequest(service, body, project, networkEndpointGroup);
        }

        /// <summary>Attach a network endpoint to the specified network endpoint group.</summary>
        public class AttachNetworkEndpointsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AttachNetworkEndpoints request.</summary>
            public AttachNetworkEndpointsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.GlobalNetworkEndpointGroupsAttachEndpointsRequest body, string project, string networkEndpointGroup) : base(service)
            {
                Project = project;
                NetworkEndpointGroup = networkEndpointGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the network endpoint group where you are attaching network endpoints to. It should comply
            /// with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("networkEndpointGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NetworkEndpointGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.GlobalNetworkEndpointGroupsAttachEndpointsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "attachNetworkEndpoints";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networkEndpointGroups/{networkEndpointGroup}/attachNetworkEndpoints";

            /// <summary>Initializes AttachNetworkEndpoints parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("networkEndpointGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkEndpointGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Deletes the specified network endpoint group.Note that the NEG cannot be deleted if there are backend
        /// services referencing it.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="networkEndpointGroup">
        /// The name of the network endpoint group to delete. It should comply with RFC1035.
        /// </param>
        public virtual DeleteRequest Delete(string project, string networkEndpointGroup)
        {
            return new DeleteRequest(service, project, networkEndpointGroup);
        }

        /// <summary>
        /// Deletes the specified network endpoint group.Note that the NEG cannot be deleted if there are backend
        /// services referencing it.
        /// </summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string networkEndpointGroup) : base(service)
            {
                Project = project;
                NetworkEndpointGroup = networkEndpointGroup;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the network endpoint group to delete. It should comply with RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("networkEndpointGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NetworkEndpointGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networkEndpointGroups/{networkEndpointGroup}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("networkEndpointGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkEndpointGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Detach the network endpoint from the specified network endpoint group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="networkEndpointGroup">
        /// The name of the network endpoint group where you are removing network endpoints. It should comply with
        /// RFC1035.
        /// </param>
        public virtual DetachNetworkEndpointsRequest DetachNetworkEndpoints(Google.Apis.Compute.v1.Data.GlobalNetworkEndpointGroupsDetachEndpointsRequest body, string project, string networkEndpointGroup)
        {
            return new DetachNetworkEndpointsRequest(service, body, project, networkEndpointGroup);
        }

        /// <summary>Detach the network endpoint from the specified network endpoint group.</summary>
        public class DetachNetworkEndpointsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new DetachNetworkEndpoints request.</summary>
            public DetachNetworkEndpointsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.GlobalNetworkEndpointGroupsDetachEndpointsRequest body, string project, string networkEndpointGroup) : base(service)
            {
                Project = project;
                NetworkEndpointGroup = networkEndpointGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the network endpoint group where you are removing network endpoints. It should comply with
            /// RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("networkEndpointGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NetworkEndpointGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.GlobalNetworkEndpointGroupsDetachEndpointsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "detachNetworkEndpoints";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networkEndpointGroups/{networkEndpointGroup}/detachNetworkEndpoints";

            /// <summary>Initializes DetachNetworkEndpoints parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("networkEndpointGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkEndpointGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified network endpoint group. Gets a list of available network endpoint groups by making a
        /// list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="networkEndpointGroup">
        /// The name of the network endpoint group. It should comply with RFC1035.
        /// </param>
        public virtual GetRequest Get(string project, string networkEndpointGroup)
        {
            return new GetRequest(service, project, networkEndpointGroup);
        }

        /// <summary>
        /// Returns the specified network endpoint group. Gets a list of available network endpoint groups by making a
        /// list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NetworkEndpointGroup>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string networkEndpointGroup) : base(service)
            {
                Project = project;
                NetworkEndpointGroup = networkEndpointGroup;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the network endpoint group. It should comply with RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("networkEndpointGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NetworkEndpointGroup { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networkEndpointGroups/{networkEndpointGroup}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("networkEndpointGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkEndpointGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates a network endpoint group in the specified project using the parameters that are included in the
        /// request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.NetworkEndpointGroup body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a network endpoint group in the specified project using the parameters that are included in the
        /// request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NetworkEndpointGroup body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NetworkEndpointGroup Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networkEndpointGroups";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of network endpoint groups that are located in the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of network endpoint groups that are located in the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NetworkEndpointGroupList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networkEndpointGroups";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Lists the network endpoints in the specified network endpoint group.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="networkEndpointGroup">
        /// The name of the network endpoint group from which you want to generate a list of included network endpoints.
        /// It should comply with RFC1035.
        /// </param>
        public virtual ListNetworkEndpointsRequest ListNetworkEndpoints(string project, string networkEndpointGroup)
        {
            return new ListNetworkEndpointsRequest(service, project, networkEndpointGroup);
        }

        /// <summary>Lists the network endpoints in the specified network endpoint group.</summary>
        public class ListNetworkEndpointsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NetworkEndpointGroupsListNetworkEndpoints>
        {
            /// <summary>Constructs a new ListNetworkEndpoints request.</summary>
            public ListNetworkEndpointsRequest(Google.Apis.Services.IClientService service, string project, string networkEndpointGroup) : base(service)
            {
                Project = project;
                NetworkEndpointGroup = networkEndpointGroup;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the network endpoint group from which you want to generate a list of included network
            /// endpoints. It should comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("networkEndpointGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NetworkEndpointGroup { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listNetworkEndpoints";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networkEndpointGroups/{networkEndpointGroup}/listNetworkEndpoints";

            /// <summary>Initializes ListNetworkEndpoints parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("networkEndpointGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkEndpointGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "globalOperations" collection of methods.</summary>
    public class GlobalOperationsResource
    {
        private const string Resource = "globalOperations";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public GlobalOperationsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of all operations.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of all operations.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.OperationAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/operations";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified Operations resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="operation">Name of the Operations resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string operation)
        {
            return new DeleteRequest(service, project, operation);
        }

        /// <summary>Deletes the specified Operations resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<string>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string operation) : base(service)
            {
                Project = project;
                Operation = operation;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the Operations resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("operation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Operation { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/operations/{operation}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("operation", new Google.Apis.Discovery.Parameter
                {
                    Name = "operation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Retrieves the specified Operations resource. Gets a list of operations by making a `list()` request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="operation">Name of the Operations resource to return.</param>
        public virtual GetRequest Get(string project, string operation)
        {
            return new GetRequest(service, project, operation);
        }

        /// <summary>
        /// Retrieves the specified Operations resource. Gets a list of operations by making a `list()` request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string operation) : base(service)
            {
                Project = project;
                Operation = operation;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the Operations resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("operation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Operation { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/operations/{operation}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("operation", new Google.Apis.Discovery.Parameter
                {
                    Name = "operation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves a list of Operation resources contained within the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves a list of Operation resources contained within the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.OperationList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/operations";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Waits for the specified Operation resource to return as `DONE` or for the request to approach the 2 minute
        /// deadline, and retrieves the specified Operation resource. This method differs from the `GET` method in that
        /// it waits for no more than the default deadline (2 minutes) and then returns the current state of the
        /// operation, which might be `DONE` or still in progress.  This method is called on a best-effort basis.
        /// Specifically:   - In uncommon cases, when the server is overloaded, the request might return before the
        /// default deadline is reached, or might return after zero seconds.  - If the default deadline is reached,
        /// there is no guarantee that the operation is actually done when the method returns. Be prepared to retry if
        /// the operation is not `DONE`.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="operation">Name of the Operations resource to return.</param>
        public virtual WaitRequest Wait(string project, string operation)
        {
            return new WaitRequest(service, project, operation);
        }

        /// <summary>
        /// Waits for the specified Operation resource to return as `DONE` or for the request to approach the 2 minute
        /// deadline, and retrieves the specified Operation resource. This method differs from the `GET` method in that
        /// it waits for no more than the default deadline (2 minutes) and then returns the current state of the
        /// operation, which might be `DONE` or still in progress.  This method is called on a best-effort basis.
        /// Specifically:   - In uncommon cases, when the server is overloaded, the request might return before the
        /// default deadline is reached, or might return after zero seconds.  - If the default deadline is reached,
        /// there is no guarantee that the operation is actually done when the method returns. Be prepared to retry if
        /// the operation is not `DONE`.
        /// </summary>
        public class WaitRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Wait request.</summary>
            public WaitRequest(Google.Apis.Services.IClientService service, string project, string operation) : base(service)
            {
                Project = project;
                Operation = operation;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the Operations resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("operation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Operation { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "wait";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/operations/{operation}/wait";

            /// <summary>Initializes Wait parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("operation", new Google.Apis.Discovery.Parameter
                {
                    Name = "operation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "globalOrganizationOperations" collection of methods.</summary>
    public class GlobalOrganizationOperationsResource
    {
        private const string Resource = "globalOrganizationOperations";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public GlobalOrganizationOperationsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified Operations resource.</summary>
        /// <param name="operation">Name of the Operations resource to delete.</param>
        public virtual DeleteRequest Delete(string operation)
        {
            return new DeleteRequest(service, operation);
        }

        /// <summary>Deletes the specified Operations resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<string>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string operation) : base(service)
            {
                Operation = operation;
                InitParameters();
            }

            /// <summary>Name of the Operations resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("operation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Operation { get; private set; }

            /// <summary>Parent ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("parentId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string ParentId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/operations/{operation}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("operation", new Google.Apis.Discovery.Parameter
                {
                    Name = "operation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("parentId", new Google.Apis.Discovery.Parameter
                {
                    Name = "parentId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves the specified Operations resource. Gets a list of operations by making a `list()` request.
        /// </summary>
        /// <param name="operation">Name of the Operations resource to return.</param>
        public virtual GetRequest Get(string operation)
        {
            return new GetRequest(service, operation);
        }

        /// <summary>
        /// Retrieves the specified Operations resource. Gets a list of operations by making a `list()` request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string operation) : base(service)
            {
                Operation = operation;
                InitParameters();
            }

            /// <summary>Name of the Operations resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("operation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Operation { get; private set; }

            /// <summary>Parent ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("parentId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string ParentId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/operations/{operation}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("operation", new Google.Apis.Discovery.Parameter
                {
                    Name = "operation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("parentId", new Google.Apis.Discovery.Parameter
                {
                    Name = "parentId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of Operation resources contained within the specified organization.</summary>
        public virtual ListRequest List()
        {
            return new ListRequest(service);
        }

        /// <summary>Retrieves a list of Operation resources contained within the specified organization.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.OperationList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service) : base(service)
            {
                InitParameters();
            }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>Parent ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("parentId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string ParentId { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "locations/global/operations";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("parentId", new Google.Apis.Discovery.Parameter
                {
                    Name = "parentId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "healthChecks" collection of methods.</summary>
    public class HealthChecksResource
    {
        private const string Resource = "healthChecks";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public HealthChecksResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Retrieves the list of all HealthCheck resources, regional and global, available to the specified project.
        /// </summary>
        /// <param name="project">Name of the project scoping this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>
        /// Retrieves the list of all HealthCheck resources, regional and global, available to the specified project.
        /// </summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.HealthChecksAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Name of the project scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/healthChecks";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified HealthCheck resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="healthCheck">Name of the HealthCheck resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string healthCheck)
        {
            return new DeleteRequest(service, project, healthCheck);
        }

        /// <summary>Deletes the specified HealthCheck resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string healthCheck) : base(service)
            {
                Project = project;
                HealthCheck = healthCheck;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the HealthCheck resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("healthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HealthCheck { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/healthChecks/{healthCheck}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("healthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "healthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified HealthCheck resource. Gets a list of available health checks by making a list()
        /// request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="healthCheck">Name of the HealthCheck resource to return.</param>
        public virtual GetRequest Get(string project, string healthCheck)
        {
            return new GetRequest(service, project, healthCheck);
        }

        /// <summary>
        /// Returns the specified HealthCheck resource. Gets a list of available health checks by making a list()
        /// request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.HealthCheck>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string healthCheck) : base(service)
            {
                Project = project;
                HealthCheck = healthCheck;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the HealthCheck resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("healthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HealthCheck { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/healthChecks/{healthCheck}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("healthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "healthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a HealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.HealthCheck body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a HealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HealthCheck body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HealthCheck Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/healthChecks";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of HealthCheck resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of HealthCheck resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.HealthCheckList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/healthChecks";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates a HealthCheck resource in the specified project using the data included in the request. This method
        /// supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="healthCheck">Name of the HealthCheck resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.HealthCheck body, string project, string healthCheck)
        {
            return new PatchRequest(service, body, project, healthCheck);
        }

        /// <summary>
        /// Updates a HealthCheck resource in the specified project using the data included in the request. This method
        /// supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HealthCheck body, string project, string healthCheck) : base(service)
            {
                Project = project;
                HealthCheck = healthCheck;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the HealthCheck resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("healthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HealthCheck { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HealthCheck Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/healthChecks/{healthCheck}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("healthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "healthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates a HealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="healthCheck">Name of the HealthCheck resource to update.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.HealthCheck body, string project, string healthCheck)
        {
            return new UpdateRequest(service, body, project, healthCheck);
        }

        /// <summary>
        /// Updates a HealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HealthCheck body, string project, string healthCheck) : base(service)
            {
                Project = project;
                HealthCheck = healthCheck;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the HealthCheck resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("healthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HealthCheck { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HealthCheck Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/healthChecks/{healthCheck}";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("healthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "healthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "httpHealthChecks" collection of methods.</summary>
    public class HttpHealthChecksResource
    {
        private const string Resource = "httpHealthChecks";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public HttpHealthChecksResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified HttpHealthCheck resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="httpHealthCheck">Name of the HttpHealthCheck resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string httpHealthCheck)
        {
            return new DeleteRequest(service, project, httpHealthCheck);
        }

        /// <summary>Deletes the specified HttpHealthCheck resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string httpHealthCheck) : base(service)
            {
                Project = project;
                HttpHealthCheck = httpHealthCheck;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the HttpHealthCheck resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("httpHealthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HttpHealthCheck { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/httpHealthChecks/{httpHealthCheck}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("httpHealthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "httpHealthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified HttpHealthCheck resource. Gets a list of available HTTP health checks by making a
        /// list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="httpHealthCheck">Name of the HttpHealthCheck resource to return.</param>
        public virtual GetRequest Get(string project, string httpHealthCheck)
        {
            return new GetRequest(service, project, httpHealthCheck);
        }

        /// <summary>
        /// Returns the specified HttpHealthCheck resource. Gets a list of available HTTP health checks by making a
        /// list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.HttpHealthCheck>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string httpHealthCheck) : base(service)
            {
                Project = project;
                HttpHealthCheck = httpHealthCheck;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the HttpHealthCheck resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("httpHealthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HttpHealthCheck { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/httpHealthChecks/{httpHealthCheck}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("httpHealthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "httpHealthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a HttpHealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.HttpHealthCheck body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a HttpHealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HttpHealthCheck body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HttpHealthCheck Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/httpHealthChecks";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of HttpHealthCheck resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of HttpHealthCheck resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.HttpHealthCheckList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/httpHealthChecks";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates a HttpHealthCheck resource in the specified project using the data included in the request. This
        /// method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="httpHealthCheck">Name of the HttpHealthCheck resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.HttpHealthCheck body, string project, string httpHealthCheck)
        {
            return new PatchRequest(service, body, project, httpHealthCheck);
        }

        /// <summary>
        /// Updates a HttpHealthCheck resource in the specified project using the data included in the request. This
        /// method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HttpHealthCheck body, string project, string httpHealthCheck) : base(service)
            {
                Project = project;
                HttpHealthCheck = httpHealthCheck;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the HttpHealthCheck resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("httpHealthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HttpHealthCheck { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HttpHealthCheck Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/httpHealthChecks/{httpHealthCheck}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("httpHealthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "httpHealthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates a HttpHealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="httpHealthCheck">Name of the HttpHealthCheck resource to update.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.HttpHealthCheck body, string project, string httpHealthCheck)
        {
            return new UpdateRequest(service, body, project, httpHealthCheck);
        }

        /// <summary>
        /// Updates a HttpHealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HttpHealthCheck body, string project, string httpHealthCheck) : base(service)
            {
                Project = project;
                HttpHealthCheck = httpHealthCheck;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the HttpHealthCheck resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("httpHealthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HttpHealthCheck { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HttpHealthCheck Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/httpHealthChecks/{httpHealthCheck}";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("httpHealthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "httpHealthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "httpsHealthChecks" collection of methods.</summary>
    public class HttpsHealthChecksResource
    {
        private const string Resource = "httpsHealthChecks";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public HttpsHealthChecksResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified HttpsHealthCheck resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="httpsHealthCheck">Name of the HttpsHealthCheck resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string httpsHealthCheck)
        {
            return new DeleteRequest(service, project, httpsHealthCheck);
        }

        /// <summary>Deletes the specified HttpsHealthCheck resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string httpsHealthCheck) : base(service)
            {
                Project = project;
                HttpsHealthCheck = httpsHealthCheck;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the HttpsHealthCheck resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("httpsHealthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HttpsHealthCheck { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/httpsHealthChecks/{httpsHealthCheck}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("httpsHealthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "httpsHealthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified HttpsHealthCheck resource. Gets a list of available HTTPS health checks by making a
        /// list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="httpsHealthCheck">Name of the HttpsHealthCheck resource to return.</param>
        public virtual GetRequest Get(string project, string httpsHealthCheck)
        {
            return new GetRequest(service, project, httpsHealthCheck);
        }

        /// <summary>
        /// Returns the specified HttpsHealthCheck resource. Gets a list of available HTTPS health checks by making a
        /// list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.HttpsHealthCheck>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string httpsHealthCheck) : base(service)
            {
                Project = project;
                HttpsHealthCheck = httpsHealthCheck;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the HttpsHealthCheck resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("httpsHealthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HttpsHealthCheck { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/httpsHealthChecks/{httpsHealthCheck}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("httpsHealthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "httpsHealthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a HttpsHealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.HttpsHealthCheck body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a HttpsHealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HttpsHealthCheck body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HttpsHealthCheck Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/httpsHealthChecks";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of HttpsHealthCheck resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of HttpsHealthCheck resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.HttpsHealthCheckList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/httpsHealthChecks";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates a HttpsHealthCheck resource in the specified project using the data included in the request. This
        /// method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="httpsHealthCheck">Name of the HttpsHealthCheck resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.HttpsHealthCheck body, string project, string httpsHealthCheck)
        {
            return new PatchRequest(service, body, project, httpsHealthCheck);
        }

        /// <summary>
        /// Updates a HttpsHealthCheck resource in the specified project using the data included in the request. This
        /// method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HttpsHealthCheck body, string project, string httpsHealthCheck) : base(service)
            {
                Project = project;
                HttpsHealthCheck = httpsHealthCheck;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the HttpsHealthCheck resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("httpsHealthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HttpsHealthCheck { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HttpsHealthCheck Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/httpsHealthChecks/{httpsHealthCheck}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("httpsHealthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "httpsHealthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates a HttpsHealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="httpsHealthCheck">Name of the HttpsHealthCheck resource to update.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.HttpsHealthCheck body, string project, string httpsHealthCheck)
        {
            return new UpdateRequest(service, body, project, httpsHealthCheck);
        }

        /// <summary>
        /// Updates a HttpsHealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HttpsHealthCheck body, string project, string httpsHealthCheck) : base(service)
            {
                Project = project;
                HttpsHealthCheck = httpsHealthCheck;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the HttpsHealthCheck resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("httpsHealthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HttpsHealthCheck { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HttpsHealthCheck Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/httpsHealthChecks/{httpsHealthCheck}";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("httpsHealthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "httpsHealthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "images" collection of methods.</summary>
    public class ImagesResource
    {
        private const string Resource = "images";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public ImagesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified image.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="image">Name of the image resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string image)
        {
            return new DeleteRequest(service, project, image);
        }

        /// <summary>Deletes the specified image.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string image) : base(service)
            {
                Project = project;
                Image = image;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the image resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("image", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Image { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/images/{image}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("image", new Google.Apis.Discovery.Parameter
                {
                    Name = "image",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets the deprecation status of an image.  If an empty request body is given, clears the deprecation status
        /// instead.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="image">Image name.</param>
        public virtual DeprecateRequest Deprecate(Google.Apis.Compute.v1.Data.DeprecationStatus body, string project, string image)
        {
            return new DeprecateRequest(service, body, project, image);
        }

        /// <summary>
        /// Sets the deprecation status of an image.  If an empty request body is given, clears the deprecation status
        /// instead.
        /// </summary>
        public class DeprecateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Deprecate request.</summary>
            public DeprecateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.DeprecationStatus body, string project, string image) : base(service)
            {
                Project = project;
                Image = image;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Image name.</summary>
            [Google.Apis.Util.RequestParameterAttribute("image", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Image { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.DeprecationStatus Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "deprecate";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/images/{image}/deprecate";

            /// <summary>Initializes Deprecate parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("image", new Google.Apis.Discovery.Parameter
                {
                    Name = "image",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified image. Gets a list of available images by making a list() request.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="image">Name of the image resource to return.</param>
        public virtual GetRequest Get(string project, string image)
        {
            return new GetRequest(service, project, image);
        }

        /// <summary>Returns the specified image. Gets a list of available images by making a list() request.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Image>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string image) : base(service)
            {
                Project = project;
                Image = image;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the image resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("image", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Image { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/images/{image}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("image", new Google.Apis.Discovery.Parameter
                {
                    Name = "image",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Returns the latest image that is part of an image family and is not deprecated.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="family">Name of the image family to search for.</param>
        public virtual GetFromFamilyRequest GetFromFamily(string project, string family)
        {
            return new GetFromFamilyRequest(service, project, family);
        }

        /// <summary>Returns the latest image that is part of an image family and is not deprecated.</summary>
        public class GetFromFamilyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Image>
        {
            /// <summary>Constructs a new GetFromFamily request.</summary>
            public GetFromFamilyRequest(Google.Apis.Services.IClientService service, string project, string family) : base(service)
            {
                Project = project;
                Family = family;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the image family to search for.</summary>
            [Google.Apis.Util.RequestParameterAttribute("family", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Family { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getFromFamily";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/images/family/{family}";

            /// <summary>Initializes GetFromFamily parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("family", new Google.Apis.Discovery.Parameter
                {
                    Name = "family",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual GetIamPolicyRequest GetIamPolicy(string project, string resource)
        {
            return new GetIamPolicyRequest(service, project, resource);
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        public class GetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new GetIamPolicy request.</summary>
            public GetIamPolicyRequest(Google.Apis.Services.IClientService service, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Requested IAM Policy version.</summary>
            [Google.Apis.Util.RequestParameterAttribute("optionsRequestedPolicyVersion", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> OptionsRequestedPolicyVersion { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/images/{resource}/getIamPolicy";

            /// <summary>Initializes GetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("optionsRequestedPolicyVersion", new Google.Apis.Discovery.Parameter
                {
                    Name = "optionsRequestedPolicyVersion",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Creates an image in the specified project using the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Image body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>Creates an image in the specified project using the data included in the request.</summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Image body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Force image creation if true.</summary>
            [Google.Apis.Util.RequestParameterAttribute("forceCreate", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ForceCreate { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Image Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/images";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("forceCreate", new Google.Apis.Discovery.Parameter
                {
                    Name = "forceCreate",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves the list of custom images available to the specified project. Custom images are images you create
        /// that belong to your project. This method does not get any images that belong to other projects, including
        /// publicly-available images, like Debian 8. If you want to get a list of publicly-available images, use this
        /// method to make a request to the respective image project, such as debian-cloud or windows-cloud.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>
        /// Retrieves the list of custom images available to the specified project. Custom images are images you create
        /// that belong to your project. This method does not get any images that belong to other projects, including
        /// publicly-available images, like Debian 8. If you want to get a list of publicly-available images, use this
        /// method to make a request to the respective image project, such as debian-cloud or windows-cloud.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ImageList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/images";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Patches the specified image with the data included in the request. Only the following fields can be
        /// modified: family, description, deprecation status.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="image">Name of the image resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.Image body, string project, string image)
        {
            return new PatchRequest(service, body, project, image);
        }

        /// <summary>
        /// Patches the specified image with the data included in the request. Only the following fields can be
        /// modified: family, description, deprecation status.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Image body, string project, string image) : base(service)
            {
                Project = project;
                Image = image;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the image resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("image", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Image { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Image Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/images/{image}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("image", new Google.Apis.Discovery.Parameter
                {
                    Name = "image",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetIamPolicyRequest SetIamPolicy(Google.Apis.Compute.v1.Data.GlobalSetPolicyRequest body, string project, string resource)
        {
            return new SetIamPolicyRequest(service, body, project, resource);
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        public class SetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new SetIamPolicy request.</summary>
            public SetIamPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.GlobalSetPolicyRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.GlobalSetPolicyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/images/{resource}/setIamPolicy";

            /// <summary>Initializes SetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Sets the labels on an image. To learn more about labels, read the Labeling Resources documentation.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetLabelsRequest SetLabels(Google.Apis.Compute.v1.Data.GlobalSetLabelsRequest body, string project, string resource)
        {
            return new SetLabelsRequest(service, body, project, resource);
        }

        /// <summary>
        /// Sets the labels on an image. To learn more about labels, read the Labeling Resources documentation.
        /// </summary>
        public class SetLabelsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetLabels request.</summary>
            public SetLabelsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.GlobalSetLabelsRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.GlobalSetLabelsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setLabels";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/images/{resource}/setLabels";

            /// <summary>Initializes SetLabels parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/images/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "instanceGroupManagers" collection of methods.</summary>
    public class InstanceGroupManagersResource
    {
        private const string Resource = "instanceGroupManagers";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public InstanceGroupManagersResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Flags the specified instances to be removed from the managed instance group. Abandoning an instance does not
        /// delete the instance, but it does remove the instance from any target pools that are applied by the managed
        /// instance group. This method reduces the targetSize of the managed instance group by the number of instances
        /// that you abandon. This operation is marked as DONE when the action is scheduled even if the instances have
        /// not yet been removed from the group. You must separately verify the status of the abandoning action with the
        /// listmanagedinstances method.  If the group is part of a backend service that has enabled connection
        /// draining, it can take up to 60 seconds after the connection draining duration has elapsed before the VM
        /// instance is removed or deleted.  You can specify a maximum of 1000 instances with this method per request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the managed instance group is located.</param>
        /// <param name="instanceGroupManager">The name of the managed instance group.</param>
        public virtual AbandonInstancesRequest AbandonInstances(Google.Apis.Compute.v1.Data.InstanceGroupManagersAbandonInstancesRequest body, string project, string zone, string instanceGroupManager)
        {
            return new AbandonInstancesRequest(service, body, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Flags the specified instances to be removed from the managed instance group. Abandoning an instance does not
        /// delete the instance, but it does remove the instance from any target pools that are applied by the managed
        /// instance group. This method reduces the targetSize of the managed instance group by the number of instances
        /// that you abandon. This operation is marked as DONE when the action is scheduled even if the instances have
        /// not yet been removed from the group. You must separately verify the status of the abandoning action with the
        /// listmanagedinstances method.  If the group is part of a backend service that has enabled connection
        /// draining, it can take up to 60 seconds after the connection draining duration has elapsed before the VM
        /// instance is removed or deleted.  You can specify a maximum of 1000 instances with this method per request.
        /// </summary>
        public class AbandonInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AbandonInstances request.</summary>
            public AbandonInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManagersAbandonInstancesRequest body, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the managed instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManagersAbandonInstancesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "abandonInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/abandonInstances";

            /// <summary>Initializes AbandonInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of managed instance groups and groups them by zone.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves the list of managed instance groups and groups them by zone.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceGroupManagerAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/instanceGroupManagers";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Applies changes to selected instances on the managed instance group. This method can be used to apply new
        /// overrides and/or new versions.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where the managed instance group is located. Should conform to RFC1035.
        /// </param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group, should conform to RFC1035.
        /// </param>
        public virtual ApplyUpdatesToInstancesRequest ApplyUpdatesToInstances(Google.Apis.Compute.v1.Data.InstanceGroupManagersApplyUpdatesRequest body, string project, string zone, string instanceGroupManager)
        {
            return new ApplyUpdatesToInstancesRequest(service, body, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Applies changes to selected instances on the managed instance group. This method can be used to apply new
        /// overrides and/or new versions.
        /// </summary>
        public class ApplyUpdatesToInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new ApplyUpdatesToInstances request.</summary>
            public ApplyUpdatesToInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManagersApplyUpdatesRequest body, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where the managed instance group is located. Should conform to RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group, should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManagersApplyUpdatesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "applyUpdatesToInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/applyUpdatesToInstances";

            /// <summary>Initializes ApplyUpdatesToInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates instances with per-instance configs in this managed instance group. Instances are created using the
        /// current instance template. The create instances operation is marked DONE if the createInstances request is
        /// successful. The underlying actions take additional time. You must separately verify the status of the
        /// creating or actions with the listmanagedinstances method.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where the managed instance group is located. It should conform to RFC1035.
        /// </param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group. It should conform to RFC1035.
        /// </param>
        public virtual CreateInstancesRequest CreateInstances(Google.Apis.Compute.v1.Data.InstanceGroupManagersCreateInstancesRequest body, string project, string zone, string instanceGroupManager)
        {
            return new CreateInstancesRequest(service, body, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Creates instances with per-instance configs in this managed instance group. Instances are created using the
        /// current instance template. The create instances operation is marked DONE if the createInstances request is
        /// successful. The underlying actions take additional time. You must separately verify the status of the
        /// creating or actions with the listmanagedinstances method.
        /// </summary>
        public class CreateInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new CreateInstances request.</summary>
            public CreateInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManagersCreateInstancesRequest body, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where the managed instance group is located. It should conform to RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group. It should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request.  The request ID must be a valid UUID with
            /// the exception that zero UUID is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManagersCreateInstancesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "createInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/createInstances";

            /// <summary>Initializes CreateInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Deletes the specified managed instance group and all of the instances in that group. Note that the instance
        /// group must not belong to a backend service. Read  Deleting an instance group for more information.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the managed instance group is located.</param>
        /// <param name="instanceGroupManager">The name of the managed instance group to delete.</param>
        public virtual DeleteRequest Delete(string project, string zone, string instanceGroupManager)
        {
            return new DeleteRequest(service, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Deletes the specified managed instance group and all of the instances in that group. Note that the instance
        /// group must not belong to a backend service. Read  Deleting an instance group for more information.
        /// </summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the managed instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Flags the specified instances in the managed instance group for immediate deletion. The instances are also
        /// removed from any target pools of which they were a member. This method reduces the targetSize of the managed
        /// instance group by the number of instances that you delete. This operation is marked as DONE when the action
        /// is scheduled even if the instances are still being deleted. You must separately verify the status of the
        /// deleting action with the listmanagedinstances method.  If the group is part of a backend service that has
        /// enabled connection draining, it can take up to 60 seconds after the connection draining duration has elapsed
        /// before the VM instance is removed or deleted.  You can specify a maximum of 1000 instances with this method
        /// per request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the managed instance group is located.</param>
        /// <param name="instanceGroupManager">The name of the managed instance group.</param>
        public virtual DeleteInstancesRequest DeleteInstances(Google.Apis.Compute.v1.Data.InstanceGroupManagersDeleteInstancesRequest body, string project, string zone, string instanceGroupManager)
        {
            return new DeleteInstancesRequest(service, body, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Flags the specified instances in the managed instance group for immediate deletion. The instances are also
        /// removed from any target pools of which they were a member. This method reduces the targetSize of the managed
        /// instance group by the number of instances that you delete. This operation is marked as DONE when the action
        /// is scheduled even if the instances are still being deleted. You must separately verify the status of the
        /// deleting action with the listmanagedinstances method.  If the group is part of a backend service that has
        /// enabled connection draining, it can take up to 60 seconds after the connection draining duration has elapsed
        /// before the VM instance is removed or deleted.  You can specify a maximum of 1000 instances with this method
        /// per request.
        /// </summary>
        public class DeleteInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new DeleteInstances request.</summary>
            public DeleteInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManagersDeleteInstancesRequest body, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the managed instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManagersDeleteInstancesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "deleteInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/deleteInstances";

            /// <summary>Initializes DeleteInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes selected per-instance configs for the managed instance group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where the managed instance group is located. It should conform to RFC1035.
        /// </param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group. It should conform to RFC1035.
        /// </param>
        public virtual DeletePerInstanceConfigsRequest DeletePerInstanceConfigs(Google.Apis.Compute.v1.Data.InstanceGroupManagersDeletePerInstanceConfigsReq body, string project, string zone, string instanceGroupManager)
        {
            return new DeletePerInstanceConfigsRequest(service, body, project, zone, instanceGroupManager);
        }

        /// <summary>Deletes selected per-instance configs for the managed instance group.</summary>
        public class DeletePerInstanceConfigsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new DeletePerInstanceConfigs request.</summary>
            public DeletePerInstanceConfigsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManagersDeletePerInstanceConfigsReq body, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where the managed instance group is located. It should conform to RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group. It should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManagersDeletePerInstanceConfigsReq Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "deletePerInstanceConfigs";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/deletePerInstanceConfigs";

            /// <summary>Initializes DeletePerInstanceConfigs parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns all of the details about the specified managed instance group. Gets a list of available managed
        /// instance groups by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the managed instance group is located.</param>
        /// <param name="instanceGroupManager">The name of the managed instance group.</param>
        public virtual GetRequest Get(string project, string zone, string instanceGroupManager)
        {
            return new GetRequest(service, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Returns all of the details about the specified managed instance group. Gets a list of available managed
        /// instance groups by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceGroupManager>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the managed instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates a managed instance group using the information that you specify in the request. After the group is
        /// created, instances in the group are created using the specified instance template. This operation is marked
        /// as DONE when the group is created even if the instances in the group have not yet been created. You must
        /// separately verify the status of the individual instances with the listmanagedinstances method.  A managed
        /// instance group can have up to 1000 VM instances per group. Please contact Cloud Support if you need an
        /// increase in this limit.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where you want to create the managed instance group.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.InstanceGroupManager body, string project, string zone)
        {
            return new InsertRequest(service, body, project, zone);
        }

        /// <summary>
        /// Creates a managed instance group using the information that you specify in the request. After the group is
        /// created, instances in the group are created using the specified instance template. This operation is marked
        /// as DONE when the group is created even if the instances in the group have not yet been created. You must
        /// separately verify the status of the individual instances with the listmanagedinstances method.  A managed
        /// instance group can have up to 1000 VM instances per group. Please contact Cloud Support if you need an
        /// increase in this limit.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManager body, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where you want to create the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManager Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves a list of managed instance groups that are contained within the specified project and zone.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the managed instance group is located.</param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>
        /// Retrieves a list of managed instance groups that are contained within the specified project and zone.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceGroupManagerList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the managed instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Lists all errors thrown by actions on instances for a given managed instance group. The filter and orderBy
        /// query parameters are not supported.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where the managed instance group is located. It should conform to RFC1035.
        /// </param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group. It must be a string that meets the requirements in RFC1035, or an
        /// unsigned long integer: must match regexp pattern: (?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?)|[1-9][0-9]{0,19}.
        /// </param>
        public virtual ListErrorsRequest ListErrors(string project, string zone, string instanceGroupManager)
        {
            return new ListErrorsRequest(service, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Lists all errors thrown by actions on instances for a given managed instance group. The filter and orderBy
        /// query parameters are not supported.
        /// </summary>
        public class ListErrorsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceGroupManagersListErrorsResponse>
        {
            /// <summary>Constructs a new ListErrors request.</summary>
            public ListErrorsRequest(Google.Apis.Services.IClientService service, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where the managed instance group is located. It should conform to RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// The name of the managed instance group. It must be a string that meets the requirements in RFC1035, or
            /// an unsigned long integer: must match regexp pattern:
            /// (?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?)|[1-9][0-9]{0,19}.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listErrors";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/listErrors";

            /// <summary>Initializes ListErrors parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Lists all of the instances in the managed instance group. Each instance in the list has a currentAction,
        /// which indicates the action that the managed instance group is performing on the instance. For example, if
        /// the group is still creating an instance, the currentAction is CREATING. If a previous action failed, the
        /// list displays the errors for that failed action. The orderBy query parameter is not supported.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the managed instance group is located.</param>
        /// <param name="instanceGroupManager">The name of the managed instance group.</param>
        public virtual ListManagedInstancesRequest ListManagedInstances(string project, string zone, string instanceGroupManager)
        {
            return new ListManagedInstancesRequest(service, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Lists all of the instances in the managed instance group. Each instance in the list has a currentAction,
        /// which indicates the action that the managed instance group is performing on the instance. For example, if
        /// the group is still creating an instance, the currentAction is CREATING. If a previous action failed, the
        /// list displays the errors for that failed action. The orderBy query parameter is not supported.
        /// </summary>
        public class ListManagedInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceGroupManagersListManagedInstancesResponse>
        {
            /// <summary>Constructs a new ListManagedInstances request.</summary>
            public ListManagedInstancesRequest(Google.Apis.Services.IClientService service, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the managed instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listManagedInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/listManagedInstances";

            /// <summary>Initializes ListManagedInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Lists all of the per-instance configs defined for the managed instance group. The orderBy query parameter is
        /// not supported.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where the managed instance group is located. It should conform to RFC1035.
        /// </param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group. It should conform to RFC1035.
        /// </param>
        public virtual ListPerInstanceConfigsRequest ListPerInstanceConfigs(string project, string zone, string instanceGroupManager)
        {
            return new ListPerInstanceConfigsRequest(service, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Lists all of the per-instance configs defined for the managed instance group. The orderBy query parameter is
        /// not supported.
        /// </summary>
        public class ListPerInstanceConfigsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceGroupManagersListPerInstanceConfigsResp>
        {
            /// <summary>Constructs a new ListPerInstanceConfigs request.</summary>
            public ListPerInstanceConfigsRequest(Google.Apis.Services.IClientService service, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where the managed instance group is located. It should conform to RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group. It should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listPerInstanceConfigs";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/listPerInstanceConfigs";

            /// <summary>Initializes ListPerInstanceConfigs parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates a managed instance group using the information that you specify in the request. This operation is
        /// marked as DONE when the group is patched even if the instances in the group are still in the process of
        /// being patched. You must separately verify the status of the individual instances with the
        /// listManagedInstances method. This method supports PATCH semantics and uses the JSON merge patch format and
        /// processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where you want to create the managed instance group.</param>
        /// <param name="instanceGroupManager">The name of the instance group manager.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.InstanceGroupManager body, string project, string zone, string instanceGroupManager)
        {
            return new PatchRequest(service, body, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Updates a managed instance group using the information that you specify in the request. This operation is
        /// marked as DONE when the group is patched even if the instances in the group are still in the process of
        /// being patched. You must separately verify the status of the individual instances with the
        /// listManagedInstances method. This method supports PATCH semantics and uses the JSON merge patch format and
        /// processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManager body, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where you want to create the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the instance group manager.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManager Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Inserts or patches per-instance configs for the managed instance group. perInstanceConfig.name serves as a
        /// key used to distinguish whether to perform insert or patch.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where the managed instance group is located. It should conform to RFC1035.
        /// </param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group. It should conform to RFC1035.
        /// </param>
        public virtual PatchPerInstanceConfigsRequest PatchPerInstanceConfigs(Google.Apis.Compute.v1.Data.InstanceGroupManagersPatchPerInstanceConfigsReq body, string project, string zone, string instanceGroupManager)
        {
            return new PatchPerInstanceConfigsRequest(service, body, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Inserts or patches per-instance configs for the managed instance group. perInstanceConfig.name serves as a
        /// key used to distinguish whether to perform insert or patch.
        /// </summary>
        public class PatchPerInstanceConfigsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new PatchPerInstanceConfigs request.</summary>
            public PatchPerInstanceConfigsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManagersPatchPerInstanceConfigsReq body, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where the managed instance group is located. It should conform to RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group. It should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManagersPatchPerInstanceConfigsReq Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patchPerInstanceConfigs";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/patchPerInstanceConfigs";

            /// <summary>Initializes PatchPerInstanceConfigs parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Flags the specified instances in the managed instance group to be immediately recreated. The instances are
        /// deleted and recreated using the current instance template for the managed instance group. This operation is
        /// marked as DONE when the flag is set even if the instances have not yet been recreated. You must separately
        /// verify the status of the recreating action with the listmanagedinstances method.  If the group is part of a
        /// backend service that has enabled connection draining, it can take up to 60 seconds after the connection
        /// draining duration has elapsed before the VM instance is removed or deleted.  You can specify a maximum of
        /// 1000 instances with this method per request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the managed instance group is located.</param>
        /// <param name="instanceGroupManager">The name of the managed instance group.</param>
        public virtual RecreateInstancesRequest RecreateInstances(Google.Apis.Compute.v1.Data.InstanceGroupManagersRecreateInstancesRequest body, string project, string zone, string instanceGroupManager)
        {
            return new RecreateInstancesRequest(service, body, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Flags the specified instances in the managed instance group to be immediately recreated. The instances are
        /// deleted and recreated using the current instance template for the managed instance group. This operation is
        /// marked as DONE when the flag is set even if the instances have not yet been recreated. You must separately
        /// verify the status of the recreating action with the listmanagedinstances method.  If the group is part of a
        /// backend service that has enabled connection draining, it can take up to 60 seconds after the connection
        /// draining duration has elapsed before the VM instance is removed or deleted.  You can specify a maximum of
        /// 1000 instances with this method per request.
        /// </summary>
        public class RecreateInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new RecreateInstances request.</summary>
            public RecreateInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManagersRecreateInstancesRequest body, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the managed instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManagersRecreateInstancesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "recreateInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/recreateInstances";

            /// <summary>Initializes RecreateInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Resizes the managed instance group. If you increase the size, the group creates new instances using the
        /// current instance template. If you decrease the size, the group deletes instances. The resize operation is
        /// marked DONE when the resize actions are scheduled even if the group has not yet added or deleted any
        /// instances. You must separately verify the status of the creating or deleting actions with the
        /// listmanagedinstances method.  When resizing down, the instance group arbitrarily chooses the order in which
        /// VMs are deleted. The group takes into account some VM attributes when making the selection including:  + The
        /// status of the VM instance. + The health of the VM instance. + The instance template version the VM is based
        /// on. + For regional managed instance groups, the location of the VM instance.  This list is subject to
        /// change.  If the group is part of a backend service that has enabled connection draining, it can take up to
        /// 60 seconds after the connection draining duration has elapsed before the VM instance is removed or deleted.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the managed instance group is located.</param>
        /// <param name="instanceGroupManager">The name of the managed instance group.</param>
        /// <param name="size">
        /// The number of running instances that the managed instance group should maintain at any given time. The group
        /// automatically adds or removes instances to maintain the number of instances specified by this parameter.
        /// </param>
        public virtual ResizeRequest Resize(string project, string zone, string instanceGroupManager, int size)
        {
            return new ResizeRequest(service, project, zone, instanceGroupManager, size);
        }

        /// <summary>
        /// Resizes the managed instance group. If you increase the size, the group creates new instances using the
        /// current instance template. If you decrease the size, the group deletes instances. The resize operation is
        /// marked DONE when the resize actions are scheduled even if the group has not yet added or deleted any
        /// instances. You must separately verify the status of the creating or deleting actions with the
        /// listmanagedinstances method.  When resizing down, the instance group arbitrarily chooses the order in which
        /// VMs are deleted. The group takes into account some VM attributes when making the selection including:  + The
        /// status of the VM instance. + The health of the VM instance. + The instance template version the VM is based
        /// on. + For regional managed instance groups, the location of the VM instance.  This list is subject to
        /// change.  If the group is part of a backend service that has enabled connection draining, it can take up to
        /// 60 seconds after the connection draining duration has elapsed before the VM instance is removed or deleted.
        /// </summary>
        public class ResizeRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Resize request.</summary>
            public ResizeRequest(Google.Apis.Services.IClientService service, string project, string zone, string instanceGroupManager, int size) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                Size = size;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the managed instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// The number of running instances that the managed instance group should maintain at any given time. The
            /// group automatically adds or removes instances to maintain the number of instances specified by this
            /// parameter.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("size", Google.Apis.Util.RequestParameterType.Query)]
            public virtual int Size { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "resize";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/resize";

            /// <summary>Initializes Resize parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("size", new Google.Apis.Discovery.Parameter
                {
                    Name = "size",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Specifies the instance template to use when creating new instances in this group. The templates for existing
        /// instances in the group do not change unless you run recreateInstances, run applyUpdatesToInstances, or set
        /// the group's updatePolicy.type to PROACTIVE.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the managed instance group is located.</param>
        /// <param name="instanceGroupManager">The name of the managed instance group.</param>
        public virtual SetInstanceTemplateRequest SetInstanceTemplate(Google.Apis.Compute.v1.Data.InstanceGroupManagersSetInstanceTemplateRequest body, string project, string zone, string instanceGroupManager)
        {
            return new SetInstanceTemplateRequest(service, body, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Specifies the instance template to use when creating new instances in this group. The templates for existing
        /// instances in the group do not change unless you run recreateInstances, run applyUpdatesToInstances, or set
        /// the group's updatePolicy.type to PROACTIVE.
        /// </summary>
        public class SetInstanceTemplateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetInstanceTemplate request.</summary>
            public SetInstanceTemplateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManagersSetInstanceTemplateRequest body, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the managed instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManagersSetInstanceTemplateRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setInstanceTemplate";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/setInstanceTemplate";

            /// <summary>Initializes SetInstanceTemplate parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Modifies the target pools to which all instances in this managed instance group are assigned. The target
        /// pools automatically apply to all of the instances in the managed instance group. This operation is marked
        /// DONE when you make the request even if the instances have not yet been added to their target pools. The
        /// change might take some time to apply to all of the instances in the group depending on the size of the
        /// group.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the managed instance group is located.</param>
        /// <param name="instanceGroupManager">The name of the managed instance group.</param>
        public virtual SetTargetPoolsRequest SetTargetPools(Google.Apis.Compute.v1.Data.InstanceGroupManagersSetTargetPoolsRequest body, string project, string zone, string instanceGroupManager)
        {
            return new SetTargetPoolsRequest(service, body, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Modifies the target pools to which all instances in this managed instance group are assigned. The target
        /// pools automatically apply to all of the instances in the managed instance group. This operation is marked
        /// DONE when you make the request even if the instances have not yet been added to their target pools. The
        /// change might take some time to apply to all of the instances in the group depending on the size of the
        /// group.
        /// </summary>
        public class SetTargetPoolsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetTargetPools request.</summary>
            public SetTargetPoolsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManagersSetTargetPoolsRequest body, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the managed instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManagersSetTargetPoolsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setTargetPools";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/setTargetPools";

            /// <summary>Initializes SetTargetPools parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Inserts or updates per-instance configs for the managed instance group. perInstanceConfig.name serves as a
        /// key used to distinguish whether to perform insert or patch.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where the managed instance group is located. It should conform to RFC1035.
        /// </param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group. It should conform to RFC1035.
        /// </param>
        public virtual UpdatePerInstanceConfigsRequest UpdatePerInstanceConfigs(Google.Apis.Compute.v1.Data.InstanceGroupManagersUpdatePerInstanceConfigsReq body, string project, string zone, string instanceGroupManager)
        {
            return new UpdatePerInstanceConfigsRequest(service, body, project, zone, instanceGroupManager);
        }

        /// <summary>
        /// Inserts or updates per-instance configs for the managed instance group. perInstanceConfig.name serves as a
        /// key used to distinguish whether to perform insert or patch.
        /// </summary>
        public class UpdatePerInstanceConfigsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new UpdatePerInstanceConfigs request.</summary>
            public UpdatePerInstanceConfigsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManagersUpdatePerInstanceConfigsReq body, string project, string zone, string instanceGroupManager) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where the managed instance group is located. It should conform to RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the managed instance group. It should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManagersUpdatePerInstanceConfigsReq Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "updatePerInstanceConfigs";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroupManagers/{instanceGroupManager}/updatePerInstanceConfigs";

            /// <summary>Initializes UpdatePerInstanceConfigs parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "instanceGroups" collection of methods.</summary>
    public class InstanceGroupsResource
    {
        private const string Resource = "instanceGroups";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public InstanceGroupsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Adds a list of instances to the specified instance group. All of the instances in the instance group must be
        /// in the same network/subnetwork. Read  Adding instances for more information.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the instance group is located.</param>
        /// <param name="instanceGroup">The name of the instance group where you are adding instances.</param>
        public virtual AddInstancesRequest AddInstances(Google.Apis.Compute.v1.Data.InstanceGroupsAddInstancesRequest body, string project, string zone, string instanceGroup)
        {
            return new AddInstancesRequest(service, body, project, zone, instanceGroup);
        }

        /// <summary>
        /// Adds a list of instances to the specified instance group. All of the instances in the instance group must be
        /// in the same network/subnetwork. Read  Adding instances for more information.
        /// </summary>
        public class AddInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddInstances request.</summary>
            public AddInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupsAddInstancesRequest body, string project, string zone, string instanceGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroup = instanceGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the instance group where you are adding instances.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupsAddInstancesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroups/{instanceGroup}/addInstances";

            /// <summary>Initializes AddInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of instance groups and sorts them by zone.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves the list of instance groups and sorts them by zone.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceGroupAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/instanceGroups";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Deletes the specified instance group. The instances in the group are not deleted. Note that instance group
        /// must not belong to a backend service. Read  Deleting an instance group for more information.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the instance group is located.</param>
        /// <param name="instanceGroup">The name of the instance group to delete.</param>
        public virtual DeleteRequest Delete(string project, string zone, string instanceGroup)
        {
            return new DeleteRequest(service, project, zone, instanceGroup);
        }

        /// <summary>
        /// Deletes the specified instance group. The instances in the group are not deleted. Note that instance group
        /// must not belong to a backend service. Read  Deleting an instance group for more information.
        /// </summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string zone, string instanceGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroup = instanceGroup;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the instance group to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroups/{instanceGroup}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified zonal instance group. Get a list of available zonal instance groups by making a list()
        /// request.  For managed instance groups, use the instanceGroupManagers or regionInstanceGroupManagers methods
        /// instead.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the instance group is located.</param>
        /// <param name="instanceGroup">The name of the instance group.</param>
        public virtual GetRequest Get(string project, string zone, string instanceGroup)
        {
            return new GetRequest(service, project, zone, instanceGroup);
        }

        /// <summary>
        /// Returns the specified zonal instance group. Get a list of available zonal instance groups by making a list()
        /// request.  For managed instance groups, use the instanceGroupManagers or regionInstanceGroupManagers methods
        /// instead.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceGroup>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string instanceGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroup = instanceGroup;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroup { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroups/{instanceGroup}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates an instance group in the specified project using the parameters that are included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where you want to create the instance group.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.InstanceGroup body, string project, string zone)
        {
            return new InsertRequest(service, body, project, zone);
        }

        /// <summary>
        /// Creates an instance group in the specified project using the parameters that are included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroup body, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where you want to create the instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroup Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroups";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves the list of zonal instance group resources contained within the specified zone.  For managed
        /// instance groups, use the instanceGroupManagers or regionInstanceGroupManagers methods instead.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the instance group is located.</param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>
        /// Retrieves the list of zonal instance group resources contained within the specified zone.  For managed
        /// instance groups, use the instanceGroupManagers or regionInstanceGroupManagers methods instead.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceGroupList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroups";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Lists the instances in the specified instance group. The orderBy query parameter is not supported.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the instance group is located.</param>
        /// <param name="instanceGroup">
        /// The name of the instance group from which you want to generate a list of included instances.
        /// </param>
        public virtual ListInstancesRequest ListInstances(Google.Apis.Compute.v1.Data.InstanceGroupsListInstancesRequest body, string project, string zone, string instanceGroup)
        {
            return new ListInstancesRequest(service, body, project, zone, instanceGroup);
        }

        /// <summary>
        /// Lists the instances in the specified instance group. The orderBy query parameter is not supported.
        /// </summary>
        public class ListInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceGroupsListInstances>
        {
            /// <summary>Constructs a new ListInstances request.</summary>
            public ListInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupsListInstancesRequest body, string project, string zone, string instanceGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroup = instanceGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// The name of the instance group from which you want to generate a list of included instances.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroup { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupsListInstancesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroups/{instanceGroup}/listInstances";

            /// <summary>Initializes ListInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Removes one or more instances from the specified instance group, but does not delete those instances.  If
        /// the group is part of a backend service that has enabled connection draining, it can take up to 60 seconds
        /// after the connection draining duration before the VM instance is removed or deleted.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the instance group is located.</param>
        /// <param name="instanceGroup">
        /// The name of the instance group where the specified instances will be removed.
        /// </param>
        public virtual RemoveInstancesRequest RemoveInstances(Google.Apis.Compute.v1.Data.InstanceGroupsRemoveInstancesRequest body, string project, string zone, string instanceGroup)
        {
            return new RemoveInstancesRequest(service, body, project, zone, instanceGroup);
        }

        /// <summary>
        /// Removes one or more instances from the specified instance group, but does not delete those instances.  If
        /// the group is part of a backend service that has enabled connection draining, it can take up to 60 seconds
        /// after the connection draining duration before the VM instance is removed or deleted.
        /// </summary>
        public class RemoveInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new RemoveInstances request.</summary>
            public RemoveInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupsRemoveInstancesRequest body, string project, string zone, string instanceGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroup = instanceGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the instance group where the specified instances will be removed.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupsRemoveInstancesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "removeInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroups/{instanceGroup}/removeInstances";

            /// <summary>Initializes RemoveInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the named ports for the specified instance group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone where the instance group is located.</param>
        /// <param name="instanceGroup">The name of the instance group where the named ports are updated.</param>
        public virtual SetNamedPortsRequest SetNamedPorts(Google.Apis.Compute.v1.Data.InstanceGroupsSetNamedPortsRequest body, string project, string zone, string instanceGroup)
        {
            return new SetNamedPortsRequest(service, body, project, zone, instanceGroup);
        }

        /// <summary>Sets the named ports for the specified instance group.</summary>
        public class SetNamedPortsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetNamedPorts request.</summary>
            public SetNamedPortsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupsSetNamedPortsRequest body, string project, string zone, string instanceGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                InstanceGroup = instanceGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone where the instance group is located.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the instance group where the named ports are updated.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupsSetNamedPortsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setNamedPorts";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instanceGroups/{instanceGroup}/setNamedPorts";

            /// <summary>Initializes SetNamedPorts parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "instanceTemplates" collection of methods.</summary>
    public class InstanceTemplatesResource
    {
        private const string Resource = "instanceTemplates";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public InstanceTemplatesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Deletes the specified instance template. Deleting an instance template is permanent and cannot be undone. It
        /// is not possible to delete templates that are already in use by a managed instance group.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="instanceTemplate">The name of the instance template to delete.</param>
        public virtual DeleteRequest Delete(string project, string instanceTemplate)
        {
            return new DeleteRequest(service, project, instanceTemplate);
        }

        /// <summary>
        /// Deletes the specified instance template. Deleting an instance template is permanent and cannot be undone. It
        /// is not possible to delete templates that are already in use by a managed instance group.
        /// </summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string instanceTemplate) : base(service)
            {
                Project = project;
                InstanceTemplate = instanceTemplate;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the instance template to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceTemplate", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceTemplate { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/instanceTemplates/{instanceTemplate}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("instanceTemplate", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceTemplate",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified instance template. Gets a list of available instance templates by making a list()
        /// request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="instanceTemplate">The name of the instance template.</param>
        public virtual GetRequest Get(string project, string instanceTemplate)
        {
            return new GetRequest(service, project, instanceTemplate);
        }

        /// <summary>
        /// Returns the specified instance template. Gets a list of available instance templates by making a list()
        /// request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceTemplate>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string instanceTemplate) : base(service)
            {
                Project = project;
                InstanceTemplate = instanceTemplate;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the instance template.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceTemplate", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceTemplate { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/instanceTemplates/{instanceTemplate}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("instanceTemplate", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceTemplate",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual GetIamPolicyRequest GetIamPolicy(string project, string resource)
        {
            return new GetIamPolicyRequest(service, project, resource);
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        public class GetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new GetIamPolicy request.</summary>
            public GetIamPolicyRequest(Google.Apis.Services.IClientService service, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Requested IAM Policy version.</summary>
            [Google.Apis.Util.RequestParameterAttribute("optionsRequestedPolicyVersion", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> OptionsRequestedPolicyVersion { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/instanceTemplates/{resource}/getIamPolicy";

            /// <summary>Initializes GetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("optionsRequestedPolicyVersion", new Google.Apis.Discovery.Parameter
                {
                    Name = "optionsRequestedPolicyVersion",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates an instance template in the specified project using the data that is included in the request. If you
        /// are creating a new template to update an existing instance group, your new instance template must use the
        /// same network or, if applicable, the same subnetwork as the original template.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.InstanceTemplate body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates an instance template in the specified project using the data that is included in the request. If you
        /// are creating a new template to update an existing instance group, your new instance template must use the
        /// same network or, if applicable, the same subnetwork as the original template.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceTemplate body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceTemplate Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/instanceTemplates";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of instance templates that are contained within the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves a list of instance templates that are contained within the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceTemplateList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/instanceTemplates";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetIamPolicyRequest SetIamPolicy(Google.Apis.Compute.v1.Data.GlobalSetPolicyRequest body, string project, string resource)
        {
            return new SetIamPolicyRequest(service, body, project, resource);
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        public class SetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new SetIamPolicy request.</summary>
            public SetIamPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.GlobalSetPolicyRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.GlobalSetPolicyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/instanceTemplates/{resource}/setIamPolicy";

            /// <summary>Initializes SetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/instanceTemplates/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "instances" collection of methods.</summary>
    public class InstancesResource
    {
        private const string Resource = "instances";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public InstancesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Adds an access config to an instance's network interface.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">The instance name for this request.</param>
        /// <param name="networkInterface">The name of the network interface to add to this instance.</param>
        public virtual AddAccessConfigRequest AddAccessConfig(Google.Apis.Compute.v1.Data.AccessConfig body, string project, string zone, string instance, string networkInterface)
        {
            return new AddAccessConfigRequest(service, body, project, zone, instance, networkInterface);
        }

        /// <summary>Adds an access config to an instance's network interface.</summary>
        public class AddAccessConfigRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddAccessConfig request.</summary>
            public AddAccessConfigRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.AccessConfig body, string project, string zone, string instance, string networkInterface) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                NetworkInterface = networkInterface;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The instance name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>The name of the network interface to add to this instance.</summary>
            [Google.Apis.Util.RequestParameterAttribute("networkInterface", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string NetworkInterface { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.AccessConfig Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addAccessConfig";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/addAccessConfig";

            /// <summary>Initializes AddAccessConfig parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("networkInterface", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkInterface",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Adds existing resource policies to an instance. You can only add one policy right now which will be applied
        /// to this instance for scheduling live migrations.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">The instance name for this request.</param>
        public virtual AddResourcePoliciesRequest AddResourcePolicies(Google.Apis.Compute.v1.Data.InstancesAddResourcePoliciesRequest body, string project, string zone, string instance)
        {
            return new AddResourcePoliciesRequest(service, body, project, zone, instance);
        }

        /// <summary>
        /// Adds existing resource policies to an instance. You can only add one policy right now which will be applied
        /// to this instance for scheduling live migrations.
        /// </summary>
        public class AddResourcePoliciesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddResourcePolicies request.</summary>
            public AddResourcePoliciesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstancesAddResourcePoliciesRequest body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The instance name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstancesAddResourcePoliciesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addResourcePolicies";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/addResourcePolicies";

            /// <summary>Initializes AddResourcePolicies parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves aggregated list of all of the instances in your project across all regions and zones.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>
        /// Retrieves aggregated list of all of the instances in your project across all regions and zones.
        /// </summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/instances";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Attaches an existing Disk resource to an instance. You must first create the disk before you can attach it.
        /// It is not possible to create and attach a disk at the same time. For more information, read Adding a
        /// persistent disk to your instance.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">The instance name for this request.</param>
        public virtual AttachDiskRequest AttachDisk(Google.Apis.Compute.v1.Data.AttachedDisk body, string project, string zone, string instance)
        {
            return new AttachDiskRequest(service, body, project, zone, instance);
        }

        /// <summary>
        /// Attaches an existing Disk resource to an instance. You must first create the disk before you can attach it.
        /// It is not possible to create and attach a disk at the same time. For more information, read Adding a
        /// persistent disk to your instance.
        /// </summary>
        public class AttachDiskRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AttachDisk request.</summary>
            public AttachDiskRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.AttachedDisk body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The instance name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// Whether to force attach the regional disk even if it's currently attached to another instance. If you
            /// try to force attach a zonal disk to an instance, you will receive an error.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("forceAttach", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ForceAttach { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.AttachedDisk Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "attachDisk";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/attachDisk";

            /// <summary>Initializes AttachDisk parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("forceAttach", new Google.Apis.Discovery.Parameter
                {
                    Name = "forceAttach",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Creates multiple instances. Count specifies the number of instances to create.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        public virtual BulkInsertRequest BulkInsert(Google.Apis.Compute.v1.Data.BulkInsertInstanceResource body, string project, string zone)
        {
            return new BulkInsertRequest(service, body, project, zone);
        }

        /// <summary>Creates multiple instances. Count specifies the number of instances to create.</summary>
        public class BulkInsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new BulkInsert request.</summary>
            public BulkInsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.BulkInsertInstanceResource body, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.BulkInsertInstanceResource Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "bulkInsert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/bulkInsert";

            /// <summary>Initializes BulkInsert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Deletes the specified Instance resource. For more information, see Stopping or Deleting an Instance.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string zone, string instance)
        {
            return new DeleteRequest(service, project, zone, instance);
        }

        /// <summary>
        /// Deletes the specified Instance resource. For more information, see Stopping or Deleting an Instance.
        /// </summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes an access config from an instance's network interface.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">The instance name for this request.</param>
        /// <param name="accessConfig">The name of the access config to delete.</param>
        /// <param name="networkInterface">The name of the network interface.</param>
        public virtual DeleteAccessConfigRequest DeleteAccessConfig(string project, string zone, string instance, string accessConfig, string networkInterface)
        {
            return new DeleteAccessConfigRequest(service, project, zone, instance, accessConfig, networkInterface);
        }

        /// <summary>Deletes an access config from an instance's network interface.</summary>
        public class DeleteAccessConfigRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new DeleteAccessConfig request.</summary>
            public DeleteAccessConfigRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance, string accessConfig, string networkInterface) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                AccessConfig = accessConfig;
                NetworkInterface = networkInterface;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The instance name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>The name of the access config to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("accessConfig", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string AccessConfig { get; private set; }

            /// <summary>The name of the network interface.</summary>
            [Google.Apis.Util.RequestParameterAttribute("networkInterface", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string NetworkInterface { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "deleteAccessConfig";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/deleteAccessConfig";

            /// <summary>Initializes DeleteAccessConfig parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("accessConfig", new Google.Apis.Discovery.Parameter
                {
                    Name = "accessConfig",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("networkInterface", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkInterface",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Detaches a disk from an instance.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Instance name for this request.</param>
        /// <param name="deviceName">
        /// The device name of the disk to detach. Make a get() request on the instance to view currently attached disks
        /// and device names.
        /// </param>
        public virtual DetachDiskRequest DetachDisk(string project, string zone, string instance, string deviceName)
        {
            return new DetachDiskRequest(service, project, zone, instance, deviceName);
        }

        /// <summary>Detaches a disk from an instance.</summary>
        public class DetachDiskRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new DetachDisk request.</summary>
            public DetachDiskRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance, string deviceName) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                DeviceName = deviceName;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Instance name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// The device name of the disk to detach. Make a get() request on the instance to view currently attached
            /// disks and device names.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("deviceName", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string DeviceName { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "detachDisk";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/detachDisk";

            /// <summary>Initializes DetachDisk parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("deviceName", new Google.Apis.Discovery.Parameter
                {
                    Name = "deviceName",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified Instance resource. Gets a list of available instances by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance resource to return.</param>
        public virtual GetRequest Get(string project, string zone, string instance)
        {
            return new GetRequest(service, project, zone, instance);
        }

        /// <summary>
        /// Returns the specified Instance resource. Gets a list of available instances by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Instance>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Returns effective firewalls applied to an interface of the instance.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance scoping this request.</param>
        /// <param name="networkInterface">The name of the network interface to get the effective firewalls.</param>
        public virtual GetEffectiveFirewallsRequest GetEffectiveFirewalls(string project, string zone, string instance, string networkInterface)
        {
            return new GetEffectiveFirewallsRequest(service, project, zone, instance, networkInterface);
        }

        /// <summary>Returns effective firewalls applied to an interface of the instance.</summary>
        public class GetEffectiveFirewallsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstancesGetEffectiveFirewallsResponse>
        {
            /// <summary>Constructs a new GetEffectiveFirewalls request.</summary>
            public GetEffectiveFirewallsRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance, string networkInterface) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                NetworkInterface = networkInterface;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>The name of the network interface to get the effective firewalls.</summary>
            [Google.Apis.Util.RequestParameterAttribute("networkInterface", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string NetworkInterface { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getEffectiveFirewalls";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/getEffectiveFirewalls";

            /// <summary>Initializes GetEffectiveFirewalls parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("networkInterface", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkInterface",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified guest attributes entry.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance scoping this request.</param>
        public virtual GetGuestAttributesRequest GetGuestAttributes(string project, string zone, string instance)
        {
            return new GetGuestAttributesRequest(service, project, zone, instance);
        }

        /// <summary>Returns the specified guest attributes entry.</summary>
        public class GetGuestAttributesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.GuestAttributes>
        {
            /// <summary>Constructs a new GetGuestAttributes request.</summary>
            public GetGuestAttributesRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>Specifies the guest attributes path to be queried.</summary>
            [Google.Apis.Util.RequestParameterAttribute("queryPath", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string QueryPath { get; set; }

            /// <summary>Specifies the key for the guest attributes entry.</summary>
            [Google.Apis.Util.RequestParameterAttribute("variableKey", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string VariableKey { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getGuestAttributes";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/getGuestAttributes";

            /// <summary>Initializes GetGuestAttributes parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("queryPath", new Google.Apis.Discovery.Parameter
                {
                    Name = "queryPath",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("variableKey", new Google.Apis.Discovery.Parameter
                {
                    Name = "variableKey",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual GetIamPolicyRequest GetIamPolicy(string project, string zone, string resource)
        {
            return new GetIamPolicyRequest(service, project, zone, resource);
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        public class GetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new GetIamPolicy request.</summary>
            public GetIamPolicyRequest(Google.Apis.Services.IClientService service, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Requested IAM Policy version.</summary>
            [Google.Apis.Util.RequestParameterAttribute("optionsRequestedPolicyVersion", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> OptionsRequestedPolicyVersion { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{resource}/getIamPolicy";

            /// <summary>Initializes GetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("optionsRequestedPolicyVersion", new Google.Apis.Discovery.Parameter
                {
                    Name = "optionsRequestedPolicyVersion",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the screenshot from the specified instance.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance scoping this request.</param>
        public virtual GetScreenshotRequest GetScreenshot(string project, string zone, string instance)
        {
            return new GetScreenshotRequest(service, project, zone, instance);
        }

        /// <summary>Returns the screenshot from the specified instance.</summary>
        public class GetScreenshotRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Screenshot>
        {
            /// <summary>Constructs a new GetScreenshot request.</summary>
            public GetScreenshotRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getScreenshot";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/screenshot";

            /// <summary>Initializes GetScreenshot parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Returns the last 1 MB of serial port output from the specified instance.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance for this request.</param>
        public virtual GetSerialPortOutputRequest GetSerialPortOutput(string project, string zone, string instance)
        {
            return new GetSerialPortOutputRequest(service, project, zone, instance);
        }

        /// <summary>Returns the last 1 MB of serial port output from the specified instance.</summary>
        public class GetSerialPortOutputRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SerialPortOutput>
        {
            /// <summary>Constructs a new GetSerialPortOutput request.</summary>
            public GetSerialPortOutputRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>Specifies which COM or serial port to retrieve data from.</summary>
            [Google.Apis.Util.RequestParameterAttribute("port", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> Port { get; set; }

            /// <summary>
            /// Specifies the starting byte position of the output to return. To start with the first byte of output to
            /// the specified port, omit this field or set it to `0`.  If the output for that byte position is
            /// available, this field matches the `start` parameter sent with the request. If the amount of serial
            /// console output exceeds the size of the buffer (1 MB), the oldest output is discarded and is no longer
            /// available. If the requested start position refers to discarded output, the start position is adjusted to
            /// the oldest output still available, and the adjusted start position is returned as the `start` property
            /// value.  You can also provide a negative start position, which translates to the most recent number of
            /// bytes written to the serial port. For example, -3 is interpreted as the most recent 3 bytes written to
            /// the serial console.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("start", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> Start { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getSerialPortOutput";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/serialPort";

            /// <summary>Initializes GetSerialPortOutput parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("port", new Google.Apis.Discovery.Parameter
                {
                    Name = "port",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "1",
                    Pattern = null,
                });
                RequestParameters.Add("start", new Google.Apis.Discovery.Parameter
                {
                    Name = "start",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the Shielded Instance Identity of an instance</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name or id of the instance scoping this request.</param>
        public virtual GetShieldedInstanceIdentityRequest GetShieldedInstanceIdentity(string project, string zone, string instance)
        {
            return new GetShieldedInstanceIdentityRequest(service, project, zone, instance);
        }

        /// <summary>Returns the Shielded Instance Identity of an instance</summary>
        public class GetShieldedInstanceIdentityRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ShieldedInstanceIdentity>
        {
            /// <summary>Constructs a new GetShieldedInstanceIdentity request.</summary>
            public GetShieldedInstanceIdentityRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getShieldedInstanceIdentity";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/getShieldedInstanceIdentity";

            /// <summary>Initializes GetShieldedInstanceIdentity parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates an instance resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Instance body, string project, string zone)
        {
            return new InsertRequest(service, body, project, zone);
        }

        /// <summary>
        /// Creates an instance resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Instance body, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>
            /// Specifies instance template to create the instance.  This field is optional. It can be a full or partial
            /// URL. For example, the following are all valid URLs to an instance template:   -
            /// https://www.googleapis.com/compute/v1/projects/project/global/instanceTemplates/instanceTemplate  -
            /// projects/project/global/instanceTemplates/instanceTemplate  - global/instanceTemplates/instanceTemplate
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("sourceInstanceTemplate", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string SourceInstanceTemplate { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Instance Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("sourceInstanceTemplate", new Google.Apis.Discovery.Parameter
                {
                    Name = "sourceInstanceTemplate",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of instances contained within the specified zone.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>Retrieves the list of instances contained within the specified zone.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves a list of resources that refer to the VM instance specified in the request. For example, if the VM
        /// instance is part of a managed or unmanaged instance group, the referrers list includes the instance group.
        /// For more information, read Viewing referrers to VM instances.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">
        /// Name of the target instance scoping this request, or '-' if the request should span over all instances in
        /// the container.
        /// </param>
        public virtual ListReferrersRequest ListReferrers(string project, string zone, string instance)
        {
            return new ListReferrersRequest(service, project, zone, instance);
        }

        /// <summary>
        /// Retrieves a list of resources that refer to the VM instance specified in the request. For example, if the VM
        /// instance is part of a managed or unmanaged instance group, the referrers list includes the instance group.
        /// For more information, read Viewing referrers to VM instances.
        /// </summary>
        public class ListReferrersRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceListReferrers>
        {
            /// <summary>Constructs a new ListReferrers request.</summary>
            public ListReferrersRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// Name of the target instance scoping this request, or '-' if the request should span over all instances
            /// in the container.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listReferrers";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/referrers";

            /// <summary>Initializes ListReferrers parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"-|[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Removes resource policies from an instance.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">The instance name for this request.</param>
        public virtual RemoveResourcePoliciesRequest RemoveResourcePolicies(Google.Apis.Compute.v1.Data.InstancesRemoveResourcePoliciesRequest body, string project, string zone, string instance)
        {
            return new RemoveResourcePoliciesRequest(service, body, project, zone, instance);
        }

        /// <summary>Removes resource policies from an instance.</summary>
        public class RemoveResourcePoliciesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new RemoveResourcePolicies request.</summary>
            public RemoveResourcePoliciesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstancesRemoveResourcePoliciesRequest body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The instance name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstancesRemoveResourcePoliciesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "removeResourcePolicies";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/removeResourcePolicies";

            /// <summary>Initializes RemoveResourcePolicies parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Performs a reset on the instance. This is a hard reset the VM does not do a graceful shutdown. For more
        /// information, see Resetting an instance.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance scoping this request.</param>
        public virtual ResetRequest Reset(string project, string zone, string instance)
        {
            return new ResetRequest(service, project, zone, instance);
        }

        /// <summary>
        /// Performs a reset on the instance. This is a hard reset the VM does not do a graceful shutdown. For more
        /// information, see Resetting an instance.
        /// </summary>
        public class ResetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Reset request.</summary>
            public ResetRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "reset";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/reset";

            /// <summary>Initializes Reset parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets deletion protection on the instance.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetDeletionProtectionRequest SetDeletionProtection(string project, string zone, string resource)
        {
            return new SetDeletionProtectionRequest(service, project, zone, resource);
        }

        /// <summary>Sets deletion protection on the instance.</summary>
        public class SetDeletionProtectionRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetDeletionProtection request.</summary>
            public SetDeletionProtectionRequest(Google.Apis.Services.IClientService service, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Whether the resource should be protected against deletion.</summary>
            [Google.Apis.Util.RequestParameterAttribute("deletionProtection", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> DeletionProtection { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setDeletionProtection";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{resource}/setDeletionProtection";

            /// <summary>Initializes SetDeletionProtection parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("deletionProtection", new Google.Apis.Discovery.Parameter
                {
                    Name = "deletionProtection",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "true",
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the auto-delete flag for a disk attached to an instance.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">The instance name for this request.</param>
        /// <param name="autoDelete">Whether to auto-delete the disk when the instance is deleted.</param>
        /// <param name="deviceName">
        /// The device name of the disk to modify. Make a get() request on the instance to view currently attached disks
        /// and device names.
        /// </param>
        public virtual SetDiskAutoDeleteRequest SetDiskAutoDelete(string project, string zone, string instance, bool autoDelete, string deviceName)
        {
            return new SetDiskAutoDeleteRequest(service, project, zone, instance, autoDelete, deviceName);
        }

        /// <summary>Sets the auto-delete flag for a disk attached to an instance.</summary>
        public class SetDiskAutoDeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetDiskAutoDelete request.</summary>
            public SetDiskAutoDeleteRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance, bool autoDelete, string deviceName) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                AutoDelete = autoDelete;
                DeviceName = deviceName;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The instance name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>Whether to auto-delete the disk when the instance is deleted.</summary>
            [Google.Apis.Util.RequestParameterAttribute("autoDelete", Google.Apis.Util.RequestParameterType.Query)]
            public virtual bool AutoDelete { get; private set; }

            /// <summary>
            /// The device name of the disk to modify. Make a get() request on the instance to view currently attached
            /// disks and device names.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("deviceName", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string DeviceName { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setDiskAutoDelete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/setDiskAutoDelete";

            /// <summary>Initializes SetDiskAutoDelete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("autoDelete", new Google.Apis.Discovery.Parameter
                {
                    Name = "autoDelete",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("deviceName", new Google.Apis.Discovery.Parameter
                {
                    Name = "deviceName",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = @"\w[\w.-]{0,254}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetIamPolicyRequest SetIamPolicy(Google.Apis.Compute.v1.Data.ZoneSetPolicyRequest body, string project, string zone, string resource)
        {
            return new SetIamPolicyRequest(service, body, project, zone, resource);
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        public class SetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new SetIamPolicy request.</summary>
            public SetIamPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ZoneSetPolicyRequest body, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ZoneSetPolicyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{resource}/setIamPolicy";

            /// <summary>Initializes SetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Sets labels on an instance. To learn more about labels, read the Labeling Resources documentation.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance scoping this request.</param>
        public virtual SetLabelsRequest SetLabels(Google.Apis.Compute.v1.Data.InstancesSetLabelsRequest body, string project, string zone, string instance)
        {
            return new SetLabelsRequest(service, body, project, zone, instance);
        }

        /// <summary>
        /// Sets labels on an instance. To learn more about labels, read the Labeling Resources documentation.
        /// </summary>
        public class SetLabelsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetLabels request.</summary>
            public SetLabelsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstancesSetLabelsRequest body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstancesSetLabelsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setLabels";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/setLabels";

            /// <summary>Initializes SetLabels parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Changes the number and/or type of accelerator for a stopped instance to the values specified in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance scoping this request.</param>
        public virtual SetMachineResourcesRequest SetMachineResources(Google.Apis.Compute.v1.Data.InstancesSetMachineResourcesRequest body, string project, string zone, string instance)
        {
            return new SetMachineResourcesRequest(service, body, project, zone, instance);
        }

        /// <summary>
        /// Changes the number and/or type of accelerator for a stopped instance to the values specified in the request.
        /// </summary>
        public class SetMachineResourcesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetMachineResources request.</summary>
            public SetMachineResourcesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstancesSetMachineResourcesRequest body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstancesSetMachineResourcesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setMachineResources";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/setMachineResources";

            /// <summary>Initializes SetMachineResources parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Changes the machine type for a stopped instance to the machine type specified in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance scoping this request.</param>
        public virtual SetMachineTypeRequest SetMachineType(Google.Apis.Compute.v1.Data.InstancesSetMachineTypeRequest body, string project, string zone, string instance)
        {
            return new SetMachineTypeRequest(service, body, project, zone, instance);
        }

        /// <summary>
        /// Changes the machine type for a stopped instance to the machine type specified in the request.
        /// </summary>
        public class SetMachineTypeRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetMachineType request.</summary>
            public SetMachineTypeRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstancesSetMachineTypeRequest body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstancesSetMachineTypeRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setMachineType";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/setMachineType";

            /// <summary>Initializes SetMachineType parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets metadata for the specified instance to the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance scoping this request.</param>
        public virtual SetMetadataRequest SetMetadata(Google.Apis.Compute.v1.Data.Metadata body, string project, string zone, string instance)
        {
            return new SetMetadataRequest(service, body, project, zone, instance);
        }

        /// <summary>Sets metadata for the specified instance to the data included in the request.</summary>
        public class SetMetadataRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetMetadata request.</summary>
            public SetMetadataRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Metadata body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Metadata Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setMetadata";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/setMetadata";

            /// <summary>Initializes SetMetadata parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Changes the minimum CPU platform that this instance should use. This method can only be called on a stopped
        /// instance. For more information, read Specifying a Minimum CPU Platform.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance scoping this request.</param>
        public virtual SetMinCpuPlatformRequest SetMinCpuPlatform(Google.Apis.Compute.v1.Data.InstancesSetMinCpuPlatformRequest body, string project, string zone, string instance)
        {
            return new SetMinCpuPlatformRequest(service, body, project, zone, instance);
        }

        /// <summary>
        /// Changes the minimum CPU platform that this instance should use. This method can only be called on a stopped
        /// instance. For more information, read Specifying a Minimum CPU Platform.
        /// </summary>
        public class SetMinCpuPlatformRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetMinCpuPlatform request.</summary>
            public SetMinCpuPlatformRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstancesSetMinCpuPlatformRequest body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstancesSetMinCpuPlatformRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setMinCpuPlatform";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/setMinCpuPlatform";

            /// <summary>Initializes SetMinCpuPlatform parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets an instance's scheduling options. You can only call this method on a stopped instance, that is, a VM
        /// instance that is in a `TERMINATED` state. See Instance Life Cycle for more information on the possible
        /// instance states.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Instance name for this request.</param>
        public virtual SetSchedulingRequest SetScheduling(Google.Apis.Compute.v1.Data.Scheduling body, string project, string zone, string instance)
        {
            return new SetSchedulingRequest(service, body, project, zone, instance);
        }

        /// <summary>
        /// Sets an instance's scheduling options. You can only call this method on a stopped instance, that is, a VM
        /// instance that is in a `TERMINATED` state. See Instance Life Cycle for more information on the possible
        /// instance states.
        /// </summary>
        public class SetSchedulingRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetScheduling request.</summary>
            public SetSchedulingRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Scheduling body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Instance name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Scheduling Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setScheduling";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/setScheduling";

            /// <summary>Initializes SetScheduling parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets the service account on the instance. For more information, read Changing the service account and access
        /// scopes for an instance.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance resource to start.</param>
        public virtual SetServiceAccountRequest SetServiceAccount(Google.Apis.Compute.v1.Data.InstancesSetServiceAccountRequest body, string project, string zone, string instance)
        {
            return new SetServiceAccountRequest(service, body, project, zone, instance);
        }

        /// <summary>
        /// Sets the service account on the instance. For more information, read Changing the service account and access
        /// scopes for an instance.
        /// </summary>
        public class SetServiceAccountRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetServiceAccount request.</summary>
            public SetServiceAccountRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstancesSetServiceAccountRequest body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance resource to start.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstancesSetServiceAccountRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setServiceAccount";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/setServiceAccount";

            /// <summary>Initializes SetServiceAccount parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets the Shielded Instance integrity policy for an instance. You can only use this method on a running
        /// instance. This method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name or id of the instance scoping this request.</param>
        public virtual SetShieldedInstanceIntegrityPolicyRequest SetShieldedInstanceIntegrityPolicy(Google.Apis.Compute.v1.Data.ShieldedInstanceIntegrityPolicy body, string project, string zone, string instance)
        {
            return new SetShieldedInstanceIntegrityPolicyRequest(service, body, project, zone, instance);
        }

        /// <summary>
        /// Sets the Shielded Instance integrity policy for an instance. You can only use this method on a running
        /// instance. This method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class SetShieldedInstanceIntegrityPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetShieldedInstanceIntegrityPolicy request.</summary>
            public SetShieldedInstanceIntegrityPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ShieldedInstanceIntegrityPolicy body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ShieldedInstanceIntegrityPolicy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setShieldedInstanceIntegrityPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/setShieldedInstanceIntegrityPolicy";

            /// <summary>Initializes SetShieldedInstanceIntegrityPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets network tags for the specified instance to the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance scoping this request.</param>
        public virtual SetTagsRequest SetTags(Google.Apis.Compute.v1.Data.Tags body, string project, string zone, string instance)
        {
            return new SetTagsRequest(service, body, project, zone, instance);
        }

        /// <summary>Sets network tags for the specified instance to the data included in the request.</summary>
        public class SetTagsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetTags request.</summary>
            public SetTagsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Tags body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Tags Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setTags";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/setTags";

            /// <summary>Initializes SetTags parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Simulates a maintenance event on the instance.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance scoping this request.</param>
        public virtual SimulateMaintenanceEventRequest SimulateMaintenanceEvent(string project, string zone, string instance)
        {
            return new SimulateMaintenanceEventRequest(service, project, zone, instance);
        }

        /// <summary>Simulates a maintenance event on the instance.</summary>
        public class SimulateMaintenanceEventRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SimulateMaintenanceEvent request.</summary>
            public SimulateMaintenanceEventRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "simulateMaintenanceEvent";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/simulateMaintenanceEvent";

            /// <summary>Initializes SimulateMaintenanceEvent parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Starts an instance that was stopped using the instances().stop method. For more information, see Restart an
        /// instance.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance resource to start.</param>
        public virtual StartRequest Start(string project, string zone, string instance)
        {
            return new StartRequest(service, project, zone, instance);
        }

        /// <summary>
        /// Starts an instance that was stopped using the instances().stop method. For more information, see Restart an
        /// instance.
        /// </summary>
        public class StartRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Start request.</summary>
            public StartRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance resource to start.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "start";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/start";

            /// <summary>Initializes Start parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Starts an instance that was stopped using the instances().stop method. For more information, see Restart an
        /// instance.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance resource to start.</param>
        public virtual StartWithEncryptionKeyRequest StartWithEncryptionKey(Google.Apis.Compute.v1.Data.InstancesStartWithEncryptionKeyRequest body, string project, string zone, string instance)
        {
            return new StartWithEncryptionKeyRequest(service, body, project, zone, instance);
        }

        /// <summary>
        /// Starts an instance that was stopped using the instances().stop method. For more information, see Restart an
        /// instance.
        /// </summary>
        public class StartWithEncryptionKeyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new StartWithEncryptionKey request.</summary>
            public StartWithEncryptionKeyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstancesStartWithEncryptionKeyRequest body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance resource to start.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstancesStartWithEncryptionKeyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "startWithEncryptionKey";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/startWithEncryptionKey";

            /// <summary>Initializes StartWithEncryptionKey parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Stops a running instance, shutting it down cleanly, and allows you to restart the instance at a later time.
        /// Stopped instances do not incur VM usage charges while they are stopped. However, resources that the VM is
        /// using, such as persistent disks and static IP addresses, will continue to be charged until they are deleted.
        /// For more information, see Stopping an instance.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance resource to stop.</param>
        public virtual StopRequest Stop(string project, string zone, string instance)
        {
            return new StopRequest(service, project, zone, instance);
        }

        /// <summary>
        /// Stops a running instance, shutting it down cleanly, and allows you to restart the instance at a later time.
        /// Stopped instances do not incur VM usage charges while they are stopped. However, resources that the VM is
        /// using, such as persistent disks and static IP addresses, will continue to be charged until they are deleted.
        /// For more information, see Stopping an instance.
        /// </summary>
        public class StopRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Stop request.</summary>
            public StopRequest(Google.Apis.Services.IClientService service, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance resource to stop.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "stop";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/stop";

            /// <summary>Initializes Stop parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string zone, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, zone, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Updates an instance only if the necessary resources are available. This method can update only a specific
        /// set of instance properties. See  Updating a running instance for a list of updatable instance properties.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance resource to update.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.Instance body, string project, string zone, string instance)
        {
            return new UpdateRequest(service, body, project, zone, instance);
        }

        /// <summary>
        /// Updates an instance only if the necessary resources are available. This method can update only a specific
        /// set of instance properties. See  Updating a running instance for a list of updatable instance properties.
        /// </summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Instance body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// Specifies the action to take when updating an instance even if the updated properties do not require it.
            /// If not specified, then Compute Engine acts based on the minimum action that the updated properties
            /// require.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("minimalAction", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<MinimalActionEnum> MinimalAction { get; set; }

            /// <summary>
            /// Specifies the action to take when updating an instance even if the updated properties do not require it.
            /// If not specified, then Compute Engine acts based on the minimum action that the updated properties
            /// require.
            /// </summary>
            public enum MinimalActionEnum
            {
                /// <summary></summary>
                [Google.Apis.Util.StringValueAttribute("INVALID")]
                INVALID,

                /// <summary></summary>
                [Google.Apis.Util.StringValueAttribute("NO_EFFECT")]
                NOEFFECT,

                /// <summary></summary>
                [Google.Apis.Util.StringValueAttribute("REFRESH")]
                REFRESH,

                /// <summary></summary>
                [Google.Apis.Util.StringValueAttribute("RESTART")]
                RESTART,
            }

            /// <summary>
            /// Specifies the most disruptive action that can be taken on the instance as part of the update. Compute
            /// Engine returns an error if the instance properties require a more disruptive action as part of the
            /// instance update. Valid options from lowest to highest are NO_EFFECT, REFRESH, and RESTART.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("mostDisruptiveAllowedAction", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<MostDisruptiveAllowedActionEnum> MostDisruptiveAllowedAction { get; set; }

            /// <summary>
            /// Specifies the most disruptive action that can be taken on the instance as part of the update. Compute
            /// Engine returns an error if the instance properties require a more disruptive action as part of the
            /// instance update. Valid options from lowest to highest are NO_EFFECT, REFRESH, and RESTART.
            /// </summary>
            public enum MostDisruptiveAllowedActionEnum
            {
                /// <summary></summary>
                [Google.Apis.Util.StringValueAttribute("INVALID")]
                INVALID,

                /// <summary></summary>
                [Google.Apis.Util.StringValueAttribute("NO_EFFECT")]
                NOEFFECT,

                /// <summary></summary>
                [Google.Apis.Util.StringValueAttribute("REFRESH")]
                REFRESH,

                /// <summary></summary>
                [Google.Apis.Util.StringValueAttribute("RESTART")]
                RESTART,
            }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Instance Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("minimalAction", new Google.Apis.Discovery.Parameter
                {
                    Name = "minimalAction",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("mostDisruptiveAllowedAction", new Google.Apis.Discovery.Parameter
                {
                    Name = "mostDisruptiveAllowedAction",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the specified access config from an instance's network interface with the data included in the
        /// request. This method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">The instance name for this request.</param>
        /// <param name="networkInterface">
        /// The name of the network interface where the access config is attached.
        /// </param>
        public virtual UpdateAccessConfigRequest UpdateAccessConfig(Google.Apis.Compute.v1.Data.AccessConfig body, string project, string zone, string instance, string networkInterface)
        {
            return new UpdateAccessConfigRequest(service, body, project, zone, instance, networkInterface);
        }

        /// <summary>
        /// Updates the specified access config from an instance's network interface with the data included in the
        /// request. This method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class UpdateAccessConfigRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new UpdateAccessConfig request.</summary>
            public UpdateAccessConfigRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.AccessConfig body, string project, string zone, string instance, string networkInterface) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                NetworkInterface = networkInterface;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The instance name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>The name of the network interface where the access config is attached.</summary>
            [Google.Apis.Util.RequestParameterAttribute("networkInterface", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string NetworkInterface { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.AccessConfig Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "updateAccessConfig";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/updateAccessConfig";

            /// <summary>Initializes UpdateAccessConfig parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("networkInterface", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkInterface",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the Display config for a VM instance. You can only use this method on a stopped VM instance. This
        /// method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name of the instance scoping this request.</param>
        public virtual UpdateDisplayDeviceRequest UpdateDisplayDevice(Google.Apis.Compute.v1.Data.DisplayDevice body, string project, string zone, string instance)
        {
            return new UpdateDisplayDeviceRequest(service, body, project, zone, instance);
        }

        /// <summary>
        /// Updates the Display config for a VM instance. You can only use this method on a stopped VM instance. This
        /// method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class UpdateDisplayDeviceRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new UpdateDisplayDevice request.</summary>
            public UpdateDisplayDeviceRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.DisplayDevice body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.DisplayDevice Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "updateDisplayDevice";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/updateDisplayDevice";

            /// <summary>Initializes UpdateDisplayDevice parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates an instance's network interface. This method can only update an interface's alias IP range and
        /// attached network. See Modifying alias IP ranges for an existing instance for instructions on changing alias
        /// IP ranges. See Migrating a VM between networks for instructions on migrating an interface. This method
        /// follows PATCH semantics.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">The instance name for this request.</param>
        /// <param name="networkInterface">The name of the network interface to update.</param>
        public virtual UpdateNetworkInterfaceRequest UpdateNetworkInterface(Google.Apis.Compute.v1.Data.NetworkInterface body, string project, string zone, string instance, string networkInterface)
        {
            return new UpdateNetworkInterfaceRequest(service, body, project, zone, instance, networkInterface);
        }

        /// <summary>
        /// Updates an instance's network interface. This method can only update an interface's alias IP range and
        /// attached network. See Modifying alias IP ranges for an existing instance for instructions on changing alias
        /// IP ranges. See Migrating a VM between networks for instructions on migrating an interface. This method
        /// follows PATCH semantics.
        /// </summary>
        public class UpdateNetworkInterfaceRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new UpdateNetworkInterface request.</summary>
            public UpdateNetworkInterfaceRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NetworkInterface body, string project, string zone, string instance, string networkInterface) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                NetworkInterface = networkInterface;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The instance name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>The name of the network interface to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("networkInterface", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string NetworkInterface { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NetworkInterface Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "updateNetworkInterface";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/updateNetworkInterface";

            /// <summary>Initializes UpdateNetworkInterface parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("networkInterface", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkInterface",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the Shielded Instance config for an instance. You can only use this method on a stopped instance.
        /// This method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="instance">Name or id of the instance scoping this request.</param>
        public virtual UpdateShieldedInstanceConfigRequest UpdateShieldedInstanceConfig(Google.Apis.Compute.v1.Data.ShieldedInstanceConfig body, string project, string zone, string instance)
        {
            return new UpdateShieldedInstanceConfigRequest(service, body, project, zone, instance);
        }

        /// <summary>
        /// Updates the Shielded Instance config for an instance. You can only use this method on a stopped instance.
        /// This method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class UpdateShieldedInstanceConfigRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new UpdateShieldedInstanceConfig request.</summary>
            public UpdateShieldedInstanceConfigRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ShieldedInstanceConfig body, string project, string zone, string instance) : base(service)
            {
                Project = project;
                Zone = zone;
                Instance = instance;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the instance scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Instance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ShieldedInstanceConfig Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "updateShieldedInstanceConfig";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/instances/{instance}/updateShieldedInstanceConfig";

            /// <summary>Initializes UpdateShieldedInstanceConfig parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("instance", new Google.Apis.Discovery.Parameter
                {
                    Name = "instance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "interconnectAttachments" collection of methods.</summary>
    public class InterconnectAttachmentsResource
    {
        private const string Resource = "interconnectAttachments";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public InterconnectAttachmentsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of interconnect attachments.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of interconnect attachments.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InterconnectAttachmentAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/interconnectAttachments";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified interconnect attachment.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="interconnectAttachment">Name of the interconnect attachment to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string interconnectAttachment)
        {
            return new DeleteRequest(service, project, region, interconnectAttachment);
        }

        /// <summary>Deletes the specified interconnect attachment.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string interconnectAttachment) : base(service)
            {
                Project = project;
                Region = region;
                InterconnectAttachment = interconnectAttachment;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the interconnect attachment to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("interconnectAttachment", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InterconnectAttachment { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/interconnectAttachments/{interconnectAttachment}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("interconnectAttachment", new Google.Apis.Discovery.Parameter
                {
                    Name = "interconnectAttachment",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified interconnect attachment.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="interconnectAttachment">Name of the interconnect attachment to return.</param>
        public virtual GetRequest Get(string project, string region, string interconnectAttachment)
        {
            return new GetRequest(service, project, region, interconnectAttachment);
        }

        /// <summary>Returns the specified interconnect attachment.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InterconnectAttachment>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string interconnectAttachment) : base(service)
            {
                Project = project;
                Region = region;
                InterconnectAttachment = interconnectAttachment;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the interconnect attachment to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("interconnectAttachment", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InterconnectAttachment { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/interconnectAttachments/{interconnectAttachment}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("interconnectAttachment", new Google.Apis.Discovery.Parameter
                {
                    Name = "interconnectAttachment",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates an InterconnectAttachment in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.InterconnectAttachment body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates an InterconnectAttachment in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InterconnectAttachment body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>If true, the request will not be committed.</summary>
            [Google.Apis.Util.RequestParameterAttribute("validateOnly", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ValidateOnly { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InterconnectAttachment Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/interconnectAttachments";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("validateOnly", new Google.Apis.Discovery.Parameter
                {
                    Name = "validateOnly",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of interconnect attachments contained within the specified region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves the list of interconnect attachments contained within the specified region.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InterconnectAttachmentList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/interconnectAttachments";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the specified interconnect attachment with the data included in the request. This method supports
        /// PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="interconnectAttachment">Name of the interconnect attachment to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.InterconnectAttachment body, string project, string region, string interconnectAttachment)
        {
            return new PatchRequest(service, body, project, region, interconnectAttachment);
        }

        /// <summary>
        /// Updates the specified interconnect attachment with the data included in the request. This method supports
        /// PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InterconnectAttachment body, string project, string region, string interconnectAttachment) : base(service)
            {
                Project = project;
                Region = region;
                InterconnectAttachment = interconnectAttachment;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the interconnect attachment to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("interconnectAttachment", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InterconnectAttachment { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InterconnectAttachment Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/interconnectAttachments/{interconnectAttachment}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("interconnectAttachment", new Google.Apis.Discovery.Parameter
                {
                    Name = "interconnectAttachment",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "interconnectLocations" collection of methods.</summary>
    public class InterconnectLocationsResource
    {
        private const string Resource = "interconnectLocations";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public InterconnectLocationsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Returns the details for the specified interconnect location. Gets a list of available interconnect locations
        /// by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="interconnectLocation">Name of the interconnect location to return.</param>
        public virtual GetRequest Get(string project, string interconnectLocation)
        {
            return new GetRequest(service, project, interconnectLocation);
        }

        /// <summary>
        /// Returns the details for the specified interconnect location. Gets a list of available interconnect locations
        /// by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InterconnectLocation>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string interconnectLocation) : base(service)
            {
                Project = project;
                InterconnectLocation = interconnectLocation;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the interconnect location to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("interconnectLocation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InterconnectLocation { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/interconnectLocations/{interconnectLocation}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("interconnectLocation", new Google.Apis.Discovery.Parameter
                {
                    Name = "interconnectLocation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves the list of interconnect locations available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of interconnect locations available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InterconnectLocationList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/interconnectLocations";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "interconnects" collection of methods.</summary>
    public class InterconnectsResource
    {
        private const string Resource = "interconnects";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public InterconnectsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified interconnect.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="interconnect">Name of the interconnect to delete.</param>
        public virtual DeleteRequest Delete(string project, string interconnect)
        {
            return new DeleteRequest(service, project, interconnect);
        }

        /// <summary>Deletes the specified interconnect.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string interconnect) : base(service)
            {
                Project = project;
                Interconnect = interconnect;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the interconnect to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("interconnect", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Interconnect { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/interconnects/{interconnect}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("interconnect", new Google.Apis.Discovery.Parameter
                {
                    Name = "interconnect",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified interconnect. Get a list of available interconnects by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="interconnect">Name of the interconnect to return.</param>
        public virtual GetRequest Get(string project, string interconnect)
        {
            return new GetRequest(service, project, interconnect);
        }

        /// <summary>
        /// Returns the specified interconnect. Get a list of available interconnects by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Interconnect>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string interconnect) : base(service)
            {
                Project = project;
                Interconnect = interconnect;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the interconnect to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("interconnect", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Interconnect { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/interconnects/{interconnect}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("interconnect", new Google.Apis.Discovery.Parameter
                {
                    Name = "interconnect",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Returns the interconnectDiagnostics for the specified interconnect.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="interconnect">Name of the interconnect resource to query.</param>
        public virtual GetDiagnosticsRequest GetDiagnostics(string project, string interconnect)
        {
            return new GetDiagnosticsRequest(service, project, interconnect);
        }

        /// <summary>Returns the interconnectDiagnostics for the specified interconnect.</summary>
        public class GetDiagnosticsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InterconnectsGetDiagnosticsResponse>
        {
            /// <summary>Constructs a new GetDiagnostics request.</summary>
            public GetDiagnosticsRequest(Google.Apis.Services.IClientService service, string project, string interconnect) : base(service)
            {
                Project = project;
                Interconnect = interconnect;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the interconnect resource to query.</summary>
            [Google.Apis.Util.RequestParameterAttribute("interconnect", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Interconnect { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getDiagnostics";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/interconnects/{interconnect}/getDiagnostics";

            /// <summary>Initializes GetDiagnostics parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("interconnect", new Google.Apis.Discovery.Parameter
                {
                    Name = "interconnect",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Creates a Interconnect in the specified project using the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Interconnect body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>Creates a Interconnect in the specified project using the data included in the request.</summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Interconnect body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Interconnect Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/interconnects";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of interconnect available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of interconnect available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InterconnectList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/interconnects";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the specified interconnect with the data included in the request. This method supports PATCH
        /// semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="interconnect">Name of the interconnect to update.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.Interconnect body, string project, string interconnect)
        {
            return new PatchRequest(service, body, project, interconnect);
        }

        /// <summary>
        /// Updates the specified interconnect with the data included in the request. This method supports PATCH
        /// semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Interconnect body, string project, string interconnect) : base(service)
            {
                Project = project;
                Interconnect = interconnect;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the interconnect to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("interconnect", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Interconnect { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Interconnect Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/interconnects/{interconnect}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("interconnect", new Google.Apis.Discovery.Parameter
                {
                    Name = "interconnect",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "licenseCodes" collection of methods.</summary>
    public class LicenseCodesResource
    {
        private const string Resource = "licenseCodes";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public LicenseCodesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Return a specified license code. License codes are mirrored across all projects that have permissions to
        /// read the License Code.  Caution This resource is intended for use only by third-party partners who are
        /// creating Cloud Marketplace images.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="licenseCode">Number corresponding to the License code resource to return.</param>
        public virtual GetRequest Get(string project, string licenseCode)
        {
            return new GetRequest(service, project, licenseCode);
        }

        /// <summary>
        /// Return a specified license code. License codes are mirrored across all projects that have permissions to
        /// read the License Code.  Caution This resource is intended for use only by third-party partners who are
        /// creating Cloud Marketplace images.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.LicenseCode>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string licenseCode) : base(service)
            {
                Project = project;
                LicenseCode = licenseCode;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Number corresponding to the License code resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("licenseCode", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string LicenseCode { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/licenseCodes/{licenseCode}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("licenseCode", new Google.Apis.Discovery.Parameter
                {
                    Name = "licenseCode",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[0-9]{0,61}?",
                });
            }
        }

        /// <summary>
        /// Returns permissions that a caller has on the specified resource.  Caution This resource is intended for use
        /// only by third-party partners who are creating Cloud Marketplace images.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, resource);
        }

        /// <summary>
        /// Returns permissions that a caller has on the specified resource.  Caution This resource is intended for use
        /// only by third-party partners who are creating Cloud Marketplace images.
        /// </summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/licenseCodes/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "licenses" collection of methods.</summary>
    public class LicensesResource
    {
        private const string Resource = "licenses";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public LicensesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Deletes the specified license.  Caution This resource is intended for use only by third-party partners who
        /// are creating Cloud Marketplace images.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="license">Name of the license resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string license)
        {
            return new DeleteRequest(service, project, license);
        }

        /// <summary>
        /// Deletes the specified license.  Caution This resource is intended for use only by third-party partners who
        /// are creating Cloud Marketplace images.
        /// </summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string license) : base(service)
            {
                Project = project;
                License = license;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the license resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("license", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string License { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/licenses/{license}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("license", new Google.Apis.Discovery.Parameter
                {
                    Name = "license",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified License resource.  Caution This resource is intended for use only by third-party
        /// partners who are creating Cloud Marketplace images.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="license">Name of the License resource to return.</param>
        public virtual GetRequest Get(string project, string license)
        {
            return new GetRequest(service, project, license);
        }

        /// <summary>
        /// Returns the specified License resource.  Caution This resource is intended for use only by third-party
        /// partners who are creating Cloud Marketplace images.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.License>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string license) : base(service)
            {
                Project = project;
                License = license;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the License resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("license", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string License { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/licenses/{license}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("license", new Google.Apis.Discovery.Parameter
                {
                    Name = "license",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.  Caution
        /// This resource is intended for use only by third-party partners who are creating Cloud Marketplace images.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual GetIamPolicyRequest GetIamPolicy(string project, string resource)
        {
            return new GetIamPolicyRequest(service, project, resource);
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.  Caution
        /// This resource is intended for use only by third-party partners who are creating Cloud Marketplace images.
        /// </summary>
        public class GetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new GetIamPolicy request.</summary>
            public GetIamPolicyRequest(Google.Apis.Services.IClientService service, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Requested IAM Policy version.</summary>
            [Google.Apis.Util.RequestParameterAttribute("optionsRequestedPolicyVersion", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> OptionsRequestedPolicyVersion { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/licenses/{resource}/getIamPolicy";

            /// <summary>Initializes GetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("optionsRequestedPolicyVersion", new Google.Apis.Discovery.Parameter
                {
                    Name = "optionsRequestedPolicyVersion",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Create a License resource in the specified project.  Caution This resource is intended for use only by
        /// third-party partners who are creating Cloud Marketplace images.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.License body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Create a License resource in the specified project.  Caution This resource is intended for use only by
        /// third-party partners who are creating Cloud Marketplace images.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.License body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.License Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/licenses";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves the list of licenses available in the specified project. This method does not get any licenses
        /// that belong to other projects, including licenses attached to publicly-available images, like Debian 9. If
        /// you want to get a list of publicly-available licenses, use this method to make a request to the respective
        /// image project, such as debian-cloud or windows-cloud.  Caution This resource is intended for use only by
        /// third-party partners who are creating Cloud Marketplace images.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>
        /// Retrieves the list of licenses available in the specified project. This method does not get any licenses
        /// that belong to other projects, including licenses attached to publicly-available images, like Debian 9. If
        /// you want to get a list of publicly-available licenses, use this method to make a request to the respective
        /// image project, such as debian-cloud or windows-cloud.  Caution This resource is intended for use only by
        /// third-party partners who are creating Cloud Marketplace images.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.LicensesListResponse>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/licenses";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets the access control policy on the specified resource. Replaces any existing policy.  Caution This
        /// resource is intended for use only by third-party partners who are creating Cloud Marketplace images.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetIamPolicyRequest SetIamPolicy(Google.Apis.Compute.v1.Data.GlobalSetPolicyRequest body, string project, string resource)
        {
            return new SetIamPolicyRequest(service, body, project, resource);
        }

        /// <summary>
        /// Sets the access control policy on the specified resource. Replaces any existing policy.  Caution This
        /// resource is intended for use only by third-party partners who are creating Cloud Marketplace images.
        /// </summary>
        public class SetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new SetIamPolicy request.</summary>
            public SetIamPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.GlobalSetPolicyRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.GlobalSetPolicyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/licenses/{resource}/setIamPolicy";

            /// <summary>Initializes SetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Returns permissions that a caller has on the specified resource.  Caution This resource is intended for use
        /// only by third-party partners who are creating Cloud Marketplace images.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, resource);
        }

        /// <summary>
        /// Returns permissions that a caller has on the specified resource.  Caution This resource is intended for use
        /// only by third-party partners who are creating Cloud Marketplace images.
        /// </summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/licenses/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "machineTypes" collection of methods.</summary>
    public class MachineTypesResource
    {
        private const string Resource = "machineTypes";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public MachineTypesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of machine types.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of machine types.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.MachineTypeAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/machineTypes";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified machine type. Gets a list of available machine types by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="machineType">Name of the machine type to return.</param>
        public virtual GetRequest Get(string project, string zone, string machineType)
        {
            return new GetRequest(service, project, zone, machineType);
        }

        /// <summary>
        /// Returns the specified machine type. Gets a list of available machine types by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.MachineType>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string machineType) : base(service)
            {
                Project = project;
                Zone = zone;
                MachineType = machineType;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the machine type to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("machineType", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string MachineType { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/machineTypes/{machineType}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("machineType", new Google.Apis.Discovery.Parameter
                {
                    Name = "machineType",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves a list of machine types available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>Retrieves a list of machine types available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.MachineTypeList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/machineTypes";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "networkEndpointGroups" collection of methods.</summary>
    public class NetworkEndpointGroupsResource
    {
        private const string Resource = "networkEndpointGroups";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public NetworkEndpointGroupsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves the list of network endpoint groups and sorts them by zone.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves the list of network endpoint groups and sorts them by zone.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NetworkEndpointGroupAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/networkEndpointGroups";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Attach a list of network endpoints to the specified network endpoint group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where the network endpoint group is located. It should comply with RFC1035.
        /// </param>
        /// <param name="networkEndpointGroup">
        /// The name of the network endpoint group where you are attaching network endpoints to. It should comply with
        /// RFC1035.
        /// </param>
        public virtual AttachNetworkEndpointsRequest AttachNetworkEndpoints(Google.Apis.Compute.v1.Data.NetworkEndpointGroupsAttachEndpointsRequest body, string project, string zone, string networkEndpointGroup)
        {
            return new AttachNetworkEndpointsRequest(service, body, project, zone, networkEndpointGroup);
        }

        /// <summary>Attach a list of network endpoints to the specified network endpoint group.</summary>
        public class AttachNetworkEndpointsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AttachNetworkEndpoints request.</summary>
            public AttachNetworkEndpointsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NetworkEndpointGroupsAttachEndpointsRequest body, string project, string zone, string networkEndpointGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                NetworkEndpointGroup = networkEndpointGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where the network endpoint group is located. It should comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// The name of the network endpoint group where you are attaching network endpoints to. It should comply
            /// with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("networkEndpointGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NetworkEndpointGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NetworkEndpointGroupsAttachEndpointsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "attachNetworkEndpoints";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/networkEndpointGroups/{networkEndpointGroup}/attachNetworkEndpoints";

            /// <summary>Initializes AttachNetworkEndpoints parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("networkEndpointGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkEndpointGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Deletes the specified network endpoint group. The network endpoints in the NEG and the VM instances they
        /// belong to are not terminated when the NEG is deleted. Note that the NEG cannot be deleted if there are
        /// backend services referencing it.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where the network endpoint group is located. It should comply with RFC1035.
        /// </param>
        /// <param name="networkEndpointGroup">
        /// The name of the network endpoint group to delete. It should comply with RFC1035.
        /// </param>
        public virtual DeleteRequest Delete(string project, string zone, string networkEndpointGroup)
        {
            return new DeleteRequest(service, project, zone, networkEndpointGroup);
        }

        /// <summary>
        /// Deletes the specified network endpoint group. The network endpoints in the NEG and the VM instances they
        /// belong to are not terminated when the NEG is deleted. Note that the NEG cannot be deleted if there are
        /// backend services referencing it.
        /// </summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string zone, string networkEndpointGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                NetworkEndpointGroup = networkEndpointGroup;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where the network endpoint group is located. It should comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the network endpoint group to delete. It should comply with RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("networkEndpointGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NetworkEndpointGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/networkEndpointGroups/{networkEndpointGroup}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("networkEndpointGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkEndpointGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Detach a list of network endpoints from the specified network endpoint group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where the network endpoint group is located. It should comply with RFC1035.
        /// </param>
        /// <param name="networkEndpointGroup">
        /// The name of the network endpoint group where you are removing network endpoints. It should comply with
        /// RFC1035.
        /// </param>
        public virtual DetachNetworkEndpointsRequest DetachNetworkEndpoints(Google.Apis.Compute.v1.Data.NetworkEndpointGroupsDetachEndpointsRequest body, string project, string zone, string networkEndpointGroup)
        {
            return new DetachNetworkEndpointsRequest(service, body, project, zone, networkEndpointGroup);
        }

        /// <summary>Detach a list of network endpoints from the specified network endpoint group.</summary>
        public class DetachNetworkEndpointsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new DetachNetworkEndpoints request.</summary>
            public DetachNetworkEndpointsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NetworkEndpointGroupsDetachEndpointsRequest body, string project, string zone, string networkEndpointGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                NetworkEndpointGroup = networkEndpointGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where the network endpoint group is located. It should comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// The name of the network endpoint group where you are removing network endpoints. It should comply with
            /// RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("networkEndpointGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NetworkEndpointGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NetworkEndpointGroupsDetachEndpointsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "detachNetworkEndpoints";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/networkEndpointGroups/{networkEndpointGroup}/detachNetworkEndpoints";

            /// <summary>Initializes DetachNetworkEndpoints parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("networkEndpointGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkEndpointGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified network endpoint group. Gets a list of available network endpoint groups by making a
        /// list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where the network endpoint group is located. It should comply with RFC1035.
        /// </param>
        /// <param name="networkEndpointGroup">
        /// The name of the network endpoint group. It should comply with RFC1035.
        /// </param>
        public virtual GetRequest Get(string project, string zone, string networkEndpointGroup)
        {
            return new GetRequest(service, project, zone, networkEndpointGroup);
        }

        /// <summary>
        /// Returns the specified network endpoint group. Gets a list of available network endpoint groups by making a
        /// list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NetworkEndpointGroup>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string networkEndpointGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                NetworkEndpointGroup = networkEndpointGroup;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where the network endpoint group is located. It should comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>The name of the network endpoint group. It should comply with RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("networkEndpointGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NetworkEndpointGroup { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/networkEndpointGroups/{networkEndpointGroup}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("networkEndpointGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkEndpointGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates a network endpoint group in the specified project using the parameters that are included in the
        /// request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where you want to create the network endpoint group. It should comply with RFC1035.
        /// </param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.NetworkEndpointGroup body, string project, string zone)
        {
            return new InsertRequest(service, body, project, zone);
        }

        /// <summary>
        /// Creates a network endpoint group in the specified project using the parameters that are included in the
        /// request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NetworkEndpointGroup body, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where you want to create the network endpoint group. It should comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NetworkEndpointGroup Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/networkEndpointGroups";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves the list of network endpoint groups that are located in the specified project and zone.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where the network endpoint group is located. It should comply with RFC1035.
        /// </param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>
        /// Retrieves the list of network endpoint groups that are located in the specified project and zone.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NetworkEndpointGroupList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where the network endpoint group is located. It should comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/networkEndpointGroups";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Lists the network endpoints in the specified network endpoint group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">
        /// The name of the zone where the network endpoint group is located. It should comply with RFC1035.
        /// </param>
        /// <param name="networkEndpointGroup">
        /// The name of the network endpoint group from which you want to generate a list of included network endpoints.
        /// It should comply with RFC1035.
        /// </param>
        public virtual ListNetworkEndpointsRequest ListNetworkEndpoints(Google.Apis.Compute.v1.Data.NetworkEndpointGroupsListEndpointsRequest body, string project, string zone, string networkEndpointGroup)
        {
            return new ListNetworkEndpointsRequest(service, body, project, zone, networkEndpointGroup);
        }

        /// <summary>Lists the network endpoints in the specified network endpoint group.</summary>
        public class ListNetworkEndpointsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NetworkEndpointGroupsListNetworkEndpoints>
        {
            /// <summary>Constructs a new ListNetworkEndpoints request.</summary>
            public ListNetworkEndpointsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NetworkEndpointGroupsListEndpointsRequest body, string project, string zone, string networkEndpointGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                NetworkEndpointGroup = networkEndpointGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the zone where the network endpoint group is located. It should comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// The name of the network endpoint group from which you want to generate a list of included network
            /// endpoints. It should comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("networkEndpointGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NetworkEndpointGroup { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NetworkEndpointGroupsListEndpointsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listNetworkEndpoints";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/networkEndpointGroups/{networkEndpointGroup}/listNetworkEndpoints";

            /// <summary>Initializes ListNetworkEndpoints parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("networkEndpointGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkEndpointGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string zone, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, zone, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/networkEndpointGroups/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "networks" collection of methods.</summary>
    public class NetworksResource
    {
        private const string Resource = "networks";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public NetworksResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Adds a peering to the specified network.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="network">Name of the network resource to add peering to.</param>
        public virtual AddPeeringRequest AddPeering(Google.Apis.Compute.v1.Data.NetworksAddPeeringRequest body, string project, string network)
        {
            return new AddPeeringRequest(service, body, project, network);
        }

        /// <summary>Adds a peering to the specified network.</summary>
        public class AddPeeringRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddPeering request.</summary>
            public AddPeeringRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NetworksAddPeeringRequest body, string project, string network) : base(service)
            {
                Project = project;
                Network = network;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the network resource to add peering to.</summary>
            [Google.Apis.Util.RequestParameterAttribute("network", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Network { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NetworksAddPeeringRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addPeering";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networks/{network}/addPeering";

            /// <summary>Initializes AddPeering parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("network", new Google.Apis.Discovery.Parameter
                {
                    Name = "network",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified network.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="network">Name of the network to delete.</param>
        public virtual DeleteRequest Delete(string project, string network)
        {
            return new DeleteRequest(service, project, network);
        }

        /// <summary>Deletes the specified network.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string network) : base(service)
            {
                Project = project;
                Network = network;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the network to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("network", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Network { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networks/{network}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("network", new Google.Apis.Discovery.Parameter
                {
                    Name = "network",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified network. Gets a list of available networks by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="network">Name of the network to return.</param>
        public virtual GetRequest Get(string project, string network)
        {
            return new GetRequest(service, project, network);
        }

        /// <summary>
        /// Returns the specified network. Gets a list of available networks by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Network>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string network) : base(service)
            {
                Project = project;
                Network = network;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the network to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("network", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Network { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networks/{network}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("network", new Google.Apis.Discovery.Parameter
                {
                    Name = "network",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Returns the effective firewalls on a given network.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="network">Name of the network for this request.</param>
        public virtual GetEffectiveFirewallsRequest GetEffectiveFirewalls(string project, string network)
        {
            return new GetEffectiveFirewallsRequest(service, project, network);
        }

        /// <summary>Returns the effective firewalls on a given network.</summary>
        public class GetEffectiveFirewallsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NetworksGetEffectiveFirewallsResponse>
        {
            /// <summary>Constructs a new GetEffectiveFirewalls request.</summary>
            public GetEffectiveFirewallsRequest(Google.Apis.Services.IClientService service, string project, string network) : base(service)
            {
                Project = project;
                Network = network;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the network for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("network", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Network { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getEffectiveFirewalls";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networks/{network}/getEffectiveFirewalls";

            /// <summary>Initializes GetEffectiveFirewalls parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("network", new Google.Apis.Discovery.Parameter
                {
                    Name = "network",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
            }
        }

        /// <summary>Creates a network in the specified project using the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Network body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>Creates a network in the specified project using the data included in the request.</summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Network body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Network Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networks";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of networks available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of networks available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NetworkList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networks";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Lists the peering routes exchanged over peering connection.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="network">Name of the network for this request.</param>
        public virtual ListPeeringRoutesRequest ListPeeringRoutes(string project, string network)
        {
            return new ListPeeringRoutesRequest(service, project, network);
        }

        /// <summary>Lists the peering routes exchanged over peering connection.</summary>
        public class ListPeeringRoutesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ExchangedPeeringRoutesList>
        {
            /// <summary>Constructs a new ListPeeringRoutes request.</summary>
            public ListPeeringRoutesRequest(Google.Apis.Services.IClientService service, string project, string network) : base(service)
            {
                Project = project;
                Network = network;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the network for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("network", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Network { get; private set; }

            /// <summary>The direction of the exchanged routes.</summary>
            [Google.Apis.Util.RequestParameterAttribute("direction", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<DirectionEnum> Direction { get; set; }

            /// <summary>The direction of the exchanged routes.</summary>
            public enum DirectionEnum
            {
                /// <summary></summary>
                [Google.Apis.Util.StringValueAttribute("INCOMING")]
                INCOMING,

                /// <summary></summary>
                [Google.Apis.Util.StringValueAttribute("OUTGOING")]
                OUTGOING,
            }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>The response will show routes exchanged over the given peering connection.</summary>
            [Google.Apis.Util.RequestParameterAttribute("peeringName", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PeeringName { get; set; }

            /// <summary>
            /// The region of the request. The response will include all subnet routes, static routes and dynamic routes
            /// in the region.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Region { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listPeeringRoutes";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networks/{network}/listPeeringRoutes";

            /// <summary>Initializes ListPeeringRoutes parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("network", new Google.Apis.Discovery.Parameter
                {
                    Name = "network",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("direction", new Google.Apis.Discovery.Parameter
                {
                    Name = "direction",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("peeringName", new Google.Apis.Discovery.Parameter
                {
                    Name = "peeringName",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Patches the specified network with the data included in the request. Only the following fields can be
        /// modified: routingConfig.routingMode.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="network">Name of the network to update.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.Network body, string project, string network)
        {
            return new PatchRequest(service, body, project, network);
        }

        /// <summary>
        /// Patches the specified network with the data included in the request. Only the following fields can be
        /// modified: routingConfig.routingMode.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Network body, string project, string network) : base(service)
            {
                Project = project;
                Network = network;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the network to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("network", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Network { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Network Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networks/{network}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("network", new Google.Apis.Discovery.Parameter
                {
                    Name = "network",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Removes a peering from the specified network.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="network">Name of the network resource to remove peering from.</param>
        public virtual RemovePeeringRequest RemovePeering(Google.Apis.Compute.v1.Data.NetworksRemovePeeringRequest body, string project, string network)
        {
            return new RemovePeeringRequest(service, body, project, network);
        }

        /// <summary>Removes a peering from the specified network.</summary>
        public class RemovePeeringRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new RemovePeering request.</summary>
            public RemovePeeringRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NetworksRemovePeeringRequest body, string project, string network) : base(service)
            {
                Project = project;
                Network = network;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the network resource to remove peering from.</summary>
            [Google.Apis.Util.RequestParameterAttribute("network", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Network { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NetworksRemovePeeringRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "removePeering";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networks/{network}/removePeering";

            /// <summary>Initializes RemovePeering parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("network", new Google.Apis.Discovery.Parameter
                {
                    Name = "network",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Switches the network mode from auto subnet mode to custom subnet mode.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="network">Name of the network to be updated.</param>
        public virtual SwitchToCustomModeRequest SwitchToCustomMode(string project, string network)
        {
            return new SwitchToCustomModeRequest(service, project, network);
        }

        /// <summary>Switches the network mode from auto subnet mode to custom subnet mode.</summary>
        public class SwitchToCustomModeRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SwitchToCustomMode request.</summary>
            public SwitchToCustomModeRequest(Google.Apis.Services.IClientService service, string project, string network) : base(service)
            {
                Project = project;
                Network = network;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the network to be updated.</summary>
            [Google.Apis.Util.RequestParameterAttribute("network", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Network { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "switchToCustomMode";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networks/{network}/switchToCustomMode";

            /// <summary>Initializes SwitchToCustomMode parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("network", new Google.Apis.Discovery.Parameter
                {
                    Name = "network",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the specified network peering with the data included in the request Only the following fields can be
        /// modified: NetworkPeering.export_custom_routes, and NetworkPeering.import_custom_routes
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="network">Name of the network resource which the updated peering is belonging to.</param>
        public virtual UpdatePeeringRequest UpdatePeering(Google.Apis.Compute.v1.Data.NetworksUpdatePeeringRequest body, string project, string network)
        {
            return new UpdatePeeringRequest(service, body, project, network);
        }

        /// <summary>
        /// Updates the specified network peering with the data included in the request Only the following fields can be
        /// modified: NetworkPeering.export_custom_routes, and NetworkPeering.import_custom_routes
        /// </summary>
        public class UpdatePeeringRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new UpdatePeering request.</summary>
            public UpdatePeeringRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NetworksUpdatePeeringRequest body, string project, string network) : base(service)
            {
                Project = project;
                Network = network;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the network resource which the updated peering is belonging to.</summary>
            [Google.Apis.Util.RequestParameterAttribute("network", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Network { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NetworksUpdatePeeringRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "updatePeering";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/networks/{network}/updatePeering";

            /// <summary>Initializes UpdatePeering parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("network", new Google.Apis.Discovery.Parameter
                {
                    Name = "network",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "nodeGroups" collection of methods.</summary>
    public class NodeGroupsResource
    {
        private const string Resource = "nodeGroups";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public NodeGroupsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Adds specified number of nodes to the node group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="nodeGroup">Name of the NodeGroup resource.</param>
        public virtual AddNodesRequest AddNodes(Google.Apis.Compute.v1.Data.NodeGroupsAddNodesRequest body, string project, string zone, string nodeGroup)
        {
            return new AddNodesRequest(service, body, project, zone, nodeGroup);
        }

        /// <summary>Adds specified number of nodes to the node group.</summary>
        public class AddNodesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddNodes request.</summary>
            public AddNodesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NodeGroupsAddNodesRequest body, string project, string zone, string nodeGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                NodeGroup = nodeGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the NodeGroup resource.</summary>
            [Google.Apis.Util.RequestParameterAttribute("nodeGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NodeGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NodeGroupsAddNodesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addNodes";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeGroups/{nodeGroup}/addNodes";

            /// <summary>Initializes AddNodes parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("nodeGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "nodeGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves an aggregated list of node groups. Note: use nodeGroups.listNodes for more details about each
        /// group.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>
        /// Retrieves an aggregated list of node groups. Note: use nodeGroups.listNodes for more details about each
        /// group.
        /// </summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NodeGroupAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/nodeGroups";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified NodeGroup resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="nodeGroup">Name of the NodeGroup resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string zone, string nodeGroup)
        {
            return new DeleteRequest(service, project, zone, nodeGroup);
        }

        /// <summary>Deletes the specified NodeGroup resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string zone, string nodeGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                NodeGroup = nodeGroup;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the NodeGroup resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("nodeGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NodeGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeGroups/{nodeGroup}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("nodeGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "nodeGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes specified nodes from the node group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="nodeGroup">Name of the NodeGroup resource whose nodes will be deleted.</param>
        public virtual DeleteNodesRequest DeleteNodes(Google.Apis.Compute.v1.Data.NodeGroupsDeleteNodesRequest body, string project, string zone, string nodeGroup)
        {
            return new DeleteNodesRequest(service, body, project, zone, nodeGroup);
        }

        /// <summary>Deletes specified nodes from the node group.</summary>
        public class DeleteNodesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new DeleteNodes request.</summary>
            public DeleteNodesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NodeGroupsDeleteNodesRequest body, string project, string zone, string nodeGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                NodeGroup = nodeGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the NodeGroup resource whose nodes will be deleted.</summary>
            [Google.Apis.Util.RequestParameterAttribute("nodeGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NodeGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NodeGroupsDeleteNodesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "deleteNodes";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeGroups/{nodeGroup}/deleteNodes";

            /// <summary>Initializes DeleteNodes parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("nodeGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "nodeGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified NodeGroup. Get a list of available NodeGroups by making a list() request. Note: the
        /// "nodes" field should not be used. Use nodeGroups.listNodes instead.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="nodeGroup">Name of the node group to return.</param>
        public virtual GetRequest Get(string project, string zone, string nodeGroup)
        {
            return new GetRequest(service, project, zone, nodeGroup);
        }

        /// <summary>
        /// Returns the specified NodeGroup. Get a list of available NodeGroups by making a list() request. Note: the
        /// "nodes" field should not be used. Use nodeGroups.listNodes instead.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NodeGroup>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string nodeGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                NodeGroup = nodeGroup;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the node group to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("nodeGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NodeGroup { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeGroups/{nodeGroup}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("nodeGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "nodeGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual GetIamPolicyRequest GetIamPolicy(string project, string zone, string resource)
        {
            return new GetIamPolicyRequest(service, project, zone, resource);
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        public class GetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new GetIamPolicy request.</summary>
            public GetIamPolicyRequest(Google.Apis.Services.IClientService service, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Requested IAM Policy version.</summary>
            [Google.Apis.Util.RequestParameterAttribute("optionsRequestedPolicyVersion", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> OptionsRequestedPolicyVersion { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeGroups/{resource}/getIamPolicy";

            /// <summary>Initializes GetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("optionsRequestedPolicyVersion", new Google.Apis.Discovery.Parameter
                {
                    Name = "optionsRequestedPolicyVersion",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates a NodeGroup resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="initialNodeCount">Initial count of nodes in the node group.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.NodeGroup body, string project, string zone, int initialNodeCount)
        {
            return new InsertRequest(service, body, project, zone, initialNodeCount);
        }

        /// <summary>
        /// Creates a NodeGroup resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NodeGroup body, string project, string zone, int initialNodeCount) : base(service)
            {
                Project = project;
                Zone = zone;
                InitialNodeCount = initialNodeCount;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Initial count of nodes in the node group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("initialNodeCount", Google.Apis.Util.RequestParameterType.Query)]
            public virtual int InitialNodeCount { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NodeGroup Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeGroups";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("initialNodeCount", new Google.Apis.Discovery.Parameter
                {
                    Name = "initialNodeCount",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves a list of node groups available to the specified project. Note: use nodeGroups.listNodes for more
        /// details about each group.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>
        /// Retrieves a list of node groups available to the specified project. Note: use nodeGroups.listNodes for more
        /// details about each group.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NodeGroupList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeGroups";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Lists nodes in the node group.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="nodeGroup">Name of the NodeGroup resource whose nodes you want to list.</param>
        public virtual ListNodesRequest ListNodes(string project, string zone, string nodeGroup)
        {
            return new ListNodesRequest(service, project, zone, nodeGroup);
        }

        /// <summary>Lists nodes in the node group.</summary>
        public class ListNodesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NodeGroupsListNodes>
        {
            /// <summary>Constructs a new ListNodes request.</summary>
            public ListNodesRequest(Google.Apis.Services.IClientService service, string project, string zone, string nodeGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                NodeGroup = nodeGroup;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the NodeGroup resource whose nodes you want to list.</summary>
            [Google.Apis.Util.RequestParameterAttribute("nodeGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NodeGroup { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listNodes";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeGroups/{nodeGroup}/listNodes";

            /// <summary>Initializes ListNodes parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("nodeGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "nodeGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Updates the specified node group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="nodeGroup">Name of the NodeGroup resource to update.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.NodeGroup body, string project, string zone, string nodeGroup)
        {
            return new PatchRequest(service, body, project, zone, nodeGroup);
        }

        /// <summary>Updates the specified node group.</summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NodeGroup body, string project, string zone, string nodeGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                NodeGroup = nodeGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the NodeGroup resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("nodeGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NodeGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NodeGroup Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeGroups/{nodeGroup}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("nodeGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "nodeGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetIamPolicyRequest SetIamPolicy(Google.Apis.Compute.v1.Data.ZoneSetPolicyRequest body, string project, string zone, string resource)
        {
            return new SetIamPolicyRequest(service, body, project, zone, resource);
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        public class SetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new SetIamPolicy request.</summary>
            public SetIamPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ZoneSetPolicyRequest body, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ZoneSetPolicyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeGroups/{resource}/setIamPolicy";

            /// <summary>Initializes SetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Updates the node template of the node group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="nodeGroup">Name of the NodeGroup resource to update.</param>
        public virtual SetNodeTemplateRequest SetNodeTemplate(Google.Apis.Compute.v1.Data.NodeGroupsSetNodeTemplateRequest body, string project, string zone, string nodeGroup)
        {
            return new SetNodeTemplateRequest(service, body, project, zone, nodeGroup);
        }

        /// <summary>Updates the node template of the node group.</summary>
        public class SetNodeTemplateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetNodeTemplate request.</summary>
            public SetNodeTemplateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NodeGroupsSetNodeTemplateRequest body, string project, string zone, string nodeGroup) : base(service)
            {
                Project = project;
                Zone = zone;
                NodeGroup = nodeGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the NodeGroup resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("nodeGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NodeGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NodeGroupsSetNodeTemplateRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setNodeTemplate";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeGroups/{nodeGroup}/setNodeTemplate";

            /// <summary>Initializes SetNodeTemplate parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("nodeGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "nodeGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string zone, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, zone, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeGroups/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "nodeTemplates" collection of methods.</summary>
    public class NodeTemplatesResource
    {
        private const string Resource = "nodeTemplates";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public NodeTemplatesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of node templates.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of node templates.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NodeTemplateAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/nodeTemplates";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified NodeTemplate resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="nodeTemplate">Name of the NodeTemplate resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string nodeTemplate)
        {
            return new DeleteRequest(service, project, region, nodeTemplate);
        }

        /// <summary>Deletes the specified NodeTemplate resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string nodeTemplate) : base(service)
            {
                Project = project;
                Region = region;
                NodeTemplate = nodeTemplate;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the NodeTemplate resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("nodeTemplate", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NodeTemplate { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/nodeTemplates/{nodeTemplate}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("nodeTemplate", new Google.Apis.Discovery.Parameter
                {
                    Name = "nodeTemplate",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified node template. Gets a list of available node templates by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="nodeTemplate">Name of the node template to return.</param>
        public virtual GetRequest Get(string project, string region, string nodeTemplate)
        {
            return new GetRequest(service, project, region, nodeTemplate);
        }

        /// <summary>
        /// Returns the specified node template. Gets a list of available node templates by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NodeTemplate>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string nodeTemplate) : base(service)
            {
                Project = project;
                Region = region;
                NodeTemplate = nodeTemplate;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the node template to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("nodeTemplate", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NodeTemplate { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/nodeTemplates/{nodeTemplate}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("nodeTemplate", new Google.Apis.Discovery.Parameter
                {
                    Name = "nodeTemplate",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual GetIamPolicyRequest GetIamPolicy(string project, string region, string resource)
        {
            return new GetIamPolicyRequest(service, project, region, resource);
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        public class GetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new GetIamPolicy request.</summary>
            public GetIamPolicyRequest(Google.Apis.Services.IClientService service, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Requested IAM Policy version.</summary>
            [Google.Apis.Util.RequestParameterAttribute("optionsRequestedPolicyVersion", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> OptionsRequestedPolicyVersion { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/nodeTemplates/{resource}/getIamPolicy";

            /// <summary>Initializes GetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("optionsRequestedPolicyVersion", new Google.Apis.Discovery.Parameter
                {
                    Name = "optionsRequestedPolicyVersion",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates a NodeTemplate resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.NodeTemplate body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a NodeTemplate resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NodeTemplate body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NodeTemplate Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/nodeTemplates";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of node templates available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves a list of node templates available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NodeTemplateList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/nodeTemplates";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetIamPolicyRequest SetIamPolicy(Google.Apis.Compute.v1.Data.RegionSetPolicyRequest body, string project, string region, string resource)
        {
            return new SetIamPolicyRequest(service, body, project, region, resource);
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        public class SetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new SetIamPolicy request.</summary>
            public SetIamPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionSetPolicyRequest body, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionSetPolicyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/nodeTemplates/{resource}/setIamPolicy";

            /// <summary>Initializes SetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string region, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, region, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/nodeTemplates/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "nodeTypes" collection of methods.</summary>
    public class NodeTypesResource
    {
        private const string Resource = "nodeTypes";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public NodeTypesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of node types.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of node types.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NodeTypeAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/nodeTypes";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified node type. Gets a list of available node types by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="nodeType">Name of the node type to return.</param>
        public virtual GetRequest Get(string project, string zone, string nodeType)
        {
            return new GetRequest(service, project, zone, nodeType);
        }

        /// <summary>
        /// Returns the specified node type. Gets a list of available node types by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NodeType>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string nodeType) : base(service)
            {
                Project = project;
                Zone = zone;
                NodeType = nodeType;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the node type to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("nodeType", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NodeType { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeTypes/{nodeType}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("nodeType", new Google.Apis.Discovery.Parameter
                {
                    Name = "nodeType",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves a list of node types available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>Retrieves a list of node types available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NodeTypeList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/nodeTypes";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "packetMirrorings" collection of methods.</summary>
    public class PacketMirroringsResource
    {
        private const string Resource = "packetMirrorings";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public PacketMirroringsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of packetMirrorings.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of packetMirrorings.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.PacketMirroringAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/packetMirrorings";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified PacketMirroring resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="packetMirroring">Name of the PacketMirroring resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string packetMirroring)
        {
            return new DeleteRequest(service, project, region, packetMirroring);
        }

        /// <summary>Deletes the specified PacketMirroring resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string packetMirroring) : base(service)
            {
                Project = project;
                Region = region;
                PacketMirroring = packetMirroring;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the PacketMirroring resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("packetMirroring", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string PacketMirroring { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/packetMirrorings/{packetMirroring}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("packetMirroring", new Google.Apis.Discovery.Parameter
                {
                    Name = "packetMirroring",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified PacketMirroring resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="packetMirroring">Name of the PacketMirroring resource to return.</param>
        public virtual GetRequest Get(string project, string region, string packetMirroring)
        {
            return new GetRequest(service, project, region, packetMirroring);
        }

        /// <summary>Returns the specified PacketMirroring resource.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.PacketMirroring>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string packetMirroring) : base(service)
            {
                Project = project;
                Region = region;
                PacketMirroring = packetMirroring;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the PacketMirroring resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("packetMirroring", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string PacketMirroring { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/packetMirrorings/{packetMirroring}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("packetMirroring", new Google.Apis.Discovery.Parameter
                {
                    Name = "packetMirroring",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a PacketMirroring resource in the specified project and region using the data included in the
        /// request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.PacketMirroring body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a PacketMirroring resource in the specified project and region using the data included in the
        /// request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.PacketMirroring body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.PacketMirroring Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/packetMirrorings";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves a list of PacketMirroring resources available to the specified project and region.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>
        /// Retrieves a list of PacketMirroring resources available to the specified project and region.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.PacketMirroringList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/packetMirrorings";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Patches the specified PacketMirroring resource with the data included in the request. This method supports
        /// PATCH semantics and uses JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="packetMirroring">Name of the PacketMirroring resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.PacketMirroring body, string project, string region, string packetMirroring)
        {
            return new PatchRequest(service, body, project, region, packetMirroring);
        }

        /// <summary>
        /// Patches the specified PacketMirroring resource with the data included in the request. This method supports
        /// PATCH semantics and uses JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.PacketMirroring body, string project, string region, string packetMirroring) : base(service)
            {
                Project = project;
                Region = region;
                PacketMirroring = packetMirroring;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the PacketMirroring resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("packetMirroring", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string PacketMirroring { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.PacketMirroring Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/packetMirrorings/{packetMirroring}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("packetMirroring", new Google.Apis.Discovery.Parameter
                {
                    Name = "packetMirroring",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string region, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, region, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/packetMirrorings/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "projects" collection of methods.</summary>
    public class ProjectsResource
    {
        private const string Resource = "projects";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public ProjectsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Disable this project as a shared VPC host project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual DisableXpnHostRequest DisableXpnHost(string project)
        {
            return new DisableXpnHostRequest(service, project);
        }

        /// <summary>Disable this project as a shared VPC host project.</summary>
        public class DisableXpnHostRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new DisableXpnHost request.</summary>
            public DisableXpnHostRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "disableXpnHost";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/disableXpnHost";

            /// <summary>Initializes DisableXpnHost parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Disable a service resource (also known as service project) associated with this host project.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual DisableXpnResourceRequest DisableXpnResource(Google.Apis.Compute.v1.Data.ProjectsDisableXpnResourceRequest body, string project)
        {
            return new DisableXpnResourceRequest(service, body, project);
        }

        /// <summary>
        /// Disable a service resource (also known as service project) associated with this host project.
        /// </summary>
        public class DisableXpnResourceRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new DisableXpnResource request.</summary>
            public DisableXpnResourceRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ProjectsDisableXpnResourceRequest body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ProjectsDisableXpnResourceRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "disableXpnResource";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/disableXpnResource";

            /// <summary>Initializes DisableXpnResource parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Enable this project as a shared VPC host project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual EnableXpnHostRequest EnableXpnHost(string project)
        {
            return new EnableXpnHostRequest(service, project);
        }

        /// <summary>Enable this project as a shared VPC host project.</summary>
        public class EnableXpnHostRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new EnableXpnHost request.</summary>
            public EnableXpnHostRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "enableXpnHost";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/enableXpnHost";

            /// <summary>Initializes EnableXpnHost parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Enable service resource (a.k.a service project) for a host project, so that subnets in the host project can
        /// be used by instances in the service project.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual EnableXpnResourceRequest EnableXpnResource(Google.Apis.Compute.v1.Data.ProjectsEnableXpnResourceRequest body, string project)
        {
            return new EnableXpnResourceRequest(service, body, project);
        }

        /// <summary>
        /// Enable service resource (a.k.a service project) for a host project, so that subnets in the host project can
        /// be used by instances in the service project.
        /// </summary>
        public class EnableXpnResourceRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new EnableXpnResource request.</summary>
            public EnableXpnResourceRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ProjectsEnableXpnResourceRequest body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ProjectsEnableXpnResourceRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "enableXpnResource";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/enableXpnResource";

            /// <summary>Initializes EnableXpnResource parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified Project resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual GetRequest Get(string project)
        {
            return new GetRequest(service, project);
        }

        /// <summary>Returns the specified Project resource.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Project>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
            }
        }

        /// <summary>
        /// Gets the shared VPC host project that this project links to. May be empty if no link exists.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual GetXpnHostRequest GetXpnHost(string project)
        {
            return new GetXpnHostRequest(service, project);
        }

        /// <summary>
        /// Gets the shared VPC host project that this project links to. May be empty if no link exists.
        /// </summary>
        public class GetXpnHostRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Project>
        {
            /// <summary>Constructs a new GetXpnHost request.</summary>
            public GetXpnHostRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getXpnHost";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/getXpnHost";

            /// <summary>Initializes GetXpnHost parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
            }
        }

        /// <summary>Gets service resources (a.k.a service project) associated with this host project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual GetXpnResourcesRequest GetXpnResources(string project)
        {
            return new GetXpnResourcesRequest(service, project);
        }

        /// <summary>Gets service resources (a.k.a service project) associated with this host project.</summary>
        public class GetXpnResourcesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ProjectsGetXpnResources>
        {
            /// <summary>Constructs a new GetXpnResources request.</summary>
            public GetXpnResourcesRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getXpnResources";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/getXpnResources";

            /// <summary>Initializes GetXpnResources parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Lists all shared VPC host projects visible to the user in an organization.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListXpnHostsRequest ListXpnHosts(Google.Apis.Compute.v1.Data.ProjectsListXpnHostsRequest body, string project)
        {
            return new ListXpnHostsRequest(service, body, project);
        }

        /// <summary>Lists all shared VPC host projects visible to the user in an organization.</summary>
        public class ListXpnHostsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.XpnHostList>
        {
            /// <summary>Constructs a new ListXpnHosts request.</summary>
            public ListXpnHostsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ProjectsListXpnHostsRequest body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ProjectsListXpnHostsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listXpnHosts";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/listXpnHosts";

            /// <summary>Initializes ListXpnHosts parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Moves a persistent disk from one zone to another.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual MoveDiskRequest MoveDisk(Google.Apis.Compute.v1.Data.DiskMoveRequest body, string project)
        {
            return new MoveDiskRequest(service, body, project);
        }

        /// <summary>Moves a persistent disk from one zone to another.</summary>
        public class MoveDiskRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new MoveDisk request.</summary>
            public MoveDiskRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.DiskMoveRequest body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.DiskMoveRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "moveDisk";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/moveDisk";

            /// <summary>Initializes MoveDisk parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Moves an instance and its attached persistent disks from one zone to another.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual MoveInstanceRequest MoveInstance(Google.Apis.Compute.v1.Data.InstanceMoveRequest body, string project)
        {
            return new MoveInstanceRequest(service, body, project);
        }

        /// <summary>Moves an instance and its attached persistent disks from one zone to another.</summary>
        public class MoveInstanceRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new MoveInstance request.</summary>
            public MoveInstanceRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceMoveRequest body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceMoveRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "moveInstance";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/moveInstance";

            /// <summary>Initializes MoveInstance parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets metadata common to all instances within the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual SetCommonInstanceMetadataRequest SetCommonInstanceMetadata(Google.Apis.Compute.v1.Data.Metadata body, string project)
        {
            return new SetCommonInstanceMetadataRequest(service, body, project);
        }

        /// <summary>
        /// Sets metadata common to all instances within the specified project using the data included in the request.
        /// </summary>
        public class SetCommonInstanceMetadataRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetCommonInstanceMetadata request.</summary>
            public SetCommonInstanceMetadataRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Metadata body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Metadata Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setCommonInstanceMetadata";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/setCommonInstanceMetadata";

            /// <summary>Initializes SetCommonInstanceMetadata parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets the default network tier of the project. The default network tier is used when an
        /// address/forwardingRule/instance is created without specifying the network tier field.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual SetDefaultNetworkTierRequest SetDefaultNetworkTier(Google.Apis.Compute.v1.Data.ProjectsSetDefaultNetworkTierRequest body, string project)
        {
            return new SetDefaultNetworkTierRequest(service, body, project);
        }

        /// <summary>
        /// Sets the default network tier of the project. The default network tier is used when an
        /// address/forwardingRule/instance is created without specifying the network tier field.
        /// </summary>
        public class SetDefaultNetworkTierRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetDefaultNetworkTier request.</summary>
            public SetDefaultNetworkTierRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ProjectsSetDefaultNetworkTierRequest body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ProjectsSetDefaultNetworkTierRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setDefaultNetworkTier";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/setDefaultNetworkTier";

            /// <summary>Initializes SetDefaultNetworkTier parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Enables the usage export feature and sets the usage export bucket where reports are stored. If you provide
        /// an empty request body using this method, the usage export feature will be disabled.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual SetUsageExportBucketRequest SetUsageExportBucket(Google.Apis.Compute.v1.Data.UsageExportLocation body, string project)
        {
            return new SetUsageExportBucketRequest(service, body, project);
        }

        /// <summary>
        /// Enables the usage export feature and sets the usage export bucket where reports are stored. If you provide
        /// an empty request body using this method, the usage export feature will be disabled.
        /// </summary>
        public class SetUsageExportBucketRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetUsageExportBucket request.</summary>
            public SetUsageExportBucketRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.UsageExportLocation body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.UsageExportLocation Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setUsageExportBucket";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/setUsageExportBucket";

            /// <summary>Initializes SetUsageExportBucket parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionAutoscalers" collection of methods.</summary>
    public class RegionAutoscalersResource
    {
        private const string Resource = "regionAutoscalers";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionAutoscalersResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified autoscaler.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="autoscaler">Name of the autoscaler to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string autoscaler)
        {
            return new DeleteRequest(service, project, region, autoscaler);
        }

        /// <summary>Deletes the specified autoscaler.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string autoscaler) : base(service)
            {
                Project = project;
                Region = region;
                Autoscaler = autoscaler;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the autoscaler to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("autoscaler", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Autoscaler { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/autoscalers/{autoscaler}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("autoscaler", new Google.Apis.Discovery.Parameter
                {
                    Name = "autoscaler",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified autoscaler.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="autoscaler">Name of the autoscaler to return.</param>
        public virtual GetRequest Get(string project, string region, string autoscaler)
        {
            return new GetRequest(service, project, region, autoscaler);
        }

        /// <summary>Returns the specified autoscaler.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Autoscaler>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string autoscaler) : base(service)
            {
                Project = project;
                Region = region;
                Autoscaler = autoscaler;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the autoscaler to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("autoscaler", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Autoscaler { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/autoscalers/{autoscaler}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("autoscaler", new Google.Apis.Discovery.Parameter
                {
                    Name = "autoscaler",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Creates an autoscaler in the specified project using the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Autoscaler body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>Creates an autoscaler in the specified project using the data included in the request.</summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Autoscaler body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Autoscaler Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/autoscalers";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of autoscalers contained within the specified region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves a list of autoscalers contained within the specified region.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RegionAutoscalerList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/autoscalers";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates an autoscaler in the specified project using the data included in the request. This method supports
        /// PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.Autoscaler body, string project, string region)
        {
            return new PatchRequest(service, body, project, region);
        }

        /// <summary>
        /// Updates an autoscaler in the specified project using the data included in the request. This method supports
        /// PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Autoscaler body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the autoscaler to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("autoscaler", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Autoscaler { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Autoscaler Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/autoscalers";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("autoscaler", new Google.Apis.Discovery.Parameter
                {
                    Name = "autoscaler",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Updates an autoscaler in the specified project using the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.Autoscaler body, string project, string region)
        {
            return new UpdateRequest(service, body, project, region);
        }

        /// <summary>Updates an autoscaler in the specified project using the data included in the request.</summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Autoscaler body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the autoscaler to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("autoscaler", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Autoscaler { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Autoscaler Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/autoscalers";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("autoscaler", new Google.Apis.Discovery.Parameter
                {
                    Name = "autoscaler",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionBackendServices" collection of methods.</summary>
    public class RegionBackendServicesResource
    {
        private const string Resource = "regionBackendServices";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionBackendServicesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified regional BackendService resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="backendService">Name of the BackendService resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string backendService)
        {
            return new DeleteRequest(service, project, region, backendService);
        }

        /// <summary>Deletes the specified regional BackendService resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string backendService) : base(service)
            {
                Project = project;
                Region = region;
                BackendService = backendService;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the BackendService resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendService { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/backendServices/{backendService}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("backendService", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified regional BackendService resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="backendService">Name of the BackendService resource to return.</param>
        public virtual GetRequest Get(string project, string region, string backendService)
        {
            return new GetRequest(service, project, region, backendService);
        }

        /// <summary>Returns the specified regional BackendService resource.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.BackendService>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string backendService) : base(service)
            {
                Project = project;
                Region = region;
                BackendService = backendService;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the BackendService resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendService { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/backendServices/{backendService}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("backendService", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Gets the most recent health check results for this regional BackendService.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project"><c>null</c></param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="backendService">Name of the BackendService resource for which to get health.</param>
        public virtual GetHealthRequest GetHealth(Google.Apis.Compute.v1.Data.ResourceGroupReference body, string project, string region, string backendService)
        {
            return new GetHealthRequest(service, body, project, region, backendService);
        }

        /// <summary>Gets the most recent health check results for this regional BackendService.</summary>
        public class GetHealthRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.BackendServiceGroupHealth>
        {
            /// <summary>Constructs a new GetHealth request.</summary>
            public GetHealthRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ResourceGroupReference body, string project, string region, string backendService) : base(service)
            {
                Project = project;
                Region = region;
                BackendService = backendService;
                Body = body;
                InitParameters();
            }

            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the BackendService resource for which to get health.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendService { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ResourceGroupReference Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getHealth";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/backendServices/{backendService}/getHealth";

            /// <summary>Initializes GetHealth parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("backendService", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a regional BackendService resource in the specified project using the data included in the request.
        /// For more information, see  Backend services overview.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.BackendService body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a regional BackendService resource in the specified project using the data included in the request.
        /// For more information, see  Backend services overview.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.BackendService body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.BackendService Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/backendServices";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves the list of regional BackendService resources available to the specified project in the given
        /// region.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>
        /// Retrieves the list of regional BackendService resources available to the specified project in the given
        /// region.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.BackendServiceList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/backendServices";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the specified regional BackendService resource with the data included in the request. For more
        /// information, see  Understanding backend services This method supports PATCH semantics and uses the JSON
        /// merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="backendService">Name of the BackendService resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.BackendService body, string project, string region, string backendService)
        {
            return new PatchRequest(service, body, project, region, backendService);
        }

        /// <summary>
        /// Updates the specified regional BackendService resource with the data included in the request. For more
        /// information, see  Understanding backend services This method supports PATCH semantics and uses the JSON
        /// merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.BackendService body, string project, string region, string backendService) : base(service)
            {
                Project = project;
                Region = region;
                BackendService = backendService;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the BackendService resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendService { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.BackendService Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/backendServices/{backendService}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("backendService", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the specified regional BackendService resource with the data included in the request. For more
        /// information, see  Backend services overview.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="backendService">Name of the BackendService resource to update.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.BackendService body, string project, string region, string backendService)
        {
            return new UpdateRequest(service, body, project, region, backendService);
        }

        /// <summary>
        /// Updates the specified regional BackendService resource with the data included in the request. For more
        /// information, see  Backend services overview.
        /// </summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.BackendService body, string project, string region, string backendService) : base(service)
            {
                Project = project;
                Region = region;
                BackendService = backendService;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the BackendService resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("backendService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string BackendService { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.BackendService Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/backendServices/{backendService}";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("backendService", new Google.Apis.Discovery.Parameter
                {
                    Name = "backendService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionCommitments" collection of methods.</summary>
    public class RegionCommitmentsResource
    {
        private const string Resource = "regionCommitments";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionCommitmentsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of commitments.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of commitments.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.CommitmentAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/commitments";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified commitment resource. Gets a list of available commitments by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="commitment">Name of the commitment to return.</param>
        public virtual GetRequest Get(string project, string region, string commitment)
        {
            return new GetRequest(service, project, region, commitment);
        }

        /// <summary>
        /// Returns the specified commitment resource. Gets a list of available commitments by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Commitment>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string commitment) : base(service)
            {
                Project = project;
                Region = region;
                Commitment = commitment;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the commitment to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("commitment", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Commitment { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/commitments/{commitment}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("commitment", new Google.Apis.Discovery.Parameter
                {
                    Name = "commitment",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Creates a commitment in the specified project using the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Commitment body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>Creates a commitment in the specified project using the data included in the request.</summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Commitment body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Commitment Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/commitments";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of commitments contained within the specified region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves a list of commitments contained within the specified region.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.CommitmentList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/commitments";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionDiskTypes" collection of methods.</summary>
    public class RegionDiskTypesResource
    {
        private const string Resource = "regionDiskTypes";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionDiskTypesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Returns the specified regional disk type. Gets a list of available disk types by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="diskType">Name of the disk type to return.</param>
        public virtual GetRequest Get(string project, string region, string diskType)
        {
            return new GetRequest(service, project, region, diskType);
        }

        /// <summary>
        /// Returns the specified regional disk type. Gets a list of available disk types by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.DiskType>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string diskType) : base(service)
            {
                Project = project;
                Region = region;
                DiskType = diskType;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the disk type to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("diskType", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string DiskType { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/diskTypes/{diskType}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("diskType", new Google.Apis.Discovery.Parameter
                {
                    Name = "diskType",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves a list of regional disk types available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves a list of regional disk types available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RegionDiskTypeList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/diskTypes";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionDisks" collection of methods.</summary>
    public class RegionDisksResource
    {
        private const string Resource = "regionDisks";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionDisksResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Adds existing resource policies to a regional disk. You can only add one policy which will be applied to
        /// this disk for scheduling snapshot creation.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="disk">The disk name for this request.</param>
        public virtual AddResourcePoliciesRequest AddResourcePolicies(Google.Apis.Compute.v1.Data.RegionDisksAddResourcePoliciesRequest body, string project, string region, string disk)
        {
            return new AddResourcePoliciesRequest(service, body, project, region, disk);
        }

        /// <summary>
        /// Adds existing resource policies to a regional disk. You can only add one policy which will be applied to
        /// this disk for scheduling snapshot creation.
        /// </summary>
        public class AddResourcePoliciesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddResourcePolicies request.</summary>
            public AddResourcePoliciesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionDisksAddResourcePoliciesRequest body, string project, string region, string disk) : base(service)
            {
                Project = project;
                Region = region;
                Disk = disk;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The disk name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("disk", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Disk { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionDisksAddResourcePoliciesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addResourcePolicies";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/disks/{disk}/addResourcePolicies";

            /// <summary>Initializes AddResourcePolicies parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("disk", new Google.Apis.Discovery.Parameter
                {
                    Name = "disk",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Creates a snapshot of this regional disk.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="disk">Name of the regional persistent disk to snapshot.</param>
        public virtual CreateSnapshotRequest CreateSnapshot(Google.Apis.Compute.v1.Data.Snapshot body, string project, string region, string disk)
        {
            return new CreateSnapshotRequest(service, body, project, region, disk);
        }

        /// <summary>Creates a snapshot of this regional disk.</summary>
        public class CreateSnapshotRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new CreateSnapshot request.</summary>
            public CreateSnapshotRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Snapshot body, string project, string region, string disk) : base(service)
            {
                Project = project;
                Region = region;
                Disk = disk;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the regional persistent disk to snapshot.</summary>
            [Google.Apis.Util.RequestParameterAttribute("disk", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Disk { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Snapshot Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "createSnapshot";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/disks/{disk}/createSnapshot";

            /// <summary>Initializes CreateSnapshot parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("disk", new Google.Apis.Discovery.Parameter
                {
                    Name = "disk",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Deletes the specified regional persistent disk. Deleting a regional disk removes all the replicas of its
        /// data permanently and is irreversible. However, deleting a disk does not delete any snapshots previously made
        /// from the disk. You must separately delete snapshots.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="disk">Name of the regional persistent disk to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string disk)
        {
            return new DeleteRequest(service, project, region, disk);
        }

        /// <summary>
        /// Deletes the specified regional persistent disk. Deleting a regional disk removes all the replicas of its
        /// data permanently and is irreversible. However, deleting a disk does not delete any snapshots previously made
        /// from the disk. You must separately delete snapshots.
        /// </summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string disk) : base(service)
            {
                Project = project;
                Region = region;
                Disk = disk;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the regional persistent disk to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("disk", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Disk { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/disks/{disk}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("disk", new Google.Apis.Discovery.Parameter
                {
                    Name = "disk",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns a specified regional persistent disk.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="disk">Name of the regional persistent disk to return.</param>
        public virtual GetRequest Get(string project, string region, string disk)
        {
            return new GetRequest(service, project, region, disk);
        }

        /// <summary>Returns a specified regional persistent disk.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Disk>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string disk) : base(service)
            {
                Project = project;
                Region = region;
                Disk = disk;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the regional persistent disk to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("disk", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Disk { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/disks/{disk}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("disk", new Google.Apis.Discovery.Parameter
                {
                    Name = "disk",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual GetIamPolicyRequest GetIamPolicy(string project, string region, string resource)
        {
            return new GetIamPolicyRequest(service, project, region, resource);
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        public class GetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new GetIamPolicy request.</summary>
            public GetIamPolicyRequest(Google.Apis.Services.IClientService service, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Requested IAM Policy version.</summary>
            [Google.Apis.Util.RequestParameterAttribute("optionsRequestedPolicyVersion", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> OptionsRequestedPolicyVersion { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/disks/{resource}/getIamPolicy";

            /// <summary>Initializes GetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("optionsRequestedPolicyVersion", new Google.Apis.Discovery.Parameter
                {
                    Name = "optionsRequestedPolicyVersion",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates a persistent regional disk in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Disk body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a persistent regional disk in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Disk body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Source image to restore onto a disk. This field is optional.</summary>
            [Google.Apis.Util.RequestParameterAttribute("sourceImage", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string SourceImage { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Disk Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/disks";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("sourceImage", new Google.Apis.Discovery.Parameter
                {
                    Name = "sourceImage",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of persistent disks contained within the specified region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves the list of persistent disks contained within the specified region.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.DiskList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/disks";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Removes resource policies from a regional disk.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="disk">The disk name for this request.</param>
        public virtual RemoveResourcePoliciesRequest RemoveResourcePolicies(Google.Apis.Compute.v1.Data.RegionDisksRemoveResourcePoliciesRequest body, string project, string region, string disk)
        {
            return new RemoveResourcePoliciesRequest(service, body, project, region, disk);
        }

        /// <summary>Removes resource policies from a regional disk.</summary>
        public class RemoveResourcePoliciesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new RemoveResourcePolicies request.</summary>
            public RemoveResourcePoliciesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionDisksRemoveResourcePoliciesRequest body, string project, string region, string disk) : base(service)
            {
                Project = project;
                Region = region;
                Disk = disk;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The disk name for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("disk", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Disk { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionDisksRemoveResourcePoliciesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "removeResourcePolicies";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/disks/{disk}/removeResourcePolicies";

            /// <summary>Initializes RemoveResourcePolicies parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("disk", new Google.Apis.Discovery.Parameter
                {
                    Name = "disk",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Resizes the specified regional persistent disk.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">The project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="disk">Name of the regional persistent disk.</param>
        public virtual ResizeRequest Resize(Google.Apis.Compute.v1.Data.RegionDisksResizeRequest body, string project, string region, string disk)
        {
            return new ResizeRequest(service, body, project, region, disk);
        }

        /// <summary>Resizes the specified regional persistent disk.</summary>
        public class ResizeRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Resize request.</summary>
            public ResizeRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionDisksResizeRequest body, string project, string region, string disk) : base(service)
            {
                Project = project;
                Region = region;
                Disk = disk;
                Body = body;
                InitParameters();
            }

            /// <summary>The project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the regional persistent disk.</summary>
            [Google.Apis.Util.RequestParameterAttribute("disk", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Disk { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionDisksResizeRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "resize";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/disks/{disk}/resize";

            /// <summary>Initializes Resize parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("disk", new Google.Apis.Discovery.Parameter
                {
                    Name = "disk",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetIamPolicyRequest SetIamPolicy(Google.Apis.Compute.v1.Data.RegionSetPolicyRequest body, string project, string region, string resource)
        {
            return new SetIamPolicyRequest(service, body, project, region, resource);
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        public class SetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new SetIamPolicy request.</summary>
            public SetIamPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionSetPolicyRequest body, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionSetPolicyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/disks/{resource}/setIamPolicy";

            /// <summary>Initializes SetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Sets the labels on the target regional disk.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetLabelsRequest SetLabels(Google.Apis.Compute.v1.Data.RegionSetLabelsRequest body, string project, string region, string resource)
        {
            return new SetLabelsRequest(service, body, project, region, resource);
        }

        /// <summary>Sets the labels on the target regional disk.</summary>
        public class SetLabelsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetLabels request.</summary>
            public SetLabelsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionSetLabelsRequest body, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionSetLabelsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setLabels";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/disks/{resource}/setLabels";

            /// <summary>Initializes SetLabels parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string region, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, region, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/disks/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "regionHealthCheckServices" collection of methods.</summary>
    public class RegionHealthCheckServicesResource
    {
        private const string Resource = "regionHealthCheckServices";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionHealthCheckServicesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified regional HealthCheckService.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="healthCheckService">
        /// Name of the HealthCheckService to delete. The name must be 1-63 characters long, and comply with RFC1035.
        /// </param>
        public virtual DeleteRequest Delete(string project, string region, string healthCheckService)
        {
            return new DeleteRequest(service, project, region, healthCheckService);
        }

        /// <summary>Deletes the specified regional HealthCheckService.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string healthCheckService) : base(service)
            {
                Project = project;
                Region = region;
                HealthCheckService = healthCheckService;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// Name of the HealthCheckService to delete. The name must be 1-63 characters long, and comply with
            /// RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("healthCheckService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HealthCheckService { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/healthCheckServices/{healthCheckService}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("healthCheckService", new Google.Apis.Discovery.Parameter
                {
                    Name = "healthCheckService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified regional HealthCheckService resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="healthCheckService">
        /// Name of the HealthCheckService to update. The name must be 1-63 characters long, and comply with RFC1035.
        /// </param>
        public virtual GetRequest Get(string project, string region, string healthCheckService)
        {
            return new GetRequest(service, project, region, healthCheckService);
        }

        /// <summary>Returns the specified regional HealthCheckService resource.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.HealthCheckService>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string healthCheckService) : base(service)
            {
                Project = project;
                Region = region;
                HealthCheckService = healthCheckService;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// Name of the HealthCheckService to update. The name must be 1-63 characters long, and comply with
            /// RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("healthCheckService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HealthCheckService { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/healthCheckServices/{healthCheckService}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("healthCheckService", new Google.Apis.Discovery.Parameter
                {
                    Name = "healthCheckService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates a regional HealthCheckService resource in the specified project and region using the data included
        /// in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.HealthCheckService body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a regional HealthCheckService resource in the specified project and region using the data included
        /// in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HealthCheckService body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HealthCheckService Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/healthCheckServices";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Lists all the HealthCheckService resources that have been configured for the specified project in the given
        /// region.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>
        /// Lists all the HealthCheckService resources that have been configured for the specified project in the given
        /// region.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.HealthCheckServicesList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/healthCheckServices";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates the specified regional HealthCheckService resource with the data included in the request. This
        /// method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="healthCheckService">
        /// Name of the HealthCheckService to update. The name must be 1-63 characters long, and comply with RFC1035.
        /// </param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.HealthCheckService body, string project, string region, string healthCheckService)
        {
            return new PatchRequest(service, body, project, region, healthCheckService);
        }

        /// <summary>
        /// Updates the specified regional HealthCheckService resource with the data included in the request. This
        /// method supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HealthCheckService body, string project, string region, string healthCheckService) : base(service)
            {
                Project = project;
                Region = region;
                HealthCheckService = healthCheckService;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// Name of the HealthCheckService to update. The name must be 1-63 characters long, and comply with
            /// RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("healthCheckService", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HealthCheckService { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HealthCheckService Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/healthCheckServices/{healthCheckService}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("healthCheckService", new Google.Apis.Discovery.Parameter
                {
                    Name = "healthCheckService",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionHealthChecks" collection of methods.</summary>
    public class RegionHealthChecksResource
    {
        private const string Resource = "regionHealthChecks";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionHealthChecksResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified HealthCheck resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="healthCheck">Name of the HealthCheck resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string healthCheck)
        {
            return new DeleteRequest(service, project, region, healthCheck);
        }

        /// <summary>Deletes the specified HealthCheck resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string healthCheck) : base(service)
            {
                Project = project;
                Region = region;
                HealthCheck = healthCheck;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the HealthCheck resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("healthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HealthCheck { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/healthChecks/{healthCheck}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("healthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "healthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified HealthCheck resource. Gets a list of available health checks by making a list()
        /// request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="healthCheck">Name of the HealthCheck resource to return.</param>
        public virtual GetRequest Get(string project, string region, string healthCheck)
        {
            return new GetRequest(service, project, region, healthCheck);
        }

        /// <summary>
        /// Returns the specified HealthCheck resource. Gets a list of available health checks by making a list()
        /// request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.HealthCheck>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string healthCheck) : base(service)
            {
                Project = project;
                Region = region;
                HealthCheck = healthCheck;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the HealthCheck resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("healthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HealthCheck { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/healthChecks/{healthCheck}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("healthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "healthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a HealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.HealthCheck body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a HealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HealthCheck body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HealthCheck Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/healthChecks";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of HealthCheck resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves the list of HealthCheck resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.HealthCheckList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/healthChecks";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates a HealthCheck resource in the specified project using the data included in the request. This method
        /// supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="healthCheck">Name of the HealthCheck resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.HealthCheck body, string project, string region, string healthCheck)
        {
            return new PatchRequest(service, body, project, region, healthCheck);
        }

        /// <summary>
        /// Updates a HealthCheck resource in the specified project using the data included in the request. This method
        /// supports PATCH semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HealthCheck body, string project, string region, string healthCheck) : base(service)
            {
                Project = project;
                Region = region;
                HealthCheck = healthCheck;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the HealthCheck resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("healthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HealthCheck { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HealthCheck Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/healthChecks/{healthCheck}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("healthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "healthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates a HealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="healthCheck">Name of the HealthCheck resource to update.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.HealthCheck body, string project, string region, string healthCheck)
        {
            return new UpdateRequest(service, body, project, region, healthCheck);
        }

        /// <summary>
        /// Updates a HealthCheck resource in the specified project using the data included in the request.
        /// </summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.HealthCheck body, string project, string region, string healthCheck) : base(service)
            {
                Project = project;
                Region = region;
                HealthCheck = healthCheck;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the HealthCheck resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("healthCheck", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string HealthCheck { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.HealthCheck Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/healthChecks/{healthCheck}";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("healthCheck", new Google.Apis.Discovery.Parameter
                {
                    Name = "healthCheck",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionInstanceGroupManagers" collection of methods.</summary>
    public class RegionInstanceGroupManagersResource
    {
        private const string Resource = "regionInstanceGroupManagers";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionInstanceGroupManagersResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Flags the specified instances to be immediately removed from the managed instance group. Abandoning an
        /// instance does not delete the instance, but it does remove the instance from any target pools that are
        /// applied by the managed instance group. This method reduces the targetSize of the managed instance group by
        /// the number of instances that you abandon. This operation is marked as DONE when the action is scheduled even
        /// if the instances have not yet been removed from the group. You must separately verify the status of the
        /// abandoning action with the listmanagedinstances method.  If the group is part of a backend service that has
        /// enabled connection draining, it can take up to 60 seconds after the connection draining duration has elapsed
        /// before the VM instance is removed or deleted.  You can specify a maximum of 1000 instances with this method
        /// per request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="instanceGroupManager">Name of the managed instance group.</param>
        public virtual AbandonInstancesRequest AbandonInstances(Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersAbandonInstancesRequest body, string project, string region, string instanceGroupManager)
        {
            return new AbandonInstancesRequest(service, body, project, region, instanceGroupManager);
        }

        /// <summary>
        /// Flags the specified instances to be immediately removed from the managed instance group. Abandoning an
        /// instance does not delete the instance, but it does remove the instance from any target pools that are
        /// applied by the managed instance group. This method reduces the targetSize of the managed instance group by
        /// the number of instances that you abandon. This operation is marked as DONE when the action is scheduled even
        /// if the instances have not yet been removed from the group. You must separately verify the status of the
        /// abandoning action with the listmanagedinstances method.  If the group is part of a backend service that has
        /// enabled connection draining, it can take up to 60 seconds after the connection draining duration has elapsed
        /// before the VM instance is removed or deleted.  You can specify a maximum of 1000 instances with this method
        /// per request.
        /// </summary>
        public class AbandonInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AbandonInstances request.</summary>
            public AbandonInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersAbandonInstancesRequest body, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersAbandonInstancesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "abandonInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/abandonInstances";

            /// <summary>Initializes AbandonInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Apply updates to selected instances the managed instance group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request, should conform to RFC1035.</param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group, should conform to RFC1035.
        /// </param>
        public virtual ApplyUpdatesToInstancesRequest ApplyUpdatesToInstances(Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersApplyUpdatesRequest body, string project, string region, string instanceGroupManager)
        {
            return new ApplyUpdatesToInstancesRequest(service, body, project, region, instanceGroupManager);
        }

        /// <summary>Apply updates to selected instances the managed instance group.</summary>
        public class ApplyUpdatesToInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new ApplyUpdatesToInstances request.</summary>
            public ApplyUpdatesToInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersApplyUpdatesRequest body, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request, should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The name of the managed instance group, should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersApplyUpdatesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "applyUpdatesToInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/applyUpdatesToInstances";

            /// <summary>Initializes ApplyUpdatesToInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates instances with per-instance configs in this regional managed instance group. Instances are created
        /// using the current instance template. The create instances operation is marked DONE if the createInstances
        /// request is successful. The underlying actions take additional time. You must separately verify the status of
        /// the creating or actions with the listmanagedinstances method.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">
        /// The name of the region where the managed instance group is located. It should conform to RFC1035.
        /// </param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group. It should conform to RFC1035.
        /// </param>
        public virtual CreateInstancesRequest CreateInstances(Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersCreateInstancesRequest body, string project, string region, string instanceGroupManager)
        {
            return new CreateInstancesRequest(service, body, project, region, instanceGroupManager);
        }

        /// <summary>
        /// Creates instances with per-instance configs in this regional managed instance group. Instances are created
        /// using the current instance template. The create instances operation is marked DONE if the createInstances
        /// request is successful. The underlying actions take additional time. You must separately verify the status of
        /// the creating or actions with the listmanagedinstances method.
        /// </summary>
        public class CreateInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new CreateInstances request.</summary>
            public CreateInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersCreateInstancesRequest body, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the region where the managed instance group is located. It should conform to RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The name of the managed instance group. It should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request.  The request ID must be a valid UUID with
            /// the exception that zero UUID is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersCreateInstancesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "createInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/createInstances";

            /// <summary>Initializes CreateInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified managed instance group and all of the instances in that group.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="instanceGroupManager">Name of the managed instance group to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string instanceGroupManager)
        {
            return new DeleteRequest(service, project, region, instanceGroupManager);
        }

        /// <summary>Deletes the specified managed instance group and all of the instances in that group.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the managed instance group to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Flags the specified instances in the managed instance group to be immediately deleted. The instances are
        /// also removed from any target pools of which they were a member. This method reduces the targetSize of the
        /// managed instance group by the number of instances that you delete. The deleteInstances operation is marked
        /// DONE if the deleteInstances request is successful. The underlying actions take additional time. You must
        /// separately verify the status of the deleting action with the listmanagedinstances method.  If the group is
        /// part of a backend service that has enabled connection draining, it can take up to 60 seconds after the
        /// connection draining duration has elapsed before the VM instance is removed or deleted.  You can specify a
        /// maximum of 1000 instances with this method per request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="instanceGroupManager">Name of the managed instance group.</param>
        public virtual DeleteInstancesRequest DeleteInstances(Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersDeleteInstancesRequest body, string project, string region, string instanceGroupManager)
        {
            return new DeleteInstancesRequest(service, body, project, region, instanceGroupManager);
        }

        /// <summary>
        /// Flags the specified instances in the managed instance group to be immediately deleted. The instances are
        /// also removed from any target pools of which they were a member. This method reduces the targetSize of the
        /// managed instance group by the number of instances that you delete. The deleteInstances operation is marked
        /// DONE if the deleteInstances request is successful. The underlying actions take additional time. You must
        /// separately verify the status of the deleting action with the listmanagedinstances method.  If the group is
        /// part of a backend service that has enabled connection draining, it can take up to 60 seconds after the
        /// connection draining duration has elapsed before the VM instance is removed or deleted.  You can specify a
        /// maximum of 1000 instances with this method per request.
        /// </summary>
        public class DeleteInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new DeleteInstances request.</summary>
            public DeleteInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersDeleteInstancesRequest body, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersDeleteInstancesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "deleteInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/deleteInstances";

            /// <summary>Initializes DeleteInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes selected per-instance configs for the managed instance group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request, should conform to RFC1035.</param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group. It should conform to RFC1035.
        /// </param>
        public virtual DeletePerInstanceConfigsRequest DeletePerInstanceConfigs(Google.Apis.Compute.v1.Data.RegionInstanceGroupManagerDeleteInstanceConfigReq body, string project, string region, string instanceGroupManager)
        {
            return new DeletePerInstanceConfigsRequest(service, body, project, region, instanceGroupManager);
        }

        /// <summary>Deletes selected per-instance configs for the managed instance group.</summary>
        public class DeletePerInstanceConfigsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new DeletePerInstanceConfigs request.</summary>
            public DeletePerInstanceConfigsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionInstanceGroupManagerDeleteInstanceConfigReq body, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request, should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The name of the managed instance group. It should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionInstanceGroupManagerDeleteInstanceConfigReq Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "deletePerInstanceConfigs";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/deletePerInstanceConfigs";

            /// <summary>Initializes DeletePerInstanceConfigs parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns all of the details about the specified managed instance group.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="instanceGroupManager">Name of the managed instance group to return.</param>
        public virtual GetRequest Get(string project, string region, string instanceGroupManager)
        {
            return new GetRequest(service, project, region, instanceGroupManager);
        }

        /// <summary>Returns all of the details about the specified managed instance group.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceGroupManager>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the managed instance group to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates a managed instance group using the information that you specify in the request. After the group is
        /// created, instances in the group are created using the specified instance template. This operation is marked
        /// as DONE when the group is created even if the instances in the group have not yet been created. You must
        /// separately verify the status of the individual instances with the listmanagedinstances method.  A regional
        /// managed instance group can contain up to 2000 instances.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.InstanceGroupManager body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a managed instance group using the information that you specify in the request. After the group is
        /// created, instances in the group are created using the specified instance template. This operation is marked
        /// as DONE when the group is created even if the instances in the group have not yet been created. You must
        /// separately verify the status of the individual instances with the listmanagedinstances method.  A regional
        /// managed instance group can contain up to 2000 instances.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManager body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManager Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves the list of managed instance groups that are contained within the specified region.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>
        /// Retrieves the list of managed instance groups that are contained within the specified region.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RegionInstanceGroupManagerList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Lists all errors thrown by actions on instances for a given regional managed instance group. The filter and
        /// orderBy query parameters are not supported.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request. This should conform to RFC1035.</param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group. It must be a string that meets the requirements in RFC1035, or an
        /// unsigned long integer: must match regexp pattern: (?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?)|[1-9][0-9]{0,19}.
        /// </param>
        public virtual ListErrorsRequest ListErrors(string project, string region, string instanceGroupManager)
        {
            return new ListErrorsRequest(service, project, region, instanceGroupManager);
        }

        /// <summary>
        /// Lists all errors thrown by actions on instances for a given regional managed instance group. The filter and
        /// orderBy query parameters are not supported.
        /// </summary>
        public class ListErrorsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersListErrorsResponse>
        {
            /// <summary>Constructs a new ListErrors request.</summary>
            public ListErrorsRequest(Google.Apis.Services.IClientService service, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request. This should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// The name of the managed instance group. It must be a string that meets the requirements in RFC1035, or
            /// an unsigned long integer: must match regexp pattern:
            /// (?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?)|[1-9][0-9]{0,19}.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listErrors";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/listErrors";

            /// <summary>Initializes ListErrors parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Lists the instances in the managed instance group and instances that are scheduled to be created. The list
        /// includes any current actions that the group has scheduled for its instances. The orderBy query parameter is
        /// not supported.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="instanceGroupManager">The name of the managed instance group.</param>
        public virtual ListManagedInstancesRequest ListManagedInstances(string project, string region, string instanceGroupManager)
        {
            return new ListManagedInstancesRequest(service, project, region, instanceGroupManager);
        }

        /// <summary>
        /// Lists the instances in the managed instance group and instances that are scheduled to be created. The list
        /// includes any current actions that the group has scheduled for its instances. The orderBy query parameter is
        /// not supported.
        /// </summary>
        public class ListManagedInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersListInstancesResponse>
        {
            /// <summary>Constructs a new ListManagedInstances request.</summary>
            public ListManagedInstancesRequest(Google.Apis.Services.IClientService service, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listManagedInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/listManagedInstances";

            /// <summary>Initializes ListManagedInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Lists all of the per-instance configs defined for the managed instance group. The orderBy query parameter is
        /// not supported.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request, should conform to RFC1035.</param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group. It should conform to RFC1035.
        /// </param>
        public virtual ListPerInstanceConfigsRequest ListPerInstanceConfigs(string project, string region, string instanceGroupManager)
        {
            return new ListPerInstanceConfigsRequest(service, project, region, instanceGroupManager);
        }

        /// <summary>
        /// Lists all of the per-instance configs defined for the managed instance group. The orderBy query parameter is
        /// not supported.
        /// </summary>
        public class ListPerInstanceConfigsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersListInstanceConfigsResp>
        {
            /// <summary>Constructs a new ListPerInstanceConfigs request.</summary>
            public ListPerInstanceConfigsRequest(Google.Apis.Services.IClientService service, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request, should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The name of the managed instance group. It should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listPerInstanceConfigs";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/listPerInstanceConfigs";

            /// <summary>Initializes ListPerInstanceConfigs parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Updates a managed instance group using the information that you specify in the request. This operation is
        /// marked as DONE when the group is patched even if the instances in the group are still in the process of
        /// being patched. You must separately verify the status of the individual instances with the
        /// listmanagedinstances method. This method supports PATCH semantics and uses the JSON merge patch format and
        /// processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="instanceGroupManager">The name of the instance group manager.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.InstanceGroupManager body, string project, string region, string instanceGroupManager)
        {
            return new PatchRequest(service, body, project, region, instanceGroupManager);
        }

        /// <summary>
        /// Updates a managed instance group using the information that you specify in the request. This operation is
        /// marked as DONE when the group is patched even if the instances in the group are still in the process of
        /// being patched. You must separately verify the status of the individual instances with the
        /// listmanagedinstances method. This method supports PATCH semantics and uses the JSON merge patch format and
        /// processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceGroupManager body, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The name of the instance group manager.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceGroupManager Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Inserts or patches per-instance configs for the managed instance group. perInstanceConfig.name serves as a
        /// key used to distinguish whether to perform insert or patch.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request, should conform to RFC1035.</param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group. It should conform to RFC1035.
        /// </param>
        public virtual PatchPerInstanceConfigsRequest PatchPerInstanceConfigs(Google.Apis.Compute.v1.Data.RegionInstanceGroupManagerPatchInstanceConfigReq body, string project, string region, string instanceGroupManager)
        {
            return new PatchPerInstanceConfigsRequest(service, body, project, region, instanceGroupManager);
        }

        /// <summary>
        /// Inserts or patches per-instance configs for the managed instance group. perInstanceConfig.name serves as a
        /// key used to distinguish whether to perform insert or patch.
        /// </summary>
        public class PatchPerInstanceConfigsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new PatchPerInstanceConfigs request.</summary>
            public PatchPerInstanceConfigsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionInstanceGroupManagerPatchInstanceConfigReq body, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request, should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The name of the managed instance group. It should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionInstanceGroupManagerPatchInstanceConfigReq Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patchPerInstanceConfigs";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/patchPerInstanceConfigs";

            /// <summary>Initializes PatchPerInstanceConfigs parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Flags the specified instances in the managed instance group to be immediately recreated. The instances are
        /// deleted and recreated using the current instance template for the managed instance group. This operation is
        /// marked as DONE when the flag is set even if the instances have not yet been recreated. You must separately
        /// verify the status of the recreating action with the listmanagedinstances method.  If the group is part of a
        /// backend service that has enabled connection draining, it can take up to 60 seconds after the connection
        /// draining duration has elapsed before the VM instance is removed or deleted.  You can specify a maximum of
        /// 1000 instances with this method per request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="instanceGroupManager">Name of the managed instance group.</param>
        public virtual RecreateInstancesRequest RecreateInstances(Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersRecreateRequest body, string project, string region, string instanceGroupManager)
        {
            return new RecreateInstancesRequest(service, body, project, region, instanceGroupManager);
        }

        /// <summary>
        /// Flags the specified instances in the managed instance group to be immediately recreated. The instances are
        /// deleted and recreated using the current instance template for the managed instance group. This operation is
        /// marked as DONE when the flag is set even if the instances have not yet been recreated. You must separately
        /// verify the status of the recreating action with the listmanagedinstances method.  If the group is part of a
        /// backend service that has enabled connection draining, it can take up to 60 seconds after the connection
        /// draining duration has elapsed before the VM instance is removed or deleted.  You can specify a maximum of
        /// 1000 instances with this method per request.
        /// </summary>
        public class RecreateInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new RecreateInstances request.</summary>
            public RecreateInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersRecreateRequest body, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersRecreateRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "recreateInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/recreateInstances";

            /// <summary>Initializes RecreateInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Changes the intended size of the managed instance group. If you increase the size, the group creates new
        /// instances using the current instance template. If you decrease the size, the group deletes one or more
        /// instances.  The resize operation is marked DONE if the resize request is successful. The underlying actions
        /// take additional time. You must separately verify the status of the creating or deleting actions with the
        /// listmanagedinstances method.  If the group is part of a backend service that has enabled connection
        /// draining, it can take up to 60 seconds after the connection draining duration has elapsed before the VM
        /// instance is removed or deleted.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="instanceGroupManager">Name of the managed instance group.</param>
        /// <param name="size">Number of instances that should exist in this instance group manager.</param>
        public virtual ResizeRequest Resize(string project, string region, string instanceGroupManager, int size)
        {
            return new ResizeRequest(service, project, region, instanceGroupManager, size);
        }

        /// <summary>
        /// Changes the intended size of the managed instance group. If you increase the size, the group creates new
        /// instances using the current instance template. If you decrease the size, the group deletes one or more
        /// instances.  The resize operation is marked DONE if the resize request is successful. The underlying actions
        /// take additional time. You must separately verify the status of the creating or deleting actions with the
        /// listmanagedinstances method.  If the group is part of a backend service that has enabled connection
        /// draining, it can take up to 60 seconds after the connection draining duration has elapsed before the VM
        /// instance is removed or deleted.
        /// </summary>
        public class ResizeRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Resize request.</summary>
            public ResizeRequest(Google.Apis.Services.IClientService service, string project, string region, string instanceGroupManager, int size) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                Size = size;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>Number of instances that should exist in this instance group manager.</summary>
            [Google.Apis.Util.RequestParameterAttribute("size", Google.Apis.Util.RequestParameterType.Query)]
            public virtual int Size { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "resize";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/resize";

            /// <summary>Initializes Resize parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("size", new Google.Apis.Discovery.Parameter
                {
                    Name = "size",
                    IsRequired = true,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets the instance template to use when creating new instances or recreating instances in this group.
        /// Existing instances are not affected.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="instanceGroupManager">The name of the managed instance group.</param>
        public virtual SetInstanceTemplateRequest SetInstanceTemplate(Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersSetTemplateRequest body, string project, string region, string instanceGroupManager)
        {
            return new SetInstanceTemplateRequest(service, body, project, region, instanceGroupManager);
        }

        /// <summary>
        /// Sets the instance template to use when creating new instances or recreating instances in this group.
        /// Existing instances are not affected.
        /// </summary>
        public class SetInstanceTemplateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetInstanceTemplate request.</summary>
            public SetInstanceTemplateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersSetTemplateRequest body, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersSetTemplateRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setInstanceTemplate";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/setInstanceTemplate";

            /// <summary>Initializes SetInstanceTemplate parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Modifies the target pools to which all new instances in this group are assigned. Existing instances in the
        /// group are not affected.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="instanceGroupManager">Name of the managed instance group.</param>
        public virtual SetTargetPoolsRequest SetTargetPools(Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersSetTargetPoolsRequest body, string project, string region, string instanceGroupManager)
        {
            return new SetTargetPoolsRequest(service, body, project, region, instanceGroupManager);
        }

        /// <summary>
        /// Modifies the target pools to which all new instances in this group are assigned. Existing instances in the
        /// group are not affected.
        /// </summary>
        public class SetTargetPoolsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetTargetPools request.</summary>
            public SetTargetPoolsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersSetTargetPoolsRequest body, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the managed instance group.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionInstanceGroupManagersSetTargetPoolsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setTargetPools";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/setTargetPools";

            /// <summary>Initializes SetTargetPools parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Inserts or updates per-instance configs for the managed instance group. perInstanceConfig.name serves as a
        /// key used to distinguish whether to perform insert or patch.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request, should conform to RFC1035.</param>
        /// <param name="instanceGroupManager">
        /// The name of the managed instance group. It should conform to RFC1035.
        /// </param>
        public virtual UpdatePerInstanceConfigsRequest UpdatePerInstanceConfigs(Google.Apis.Compute.v1.Data.RegionInstanceGroupManagerUpdateInstanceConfigReq body, string project, string region, string instanceGroupManager)
        {
            return new UpdatePerInstanceConfigsRequest(service, body, project, region, instanceGroupManager);
        }

        /// <summary>
        /// Inserts or updates per-instance configs for the managed instance group. perInstanceConfig.name serves as a
        /// key used to distinguish whether to perform insert or patch.
        /// </summary>
        public class UpdatePerInstanceConfigsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new UpdatePerInstanceConfigs request.</summary>
            public UpdatePerInstanceConfigsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionInstanceGroupManagerUpdateInstanceConfigReq body, string project, string region, string instanceGroupManager) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroupManager = instanceGroupManager;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request, should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The name of the managed instance group. It should conform to RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroupManager", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroupManager { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionInstanceGroupManagerUpdateInstanceConfigReq Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "updatePerInstanceConfigs";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroupManagers/{instanceGroupManager}/updatePerInstanceConfigs";

            /// <summary>Initializes UpdatePerInstanceConfigs parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroupManager", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroupManager",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionInstanceGroups" collection of methods.</summary>
    public class RegionInstanceGroupsResource
    {
        private const string Resource = "regionInstanceGroups";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionInstanceGroupsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Returns the specified instance group resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="instanceGroup">Name of the instance group resource to return.</param>
        public virtual GetRequest Get(string project, string region, string instanceGroup)
        {
            return new GetRequest(service, project, region, instanceGroup);
        }

        /// <summary>Returns the specified instance group resource.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.InstanceGroup>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string instanceGroup) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroup = instanceGroup;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the instance group resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroup { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroups/{instanceGroup}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of instance group resources contained within the specified region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves the list of instance group resources contained within the specified region.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RegionInstanceGroupList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroups";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Lists the instances in the specified instance group and displays information about the named ports.
        /// Depending on the specified options, this method can list all instances or only the instances that are
        /// running. The orderBy query parameter is not supported.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="instanceGroup">
        /// Name of the regional instance group for which we want to list the instances.
        /// </param>
        public virtual ListInstancesRequest ListInstances(Google.Apis.Compute.v1.Data.RegionInstanceGroupsListInstancesRequest body, string project, string region, string instanceGroup)
        {
            return new ListInstancesRequest(service, body, project, region, instanceGroup);
        }

        /// <summary>
        /// Lists the instances in the specified instance group and displays information about the named ports.
        /// Depending on the specified options, this method can list all instances or only the instances that are
        /// running. The orderBy query parameter is not supported.
        /// </summary>
        public class ListInstancesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RegionInstanceGroupsListInstances>
        {
            /// <summary>Constructs a new ListInstances request.</summary>
            public ListInstancesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionInstanceGroupsListInstancesRequest body, string project, string region, string instanceGroup) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroup = instanceGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the regional instance group for which we want to list the instances.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroup { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionInstanceGroupsListInstancesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listInstances";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroups/{instanceGroup}/listInstances";

            /// <summary>Initializes ListInstances parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the named ports for the specified regional instance group.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="instanceGroup">
        /// The name of the regional instance group where the named ports are updated.
        /// </param>
        public virtual SetNamedPortsRequest SetNamedPorts(Google.Apis.Compute.v1.Data.RegionInstanceGroupsSetNamedPortsRequest body, string project, string region, string instanceGroup)
        {
            return new SetNamedPortsRequest(service, body, project, region, instanceGroup);
        }

        /// <summary>Sets the named ports for the specified regional instance group.</summary>
        public class SetNamedPortsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetNamedPorts request.</summary>
            public SetNamedPortsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionInstanceGroupsSetNamedPortsRequest body, string project, string region, string instanceGroup) : base(service)
            {
                Project = project;
                Region = region;
                InstanceGroup = instanceGroup;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The name of the regional instance group where the named ports are updated.</summary>
            [Google.Apis.Util.RequestParameterAttribute("instanceGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string InstanceGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionInstanceGroupsSetNamedPortsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setNamedPorts";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instanceGroups/{instanceGroup}/setNamedPorts";

            /// <summary>Initializes SetNamedPorts parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("instanceGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "instanceGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionInstances" collection of methods.</summary>
    public class RegionInstancesResource
    {
        private const string Resource = "regionInstances";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionInstancesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Creates multiple instances in a given region. Count specifies the number of instances to create.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        public virtual BulkInsertRequest BulkInsert(Google.Apis.Compute.v1.Data.BulkInsertInstanceResource body, string project, string region)
        {
            return new BulkInsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates multiple instances in a given region. Count specifies the number of instances to create.
        /// </summary>
        public class BulkInsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new BulkInsert request.</summary>
            public BulkInsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.BulkInsertInstanceResource body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.BulkInsertInstanceResource Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "bulkInsert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/instances/bulkInsert";

            /// <summary>Initializes BulkInsert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionNetworkEndpointGroups" collection of methods.</summary>
    public class RegionNetworkEndpointGroupsResource
    {
        private const string Resource = "regionNetworkEndpointGroups";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionNetworkEndpointGroupsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Deletes the specified network endpoint group. Note that the NEG cannot be deleted if it is configured as a
        /// backend of a backend service.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">
        /// The name of the region where the network endpoint group is located. It should comply with RFC1035.
        /// </param>
        /// <param name="networkEndpointGroup">
        /// The name of the network endpoint group to delete. It should comply with RFC1035.
        /// </param>
        public virtual DeleteRequest Delete(string project, string region, string networkEndpointGroup)
        {
            return new DeleteRequest(service, project, region, networkEndpointGroup);
        }

        /// <summary>
        /// Deletes the specified network endpoint group. Note that the NEG cannot be deleted if it is configured as a
        /// backend of a backend service.
        /// </summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string networkEndpointGroup) : base(service)
            {
                Project = project;
                Region = region;
                NetworkEndpointGroup = networkEndpointGroup;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the region where the network endpoint group is located. It should comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The name of the network endpoint group to delete. It should comply with RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("networkEndpointGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NetworkEndpointGroup { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/networkEndpointGroups/{networkEndpointGroup}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("networkEndpointGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkEndpointGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified network endpoint group. Gets a list of available network endpoint groups by making a
        /// list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">
        /// The name of the region where the network endpoint group is located. It should comply with RFC1035.
        /// </param>
        /// <param name="networkEndpointGroup">
        /// The name of the network endpoint group. It should comply with RFC1035.
        /// </param>
        public virtual GetRequest Get(string project, string region, string networkEndpointGroup)
        {
            return new GetRequest(service, project, region, networkEndpointGroup);
        }

        /// <summary>
        /// Returns the specified network endpoint group. Gets a list of available network endpoint groups by making a
        /// list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NetworkEndpointGroup>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string networkEndpointGroup) : base(service)
            {
                Project = project;
                Region = region;
                NetworkEndpointGroup = networkEndpointGroup;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the region where the network endpoint group is located. It should comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>The name of the network endpoint group. It should comply with RFC1035.</summary>
            [Google.Apis.Util.RequestParameterAttribute("networkEndpointGroup", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NetworkEndpointGroup { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/networkEndpointGroups/{networkEndpointGroup}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("networkEndpointGroup", new Google.Apis.Discovery.Parameter
                {
                    Name = "networkEndpointGroup",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Creates a network endpoint group in the specified project using the parameters that are included in the
        /// request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">
        /// The name of the region where you want to create the network endpoint group. It should comply with RFC1035.
        /// </param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.NetworkEndpointGroup body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a network endpoint group in the specified project using the parameters that are included in the
        /// request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NetworkEndpointGroup body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the region where you want to create the network endpoint group. It should comply with
            /// RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NetworkEndpointGroup Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/networkEndpointGroups";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves the list of regional network endpoint groups available to the specified project in the given
        /// region.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">
        /// The name of the region where the network endpoint group is located. It should comply with RFC1035.
        /// </param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>
        /// Retrieves the list of regional network endpoint groups available to the specified project in the given
        /// region.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NetworkEndpointGroupList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// The name of the region where the network endpoint group is located. It should comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/networkEndpointGroups";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionNotificationEndpoints" collection of methods.</summary>
    public class RegionNotificationEndpointsResource
    {
        private const string Resource = "regionNotificationEndpoints";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionNotificationEndpointsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified NotificationEndpoint in the given region</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="notificationEndpoint">Name of the NotificationEndpoint resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string notificationEndpoint)
        {
            return new DeleteRequest(service, project, region, notificationEndpoint);
        }

        /// <summary>Deletes the specified NotificationEndpoint in the given region</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string notificationEndpoint) : base(service)
            {
                Project = project;
                Region = region;
                NotificationEndpoint = notificationEndpoint;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the NotificationEndpoint resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("notificationEndpoint", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NotificationEndpoint { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/notificationEndpoints/{notificationEndpoint}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("notificationEndpoint", new Google.Apis.Discovery.Parameter
                {
                    Name = "notificationEndpoint",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified NotificationEndpoint resource in the given region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="notificationEndpoint">Name of the NotificationEndpoint resource to return.</param>
        public virtual GetRequest Get(string project, string region, string notificationEndpoint)
        {
            return new GetRequest(service, project, region, notificationEndpoint);
        }

        /// <summary>Returns the specified NotificationEndpoint resource in the given region.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NotificationEndpoint>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string notificationEndpoint) : base(service)
            {
                Project = project;
                Region = region;
                NotificationEndpoint = notificationEndpoint;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the NotificationEndpoint resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("notificationEndpoint", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string NotificationEndpoint { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/notificationEndpoints/{notificationEndpoint}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("notificationEndpoint", new Google.Apis.Discovery.Parameter
                {
                    Name = "notificationEndpoint",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Create a NotificationEndpoint in the specified project in the given region using the parameters that are
        /// included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.NotificationEndpoint body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Create a NotificationEndpoint in the specified project in the given region using the parameters that are
        /// included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.NotificationEndpoint body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.NotificationEndpoint Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/notificationEndpoints";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Lists the NotificationEndpoints for a project in the given region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Lists the NotificationEndpoints for a project in the given region.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.NotificationEndpointList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/notificationEndpoints";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionOperations" collection of methods.</summary>
    public class RegionOperationsResource
    {
        private const string Resource = "regionOperations";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionOperationsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified region-specific Operations resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="operation">Name of the Operations resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string operation)
        {
            return new DeleteRequest(service, project, region, operation);
        }

        /// <summary>Deletes the specified region-specific Operations resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<string>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string operation) : base(service)
            {
                Project = project;
                Region = region;
                Operation = operation;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Operations resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("operation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Operation { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/operations/{operation}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("operation", new Google.Apis.Discovery.Parameter
                {
                    Name = "operation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves the specified region-specific Operations resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="operation">Name of the Operations resource to return.</param>
        public virtual GetRequest Get(string project, string region, string operation)
        {
            return new GetRequest(service, project, region, operation);
        }

        /// <summary>Retrieves the specified region-specific Operations resource.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string operation) : base(service)
            {
                Project = project;
                Region = region;
                Operation = operation;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Operations resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("operation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Operation { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/operations/{operation}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("operation", new Google.Apis.Discovery.Parameter
                {
                    Name = "operation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves a list of Operation resources contained within the specified region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves a list of Operation resources contained within the specified region.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.OperationList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/operations";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Waits for the specified Operation resource to return as `DONE` or for the request to approach the 2 minute
        /// deadline, and retrieves the specified Operation resource. This method differs from the `GET` method in that
        /// it waits for no more than the default deadline (2 minutes) and then returns the current state of the
        /// operation, which might be `DONE` or still in progress.  This method is called on a best-effort basis.
        /// Specifically:   - In uncommon cases, when the server is overloaded, the request might return before the
        /// default deadline is reached, or might return after zero seconds.  - If the default deadline is reached,
        /// there is no guarantee that the operation is actually done when the method returns. Be prepared to retry if
        /// the operation is not `DONE`.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="operation">Name of the Operations resource to return.</param>
        public virtual WaitRequest Wait(string project, string region, string operation)
        {
            return new WaitRequest(service, project, region, operation);
        }

        /// <summary>
        /// Waits for the specified Operation resource to return as `DONE` or for the request to approach the 2 minute
        /// deadline, and retrieves the specified Operation resource. This method differs from the `GET` method in that
        /// it waits for no more than the default deadline (2 minutes) and then returns the current state of the
        /// operation, which might be `DONE` or still in progress.  This method is called on a best-effort basis.
        /// Specifically:   - In uncommon cases, when the server is overloaded, the request might return before the
        /// default deadline is reached, or might return after zero seconds.  - If the default deadline is reached,
        /// there is no guarantee that the operation is actually done when the method returns. Be prepared to retry if
        /// the operation is not `DONE`.
        /// </summary>
        public class WaitRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Wait request.</summary>
            public WaitRequest(Google.Apis.Services.IClientService service, string project, string region, string operation) : base(service)
            {
                Project = project;
                Region = region;
                Operation = operation;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Operations resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("operation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Operation { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "wait";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/operations/{operation}/wait";

            /// <summary>Initializes Wait parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("operation", new Google.Apis.Discovery.Parameter
                {
                    Name = "operation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "regionSslCertificates" collection of methods.</summary>
    public class RegionSslCertificatesResource
    {
        private const string Resource = "regionSslCertificates";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionSslCertificatesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified SslCertificate resource in the region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="sslCertificate">Name of the SslCertificate resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string sslCertificate)
        {
            return new DeleteRequest(service, project, region, sslCertificate);
        }

        /// <summary>Deletes the specified SslCertificate resource in the region.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string sslCertificate) : base(service)
            {
                Project = project;
                Region = region;
                SslCertificate = sslCertificate;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the SslCertificate resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("sslCertificate", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SslCertificate { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/sslCertificates/{sslCertificate}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("sslCertificate", new Google.Apis.Discovery.Parameter
                {
                    Name = "sslCertificate",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified SslCertificate resource in the specified region. Get a list of available SSL
        /// certificates by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="sslCertificate">Name of the SslCertificate resource to return.</param>
        public virtual GetRequest Get(string project, string region, string sslCertificate)
        {
            return new GetRequest(service, project, region, sslCertificate);
        }

        /// <summary>
        /// Returns the specified SslCertificate resource in the specified region. Get a list of available SSL
        /// certificates by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SslCertificate>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string sslCertificate) : base(service)
            {
                Project = project;
                Region = region;
                SslCertificate = sslCertificate;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the SslCertificate resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("sslCertificate", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SslCertificate { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/sslCertificates/{sslCertificate}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("sslCertificate", new Google.Apis.Discovery.Parameter
                {
                    Name = "sslCertificate",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a SslCertificate resource in the specified project and region using the data included in the request
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.SslCertificate body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a SslCertificate resource in the specified project and region using the data included in the request
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SslCertificate body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SslCertificate Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/sslCertificates";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves the list of SslCertificate resources available to the specified project in the specified region.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>
        /// Retrieves the list of SslCertificate resources available to the specified project in the specified region.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SslCertificateList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/sslCertificates";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionTargetHttpProxies" collection of methods.</summary>
    public class RegionTargetHttpProxiesResource
    {
        private const string Resource = "regionTargetHttpProxies";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionTargetHttpProxiesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified TargetHttpProxy resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetHttpProxy">Name of the TargetHttpProxy resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string targetHttpProxy)
        {
            return new DeleteRequest(service, project, region, targetHttpProxy);
        }

        /// <summary>Deletes the specified TargetHttpProxy resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string targetHttpProxy) : base(service)
            {
                Project = project;
                Region = region;
                TargetHttpProxy = targetHttpProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the TargetHttpProxy resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetHttpProxies/{targetHttpProxy}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetHttpProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified TargetHttpProxy resource in the specified region. Gets a list of available target HTTP
        /// proxies by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetHttpProxy">Name of the TargetHttpProxy resource to return.</param>
        public virtual GetRequest Get(string project, string region, string targetHttpProxy)
        {
            return new GetRequest(service, project, region, targetHttpProxy);
        }

        /// <summary>
        /// Returns the specified TargetHttpProxy resource in the specified region. Gets a list of available target HTTP
        /// proxies by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetHttpProxy>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string targetHttpProxy) : base(service)
            {
                Project = project;
                Region = region;
                TargetHttpProxy = targetHttpProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the TargetHttpProxy resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpProxy { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetHttpProxies/{targetHttpProxy}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetHttpProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a TargetHttpProxy resource in the specified project and region using the data included in the
        /// request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.TargetHttpProxy body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a TargetHttpProxy resource in the specified project and region using the data included in the
        /// request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetHttpProxy body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetHttpProxy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetHttpProxies";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves the list of TargetHttpProxy resources available to the specified project in the specified region.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>
        /// Retrieves the list of TargetHttpProxy resources available to the specified project in the specified region.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetHttpProxyList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetHttpProxies";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Changes the URL map for TargetHttpProxy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetHttpProxy">Name of the TargetHttpProxy to set a URL map for.</param>
        public virtual SetUrlMapRequest SetUrlMap(Google.Apis.Compute.v1.Data.UrlMapReference body, string project, string region, string targetHttpProxy)
        {
            return new SetUrlMapRequest(service, body, project, region, targetHttpProxy);
        }

        /// <summary>Changes the URL map for TargetHttpProxy.</summary>
        public class SetUrlMapRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetUrlMap request.</summary>
            public SetUrlMapRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.UrlMapReference body, string project, string region, string targetHttpProxy) : base(service)
            {
                Project = project;
                Region = region;
                TargetHttpProxy = targetHttpProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the TargetHttpProxy to set a URL map for.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.UrlMapReference Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setUrlMap";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetHttpProxies/{targetHttpProxy}/setUrlMap";

            /// <summary>Initializes SetUrlMap parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetHttpProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionTargetHttpsProxies" collection of methods.</summary>
    public class RegionTargetHttpsProxiesResource
    {
        private const string Resource = "regionTargetHttpsProxies";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionTargetHttpsProxiesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified TargetHttpsProxy resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetHttpsProxy">Name of the TargetHttpsProxy resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string targetHttpsProxy)
        {
            return new DeleteRequest(service, project, region, targetHttpsProxy);
        }

        /// <summary>Deletes the specified TargetHttpsProxy resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string targetHttpsProxy) : base(service)
            {
                Project = project;
                Region = region;
                TargetHttpsProxy = targetHttpsProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the TargetHttpsProxy resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpsProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpsProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetHttpsProxies/{targetHttpsProxy}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetHttpsProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpsProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified TargetHttpsProxy resource in the specified region. Gets a list of available target
        /// HTTP proxies by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetHttpsProxy">Name of the TargetHttpsProxy resource to return.</param>
        public virtual GetRequest Get(string project, string region, string targetHttpsProxy)
        {
            return new GetRequest(service, project, region, targetHttpsProxy);
        }

        /// <summary>
        /// Returns the specified TargetHttpsProxy resource in the specified region. Gets a list of available target
        /// HTTP proxies by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetHttpsProxy>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string targetHttpsProxy) : base(service)
            {
                Project = project;
                Region = region;
                TargetHttpsProxy = targetHttpsProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the TargetHttpsProxy resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpsProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpsProxy { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetHttpsProxies/{targetHttpsProxy}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetHttpsProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpsProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a TargetHttpsProxy resource in the specified project and region using the data included in the
        /// request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.TargetHttpsProxy body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a TargetHttpsProxy resource in the specified project and region using the data included in the
        /// request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetHttpsProxy body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetHttpsProxy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetHttpsProxies";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves the list of TargetHttpsProxy resources available to the specified project in the specified region.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>
        /// Retrieves the list of TargetHttpsProxy resources available to the specified project in the specified region.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetHttpsProxyList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetHttpsProxies";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Replaces SslCertificates for TargetHttpsProxy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetHttpsProxy">
        /// Name of the TargetHttpsProxy resource to set an SslCertificates resource for.
        /// </param>
        public virtual SetSslCertificatesRequest SetSslCertificates(Google.Apis.Compute.v1.Data.RegionTargetHttpsProxiesSetSslCertificatesRequest body, string project, string region, string targetHttpsProxy)
        {
            return new SetSslCertificatesRequest(service, body, project, region, targetHttpsProxy);
        }

        /// <summary>Replaces SslCertificates for TargetHttpsProxy.</summary>
        public class SetSslCertificatesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetSslCertificates request.</summary>
            public SetSslCertificatesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionTargetHttpsProxiesSetSslCertificatesRequest body, string project, string region, string targetHttpsProxy) : base(service)
            {
                Project = project;
                Region = region;
                TargetHttpsProxy = targetHttpsProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the TargetHttpsProxy resource to set an SslCertificates resource for.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpsProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpsProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionTargetHttpsProxiesSetSslCertificatesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setSslCertificates";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetHttpsProxies/{targetHttpsProxy}/setSslCertificates";

            /// <summary>Initializes SetSslCertificates parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetHttpsProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpsProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Changes the URL map for TargetHttpsProxy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetHttpsProxy">Name of the TargetHttpsProxy to set a URL map for.</param>
        public virtual SetUrlMapRequest SetUrlMap(Google.Apis.Compute.v1.Data.UrlMapReference body, string project, string region, string targetHttpsProxy)
        {
            return new SetUrlMapRequest(service, body, project, region, targetHttpsProxy);
        }

        /// <summary>Changes the URL map for TargetHttpsProxy.</summary>
        public class SetUrlMapRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetUrlMap request.</summary>
            public SetUrlMapRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.UrlMapReference body, string project, string region, string targetHttpsProxy) : base(service)
            {
                Project = project;
                Region = region;
                TargetHttpsProxy = targetHttpsProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the TargetHttpsProxy to set a URL map for.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpsProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpsProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.UrlMapReference Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setUrlMap";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetHttpsProxies/{targetHttpsProxy}/setUrlMap";

            /// <summary>Initializes SetUrlMap parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetHttpsProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpsProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "regionUrlMaps" collection of methods.</summary>
    public class RegionUrlMapsResource
    {
        private const string Resource = "regionUrlMaps";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionUrlMapsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified UrlMap resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="urlMap">Name of the UrlMap resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string urlMap)
        {
            return new DeleteRequest(service, project, region, urlMap);
        }

        /// <summary>Deletes the specified UrlMap resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string urlMap) : base(service)
            {
                Project = project;
                Region = region;
                UrlMap = urlMap;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the UrlMap resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("urlMap", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string UrlMap { get; private set; }

            /// <summary>begin_interface: MixerMutationRequestBuilder Request ID to support idempotency.</summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/urlMaps/{urlMap}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("urlMap", new Google.Apis.Discovery.Parameter
                {
                    Name = "urlMap",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified UrlMap resource. Gets a list of available URL maps by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="urlMap">Name of the UrlMap resource to return.</param>
        public virtual GetRequest Get(string project, string region, string urlMap)
        {
            return new GetRequest(service, project, region, urlMap);
        }

        /// <summary>
        /// Returns the specified UrlMap resource. Gets a list of available URL maps by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.UrlMap>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string urlMap) : base(service)
            {
                Project = project;
                Region = region;
                UrlMap = urlMap;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the UrlMap resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("urlMap", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string UrlMap { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/urlMaps/{urlMap}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("urlMap", new Google.Apis.Discovery.Parameter
                {
                    Name = "urlMap",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a UrlMap resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.UrlMap body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a UrlMap resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.UrlMap body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>begin_interface: MixerMutationRequestBuilder Request ID to support idempotency.</summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.UrlMap Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/urlMaps";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Retrieves the list of UrlMap resources available to the specified project in the specified region.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>
        /// Retrieves the list of UrlMap resources available to the specified project in the specified region.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.UrlMapList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/urlMaps";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Patches the specified UrlMap resource with the data included in the request. This method supports PATCH
        /// semantics and uses JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="urlMap">Name of the UrlMap resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.UrlMap body, string project, string region, string urlMap)
        {
            return new PatchRequest(service, body, project, region, urlMap);
        }

        /// <summary>
        /// Patches the specified UrlMap resource with the data included in the request. This method supports PATCH
        /// semantics and uses JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.UrlMap body, string project, string region, string urlMap) : base(service)
            {
                Project = project;
                Region = region;
                UrlMap = urlMap;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the UrlMap resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("urlMap", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string UrlMap { get; private set; }

            /// <summary>begin_interface: MixerMutationRequestBuilder Request ID to support idempotency.</summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.UrlMap Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/urlMaps/{urlMap}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("urlMap", new Google.Apis.Discovery.Parameter
                {
                    Name = "urlMap",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Updates the specified UrlMap resource with the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="urlMap">Name of the UrlMap resource to update.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.UrlMap body, string project, string region, string urlMap)
        {
            return new UpdateRequest(service, body, project, region, urlMap);
        }

        /// <summary>Updates the specified UrlMap resource with the data included in the request.</summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.UrlMap body, string project, string region, string urlMap) : base(service)
            {
                Project = project;
                Region = region;
                UrlMap = urlMap;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the UrlMap resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("urlMap", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string UrlMap { get; private set; }

            /// <summary>begin_interface: MixerMutationRequestBuilder Request ID to support idempotency.</summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.UrlMap Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/urlMaps/{urlMap}";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("urlMap", new Google.Apis.Discovery.Parameter
                {
                    Name = "urlMap",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Runs static validation for the UrlMap. In particular, the tests of the provided UrlMap will be run. Calling
        /// this method does NOT create the UrlMap.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="urlMap">Name of the UrlMap resource to be validated as.</param>
        public virtual ValidateRequest Validate(Google.Apis.Compute.v1.Data.RegionUrlMapsValidateRequest body, string project, string region, string urlMap)
        {
            return new ValidateRequest(service, body, project, region, urlMap);
        }

        /// <summary>
        /// Runs static validation for the UrlMap. In particular, the tests of the provided UrlMap will be run. Calling
        /// this method does NOT create the UrlMap.
        /// </summary>
        public class ValidateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.UrlMapsValidateResponse>
        {
            /// <summary>Constructs a new Validate request.</summary>
            public ValidateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionUrlMapsValidateRequest body, string project, string region, string urlMap) : base(service)
            {
                Project = project;
                Region = region;
                UrlMap = urlMap;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the UrlMap resource to be validated as.</summary>
            [Google.Apis.Util.RequestParameterAttribute("urlMap", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string UrlMap { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionUrlMapsValidateRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "validate";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/urlMaps/{urlMap}/validate";

            /// <summary>Initializes Validate parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("urlMap", new Google.Apis.Discovery.Parameter
                {
                    Name = "urlMap",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "regions" collection of methods.</summary>
    public class RegionsResource
    {
        private const string Resource = "regions";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RegionsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Returns the specified Region resource. Gets a list of available regions by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region resource to return.</param>
        public virtual GetRequest Get(string project, string region)
        {
            return new GetRequest(service, project, region);
        }

        /// <summary>
        /// Returns the specified Region resource. Gets a list of available regions by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Region>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves the list of region resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of region resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RegionList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "reservations" collection of methods.</summary>
    public class ReservationsResource
    {
        private const string Resource = "reservations";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public ReservationsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of reservations.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of reservations.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ReservationAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/reservations";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified reservation.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        /// <param name="reservation">Name of the reservation to delete.</param>
        public virtual DeleteRequest Delete(string project, string zone, string reservation)
        {
            return new DeleteRequest(service, project, zone, reservation);
        }

        /// <summary>Deletes the specified reservation.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string zone, string reservation) : base(service)
            {
                Project = project;
                Zone = zone;
                Reservation = reservation;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the reservation to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("reservation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Reservation { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/reservations/{reservation}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("reservation", new Google.Apis.Discovery.Parameter
                {
                    Name = "reservation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves information about the specified reservation.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        /// <param name="reservation">Name of the reservation to retrieve.</param>
        public virtual GetRequest Get(string project, string zone, string reservation)
        {
            return new GetRequest(service, project, zone, reservation);
        }

        /// <summary>Retrieves information about the specified reservation.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Reservation>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string reservation) : base(service)
            {
                Project = project;
                Zone = zone;
                Reservation = reservation;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the reservation to retrieve.</summary>
            [Google.Apis.Util.RequestParameterAttribute("reservation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Reservation { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/reservations/{reservation}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("reservation", new Google.Apis.Discovery.Parameter
                {
                    Name = "reservation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual GetIamPolicyRequest GetIamPolicy(string project, string zone, string resource)
        {
            return new GetIamPolicyRequest(service, project, zone, resource);
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        public class GetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new GetIamPolicy request.</summary>
            public GetIamPolicyRequest(Google.Apis.Services.IClientService service, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Requested IAM Policy version.</summary>
            [Google.Apis.Util.RequestParameterAttribute("optionsRequestedPolicyVersion", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> OptionsRequestedPolicyVersion { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/reservations/{resource}/getIamPolicy";

            /// <summary>Initializes GetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("optionsRequestedPolicyVersion", new Google.Apis.Discovery.Parameter
                {
                    Name = "optionsRequestedPolicyVersion",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Creates a new reservation. For more information, read Reserving zonal resources.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Reservation body, string project, string zone)
        {
            return new InsertRequest(service, body, project, zone);
        }

        /// <summary>Creates a new reservation. For more information, read Reserving zonal resources.</summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Reservation body, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Reservation Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/reservations";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// A list of all the reservations that have been configured for the specified project in specified zone.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>
        /// A list of all the reservations that have been configured for the specified project in specified zone.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ReservationList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/reservations";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Resizes the reservation (applicable to standalone reservations only). For more information, read Modifying
        /// reservations.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        /// <param name="reservation">Name of the reservation to update.</param>
        public virtual ResizeRequest Resize(Google.Apis.Compute.v1.Data.ReservationsResizeRequest body, string project, string zone, string reservation)
        {
            return new ResizeRequest(service, body, project, zone, reservation);
        }

        /// <summary>
        /// Resizes the reservation (applicable to standalone reservations only). For more information, read Modifying
        /// reservations.
        /// </summary>
        public class ResizeRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Resize request.</summary>
            public ResizeRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ReservationsResizeRequest body, string project, string zone, string reservation) : base(service)
            {
                Project = project;
                Zone = zone;
                Reservation = reservation;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the reservation to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("reservation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Reservation { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ReservationsResizeRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "resize";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/reservations/{reservation}/resize";

            /// <summary>Initializes Resize parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("reservation", new Google.Apis.Discovery.Parameter
                {
                    Name = "reservation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetIamPolicyRequest SetIamPolicy(Google.Apis.Compute.v1.Data.ZoneSetPolicyRequest body, string project, string zone, string resource)
        {
            return new SetIamPolicyRequest(service, body, project, zone, resource);
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        public class SetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new SetIamPolicy request.</summary>
            public SetIamPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ZoneSetPolicyRequest body, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ZoneSetPolicyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/reservations/{resource}/setIamPolicy";

            /// <summary>Initializes SetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">The name of the zone for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string zone, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, zone, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string zone, string resource) : base(service)
            {
                Project = project;
                Zone = zone;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/reservations/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "resourcePolicies" collection of methods.</summary>
    public class ResourcePoliciesResource
    {
        private const string Resource = "resourcePolicies";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public ResourcePoliciesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of resource policies.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of resource policies.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ResourcePolicyAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/resourcePolicies";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified resource policy.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="resourcePolicy">Name of the resource policy to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string resourcePolicy)
        {
            return new DeleteRequest(service, project, region, resourcePolicy);
        }

        /// <summary>Deletes the specified resource policy.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string resourcePolicy) : base(service)
            {
                Project = project;
                Region = region;
                ResourcePolicy = resourcePolicy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the resource policy to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resourcePolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string ResourcePolicy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/resourcePolicies/{resourcePolicy}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resourcePolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "resourcePolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves all information of the specified resource policy.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="resourcePolicy">Name of the resource policy to retrieve.</param>
        public virtual GetRequest Get(string project, string region, string resourcePolicy)
        {
            return new GetRequest(service, project, region, resourcePolicy);
        }

        /// <summary>Retrieves all information of the specified resource policy.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ResourcePolicy>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string resourcePolicy) : base(service)
            {
                Project = project;
                Region = region;
                ResourcePolicy = resourcePolicy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the resource policy to retrieve.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resourcePolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string ResourcePolicy { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/resourcePolicies/{resourcePolicy}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resourcePolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "resourcePolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual GetIamPolicyRequest GetIamPolicy(string project, string region, string resource)
        {
            return new GetIamPolicyRequest(service, project, region, resource);
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        public class GetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new GetIamPolicy request.</summary>
            public GetIamPolicyRequest(Google.Apis.Services.IClientService service, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Requested IAM Policy version.</summary>
            [Google.Apis.Util.RequestParameterAttribute("optionsRequestedPolicyVersion", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> OptionsRequestedPolicyVersion { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/resourcePolicies/{resource}/getIamPolicy";

            /// <summary>Initializes GetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("optionsRequestedPolicyVersion", new Google.Apis.Discovery.Parameter
                {
                    Name = "optionsRequestedPolicyVersion",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Creates a new resource policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.ResourcePolicy body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>Creates a new resource policy.</summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.ResourcePolicy body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.ResourcePolicy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/resourcePolicies";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// A list all the resource policies that have been configured for the specified project in specified region.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>
        /// A list all the resource policies that have been configured for the specified project in specified region.
        /// </summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ResourcePolicyList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/resourcePolicies";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetIamPolicyRequest SetIamPolicy(Google.Apis.Compute.v1.Data.RegionSetPolicyRequest body, string project, string region, string resource)
        {
            return new SetIamPolicyRequest(service, body, project, region, resource);
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        public class SetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new SetIamPolicy request.</summary>
            public SetIamPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionSetPolicyRequest body, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionSetPolicyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/resourcePolicies/{resource}/setIamPolicy";

            /// <summary>Initializes SetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string region, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, region, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/resourcePolicies/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "routers" collection of methods.</summary>
    public class RoutersResource
    {
        private const string Resource = "routers";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RoutersResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of routers.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of routers.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RouterAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/routers";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified Router resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="router">Name of the Router resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string router)
        {
            return new DeleteRequest(service, project, region, router);
        }

        /// <summary>Deletes the specified Router resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string router) : base(service)
            {
                Project = project;
                Region = region;
                Router = router;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Router resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("router", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Router { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/routers/{router}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("router", new Google.Apis.Discovery.Parameter
                {
                    Name = "router",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified Router resource. Gets a list of available routers by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="router">Name of the Router resource to return.</param>
        public virtual GetRequest Get(string project, string region, string router)
        {
            return new GetRequest(service, project, region, router);
        }

        /// <summary>
        /// Returns the specified Router resource. Gets a list of available routers by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Router>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string router) : base(service)
            {
                Project = project;
                Region = region;
                Router = router;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Router resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("router", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Router { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/routers/{router}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("router", new Google.Apis.Discovery.Parameter
                {
                    Name = "router",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves runtime Nat mapping information of VM endpoints.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="router">
        /// Name of the Router resource to query for Nat Mapping information of VM endpoints.
        /// </param>
        public virtual GetNatMappingInfoRequest GetNatMappingInfo(string project, string region, string router)
        {
            return new GetNatMappingInfoRequest(service, project, region, router);
        }

        /// <summary>Retrieves runtime Nat mapping information of VM endpoints.</summary>
        public class GetNatMappingInfoRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.VmEndpointNatMappingsList>
        {
            /// <summary>Constructs a new GetNatMappingInfo request.</summary>
            public GetNatMappingInfoRequest(Google.Apis.Services.IClientService service, string project, string region, string router) : base(service)
            {
                Project = project;
                Region = region;
                Router = router;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Router resource to query for Nat Mapping information of VM endpoints.</summary>
            [Google.Apis.Util.RequestParameterAttribute("router", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Router { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getNatMappingInfo";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/routers/{router}/getNatMappingInfo";

            /// <summary>Initializes GetNatMappingInfo parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("router", new Google.Apis.Discovery.Parameter
                {
                    Name = "router",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves runtime information of the specified router.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="router">Name of the Router resource to query.</param>
        public virtual GetRouterStatusRequest GetRouterStatus(string project, string region, string router)
        {
            return new GetRouterStatusRequest(service, project, region, router);
        }

        /// <summary>Retrieves runtime information of the specified router.</summary>
        public class GetRouterStatusRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RouterStatusResponse>
        {
            /// <summary>Constructs a new GetRouterStatus request.</summary>
            public GetRouterStatusRequest(Google.Apis.Services.IClientService service, string project, string region, string router) : base(service)
            {
                Project = project;
                Region = region;
                Router = router;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Router resource to query.</summary>
            [Google.Apis.Util.RequestParameterAttribute("router", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Router { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getRouterStatus";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/routers/{router}/getRouterStatus";

            /// <summary>Initializes GetRouterStatus parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("router", new Google.Apis.Discovery.Parameter
                {
                    Name = "router",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a Router resource in the specified project and region using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Router body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a Router resource in the specified project and region using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Router body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Router Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/routers";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of Router resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves a list of Router resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RouterList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/routers";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Patches the specified Router resource with the data included in the request. This method supports PATCH
        /// semantics and uses JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="router">Name of the Router resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.Router body, string project, string region, string router)
        {
            return new PatchRequest(service, body, project, region, router);
        }

        /// <summary>
        /// Patches the specified Router resource with the data included in the request. This method supports PATCH
        /// semantics and uses JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Router body, string project, string region, string router) : base(service)
            {
                Project = project;
                Region = region;
                Router = router;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Router resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("router", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Router { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Router Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/routers/{router}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("router", new Google.Apis.Discovery.Parameter
                {
                    Name = "router",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Preview fields auto-generated during router create and update operations. Calling this method does NOT
        /// create or update the router.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="router">Name of the Router resource to query.</param>
        public virtual PreviewRequest Preview(Google.Apis.Compute.v1.Data.Router body, string project, string region, string router)
        {
            return new PreviewRequest(service, body, project, region, router);
        }

        /// <summary>
        /// Preview fields auto-generated during router create and update operations. Calling this method does NOT
        /// create or update the router.
        /// </summary>
        public class PreviewRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RoutersPreviewResponse>
        {
            /// <summary>Constructs a new Preview request.</summary>
            public PreviewRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Router body, string project, string region, string router) : base(service)
            {
                Project = project;
                Region = region;
                Router = router;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Router resource to query.</summary>
            [Google.Apis.Util.RequestParameterAttribute("router", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Router { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Router Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "preview";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/routers/{router}/preview";

            /// <summary>Initializes Preview parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("router", new Google.Apis.Discovery.Parameter
                {
                    Name = "router",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Updates the specified Router resource with the data included in the request. This method conforms to PUT
        /// semantics, which requests that the state of the target resource be created or replaced with the state
        /// defined by the representation enclosed in the request message payload.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="router">Name of the Router resource to update.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.Router body, string project, string region, string router)
        {
            return new UpdateRequest(service, body, project, region, router);
        }

        /// <summary>
        /// Updates the specified Router resource with the data included in the request. This method conforms to PUT
        /// semantics, which requests that the state of the target resource be created or replaced with the state
        /// defined by the representation enclosed in the request message payload.
        /// </summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Router body, string project, string region, string router) : base(service)
            {
                Project = project;
                Region = region;
                Router = router;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Router resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("router", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Router { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Router Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/routers/{router}";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("router", new Google.Apis.Discovery.Parameter
                {
                    Name = "router",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "routes" collection of methods.</summary>
    public class RoutesResource
    {
        private const string Resource = "routes";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public RoutesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified Route resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="route">Name of the Route resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string route)
        {
            return new DeleteRequest(service, project, route);
        }

        /// <summary>Deletes the specified Route resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string route) : base(service)
            {
                Project = project;
                Route = route;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the Route resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("route", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Route { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/routes/{route}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("route", new Google.Apis.Discovery.Parameter
                {
                    Name = "route",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified Route resource. Gets a list of available routes by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="route">Name of the Route resource to return.</param>
        public virtual GetRequest Get(string project, string route)
        {
            return new GetRequest(service, project, route);
        }

        /// <summary>
        /// Returns the specified Route resource. Gets a list of available routes by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Route>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string route) : base(service)
            {
                Project = project;
                Route = route;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the Route resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("route", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Route { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/routes/{route}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("route", new Google.Apis.Discovery.Parameter
                {
                    Name = "route",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Creates a Route resource in the specified project using the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Route body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>Creates a Route resource in the specified project using the data included in the request.</summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Route body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Route Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/routes";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of Route resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of Route resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.RouteList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/routes";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "securityPolicies" collection of methods.</summary>
    public class SecurityPoliciesResource
    {
        private const string Resource = "securityPolicies";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public SecurityPoliciesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Inserts a rule into a security policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="securityPolicy">Name of the security policy to update.</param>
        public virtual AddRuleRequest AddRule(Google.Apis.Compute.v1.Data.SecurityPolicyRule body, string project, string securityPolicy)
        {
            return new AddRuleRequest(service, body, project, securityPolicy);
        }

        /// <summary>Inserts a rule into a security policy.</summary>
        public class AddRuleRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddRule request.</summary>
            public AddRuleRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SecurityPolicyRule body, string project, string securityPolicy) : base(service)
            {
                Project = project;
                SecurityPolicy = securityPolicy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the security policy to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("securityPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SecurityPolicy { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SecurityPolicyRule Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addRule";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/securityPolicies/{securityPolicy}/addRule";

            /// <summary>Initializes AddRule parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("securityPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "securityPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Deletes the specified policy.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="securityPolicy">Name of the security policy to delete.</param>
        public virtual DeleteRequest Delete(string project, string securityPolicy)
        {
            return new DeleteRequest(service, project, securityPolicy);
        }

        /// <summary>Deletes the specified policy.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string securityPolicy) : base(service)
            {
                Project = project;
                SecurityPolicy = securityPolicy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the security policy to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("securityPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SecurityPolicy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/securityPolicies/{securityPolicy}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("securityPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "securityPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>List all of the ordered rules present in a single specified policy.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="securityPolicy">Name of the security policy to get.</param>
        public virtual GetRequest Get(string project, string securityPolicy)
        {
            return new GetRequest(service, project, securityPolicy);
        }

        /// <summary>List all of the ordered rules present in a single specified policy.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SecurityPolicy>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string securityPolicy) : base(service)
            {
                Project = project;
                SecurityPolicy = securityPolicy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the security policy to get.</summary>
            [Google.Apis.Util.RequestParameterAttribute("securityPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SecurityPolicy { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/securityPolicies/{securityPolicy}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("securityPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "securityPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Gets a rule at the specified priority.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="securityPolicy">Name of the security policy to which the queried rule belongs.</param>
        public virtual GetRuleRequest GetRule(string project, string securityPolicy)
        {
            return new GetRuleRequest(service, project, securityPolicy);
        }

        /// <summary>Gets a rule at the specified priority.</summary>
        public class GetRuleRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SecurityPolicyRule>
        {
            /// <summary>Constructs a new GetRule request.</summary>
            public GetRuleRequest(Google.Apis.Services.IClientService service, string project, string securityPolicy) : base(service)
            {
                Project = project;
                SecurityPolicy = securityPolicy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the security policy to which the queried rule belongs.</summary>
            [Google.Apis.Util.RequestParameterAttribute("securityPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SecurityPolicy { get; private set; }

            /// <summary>The priority of the rule to get from the security policy.</summary>
            [Google.Apis.Util.RequestParameterAttribute("priority", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> Priority { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getRule";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/securityPolicies/{securityPolicy}/getRule";

            /// <summary>Initializes GetRule parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("securityPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "securityPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("priority", new Google.Apis.Discovery.Parameter
                {
                    Name = "priority",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Creates a new policy in the specified project using the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.SecurityPolicy body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>Creates a new policy in the specified project using the data included in the request.</summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SecurityPolicy body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SecurityPolicy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/securityPolicies";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>List all the policies that have been configured for the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>List all the policies that have been configured for the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SecurityPolicyList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/securityPolicies";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Gets the current list of preconfigured Web Application Firewall (WAF) expressions.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListPreconfiguredExpressionSetsRequest ListPreconfiguredExpressionSets(string project)
        {
            return new ListPreconfiguredExpressionSetsRequest(service, project);
        }

        /// <summary>Gets the current list of preconfigured Web Application Firewall (WAF) expressions.</summary>
        public class ListPreconfiguredExpressionSetsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SecurityPoliciesListPreconfiguredExpressionSetsResponse>
        {
            /// <summary>Constructs a new ListPreconfiguredExpressionSets request.</summary>
            public ListPreconfiguredExpressionSetsRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listPreconfiguredExpressionSets";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/securityPolicies/listPreconfiguredExpressionSets";

            /// <summary>Initializes ListPreconfiguredExpressionSets parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Patches the specified policy with the data included in the request. This cannot be used to be update the
        /// rules in the policy. Please use the per rule methods like addRule, patchRule, and removeRule instead.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="securityPolicy">Name of the security policy to update.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.SecurityPolicy body, string project, string securityPolicy)
        {
            return new PatchRequest(service, body, project, securityPolicy);
        }

        /// <summary>
        /// Patches the specified policy with the data included in the request. This cannot be used to be update the
        /// rules in the policy. Please use the per rule methods like addRule, patchRule, and removeRule instead.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SecurityPolicy body, string project, string securityPolicy) : base(service)
            {
                Project = project;
                SecurityPolicy = securityPolicy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the security policy to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("securityPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SecurityPolicy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SecurityPolicy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/securityPolicies/{securityPolicy}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("securityPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "securityPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Patches a rule at the specified priority.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="securityPolicy">Name of the security policy to update.</param>
        public virtual PatchRuleRequest PatchRule(Google.Apis.Compute.v1.Data.SecurityPolicyRule body, string project, string securityPolicy)
        {
            return new PatchRuleRequest(service, body, project, securityPolicy);
        }

        /// <summary>Patches a rule at the specified priority.</summary>
        public class PatchRuleRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new PatchRule request.</summary>
            public PatchRuleRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SecurityPolicyRule body, string project, string securityPolicy) : base(service)
            {
                Project = project;
                SecurityPolicy = securityPolicy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the security policy to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("securityPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SecurityPolicy { get; private set; }

            /// <summary>The priority of the rule to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("priority", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> Priority { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SecurityPolicyRule Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patchRule";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/securityPolicies/{securityPolicy}/patchRule";

            /// <summary>Initializes PatchRule parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("securityPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "securityPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("priority", new Google.Apis.Discovery.Parameter
                {
                    Name = "priority",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes a rule at the specified priority.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="securityPolicy">Name of the security policy to update.</param>
        public virtual RemoveRuleRequest RemoveRule(string project, string securityPolicy)
        {
            return new RemoveRuleRequest(service, project, securityPolicy);
        }

        /// <summary>Deletes a rule at the specified priority.</summary>
        public class RemoveRuleRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new RemoveRule request.</summary>
            public RemoveRuleRequest(Google.Apis.Services.IClientService service, string project, string securityPolicy) : base(service)
            {
                Project = project;
                SecurityPolicy = securityPolicy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the security policy to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("securityPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SecurityPolicy { get; private set; }

            /// <summary>The priority of the rule to remove from the security policy.</summary>
            [Google.Apis.Util.RequestParameterAttribute("priority", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> Priority { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "removeRule";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/securityPolicies/{securityPolicy}/removeRule";

            /// <summary>Initializes RemoveRule parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("securityPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "securityPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("priority", new Google.Apis.Discovery.Parameter
                {
                    Name = "priority",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "snapshots" collection of methods.</summary>
    public class SnapshotsResource
    {
        private const string Resource = "snapshots";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public SnapshotsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Deletes the specified Snapshot resource. Keep in mind that deleting a single snapshot might not necessarily
        /// delete all the data on that snapshot. If any data on the snapshot that is marked for deletion is needed for
        /// subsequent snapshots, the data will be moved to the next corresponding snapshot.  For more information, see
        /// Deleting snapshots.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="snapshot">Name of the Snapshot resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string snapshot)
        {
            return new DeleteRequest(service, project, snapshot);
        }

        /// <summary>
        /// Deletes the specified Snapshot resource. Keep in mind that deleting a single snapshot might not necessarily
        /// delete all the data on that snapshot. If any data on the snapshot that is marked for deletion is needed for
        /// subsequent snapshots, the data will be moved to the next corresponding snapshot.  For more information, see
        /// Deleting snapshots.
        /// </summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string snapshot) : base(service)
            {
                Project = project;
                Snapshot = snapshot;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the Snapshot resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("snapshot", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Snapshot { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/snapshots/{snapshot}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("snapshot", new Google.Apis.Discovery.Parameter
                {
                    Name = "snapshot",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified Snapshot resource. Gets a list of available snapshots by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="snapshot">Name of the Snapshot resource to return.</param>
        public virtual GetRequest Get(string project, string snapshot)
        {
            return new GetRequest(service, project, snapshot);
        }

        /// <summary>
        /// Returns the specified Snapshot resource. Gets a list of available snapshots by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Snapshot>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string snapshot) : base(service)
            {
                Project = project;
                Snapshot = snapshot;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the Snapshot resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("snapshot", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Snapshot { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/snapshots/{snapshot}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("snapshot", new Google.Apis.Discovery.Parameter
                {
                    Name = "snapshot",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual GetIamPolicyRequest GetIamPolicy(string project, string resource)
        {
            return new GetIamPolicyRequest(service, project, resource);
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        public class GetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new GetIamPolicy request.</summary>
            public GetIamPolicyRequest(Google.Apis.Services.IClientService service, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Requested IAM Policy version.</summary>
            [Google.Apis.Util.RequestParameterAttribute("optionsRequestedPolicyVersion", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> OptionsRequestedPolicyVersion { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/snapshots/{resource}/getIamPolicy";

            /// <summary>Initializes GetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("optionsRequestedPolicyVersion", new Google.Apis.Discovery.Parameter
                {
                    Name = "optionsRequestedPolicyVersion",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of Snapshot resources contained within the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of Snapshot resources contained within the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SnapshotList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/snapshots";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetIamPolicyRequest SetIamPolicy(Google.Apis.Compute.v1.Data.GlobalSetPolicyRequest body, string project, string resource)
        {
            return new SetIamPolicyRequest(service, body, project, resource);
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        public class SetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new SetIamPolicy request.</summary>
            public SetIamPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.GlobalSetPolicyRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.GlobalSetPolicyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/snapshots/{resource}/setIamPolicy";

            /// <summary>Initializes SetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Sets the labels on a snapshot. To learn more about labels, read the Labeling Resources documentation.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetLabelsRequest SetLabels(Google.Apis.Compute.v1.Data.GlobalSetLabelsRequest body, string project, string resource)
        {
            return new SetLabelsRequest(service, body, project, resource);
        }

        /// <summary>
        /// Sets the labels on a snapshot. To learn more about labels, read the Labeling Resources documentation.
        /// </summary>
        public class SetLabelsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetLabels request.</summary>
            public SetLabelsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.GlobalSetLabelsRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.GlobalSetLabelsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setLabels";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/snapshots/{resource}/setLabels";

            /// <summary>Initializes SetLabels parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string resource) : base(service)
            {
                Project = project;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/snapshots/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9_]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "sslCertificates" collection of methods.</summary>
    public class SslCertificatesResource
    {
        private const string Resource = "sslCertificates";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public SslCertificatesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Retrieves the list of all SslCertificate resources, regional and global, available to the specified project.
        /// </summary>
        /// <param name="project">Name of the project scoping this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>
        /// Retrieves the list of all SslCertificate resources, regional and global, available to the specified project.
        /// </summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SslCertificateAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Name of the project scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/sslCertificates";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified SslCertificate resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="sslCertificate">Name of the SslCertificate resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string sslCertificate)
        {
            return new DeleteRequest(service, project, sslCertificate);
        }

        /// <summary>Deletes the specified SslCertificate resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string sslCertificate) : base(service)
            {
                Project = project;
                SslCertificate = sslCertificate;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the SslCertificate resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("sslCertificate", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SslCertificate { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/sslCertificates/{sslCertificate}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("sslCertificate", new Google.Apis.Discovery.Parameter
                {
                    Name = "sslCertificate",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified SslCertificate resource. Gets a list of available SSL certificates by making a list()
        /// request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="sslCertificate">Name of the SslCertificate resource to return.</param>
        public virtual GetRequest Get(string project, string sslCertificate)
        {
            return new GetRequest(service, project, sslCertificate);
        }

        /// <summary>
        /// Returns the specified SslCertificate resource. Gets a list of available SSL certificates by making a list()
        /// request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SslCertificate>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string sslCertificate) : base(service)
            {
                Project = project;
                SslCertificate = sslCertificate;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the SslCertificate resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("sslCertificate", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SslCertificate { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/sslCertificates/{sslCertificate}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("sslCertificate", new Google.Apis.Discovery.Parameter
                {
                    Name = "sslCertificate",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a SslCertificate resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.SslCertificate body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a SslCertificate resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SslCertificate body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SslCertificate Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/sslCertificates";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of SslCertificate resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of SslCertificate resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SslCertificateList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/sslCertificates";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "sslPolicies" collection of methods.</summary>
    public class SslPoliciesResource
    {
        private const string Resource = "sslPolicies";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public SslPoliciesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Deletes the specified SSL policy. The SSL policy resource can be deleted only if it is not in use by any
        /// TargetHttpsProxy or TargetSslProxy resources.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="sslPolicy">
        /// Name of the SSL policy to delete. The name must be 1-63 characters long, and comply with RFC1035.
        /// </param>
        public virtual DeleteRequest Delete(string project, string sslPolicy)
        {
            return new DeleteRequest(service, project, sslPolicy);
        }

        /// <summary>
        /// Deletes the specified SSL policy. The SSL policy resource can be deleted only if it is not in use by any
        /// TargetHttpsProxy or TargetSslProxy resources.
        /// </summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string sslPolicy) : base(service)
            {
                Project = project;
                SslPolicy = sslPolicy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// Name of the SSL policy to delete. The name must be 1-63 characters long, and comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("sslPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SslPolicy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/sslPolicies/{sslPolicy}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("sslPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "sslPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Lists all of the ordered rules present in a single specified policy.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="sslPolicy">
        /// Name of the SSL policy to update. The name must be 1-63 characters long, and comply with RFC1035.
        /// </param>
        public virtual GetRequest Get(string project, string sslPolicy)
        {
            return new GetRequest(service, project, sslPolicy);
        }

        /// <summary>Lists all of the ordered rules present in a single specified policy.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SslPolicy>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string sslPolicy) : base(service)
            {
                Project = project;
                SslPolicy = sslPolicy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// Name of the SSL policy to update. The name must be 1-63 characters long, and comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("sslPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SslPolicy { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/sslPolicies/{sslPolicy}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("sslPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "sslPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified SSL policy resource. Gets a list of available SSL policies by making a list() request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.SslPolicy body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Returns the specified SSL policy resource. Gets a list of available SSL policies by making a list() request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SslPolicy body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SslPolicy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/sslPolicies";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Lists all the SSL policies that have been configured for the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Lists all the SSL policies that have been configured for the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SslPoliciesList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/sslPolicies";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Lists all features that can be specified in the SSL policy when using custom profile.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListAvailableFeaturesRequest ListAvailableFeatures(string project)
        {
            return new ListAvailableFeaturesRequest(service, project);
        }

        /// <summary>Lists all features that can be specified in the SSL policy when using custom profile.</summary>
        public class ListAvailableFeaturesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SslPoliciesListAvailableFeaturesResponse>
        {
            /// <summary>Constructs a new ListAvailableFeatures request.</summary>
            public ListAvailableFeaturesRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listAvailableFeatures";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/sslPolicies/listAvailableFeatures";

            /// <summary>Initializes ListAvailableFeatures parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Patches the specified SSL policy with the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="sslPolicy">
        /// Name of the SSL policy to update. The name must be 1-63 characters long, and comply with RFC1035.
        /// </param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.SslPolicy body, string project, string sslPolicy)
        {
            return new PatchRequest(service, body, project, sslPolicy);
        }

        /// <summary>Patches the specified SSL policy with the data included in the request.</summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SslPolicy body, string project, string sslPolicy) : base(service)
            {
                Project = project;
                SslPolicy = sslPolicy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// Name of the SSL policy to update. The name must be 1-63 characters long, and comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("sslPolicy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string SslPolicy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SslPolicy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/sslPolicies/{sslPolicy}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("sslPolicy", new Google.Apis.Discovery.Parameter
                {
                    Name = "sslPolicy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "subnetworks" collection of methods.</summary>
    public class SubnetworksResource
    {
        private const string Resource = "subnetworks";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public SubnetworksResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of subnetworks.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of subnetworks.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SubnetworkAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/subnetworks";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified subnetwork.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="subnetwork">Name of the Subnetwork resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string subnetwork)
        {
            return new DeleteRequest(service, project, region, subnetwork);
        }

        /// <summary>Deletes the specified subnetwork.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string subnetwork) : base(service)
            {
                Project = project;
                Region = region;
                Subnetwork = subnetwork;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Subnetwork resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("subnetwork", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Subnetwork { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/subnetworks/{subnetwork}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("subnetwork", new Google.Apis.Discovery.Parameter
                {
                    Name = "subnetwork",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Expands the IP CIDR range of the subnetwork to a specified value.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="subnetwork">Name of the Subnetwork resource to update.</param>
        public virtual ExpandIpCidrRangeRequest ExpandIpCidrRange(Google.Apis.Compute.v1.Data.SubnetworksExpandIpCidrRangeRequest body, string project, string region, string subnetwork)
        {
            return new ExpandIpCidrRangeRequest(service, body, project, region, subnetwork);
        }

        /// <summary>Expands the IP CIDR range of the subnetwork to a specified value.</summary>
        public class ExpandIpCidrRangeRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new ExpandIpCidrRange request.</summary>
            public ExpandIpCidrRangeRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SubnetworksExpandIpCidrRangeRequest body, string project, string region, string subnetwork) : base(service)
            {
                Project = project;
                Region = region;
                Subnetwork = subnetwork;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Subnetwork resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("subnetwork", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Subnetwork { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SubnetworksExpandIpCidrRangeRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "expandIpCidrRange";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/subnetworks/{subnetwork}/expandIpCidrRange";

            /// <summary>Initializes ExpandIpCidrRange parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("subnetwork", new Google.Apis.Discovery.Parameter
                {
                    Name = "subnetwork",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified subnetwork. Gets a list of available subnetworks list() request.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="subnetwork">Name of the Subnetwork resource to return.</param>
        public virtual GetRequest Get(string project, string region, string subnetwork)
        {
            return new GetRequest(service, project, region, subnetwork);
        }

        /// <summary>Returns the specified subnetwork. Gets a list of available subnetworks list() request.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Subnetwork>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string subnetwork) : base(service)
            {
                Project = project;
                Region = region;
                Subnetwork = subnetwork;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Subnetwork resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("subnetwork", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Subnetwork { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/subnetworks/{subnetwork}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("subnetwork", new Google.Apis.Discovery.Parameter
                {
                    Name = "subnetwork",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual GetIamPolicyRequest GetIamPolicy(string project, string region, string resource)
        {
            return new GetIamPolicyRequest(service, project, region, resource);
        }

        /// <summary>
        /// Gets the access control policy for a resource. May be empty if no such policy or resource exists.
        /// </summary>
        public class GetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new GetIamPolicy request.</summary>
            public GetIamPolicyRequest(Google.Apis.Services.IClientService service, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Requested IAM Policy version.</summary>
            [Google.Apis.Util.RequestParameterAttribute("optionsRequestedPolicyVersion", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> OptionsRequestedPolicyVersion { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/subnetworks/{resource}/getIamPolicy";

            /// <summary>Initializes GetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("optionsRequestedPolicyVersion", new Google.Apis.Discovery.Parameter
                {
                    Name = "optionsRequestedPolicyVersion",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Creates a subnetwork in the specified project using the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.Subnetwork body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>Creates a subnetwork in the specified project using the data included in the request.</summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Subnetwork body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Subnetwork Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/subnetworks";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of subnetworks available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves a list of subnetworks available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.SubnetworkList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/subnetworks";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves an aggregated list of all usable subnetworks in the project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListUsableRequest ListUsable(string project)
        {
            return new ListUsableRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of all usable subnetworks in the project.</summary>
        public class ListUsableRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.UsableSubnetworksAggregatedList>
        {
            /// <summary>Constructs a new ListUsable request.</summary>
            public ListUsableRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "listUsable";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/subnetworks/listUsable";

            /// <summary>Initializes ListUsable parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Patches the specified subnetwork with the data included in the request. Only certain fields can be updated
        /// with a patch request as indicated in the field descriptions. You must specify the current fingerprint of the
        /// subnetwork resource being patched.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="subnetwork">Name of the Subnetwork resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.Subnetwork body, string project, string region, string subnetwork)
        {
            return new PatchRequest(service, body, project, region, subnetwork);
        }

        /// <summary>
        /// Patches the specified subnetwork with the data included in the request. Only certain fields can be updated
        /// with a patch request as indicated in the field descriptions. You must specify the current fingerprint of the
        /// subnetwork resource being patched.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.Subnetwork body, string project, string region, string subnetwork) : base(service)
            {
                Project = project;
                Region = region;
                Subnetwork = subnetwork;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Subnetwork resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("subnetwork", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Subnetwork { get; private set; }

            /// <summary>
            /// The drain timeout specifies the upper bound in seconds on the amount of time allowed to drain
            /// connections from the current ACTIVE subnetwork to the current BACKUP subnetwork. The drain timeout is
            /// only applicable when the following conditions are true: - the subnetwork being patched has purpose =
            /// INTERNAL_HTTPS_LOAD_BALANCER - the subnetwork being patched has role = BACKUP - the patch request is
            /// setting the role to ACTIVE. Note that after this patch operation the roles of the ACTIVE and BACKUP
            /// subnetworks will be swapped.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("drainTimeoutSeconds", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<int> DrainTimeoutSeconds { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.Subnetwork Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/subnetworks/{subnetwork}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("subnetwork", new Google.Apis.Discovery.Parameter
                {
                    Name = "subnetwork",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("drainTimeoutSeconds", new Google.Apis.Discovery.Parameter
                {
                    Name = "drainTimeoutSeconds",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetIamPolicyRequest SetIamPolicy(Google.Apis.Compute.v1.Data.RegionSetPolicyRequest body, string project, string region, string resource)
        {
            return new SetIamPolicyRequest(service, body, project, region, resource);
        }

        /// <summary>Sets the access control policy on the specified resource. Replaces any existing policy.</summary>
        public class SetIamPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Policy>
        {
            /// <summary>Constructs a new SetIamPolicy request.</summary>
            public SetIamPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionSetPolicyRequest body, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionSetPolicyRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setIamPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/subnetworks/{resource}/setIamPolicy";

            /// <summary>Initializes SetIamPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Set whether VMs in this subnet can access Google services without assigning external IP addresses through
        /// Private Google Access.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="subnetwork">Name of the Subnetwork resource.</param>
        public virtual SetPrivateIpGoogleAccessRequest SetPrivateIpGoogleAccess(Google.Apis.Compute.v1.Data.SubnetworksSetPrivateIpGoogleAccessRequest body, string project, string region, string subnetwork)
        {
            return new SetPrivateIpGoogleAccessRequest(service, body, project, region, subnetwork);
        }

        /// <summary>
        /// Set whether VMs in this subnet can access Google services without assigning external IP addresses through
        /// Private Google Access.
        /// </summary>
        public class SetPrivateIpGoogleAccessRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetPrivateIpGoogleAccess request.</summary>
            public SetPrivateIpGoogleAccessRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SubnetworksSetPrivateIpGoogleAccessRequest body, string project, string region, string subnetwork) : base(service)
            {
                Project = project;
                Region = region;
                Subnetwork = subnetwork;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the Subnetwork resource.</summary>
            [Google.Apis.Util.RequestParameterAttribute("subnetwork", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Subnetwork { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SubnetworksSetPrivateIpGoogleAccessRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setPrivateIpGoogleAccess";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/subnetworks/{subnetwork}/setPrivateIpGoogleAccess";

            /// <summary>Initializes SetPrivateIpGoogleAccess parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("subnetwork", new Google.Apis.Discovery.Parameter
                {
                    Name = "subnetwork",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string region, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, region, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/subnetworks/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "targetGrpcProxies" collection of methods.</summary>
    public class TargetGrpcProxiesResource
    {
        private const string Resource = "targetGrpcProxies";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public TargetGrpcProxiesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified TargetGrpcProxy in the given scope</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetGrpcProxy">Name of the TargetGrpcProxy resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string targetGrpcProxy)
        {
            return new DeleteRequest(service, project, targetGrpcProxy);
        }

        /// <summary>Deletes the specified TargetGrpcProxy in the given scope</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string targetGrpcProxy) : base(service)
            {
                Project = project;
                TargetGrpcProxy = targetGrpcProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetGrpcProxy resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetGrpcProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetGrpcProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetGrpcProxies/{targetGrpcProxy}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetGrpcProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetGrpcProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns the specified TargetGrpcProxy resource in the given scope.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetGrpcProxy">Name of the TargetGrpcProxy resource to return.</param>
        public virtual GetRequest Get(string project, string targetGrpcProxy)
        {
            return new GetRequest(service, project, targetGrpcProxy);
        }

        /// <summary>Returns the specified TargetGrpcProxy resource in the given scope.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetGrpcProxy>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string targetGrpcProxy) : base(service)
            {
                Project = project;
                TargetGrpcProxy = targetGrpcProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetGrpcProxy resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetGrpcProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetGrpcProxy { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetGrpcProxies/{targetGrpcProxy}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetGrpcProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetGrpcProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a TargetGrpcProxy in the specified project in the given scope using the parameters that are included
        /// in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.TargetGrpcProxy body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a TargetGrpcProxy in the specified project in the given scope using the parameters that are included
        /// in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetGrpcProxy body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetGrpcProxy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetGrpcProxies";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Lists the TargetGrpcProxies for a project in the given scope.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Lists the TargetGrpcProxies for a project in the given scope.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetGrpcProxyList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetGrpcProxies";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Patches the specified TargetGrpcProxy resource with the data included in the request. This method supports
        /// PATCH semantics and uses JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetGrpcProxy">Name of the TargetGrpcProxy resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.TargetGrpcProxy body, string project, string targetGrpcProxy)
        {
            return new PatchRequest(service, body, project, targetGrpcProxy);
        }

        /// <summary>
        /// Patches the specified TargetGrpcProxy resource with the data included in the request. This method supports
        /// PATCH semantics and uses JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetGrpcProxy body, string project, string targetGrpcProxy) : base(service)
            {
                Project = project;
                TargetGrpcProxy = targetGrpcProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetGrpcProxy resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetGrpcProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetGrpcProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetGrpcProxy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetGrpcProxies/{targetGrpcProxy}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetGrpcProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetGrpcProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "targetHttpProxies" collection of methods.</summary>
    public class TargetHttpProxiesResource
    {
        private const string Resource = "targetHttpProxies";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public TargetHttpProxiesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Retrieves the list of all TargetHttpProxy resources, regional and global, available to the specified
        /// project.
        /// </summary>
        /// <param name="project">Name of the project scoping this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>
        /// Retrieves the list of all TargetHttpProxy resources, regional and global, available to the specified
        /// project.
        /// </summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetHttpProxyAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Name of the project scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/targetHttpProxies";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified TargetHttpProxy resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetHttpProxy">Name of the TargetHttpProxy resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string targetHttpProxy)
        {
            return new DeleteRequest(service, project, targetHttpProxy);
        }

        /// <summary>Deletes the specified TargetHttpProxy resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string targetHttpProxy) : base(service)
            {
                Project = project;
                TargetHttpProxy = targetHttpProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetHttpProxy resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetHttpProxies/{targetHttpProxy}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetHttpProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified TargetHttpProxy resource. Gets a list of available target HTTP proxies by making a
        /// list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetHttpProxy">Name of the TargetHttpProxy resource to return.</param>
        public virtual GetRequest Get(string project, string targetHttpProxy)
        {
            return new GetRequest(service, project, targetHttpProxy);
        }

        /// <summary>
        /// Returns the specified TargetHttpProxy resource. Gets a list of available target HTTP proxies by making a
        /// list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetHttpProxy>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string targetHttpProxy) : base(service)
            {
                Project = project;
                TargetHttpProxy = targetHttpProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetHttpProxy resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpProxy { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetHttpProxies/{targetHttpProxy}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetHttpProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a TargetHttpProxy resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.TargetHttpProxy body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a TargetHttpProxy resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetHttpProxy body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetHttpProxy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetHttpProxies";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of TargetHttpProxy resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of TargetHttpProxy resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetHttpProxyList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetHttpProxies";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Patches the specified TargetHttpProxy resource with the data included in the request. This method supports
        /// PATCH semantics and uses JSON merge patch format and processing rules. (== suppress_warning
        /// http-rest-shadowed ==)
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetHttpProxy">Name of the TargetHttpProxy resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.TargetHttpProxy body, string project, string targetHttpProxy)
        {
            return new PatchRequest(service, body, project, targetHttpProxy);
        }

        /// <summary>
        /// Patches the specified TargetHttpProxy resource with the data included in the request. This method supports
        /// PATCH semantics and uses JSON merge patch format and processing rules. (== suppress_warning
        /// http-rest-shadowed ==)
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetHttpProxy body, string project, string targetHttpProxy) : base(service)
            {
                Project = project;
                TargetHttpProxy = targetHttpProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetHttpProxy resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetHttpProxy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetHttpProxies/{targetHttpProxy}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetHttpProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Changes the URL map for TargetHttpProxy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetHttpProxy">Name of the TargetHttpProxy to set a URL map for.</param>
        public virtual SetUrlMapRequest SetUrlMap(Google.Apis.Compute.v1.Data.UrlMapReference body, string project, string targetHttpProxy)
        {
            return new SetUrlMapRequest(service, body, project, targetHttpProxy);
        }

        /// <summary>Changes the URL map for TargetHttpProxy.</summary>
        public class SetUrlMapRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetUrlMap request.</summary>
            public SetUrlMapRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.UrlMapReference body, string project, string targetHttpProxy) : base(service)
            {
                Project = project;
                TargetHttpProxy = targetHttpProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetHttpProxy to set a URL map for.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.UrlMapReference Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setUrlMap";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/targetHttpProxies/{targetHttpProxy}/setUrlMap";

            /// <summary>Initializes SetUrlMap parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetHttpProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "targetHttpsProxies" collection of methods.</summary>
    public class TargetHttpsProxiesResource
    {
        private const string Resource = "targetHttpsProxies";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public TargetHttpsProxiesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Retrieves the list of all TargetHttpsProxy resources, regional and global, available to the specified
        /// project.
        /// </summary>
        /// <param name="project">Name of the project scoping this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>
        /// Retrieves the list of all TargetHttpsProxy resources, regional and global, available to the specified
        /// project.
        /// </summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetHttpsProxyAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Name of the project scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/targetHttpsProxies";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified TargetHttpsProxy resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetHttpsProxy">Name of the TargetHttpsProxy resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string targetHttpsProxy)
        {
            return new DeleteRequest(service, project, targetHttpsProxy);
        }

        /// <summary>Deletes the specified TargetHttpsProxy resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string targetHttpsProxy) : base(service)
            {
                Project = project;
                TargetHttpsProxy = targetHttpsProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetHttpsProxy resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpsProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpsProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetHttpsProxies/{targetHttpsProxy}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetHttpsProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpsProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified TargetHttpsProxy resource. Gets a list of available target HTTPS proxies by making a
        /// list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetHttpsProxy">Name of the TargetHttpsProxy resource to return.</param>
        public virtual GetRequest Get(string project, string targetHttpsProxy)
        {
            return new GetRequest(service, project, targetHttpsProxy);
        }

        /// <summary>
        /// Returns the specified TargetHttpsProxy resource. Gets a list of available target HTTPS proxies by making a
        /// list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetHttpsProxy>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string targetHttpsProxy) : base(service)
            {
                Project = project;
                TargetHttpsProxy = targetHttpsProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetHttpsProxy resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpsProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpsProxy { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetHttpsProxies/{targetHttpsProxy}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetHttpsProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpsProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a TargetHttpsProxy resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.TargetHttpsProxy body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a TargetHttpsProxy resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetHttpsProxy body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetHttpsProxy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetHttpsProxies";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of TargetHttpsProxy resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of TargetHttpsProxy resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetHttpsProxyList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetHttpsProxies";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Patches the specified TargetHttpsProxy resource with the data included in the request. This method supports
        /// PATCH semantics and uses JSON merge patch format and processing rules. (== suppress_warning
        /// http-rest-shadowed ==)
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetHttpsProxy">Name of the TargetHttpsProxy resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.TargetHttpsProxy body, string project, string targetHttpsProxy)
        {
            return new PatchRequest(service, body, project, targetHttpsProxy);
        }

        /// <summary>
        /// Patches the specified TargetHttpsProxy resource with the data included in the request. This method supports
        /// PATCH semantics and uses JSON merge patch format and processing rules. (== suppress_warning
        /// http-rest-shadowed ==)
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetHttpsProxy body, string project, string targetHttpsProxy) : base(service)
            {
                Project = project;
                TargetHttpsProxy = targetHttpsProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetHttpsProxy resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpsProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpsProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetHttpsProxy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetHttpsProxies/{targetHttpsProxy}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetHttpsProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpsProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Sets the QUIC override policy for TargetHttpsProxy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetHttpsProxy">
        /// Name of the TargetHttpsProxy resource to set the QUIC override policy for. The name should conform to
        /// RFC1035.
        /// </param>
        public virtual SetQuicOverrideRequest SetQuicOverride(Google.Apis.Compute.v1.Data.TargetHttpsProxiesSetQuicOverrideRequest body, string project, string targetHttpsProxy)
        {
            return new SetQuicOverrideRequest(service, body, project, targetHttpsProxy);
        }

        /// <summary>Sets the QUIC override policy for TargetHttpsProxy.</summary>
        public class SetQuicOverrideRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetQuicOverride request.</summary>
            public SetQuicOverrideRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetHttpsProxiesSetQuicOverrideRequest body, string project, string targetHttpsProxy) : base(service)
            {
                Project = project;
                TargetHttpsProxy = targetHttpsProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// Name of the TargetHttpsProxy resource to set the QUIC override policy for. The name should conform to
            /// RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpsProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpsProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetHttpsProxiesSetQuicOverrideRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setQuicOverride";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetHttpsProxies/{targetHttpsProxy}/setQuicOverride";

            /// <summary>Initializes SetQuicOverride parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetHttpsProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpsProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Replaces SslCertificates for TargetHttpsProxy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetHttpsProxy">
        /// Name of the TargetHttpsProxy resource to set an SslCertificates resource for.
        /// </param>
        public virtual SetSslCertificatesRequest SetSslCertificates(Google.Apis.Compute.v1.Data.TargetHttpsProxiesSetSslCertificatesRequest body, string project, string targetHttpsProxy)
        {
            return new SetSslCertificatesRequest(service, body, project, targetHttpsProxy);
        }

        /// <summary>Replaces SslCertificates for TargetHttpsProxy.</summary>
        public class SetSslCertificatesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetSslCertificates request.</summary>
            public SetSslCertificatesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetHttpsProxiesSetSslCertificatesRequest body, string project, string targetHttpsProxy) : base(service)
            {
                Project = project;
                TargetHttpsProxy = targetHttpsProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetHttpsProxy resource to set an SslCertificates resource for.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpsProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpsProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetHttpsProxiesSetSslCertificatesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setSslCertificates";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/targetHttpsProxies/{targetHttpsProxy}/setSslCertificates";

            /// <summary>Initializes SetSslCertificates parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetHttpsProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpsProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets the SSL policy for TargetHttpsProxy. The SSL policy specifies the server-side support for SSL features.
        /// This affects connections between clients and the HTTPS proxy load balancer. They do not affect the
        /// connection between the load balancer and the backends.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetHttpsProxy">
        /// Name of the TargetHttpsProxy resource whose SSL policy is to be set. The name must be 1-63 characters long,
        /// and comply with RFC1035.
        /// </param>
        public virtual SetSslPolicyRequest SetSslPolicy(Google.Apis.Compute.v1.Data.SslPolicyReference body, string project, string targetHttpsProxy)
        {
            return new SetSslPolicyRequest(service, body, project, targetHttpsProxy);
        }

        /// <summary>
        /// Sets the SSL policy for TargetHttpsProxy. The SSL policy specifies the server-side support for SSL features.
        /// This affects connections between clients and the HTTPS proxy load balancer. They do not affect the
        /// connection between the load balancer and the backends.
        /// </summary>
        public class SetSslPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetSslPolicy request.</summary>
            public SetSslPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SslPolicyReference body, string project, string targetHttpsProxy) : base(service)
            {
                Project = project;
                TargetHttpsProxy = targetHttpsProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// Name of the TargetHttpsProxy resource whose SSL policy is to be set. The name must be 1-63 characters
            /// long, and comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpsProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpsProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SslPolicyReference Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setSslPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetHttpsProxies/{targetHttpsProxy}/setSslPolicy";

            /// <summary>Initializes SetSslPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetHttpsProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpsProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Changes the URL map for TargetHttpsProxy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetHttpsProxy">Name of the TargetHttpsProxy resource whose URL map is to be set.</param>
        public virtual SetUrlMapRequest SetUrlMap(Google.Apis.Compute.v1.Data.UrlMapReference body, string project, string targetHttpsProxy)
        {
            return new SetUrlMapRequest(service, body, project, targetHttpsProxy);
        }

        /// <summary>Changes the URL map for TargetHttpsProxy.</summary>
        public class SetUrlMapRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetUrlMap request.</summary>
            public SetUrlMapRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.UrlMapReference body, string project, string targetHttpsProxy) : base(service)
            {
                Project = project;
                TargetHttpsProxy = targetHttpsProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetHttpsProxy resource whose URL map is to be set.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetHttpsProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetHttpsProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.UrlMapReference Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setUrlMap";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/targetHttpsProxies/{targetHttpsProxy}/setUrlMap";

            /// <summary>Initializes SetUrlMap parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetHttpsProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetHttpsProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "targetInstances" collection of methods.</summary>
    public class TargetInstancesResource
    {
        private const string Resource = "targetInstances";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public TargetInstancesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of target instances.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of target instances.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetInstanceAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/targetInstances";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified TargetInstance resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone scoping this request.</param>
        /// <param name="targetInstance">Name of the TargetInstance resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string zone, string targetInstance)
        {
            return new DeleteRequest(service, project, zone, targetInstance);
        }

        /// <summary>Deletes the specified TargetInstance resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string zone, string targetInstance) : base(service)
            {
                Project = project;
                Zone = zone;
                TargetInstance = targetInstance;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the TargetInstance resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetInstance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetInstance { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/targetInstances/{targetInstance}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetInstance", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetInstance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified TargetInstance resource. Gets a list of available target instances by making a list()
        /// request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone scoping this request.</param>
        /// <param name="targetInstance">Name of the TargetInstance resource to return.</param>
        public virtual GetRequest Get(string project, string zone, string targetInstance)
        {
            return new GetRequest(service, project, zone, targetInstance);
        }

        /// <summary>
        /// Returns the specified TargetInstance resource. Gets a list of available target instances by making a list()
        /// request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetInstance>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string targetInstance) : base(service)
            {
                Project = project;
                Zone = zone;
                TargetInstance = targetInstance;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the TargetInstance resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetInstance", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetInstance { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/targetInstances/{targetInstance}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetInstance", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetInstance",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a TargetInstance resource in the specified project and zone using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.TargetInstance body, string project, string zone)
        {
            return new InsertRequest(service, body, project, zone);
        }

        /// <summary>
        /// Creates a TargetInstance resource in the specified project and zone using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetInstance body, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetInstance Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/targetInstances";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of TargetInstance resources available to the specified project and zone.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone scoping this request.</param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>Retrieves a list of TargetInstance resources available to the specified project and zone.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetInstanceList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/targetInstances";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "targetPools" collection of methods.</summary>
    public class TargetPoolsResource
    {
        private const string Resource = "targetPools";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public TargetPoolsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Adds health check URLs to a target pool.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetPool">Name of the target pool to add a health check to.</param>
        public virtual AddHealthCheckRequest AddHealthCheck(Google.Apis.Compute.v1.Data.TargetPoolsAddHealthCheckRequest body, string project, string region, string targetPool)
        {
            return new AddHealthCheckRequest(service, body, project, region, targetPool);
        }

        /// <summary>Adds health check URLs to a target pool.</summary>
        public class AddHealthCheckRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddHealthCheck request.</summary>
            public AddHealthCheckRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetPoolsAddHealthCheckRequest body, string project, string region, string targetPool) : base(service)
            {
                Project = project;
                Region = region;
                TargetPool = targetPool;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the target pool to add a health check to.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetPool", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetPool { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetPoolsAddHealthCheckRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addHealthCheck";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetPools/{targetPool}/addHealthCheck";

            /// <summary>Initializes AddHealthCheck parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetPool", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetPool",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Adds an instance to a target pool.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetPool">Name of the TargetPool resource to add instances to.</param>
        public virtual AddInstanceRequest AddInstance(Google.Apis.Compute.v1.Data.TargetPoolsAddInstanceRequest body, string project, string region, string targetPool)
        {
            return new AddInstanceRequest(service, body, project, region, targetPool);
        }

        /// <summary>Adds an instance to a target pool.</summary>
        public class AddInstanceRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new AddInstance request.</summary>
            public AddInstanceRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetPoolsAddInstanceRequest body, string project, string region, string targetPool) : base(service)
            {
                Project = project;
                Region = region;
                TargetPool = targetPool;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the TargetPool resource to add instances to.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetPool", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetPool { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetPoolsAddInstanceRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "addInstance";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetPools/{targetPool}/addInstance";

            /// <summary>Initializes AddInstance parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetPool", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetPool",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves an aggregated list of target pools.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of target pools.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetPoolAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/targetPools";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified target pool.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetPool">Name of the TargetPool resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string targetPool)
        {
            return new DeleteRequest(service, project, region, targetPool);
        }

        /// <summary>Deletes the specified target pool.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string targetPool) : base(service)
            {
                Project = project;
                Region = region;
                TargetPool = targetPool;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the TargetPool resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetPool", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetPool { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetPools/{targetPool}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetPool", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetPool",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified target pool. Gets a list of available target pools by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetPool">Name of the TargetPool resource to return.</param>
        public virtual GetRequest Get(string project, string region, string targetPool)
        {
            return new GetRequest(service, project, region, targetPool);
        }

        /// <summary>
        /// Returns the specified target pool. Gets a list of available target pools by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetPool>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string targetPool) : base(service)
            {
                Project = project;
                Region = region;
                TargetPool = targetPool;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the TargetPool resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetPool", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetPool { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetPools/{targetPool}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetPool", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetPool",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Gets the most recent health check results for each IP for the instance that is referenced by the given
        /// target pool.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetPool">Name of the TargetPool resource to which the queried instance belongs.</param>
        public virtual GetHealthRequest GetHealth(Google.Apis.Compute.v1.Data.InstanceReference body, string project, string region, string targetPool)
        {
            return new GetHealthRequest(service, body, project, region, targetPool);
        }

        /// <summary>
        /// Gets the most recent health check results for each IP for the instance that is referenced by the given
        /// target pool.
        /// </summary>
        public class GetHealthRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetPoolInstanceHealth>
        {
            /// <summary>Constructs a new GetHealth request.</summary>
            public GetHealthRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.InstanceReference body, string project, string region, string targetPool) : base(service)
            {
                Project = project;
                Region = region;
                TargetPool = targetPool;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the TargetPool resource to which the queried instance belongs.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetPool", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetPool { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.InstanceReference Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getHealth";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetPools/{targetPool}/getHealth";

            /// <summary>Initializes GetHealth parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetPool", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetPool",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a target pool in the specified project and region using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.TargetPool body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a target pool in the specified project and region using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetPool body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetPool Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetPools";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of target pools available to the specified project and region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves a list of target pools available to the specified project and region.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetPoolList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetPools";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Removes health check URL from a target pool.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="targetPool">Name of the target pool to remove health checks from.</param>
        public virtual RemoveHealthCheckRequest RemoveHealthCheck(Google.Apis.Compute.v1.Data.TargetPoolsRemoveHealthCheckRequest body, string project, string region, string targetPool)
        {
            return new RemoveHealthCheckRequest(service, body, project, region, targetPool);
        }

        /// <summary>Removes health check URL from a target pool.</summary>
        public class RemoveHealthCheckRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new RemoveHealthCheck request.</summary>
            public RemoveHealthCheckRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetPoolsRemoveHealthCheckRequest body, string project, string region, string targetPool) : base(service)
            {
                Project = project;
                Region = region;
                TargetPool = targetPool;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the target pool to remove health checks from.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetPool", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetPool { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetPoolsRemoveHealthCheckRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "removeHealthCheck";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetPools/{targetPool}/removeHealthCheck";

            /// <summary>Initializes RemoveHealthCheck parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetPool", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetPool",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Removes instance URL from a target pool.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetPool">Name of the TargetPool resource to remove instances from.</param>
        public virtual RemoveInstanceRequest RemoveInstance(Google.Apis.Compute.v1.Data.TargetPoolsRemoveInstanceRequest body, string project, string region, string targetPool)
        {
            return new RemoveInstanceRequest(service, body, project, region, targetPool);
        }

        /// <summary>Removes instance URL from a target pool.</summary>
        public class RemoveInstanceRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new RemoveInstance request.</summary>
            public RemoveInstanceRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetPoolsRemoveInstanceRequest body, string project, string region, string targetPool) : base(service)
            {
                Project = project;
                Region = region;
                TargetPool = targetPool;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the TargetPool resource to remove instances from.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetPool", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetPool { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetPoolsRemoveInstanceRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "removeInstance";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetPools/{targetPool}/removeInstance";

            /// <summary>Initializes RemoveInstance parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetPool", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetPool",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Changes a backup target pool's configurations.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region scoping this request.</param>
        /// <param name="targetPool">Name of the TargetPool resource to set a backup pool for.</param>
        public virtual SetBackupRequest SetBackup(Google.Apis.Compute.v1.Data.TargetReference body, string project, string region, string targetPool)
        {
            return new SetBackupRequest(service, body, project, region, targetPool);
        }

        /// <summary>Changes a backup target pool's configurations.</summary>
        public class SetBackupRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetBackup request.</summary>
            public SetBackupRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetReference body, string project, string region, string targetPool) : base(service)
            {
                Project = project;
                Region = region;
                TargetPool = targetPool;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the TargetPool resource to set a backup pool for.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetPool", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetPool { get; private set; }

            /// <summary>New failoverRatio value for the target pool.</summary>
            [Google.Apis.Util.RequestParameterAttribute("failoverRatio", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<float> FailoverRatio { get; set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetReference Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setBackup";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetPools/{targetPool}/setBackup";

            /// <summary>Initializes SetBackup parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetPool", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetPool",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("failoverRatio", new Google.Apis.Discovery.Parameter
                {
                    Name = "failoverRatio",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "targetSslProxies" collection of methods.</summary>
    public class TargetSslProxiesResource
    {
        private const string Resource = "targetSslProxies";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public TargetSslProxiesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified TargetSslProxy resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetSslProxy">Name of the TargetSslProxy resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string targetSslProxy)
        {
            return new DeleteRequest(service, project, targetSslProxy);
        }

        /// <summary>Deletes the specified TargetSslProxy resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string targetSslProxy) : base(service)
            {
                Project = project;
                TargetSslProxy = targetSslProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetSslProxy resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetSslProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetSslProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetSslProxies/{targetSslProxy}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetSslProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetSslProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified TargetSslProxy resource. Gets a list of available target SSL proxies by making a
        /// list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetSslProxy">Name of the TargetSslProxy resource to return.</param>
        public virtual GetRequest Get(string project, string targetSslProxy)
        {
            return new GetRequest(service, project, targetSslProxy);
        }

        /// <summary>
        /// Returns the specified TargetSslProxy resource. Gets a list of available target SSL proxies by making a
        /// list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetSslProxy>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string targetSslProxy) : base(service)
            {
                Project = project;
                TargetSslProxy = targetSslProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetSslProxy resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetSslProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetSslProxy { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetSslProxies/{targetSslProxy}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetSslProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetSslProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a TargetSslProxy resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.TargetSslProxy body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a TargetSslProxy resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetSslProxy body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetSslProxy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetSslProxies";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of TargetSslProxy resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of TargetSslProxy resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetSslProxyList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetSslProxies";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Changes the BackendService for TargetSslProxy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetSslProxy">
        /// Name of the TargetSslProxy resource whose BackendService resource is to be set.
        /// </param>
        public virtual SetBackendServiceRequest SetBackendService(Google.Apis.Compute.v1.Data.TargetSslProxiesSetBackendServiceRequest body, string project, string targetSslProxy)
        {
            return new SetBackendServiceRequest(service, body, project, targetSslProxy);
        }

        /// <summary>Changes the BackendService for TargetSslProxy.</summary>
        public class SetBackendServiceRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetBackendService request.</summary>
            public SetBackendServiceRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetSslProxiesSetBackendServiceRequest body, string project, string targetSslProxy) : base(service)
            {
                Project = project;
                TargetSslProxy = targetSslProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetSslProxy resource whose BackendService resource is to be set.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetSslProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetSslProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetSslProxiesSetBackendServiceRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setBackendService";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetSslProxies/{targetSslProxy}/setBackendService";

            /// <summary>Initializes SetBackendService parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetSslProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetSslProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Changes the ProxyHeaderType for TargetSslProxy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetSslProxy">Name of the TargetSslProxy resource whose ProxyHeader is to be set.</param>
        public virtual SetProxyHeaderRequest SetProxyHeader(Google.Apis.Compute.v1.Data.TargetSslProxiesSetProxyHeaderRequest body, string project, string targetSslProxy)
        {
            return new SetProxyHeaderRequest(service, body, project, targetSslProxy);
        }

        /// <summary>Changes the ProxyHeaderType for TargetSslProxy.</summary>
        public class SetProxyHeaderRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetProxyHeader request.</summary>
            public SetProxyHeaderRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetSslProxiesSetProxyHeaderRequest body, string project, string targetSslProxy) : base(service)
            {
                Project = project;
                TargetSslProxy = targetSslProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetSslProxy resource whose ProxyHeader is to be set.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetSslProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetSslProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetSslProxiesSetProxyHeaderRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setProxyHeader";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetSslProxies/{targetSslProxy}/setProxyHeader";

            /// <summary>Initializes SetProxyHeader parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetSslProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetSslProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Changes SslCertificates for TargetSslProxy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetSslProxy">
        /// Name of the TargetSslProxy resource whose SslCertificate resource is to be set.
        /// </param>
        public virtual SetSslCertificatesRequest SetSslCertificates(Google.Apis.Compute.v1.Data.TargetSslProxiesSetSslCertificatesRequest body, string project, string targetSslProxy)
        {
            return new SetSslCertificatesRequest(service, body, project, targetSslProxy);
        }

        /// <summary>Changes SslCertificates for TargetSslProxy.</summary>
        public class SetSslCertificatesRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetSslCertificates request.</summary>
            public SetSslCertificatesRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetSslProxiesSetSslCertificatesRequest body, string project, string targetSslProxy) : base(service)
            {
                Project = project;
                TargetSslProxy = targetSslProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetSslProxy resource whose SslCertificate resource is to be set.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetSslProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetSslProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetSslProxiesSetSslCertificatesRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setSslCertificates";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetSslProxies/{targetSslProxy}/setSslCertificates";

            /// <summary>Initializes SetSslCertificates parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetSslProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetSslProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets the SSL policy for TargetSslProxy. The SSL policy specifies the server-side support for SSL features.
        /// This affects connections between clients and the SSL proxy load balancer. They do not affect the connection
        /// between the load balancer and the backends.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetSslProxy">
        /// Name of the TargetSslProxy resource whose SSL policy is to be set. The name must be 1-63 characters long,
        /// and comply with RFC1035.
        /// </param>
        public virtual SetSslPolicyRequest SetSslPolicy(Google.Apis.Compute.v1.Data.SslPolicyReference body, string project, string targetSslProxy)
        {
            return new SetSslPolicyRequest(service, body, project, targetSslProxy);
        }

        /// <summary>
        /// Sets the SSL policy for TargetSslProxy. The SSL policy specifies the server-side support for SSL features.
        /// This affects connections between clients and the SSL proxy load balancer. They do not affect the connection
        /// between the load balancer and the backends.
        /// </summary>
        public class SetSslPolicyRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetSslPolicy request.</summary>
            public SetSslPolicyRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.SslPolicyReference body, string project, string targetSslProxy) : base(service)
            {
                Project = project;
                TargetSslProxy = targetSslProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// Name of the TargetSslProxy resource whose SSL policy is to be set. The name must be 1-63 characters
            /// long, and comply with RFC1035.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("targetSslProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetSslProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.SslPolicyReference Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setSslPolicy";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetSslProxies/{targetSslProxy}/setSslPolicy";

            /// <summary>Initializes SetSslPolicy parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetSslProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetSslProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "targetTcpProxies" collection of methods.</summary>
    public class TargetTcpProxiesResource
    {
        private const string Resource = "targetTcpProxies";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public TargetTcpProxiesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified TargetTcpProxy resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetTcpProxy">Name of the TargetTcpProxy resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string targetTcpProxy)
        {
            return new DeleteRequest(service, project, targetTcpProxy);
        }

        /// <summary>Deletes the specified TargetTcpProxy resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string targetTcpProxy) : base(service)
            {
                Project = project;
                TargetTcpProxy = targetTcpProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetTcpProxy resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetTcpProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetTcpProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetTcpProxies/{targetTcpProxy}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetTcpProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetTcpProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified TargetTcpProxy resource. Gets a list of available target TCP proxies by making a
        /// list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetTcpProxy">Name of the TargetTcpProxy resource to return.</param>
        public virtual GetRequest Get(string project, string targetTcpProxy)
        {
            return new GetRequest(service, project, targetTcpProxy);
        }

        /// <summary>
        /// Returns the specified TargetTcpProxy resource. Gets a list of available target TCP proxies by making a
        /// list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetTcpProxy>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string targetTcpProxy) : base(service)
            {
                Project = project;
                TargetTcpProxy = targetTcpProxy;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetTcpProxy resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetTcpProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetTcpProxy { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetTcpProxies/{targetTcpProxy}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetTcpProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetTcpProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a TargetTcpProxy resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.TargetTcpProxy body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a TargetTcpProxy resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetTcpProxy body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetTcpProxy Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetTcpProxies";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of TargetTcpProxy resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of TargetTcpProxy resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetTcpProxyList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetTcpProxies";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Changes the BackendService for TargetTcpProxy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetTcpProxy">
        /// Name of the TargetTcpProxy resource whose BackendService resource is to be set.
        /// </param>
        public virtual SetBackendServiceRequest SetBackendService(Google.Apis.Compute.v1.Data.TargetTcpProxiesSetBackendServiceRequest body, string project, string targetTcpProxy)
        {
            return new SetBackendServiceRequest(service, body, project, targetTcpProxy);
        }

        /// <summary>Changes the BackendService for TargetTcpProxy.</summary>
        public class SetBackendServiceRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetBackendService request.</summary>
            public SetBackendServiceRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetTcpProxiesSetBackendServiceRequest body, string project, string targetTcpProxy) : base(service)
            {
                Project = project;
                TargetTcpProxy = targetTcpProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetTcpProxy resource whose BackendService resource is to be set.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetTcpProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetTcpProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetTcpProxiesSetBackendServiceRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setBackendService";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetTcpProxies/{targetTcpProxy}/setBackendService";

            /// <summary>Initializes SetBackendService parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetTcpProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetTcpProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Changes the ProxyHeaderType for TargetTcpProxy.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="targetTcpProxy">Name of the TargetTcpProxy resource whose ProxyHeader is to be set.</param>
        public virtual SetProxyHeaderRequest SetProxyHeader(Google.Apis.Compute.v1.Data.TargetTcpProxiesSetProxyHeaderRequest body, string project, string targetTcpProxy)
        {
            return new SetProxyHeaderRequest(service, body, project, targetTcpProxy);
        }

        /// <summary>Changes the ProxyHeaderType for TargetTcpProxy.</summary>
        public class SetProxyHeaderRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetProxyHeader request.</summary>
            public SetProxyHeaderRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetTcpProxiesSetProxyHeaderRequest body, string project, string targetTcpProxy) : base(service)
            {
                Project = project;
                TargetTcpProxy = targetTcpProxy;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the TargetTcpProxy resource whose ProxyHeader is to be set.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetTcpProxy", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetTcpProxy { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetTcpProxiesSetProxyHeaderRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setProxyHeader";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/targetTcpProxies/{targetTcpProxy}/setProxyHeader";

            /// <summary>Initializes SetProxyHeader parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("targetTcpProxy", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetTcpProxy",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "targetVpnGateways" collection of methods.</summary>
    public class TargetVpnGatewaysResource
    {
        private const string Resource = "targetVpnGateways";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public TargetVpnGatewaysResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of target VPN gateways.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of target VPN gateways.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetVpnGatewayAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/targetVpnGateways";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified target VPN gateway.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="targetVpnGateway">Name of the target VPN gateway to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string targetVpnGateway)
        {
            return new DeleteRequest(service, project, region, targetVpnGateway);
        }

        /// <summary>Deletes the specified target VPN gateway.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string targetVpnGateway) : base(service)
            {
                Project = project;
                Region = region;
                TargetVpnGateway = targetVpnGateway;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the target VPN gateway to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetVpnGateway", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetVpnGateway { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetVpnGateways/{targetVpnGateway}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetVpnGateway", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetVpnGateway",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified target VPN gateway. Gets a list of available target VPN gateways by making a list()
        /// request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="targetVpnGateway">Name of the target VPN gateway to return.</param>
        public virtual GetRequest Get(string project, string region, string targetVpnGateway)
        {
            return new GetRequest(service, project, region, targetVpnGateway);
        }

        /// <summary>
        /// Returns the specified target VPN gateway. Gets a list of available target VPN gateways by making a list()
        /// request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetVpnGateway>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string targetVpnGateway) : base(service)
            {
                Project = project;
                Region = region;
                TargetVpnGateway = targetVpnGateway;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the target VPN gateway to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("targetVpnGateway", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string TargetVpnGateway { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetVpnGateways/{targetVpnGateway}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("targetVpnGateway", new Google.Apis.Discovery.Parameter
                {
                    Name = "targetVpnGateway",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a target VPN gateway in the specified project and region using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.TargetVpnGateway body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a target VPN gateway in the specified project and region using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TargetVpnGateway body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TargetVpnGateway Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetVpnGateways";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of target VPN gateways available to the specified project and region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves a list of target VPN gateways available to the specified project and region.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TargetVpnGatewayList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/targetVpnGateways";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "urlMaps" collection of methods.</summary>
    public class UrlMapsResource
    {
        private const string Resource = "urlMaps";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public UrlMapsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Retrieves the list of all UrlMap resources, regional and global, available to the specified project.
        /// </summary>
        /// <param name="project">Name of the project scoping this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>
        /// Retrieves the list of all UrlMap resources, regional and global, available to the specified project.
        /// </summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.UrlMapsAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Name of the project scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/urlMaps";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified UrlMap resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="urlMap">Name of the UrlMap resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string urlMap)
        {
            return new DeleteRequest(service, project, urlMap);
        }

        /// <summary>Deletes the specified UrlMap resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string urlMap) : base(service)
            {
                Project = project;
                UrlMap = urlMap;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the UrlMap resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("urlMap", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string UrlMap { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/urlMaps/{urlMap}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("urlMap", new Google.Apis.Discovery.Parameter
                {
                    Name = "urlMap",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified UrlMap resource. Gets a list of available URL maps by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="urlMap">Name of the UrlMap resource to return.</param>
        public virtual GetRequest Get(string project, string urlMap)
        {
            return new GetRequest(service, project, urlMap);
        }

        /// <summary>
        /// Returns the specified UrlMap resource. Gets a list of available URL maps by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.UrlMap>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string urlMap) : base(service)
            {
                Project = project;
                UrlMap = urlMap;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the UrlMap resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("urlMap", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string UrlMap { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/urlMaps/{urlMap}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("urlMap", new Google.Apis.Discovery.Parameter
                {
                    Name = "urlMap",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a UrlMap resource in the specified project using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.UrlMap body, string project)
        {
            return new InsertRequest(service, body, project);
        }

        /// <summary>
        /// Creates a UrlMap resource in the specified project using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.UrlMap body, string project) : base(service)
            {
                Project = project;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.UrlMap Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/urlMaps";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Initiates a cache invalidation operation, invalidating the specified path, scoped to the specified UrlMap.
        /// For more information, see [Invalidating cached content](/cdn/docs/invalidating-cached-content).
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="urlMap">Name of the UrlMap scoping this request.</param>
        public virtual InvalidateCacheRequest InvalidateCache(Google.Apis.Compute.v1.Data.CacheInvalidationRule body, string project, string urlMap)
        {
            return new InvalidateCacheRequest(service, body, project, urlMap);
        }

        /// <summary>
        /// Initiates a cache invalidation operation, invalidating the specified path, scoped to the specified UrlMap.
        /// For more information, see [Invalidating cached content](/cdn/docs/invalidating-cached-content).
        /// </summary>
        public class InvalidateCacheRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new InvalidateCache request.</summary>
            public InvalidateCacheRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.CacheInvalidationRule body, string project, string urlMap) : base(service)
            {
                Project = project;
                UrlMap = urlMap;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the UrlMap scoping this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("urlMap", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string UrlMap { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.CacheInvalidationRule Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "invalidateCache";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/urlMaps/{urlMap}/invalidateCache";

            /// <summary>Initializes InvalidateCache parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("urlMap", new Google.Apis.Discovery.Parameter
                {
                    Name = "urlMap",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves the list of UrlMap resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of UrlMap resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.UrlMapList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/urlMaps";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Patches the specified UrlMap resource with the data included in the request. This method supports PATCH
        /// semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="urlMap">Name of the UrlMap resource to patch.</param>
        public virtual PatchRequest Patch(Google.Apis.Compute.v1.Data.UrlMap body, string project, string urlMap)
        {
            return new PatchRequest(service, body, project, urlMap);
        }

        /// <summary>
        /// Patches the specified UrlMap resource with the data included in the request. This method supports PATCH
        /// semantics and uses the JSON merge patch format and processing rules.
        /// </summary>
        public class PatchRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Patch request.</summary>
            public PatchRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.UrlMap body, string project, string urlMap) : base(service)
            {
                Project = project;
                UrlMap = urlMap;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the UrlMap resource to patch.</summary>
            [Google.Apis.Util.RequestParameterAttribute("urlMap", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string UrlMap { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.UrlMap Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "patch";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PATCH";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/urlMaps/{urlMap}";

            /// <summary>Initializes Patch parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("urlMap", new Google.Apis.Discovery.Parameter
                {
                    Name = "urlMap",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Updates the specified UrlMap resource with the data included in the request.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="urlMap">Name of the UrlMap resource to update.</param>
        public virtual UpdateRequest Update(Google.Apis.Compute.v1.Data.UrlMap body, string project, string urlMap)
        {
            return new UpdateRequest(service, body, project, urlMap);
        }

        /// <summary>Updates the specified UrlMap resource with the data included in the request.</summary>
        public class UpdateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Update request.</summary>
            public UpdateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.UrlMap body, string project, string urlMap) : base(service)
            {
                Project = project;
                UrlMap = urlMap;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the UrlMap resource to update.</summary>
            [Google.Apis.Util.RequestParameterAttribute("urlMap", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string UrlMap { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.UrlMap Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "update";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "PUT";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/urlMaps/{urlMap}";

            /// <summary>Initializes Update parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("urlMap", new Google.Apis.Discovery.Parameter
                {
                    Name = "urlMap",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Runs static validation for the UrlMap. In particular, the tests of the provided UrlMap will be run. Calling
        /// this method does NOT create the UrlMap.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="urlMap">Name of the UrlMap resource to be validated as.</param>
        public virtual ValidateRequest Validate(Google.Apis.Compute.v1.Data.UrlMapsValidateRequest body, string project, string urlMap)
        {
            return new ValidateRequest(service, body, project, urlMap);
        }

        /// <summary>
        /// Runs static validation for the UrlMap. In particular, the tests of the provided UrlMap will be run. Calling
        /// this method does NOT create the UrlMap.
        /// </summary>
        public class ValidateRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.UrlMapsValidateResponse>
        {
            /// <summary>Constructs a new Validate request.</summary>
            public ValidateRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.UrlMapsValidateRequest body, string project, string urlMap) : base(service)
            {
                Project = project;
                UrlMap = urlMap;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the UrlMap resource to be validated as.</summary>
            [Google.Apis.Util.RequestParameterAttribute("urlMap", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string UrlMap { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.UrlMapsValidateRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "validate";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/global/urlMaps/{urlMap}/validate";

            /// <summary>Initializes Validate parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("urlMap", new Google.Apis.Discovery.Parameter
                {
                    Name = "urlMap",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "vpnGateways" collection of methods.</summary>
    public class VpnGatewaysResource
    {
        private const string Resource = "vpnGateways";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public VpnGatewaysResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of VPN gateways.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of VPN gateways.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.VpnGatewayAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/vpnGateways";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified VPN gateway.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="vpnGateway">Name of the VPN gateway to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string vpnGateway)
        {
            return new DeleteRequest(service, project, region, vpnGateway);
        }

        /// <summary>Deletes the specified VPN gateway.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string vpnGateway) : base(service)
            {
                Project = project;
                Region = region;
                VpnGateway = vpnGateway;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the VPN gateway to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("vpnGateway", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string VpnGateway { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/vpnGateways/{vpnGateway}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("vpnGateway", new Google.Apis.Discovery.Parameter
                {
                    Name = "vpnGateway",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified VPN gateway. Gets a list of available VPN gateways by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="vpnGateway">Name of the VPN gateway to return.</param>
        public virtual GetRequest Get(string project, string region, string vpnGateway)
        {
            return new GetRequest(service, project, region, vpnGateway);
        }

        /// <summary>
        /// Returns the specified VPN gateway. Gets a list of available VPN gateways by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.VpnGateway>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string vpnGateway) : base(service)
            {
                Project = project;
                Region = region;
                VpnGateway = vpnGateway;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the VPN gateway to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("vpnGateway", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string VpnGateway { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/vpnGateways/{vpnGateway}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("vpnGateway", new Google.Apis.Discovery.Parameter
                {
                    Name = "vpnGateway",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Returns the status for the specified VPN gateway.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="vpnGateway">Name of the VPN gateway to return.</param>
        public virtual GetStatusRequest GetStatus(string project, string region, string vpnGateway)
        {
            return new GetStatusRequest(service, project, region, vpnGateway);
        }

        /// <summary>Returns the status for the specified VPN gateway.</summary>
        public class GetStatusRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.VpnGatewaysGetStatusResponse>
        {
            /// <summary>Constructs a new GetStatus request.</summary>
            public GetStatusRequest(Google.Apis.Services.IClientService service, string project, string region, string vpnGateway) : base(service)
            {
                Project = project;
                Region = region;
                VpnGateway = vpnGateway;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the VPN gateway to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("vpnGateway", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string VpnGateway { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "getStatus";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/vpnGateways/{vpnGateway}/getStatus";

            /// <summary>Initializes GetStatus parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("vpnGateway", new Google.Apis.Discovery.Parameter
                {
                    Name = "vpnGateway",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a VPN gateway in the specified project and region using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.VpnGateway body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a VPN gateway in the specified project and region using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.VpnGateway body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.VpnGateway Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/vpnGateways";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of VPN gateways available to the specified project and region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves a list of VPN gateways available to the specified project and region.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.VpnGatewayList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/vpnGateways";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Sets the labels on a VpnGateway. To learn more about labels, read the Labeling Resources documentation.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual SetLabelsRequest SetLabels(Google.Apis.Compute.v1.Data.RegionSetLabelsRequest body, string project, string region, string resource)
        {
            return new SetLabelsRequest(service, body, project, region, resource);
        }

        /// <summary>
        /// Sets the labels on a VpnGateway. To learn more about labels, read the Labeling Resources documentation.
        /// </summary>
        public class SetLabelsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new SetLabels request.</summary>
            public SetLabelsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.RegionSetLabelsRequest body, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.RegionSetLabelsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "setLabels";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/vpnGateways/{resource}/setLabels";

            /// <summary>Initializes SetLabels parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">The name of the region for this request.</param>
        /// <param name="resource">Name or id of the resource for this request.</param>
        public virtual TestIamPermissionsRequest TestIamPermissions(Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string region, string resource)
        {
            return new TestIamPermissionsRequest(service, body, project, region, resource);
        }

        /// <summary>Returns permissions that a caller has on the specified resource.</summary>
        public class TestIamPermissionsRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.TestPermissionsResponse>
        {
            /// <summary>Constructs a new TestIamPermissions request.</summary>
            public TestIamPermissionsRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.TestPermissionsRequest body, string project, string region, string resource) : base(service)
            {
                Project = project;
                Region = region;
                Resource = resource;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>The name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name or id of the resource for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("resource", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Resource { get; private set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.TestPermissionsRequest Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "testIamPermissions";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/vpnGateways/{resource}/testIamPermissions";

            /// <summary>Initializes TestIamPermissions parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("resource", new Google.Apis.Discovery.Parameter
                {
                    Name = "resource",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "vpnTunnels" collection of methods.</summary>
    public class VpnTunnelsResource
    {
        private const string Resource = "vpnTunnels";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public VpnTunnelsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Retrieves an aggregated list of VPN tunnels.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual AggregatedListRequest AggregatedList(string project)
        {
            return new AggregatedListRequest(service, project);
        }

        /// <summary>Retrieves an aggregated list of VPN tunnels.</summary>
        public class AggregatedListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.VpnTunnelAggregatedList>
        {
            /// <summary>Constructs a new AggregatedList request.</summary>
            public AggregatedListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// Indicates whether every visible scope for each scope type (zone, region, global) should be included in
            /// the response. For new resource types added after this field, the flag has no effect as new resource
            /// types will always include every visible scope for each scope type in response. For resource types which
            /// predate this field, if this flag is omitted or false, only scopes of the scope types where the resource
            /// type is expected to be found will be included.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("includeAllScopes", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> IncludeAllScopes { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "aggregatedList";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/aggregated/vpnTunnels";

            /// <summary>Initializes AggregatedList parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("includeAllScopes", new Google.Apis.Discovery.Parameter
                {
                    Name = "includeAllScopes",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Deletes the specified VpnTunnel resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="vpnTunnel">Name of the VpnTunnel resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string region, string vpnTunnel)
        {
            return new DeleteRequest(service, project, region, vpnTunnel);
        }

        /// <summary>Deletes the specified VpnTunnel resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string region, string vpnTunnel) : base(service)
            {
                Project = project;
                Region = region;
                VpnTunnel = vpnTunnel;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the VpnTunnel resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("vpnTunnel", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string VpnTunnel { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/vpnTunnels/{vpnTunnel}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("vpnTunnel", new Google.Apis.Discovery.Parameter
                {
                    Name = "vpnTunnel",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Returns the specified VpnTunnel resource. Gets a list of available VPN tunnels by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        /// <param name="vpnTunnel">Name of the VpnTunnel resource to return.</param>
        public virtual GetRequest Get(string project, string region, string vpnTunnel)
        {
            return new GetRequest(service, project, region, vpnTunnel);
        }

        /// <summary>
        /// Returns the specified VpnTunnel resource. Gets a list of available VPN tunnels by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.VpnTunnel>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string region, string vpnTunnel) : base(service)
            {
                Project = project;
                Region = region;
                VpnTunnel = vpnTunnel;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>Name of the VpnTunnel resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("vpnTunnel", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string VpnTunnel { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/vpnTunnels/{vpnTunnel}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("vpnTunnel", new Google.Apis.Discovery.Parameter
                {
                    Name = "vpnTunnel",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>
        /// Creates a VpnTunnel resource in the specified project and region using the data included in the request.
        /// </summary>
        /// <param name="body">The body of the request.</param>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual InsertRequest Insert(Google.Apis.Compute.v1.Data.VpnTunnel body, string project, string region)
        {
            return new InsertRequest(service, body, project, region);
        }

        /// <summary>
        /// Creates a VpnTunnel resource in the specified project and region using the data included in the request.
        /// </summary>
        public class InsertRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Insert request.</summary>
            public InsertRequest(Google.Apis.Services.IClientService service, Google.Apis.Compute.v1.Data.VpnTunnel body, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                Body = body;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// An optional request ID to identify requests. Specify a unique request ID so that if you must retry your
            /// request, the server will know to ignore the request if it has already been completed.  For example,
            /// consider a situation where you make an initial request and the request times out. If you make the
            /// request again with the same request ID, the server can check if original operation with the same request
            /// ID was received, and if so, will ignore the second request. This prevents clients from accidentally
            /// creating duplicate commitments.  The request ID must be a valid UUID with the exception that zero UUID
            /// is not supported (00000000-0000-0000-0000-000000000000).
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("requestId", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string RequestId { get; set; }

            /// <summary>Gets or sets the body of this request.</summary>
            Google.Apis.Compute.v1.Data.VpnTunnel Body { get; set; }

            /// <summary>Returns the body of the request.</summary>
            protected override object GetBody() => Body;

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "insert";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/vpnTunnels";

            /// <summary>Initializes Insert parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("requestId", new Google.Apis.Discovery.Parameter
                {
                    Name = "requestId",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>Retrieves a list of VpnTunnel resources contained in the specified project and region.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="region">Name of the region for this request.</param>
        public virtual ListRequest List(string project, string region)
        {
            return new ListRequest(service, project, region);
        }

        /// <summary>Retrieves a list of VpnTunnel resources contained in the specified project and region.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.VpnTunnelList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string region) : base(service)
            {
                Project = project;
                Region = region;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the region for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("region", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Region { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/regions/{region}/vpnTunnels";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("region", new Google.Apis.Discovery.Parameter
                {
                    Name = "region",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }

    /// <summary>The "zoneOperations" collection of methods.</summary>
    public class ZoneOperationsResource
    {
        private const string Resource = "zoneOperations";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public ZoneOperationsResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>Deletes the specified zone-specific Operations resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        /// <param name="operation">Name of the Operations resource to delete.</param>
        public virtual DeleteRequest Delete(string project, string zone, string operation)
        {
            return new DeleteRequest(service, project, zone, operation);
        }

        /// <summary>Deletes the specified zone-specific Operations resource.</summary>
        public class DeleteRequest : ComputeBaseServiceRequest<string>
        {
            /// <summary>Constructs a new Delete request.</summary>
            public DeleteRequest(Google.Apis.Services.IClientService service, string project, string zone, string operation) : base(service)
            {
                Project = project;
                Zone = zone;
                Operation = operation;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the Operations resource to delete.</summary>
            [Google.Apis.Util.RequestParameterAttribute("operation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Operation { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "delete";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "DELETE";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/operations/{operation}";

            /// <summary>Initializes Delete parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("operation", new Google.Apis.Discovery.Parameter
                {
                    Name = "operation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves the specified zone-specific Operations resource.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        /// <param name="operation">Name of the Operations resource to return.</param>
        public virtual GetRequest Get(string project, string zone, string operation)
        {
            return new GetRequest(service, project, zone, operation);
        }

        /// <summary>Retrieves the specified zone-specific Operations resource.</summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone, string operation) : base(service)
            {
                Project = project;
                Zone = zone;
                Operation = operation;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the Operations resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("operation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Operation { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/operations/{operation}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("operation", new Google.Apis.Discovery.Parameter
                {
                    Name = "operation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves a list of Operation resources contained within the specified zone.</summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for request.</param>
        public virtual ListRequest List(string project, string zone)
        {
            return new ListRequest(service, project, zone);
        }

        /// <summary>Retrieves a list of Operation resources contained within the specified zone.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.OperationList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/operations";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }

        /// <summary>
        /// Waits for the specified Operation resource to return as `DONE` or for the request to approach the 2 minute
        /// deadline, and retrieves the specified Operation resource. This method differs from the `GET` method in that
        /// it waits for no more than the default deadline (2 minutes) and then returns the current state of the
        /// operation, which might be `DONE` or still in progress.  This method is called on a best-effort basis.
        /// Specifically:   - In uncommon cases, when the server is overloaded, the request might return before the
        /// default deadline is reached, or might return after zero seconds.  - If the default deadline is reached,
        /// there is no guarantee that the operation is actually done when the method returns. Be prepared to retry if
        /// the operation is not `DONE`.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone for this request.</param>
        /// <param name="operation">Name of the Operations resource to return.</param>
        public virtual WaitRequest Wait(string project, string zone, string operation)
        {
            return new WaitRequest(service, project, zone, operation);
        }

        /// <summary>
        /// Waits for the specified Operation resource to return as `DONE` or for the request to approach the 2 minute
        /// deadline, and retrieves the specified Operation resource. This method differs from the `GET` method in that
        /// it waits for no more than the default deadline (2 minutes) and then returns the current state of the
        /// operation, which might be `DONE` or still in progress.  This method is called on a best-effort basis.
        /// Specifically:   - In uncommon cases, when the server is overloaded, the request might return before the
        /// default deadline is reached, or might return after zero seconds.  - If the default deadline is reached,
        /// there is no guarantee that the operation is actually done when the method returns. Be prepared to retry if
        /// the operation is not `DONE`.
        /// </summary>
        public class WaitRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Operation>
        {
            /// <summary>Constructs a new Wait request.</summary>
            public WaitRequest(Google.Apis.Services.IClientService service, string project, string zone, string operation) : base(service)
            {
                Project = project;
                Zone = zone;
                Operation = operation;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Name of the Operations resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("operation", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Operation { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "wait";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "POST";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}/operations/{operation}/wait";

            /// <summary>Initializes Wait parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?",
                });
                RequestParameters.Add("operation", new Google.Apis.Discovery.Parameter
                {
                    Name = "operation",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }
    }

    /// <summary>The "zones" collection of methods.</summary>
    public class ZonesResource
    {
        private const string Resource = "zones";

        /// <summary>The service which this resource belongs to.</summary>
        private readonly Google.Apis.Services.IClientService service;

        /// <summary>Constructs a new resource.</summary>
        public ZonesResource(Google.Apis.Services.IClientService service)
        {
            this.service = service;
        }

        /// <summary>
        /// Returns the specified Zone resource. Gets a list of available zones by making a list() request.
        /// </summary>
        /// <param name="project">Project ID for this request.</param>
        /// <param name="zone">Name of the zone resource to return.</param>
        public virtual GetRequest Get(string project, string zone)
        {
            return new GetRequest(service, project, zone);
        }

        /// <summary>
        /// Returns the specified Zone resource. Gets a list of available zones by making a list() request.
        /// </summary>
        public class GetRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.Zone>
        {
            /// <summary>Constructs a new Get request.</summary>
            public GetRequest(Google.Apis.Services.IClientService service, string project, string zone) : base(service)
            {
                Project = project;
                Zone = zone;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>Name of the zone resource to return.</summary>
            [Google.Apis.Util.RequestParameterAttribute("zone", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Zone { get; private set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "get";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones/{zone}";

            /// <summary>Initializes Get parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("zone", new Google.Apis.Discovery.Parameter
                {
                    Name = "zone",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?|[1-9][0-9]{0,19}",
                });
            }
        }

        /// <summary>Retrieves the list of Zone resources available to the specified project.</summary>
        /// <param name="project">Project ID for this request.</param>
        public virtual ListRequest List(string project)
        {
            return new ListRequest(service, project);
        }

        /// <summary>Retrieves the list of Zone resources available to the specified project.</summary>
        public class ListRequest : ComputeBaseServiceRequest<Google.Apis.Compute.v1.Data.ZoneList>
        {
            /// <summary>Constructs a new List request.</summary>
            public ListRequest(Google.Apis.Services.IClientService service, string project) : base(service)
            {
                Project = project;
                InitParameters();
            }

            /// <summary>Project ID for this request.</summary>
            [Google.Apis.Util.RequestParameterAttribute("project", Google.Apis.Util.RequestParameterType.Path)]
            public virtual string Project { get; private set; }

            /// <summary>
            /// A filter expression that filters resources listed in the response. The expression must specify the field
            /// name, a comparison operator, and the value that you want to use for filtering. The value must be a
            /// string, a number, or a boolean. The comparison operator must be either `=`, `!=`, `&amp;gt;`, or
            /// `&amp;lt;`.  For example, if you are filtering Compute Engine instances, you can exclude instances named
            /// `example-instance` by specifying `name != example-instance`.  You can also filter nested fields. For
            /// example, you could specify `scheduling.automaticRestart = false` to include instances only if they are
            /// not scheduled for automatic restarts. You can use filtering on nested fields to filter based on resource
            /// labels.  To filter on multiple expressions, provide each separate expression within parentheses. For
            /// example: ``` (scheduling.automaticRestart = true) (cpuPlatform = "Intel Skylake") ``` By default, each
            /// expression is an `AND` expression. However, you can include `AND` and `OR` expressions explicitly. For
            /// example: ``` (cpuPlatform = "Intel Skylake") OR (cpuPlatform = "Intel Broadwell") AND
            /// (scheduling.automaticRestart = true) ```
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("filter", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string Filter { get; set; }

            /// <summary>
            /// The maximum number of results per page that should be returned. If the number of available results is
            /// larger than `maxResults`, Compute Engine returns a `nextPageToken` that can be used to get the next page
            /// of results in subsequent list requests. Acceptable values are `0` to `500`, inclusive. (Default: `500`)
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("maxResults", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<long> MaxResults { get; set; }

            /// <summary>
            /// Sorts list results by a certain order. By default, results are returned in alphanumerical order based on
            /// the resource name.  You can also sort results in descending order based on the creation timestamp using
            /// `orderBy="creationTimestamp desc"`. This sorts results based on the `creationTimestamp` field in reverse
            /// chronological order (newest result first). Use this to sort resources like operations so that the newest
            /// operation is returned first.  Currently, only sorting by `name` or `creationTimestamp desc` is
            /// supported.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("orderBy", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string OrderBy { get; set; }

            /// <summary>
            /// Specifies a page token to use. Set `pageToken` to the `nextPageToken` returned by a previous list
            /// request to get the next page of results.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("pageToken", Google.Apis.Util.RequestParameterType.Query)]
            public virtual string PageToken { get; set; }

            /// <summary>
            /// Opt-in for partial success behavior which provides partial results in case of failure. The default value
            /// is false.
            /// </summary>
            [Google.Apis.Util.RequestParameterAttribute("returnPartialSuccess", Google.Apis.Util.RequestParameterType.Query)]
            public virtual System.Nullable<bool> ReturnPartialSuccess { get; set; }

            /// <summary>Gets the method name.</summary>
            public override string MethodName => "list";

            /// <summary>Gets the HTTP method.</summary>
            public override string HttpMethod => "GET";

            /// <summary>Gets the REST path.</summary>
            public override string RestPath => "projects/{project}/zones";

            /// <summary>Initializes List parameter list.</summary>
            protected override void InitParameters()
            {
                base.InitParameters();
                RequestParameters.Add("project", new Google.Apis.Discovery.Parameter
                {
                    Name = "project",
                    IsRequired = true,
                    ParameterType = "path",
                    DefaultValue = null,
                    Pattern = @"(?:(?:[-a-z0-9]{1,63}\.)*(?:[a-z](?:[-a-z0-9]{0,61}[a-z0-9])?):)?(?:[0-9]{1,19}|(?:[a-z0-9](?:[-a-z0-9]{0,61}[a-z0-9])?))",
                });
                RequestParameters.Add("filter", new Google.Apis.Discovery.Parameter
                {
                    Name = "filter",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("maxResults", new Google.Apis.Discovery.Parameter
                {
                    Name = "maxResults",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = "500",
                    Pattern = null,
                });
                RequestParameters.Add("orderBy", new Google.Apis.Discovery.Parameter
                {
                    Name = "orderBy",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("pageToken", new Google.Apis.Discovery.Parameter
                {
                    Name = "pageToken",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
                RequestParameters.Add("returnPartialSuccess", new Google.Apis.Discovery.Parameter
                {
                    Name = "returnPartialSuccess",
                    IsRequired = false,
                    ParameterType = "query",
                    DefaultValue = null,
                    Pattern = null,
                });
            }
        }
    }
}
namespace Google.Apis.Compute.v1.Data
{
    /// <summary>A specification of the type and number of accelerator cards attached to the instance.</summary>
    public class AcceleratorConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The number of the guest accelerator cards exposed to this instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("acceleratorCount")]
        public virtual System.Nullable<int> AcceleratorCount { get; set; }

        /// <summary>
        /// Full or partial URL of the accelerator type resource to attach to this instance. For example:
        /// projects/my-project/zones/us-central1-c/acceleratorTypes/nvidia-tesla-p100 If you are creating an instance
        /// template, specify only the accelerator name. See GPUs on Compute Engine for a full list of accelerator
        /// types.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("acceleratorType")]
        public virtual string AcceleratorType { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents an Accelerator Type resource.  Google Cloud Platform provides graphics processing units
    /// (accelerators) that you can add to VM instances to improve or accelerate performance when working with intensive
    /// workloads. For more information, read GPUs on Compute Engine. (== resource_for {$api_version}.acceleratorTypes
    /// ==)
    /// </summary>
    public class AcceleratorType : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>[Output Only] The deprecation status associated with this accelerator type.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("deprecated")]
        public virtual DeprecationStatus Deprecated { get; set; }

        /// <summary>[Output Only] An optional textual description of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// [Output Only] The type of the resource. Always compute#acceleratorType for accelerator types.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>[Output Only] Maximum number of accelerator cards allowed per instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maximumCardsPerInstance")]
        public virtual System.Nullable<int> MaximumCardsPerInstance { get; set; }

        /// <summary>[Output Only] Name of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] Server-defined, fully qualified URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// [Output Only] The name of the zone where the accelerator type resides, such as us-central1-a. You must
        /// specify this field as part of the HTTP request URL. It is not settable as a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class AcceleratorTypeAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of AcceleratorTypesScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, AcceleratorTypesScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#acceleratorTypeAggregatedList for aggregated lists of
        /// accelerator types.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of accelerator types.</summary>
    public class AcceleratorTypeList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of AcceleratorType resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<AcceleratorType> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#acceleratorTypeList for lists of accelerator types.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class AcceleratorTypesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of accelerator types contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("acceleratorTypes")]
        public virtual System.Collections.Generic.IList<AcceleratorType> AcceleratorTypes { get; set; }

        /// <summary>
        /// [Output Only] An informational warning that appears when the accelerator types list is empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] An informational warning that appears when the accelerator types list is empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// An access configuration attached to an instance's network interface. Only one access config per instance is
    /// supported.
    /// </summary>
    public class AccessConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Type of the resource. Always compute#accessConfig for access configs.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// The name of this access configuration. The default and recommended name is External NAT, but you can use any
        /// arbitrary string, such as My external IP or Network Access.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// An external IP address associated with this instance. Specify an unused static external IP address available
        /// to the project or leave this field undefined to use an IP from a shared ephemeral IP address pool. If you
        /// specify a static external IP address, it must live in the same region as the zone of the instance.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("natIP")]
        public virtual string NatIP { get; set; }

        /// <summary>
        /// This signifies the networking tier used for configuring this access configuration and can only take the
        /// following values: PREMIUM, STANDARD.  If an AccessConfig is specified without a valid external IP address,
        /// an ephemeral IP will be created with this networkTier.  If an AccessConfig with a valid external IP address
        /// is specified, it must match that of the networkTier associated with the Address resource owning that IP.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkTier")]
        public virtual string NetworkTier { get; set; }

        /// <summary>
        /// The DNS domain name for the public PTR record. You can set this field only if the `setPublicPtr` field is
        /// enabled.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("publicPtrDomainName")]
        public virtual string PublicPtrDomainName { get; set; }

        /// <summary>
        /// Specifies whether a public DNS 'PTR' record should be created to map the external IP address of the instance
        /// to a DNS domain name.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("setPublicPtr")]
        public virtual System.Nullable<bool> SetPublicPtr { get; set; }

        /// <summary>The type of configuration. The default and only option is ONE_TO_ONE_NAT.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Use global external addresses for GFE-based external HTTP(S) load balancers in Premium Tier.  Use global
    /// internal addresses for reserved peering network range.  Use regional external addresses for the following
    /// resources:  - External IP addresses for VM instances - Regional external forwarding rules - Cloud NAT external
    /// IP addresses - GFE based LBs in Standard Tier - Network LBs in Premium or Standard Tier - Cloud VPN gateways
    /// (both Classic and HA)  Use regional internal IP addresses for subnet IP ranges (primary and secondary). This
    /// includes:  - Internal IP addresses for VM instances - Alias IP ranges of VM instances (/32 only) - Regional
    /// internal forwarding rules - Internal TCP/UDP load balancer addresses - Internal HTTP(S) load balancer addresses
    /// - Cloud DNS inbound forwarding IP addresses  For more information, read reserved IP address.  (== resource_for
    /// {$api_version}.addresses ==) (== resource_for {$api_version}.globalAddresses ==)
    /// </summary>
    public class Address : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The static IP address represented by this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("address")]
        public virtual string AddressValue { get; set; }

        /// <summary>
        /// The type of address to reserve, either INTERNAL or EXTERNAL. If unspecified, defaults to EXTERNAL.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("addressType")]
        public virtual string AddressType { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this field when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// The IP version that will be used by this address. Valid options are IPV4 or IPV6. This can only be specified
        /// for a global address.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipVersion")]
        public virtual string IpVersion { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#address for addresses.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?`. The first character must be a lowercase letter, and all following
        /// characters (except for the last character) must be a dash, lowercase letter, or digit. The last character
        /// must be a lowercase letter or digit.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// The URL of the network in which to reserve the address. This field can only be used with INTERNAL type with
        /// the VPC_PEERING purpose.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>
        /// This signifies the networking tier used for configuring this address and can only take the following values:
        /// PREMIUM or STANDARD. Global forwarding rules can only be Premium Tier. Regional forwarding rules can be
        /// either Premium or Standard Tier. Standard Tier addresses applied to regional forwarding rules can be used
        /// with any external load balancer. Regional forwarding rules in Premium Tier can only be used with a network
        /// load balancer.  If this field is not specified, it is assumed to be PREMIUM.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkTier")]
        public virtual string NetworkTier { get; set; }

        /// <summary>The prefix length if the resource represents an IP range.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("prefixLength")]
        public virtual System.Nullable<int> PrefixLength { get; set; }

        /// <summary>
        /// The purpose of this resource, which can be one of the following values:   - `GCE_ENDPOINT` for addresses
        /// that are used by VM instances, alias IP ranges, internal load balancers, and similar resources.  -
        /// `DNS_RESOLVER` for a DNS resolver address in a subnetwork  - `VPC_PEERING` for addresses that are reserved
        /// for VPC peer networks.  - `NAT_AUTO` for addresses that are external IP addresses automatically reserved for
        /// Cloud NAT.  - `IPSEC_INTERCONNECT` for addresses created from a private IP range that are reserved for a
        /// VLAN attachment in an IPsec-encrypted Cloud Interconnect configuration. These addresses are regional
        /// resources.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("purpose")]
        public virtual string Purpose { get; set; }

        /// <summary>
        /// [Output Only] The URL of the region where a regional address resides. For regional addresses, you must
        /// specify the region as a path parameter in the HTTP request URL. This field is not applicable to global
        /// addresses.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// [Output Only] The status of the address, which can be one of RESERVING, RESERVED, or IN_USE. An address that
        /// is RESERVING is currently in the process of being reserved. A RESERVED address is currently reserved and
        /// available to use. An IN_USE address is currently being used by another resource and is not available.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>
        /// The URL of the subnetwork in which to reserve the address. If an IP address is specified, it must be within
        /// the subnetwork's IP range. This field can only be used with INTERNAL type with a GCE_ENDPOINT or
        /// DNS_RESOLVER purpose.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("subnetwork")]
        public virtual string Subnetwork { get; set; }

        /// <summary>[Output Only] The URLs of the resources that are using this address.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("users")]
        public virtual System.Collections.Generic.IList<string> Users { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class AddressAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of AddressesScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, AddressesScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#addressAggregatedList for aggregated lists of addresses.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of addresses.</summary>
    public class AddressList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Address resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Address> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#addressList for lists of addresses.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class AddressesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of addresses contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("addresses")]
        public virtual System.Collections.Generic.IList<Address> Addresses { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of addresses when the list is empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of addresses when the list is empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Specifies options for controlling advanced machine features. Options that would traditionally be configured in a
    /// BIOS belong here. Features that require operating system support may have corresponding entries in the
    /// GuestOsFeatures of an Image (e.g., whether or not the OS in the Image supports nested virtualization being
    /// enabled or disabled).
    /// </summary>
    public class AdvancedMachineFeatures : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Whether to enable nested virtualization or not (default is false).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enableNestedVirtualization")]
        public virtual System.Nullable<bool> EnableNestedVirtualization { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>An alias IP range attached to an instance's network interface.</summary>
    public class AliasIpRange : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The IP alias ranges to allocate for this interface. This IP CIDR range must belong to the specified
        /// subnetwork and cannot contain IP addresses reserved by system or used by other network interfaces. This
        /// range may be a single IP address (such as 10.2.3.4), a netmask (such as /24) or a CIDR-formatted string
        /// (such as 10.1.2.0/24).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipCidrRange")]
        public virtual string IpCidrRange { get; set; }

        /// <summary>
        /// The name of a subnetwork secondary IP range from which to allocate an IP alias range. If not specified, the
        /// primary range of the subnetwork is used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("subnetworkRangeName")]
        public virtual string SubnetworkRangeName { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Specifies the size of the disk in base-2 GB.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskSizeGb")]
        public virtual System.Nullable<long> DiskSizeGb { get; set; }

        /// <summary>
        /// Specifies the disk interface to use for attaching this disk, which is either SCSI or NVME. The default is
        /// SCSI. For performance characteristics of SCSI over NVMe, see Local SSD performance.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("interface")]
        public virtual string Interface__ { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Properties of the SKU instances being reserved. Next ID: 9</summary>
    public class AllocationSpecificSKUAllocationReservedInstanceProperties : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Specifies accelerator type and count.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("guestAccelerators")]
        public virtual System.Collections.Generic.IList<AcceleratorConfig> GuestAccelerators { get; set; }

        /// <summary>
        /// Specifies amount of local ssd to reserve with each instance. The type of disk is local-ssd.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("localSsds")]
        public virtual System.Collections.Generic.IList<AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk> LocalSsds { get; set; }

        /// <summary>
        /// An opaque location hint used to place the allocation close to other resources. This field is for use by
        /// internal tools that use the public API.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("locationHint")]
        public virtual string LocationHint { get; set; }

        /// <summary>
        /// Specifies type of machine (name only) which has fixed number of vCPUs and fixed amount of memory. This also
        /// includes specifying custom machine type following custom-NUMBER_OF_CPUS-AMOUNT_OF_MEMORY pattern.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("machineType")]
        public virtual string MachineType { get; set; }

        /// <summary>Minimum cpu platform the reservation.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minCpuPlatform")]
        public virtual string MinCpuPlatform { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>This reservation type allows to pre allocate specific instance configuration.</summary>
    public class AllocationSpecificSKUReservation : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Specifies the number of resources that are allocated.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("count")]
        public virtual System.Nullable<long> Count { get; set; }

        /// <summary>[Output Only] Indicates how many instances are in use.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("inUseCount")]
        public virtual System.Nullable<long> InUseCount { get; set; }

        /// <summary>The instance properties for the reservation.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceProperties")]
        public virtual AllocationSpecificSKUAllocationReservedInstanceProperties InstanceProperties { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>An instance-attached disk resource.</summary>
    public class AttachedDisk : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Specifies whether the disk will be auto-deleted when the instance is deleted (but not when the disk is
        /// detached from the instance).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoDelete")]
        public virtual System.Nullable<bool> AutoDelete { get; set; }

        /// <summary>
        /// Indicates that this is a boot disk. The virtual machine will use the first partition of the disk for its
        /// root filesystem.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("boot")]
        public virtual System.Nullable<bool> Boot { get; set; }

        /// <summary>
        /// Specifies a unique device name of your choice that is reflected into the /dev/disk/by-id/google-* tree of a
        /// Linux operating system running within the instance. This name can be used to reference the device for
        /// mounting, resizing, and so on, from within the instance.  If not specified, the server chooses a default
        /// device name to apply to this disk, in the form persistent-disk-x, where x is a number assigned by Google
        /// Compute Engine. This field is only applicable for persistent disks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("deviceName")]
        public virtual string DeviceName { get; set; }

        /// <summary>
        /// Encrypts or decrypts a disk using a customer-supplied encryption key.  If you are creating a new disk, this
        /// field encrypts the new disk using an encryption key that you provide. If you are attaching an existing disk
        /// that is already encrypted, this field decrypts the disk using the customer-supplied encryption key.  If you
        /// encrypt a disk using a customer-supplied key, you must provide the same key again when you attempt to use
        /// this resource at a later time. For example, you must provide the key when you create a snapshot or an image
        /// from the disk or when you attach the disk to a virtual machine instance.  If you do not provide an
        /// encryption key, then the disk will be encrypted using an automatically generated key and you do not need to
        /// provide a key to use the disk later.  Instance templates do not store customer-supplied encryption keys, so
        /// you cannot use your own keys to encrypt disks in a managed instance group.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskEncryptionKey")]
        public virtual CustomerEncryptionKey DiskEncryptionKey { get; set; }

        /// <summary>The size of the disk in GB.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskSizeGb")]
        public virtual System.Nullable<long> DiskSizeGb { get; set; }

        /// <summary>
        /// A list of features to enable on the guest operating system. Applicable only for bootable images. Read
        /// Enabling guest operating system features to see a list of available options.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("guestOsFeatures")]
        public virtual System.Collections.Generic.IList<GuestOsFeature> GuestOsFeatures { get; set; }

        /// <summary>
        /// [Output Only] A zero-based index to this disk, where 0 is reserved for the boot disk. If you have many disks
        /// attached to an instance, each disk would have a unique index number.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("index")]
        public virtual System.Nullable<int> Index { get; set; }

        /// <summary>
        /// [Input Only] Specifies the parameters for a new disk that will be created alongside the new instance. Use
        /// initialization parameters to create boot disks or local SSDs attached to the new instance.  This property is
        /// mutually exclusive with the source property; you can only define one or the other, but not both.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("initializeParams")]
        public virtual AttachedDiskInitializeParams InitializeParams { get; set; }

        /// <summary>
        /// Specifies the disk interface to use for attaching this disk, which is either SCSI or NVME. The default is
        /// SCSI. Persistent disks must always use SCSI and the request will fail if you attempt to attach a persistent
        /// disk in any other format than SCSI. Local SSDs can use either NVME or SCSI. For performance characteristics
        /// of SCSI over NVMe, see Local SSD performance.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("interface")]
        public virtual string Interface__ { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#attachedDisk for attached disks.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>[Output Only] Any valid publicly visible licenses.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("licenses")]
        public virtual System.Collections.Generic.IList<string> Licenses { get; set; }

        /// <summary>
        /// The mode in which to attach this disk, either READ_WRITE or READ_ONLY. If not specified, the default is to
        /// attach the disk in READ_WRITE mode.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("mode")]
        public virtual string Mode { get; set; }

        /// <summary>[Output Only] shielded vm initial state stored on disk</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("shieldedInstanceInitialState")]
        public virtual InitialStateConfig ShieldedInstanceInitialState { get; set; }

        /// <summary>
        /// Specifies a valid partial or full URL to an existing Persistent Disk resource. When creating a new instance,
        /// one of initializeParams.sourceImage or initializeParams.sourceSnapshot or disks.source is required except
        /// for local SSD.  If desired, you can also attach existing non-root persistent disks using this property. This
        /// field is only applicable for persistent disks.  Note that for InstanceTemplate, specify the disk name, not
        /// the URL for the disk.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("source")]
        public virtual string Source { get; set; }

        /// <summary>
        /// Specifies the type of the disk, either SCRATCH or PERSISTENT. If not specified, the default is PERSISTENT.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// [Input Only] Specifies the parameters for a new disk that will be created alongside the new instance. Use
    /// initialization parameters to create boot disks or local SSDs attached to the new instance.  This property is
    /// mutually exclusive with the source property; you can only define one or the other, but not both.
    /// </summary>
    public class AttachedDiskInitializeParams : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>An optional description. Provide this property when creating the disk.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Specifies the disk name. If not specified, the default is to use the name of the instance. If a disk with
        /// the same name already exists in the given region, the existing disk is attached to the new instance and the
        /// new disk is not created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskName")]
        public virtual string DiskName { get; set; }

        /// <summary>
        /// Specifies the size of the disk in base-2 GB. The size must be at least 10 GB. If you specify a sourceImage,
        /// which is required for boot disks, the default size is the size of the sourceImage. If you do not specify a
        /// sourceImage, the default disk size is 500 GB.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskSizeGb")]
        public virtual System.Nullable<long> DiskSizeGb { get; set; }

        /// <summary>
        /// Specifies the disk type to use to create the instance. If not specified, the default is pd-standard,
        /// specified using the full URL. For example:
        /// https://www.googleapis.com/compute/v1/projects/project/zones/zone/diskTypes/pd-standard   Other values
        /// include pd-ssd and local-ssd. If you define this field, you can provide either the full or partial URL. For
        /// example, the following are valid values:   -
        /// https://www.googleapis.com/compute/v1/projects/project/zones/zone/diskTypes/diskType  -
        /// projects/project/zones/zone/diskTypes/diskType  - zones/zone/diskTypes/diskType  Note that for
        /// InstanceTemplate, this is the name of the disk type, not URL.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskType")]
        public virtual string DiskType { get; set; }

        /// <summary>
        /// Labels to apply to this disk. These can be later modified by the disks.setLabels method. This field is only
        /// applicable for persistent disks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>
        /// Specifies which action to take on instance update with this disk. Default is to use the existing disk.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("onUpdateAction")]
        public virtual string OnUpdateAction { get; set; }

        /// <summary>Indicates how many IOPS must be provisioned for the disk.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("provisionedIops")]
        public virtual System.Nullable<long> ProvisionedIops { get; set; }

        /// <summary>
        /// Resource policies applied to this disk for automatic snapshot creations. Specified using the full or partial
        /// URL. For instance template, specify only the resource policy name.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resourcePolicies")]
        public virtual System.Collections.Generic.IList<string> ResourcePolicies { get; set; }

        /// <summary>
        /// The source image to create this disk. When creating a new instance, one of initializeParams.sourceImage or
        /// initializeParams.sourceSnapshot or disks.source is required except for local SSD.  To create a disk with one
        /// of the public operating system images, specify the image by its family name. For example, specify
        /// family/debian-9 to use the latest Debian 9 image: projects/debian-cloud/global/images/family/debian-9
        /// Alternatively, use a specific version of a public operating system image:
        /// projects/debian-cloud/global/images/debian-9-stretch-vYYYYMMDD   To create a disk with a custom image that
        /// you created, specify the image name in the following format: global/images/my-custom-image   You can also
        /// specify a custom image by its image family, which returns the latest version of the image in that family.
        /// Replace the image name with family/family-name: global/images/family/my-image-family   If the source image
        /// is deleted later, this field will not be set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceImage")]
        public virtual string SourceImage { get; set; }

        /// <summary>
        /// The customer-supplied encryption key of the source image. Required if the source image is protected by a
        /// customer-supplied encryption key.  Instance templates do not store customer-supplied encryption keys, so you
        /// cannot create disks for instances in a managed instance group if the source images are encrypted with your
        /// own keys.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceImageEncryptionKey")]
        public virtual CustomerEncryptionKey SourceImageEncryptionKey { get; set; }

        /// <summary>
        /// The source snapshot to create this disk. When creating a new instance, one of
        /// initializeParams.sourceSnapshot or initializeParams.sourceImage or disks.source is required except for local
        /// SSD.  To create a disk with a snapshot that you created, specify the snapshot name in the following format:
        /// global/snapshots/my-backup   If the source snapshot is deleted later, this field will not be set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceSnapshot")]
        public virtual string SourceSnapshot { get; set; }

        /// <summary>The customer-supplied encryption key of the source snapshot.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceSnapshotEncryptionKey")]
        public virtual CustomerEncryptionKey SourceSnapshotEncryptionKey { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Specifies the audit configuration for a service. The configuration determines which permission types are logged,
    /// and what identities, if any, are exempted from logging. An AuditConfig must have one or more AuditLogConfigs.
    /// If there are AuditConfigs for both `allServices` and a specific service, the union of the two AuditConfigs is
    /// used for that service: the log_types specified in each AuditConfig are enabled, and the exempted_members in each
    /// AuditLogConfig are exempted.  Example Policy with multiple AuditConfigs:  { "audit_configs": [ { "service":
    /// "allServices", "audit_log_configs": [ { "log_type": "DATA_READ", "exempted_members": [ "user:jose@example.com" ]
    /// }, { "log_type": "DATA_WRITE" }, { "log_type": "ADMIN_READ" } ] }, { "service": "sampleservice.googleapis.com",
    /// "audit_log_configs": [ { "log_type": "DATA_READ" }, { "log_type": "DATA_WRITE", "exempted_members": [
    /// "user:aliya@example.com" ] } ] } ] }  For sampleservice, this policy enables DATA_READ, DATA_WRITE and
    /// ADMIN_READ logging. It also exempts jose@example.com from DATA_READ logging, and aliya@example.com from
    /// DATA_WRITE logging.
    /// </summary>
    public class AuditConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The configuration for logging of each type of permission.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("auditLogConfigs")]
        public virtual System.Collections.Generic.IList<AuditLogConfig> AuditLogConfigs { get; set; }

        /// <summary></summary>
        [Newtonsoft.Json.JsonPropertyAttribute("exemptedMembers")]
        public virtual System.Collections.Generic.IList<string> ExemptedMembers { get; set; }

        /// <summary>
        /// Specifies a service that will be enabled for audit logging. For example, `storage.googleapis.com`,
        /// `cloudsql.googleapis.com`. `allServices` is a special value that covers all services.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("service")]
        public virtual string Service { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Provides the configuration for logging a type of permissions. Example:  { "audit_log_configs": [ { "log_type":
    /// "DATA_READ", "exempted_members": [ "user:jose@example.com" ] }, { "log_type": "DATA_WRITE" } ] }  This enables
    /// 'DATA_READ' and 'DATA_WRITE' logging, while exempting jose@example.com from DATA_READ logging.
    /// </summary>
    public class AuditLogConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Specifies the identities that do not cause logging for this type of permission. Follows the same format of
        /// [Binding.members][].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("exemptedMembers")]
        public virtual System.Collections.Generic.IList<string> ExemptedMembers { get; set; }

        /// <summary></summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ignoreChildExemptions")]
        public virtual System.Nullable<bool> IgnoreChildExemptions { get; set; }

        /// <summary>The log type that this config enables.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("logType")]
        public virtual string LogType { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Authorization-related information used by Cloud Audit Logging.</summary>
    public class AuthorizationLoggingOptions : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The type of the permission that was checked.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("permissionType")]
        public virtual string PermissionType { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents an Autoscaler resource.  Google Compute Engine has two Autoscaler resources:  *
    /// [Zonal](/compute/docs/reference/rest/{$api_version}/autoscalers) *
    /// [Regional](/compute/docs/reference/rest/{$api_version}/regionAutoscalers)  Use autoscalers to automatically add
    /// or delete instances from a managed instance group according to your defined autoscaling policy. For more
    /// information, read Autoscaling Groups of Instances.  For zonal managed instance groups resource, use the
    /// autoscaler resource.  For regional managed instance groups, use the regionAutoscalers resource. (== resource_for
    /// {$api_version}.autoscalers ==) (== resource_for {$api_version}.regionAutoscalers ==)
    /// </summary>
    public class Autoscaler : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The configuration parameters for the autoscaling algorithm. You can define one or more of the policies for
        /// an autoscaler: cpuUtilization, customMetricUtilizations, and loadBalancingUtilization.  If none of these are
        /// specified, the default will be to autoscale based on cpuUtilization to 0.6 or 60%.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoscalingPolicy")]
        public virtual AutoscalingPolicy AutoscalingPolicy { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#autoscaler for autoscalers.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// [Output Only] Target recommended MIG size (number of instances) computed by autoscaler. Autoscaler
        /// calculates the recommended MIG size even when the autoscaling policy mode is different from ON. This field
        /// is empty when autoscaler is not connected to an existing managed instance group or autoscaler did not
        /// generate its prediction.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("recommendedSize")]
        public virtual System.Nullable<int> RecommendedSize { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the instance group resides (for autoscalers living in regional scope).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// [Output Only] The status of the autoscaler configuration. Current set of possible values:   - PENDING:
        /// Autoscaler backend hasn't read new/updated configuration.  - DELETING: Configuration is being deleted.  -
        /// ACTIVE: Configuration is acknowledged to be effective. Some warnings might be present in the statusDetails
        /// field.  - ERROR: Configuration has errors. Actionable for users. Details are present in the statusDetails
        /// field.  New values might be added in the future.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>
        /// [Output Only] Human-readable details about the current state of the autoscaler. Read the documentation for
        /// Commonly returned status messages for examples of status messages you might encounter.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("statusDetails")]
        public virtual System.Collections.Generic.IList<AutoscalerStatusDetails> StatusDetails { get; set; }

        /// <summary>
        /// URL of the managed instance group that this autoscaler will scale. This field is required when creating an
        /// autoscaler.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("target")]
        public virtual string Target { get; set; }

        /// <summary>
        /// [Output Only] URL of the zone where the instance group resides (for autoscalers living in zonal scope).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class AutoscalerAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of AutoscalersScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, AutoscalersScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#autoscalerAggregatedList for aggregated lists of autoscalers.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of Autoscaler resources.</summary>
    public class AutoscalerList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Autoscaler resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Autoscaler> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#autoscalerList for lists of autoscalers.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class AutoscalerStatusDetails : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The status message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("message")]
        public virtual string Message { get; set; }

        /// <summary>
        /// The type of error, warning, or notice returned. Current set of possible values:   - ALL_INSTANCES_UNHEALTHY
        /// (WARNING): All instances in the instance group are unhealthy (not in RUNNING state).  -
        /// BACKEND_SERVICE_DOES_NOT_EXIST (ERROR): There is no backend service attached to the instance group.  -
        /// CAPPED_AT_MAX_NUM_REPLICAS (WARNING): Autoscaler recommends a size greater than maxNumReplicas.  -
        /// CUSTOM_METRIC_DATA_POINTS_TOO_SPARSE (WARNING): The custom metric samples are not exported often enough to
        /// be a credible base for autoscaling.  - CUSTOM_METRIC_INVALID (ERROR): The custom metric that was specified
        /// does not exist or does not have the necessary labels.  - MIN_EQUALS_MAX (WARNING): The minNumReplicas is
        /// equal to maxNumReplicas. This means the autoscaler cannot add or remove instances from the instance group.
        /// - MISSING_CUSTOM_METRIC_DATA_POINTS (WARNING): The autoscaler did not receive any data from the custom
        /// metric configured for autoscaling.  - MISSING_LOAD_BALANCING_DATA_POINTS (WARNING): The autoscaler is
        /// configured to scale based on a load balancing signal but the instance group has not received any requests
        /// from the load balancer.  - MODE_OFF (WARNING): Autoscaling is turned off. The number of instances in the
        /// group won't change automatically. The autoscaling configuration is preserved.  - MODE_ONLY_UP (WARNING):
        /// Autoscaling is in the "Autoscale only out" mode. The autoscaler can add instances but not remove any.  -
        /// MORE_THAN_ONE_BACKEND_SERVICE (ERROR): The instance group cannot be autoscaled because it has more than one
        /// backend service attached to it.  - NOT_ENOUGH_QUOTA_AVAILABLE (ERROR): There is insufficient quota for the
        /// necessary resources, such as CPU or number of instances.  - REGION_RESOURCE_STOCKOUT (ERROR): Shown only for
        /// regional autoscalers: there is a resource stockout in the chosen region.  - SCALING_TARGET_DOES_NOT_EXIST
        /// (ERROR): The target to be scaled does not exist.  - UNSUPPORTED_MAX_RATE_LOAD_BALANCING_CONFIGURATION
        /// (ERROR): Autoscaling does not work with an HTTP/S load balancer that has been configured for maxRate.  -
        /// ZONE_RESOURCE_STOCKOUT (ERROR): For zonal autoscalers: there is a resource stockout in the chosen zone. For
        /// regional autoscalers: in at least one of the zones you're using there is a resource stockout.  New values
        /// might be added in the future. Some of the values might not be available in all API versions.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class AutoscalersScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of autoscalers contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoscalers")]
        public virtual System.Collections.Generic.IList<Autoscaler> Autoscalers { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of autoscalers when the list is empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of autoscalers when the list is empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Cloud Autoscaler policy.</summary>
    public class AutoscalingPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The number of seconds that the autoscaler waits before it starts collecting information from a new instance.
        /// This prevents the autoscaler from collecting information when the instance is initializing, during which the
        /// collected usage would not be reliable. The default time autoscaler waits is 60 seconds.  Virtual machine
        /// initialization times might vary because of numerous factors. We recommend that you test how long an instance
        /// may take to initialize. To do this, create an instance and time the startup process.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("coolDownPeriodSec")]
        public virtual System.Nullable<int> CoolDownPeriodSec { get; set; }

        /// <summary>
        /// Defines the CPU utilization policy that allows the autoscaler to scale based on the average CPU utilization
        /// of a managed instance group.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cpuUtilization")]
        public virtual AutoscalingPolicyCpuUtilization CpuUtilization { get; set; }

        /// <summary>Configuration parameters of autoscaling based on a custom metric.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("customMetricUtilizations")]
        public virtual System.Collections.Generic.IList<AutoscalingPolicyCustomMetricUtilization> CustomMetricUtilizations { get; set; }

        /// <summary>Configuration parameters of autoscaling based on load balancer.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("loadBalancingUtilization")]
        public virtual AutoscalingPolicyLoadBalancingUtilization LoadBalancingUtilization { get; set; }

        /// <summary>
        /// The maximum number of instances that the autoscaler can scale out to. This is required when creating or
        /// updating an autoscaler. The maximum number of replicas must not be lower than minimal number of replicas.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxNumReplicas")]
        public virtual System.Nullable<int> MaxNumReplicas { get; set; }

        /// <summary>
        /// The minimum number of replicas that the autoscaler can scale in to. This cannot be less than 0. If not
        /// provided, autoscaler chooses a default value depending on maximum number of instances allowed.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minNumReplicas")]
        public virtual System.Nullable<int> MinNumReplicas { get; set; }

        /// <summary>Defines operating mode for this policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("mode")]
        public virtual string Mode { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("scaleInControl")]
        public virtual AutoscalingPolicyScaleInControl ScaleInControl { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>CPU utilization policy.</summary>
    public class AutoscalingPolicyCpuUtilization : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The target CPU utilization that the autoscaler maintains. Must be a float value in the range (0, 1]. If not
        /// specified, the default is 0.6.  If the CPU level is below the target utilization, the autoscaler scales in
        /// the number of instances until it reaches the minimum number of instances you specified or until the average
        /// CPU of your instances reaches the target utilization.  If the average CPU is above the target utilization,
        /// the autoscaler scales out until it reaches the maximum number of instances you specified or until the
        /// average utilization reaches the target utilization.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("utilizationTarget")]
        public virtual System.Nullable<double> UtilizationTarget { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Custom utilization metric policy.</summary>
    public class AutoscalingPolicyCustomMetricUtilization : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// A filter string, compatible with a Stackdriver Monitoring filter string for TimeSeries.list API call. This
        /// filter is used to select a specific TimeSeries for the purpose of autoscaling and to determine whether the
        /// metric is exporting per-instance or per-group data.  For the filter to be valid for autoscaling purposes,
        /// the following rules apply:   - You can only use the AND operator for joining selectors.  - You can only use
        /// direct equality comparison operator (=) without any functions for each selector.  - You can specify the
        /// metric in both the filter string and in the metric field. However, if specified in both places, the metric
        /// must be identical.  - The monitored resource type determines what kind of values are expected for the
        /// metric. If it is a gce_instance, the autoscaler expects the metric to include a separate TimeSeries for each
        /// instance in a group. In such a case, you cannot filter on resource labels. If the resource type is any other
        /// value, the autoscaler expects this metric to contain values that apply to the entire autoscaled instance
        /// group and resource label filtering can be performed to point autoscaler at the correct TimeSeries to scale
        /// upon. This is called a per-group metric for the purpose of autoscaling.  If not specified, the type defaults
        /// to gce_instance.    Try to provide a filter that is selective enough to pick just one TimeSeries for the
        /// autoscaled group or for each of the instances (if you are using gce_instance resource type). If multiple
        /// TimeSeries are returned upon the query execution, the autoscaler will sum their respective values to obtain
        /// its scaling value.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("filter")]
        public virtual string Filter { get; set; }

        /// <summary>
        /// The identifier (type) of the Stackdriver Monitoring metric. The metric cannot have negative values.  The
        /// metric must have a value type of INT64 or DOUBLE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("metric")]
        public virtual string Metric { get; set; }

        /// <summary>
        /// If scaling is based on a per-group metric value that represents the total amount of work to be done or
        /// resource usage, set this value to an amount assigned for a single instance of the scaled group. Autoscaler
        /// keeps the number of instances proportional to the value of this metric. The metric itself does not change
        /// value due to group resizing.  A good metric to use with the target is for example
        /// pubsub.googleapis.com/subscription/num_undelivered_messages or a custom metric exporting the total number of
        /// requests coming to your instances.  A bad example would be a metric exporting an average or median latency,
        /// since this value can't include a chunk assignable to a single instance, it could be better used with
        /// utilization_target instead.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("singleInstanceAssignment")]
        public virtual System.Nullable<double> SingleInstanceAssignment { get; set; }

        /// <summary>
        /// The target value of the metric that autoscaler maintains. This must be a positive value. A utilization
        /// metric scales number of virtual machines handling requests to increase or decrease proportionally to the
        /// metric.  For example, a good metric to use as a utilization_target is
        /// https://www.googleapis.com/compute/v1/instance/network/received_bytes_count. The autoscaler works to keep
        /// this value constant for each of the instances.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("utilizationTarget")]
        public virtual System.Nullable<double> UtilizationTarget { get; set; }

        /// <summary>
        /// Defines how target utilization value is expressed for a Stackdriver Monitoring metric. Either GAUGE,
        /// DELTA_PER_SECOND, or DELTA_PER_MINUTE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("utilizationTargetType")]
        public virtual string UtilizationTargetType { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Configuration parameters of autoscaling based on load balancing.</summary>
    public class AutoscalingPolicyLoadBalancingUtilization : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Fraction of backend capacity utilization (set in HTTP(S) load balancing configuration) that the autoscaler
        /// maintains. Must be a positive float value. If not defined, the default is 0.8.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("utilizationTarget")]
        public virtual System.Nullable<double> UtilizationTarget { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Configuration that allows for slower scale in so that even if Autoscaler recommends an abrupt scale in of a MIG,
    /// it will be throttled as specified by the parameters below.
    /// </summary>
    public class AutoscalingPolicyScaleInControl : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Maximum allowed number (or %) of VMs that can be deducted from the peak recommendation during the window
        /// autoscaler looks at when computing recommendations. Possibly all these VMs can be deleted at once so user
        /// service needs to be prepared to lose that many VMs in one step.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxScaledInReplicas")]
        public virtual FixedOrPercent MaxScaledInReplicas { get; set; }

        /// <summary>
        /// How far back autoscaling looks when computing recommendations to include directives regarding slower scale
        /// in, as described above.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("timeWindowSec")]
        public virtual System.Nullable<int> TimeWindowSec { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Message containing information of one individual backend.</summary>
    public class Backend : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Specifies how to determine whether the backend of a load balancer can handle additional traffic or is fully
        /// loaded. For usage guidelines, see  Connection balancing mode.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("balancingMode")]
        public virtual string BalancingMode { get; set; }

        /// <summary>
        /// A multiplier applied to the backend's target capacity of its balancing mode. The default value is 1, which
        /// means the group serves up to 100% of its configured capacity (depending on balancingMode). A setting of 0
        /// means the group is completely drained, offering 0% of its available capacity. The valid ranges are 0.0 and
        /// [0.1,1.0]. You cannot configure a setting larger than 0 and smaller than 0.1. You cannot configure a setting
        /// of 0 when there is only one backend attached to the backend service.  Not supported by:  - Internal TCP/UDP
        /// Load Balancing - Network Load Balancing
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("capacityScaler")]
        public virtual System.Nullable<float> CapacityScaler { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// This field designates whether this is a failover backend. More than one failover backend can be configured
        /// for a given BackendService.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("failover")]
        public virtual System.Nullable<bool> Failover { get; set; }

        /// <summary>
        /// The fully-qualified URL of an instance group or network endpoint group (NEG) resource. The type of backend
        /// that a backend service supports depends on the backend service's loadBalancingScheme.    - When the
        /// loadBalancingScheme for the backend service is EXTERNAL (except Network Load Balancing),
        /// INTERNAL_SELF_MANAGED, or INTERNAL_MANAGED , the backend can be either an instance group or a NEG. The
        /// backends on the backend service must be either all instance groups or all NEGs. You cannot mix instance
        /// group and NEG backends on the same backend service.    - When the loadBalancingScheme for the backend
        /// service is EXTERNAL for Network Load Balancing or INTERNAL for Internal TCP/UDP Load Balancing, the backend
        /// must be an instance group. NEGs are not supported.    For regional services, the backend must be in the same
        /// region as the backend service.  You must use the fully-qualified URL (starting with
        /// https://www.googleapis.com/) to specify the instance group or NEG. Partial URLs are not supported.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("group")]
        public virtual string Group { get; set; }

        /// <summary>
        /// Defines a target maximum number of simultaneous connections. For usage guidelines, see Connection balancing
        /// mode and Utilization balancing mode. Not available if the backend's balancingMode is RATE. Not supported by:
        ///  - Internal TCP/UDP Load Balancing - Network Load Balancing
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxConnections")]
        public virtual System.Nullable<int> MaxConnections { get; set; }

        /// <summary>
        /// Defines a target maximum number of simultaneous connections. For usage guidelines, see Connection balancing
        /// mode and Utilization balancing mode.  Not available if the backend's balancingMode is RATE. Not supported
        /// by:  - Internal TCP/UDP Load Balancing - Network Load Balancing.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxConnectionsPerEndpoint")]
        public virtual System.Nullable<int> MaxConnectionsPerEndpoint { get; set; }

        /// <summary>
        /// Defines a target maximum number of simultaneous connections. For usage guidelines, see Connection balancing
        /// mode and Utilization balancing mode.  Not available if the backend's balancingMode is RATE. Not supported
        /// by:  - Internal TCP/UDP Load Balancing - Network Load Balancing.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxConnectionsPerInstance")]
        public virtual System.Nullable<int> MaxConnectionsPerInstance { get; set; }

        /// <summary>
        /// Defines a maximum number of HTTP requests per second (RPS). For usage guidelines, see Rate balancing mode
        /// and Utilization balancing mode.  Not available if the backend's balancingMode is CONNECTION.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxRate")]
        public virtual System.Nullable<int> MaxRate { get; set; }

        /// <summary>
        /// Defines a maximum target for requests per second (RPS). For usage guidelines, see Rate balancing mode and
        /// Utilization balancing mode.  Not available if the backend's balancingMode is CONNECTION.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxRatePerEndpoint")]
        public virtual System.Nullable<float> MaxRatePerEndpoint { get; set; }

        /// <summary>
        /// Defines a maximum target for requests per second (RPS). For usage guidelines, see Rate balancing mode and
        /// Utilization balancing mode.  Not available if the backend's balancingMode is CONNECTION.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxRatePerInstance")]
        public virtual System.Nullable<float> MaxRatePerInstance { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("maxUtilization")]
        public virtual System.Nullable<float> MaxUtilization { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Cloud Storage Bucket resource.  This Cloud Storage bucket resource is referenced by a URL map of a
    /// load balancer. For more information, read Backend Buckets.
    /// </summary>
    public class BackendBucket : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Cloud Storage bucket name.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("bucketName")]
        public virtual string BucketName { get; set; }

        /// <summary>Cloud CDN configuration for this BackendBucket.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cdnPolicy")]
        public virtual BackendBucketCdnPolicy CdnPolicy { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>Headers that the HTTP/S load balancer should add to proxied responses.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("customResponseHeaders")]
        public virtual System.Collections.Generic.IList<string> CustomResponseHeaders { get; set; }

        /// <summary>
        /// An optional textual description of the resource; provided by the client when the resource is created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>If true, enable Cloud CDN for this BackendBucket.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enableCdn")]
        public virtual System.Nullable<bool> EnableCdn { get; set; }

        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>Type of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Message containing Cloud CDN configuration for a backend bucket.</summary>
    public class BackendBucketCdnPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Specifies the cache setting for all responses from this backend. The possible values are:
        /// USE_ORIGIN_HEADERS Requires the origin to set valid caching headers to cache content. Responses without
        /// these headers will not be cached at Google's edge, and will require a full trip to the origin on every
        /// request, potentially impacting performance and increasing load on the origin server.  FORCE_CACHE_ALL Cache
        /// all content, ignoring any "private", "no-store" or "no-cache" directives in Cache-Control response headers.
        /// Warning: this may result in Cloud CDN caching private, per-user (user identifiable) content.
        /// CACHE_ALL_STATIC Automatically cache static content, including common image formats, media (video and
        /// audio), and web assets (JavaScript and CSS). Requests and responses that are marked as uncacheable, as well
        /// as dynamic content (including HTML), will not be cached.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cacheMode")]
        public virtual string CacheMode { get; set; }

        /// <summary>
        /// Specifies a separate client (e.g. browser client) maximum TTL. This is used to clamp the max-age (or
        /// Expires) value sent to the client. With FORCE_CACHE_ALL, the lesser of client_ttl and default_ttl is used
        /// for the response max-age directive, along with a "public" directive. For cacheable content in
        /// CACHE_ALL_STATIC mode, client_ttl clamps the max-age from the origin (if specified), or else sets the
        /// response max-age directive to the lesser of the client_ttl and default_ttl, and also ensures a "public"
        /// cache-control directive is present. If a client TTL is not specified, a default value (1 hour) will be used.
        /// The maximum allowed value is 86400s (1 day).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("clientTtl")]
        public virtual System.Nullable<int> ClientTtl { get; set; }

        /// <summary>
        /// Specifies the default TTL for cached content served by this origin for responses that do not have an
        /// existing valid TTL (max-age or s-max-age). Setting a TTL of "0" means "always revalidate". The value of
        /// defaultTTL cannot be set to a value greater than that of maxTTL, but can be equal. When the cacheMode is set
        /// to FORCE_CACHE_ALL, the defaultTTL will overwrite the TTL set in all responses. The maximum allowed value is
        /// 31,622,400s (1 year), noting that infrequently accessed objects may be evicted from the cache before the
        /// defined TTL.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("defaultTtl")]
        public virtual System.Nullable<int> DefaultTtl { get; set; }

        /// <summary>
        /// Specifies the maximum allowed TTL for cached content served by this origin. Cache directives that attempt to
        /// set a max-age or s-maxage higher than this, or an Expires header more than maxTTL seconds in the future will
        /// be capped at the value of maxTTL, as if it were the value of an s-maxage Cache-Control directive. Headers
        /// sent to the client will not be modified. Setting a TTL of "0" means "always revalidate". The maximum allowed
        /// value is 31,622,400s (1 year), noting that infrequently accessed objects may be evicted from the cache
        /// before the defined TTL.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxTtl")]
        public virtual System.Nullable<int> MaxTtl { get; set; }

        /// <summary>
        /// Maximum number of seconds the response to a signed URL request will be considered fresh. After this time
        /// period, the response will be revalidated before being served. Defaults to 1hr (3600s). When serving
        /// responses to signed URL requests, Cloud CDN will internally behave as though all responses from this backend
        /// had a "Cache-Control: public, max-age=[TTL]" header, regardless of any existing Cache-Control header. The
        /// actual headers served in responses will not be altered.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("signedUrlCacheMaxAgeSec")]
        public virtual System.Nullable<long> SignedUrlCacheMaxAgeSec { get; set; }

        /// <summary>[Output Only] Names of the keys for signing request URLs.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("signedUrlKeyNames")]
        public virtual System.Collections.Generic.IList<string> SignedUrlKeyNames { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of BackendBucket resources.</summary>
    public class BackendBucketList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of BackendBucket resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<BackendBucket> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a Backend Service resource.  A backend service defines how Google Cloud load balancers distribute
    /// traffic. The backend service configuration contains a set of values, such as the protocol used to connect to
    /// backends, various distribution and session settings, health checks, and timeouts. These settings provide
    /// fine-grained control over how your load balancer behaves. Most of the settings have default values that allow
    /// for easy configuration if you need to get started quickly.  Backend services in Google Compute Engine can be
    /// either regionally or globally scoped.  * [Global](/compute/docs/reference/rest/{$api_version}/backendServices) *
    /// [Regional](/compute/docs/reference/rest/{$api_version}/regionBackendServices)  For more information, see Backend
    /// Services.  (== resource_for {$api_version}.backendService ==)
    /// </summary>
    public class BackendService : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Lifetime of cookies in seconds. Only applicable if the loadBalancingScheme is EXTERNAL,
        /// INTERNAL_SELF_MANAGED, or INTERNAL_MANAGED, the protocol is HTTP or HTTPS, and the sessionAffinity is
        /// GENERATED_COOKIE, or HTTP_COOKIE.  If set to 0, the cookie is non-persistent and lasts only until the end of
        /// the browser session (or equivalent). The maximum allowed value is one day (86,400).  Not supported when the
        /// backend service is referenced by a URL map that is bound to target gRPC proxy that has validateForProxyless
        /// field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("affinityCookieTtlSec")]
        public virtual System.Nullable<int> AffinityCookieTtlSec { get; set; }

        /// <summary>The list of backends that serve this BackendService.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("backends")]
        public virtual System.Collections.Generic.IList<Backend> Backends { get; set; }

        /// <summary>
        /// Cloud CDN configuration for this BackendService. Only available for  external HTTP(S) Load Balancing.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cdnPolicy")]
        public virtual BackendServiceCdnPolicy CdnPolicy { get; set; }

        /// <summary>
        /// Settings controlling the volume of connections to a backend service. If not set, this feature is considered
        /// disabled.  This field is applicable to either:   - A regional backend service with the service_protocol set
        /// to HTTP, HTTPS, or HTTP2, and load_balancing_scheme set to INTERNAL_MANAGED.  - A global backend service
        /// with the load_balancing_scheme set to INTERNAL_SELF_MANAGED.    Not supported when the backend service is
        /// referenced by a URL map that is bound to target gRPC proxy that has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("circuitBreakers")]
        public virtual CircuitBreakers CircuitBreakers { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("connectionDraining")]
        public virtual ConnectionDraining ConnectionDraining { get; set; }

        /// <summary>
        /// Consistent Hash-based load balancing can be used to provide soft session affinity based on HTTP headers,
        /// cookies or other properties. This load balancing policy is applicable only for HTTP connections. The
        /// affinity to a particular destination host will be lost when one or more hosts are added/removed from the
        /// destination service. This field specifies parameters that control consistent hashing. This field is only
        /// applicable when localityLbPolicy is set to MAGLEV or RING_HASH.  This field is applicable to either:   - A
        /// regional backend service with the service_protocol set to HTTP, HTTPS, or HTTP2, and load_balancing_scheme
        /// set to INTERNAL_MANAGED.  - A global backend service with the load_balancing_scheme set to
        /// INTERNAL_SELF_MANAGED.    Not supported when the backend service is referenced by a URL map that is bound to
        /// target gRPC proxy that has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("consistentHash")]
        public virtual ConsistentHashLoadBalancerSettings ConsistentHash { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>Headers that the HTTP/S load balancer should add to proxied requests.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("customRequestHeaders")]
        public virtual System.Collections.Generic.IList<string> CustomRequestHeaders { get; set; }

        /// <summary>Headers that the HTTP/S load balancer should add to proxied responses.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("customResponseHeaders")]
        public virtual System.Collections.Generic.IList<string> CustomResponseHeaders { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// If true, enables Cloud CDN for the backend service. Only applicable if the loadBalancingScheme is EXTERNAL
        /// and the protocol is HTTP or HTTPS.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enableCDN")]
        public virtual System.Nullable<bool> EnableCDN { get; set; }

        /// <summary>
        /// Applicable only to Failover for Internal TCP/UDP Load Balancing and Network Load Balancing. Requires at
        /// least one backend instance group to be defined as a backup (failover) backend.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("failoverPolicy")]
        public virtual BackendServiceFailoverPolicy FailoverPolicy { get; set; }

        /// <summary>
        /// Fingerprint of this resource. A hash of the contents stored in this object. This field is used in optimistic
        /// locking. This field will be ignored when inserting a BackendService. An up-to-date fingerprint must be
        /// provided in order to update the BackendService, otherwise the request will fail with error 412
        /// conditionNotMet.  To see the latest fingerprint, make a get() request to retrieve a BackendService.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// The list of URLs to the healthChecks, httpHealthChecks (legacy), or httpsHealthChecks (legacy) resource for
        /// health checking this backend service. Not all backend services support legacy health checks. See  Load
        /// balancer guide. Currently, at most one health check can be specified for each backend service. Backend
        /// services with instance group or zonal NEG backends must have a health check. Backend services with internet
        /// or serverless NEG backends must not have a health check.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthChecks")]
        public virtual System.Collections.Generic.IList<string> HealthChecks { get; set; }

        /// <summary>
        /// The configurations for Identity-Aware Proxy on this resource. Not available for Internal TCP/UDP Load
        /// Balancing and Network Load Balancing.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("iap")]
        public virtual BackendServiceIAP Iap { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#backendService for backend services.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Specifies the load balancer type. Choose EXTERNAL for external HTTP(S), SSL Proxy, TCP Proxy and Network
        /// Load Balancing. Choose  INTERNAL for Internal TCP/UDP Load Balancing. Choose  INTERNAL_MANAGED for Internal
        /// HTTP(S) Load Balancing.  INTERNAL_SELF_MANAGED for Traffic Director. A backend service created for one type
        /// of load balancer cannot be used with another. For more information, refer to Choosing a load balancer.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("loadBalancingScheme")]
        public virtual string LoadBalancingScheme { get; set; }

        /// <summary>
        /// The load balancing algorithm used within the scope of the locality. The possible values are:   -
        /// ROUND_ROBIN: This is a simple policy in which each healthy backend is selected in round robin order. This is
        /// the default.  - LEAST_REQUEST: An O(1) algorithm which selects two random healthy hosts and picks the host
        /// which has fewer active requests.  - RING_HASH: The ring/modulo hash load balancer implements consistent
        /// hashing to backends. The algorithm has the property that the addition/removal of a host from a set of N
        /// hosts only affects 1/N of the requests.  - RANDOM: The load balancer selects a random healthy host.  -
        /// ORIGINAL_DESTINATION: Backend host is selected based on the client connection metadata, i.e., connections
        /// are opened to the same address as the destination address of the incoming connection before the connection
        /// was redirected to the load balancer.  - MAGLEV: used as a drop in replacement for the ring hash load
        /// balancer. Maglev is not as stable as ring hash but has faster table lookup build times and host selection
        /// times. For more information about Maglev, see https://ai.google/research/pubs/pub44824   This field is
        /// applicable to either:   - A regional backend service with the service_protocol set to HTTP, HTTPS, or HTTP2,
        /// and load_balancing_scheme set to INTERNAL_MANAGED.  - A global backend service with the
        /// load_balancing_scheme set to INTERNAL_SELF_MANAGED.    If sessionAffinity is not NONE, and this field is not
        /// set to MAGLEV or RING_HASH, session affinity settings will not take effect.  Only the default ROUND_ROBIN
        /// policy is supported when the backend service is referenced by a URL map that is bound to target gRPC proxy
        /// that has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("localityLbPolicy")]
        public virtual string LocalityLbPolicy { get; set; }

        /// <summary>
        /// This field denotes the logging options for the load balancer traffic served by this backend service. If
        /// logging is enabled, logs will be exported to Stackdriver.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("logConfig")]
        public virtual BackendServiceLogConfig LogConfig { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// The URL of the network to which this backend service belongs. This field can only be specified when the load
        /// balancing scheme is set to INTERNAL.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>
        /// Settings controlling the eviction of unhealthy hosts from the load balancing pool for the backend service.
        /// If not set, this feature is considered disabled.  This field is applicable to either:   - A regional backend
        /// service with the service_protocol set to HTTP, HTTPS, or HTTP2, and load_balancing_scheme set to
        /// INTERNAL_MANAGED.  - A global backend service with the load_balancing_scheme set to INTERNAL_SELF_MANAGED.
        ///  Not supported when the backend service is referenced by a URL map that is bound to target gRPC proxy that
        /// has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("outlierDetection")]
        public virtual OutlierDetection OutlierDetection { get; set; }

        /// <summary>
        /// Deprecated in favor of portName. The TCP port to connect on the backend. The default value is 80.  Backend
        /// services for Internal TCP/UDP Load Balancing and Network Load Balancing require you omit port.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("port")]
        public virtual System.Nullable<int> Port { get; set; }

        /// <summary>
        /// A named port on a backend instance group representing the port for communication to the backend VMs in that
        /// group. Required when the loadBalancingScheme is EXTERNAL (except Network Load Balancing), INTERNAL_MANAGED,
        /// or  INTERNAL_SELF_MANAGED and the backends are instance groups. The named port must be defined on each
        /// backend instance group. This parameter has no meaning if the backends are NEGs.    Backend services for
        /// Internal TCP/UDP Load Balancing and Network Load Balancing require you omit port_name.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portName")]
        public virtual string PortName { get; set; }

        /// <summary>
        /// The protocol this BackendService uses to communicate with backends.  Possible values are HTTP, HTTPS, HTTP2,
        /// TCP, SSL, UDP or GRPC. depending on the chosen load balancer or Traffic Director configuration. Refer to the
        /// documentation for the load balancer or for Traffic Director for more information.  Must be set to GRPC when
        /// the backend service is referenced by a URL map that is bound to target gRPC proxy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("protocol")]
        public virtual string Protocol { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the regional backend service resides. This field is not applicable to
        /// global backend services. You must specify this field as part of the HTTP request URL. It is not settable as
        /// a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>
        /// [Output Only] The resource URL for the security policy associated with this backend service.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("securityPolicy")]
        public virtual string SecurityPolicy { get; set; }

        /// <summary>
        /// This field specifies the security policy that applies to this backend service. This field is applicable to
        /// either:   - A regional backend service with the service_protocol set to HTTP, HTTPS, or HTTP2, and
        /// load_balancing_scheme set to INTERNAL_MANAGED.  - A global backend service with the load_balancing_scheme
        /// set to INTERNAL_SELF_MANAGED.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("securitySettings")]
        public virtual SecuritySettings SecuritySettings { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// Type of session affinity to use. The default is NONE.  When the loadBalancingScheme is EXTERNAL: * For
        /// Network Load Balancing, the possible values are NONE, CLIENT_IP, CLIENT_IP_PROTO, or CLIENT_IP_PORT_PROTO. *
        /// For all other load balancers that use loadBalancingScheme=EXTERNAL, the possible values are NONE, CLIENT_IP,
        /// or GENERATED_COOKIE. * You can use GENERATED_COOKIE if the protocol is HTTP, HTTP2, or HTTPS.  When the
        /// loadBalancingScheme is INTERNAL, possible values are NONE, CLIENT_IP, CLIENT_IP_PROTO, or
        /// CLIENT_IP_PORT_PROTO.  When the loadBalancingScheme is INTERNAL_SELF_MANAGED, or INTERNAL_MANAGED, possible
        /// values are NONE, CLIENT_IP, GENERATED_COOKIE, HEADER_FIELD, or HTTP_COOKIE.  Not supported when the backend
        /// service is referenced by a URL map that is bound to target gRPC proxy that has validateForProxyless field
        /// set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sessionAffinity")]
        public virtual string SessionAffinity { get; set; }

        /// <summary>
        /// The backend service timeout has a different meaning depending on the type of load balancer. For more
        /// information see,  Backend service settings The default is 30 seconds. The full range of timeout values
        /// allowed is 1 - 2,147,483,647 seconds.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("timeoutSec")]
        public virtual System.Nullable<int> TimeoutSec { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of BackendServicesScopedList.</summary>
    public class BackendServiceAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of BackendServicesScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, BackendServicesScopedList> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Message containing Cloud CDN configuration for a backend service.</summary>
    public class BackendServiceCdnPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The CacheKeyPolicy for this CdnPolicy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cacheKeyPolicy")]
        public virtual CacheKeyPolicy CacheKeyPolicy { get; set; }

        /// <summary>
        /// Specifies the cache setting for all responses from this backend. The possible values are:
        /// USE_ORIGIN_HEADERS Requires the origin to set valid caching headers to cache content. Responses without
        /// these headers will not be cached at Google's edge, and will require a full trip to the origin on every
        /// request, potentially impacting performance and increasing load on the origin server.  FORCE_CACHE_ALL Cache
        /// all content, ignoring any "private", "no-store" or "no-cache" directives in Cache-Control response headers.
        /// Warning: this may result in Cloud CDN caching private, per-user (user identifiable) content.
        /// CACHE_ALL_STATIC Automatically cache static content, including common image formats, media (video and
        /// audio), and web assets (JavaScript and CSS). Requests and responses that are marked as uncacheable, as well
        /// as dynamic content (including HTML), will not be cached.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cacheMode")]
        public virtual string CacheMode { get; set; }

        /// <summary>
        /// Specifies a separate client (e.g. browser client) maximum TTL. This is used to clamp the max-age (or
        /// Expires) value sent to the client. With FORCE_CACHE_ALL, the lesser of client_ttl and default_ttl is used
        /// for the response max-age directive, along with a "public" directive. For cacheable content in
        /// CACHE_ALL_STATIC mode, client_ttl clamps the max-age from the origin (if specified), or else sets the
        /// response max-age directive to the lesser of the client_ttl and default_ttl, and also ensures a "public"
        /// cache-control directive is present. If a client TTL is not specified, a default value (1 hour) will be used.
        /// The maximum allowed value is 86400s (1 day).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("clientTtl")]
        public virtual System.Nullable<int> ClientTtl { get; set; }

        /// <summary>
        /// Specifies the default TTL for cached content served by this origin for responses that do not have an
        /// existing valid TTL (max-age or s-max-age). Setting a TTL of "0" means "always revalidate". The value of
        /// defaultTTL cannot be set to a value greater than that of maxTTL, but can be equal. When the cacheMode is set
        /// to FORCE_CACHE_ALL, the defaultTTL will overwrite the TTL set in all responses. The maximum allowed value is
        /// 31,622,400s (1 year), noting that infrequently accessed objects may be evicted from the cache before the
        /// defined TTL.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("defaultTtl")]
        public virtual System.Nullable<int> DefaultTtl { get; set; }

        /// <summary>
        /// Specifies the maximum allowed TTL for cached content served by this origin. Cache directives that attempt to
        /// set a max-age or s-maxage higher than this, or an Expires header more than maxTTL seconds in the future will
        /// be capped at the value of maxTTL, as if it were the value of an s-maxage Cache-Control directive. Headers
        /// sent to the client will not be modified. Setting a TTL of "0" means "always revalidate". The maximum allowed
        /// value is 31,622,400s (1 year), noting that infrequently accessed objects may be evicted from the cache
        /// before the defined TTL.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxTtl")]
        public virtual System.Nullable<int> MaxTtl { get; set; }

        /// <summary>
        /// Maximum number of seconds the response to a signed URL request will be considered fresh. After this time
        /// period, the response will be revalidated before being served. Defaults to 1hr (3600s). When serving
        /// responses to signed URL requests, Cloud CDN will internally behave as though all responses from this backend
        /// had a "Cache-Control: public, max-age=[TTL]" header, regardless of any existing Cache-Control header. The
        /// actual headers served in responses will not be altered.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("signedUrlCacheMaxAgeSec")]
        public virtual System.Nullable<long> SignedUrlCacheMaxAgeSec { get; set; }

        /// <summary>[Output Only] Names of the keys for signing request URLs.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("signedUrlKeyNames")]
        public virtual System.Collections.Generic.IList<string> SignedUrlKeyNames { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Applicable only to Failover for Internal TCP/UDP Load Balancing and Network Load Balancing. On failover or
    /// failback, this field indicates whether connection draining will be honored. GCP has a fixed connection draining
    /// timeout of 10 minutes. A setting of true terminates existing TCP connections to the active pool during failover
    /// and failback, immediately draining traffic. A setting of false allows existing TCP connections to persist, even
    /// on VMs no longer in the active pool, for up to the duration of the connection draining timeout (10 minutes).
    /// </summary>
    public class BackendServiceFailoverPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>This can be set to true only if the protocol is TCP.  The default is false.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("disableConnectionDrainOnFailover")]
        public virtual System.Nullable<bool> DisableConnectionDrainOnFailover { get; set; }

        /// <summary>
        /// Applicable only to Failover for Internal TCP/UDP Load Balancing and Network Load Balancing, If set to true,
        /// connections to the load balancer are dropped when all primary and all backup backend VMs are unhealthy.If
        /// set to false, connections are distributed among all primary VMs when all primary and all backup backend VMs
        /// are unhealthy. The default is false.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("dropTrafficIfUnhealthy")]
        public virtual System.Nullable<bool> DropTrafficIfUnhealthy { get; set; }

        /// <summary>
        /// Applicable only to Failover for Internal TCP/UDP Load Balancing and Network Load Balancing. The value of the
        /// field must be in the range [0, 1]. If the value is 0, the load balancer performs a failover when the number
        /// of healthy primary VMs equals zero. For all other values, the load balancer performs a failover when the
        /// total number of healthy primary VMs is less than this ratio.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("failoverRatio")]
        public virtual System.Nullable<float> FailoverRatio { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class BackendServiceGroupHealth : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Metadata defined as annotations on the network endpoint group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("annotations")]
        public virtual System.Collections.Generic.IDictionary<string, string> Annotations { get; set; }

        /// <summary>
        /// Health state of the backend instances or endpoints in requested instance or network endpoint group,
        /// determined based on configured health checks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthStatus")]
        public virtual System.Collections.Generic.IList<HealthStatus> HealthStatus { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#backendServiceGroupHealth for the health of backend services.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Identity-Aware Proxy</summary>
    public class BackendServiceIAP : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Whether the serving infrastructure will authenticate and authorize all incoming requests. If true, the
        /// oauth2ClientId and oauth2ClientSecret fields must be non-empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enabled")]
        public virtual System.Nullable<bool> Enabled { get; set; }

        /// <summary>OAuth2 client ID to use for the authentication flow.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("oauth2ClientId")]
        public virtual string Oauth2ClientId { get; set; }

        /// <summary>
        /// OAuth2 client secret to use for the authentication flow. For security reasons, this value cannot be
        /// retrieved via the API. Instead, the SHA-256 hash of the value is returned in the oauth2ClientSecretSha256
        /// field.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("oauth2ClientSecret")]
        public virtual string Oauth2ClientSecret { get; set; }

        /// <summary>[Output Only] SHA256 hash value for the field oauth2_client_secret above.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("oauth2ClientSecretSha256")]
        public virtual string Oauth2ClientSecretSha256 { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of BackendService resources.</summary>
    public class BackendServiceList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of BackendService resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<BackendService> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#backendServiceList for lists of backend services.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>The available logging options for the load balancer traffic served by this backend service.</summary>
    public class BackendServiceLogConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// This field denotes whether to enable logging for the load balancer traffic served by this backend service.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enable")]
        public virtual System.Nullable<bool> Enable { get; set; }

        /// <summary>
        /// This field can only be specified if logging is enabled for this backend service. The value of the field must
        /// be in [0, 1]. This configures the sampling rate of requests to the load balancer where 1.0 means all logged
        /// requests are reported and 0.0 means no logged requests are reported. The default value is 1.0.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sampleRate")]
        public virtual System.Nullable<float> SampleRate { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class BackendServiceReference : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("backendService")]
        public virtual string BackendService { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class BackendServicesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of BackendServices contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("backendServices")]
        public virtual System.Collections.Generic.IList<BackendService> BackendServices { get; set; }

        /// <summary>Informational warning which replaces the list of backend services when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of backend services when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Associates `members` with a `role`.</summary>
    public class Binding : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary></summary>
        [Newtonsoft.Json.JsonPropertyAttribute("bindingId")]
        public virtual string BindingId { get; set; }

        /// <summary>
        /// The condition that is associated with this binding.  If the condition evaluates to `true`, then this binding
        /// applies to the current request.  If the condition evaluates to `false`, then this binding does not apply to
        /// the current request. However, a different role binding might grant the same role to one or more of the
        /// members in this binding.  To learn which resources support conditions in their IAM policies, see the [IAM
        /// documentation](https://cloud.google.com/iam/help/conditions/resource-policies).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("condition")]
        public virtual Expr Condition { get; set; }

        /// <summary>
        /// Specifies the identities requesting access for a Cloud Platform resource. `members` can have the following
        /// values:  * `allUsers`: A special identifier that represents anyone who is on the internet; with or without a
        /// Google account.  * `allAuthenticatedUsers`: A special identifier that represents anyone who is authenticated
        /// with a Google account or a service account.  * `user:{emailid}`: An email address that represents a specific
        /// Google account. For example, `alice@example.com` .    * `serviceAccount:{emailid}`: An email address that
        /// represents a service account. For example, `my-other-app@appspot.gserviceaccount.com`.  * `group:{emailid}`:
        /// An email address that represents a Google group. For example, `admins@example.com`.  *
        /// `deleted:user:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a user that
        /// has been recently deleted. For example, `alice@example.com?uid=123456789012345678901`. If the user is
        /// recovered, this value reverts to `user:{emailid}` and the recovered user retains the role in the binding.  *
        /// `deleted:serviceAccount:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a
        /// service account that has been recently deleted. For example,
        /// `my-other-app@appspot.gserviceaccount.com?uid=123456789012345678901`. If the service account is undeleted,
        /// this value reverts to `serviceAccount:{emailid}` and the undeleted service account retains the role in the
        /// binding.  * `deleted:group:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing
        /// a Google group that has been recently deleted. For example, `admins@example.com?uid=123456789012345678901`.
        /// If the group is recovered, this value reverts to `group:{emailid}` and the recovered group retains the role
        /// in the binding.    * `domain:{domain}`: The G Suite domain (primary) that represents all the users of that
        /// domain. For example, `google.com` or `example.com`.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("members")]
        public virtual System.Collections.Generic.IList<string> Members { get; set; }

        /// <summary>
        /// Role that is assigned to `members`. For example, `roles/viewer`, `roles/editor`, or `roles/owner`.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("role")]
        public virtual string Role { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class BulkInsertInstanceResource : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The maximum number of instances to create.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("count")]
        public virtual System.Nullable<long> Count { get; set; }

        /// <summary>
        /// The instance properties defining the VM instances to be created. Required if sourceInstanceTemplate is not
        /// provided.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceProperties")]
        public virtual InstanceProperties InstanceProperties { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("locationPolicy")]
        public virtual LocationPolicy LocationPolicy { get; set; }

        /// <summary>
        /// The minimum number of instances to create. If no min_count is specified then count is used as the default
        /// value. If min_count instances cannot be created, then no instances will be created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minCount")]
        public virtual System.Nullable<long> MinCount { get; set; }

        /// <summary>
        /// The string pattern used for the names of the VMs. Either name_pattern or predefined_names must be set. The
        /// pattern should contain one consecutive sequence of placeholder hash characters (#) with each character
        /// corresponding to one digit of the generated instance name. Example: name_pattern of inst-#### will generate
        /// instance names like inst-0001, inst-0002, ... . If there already exist instance(s) whose names match the
        /// name pattern in the same project and zone, then the generated instance numbers will start after the biggest
        /// existing number. For example, if there exists an instance with name inst-0050, then instance names generated
        /// using the pattern inst-#### will be inst-0051, inst-0052, etc. The name pattern placeholder #...# can
        /// contain up to 18 characters.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("namePattern")]
        public virtual string NamePattern { get; set; }

        /// <summary>
        /// Per-instance properties to be set on individual instances. Keys of this map specify requested instance
        /// names. Can be empty if name_pattern is used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("perInstanceProperties")]
        public virtual System.Collections.Generic.IDictionary<string, BulkInsertInstanceResourcePerInstanceProperties> PerInstanceProperties { get; set; }

        /// <summary>
        /// Specifies the instance template from which to create instances. You may combine sourceInstanceTemplate with
        /// instanceProperties to override specific values from an existing instance template. Bulk API follows the
        /// semantics of JSON Merge Patch described by RFC 7396.  It can be a full or partial URL. For example, the
        /// following are all valid URLs to an instance template:   -
        /// https://www.googleapis.com/compute/v1/projects/project/global/instanceTemplates/instanceTemplate  -
        /// projects/project/global/instanceTemplates/instanceTemplate  - global/instanceTemplates/instanceTemplate
        /// This field is optional.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceInstanceTemplate")]
        public virtual string SourceInstanceTemplate { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Per-instance properties to be set on individual instances. To be extended in the future.</summary>
    public class BulkInsertInstanceResourcePerInstanceProperties : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>This field is only temporary. It will be removed. Do not use it.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class CacheInvalidationRule : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// If set, this invalidation rule will only apply to requests with a Host header matching host.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("host")]
        public virtual string Host { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("path")]
        public virtual string Path { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Message containing what to include in the cache key for a request for Cloud CDN.</summary>
    public class CacheKeyPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>If true, requests to different hosts will be cached separately.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("includeHost")]
        public virtual System.Nullable<bool> IncludeHost { get; set; }

        /// <summary>If true, http and https requests will be cached separately.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("includeProtocol")]
        public virtual System.Nullable<bool> IncludeProtocol { get; set; }

        /// <summary>
        /// If true, include query string parameters in the cache key according to query_string_whitelist and
        /// query_string_blacklist. If neither is set, the entire query string will be included. If false, the query
        /// string will be excluded from the cache key entirely.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("includeQueryString")]
        public virtual System.Nullable<bool> IncludeQueryString { get; set; }

        /// <summary>
        /// Names of query string parameters to exclude in cache keys. All other parameters will be included. Either
        /// specify query_string_whitelist or query_string_blacklist, not both. '&amp;amp;' and '=' will be percent
        /// encoded and not treated as delimiters.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("queryStringBlacklist")]
        public virtual System.Collections.Generic.IList<string> QueryStringBlacklist { get; set; }

        /// <summary>
        /// Names of query string parameters to include in cache keys. All other parameters will be excluded. Either
        /// specify query_string_whitelist or query_string_blacklist, not both. '&amp;amp;' and '=' will be percent
        /// encoded and not treated as delimiters.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("queryStringWhitelist")]
        public virtual System.Collections.Generic.IList<string> QueryStringWhitelist { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Settings controlling the volume of connections to a backend service.</summary>
    public class CircuitBreakers : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The maximum number of connections to the backend service. If not specified, there is no limit.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxConnections")]
        public virtual System.Nullable<int> MaxConnections { get; set; }

        /// <summary>
        /// The maximum number of pending requests allowed to the backend service. If not specified, there is no limit.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxPendingRequests")]
        public virtual System.Nullable<int> MaxPendingRequests { get; set; }

        /// <summary>
        /// The maximum number of parallel requests that allowed to the backend service. If not specified, there is no
        /// limit.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxRequests")]
        public virtual System.Nullable<int> MaxRequests { get; set; }

        /// <summary>
        /// Maximum requests for a single connection to the backend service. This parameter is respected by both the
        /// HTTP/1.1 and HTTP/2 implementations. If not specified, there is no limit. Setting this parameter to 1 will
        /// effectively disable keep alive.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxRequestsPerConnection")]
        public virtual System.Nullable<int> MaxRequestsPerConnection { get; set; }

        /// <summary>
        /// The maximum number of parallel retries allowed to the backend cluster. If not specified, the default is 1.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxRetries")]
        public virtual System.Nullable<int> MaxRetries { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a regional Commitment resource.  Creating a commitment resource means that you are purchasing a
    /// committed use contract with an explicit start and end time. You can create commitments based on vCPUs and memory
    /// usage and receive discounted rates. For full details, read Signing Up for Committed Use Discounts. (==
    /// resource_for {$api_version}.regionCommitments ==)
    /// </summary>
    public class Commitment : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The category of the commitment. Category MACHINE specifies commitments composed of machine resources such as
        /// VCPU or MEMORY, listed in resources. Category LICENSE specifies commitments composed of software licenses,
        /// listed in licenseResources. Note that only MACHINE commitments should have a Type specified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("category")]
        public virtual string Category { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>[Output Only] Commitment end time in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("endTimestamp")]
        public virtual string EndTimestamp { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#commitment for commitments.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>The license specification required as part of a license commitment.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("licenseResource")]
        public virtual LicenseResourceCommitment LicenseResource { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// The plan for this commitment, which determines duration and discount rate. The currently supported plans are
        /// TWELVE_MONTH (1 year), and THIRTY_SIX_MONTH (3 years).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("plan")]
        public virtual string Plan { get; set; }

        /// <summary>[Output Only] URL of the region where this commitment may be used.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>List of reservations in this commitment.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("reservations")]
        public virtual System.Collections.Generic.IList<Reservation> Reservations { get; set; }

        /// <summary>
        /// A list of commitment amounts for particular resources. Note that VCPU and MEMORY resource commitments must
        /// occur together.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resources")]
        public virtual System.Collections.Generic.IList<ResourceCommitment> Resources { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Commitment start time in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("startTimestamp")]
        public virtual string StartTimestamp { get; set; }

        /// <summary>
        /// [Output Only] Status of the commitment with regards to eventual expiration (each commitment has an end date
        /// defined). One of the following values: NOT_YET_ACTIVE, ACTIVE, EXPIRED.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>[Output Only] An optional, human-readable explanation of the status.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("statusMessage")]
        public virtual string StatusMessage { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class CommitmentAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of CommitmentsScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, CommitmentsScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#commitmentAggregatedList for aggregated lists of commitments.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of Commitment resources.</summary>
    public class CommitmentList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Commitment resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Commitment> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#commitmentList for lists of commitments.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class CommitmentsScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of commitments contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("commitments")]
        public virtual System.Collections.Generic.IList<Commitment> Commitments { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of commitments when the list is empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of commitments when the list is empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>A condition to be met.</summary>
    public class Condition : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Trusted attributes supplied by the IAM system.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("iam")]
        public virtual string Iam { get; set; }

        /// <summary>An operator to apply the subject with.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("op")]
        public virtual string Op { get; set; }

        /// <summary>Trusted attributes discharged by the service.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("svc")]
        public virtual string Svc { get; set; }

        /// <summary>
        /// Trusted attributes supplied by any service that owns resources and uses the IAM system for access control.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sys")]
        public virtual string Sys { get; set; }

        /// <summary>The objects of the condition.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("values")]
        public virtual System.Collections.Generic.IList<string> Values { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A set of Confidential Instance options.</summary>
    public class ConfidentialInstanceConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Defines whether the instance should have confidential compute enabled.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enableConfidentialCompute")]
        public virtual System.Nullable<bool> EnableConfidentialCompute { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Message containing connection draining configuration.</summary>
    public class ConnectionDraining : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Configures a duration timeout for existing requests on a removed backend instance. For supported load
        /// balancers and protocols, as described in Enabling connection draining.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("drainingTimeoutSec")]
        public virtual System.Nullable<int> DrainingTimeoutSec { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>This message defines settings for a consistent hash style load balancer.</summary>
    public class ConsistentHashLoadBalancerSettings : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Hash is based on HTTP Cookie. This field describes a HTTP cookie that will be used as the hash key for the
        /// consistent hash load balancer. If the cookie is not present, it will be generated. This field is applicable
        /// if the sessionAffinity is set to HTTP_COOKIE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("httpCookie")]
        public virtual ConsistentHashLoadBalancerSettingsHttpCookie HttpCookie { get; set; }

        /// <summary>
        /// The hash based on the value of the specified header field. This field is applicable if the sessionAffinity
        /// is set to HEADER_FIELD.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("httpHeaderName")]
        public virtual string HttpHeaderName { get; set; }

        /// <summary>
        /// The minimum number of virtual nodes to use for the hash ring. Defaults to 1024. Larger ring sizes result in
        /// more granular load distributions. If the number of hosts in the load balancing pool is larger than the ring
        /// size, each host will be assigned a single virtual node.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minimumRingSize")]
        public virtual System.Nullable<long> MinimumRingSize { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// The information about the HTTP Cookie on which the hash function is based for load balancing policies that use a
    /// consistent hash.
    /// </summary>
    public class ConsistentHashLoadBalancerSettingsHttpCookie : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Name of the cookie.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>Path to set for the cookie.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("path")]
        public virtual string Path { get; set; }

        /// <summary>Lifetime of the cookie.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ttl")]
        public virtual Duration Ttl { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// The specification for allowing client side cross-origin requests. Please see W3C Recommendation for Cross Origin
    /// Resource Sharing
    /// </summary>
    public class CorsPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// In response to a preflight request, setting this to true indicates that the actual request can include user
        /// credentials. This translates to the Access-Control-Allow-Credentials header. Default is false.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("allowCredentials")]
        public virtual System.Nullable<bool> AllowCredentials { get; set; }

        /// <summary>Specifies the content for the Access-Control-Allow-Headers header.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("allowHeaders")]
        public virtual System.Collections.Generic.IList<string> AllowHeaders { get; set; }

        /// <summary>Specifies the content for the Access-Control-Allow-Methods header.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("allowMethods")]
        public virtual System.Collections.Generic.IList<string> AllowMethods { get; set; }

        /// <summary>
        /// Specifies the regualar expression patterns that match allowed origins. For regular expression grammar please
        /// see github.com/google/re2/wiki/Syntax  An origin is allowed if it matches either an item in allowOrigins or
        /// an item in allowOriginRegexes.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("allowOriginRegexes")]
        public virtual System.Collections.Generic.IList<string> AllowOriginRegexes { get; set; }

        /// <summary>
        /// Specifies the list of origins that will be allowed to do CORS requests. An origin is allowed if it matches
        /// either an item in allowOrigins or an item in allowOriginRegexes.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("allowOrigins")]
        public virtual System.Collections.Generic.IList<string> AllowOrigins { get; set; }

        /// <summary>
        /// If true, specifies the CORS policy is disabled. The default value of false, which indicates that the CORS
        /// policy is in effect.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("disabled")]
        public virtual System.Nullable<bool> Disabled { get; set; }

        /// <summary>Specifies the content for the Access-Control-Expose-Headers header.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("exposeHeaders")]
        public virtual System.Collections.Generic.IList<string> ExposeHeaders { get; set; }

        /// <summary>
        /// Specifies how long results of a preflight request can be cached in seconds. This translates to the
        /// Access-Control-Max-Age header.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxAge")]
        public virtual System.Nullable<int> MaxAge { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class CustomerEncryptionKey : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The name of the encryption key that is stored in Google Cloud KMS.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kmsKeyName")]
        public virtual string KmsKeyName { get; set; }

        /// <summary>
        /// The service account being used for the encryption request for the given KMS key. If absent, the Compute
        /// Engine default service account is used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kmsKeyServiceAccount")]
        public virtual string KmsKeyServiceAccount { get; set; }

        /// <summary>
        /// Specifies a 256-bit customer-supplied encryption key, encoded in RFC 4648 base64 to either encrypt or
        /// decrypt this resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("rawKey")]
        public virtual string RawKey { get; set; }

        /// <summary>
        /// [Output only] The RFC 4648 base64 encoded SHA-256 hash of the customer-supplied encryption key that protects
        /// this resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sha256")]
        public virtual string Sha256 { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class CustomerEncryptionKeyProtectedDisk : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Decrypts data associated with the disk with a customer-supplied encryption key.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskEncryptionKey")]
        public virtual CustomerEncryptionKey DiskEncryptionKey { get; set; }

        /// <summary>
        /// Specifies a valid partial or full URL to an existing Persistent Disk resource. This field is only applicable
        /// for persistent disks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("source")]
        public virtual string Source { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Deprecation status for a public resource.</summary>
    public class DeprecationStatus : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// An optional RFC3339 timestamp on or after which the state of this resource is intended to change to DELETED.
        /// This is only informational and the status will not change unless the client explicitly changes it.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("deleted")]
        public virtual string Deleted { get; set; }

        /// <summary>
        /// An optional RFC3339 timestamp on or after which the state of this resource is intended to change to
        /// DEPRECATED. This is only informational and the status will not change unless the client explicitly changes
        /// it.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("deprecated")]
        public virtual string Deprecated { get; set; }

        /// <summary>
        /// An optional RFC3339 timestamp on or after which the state of this resource is intended to change to
        /// OBSOLETE. This is only informational and the status will not change unless the client explicitly changes it.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("obsolete")]
        public virtual string Obsolete { get; set; }

        /// <summary>
        /// The URL of the suggested replacement for a deprecated resource. The suggested replacement resource must be
        /// the same kind of resource as the deprecated resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("replacement")]
        public virtual string Replacement { get; set; }

        /// <summary>
        /// The deprecation state of this resource. This can be ACTIVE, DEPRECATED, OBSOLETE, or DELETED. Operations
        /// which communicate the end of life date for an image, can use ACTIVE. Operations which create a new resource
        /// using a DEPRECATED resource will return successfully, but with a warning indicating the deprecated resource
        /// and recommending its replacement. Operations which use OBSOLETE or DELETED resources will be rejected and
        /// result in an error.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("state")]
        public virtual string State { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Persistent Disk resource.  Google Compute Engine has two Disk resources:  *
    /// [Zonal](/compute/docs/reference/rest/{$api_version}/disks) *
    /// [Regional](/compute/docs/reference/rest/{$api_version}/regionDisks)  Persistent disks are required for running
    /// your VM instances. Create both boot and non-boot (data) persistent disks. For more information, read Persistent
    /// Disks. For more storage options, read Storage options.  The disks resource represents a zonal persistent disk.
    /// For more information, read Zonal persistent disks.  The regionDisks resource represents a regional persistent
    /// disk. For more information, read  Regional resources. (== resource_for {$api_version}.disks ==) (== resource_for
    /// {$api_version}.regionDisks ==)
    /// </summary>
    public class Disk : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Encrypts the disk using a customer-supplied encryption key.  After you encrypt a disk with a
        /// customer-supplied key, you must provide the same key if you use the disk later (e.g. to create a disk
        /// snapshot, to create a disk image, to create a machine image, or to attach the disk to a virtual machine).
        /// Customer-supplied encryption keys do not protect access to metadata of the disk.  If you do not provide an
        /// encryption key when creating the disk, then the disk will be encrypted using an automatically generated key
        /// and you do not need to provide a key to use the disk later.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskEncryptionKey")]
        public virtual CustomerEncryptionKey DiskEncryptionKey { get; set; }

        /// <summary>
        /// A list of features to enable on the guest operating system. Applicable only for bootable images. Read
        /// Enabling guest operating system features to see a list of available options.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("guestOsFeatures")]
        public virtual System.Collections.Generic.IList<GuestOsFeature> GuestOsFeatures { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#disk for disks.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// A fingerprint for the labels being applied to this disk, which is essentially a hash of the labels set used
        /// for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every
        /// request to modify or update labels. You must always provide an up-to-date fingerprint hash in order to
        /// update or change labels, otherwise the request will fail with error 412 conditionNotMet.  To see the latest
        /// fingerprint, make a get() request to retrieve a disk.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labelFingerprint")]
        public virtual string LabelFingerprint { get; set; }

        /// <summary>Labels to apply to this disk. These can be later modified by the setLabels method.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>[Output Only] Last attach timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("lastAttachTimestamp")]
        public virtual string LastAttachTimestamp { get; set; }

        /// <summary>[Output Only] Last detach timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("lastDetachTimestamp")]
        public virtual string LastDetachTimestamp { get; set; }

        /// <summary>Integer license codes indicating which licenses are attached to this disk.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("licenseCodes")]
        public virtual System.Collections.Generic.IList<System.Nullable<long>> LicenseCodes { get; set; }

        /// <summary>A list of publicly visible licenses. Reserved for Google's use.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("licenses")]
        public virtual System.Collections.Generic.IList<string> Licenses { get; set; }

        /// <summary>
        /// An opaque location hint used to place the disk close to other resources. This field is for use by internal
        /// tools that use the public API.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("locationHint")]
        public virtual string LocationHint { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>Internal use only.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("options")]
        public virtual string Options { get; set; }

        /// <summary>
        /// Physical block size of the persistent disk, in bytes. If not present in a request, a default value is used.
        /// The currently supported size is 4096, other sizes may be added in the future. If an unsupported value is
        /// requested, the error message will list the supported values for the caller's project.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("physicalBlockSizeBytes")]
        public virtual System.Nullable<long> PhysicalBlockSizeBytes { get; set; }

        /// <summary>Indicates how many IOPS must be provisioned for the disk.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("provisionedIops")]
        public virtual System.Nullable<long> ProvisionedIops { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the disk resides. Only applicable for regional resources. You must
        /// specify this field as part of the HTTP request URL. It is not settable as a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>
        /// URLs of the zones where the disk should be replicated to. Only applicable for regional resources.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("replicaZones")]
        public virtual System.Collections.Generic.IList<string> ReplicaZones { get; set; }

        /// <summary>Resource policies applied to this disk for automatic snapshot creations.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resourcePolicies")]
        public virtual System.Collections.Generic.IList<string> ResourcePolicies { get; set; }

        /// <summary>[Output Only] Reserved for future use.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("satisfiesPzs")]
        public virtual System.Nullable<bool> SatisfiesPzs { get; set; }

        /// <summary>[Output Only] Server-defined fully-qualified URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// Size, in GB, of the persistent disk. You can specify this field when creating a persistent disk using the
        /// sourceImage, sourceSnapshot, or sourceDisk parameter, or specify it alone to create an empty persistent
        /// disk.  If you specify this field along with a source, the value of sizeGb must not be less than the size of
        /// the source. Acceptable values are 1 to 65536, inclusive.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sizeGb")]
        public virtual System.Nullable<long> SizeGb { get; set; }

        /// <summary>
        /// The source disk used to create this disk. You can provide this as a partial or full URL to the resource. For
        /// example, the following are valid values:   -
        /// https://www.googleapis.com/compute/v1/projects/project/zones/zone/disks/disk   -
        /// https://www.googleapis.com/compute/v1/projects/project/regions/region/disks/disk   -
        /// projects/project/zones/zone/disks/disk   - projects/project/regions/region/disks/disk   -
        /// zones/zone/disks/disk   - regions/region/disks/disk
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceDisk")]
        public virtual string SourceDisk { get; set; }

        /// <summary>
        /// [Output Only] The unique ID of the disk used to create this disk. This value identifies the exact disk that
        /// was used to create this persistent disk. For example, if you created the persistent disk from a disk that
        /// was later deleted and recreated under the same name, the source disk ID would identify the exact version of
        /// the disk that was used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceDiskId")]
        public virtual string SourceDiskId { get; set; }

        /// <summary>
        /// The source image used to create this disk. If the source image is deleted, this field will not be set.  To
        /// create a disk with one of the public operating system images, specify the image by its family name. For
        /// example, specify family/debian-9 to use the latest Debian 9 image:
        /// projects/debian-cloud/global/images/family/debian-9   Alternatively, use a specific version of a public
        /// operating system image: projects/debian-cloud/global/images/debian-9-stretch-vYYYYMMDD   To create a disk
        /// with a custom image that you created, specify the image name in the following format:
        /// global/images/my-custom-image   You can also specify a custom image by its image family, which returns the
        /// latest version of the image in that family. Replace the image name with family/family-name:
        /// global/images/family/my-image-family
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceImage")]
        public virtual string SourceImage { get; set; }

        /// <summary>
        /// The customer-supplied encryption key of the source image. Required if the source image is protected by a
        /// customer-supplied encryption key.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceImageEncryptionKey")]
        public virtual CustomerEncryptionKey SourceImageEncryptionKey { get; set; }

        /// <summary>
        /// [Output Only] The ID value of the image used to create this disk. This value identifies the exact image that
        /// was used to create this persistent disk. For example, if you created the persistent disk from an image that
        /// was later deleted and recreated under the same name, the source image ID would identify the exact version of
        /// the image that was used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceImageId")]
        public virtual string SourceImageId { get; set; }

        /// <summary>
        /// The source snapshot used to create this disk. You can provide this as a partial or full URL to the resource.
        /// For example, the following are valid values:   -
        /// https://www.googleapis.com/compute/v1/projects/project/global/snapshots/snapshot  -
        /// projects/project/global/snapshots/snapshot  - global/snapshots/snapshot
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceSnapshot")]
        public virtual string SourceSnapshot { get; set; }

        /// <summary>
        /// The customer-supplied encryption key of the source snapshot. Required if the source snapshot is protected by
        /// a customer-supplied encryption key.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceSnapshotEncryptionKey")]
        public virtual CustomerEncryptionKey SourceSnapshotEncryptionKey { get; set; }

        /// <summary>
        /// [Output Only] The unique ID of the snapshot used to create this disk. This value identifies the exact
        /// snapshot that was used to create this persistent disk. For example, if you created the persistent disk from
        /// a snapshot that was later deleted and recreated under the same name, the source snapshot ID would identify
        /// the exact version of the snapshot that was used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceSnapshotId")]
        public virtual string SourceSnapshotId { get; set; }

        /// <summary>
        /// The full Google Cloud Storage URI where the disk image is stored. This file must be a gzip-compressed
        /// tarball whose name ends in .tar.gz or virtual machine disk whose name ends in vmdk. Valid URIs may start
        /// with gs:// or https://storage.googleapis.com/. This flag is not optimized for creating multiple disks from a
        /// source storage object. To create many disks from a source storage object, use gcloud compute images import
        /// instead.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceStorageObject")]
        public virtual string SourceStorageObject { get; set; }

        /// <summary>
        /// [Output Only] The status of disk creation.   - CREATING: Disk is provisioning.  - RESTORING: Source data is
        /// being copied into the disk.  - FAILED: Disk creation failed.  - READY: Disk is ready for use.  - DELETING:
        /// Disk is deleting.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>
        /// URL of the disk type resource describing which disk type to use to create the disk. Provide this when
        /// creating the disk. For example: projects/project/zones/zone/diskTypes/pd-standard  or pd-ssd
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>
        /// [Output Only] Links to the users of the disk (attached instances) in form:
        /// projects/project/zones/zone/instances/instance
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("users")]
        public virtual System.Collections.Generic.IList<string> Users { get; set; }

        /// <summary>
        /// [Output Only] URL of the zone where the disk resides. You must specify this field as part of the HTTP
        /// request URL. It is not settable as a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class DiskAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of DisksScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, DisksScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#diskAggregatedList for aggregated lists of persistent disks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// A specification of the desired way to instantiate a disk in the instance template when its created from a source
    /// instance.
    /// </summary>
    public class DiskInstantiationConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Specifies whether the disk will be auto-deleted when the instance is deleted (but not when the disk is
        /// detached from the instance).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoDelete")]
        public virtual System.Nullable<bool> AutoDelete { get; set; }

        /// <summary>
        /// The custom source image to be used to restore this disk when instantiating this instance template.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("customImage")]
        public virtual string CustomImage { get; set; }

        /// <summary>Specifies the device name of the disk to which the configurations apply to.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("deviceName")]
        public virtual string DeviceName { get; set; }

        /// <summary>
        /// Specifies whether to include the disk and what image to use. Possible values are:   - source-image: to use
        /// the same image that was used to create the source instance's corresponding disk. Applicable to the boot disk
        /// and additional read-write disks.  - source-image-family: to use the same image family that was used to
        /// create the source instance's corresponding disk. Applicable to the boot disk and additional read-write
        /// disks.  - custom-image: to use a user-provided image url for disk creation. Applicable to the boot disk and
        /// additional read-write disks.  - attach-read-only: to attach a read-only disk. Applicable to read-only disks.
        ///  - do-not-include: to exclude a disk from the template. Applicable to additional read-write disks, local
        /// SSDs, and read-only disks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instantiateFrom")]
        public virtual string InstantiateFrom { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A list of Disk resources.</summary>
    public class DiskList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Disk resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Disk> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#diskList for lists of disks.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class DiskMoveRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The URL of the destination zone to move the disk. This can be a full or partial URL. For example, the
        /// following are all valid URLs to a zone:   -
        /// https://www.googleapis.com/compute/v1/projects/project/zones/zone  - projects/project/zones/zone  -
        /// zones/zone
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("destinationZone")]
        public virtual string DestinationZone { get; set; }

        /// <summary>
        /// The URL of the target disk to move. This can be a full or partial URL. For example, the following are all
        /// valid URLs to a disk:   - https://www.googleapis.com/compute/v1/projects/project/zones/zone/disks/disk  -
        /// projects/project/zones/zone/disks/disk  - zones/zone/disks/disk
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetDisk")]
        public virtual string TargetDisk { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Disk Type resource.  Google Compute Engine has two Disk Type resources:  *
    /// [Regional](/compute/docs/reference/rest/{$api_version}/regionDiskTypes) *
    /// [Zonal](/compute/docs/reference/rest/{$api_version}/diskTypes)  You can choose from a variety of disk types
    /// based on your needs. For more information, read Storage options.  The diskTypes resource represents disk types
    /// for a zonal persistent disk. For more information, read Zonal persistent disks.  The regionDiskTypes resource
    /// represents disk types for a regional persistent disk. For more information, read Regional persistent disks. (==
    /// resource_for {$api_version}.diskTypes ==) (== resource_for {$api_version}.regionDiskTypes ==)
    /// </summary>
    public class DiskType : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>[Output Only] Server-defined default disk size in GB.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("defaultDiskSizeGb")]
        public virtual System.Nullable<long> DefaultDiskSizeGb { get; set; }

        /// <summary>[Output Only] The deprecation status associated with this disk type.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("deprecated")]
        public virtual DeprecationStatus Deprecated { get; set; }

        /// <summary>[Output Only] An optional description of this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#diskType for disk types.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>[Output Only] Name of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the disk type resides. Only applicable for regional resources. You
        /// must specify this field as part of the HTTP request URL. It is not settable as a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// [Output Only] An optional textual description of the valid disk size, such as "10GB-10TB".
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("validDiskSize")]
        public virtual string ValidDiskSize { get; set; }

        /// <summary>
        /// [Output Only] URL of the zone where the disk type resides. You must specify this field as part of the HTTP
        /// request URL. It is not settable as a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class DiskTypeAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of DiskTypesScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, DiskTypesScopedList> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#diskTypeAggregatedList.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of disk types.</summary>
    public class DiskTypeList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of DiskType resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<DiskType> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#diskTypeList for disk types.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class DiskTypesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of disk types contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskTypes")]
        public virtual System.Collections.Generic.IList<DiskType> DiskTypes { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of disk types when the list is empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of disk types when the list is empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class DisksAddResourcePoliciesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Resource policies to be added to this disk. Currently you can only specify one policy here.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resourcePolicies")]
        public virtual System.Collections.Generic.IList<string> ResourcePolicies { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class DisksRemoveResourcePoliciesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Resource policies to be removed from this disk.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resourcePolicies")]
        public virtual System.Collections.Generic.IList<string> ResourcePolicies { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class DisksResizeRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The new size of the persistent disk, which is specified in GB.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sizeGb")]
        public virtual System.Nullable<long> SizeGb { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class DisksScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of disks contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("disks")]
        public virtual System.Collections.Generic.IList<Disk> Disks { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of disks when the list is empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of disks when the list is empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>A set of Display Device options</summary>
    public class DisplayDevice : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Defines whether the instance has Display enabled.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enableDisplay")]
        public virtual System.Nullable<bool> EnableDisplay { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class DistributionPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Zones where the regional managed instance group will create and manage its instances.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zones")]
        public virtual System.Collections.Generic.IList<DistributionPolicyZoneConfiguration> Zones { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class DistributionPolicyZoneConfiguration : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The URL of the zone. The zone must exist in the region where the managed instance group is located.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// A Duration represents a fixed-length span of time represented as a count of seconds and fractions of seconds at
    /// nanosecond resolution. It is independent of any calendar and concepts like "day" or "month". Range is
    /// approximately 10,000 years.
    /// </summary>
    public class Duration : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Span of time that's a fraction of a second at nanosecond resolution. Durations less than one second are
        /// represented with a 0 `seconds` field and a positive `nanos` field. Must be from 0 to 999,999,999 inclusive.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nanos")]
        public virtual System.Nullable<int> Nanos { get; set; }

        /// <summary>
        /// Span of time at a resolution of a second. Must be from 0 to 315,576,000,000 inclusive. Note: these bounds
        /// are computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("seconds")]
        public virtual System.Nullable<long> Seconds { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ExchangedPeeringRoute : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The destination range of the route.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("destRange")]
        public virtual string DestRange { get; set; }

        /// <summary>
        /// True if the peering route has been imported from a peer. The actual import happens if the field
        /// networkPeering.importCustomRoutes is true for this network, and networkPeering.exportCustomRoutes is true
        /// for the peer network, and the import does not result in a route conflict.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("imported")]
        public virtual System.Nullable<bool> Imported { get; set; }

        /// <summary>The region of peering route next hop, only applies to dynamic routes.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextHopRegion")]
        public virtual string NextHopRegion { get; set; }

        /// <summary>The priority of the peering route.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("priority")]
        public virtual System.Nullable<long> Priority { get; set; }

        /// <summary>The type of the peering route.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ExchangedPeeringRoutesList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of ExchangedPeeringRoute resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<ExchangedPeeringRoute> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#exchangedPeeringRoutesList for exchanged peering routes
        /// lists.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a textual expression in the Common Expression Language (CEL) syntax. CEL is a C-like expression
    /// language. The syntax and semantics of CEL are documented at https://github.com/google/cel-spec.  Example
    /// (Comparison):  title: "Summary size limit" description: "Determines if a summary is less than 100 chars"
    /// expression: "document.summary.size() &amp;lt; 100"  Example (Equality):  title: "Requestor is owner"
    /// description: "Determines if requestor is the document owner" expression: "document.owner ==
    /// request.auth.claims.email"  Example (Logic):  title: "Public documents" description: "Determine whether the
    /// document should be publicly visible" expression: "document.type != 'private' &amp;amp;&amp;amp; document.type !=
    /// 'internal'"  Example (Data Manipulation):  title: "Notification string" description: "Create a notification
    /// string with a timestamp." expression: "'New message received at ' + string(document.create_time)"  The exact
    /// variables and functions that may be referenced within an expression are determined by the service that evaluates
    /// it. See the service documentation for additional information.
    /// </summary>
    public class Expr : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Optional. Description of the expression. This is a longer text which describes the expression, e.g. when
        /// hovered over it in a UI.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>Textual representation of an expression in Common Expression Language syntax.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("expression")]
        public virtual string Expression { get; set; }

        /// <summary>
        /// Optional. String indicating the location of the expression for error reporting, e.g. a file name and a
        /// position in the file.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("location")]
        public virtual string Location { get; set; }

        /// <summary>
        /// Optional. Title for the expression, i.e. a short string describing its purpose. This can be used e.g. in UIs
        /// which allow to enter the expression.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("title")]
        public virtual string Title { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents an external VPN gateway.  External VPN gateway is the on-premises VPN gateway(s) or another cloud
    /// provider's VPN gateway that connects to your Google Cloud VPN gateway.  To create a highly available VPN from
    /// Google Cloud Platform to your VPN gateway or another cloud provider's VPN gateway, you must create a external
    /// VPN gateway resource with information about the other gateway.  For more information about using external VPN
    /// gateways, see  Creating an HA VPN gateway and tunnel pair to a peer VPN. (== resource_for
    /// {$api_version}.externalVpnGateways ==)
    /// </summary>
    public class ExternalVpnGateway : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>List of interfaces for this external VPN gateway.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("interfaces")]
        public virtual System.Collections.Generic.IList<ExternalVpnGatewayInterface> Interfaces { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#externalVpnGateway for externalVpnGateways.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// A fingerprint for the labels being applied to this ExternalVpnGateway, which is essentially a hash of the
        /// labels set used for optimistic locking. The fingerprint is initially generated by Compute Engine and changes
        /// after every request to modify or update labels. You must always provide an up-to-date fingerprint hash in
        /// order to update or change labels, otherwise the request will fail with error 412 conditionNotMet.  To see
        /// the latest fingerprint, make a get() request to retrieve an ExternalVpnGateway.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labelFingerprint")]
        public virtual string LabelFingerprint { get; set; }

        /// <summary>
        /// Labels for this resource. These can only be added or modified by the setLabels method. Each label key/value
        /// pair must comply with RFC1035. Label values may be empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>Indicates the user-supplied redundancy type of this external VPN gateway.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("redundancyType")]
        public virtual string RedundancyType { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>The interface for the external VPN gateway.</summary>
    public class ExternalVpnGatewayInterface : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The numeric ID of this interface. The allowed input values for this id for different redundancy types of
        /// external VPN gateway: SINGLE_IP_INTERNALLY_REDUNDANT - 0 TWO_IPS_REDUNDANCY - 0, 1 FOUR_IPS_REDUNDANCY - 0,
        /// 1, 2, 3
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<long> Id { get; set; }

        /// <summary>
        /// IP address of the interface in the external VPN gateway. Only IPv4 is supported. This IP address can be
        /// either from your on-premise gateway or another Cloud provider's VPN gateway, it cannot be an IP address from
        /// Google Compute Engine.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipAddress")]
        public virtual string IpAddress { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Response to the list request, and contains a list of externalVpnGateways.</summary>
    public class ExternalVpnGatewayList : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("etag")]
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of ExternalVpnGateway resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<ExternalVpnGateway> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#externalVpnGatewayList  for lists of externalVpnGateways.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class FileContentBuffer : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The raw content in the secure keys file.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("content")]
        public virtual string Content { get; set; }

        /// <summary>The file type of source file.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fileType")]
        public virtual string FileType { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Firewall Rule resource.  Firewall rules allow or deny ingress traffic to, and egress traffic from
    /// your instances. For more information, read Firewall rules.
    /// </summary>
    public class Firewall : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The list of ALLOW rules specified by this firewall. Each rule specifies a protocol and port-range tuple that
        /// describes a permitted connection.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("allowed")]
        public virtual System.Collections.Generic.IList<AllowedData> Allowed { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// The list of DENY rules specified by this firewall. Each rule specifies a protocol and port-range tuple that
        /// describes a denied connection.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("denied")]
        public virtual System.Collections.Generic.IList<DeniedData> Denied { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this field when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// If destination ranges are specified, the firewall rule applies only to traffic that has destination IP
        /// address in these ranges. These ranges must be expressed in CIDR format. Only IPv4 is supported.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("destinationRanges")]
        public virtual System.Collections.Generic.IList<string> DestinationRanges { get; set; }

        /// <summary>
        /// Direction of traffic to which this firewall applies, either `INGRESS` or `EGRESS`. The default is `INGRESS`.
        /// For `INGRESS` traffic, you cannot specify the destinationRanges field, and for `EGRESS` traffic, you cannot
        /// specify the sourceRanges or sourceTags fields.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("direction")]
        public virtual string Direction { get; set; }

        /// <summary>
        /// Denotes whether the firewall rule is disabled. When set to true, the firewall rule is not enforced and the
        /// network behaves as if it did not exist. If this is unspecified, the firewall rule will be enabled.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("disabled")]
        public virtual System.Nullable<bool> Disabled { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#firewall for firewall rules.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// This field denotes the logging options for a particular firewall rule. If logging is enabled, logs will be
        /// exported to Cloud Logging.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("logConfig")]
        public virtual FirewallLogConfig LogConfig { get; set; }

        /// <summary>
        /// Name of the resource; provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?. The first character must be a lowercase letter, and all following
        /// characters (except for the last character) must be a dash, lowercase letter, or digit. The last character
        /// must be a lowercase letter or digit.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// URL of the network resource for this firewall rule. If not specified when creating a firewall rule, the
        /// default network is used: global/networks/default If you choose to specify this field, you can specify the
        /// network as a full or partial URL. For example, the following are all valid URLs:   -
        /// https://www.googleapis.com/compute/v1/projects/myproject/global/networks/my-network  -
        /// projects/myproject/global/networks/my-network  - global/networks/default
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>
        /// Priority for this rule. This is an integer between `0` and `65535`, both inclusive. The default value is
        /// `1000`. Relative priorities determine which rule takes effect if multiple rules apply. Lower values indicate
        /// higher priority. For example, a rule with priority `0` has higher precedence than a rule with priority `1`.
        /// DENY rules take precedence over ALLOW rules if they have equal priority. Note that VPC networks have implied
        /// rules with a priority of `65535`. To avoid conflicts with the implied rules, use a priority number less than
        /// `65535`.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("priority")]
        public virtual System.Nullable<int> Priority { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// If source ranges are specified, the firewall rule applies only to traffic that has a source IP address in
        /// these ranges. These ranges must be expressed in CIDR format. One or both of sourceRanges and sourceTags may
        /// be set. If both fields are set, the rule applies to traffic that has a source IP address within sourceRanges
        /// OR a source IP from a resource with a matching tag listed in the sourceTags field. The connection does not
        /// need to match both fields for the rule to apply. Only IPv4 is supported.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceRanges")]
        public virtual System.Collections.Generic.IList<string> SourceRanges { get; set; }

        /// <summary>
        /// If source service accounts are specified, the firewall rules apply only to traffic originating from an
        /// instance with a service account in this list. Source service accounts cannot be used to control traffic to
        /// an instance's external IP address because service accounts are associated with an instance, not an IP
        /// address. sourceRanges can be set at the same time as sourceServiceAccounts. If both are set, the firewall
        /// applies to traffic that has a source IP address within the sourceRanges OR a source IP that belongs to an
        /// instance with service account listed in sourceServiceAccount. The connection does not need to match both
        /// fields for the firewall to apply. sourceServiceAccounts cannot be used at the same time as sourceTags or
        /// targetTags.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceServiceAccounts")]
        public virtual System.Collections.Generic.IList<string> SourceServiceAccounts { get; set; }

        /// <summary>
        /// If source tags are specified, the firewall rule applies only to traffic with source IPs that match the
        /// primary network interfaces of VM instances that have the tag and are in the same VPC network. Source tags
        /// cannot be used to control traffic to an instance's external IP address, it only applies to traffic between
        /// instances in the same virtual network. Because tags are associated with instances, not IP addresses. One or
        /// both of sourceRanges and sourceTags may be set. If both fields are set, the firewall applies to traffic that
        /// has a source IP address within sourceRanges OR a source IP from a resource with a matching tag listed in the
        /// sourceTags field. The connection does not need to match both fields for the firewall to apply.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceTags")]
        public virtual System.Collections.Generic.IList<string> SourceTags { get; set; }

        /// <summary>
        /// A list of service accounts indicating sets of instances located in the network that may make network
        /// connections as specified in allowed[]. targetServiceAccounts cannot be used at the same time as targetTags
        /// or sourceTags. If neither targetServiceAccounts nor targetTags are specified, the firewall rule applies to
        /// all instances on the specified network.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetServiceAccounts")]
        public virtual System.Collections.Generic.IList<string> TargetServiceAccounts { get; set; }

        /// <summary>
        /// A list of tags that controls which instances the firewall rule applies to. If targetTags are specified, then
        /// the firewall rule applies only to instances in the VPC network that have one of those tags. If no targetTags
        /// are specified, the firewall rule applies to all instances on the specified network.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetTags")]
        public virtual System.Collections.Generic.IList<string> TargetTags { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// The list of ALLOW rules specified by this firewall. Each rule specifies a protocol and port-range tuple that
        /// describes a permitted connection.
        /// </summary>
        public class AllowedData
        {
            /// <summary>
            /// The IP protocol to which this rule applies. The protocol type is required when creating a firewall rule.
            /// This value can either be one of the following well known protocol strings (tcp, udp, icmp, esp, ah,
            /// ipip, sctp) or the IP protocol number.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("IPProtocol")]
            public virtual string IPProtocol { get; set; }

            /// <summary>
            /// An optional list of ports to which this rule applies. This field is only applicable for the UDP or TCP
            /// protocol. Each entry must be either an integer or a range. If not specified, this rule applies to
            /// connections through any port.  Example inputs include: ["22"], ["80","443"], and ["12345-12349"].
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("ports")]
            public virtual System.Collections.Generic.IList<string> Ports { get; set; }
        }

        /// <summary>
        /// The list of DENY rules specified by this firewall. Each rule specifies a protocol and port-range tuple that
        /// describes a denied connection.
        /// </summary>
        public class DeniedData
        {
            /// <summary>
            /// The IP protocol to which this rule applies. The protocol type is required when creating a firewall rule.
            /// This value can either be one of the following well known protocol strings (tcp, udp, icmp, esp, ah,
            /// ipip, sctp) or the IP protocol number.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("IPProtocol")]
            public virtual string IPProtocol { get; set; }

            /// <summary>
            /// An optional list of ports to which this rule applies. This field is only applicable for the UDP or TCP
            /// protocol. Each entry must be either an integer or a range. If not specified, this rule applies to
            /// connections through any port.  Example inputs include: ["22"], ["80","443"], and ["12345-12349"].
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("ports")]
            public virtual System.Collections.Generic.IList<string> Ports { get; set; }
        }
    }

    /// <summary>Contains a list of firewalls.</summary>
    public class FirewallList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Firewall resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Firewall> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#firewallList for lists of firewalls.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>The available logging options for a firewall rule.</summary>
    public class FirewallLogConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>This field denotes whether to enable logging for a particular firewall rule.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enable")]
        public virtual System.Nullable<bool> Enable { get; set; }

        /// <summary>
        /// This field can only be specified for a particular firewall rule if logging is enabled for that rule. This
        /// field denotes whether to include or exclude metadata for firewall logs.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("metadata")]
        public virtual string Metadata { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class FirewallPoliciesListAssociationsResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of associations.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("associations")]
        public virtual System.Collections.Generic.IList<FirewallPolicyAssociation> Associations { get; set; }

        /// <summary>
        /// [Output Only] Type of firewallPolicy associations. Always compute#FirewallPoliciesListAssociations for lists
        /// of firewallPolicy associations.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Represents a Firewall Policy resource. (== resource_for {$api_version}.firewallPolicies ==)</summary>
    public class FirewallPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of associations that belong to this firewall policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("associations")]
        public virtual System.Collections.Generic.IList<FirewallPolicyAssociation> Associations { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// User-provided name of the Organization firewall plicy. The name should be unique in the organization in
        /// which the firewall policy is created. The name must be 1-63 characters long, and comply with RFC1035.
        /// Specifically, the name must be 1-63 characters long and match the regular expression
        /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following
        /// characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("displayName")]
        public virtual string DisplayName { get; set; }

        /// <summary>
        /// Specifies a fingerprint for this resource, which is essentially a hash of the metadata's contents and used
        /// for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every
        /// request to modify or update metadata. You must always provide an up-to-date fingerprint hash in order to
        /// update or change metadata, otherwise the request will fail with error 412 conditionNotMet.  To see the
        /// latest fingerprint, make get() request to the firewall policy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output only] Type of the resource. Always compute#firewallPolicyfor firewall policies</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] Name of the resource. It is a numeric ID allocated by GCP which uniquely identifies the
        /// Firewall Policy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] The parent of the firewall policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("parent")]
        public virtual string Parent { get; set; }

        /// <summary>
        /// [Output Only] Total count of all firewall policy rule tuples. A firewall policy can not exceed a set number
        /// of tuples.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ruleTupleCount")]
        public virtual System.Nullable<int> RuleTupleCount { get; set; }

        /// <summary>
        /// A list of rules that belong to this policy. There must always be a default rule (rule with priority
        /// 2147483647 and match "*"). If no rules are provided when creating a firewall policy, a default rule with
        /// action "allow" will be added.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("rules")]
        public virtual System.Collections.Generic.IList<FirewallPolicyRule> Rules { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource with the resource id.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLinkWithId")]
        public virtual string SelfLinkWithId { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class FirewallPolicyAssociation : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The target that the firewall policy is attached to.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("attachmentTarget")]
        public virtual string AttachmentTarget { get; set; }

        /// <summary>[Output Only] The display name of the firewall policy of the association.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("displayName")]
        public virtual string DisplayName { get; set; }

        /// <summary>[Output Only] The firewall policy ID of the association.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("firewallPolicyId")]
        public virtual string FirewallPolicyId { get; set; }

        /// <summary>The name for an association.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class FirewallPolicyList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of FirewallPolicy resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<FirewallPolicy> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#firewallPolicyList for listsof FirewallPolicies
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a rule that describes one or more match conditions along with the action to be taken when traffic
    /// matches this condition (allow or deny).
    /// </summary>
    public class FirewallPolicyRule : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The Action to perform when the client connection triggers the rule. Can currently be either "allow" or
        /// "deny()" where valid values for status are 403, 404, and 502.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("action")]
        public virtual string Action { get; set; }

        /// <summary>An optional description for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>The direction in which this rule applies.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("direction")]
        public virtual string Direction { get; set; }

        /// <summary>
        /// Denotes whether the firewall policy rule is disabled. When set to true, the firewall policy rule is not
        /// enforced and traffic behaves as if it did not exist. If this is unspecified, the firewall policy rule will
        /// be enabled.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("disabled")]
        public virtual System.Nullable<bool> Disabled { get; set; }

        /// <summary>
        /// Denotes whether to enable logging for a particular rule. If logging is enabled, logs will be exported to the
        /// configured export destination in Stackdriver. Logs may be exported to BigQuery or Pub/Sub. Note: you cannot
        /// enable logging on "goto_next" rules.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enableLogging")]
        public virtual System.Nullable<bool> EnableLogging { get; set; }

        /// <summary>
        /// [Output only] Type of the resource. Always compute#firewallPolicyRule for firewall policy rules
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// A match condition that incoming traffic is evaluated against. If it evaluates to true, the corresponding
        /// 'action' is enforced.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("match")]
        public virtual FirewallPolicyRuleMatcher Match { get; set; }

        /// <summary>
        /// An integer indicating the priority of a rule in the list. The priority must be a positive value between 0
        /// and 2147483647. Rules are evaluated from highest to lowest priority where 0 is the highest priority and
        /// 2147483647 is the lowest prority.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("priority")]
        public virtual System.Nullable<int> Priority { get; set; }

        /// <summary>[Output Only] Calculation of the complexity of a single firewall policy rule.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ruleTupleCount")]
        public virtual System.Nullable<int> RuleTupleCount { get; set; }

        /// <summary>
        /// A list of network resource URLs to which this rule applies. This field allows you to control which network's
        /// VMs get this rule. If this field is left blank, all VMs within the organization will receive the rule.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetResources")]
        public virtual System.Collections.Generic.IList<string> TargetResources { get; set; }

        /// <summary>
        /// A list of secure labels that controls which instances the firewall rule applies to. If targetSecureLabel are
        /// specified, then the firewall rule applies only to instances in the VPC network that have one of those secure
        /// labels. targetSecureLabel may not be set at the same time as targetServiceAccounts. If neither
        /// targetServiceAccounts nor targetSecureLabel are specified, the firewall rule applies to all instances on the
        /// specified network. Maximum number of target label values allowed is 256.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetSecureLabels")]
        public virtual System.Collections.Generic.IList<string> TargetSecureLabels { get; set; }

        /// <summary>
        /// A list of service accounts indicating the sets of instances that are applied with this rule.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetServiceAccounts")]
        public virtual System.Collections.Generic.IList<string> TargetServiceAccounts { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a match condition that incoming traffic is evaluated against. Exactly one field must be specified.
    /// </summary>
    public class FirewallPolicyRuleMatcher : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>CIDR IP address range. Maximum number of destination CIDR IP ranges allowed is 256.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("destIpRanges")]
        public virtual System.Collections.Generic.IList<string> DestIpRanges { get; set; }

        /// <summary>Pairs of IP protocols and ports that the rule should match.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("layer4Configs")]
        public virtual System.Collections.Generic.IList<FirewallPolicyRuleMatcherLayer4Config> Layer4Configs { get; set; }

        /// <summary>CIDR IP address range. Maximum number of source CIDR IP ranges allowed is 256.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("srcIpRanges")]
        public virtual System.Collections.Generic.IList<string> SrcIpRanges { get; set; }

        /// <summary>
        /// List of firewall label values, which should be matched at the source of the traffic. Maximum number of
        /// source label values allowed is 256.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("srcSecureLabels")]
        public virtual System.Collections.Generic.IList<string> SrcSecureLabels { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class FirewallPolicyRuleMatcherLayer4Config : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The IP protocol to which this rule applies. The protocol type is required when creating a firewall rule.
        /// This value can either be one of the following well known protocol strings (tcp, udp, icmp, esp, ah, ipip,
        /// sctp), or the IP protocol number.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipProtocol")]
        public virtual string IpProtocol { get; set; }

        /// <summary>
        /// An optional list of ports to which this rule applies. This field is only applicable for UDP or TCP protocol.
        /// Each entry must be either an integer or a range. If not specified, this rule applies to connections through
        /// any port.  Example inputs include: ["22"], ["80","443"], and ["12345-12349"].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ports")]
        public virtual System.Collections.Generic.IList<string> Ports { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Encapsulates numeric value that can be either absolute or relative.</summary>
    public class FixedOrPercent : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] Absolute value of VM instances calculated based on the specific mode.    - If the value is
        /// fixed, then the calculated value is equal to the fixed value.  - If the value is a percent, then the
        /// calculated value is percent/100 * targetSize. For example, the calculated value of a 80% of a managed
        /// instance group with 150 instances would be (80/100 * 150) = 120 VM instances. If there is a remainder, the
        /// number is rounded up.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("calculated")]
        public virtual System.Nullable<int> Calculated { get; set; }

        /// <summary>Specifies a fixed number of VM instances. This must be a positive integer.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fixed")]
        public virtual System.Nullable<int> Fixed__ { get; set; }

        /// <summary>
        /// Specifies a percentage of instances between 0 to 100%, inclusive. For example, specify 80 for 80%.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("percent")]
        public virtual System.Nullable<int> Percent { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Forwarding Rule resource.  Forwarding rule resources in GCP can be either regional or global in
    /// scope:  * [Global](/compute/docs/reference/rest/{$api_version}/globalForwardingRules) *
    /// [Regional](/compute/docs/reference/rest/{$api_version}/forwardingRules)  A forwarding rule and its corresponding
    /// IP address represent the frontend configuration of a Google Cloud Platform load balancer. Forwarding rules can
    /// also reference target instances and Cloud VPN Classic gateways (targetVpnGateway).  For more information, read
    /// Forwarding rule concepts and Using protocol forwarding.  (== resource_for {$api_version}.forwardingRules ==) (==
    /// resource_for {$api_version}.globalForwardingRules ==) (== resource_for {$api_version}.regionForwardingRules ==)
    /// </summary>
    public class ForwardingRule : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// IP address that this forwarding rule serves. When a client sends traffic to this IP address, the forwarding
        /// rule directs the traffic to the target that you specify in the forwarding rule.  If you don't specify a
        /// reserved IP address, an ephemeral IP address is assigned. Methods for specifying an IP address:  * IPv4
        /// dotted decimal, as in `100.1.2.3` * Full URL, as in
        /// https://www.googleapis.com/compute/v1/projects/project_id/regions/region/addresses/address-name * Partial
        /// URL or by name, as in:   - projects/project_id/regions/region/addresses/address-name  -
        /// regions/region/addresses/address-name  - global/addresses/address-name  - address-name    The
        /// loadBalancingScheme and the forwarding rule's target determine the type of IP address that you can use. For
        /// detailed information, refer to [IP address
        /// specifications](/load-balancing/docs/forwarding-rule-concepts#ip_address_specifications).  Must be set to
        /// `0.0.0.0` when the target is targetGrpcProxy that has validateForProxyless field set to true.  For Private
        /// Service Connect forwarding rules that forward traffic to Google APIs, IP address must be provided.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("IPAddress")]
        public virtual string IPAddress { get; set; }

        /// <summary>
        /// The IP protocol to which this rule applies.  For protocol forwarding, valid options are TCP, UDP, ESP, AH,
        /// SCTP and ICMP.  The valid IP protocols are different for different load balancing products:   - Internal
        /// TCP/UDP Load Balancing: The load balancing scheme is INTERNAL, and one of TCP, UDP or ALL is valid.  -
        /// Traffic Director: The load balancing scheme is INTERNAL_SELF_MANAGED, and only TCP is valid.   - Internal
        /// HTTP(S) Load Balancing: The load balancing scheme is INTERNAL_MANAGED, and only TCP is valid.  - HTTP(S),
        /// SSL Proxy, and TCP Proxy Load Balancing: The load balancing scheme is EXTERNAL and only TCP is valid.  -
        /// Network Load Balancing: The load balancing scheme is EXTERNAL, and one of TCP or UDP is valid.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("IPProtocol")]
        public virtual string IPProtocol { get; set; }

        /// <summary>
        /// This field is used along with the backend_service field for internal load balancing or with the target field
        /// for internal TargetInstance. This field cannot be used with port or portRange fields.  When the load
        /// balancing scheme is INTERNAL and protocol is TCP/UDP, specify this field to allow packets addressed to any
        /// ports will be forwarded to the backends configured with this forwarding rule.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("allPorts")]
        public virtual System.Nullable<bool> AllPorts { get; set; }

        /// <summary>
        /// This field is used along with the backend_service field for internal load balancing or with the target field
        /// for internal TargetInstance. If the field is set to TRUE, clients can access ILB from all regions. Otherwise
        /// only allows access from clients in the same region as the internal load balancer.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("allowGlobalAccess")]
        public virtual System.Nullable<bool> AllowGlobalAccess { get; set; }

        /// <summary>
        /// Identifies the backend service to which the forwarding rule sends traffic. Required for Internal TCP/UDP
        /// Load Balancing and Network Load Balancing; must be omitted for all other load balancer types.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("backendService")]
        public virtual string BackendService { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Fingerprint of this resource. A hash of the contents stored in this object. This field is used in optimistic
        /// locking. This field will be ignored when inserting a ForwardingRule. Include the fingerprint in patch
        /// request to ensure that you do not overwrite changes that were applied from another concurrent request.  To
        /// see the latest fingerprint, make a get() request to retrieve a ForwardingRule.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// The IP Version that will be used by this forwarding rule. Valid options are IPV4 or IPV6. This can only be
        /// specified for an external global forwarding rule.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipVersion")]
        public virtual string IpVersion { get; set; }

        /// <summary>
        /// Indicates whether or not this load balancer can be used as a collector for packet mirroring. To prevent
        /// mirroring loops, instances behind this load balancer will not have their traffic mirrored even if a
        /// PacketMirroring rule applies to them. This can only be set to true for load balancers that have their
        /// loadBalancingScheme set to INTERNAL.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("isMirroringCollector")]
        public virtual System.Nullable<bool> IsMirroringCollector { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#forwardingRule for Forwarding Rule resources.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// A fingerprint for the labels being applied to this resource, which is essentially a hash of the labels set
        /// used for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after
        /// every request to modify or update labels. You must always provide an up-to-date fingerprint hash in order to
        /// update or change labels, otherwise the request will fail with error 412 conditionNotMet.  To see the latest
        /// fingerprint, make a get() request to retrieve a ForwardingRule.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labelFingerprint")]
        public virtual string LabelFingerprint { get; set; }

        /// <summary>
        /// Labels for this resource. These can only be added or modified by the setLabels method. Each label key/value
        /// pair must comply with RFC1035. Label values may be empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>
        /// Specifies the forwarding rule type.    - EXTERNAL is used for:   - Classic Cloud VPN gateways  - Protocol
        /// forwarding to VMs from an external IP address  - HTTP(S), SSL Proxy, TCP Proxy, and Network Load Balancing
        ///   - INTERNAL is used for:   - Protocol forwarding to VMs from an internal IP address  - Internal TCP/UDP
        /// Load Balancing    - INTERNAL_MANAGED is used for:   - Internal HTTP(S) Load Balancing    -
        /// INTERNAL_SELF_MANAGED is used for:   - Traffic Director      For more information about forwarding rules,
        /// refer to Forwarding rule concepts.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("loadBalancingScheme")]
        public virtual string LoadBalancingScheme { get; set; }

        /// <summary>
        /// Opaque filter criteria used by Loadbalancer to restrict routing configuration to a limited set of xDS
        /// compliant clients. In their xDS requests to Loadbalancer, xDS clients present node metadata. When there is a
        /// match, the relevant configuration is made available to those proxies. Otherwise, all the resources (e.g.
        /// TargetHttpProxy, UrlMap) referenced by the ForwardingRule will not be visible to those proxies. For each
        /// metadataFilter in this list, if its filterMatchCriteria is set to MATCH_ANY, at least one of the
        /// filterLabels must match the corresponding label provided in the metadata. If its filterMatchCriteria is set
        /// to MATCH_ALL, then all of its filterLabels must match with corresponding labels provided in the metadata. If
        /// multiple metadataFilters are specified, all of them need to be satisfied in order to be considered a match.
        /// metadataFilters specified here will be applifed before those specified in the UrlMap that this
        /// ForwardingRule references. metadataFilters only applies to Loadbalancers that have their loadBalancingScheme
        /// set to INTERNAL_SELF_MANAGED.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("metadataFilters")]
        public virtual System.Collections.Generic.IList<MetadataFilter> MetadataFilters { get; set; }

        /// <summary>
        /// Name of the resource; provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// This field is not used for external load balancing.  For Internal TCP/UDP Load Balancing, this field
        /// identifies the network that the load balanced IP should belong to for this Forwarding Rule. If this field is
        /// not specified, the default network will be used.  For Private Service Connect forwarding rules that forward
        /// traffic to Google APIs, a network must be provided.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>
        /// This signifies the networking tier used for configuring this load balancer and can only take the following
        /// values: PREMIUM, STANDARD.  For regional ForwardingRule, the valid values are PREMIUM and STANDARD. For
        /// GlobalForwardingRule, the valid value is PREMIUM.  If this field is not specified, it is assumed to be
        /// PREMIUM. If IPAddress is specified, this value must be equal to the networkTier of the Address.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkTier")]
        public virtual string NetworkTier { get; set; }

        /// <summary>
        /// This field can be used only if: * Load balancing scheme is one of EXTERNAL,  INTERNAL_SELF_MANAGED or
        /// INTERNAL_MANAGED, and * IPProtocol is one of TCP, UDP, or SCTP.  Packets addressed to ports in the specified
        /// range will be forwarded to target or  backend_service. You can only use one of ports, port_range, or
        /// allPorts. The three are mutually exclusive. Forwarding rules with the same [IPAddress, IPProtocol] pair must
        /// have disjoint port ranges.  Some types of forwarding target have constraints on the acceptable ports:   -
        /// TargetHttpProxy: 80, 8080  - TargetHttpsProxy: 443  - TargetGrpcProxy: no constraints  - TargetTcpProxy: 25,
        /// 43, 110, 143, 195, 443, 465, 587, 700, 993, 995, 1688, 1883, 5222  - TargetSslProxy: 25, 43, 110, 143, 195,
        /// 443, 465, 587, 700, 993, 995, 1688, 1883, 5222  - TargetVpnGateway: 500, 4500
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portRange")]
        public virtual string PortRange { get; set; }

        /// <summary>
        /// The ports field is only supported when the forwarding rule references a backend_service directly. Supported
        /// load balancing products are Internal TCP/UDP Load Balancing and Network Load Balancing. Only packets
        /// addressed to the specified list of ports are forwarded to backends.  You can only use one of ports and
        /// port_range, or allPorts. The three are mutually exclusive.  You can specify a list of up to five ports,
        /// which can be non-contiguous.  For Internal TCP/UDP Load Balancing, if you specify allPorts, you should not
        /// specify ports.  For more information, see [Port
        /// specifications](/load-balancing/docs/forwarding-rule-concepts#port_specifications).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ports")]
        public virtual System.Collections.Generic.IList<string> Ports { get; set; }

        /// <summary>[Output Only] The PSC connection id of the PSC Forwarding Rule.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("pscConnectionId")]
        public virtual System.Nullable<ulong> PscConnectionId { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the regional forwarding rule resides. This field is not applicable to
        /// global forwarding rules. You must specify this field as part of the HTTP request URL. It is not settable as
        /// a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// Service Directory resources to register this forwarding rule with. Currently, only supports a single Service
        /// Directory resource.  It is only supported for Internal TCP/UDP Load Balancing and Internal HTTP(S) Load
        /// Balancing.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("serviceDirectoryRegistrations")]
        public virtual System.Collections.Generic.IList<ForwardingRuleServiceDirectoryRegistration> ServiceDirectoryRegistrations { get; set; }

        /// <summary>
        /// An optional prefix to the service name for this Forwarding Rule. If specified, the prefix is the first label
        /// of the fully qualified service name.  The label must be 1-63 characters long, and comply with RFC1035.
        /// Specifically, the label must be 1-63 characters long and match the regular expression
        /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following
        /// characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.
        /// This field is only used for internal load balancing.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("serviceLabel")]
        public virtual string ServiceLabel { get; set; }

        /// <summary>
        /// [Output Only] The internal fully qualified service name for this Forwarding Rule.  This field is only used
        /// for internal load balancing.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("serviceName")]
        public virtual string ServiceName { get; set; }

        /// <summary>
        /// This field is only used for internal load balancing.  For internal load balancing, this field identifies the
        /// subnetwork that the load balanced IP should belong to for this Forwarding Rule.  If the network specified is
        /// in auto subnet mode, this field is optional. However, if the network is in custom subnet mode, a subnetwork
        /// must be specified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("subnetwork")]
        public virtual string Subnetwork { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("target")]
        public virtual string Target { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ForwardingRuleAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of ForwardingRulesScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, ForwardingRulesScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#forwardingRuleAggregatedList for lists of forwarding rules.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of ForwardingRule resources.</summary>
    public class ForwardingRuleList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of ForwardingRule resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<ForwardingRule> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class ForwardingRuleReference : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("forwardingRule")]
        public virtual string ForwardingRule { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Describes the auto-registration of the Forwarding Rule to Service Directory. The region and project of the
    /// Service Directory resource generated from this registration will be the same as this Forwarding Rule.
    /// </summary>
    public class ForwardingRuleServiceDirectoryRegistration : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Service Directory namespace to register the forwarding rule under.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("namespace")]
        public virtual string Namespace__ { get; set; }

        /// <summary>Service Directory service to register the forwarding rule under.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("service")]
        public virtual string Service { get; set; }

        /// <summary>
        /// [Optional] Service Directory region to register this global forwarding rule under. Default to "us-central1".
        /// Only used for PSC for Google APIs. All PSC for Google APIs Forwarding Rules on the same network should use
        /// the same Service Directory region.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("serviceDirectoryRegion")]
        public virtual string ServiceDirectoryRegion { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ForwardingRulesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of forwarding rules contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("forwardingRules")]
        public virtual System.Collections.Generic.IList<ForwardingRule> ForwardingRules { get; set; }

        /// <summary>Informational warning which replaces the list of forwarding rules when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of forwarding rules when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class GRPCHealthCheck : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The gRPC service name for the health check. This field is optional. The value of grpc_service_name has the
        /// following meanings by convention: - Empty service_name means the overall status of all services at the
        /// backend. - Non-empty service_name means the health of that gRPC service, as defined by the owner of the
        /// service. The grpc_service_name can only be ASCII.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("grpcServiceName")]
        public virtual string GrpcServiceName { get; set; }

        /// <summary>
        /// The port number for the health check request. Must be specified if port_name and port_specification are not
        /// set or if port_specification is USE_FIXED_PORT. Valid values are 1 through 65535.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("port")]
        public virtual System.Nullable<int> Port { get; set; }

        /// <summary>
        /// Port name as defined in InstanceGroup#NamedPort#name. If both port and port_name are defined, port takes
        /// precedence. The port_name should conform to RFC1035.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portName")]
        public virtual string PortName { get; set; }

        /// <summary>
        /// Specifies how port is selected for health checking, can be one of following values: USE_FIXED_PORT: The port
        /// number in port is used for health checking. USE_NAMED_PORT: The portName is used for health checking.
        /// USE_SERVING_PORT: For NetworkEndpointGroup, the port specified for each network endpoint is used for health
        /// checking. For other backends, the port or named port specified in the Backend Service is used for health
        /// checking.   If not specified, gRPC health check follows behavior specified in port and portName fields.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portSpecification")]
        public virtual string PortSpecification { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class GlobalNetworkEndpointGroupsAttachEndpointsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The list of network endpoints to be attached.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkEndpoints")]
        public virtual System.Collections.Generic.IList<NetworkEndpoint> NetworkEndpoints { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class GlobalNetworkEndpointGroupsDetachEndpointsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The list of network endpoints to be detached.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkEndpoints")]
        public virtual System.Collections.Generic.IList<NetworkEndpoint> NetworkEndpoints { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class GlobalOrganizationSetPolicyRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Flatten Policy to create a backward compatible wire-format. Deprecated. Use 'policy' to specify bindings.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("bindings")]
        public virtual System.Collections.Generic.IList<Binding> Bindings { get; set; }

        /// <summary>
        /// Flatten Policy to create a backward compatible wire-format. Deprecated. Use 'policy' to specify the etag.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("etag")]
        public virtual string ETag { get; set; }

        /// <summary>
        /// REQUIRED: The complete policy to be applied to the 'resource'. The size of the policy is limited to a few
        /// 10s of KB. An empty policy is in general a valid policy but certain services (like Projects) might reject
        /// them.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("policy")]
        public virtual Policy Policy { get; set; }
    }

    public class GlobalSetLabelsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The fingerprint of the previous set of labels for this resource, used to detect conflicts. The fingerprint
        /// is initially generated by Compute Engine and changes after every request to modify or update labels. You
        /// must always provide an up-to-date fingerprint hash when updating or changing labels, otherwise the request
        /// will fail with error 412 conditionNotMet. Make a get() request to the resource to get the latest
        /// fingerprint.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labelFingerprint")]
        public virtual string LabelFingerprint { get; set; }

        /// <summary>
        /// A list of labels to apply for this resource. Each label key &amp;amp; value must comply with RFC1035.
        /// Specifically, the name must be 1-63 characters long and match the regular expression
        /// `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all following
        /// characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.
        /// For example, "webserver-frontend": "images". A label value can also be empty (e.g. "my-label": "").
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class GlobalSetPolicyRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Flatten Policy to create a backward compatible wire-format. Deprecated. Use 'policy' to specify bindings.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("bindings")]
        public virtual System.Collections.Generic.IList<Binding> Bindings { get; set; }

        /// <summary>
        /// Flatten Policy to create a backward compatible wire-format. Deprecated. Use 'policy' to specify the etag.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("etag")]
        public virtual string ETag { get; set; }

        /// <summary>
        /// REQUIRED: The complete policy to be applied to the 'resource'. The size of the policy is limited to a few
        /// 10s of KB. An empty policy is in general a valid policy but certain services (like Projects) might reject
        /// them.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("policy")]
        public virtual Policy Policy { get; set; }
    }

    /// <summary>A guest attributes entry.</summary>
    public class GuestAttributes : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] Type of the resource. Always compute#guestAttributes for guest attributes entry.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// The path to be queried. This can be the default namespace ('/') or a nested namespace ('/\/') or a specified
        /// key ('/\/\')
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("queryPath")]
        public virtual string QueryPath { get; set; }

        /// <summary>[Output Only] The value of the requested queried path.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("queryValue")]
        public virtual GuestAttributesValue QueryValue { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>The key to search for.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("variableKey")]
        public virtual string VariableKey { get; set; }

        /// <summary>[Output Only] The value found for the requested key.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("variableValue")]
        public virtual string VariableValue { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A guest attributes namespace/key/value entry.</summary>
    public class GuestAttributesEntry : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Key for the guest attribute entry.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("key")]
        public virtual string Key { get; set; }

        /// <summary>Namespace for the guest attribute entry.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("namespace")]
        public virtual string Namespace__ { get; set; }

        /// <summary>Value for the guest attribute entry.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("value")]
        public virtual string Value { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Array of guest attribute namespace/key/value tuples.</summary>
    public class GuestAttributesValue : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<GuestAttributesEntry> Items { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Guest OS features.</summary>
    public class GuestOsFeature : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The ID of a supported feature. Read  Enabling guest operating system features to see a list of available
        /// options.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class HTTP2HealthCheck : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The value of the host header in the HTTP/2 health check request. If left empty (default value), the IP on
        /// behalf of which this health check is performed will be used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("host")]
        public virtual string Host { get; set; }

        /// <summary>
        /// The TCP port number for the health check request. The default value is 443. Valid values are 1 through
        /// 65535.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("port")]
        public virtual System.Nullable<int> Port { get; set; }

        /// <summary>
        /// Port name as defined in InstanceGroup#NamedPort#name. If both port and port_name are defined, port takes
        /// precedence.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portName")]
        public virtual string PortName { get; set; }

        /// <summary>
        /// Specifies how port is selected for health checking, can be one of following values: USE_FIXED_PORT: The port
        /// number in port is used for health checking. USE_NAMED_PORT: The portName is used for health checking.
        /// USE_SERVING_PORT: For NetworkEndpointGroup, the port specified for each network endpoint is used for health
        /// checking. For other backends, the port or named port specified in the Backend Service is used for health
        /// checking.   If not specified, HTTP2 health check follows behavior specified in port and portName fields.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portSpecification")]
        public virtual string PortSpecification { get; set; }

        /// <summary>
        /// Specifies the type of proxy header to append before sending data to the backend, either NONE or PROXY_V1.
        /// The default is NONE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("proxyHeader")]
        public virtual string ProxyHeader { get; set; }

        /// <summary>The request path of the HTTP/2 health check request. The default value is /.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("requestPath")]
        public virtual string RequestPath { get; set; }

        /// <summary>
        /// The string to match anywhere in the first 1024 bytes of the response body. If left empty (the default
        /// value), the status code determines health. The response data can only be ASCII.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("response")]
        public virtual string Response { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class HTTPHealthCheck : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The value of the host header in the HTTP health check request. If left empty (default value), the IP on
        /// behalf of which this health check is performed will be used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("host")]
        public virtual string Host { get; set; }

        /// <summary>
        /// The TCP port number for the health check request. The default value is 80. Valid values are 1 through 65535.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("port")]
        public virtual System.Nullable<int> Port { get; set; }

        /// <summary>
        /// Port name as defined in InstanceGroup#NamedPort#name. If both port and port_name are defined, port takes
        /// precedence.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portName")]
        public virtual string PortName { get; set; }

        /// <summary>
        /// Specifies how port is selected for health checking, can be one of following values: USE_FIXED_PORT: The port
        /// number in port is used for health checking. USE_NAMED_PORT: The portName is used for health checking.
        /// USE_SERVING_PORT: For NetworkEndpointGroup, the port specified for each network endpoint is used for health
        /// checking. For other backends, the port or named port specified in the Backend Service is used for health
        /// checking.   If not specified, HTTP health check follows behavior specified in port and portName fields.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portSpecification")]
        public virtual string PortSpecification { get; set; }

        /// <summary>
        /// Specifies the type of proxy header to append before sending data to the backend, either NONE or PROXY_V1.
        /// The default is NONE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("proxyHeader")]
        public virtual string ProxyHeader { get; set; }

        /// <summary>The request path of the HTTP health check request. The default value is /.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("requestPath")]
        public virtual string RequestPath { get; set; }

        /// <summary>
        /// The string to match anywhere in the first 1024 bytes of the response body. If left empty (the default
        /// value), the status code determines health. The response data can only be ASCII.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("response")]
        public virtual string Response { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class HTTPSHealthCheck : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The value of the host header in the HTTPS health check request. If left empty (default value), the IP on
        /// behalf of which this health check is performed will be used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("host")]
        public virtual string Host { get; set; }

        /// <summary>
        /// The TCP port number for the health check request. The default value is 443. Valid values are 1 through
        /// 65535.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("port")]
        public virtual System.Nullable<int> Port { get; set; }

        /// <summary>
        /// Port name as defined in InstanceGroup#NamedPort#name. If both port and port_name are defined, port takes
        /// precedence.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portName")]
        public virtual string PortName { get; set; }

        /// <summary>
        /// Specifies how port is selected for health checking, can be one of following values: USE_FIXED_PORT: The port
        /// number in port is used for health checking. USE_NAMED_PORT: The portName is used for health checking.
        /// USE_SERVING_PORT: For NetworkEndpointGroup, the port specified for each network endpoint is used for health
        /// checking. For other backends, the port or named port specified in the Backend Service is used for health
        /// checking.   If not specified, HTTPS health check follows behavior specified in port and portName fields.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portSpecification")]
        public virtual string PortSpecification { get; set; }

        /// <summary>
        /// Specifies the type of proxy header to append before sending data to the backend, either NONE or PROXY_V1.
        /// The default is NONE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("proxyHeader")]
        public virtual string ProxyHeader { get; set; }

        /// <summary>The request path of the HTTPS health check request. The default value is /.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("requestPath")]
        public virtual string RequestPath { get; set; }

        /// <summary>
        /// The string to match anywhere in the first 1024 bytes of the response body. If left empty (the default
        /// value), the status code determines health. The response data can only be ASCII.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("response")]
        public virtual string Response { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Health Check resource.  Google Compute Engine has two Health Check resources:  *
    /// [Global](/compute/docs/reference/rest/{$api_version}/healthChecks) *
    /// [Regional](/compute/docs/reference/rest/{$api_version}/regionHealthChecks)  Internal HTTP(S) load balancers must
    /// use regional health checks (`compute.v1.regionHealthChecks`).  Traffic Director must use global health checks
    /// (`compute.v1.HealthChecks`).  Internal TCP/UDP load balancers can use either regional or global health checks
    /// (`compute.v1.regionHealthChecks` or `compute.v1.HealthChecks`).  External HTTP(S), TCP proxy, and SSL proxy load
    /// balancers as well as managed instance group auto-healing must use global health checks
    /// (`compute.v1.HealthChecks`).  Network load balancers must use legacy HTTP health checks (httpHealthChecks).  For
    /// more information, see Health checks overview.
    /// </summary>
    public class HealthCheck : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>How often (in seconds) to send a health check. The default value is 5 seconds.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("checkIntervalSec")]
        public virtual System.Nullable<int> CheckIntervalSec { get; set; }

        /// <summary>[Output Only] Creation timestamp in 3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("grpcHealthCheck")]
        public virtual GRPCHealthCheck GrpcHealthCheck { get; set; }

        /// <summary>
        /// A so-far unhealthy instance will be marked healthy after this many consecutive successes. The default value
        /// is 2.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthyThreshold")]
        public virtual System.Nullable<int> HealthyThreshold { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("http2HealthCheck")]
        public virtual HTTP2HealthCheck Http2HealthCheck { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("httpHealthCheck")]
        public virtual HTTPHealthCheck HttpHealthCheck { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("httpsHealthCheck")]
        public virtual HTTPSHealthCheck HttpsHealthCheck { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>Type of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>Configure logging on this health check.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("logConfig")]
        public virtual HealthCheckLogConfig LogConfig { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. For example, a name that is 1-63 characters long, matches the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?`, and otherwise complies with RFC1035. This regular expression
        /// describes a name where the first character is a lowercase letter, and all following characters are a dash,
        /// lowercase letter, or digit, except the last character, which isn't a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// [Output Only] Region where the health check resides. Not applicable to global health checks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("sslHealthCheck")]
        public virtual SSLHealthCheck SslHealthCheck { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("tcpHealthCheck")]
        public virtual TCPHealthCheck TcpHealthCheck { get; set; }

        /// <summary>
        /// How long (in seconds) to wait before claiming failure. The default value is 5 seconds. It is invalid for
        /// timeoutSec to have greater value than checkIntervalSec.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("timeoutSec")]
        public virtual System.Nullable<int> TimeoutSec { get; set; }

        /// <summary>
        /// Specifies the type of the healthCheck, either TCP, SSL, HTTP, HTTPS or HTTP2. If not specified, the default
        /// is TCP. Exactly one of the protocol-specific health check field must be specified, which must match type
        /// field.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>
        /// A so-far healthy instance will be marked unhealthy after this many consecutive failures. The default value
        /// is 2.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unhealthyThreshold")]
        public virtual System.Nullable<int> UnhealthyThreshold { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of HealthCheck resources.</summary>
    public class HealthCheckList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of HealthCheck resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<HealthCheck> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Configuration of logging on a health check. If logging is enabled, logs will be exported to Stackdriver.
    /// </summary>
    public class HealthCheckLogConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Indicates whether or not to export logs. This is false by default, which means no health check logging will
        /// be done.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enable")]
        public virtual System.Nullable<bool> Enable { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// A full or valid partial URL to a health check. For example, the following are valid URLs:   -
    /// https://www.googleapis.com/compute/beta/projects/project-id/global/httpHealthChecks/health-check  -
    /// projects/project-id/global/httpHealthChecks/health-check  - global/httpHealthChecks/health-check
    /// </summary>
    public class HealthCheckReference : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("healthCheck")]
        public virtual string HealthCheck { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Health-Check as a Service resource.  (== resource_for {$api_version}.regionHealthCheckServices ==)
    /// </summary>
    public class HealthCheckService : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Fingerprint of this resource. A hash of the contents stored in this object. This field is used in optimistic
        /// locking. This field will be ignored when inserting a HealthCheckService. An up-to-date fingerprint must be
        /// provided in order to patch/update the HealthCheckService; Otherwise, the request will fail with error 412
        /// conditionNotMet. To see the latest fingerprint, make a get() request to retrieve the HealthCheckService.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// List of URLs to the HealthCheck resources. Must have at least one HealthCheck, and not more than 10.
        /// HealthCheck resources must have portSpecification=USE_SERVING_PORT. For regional HealthCheckService, the
        /// HealthCheck must be regional and in the same region. For global HealthCheckService, HealthCheck must be
        /// global. Mix of regional and global HealthChecks is not supported. Multiple regional HealthChecks must belong
        /// to the same region. Regional HealthChecks&amp;lt;/code? must belong to the same region as zones of NEGs.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthChecks")]
        public virtual System.Collections.Generic.IList<string> HealthChecks { get; set; }

        /// <summary>
        /// Optional. Policy for how the results from multiple health checks for the same endpoint are aggregated.
        /// Defaults to NO_AGGREGATION if unspecified.   - NO_AGGREGATION. An EndpointHealth message is returned for
        /// each backend in the health check service.  - AND. If any backend's health check reports UNHEALTHY, then
        /// UNHEALTHY is the HealthState of the entire health check service. If all backend's are healthy, the
        /// HealthState of the health check service is HEALTHY. .
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthStatusAggregationPolicy")]
        public virtual string HealthStatusAggregationPolicy { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// [Output only] Type of the resource. Always compute#healthCheckServicefor health check services.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name
        /// must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the
        /// first character must be a lowercase letter, and all following characters must be a dash, lowercase letter,
        /// or digit, except the last character, which cannot be a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// List of URLs to the NetworkEndpointGroup resources. Must not have more than 100. For regional
        /// HealthCheckService, NEGs must be in zones in the region of the HealthCheckService.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkEndpointGroups")]
        public virtual System.Collections.Generic.IList<string> NetworkEndpointGroups { get; set; }

        /// <summary>
        /// List of URLs to the NotificationEndpoint resources. Must not have more than 10. A list of endpoints for
        /// receiving notifications of change in health status. For regional HealthCheckService, NotificationEndpoint
        /// must be regional and in the same region. For global HealthCheckService, NotificationEndpoint must be global.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("notificationEndpoints")]
        public virtual System.Collections.Generic.IList<string> NotificationEndpoints { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the health check service resides. This field is not applicable to
        /// global health check services. You must specify this field as part of the HTTP request URL. It is not
        /// settable as a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// A full or valid partial URL to a health check service. For example, the following are valid URLs:   -
    /// https://www.googleapis.com/compute/beta/projects/project-id/regions/us-west1/healthCheckServices/health-check-service
    ///  - projects/project-id/regions/us-west1/healthCheckServices/health-check-service  -
    /// regions/us-west1/healthCheckServices/health-check-service
    /// </summary>
    public class HealthCheckServiceReference : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("healthCheckService")]
        public virtual string HealthCheckService { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class HealthCheckServicesList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of HealthCheckService resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<HealthCheckService> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#healthCheckServicesList for lists of HealthCheckServices.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class HealthChecksAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of HealthChecksScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, HealthChecksScopedList> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class HealthChecksScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of HealthChecks contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthChecks")]
        public virtual System.Collections.Generic.IList<HealthCheck> HealthChecks { get; set; }

        /// <summary>Informational warning which replaces the list of backend services when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of backend services when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class HealthStatus : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Metadata defined as annotations for network endpoint.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("annotations")]
        public virtual System.Collections.Generic.IDictionary<string, string> Annotations { get; set; }

        /// <summary>Health state of the instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthState")]
        public virtual string HealthState { get; set; }

        /// <summary>URL of the instance resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instance")]
        public virtual string Instance { get; set; }

        /// <summary>
        /// For target pool based Network Load Balancing, it indicates the forwarding rule's IP address assigned to this
        /// instance. For other types of load balancing, the field indicates VM internal ip.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipAddress")]
        public virtual string IpAddress { get; set; }

        /// <summary>The named port of the instance group, not necessarily the port that is health-checked.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("port")]
        public virtual System.Nullable<int> Port { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("weight")]
        public virtual string Weight { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("weightError")]
        public virtual string WeightError { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class HealthStatusForNetworkEndpoint : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>URL of the backend service associated with the health state of the network endpoint.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("backendService")]
        public virtual BackendServiceReference BackendService { get; set; }

        /// <summary>URL of the forwarding rule associated with the health state of the network endpoint.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("forwardingRule")]
        public virtual ForwardingRuleReference ForwardingRule { get; set; }

        /// <summary>URL of the health check associated with the health state of the network endpoint.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthCheck")]
        public virtual HealthCheckReference HealthCheck { get; set; }

        /// <summary>URL of the health check service associated with the health state of the network endpoint.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthCheckService")]
        public virtual HealthCheckServiceReference HealthCheckService { get; set; }

        /// <summary>Health state of the network endpoint determined based on the health checks configured.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthState")]
        public virtual string HealthState { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// UrlMaps A host-matching rule for a URL. If matched, will use the named PathMatcher to select the BackendService.
    /// </summary>
    public class HostRule : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// The list of host patterns to match. They must be valid hostnames with optional port numbers in the format
        /// host:port. * matches any string of ([a-z0-9-.]*). In that case, * must be the first character and must be
        /// followed in the pattern by either - or .. * based matching is not supported when the URL map is bound to
        /// target gRPC proxy that has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("hosts")]
        public virtual System.Collections.Generic.IList<string> Hosts { get; set; }

        /// <summary>
        /// The name of the PathMatcher to use to match the path portion of the URL if the hostRule matches the URL's
        /// host portion.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("pathMatcher")]
        public virtual string PathMatcher { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Specification for how requests are aborted as part of fault injection.</summary>
    public class HttpFaultAbort : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The HTTP status code used to abort the request. The value must be between 200 and 599 inclusive.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("httpStatus")]
        public virtual System.Nullable<long> HttpStatus { get; set; }

        /// <summary>
        /// The percentage of traffic (connections/operations/requests) which will be aborted as part of fault
        /// injection. The value must be between 0.0 and 100.0 inclusive.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("percentage")]
        public virtual System.Nullable<double> Percentage { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Specifies the delay introduced by Loadbalancer before forwarding the request to the backend service as part of
    /// fault injection.
    /// </summary>
    public class HttpFaultDelay : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Specifies the value of the fixed delay interval.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fixedDelay")]
        public virtual Duration FixedDelay { get; set; }

        /// <summary>
        /// The percentage of traffic (connections/operations/requests) on which delay will be introduced as part of
        /// fault injection. The value must be between 0.0 and 100.0 inclusive.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("percentage")]
        public virtual System.Nullable<double> Percentage { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// The specification for fault injection introduced into traffic to test the resiliency of clients to backend
    /// service failure. As part of fault injection, when clients send requests to a backend service, delays can be
    /// introduced by Loadbalancer on a percentage of requests before sending those request to the backend service.
    /// Similarly requests from clients can be aborted by the Loadbalancer for a percentage of requests.
    /// </summary>
    public class HttpFaultInjection : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The specification for how client requests are aborted as part of fault injection.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("abort")]
        public virtual HttpFaultAbort Abort { get; set; }

        /// <summary>
        /// The specification for how client requests are delayed as part of fault injection, before being sent to a
        /// backend service.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("delay")]
        public virtual HttpFaultDelay Delay { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// The request and response header transformations that take effect before the request is passed along to the
    /// selected backendService.
    /// </summary>
    public class HttpHeaderAction : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Headers to add to a matching request prior to forwarding the request to the backendService.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("requestHeadersToAdd")]
        public virtual System.Collections.Generic.IList<HttpHeaderOption> RequestHeadersToAdd { get; set; }

        /// <summary>
        /// A list of header names for headers that need to be removed from the request prior to forwarding the request
        /// to the backendService.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("requestHeadersToRemove")]
        public virtual System.Collections.Generic.IList<string> RequestHeadersToRemove { get; set; }

        /// <summary>Headers to add the response prior to sending the response back to the client.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("responseHeadersToAdd")]
        public virtual System.Collections.Generic.IList<HttpHeaderOption> ResponseHeadersToAdd { get; set; }

        /// <summary>
        /// A list of header names for headers that need to be removed from the response prior to sending the response
        /// back to the client.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("responseHeadersToRemove")]
        public virtual System.Collections.Generic.IList<string> ResponseHeadersToRemove { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>matchRule criteria for request header matches.</summary>
    public class HttpHeaderMatch : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The value should exactly match contents of exactMatch. Only one of exactMatch, prefixMatch, suffixMatch,
        /// regexMatch, presentMatch or rangeMatch must be set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("exactMatch")]
        public virtual string ExactMatch { get; set; }

        /// <summary>
        /// The name of the HTTP header to match. For matching against the HTTP request's authority, use a headerMatch
        /// with the header name ":authority". For matching a request's method, use the headerName ":method". When the
        /// URL map is bound to target gRPC proxy that has validateForProxyless field set to true, only non-binary
        /// user-specified custom metadata and the `content-type` header are supported. The following transport-level
        /// headers cannot be used in header matching rules: `:authority`, `:method`, `:path`, `:scheme`, `user-agent`,
        /// `accept-encoding`, `content-encoding`, `grpc-accept-encoding`, `grpc-encoding`,
        /// `grpc-previous-rpc-attempts`, `grpc-tags-bin`, `grpc-timeout` and `grpc-trace-bin.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("headerName")]
        public virtual string HeaderName { get; set; }

        /// <summary>
        /// If set to false, the headerMatch is considered a match if the match criteria above are met. If set to true,
        /// the headerMatch is considered a match if the match criteria above are NOT met. The default setting is false.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("invertMatch")]
        public virtual System.Nullable<bool> InvertMatch { get; set; }

        /// <summary>
        /// The value of the header must start with the contents of prefixMatch. Only one of exactMatch, prefixMatch,
        /// suffixMatch, regexMatch, presentMatch or rangeMatch must be set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("prefixMatch")]
        public virtual string PrefixMatch { get; set; }

        /// <summary>
        /// A header with the contents of headerName must exist. The match takes place whether or not the request's
        /// header has a value. Only one of exactMatch, prefixMatch, suffixMatch, regexMatch, presentMatch or rangeMatch
        /// must be set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("presentMatch")]
        public virtual System.Nullable<bool> PresentMatch { get; set; }

        /// <summary>
        /// The header value must be an integer and its value must be in the range specified in rangeMatch. If the
        /// header does not contain an integer, number or is empty, the match fails. For example for a range [-5, 0]   -
        /// -3 will match.  - 0 will not match.  - 0.25 will not match.  - -3someString will not match.   Only one of
        /// exactMatch, prefixMatch, suffixMatch, regexMatch, presentMatch or rangeMatch must be set. Note that
        /// rangeMatch is not supported for Loadbalancers that have their loadBalancingScheme set to EXTERNAL.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("rangeMatch")]
        public virtual Int64RangeMatch RangeMatch { get; set; }

        /// <summary>
        /// The value of the header must match the regular expression specified in regexMatch. For regular expression
        /// grammar, please see:  github.com/google/re2/wiki/Syntax  For matching against a port specified in the HTTP
        /// request, use a headerMatch with headerName set to PORT and a regular expression that satisfies the RFC2616
        /// Host header's port specifier. Only one of exactMatch, prefixMatch, suffixMatch, regexMatch, presentMatch or
        /// rangeMatch must be set. Note that regexMatch only applies to Loadbalancers that have their
        /// loadBalancingScheme set to INTERNAL_SELF_MANAGED.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("regexMatch")]
        public virtual string RegexMatch { get; set; }

        /// <summary>
        /// The value of the header must end with the contents of suffixMatch. Only one of exactMatch, prefixMatch,
        /// suffixMatch, regexMatch, presentMatch or rangeMatch must be set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("suffixMatch")]
        public virtual string SuffixMatch { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Specification determining how headers are added to requests or responses.</summary>
    public class HttpHeaderOption : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The name of the header.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("headerName")]
        public virtual string HeaderName { get; set; }

        /// <summary>The value of the header to add.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("headerValue")]
        public virtual string HeaderValue { get; set; }

        /// <summary>
        /// If false, headerValue is appended to any values that already exist for the header. If true, headerValue is
        /// set for the header, discarding any values that were set for that header. The default value is false.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("replace")]
        public virtual System.Nullable<bool> Replace { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a legacy HTTP Health Check resource.  Legacy health checks are required by network load balancers.
    /// For more information, read Health Check Concepts.
    /// </summary>
    public class HttpHealthCheck : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>How often (in seconds) to send a health check. The default value is 5 seconds.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("checkIntervalSec")]
        public virtual System.Nullable<int> CheckIntervalSec { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// A so-far unhealthy instance will be marked healthy after this many consecutive successes. The default value
        /// is 2.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthyThreshold")]
        public virtual System.Nullable<int> HealthyThreshold { get; set; }

        /// <summary>
        /// The value of the host header in the HTTP health check request. If left empty (default value), the public IP
        /// on behalf of which this health check is performed will be used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("host")]
        public virtual string Host { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#httpHealthCheck for HTTP health checks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The TCP port number for the HTTP health check request. The default value is 80.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("port")]
        public virtual System.Nullable<int> Port { get; set; }

        /// <summary>
        /// The request path of the HTTP health check request. The default value is /. This field does not support query
        /// parameters.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("requestPath")]
        public virtual string RequestPath { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// How long (in seconds) to wait before claiming failure. The default value is 5 seconds. It is invalid for
        /// timeoutSec to have greater value than checkIntervalSec.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("timeoutSec")]
        public virtual System.Nullable<int> TimeoutSec { get; set; }

        /// <summary>
        /// A so-far healthy instance will be marked unhealthy after this many consecutive failures. The default value
        /// is 2.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unhealthyThreshold")]
        public virtual System.Nullable<int> UnhealthyThreshold { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of HttpHealthCheck resources.</summary>
    public class HttpHealthCheckList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of HttpHealthCheck resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<HttpHealthCheck> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>HttpRouteRuleMatch criteria for a request's query parameter.</summary>
    public class HttpQueryParameterMatch : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The queryParameterMatch matches if the value of the parameter exactly matches the contents of exactMatch.
        /// Only one of presentMatch, exactMatch or regexMatch must be set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("exactMatch")]
        public virtual string ExactMatch { get; set; }

        /// <summary>
        /// The name of the query parameter to match. The query parameter must exist in the request, in the absence of
        /// which the request match fails.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// Specifies that the queryParameterMatch matches if the request contains the query parameter, irrespective of
        /// whether the parameter has a value or not. Only one of presentMatch, exactMatch or regexMatch must be set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("presentMatch")]
        public virtual System.Nullable<bool> PresentMatch { get; set; }

        /// <summary>
        /// The queryParameterMatch matches if the value of the parameter matches the regular expression specified by
        /// regexMatch. For the regular expression grammar, please see github.com/google/re2/wiki/Syntax  Only one of
        /// presentMatch, exactMatch or regexMatch must be set. Note that regexMatch only applies when the
        /// loadBalancingScheme is set to INTERNAL_SELF_MANAGED.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("regexMatch")]
        public virtual string RegexMatch { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Specifies settings for an HTTP redirect.</summary>
    public class HttpRedirectAction : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The host that will be used in the redirect response instead of the one that was supplied in the request. The
        /// value must be between 1 and 255 characters.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("hostRedirect")]
        public virtual string HostRedirect { get; set; }

        /// <summary>
        /// If set to true, the URL scheme in the redirected request is set to https. If set to false, the URL scheme of
        /// the redirected request will remain the same as that of the request. This must only be set for UrlMaps used
        /// in TargetHttpProxys. Setting this true for TargetHttpsProxy is not permitted. The default is set to false.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("httpsRedirect")]
        public virtual System.Nullable<bool> HttpsRedirect { get; set; }

        /// <summary>
        /// The path that will be used in the redirect response instead of the one that was supplied in the request.
        /// pathRedirect cannot be supplied together with prefixRedirect. Supply one alone or neither. If neither is
        /// supplied, the path of the original request will be used for the redirect. The value must be between 1 and
        /// 1024 characters.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("pathRedirect")]
        public virtual string PathRedirect { get; set; }

        /// <summary>
        /// The prefix that replaces the prefixMatch specified in the HttpRouteRuleMatch, retaining the remaining
        /// portion of the URL before redirecting the request. prefixRedirect cannot be supplied together with
        /// pathRedirect. Supply one alone or neither. If neither is supplied, the path of the original request will be
        /// used for the redirect. The value must be between 1 and 1024 characters.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("prefixRedirect")]
        public virtual string PrefixRedirect { get; set; }

        /// <summary>
        /// The HTTP Status code to use for this RedirectAction. Supported values are:   - MOVED_PERMANENTLY_DEFAULT,
        /// which is the default value and corresponds to 301.  - FOUND, which corresponds to 302.  - SEE_OTHER which
        /// corresponds to 303.  - TEMPORARY_REDIRECT, which corresponds to 307. In this case, the request method will
        /// be retained.  - PERMANENT_REDIRECT, which corresponds to 308. In this case, the request method will be
        /// retained.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("redirectResponseCode")]
        public virtual string RedirectResponseCode { get; set; }

        /// <summary>
        /// If set to true, any accompanying query portion of the original URL is removed prior to redirecting the
        /// request. If set to false, the query portion of the original URL is retained. The default is set to false.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("stripQuery")]
        public virtual System.Nullable<bool> StripQuery { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>The retry policy associates with HttpRouteRule</summary>
    public class HttpRetryPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Specifies the allowed number retries. This number must be &amp;gt; 0. If not specified, defaults to 1.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("numRetries")]
        public virtual System.Nullable<long> NumRetries { get; set; }

        /// <summary>
        /// Specifies a non-zero timeout per retry attempt. If not specified, will use the timeout set in
        /// HttpRouteAction. If timeout in HttpRouteAction is not set, will use the largest timeout among all backend
        /// services associated with the route.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("perTryTimeout")]
        public virtual Duration PerTryTimeout { get; set; }

        /// <summary>
        /// Specfies one or more conditions when this retry rule applies. Valid values are:   - 5xx: Loadbalancer will
        /// attempt a retry if the backend service responds with any 5xx response code, or if the backend service does
        /// not respond at all, example: disconnects, reset, read timeout, connection failure, and refused streams.  -
        /// gateway-error: Similar to 5xx, but only applies to response codes 502, 503 or 504. -  - connect-failure:
        /// Loadbalancer will retry on failures connecting to backend services, for example due to connection timeouts.
        /// - retriable-4xx: Loadbalancer will retry for retriable 4xx response codes. Currently the only retriable
        /// error supported is 409.  - refused-stream:Loadbalancer will retry if the backend service resets the stream
        /// with a REFUSED_STREAM error code. This reset type indicates that it is safe to retry.  -
        /// cancelledLoadbalancer will retry if the gRPC status code in the response header is set to cancelled  -
        /// deadline-exceeded: Loadbalancer will retry if the gRPC status code in the response header is set to
        /// deadline-exceeded  - resource-exhausted: Loadbalancer will retry if the gRPC status code in the response
        /// header is set to resource-exhausted  - unavailable: Loadbalancer will retry if the gRPC status code in the
        /// response header is set to unavailable
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("retryConditions")]
        public virtual System.Collections.Generic.IList<string> RetryConditions { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class HttpRouteAction : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The specification for allowing client side cross-origin requests. Please see W3C Recommendation for Cross
        /// Origin Resource Sharing  Not supported when the URL map is bound to target gRPC proxy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("corsPolicy")]
        public virtual CorsPolicy CorsPolicy { get; set; }

        /// <summary>
        /// The specification for fault injection introduced into traffic to test the resiliency of clients to backend
        /// service failure. As part of fault injection, when clients send requests to a backend service, delays can be
        /// introduced by Loadbalancer on a percentage of requests before sending those request to the backend service.
        /// Similarly requests from clients can be aborted by the Loadbalancer for a percentage of requests. timeout and
        /// retry_policy will be ignored by clients that are configured with a fault_injection_policy. Not supported
        /// when the URL map is bound to target gRPC proxy that has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("faultInjectionPolicy")]
        public virtual HttpFaultInjection FaultInjectionPolicy { get; set; }

        /// <summary>
        /// Specifies the policy on how requests intended for the route's backends are shadowed to a separate mirrored
        /// backend service. Loadbalancer does not wait for responses from the shadow service. Prior to sending traffic
        /// to the shadow service, the host / authority header is suffixed with -shadow. Not supported when the URL map
        /// is bound to target gRPC proxy that has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("requestMirrorPolicy")]
        public virtual RequestMirrorPolicy RequestMirrorPolicy { get; set; }

        /// <summary>
        /// Specifies the retry policy associated with this route. Not supported when the URL map is bound to target
        /// gRPC proxy that has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("retryPolicy")]
        public virtual HttpRetryPolicy RetryPolicy { get; set; }

        /// <summary>
        /// Specifies the timeout for the selected route. Timeout is computed from the time the request has been fully
        /// processed (i.e. end-of-stream) up until the response has been completely processed. Timeout includes all
        /// retries. If not specified, will use the largest timeout among all backend services associated with the
        /// route. Not supported when the URL map is bound to target gRPC proxy that has validateForProxyless field set
        /// to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("timeout")]
        public virtual Duration Timeout { get; set; }

        /// <summary>
        /// The spec to modify the URL of the request, prior to forwarding the request to the matched service.
        /// urlRewrite is the only action supported in UrlMaps for external HTTP(S) load balancers. Not supported when
        /// the URL map is bound to target gRPC proxy that has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("urlRewrite")]
        public virtual UrlRewrite UrlRewrite { get; set; }

        /// <summary>
        /// A list of weighted backend services to send traffic to when a route match occurs. The weights determine the
        /// fraction of traffic that flows to their corresponding backend service. If all traffic needs to go to a
        /// single backend service, there must be one  weightedBackendService with weight set to a non-zero number. Once
        /// a backendService is identified and before forwarding the request to the backend service, advanced routing
        /// actions such as URL rewrites and header transformations are applied depending on additional settings
        /// specified in this HttpRouteAction.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("weightedBackendServices")]
        public virtual System.Collections.Generic.IList<WeightedBackendService> WeightedBackendServices { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// An HttpRouteRule specifies how to match an HTTP request and the corresponding routing action that load balancing
    /// proxies will perform.
    /// </summary>
    public class HttpRouteRule : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The short description conveying the intent of this routeRule. The description can have a maximum length of
        /// 1024 characters.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Specifies changes to request and response headers that need to take effect for the selected backendService.
        /// The headerAction specified here are applied before the matching pathMatchers[].headerAction and after
        /// pathMatchers[].routeRules[].routeAction.weightedBackendService.backendServiceWeightAction[].headerAction
        /// Note that headerAction is not supported for Loadbalancers that have their loadBalancingScheme set to
        /// EXTERNAL. Not supported when the URL map is bound to target gRPC proxy that has validateForProxyless field
        /// set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("headerAction")]
        public virtual HttpHeaderAction HeaderAction { get; set; }

        /// <summary>
        /// The list of criteria for matching attributes of a request to this routeRule. This list has OR semantics: the
        /// request matches this routeRule when any of the matchRules are satisfied. However predicates within a given
        /// matchRule have AND semantics. All predicates within a matchRule must match for the request to match the
        /// rule.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("matchRules")]
        public virtual System.Collections.Generic.IList<HttpRouteRuleMatch> MatchRules { get; set; }

        /// <summary>
        /// For routeRules within a given pathMatcher, priority determines the order in which load balancer will
        /// interpret routeRules. RouteRules are evaluated in order of priority, from the lowest to highest number. The
        /// priority of a rule decreases as its number increases (1, 2, 3, N+1). The first rule that matches the request
        /// is applied. You cannot configure two or more routeRules with the same priority. Priority for each rule must
        /// be set to a number between 0 and 2147483647 inclusive. Priority numbers can have gaps, which enable you to
        /// add or remove rules in the future without affecting the rest of the rules. For example, 1, 2, 3, 4, 5, 9,
        /// 12, 16 is a valid series of priority numbers to which you could add rules numbered from 6 to 8, 10 to 11,
        /// and 13 to 15 in the future without any impact on existing rules.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("priority")]
        public virtual System.Nullable<int> Priority { get; set; }

        /// <summary>
        /// In response to a matching matchRule, the load balancer performs advanced routing actions like URL rewrites,
        /// header transformations, etc. prior to forwarding the request to the selected backend. If  routeAction
        /// specifies any  weightedBackendServices, service must not be set. Conversely if service is set, routeAction
        /// cannot contain any  weightedBackendServices. Only one of urlRedirect, service or
        /// routeAction.weightedBackendService must be set. UrlMaps for external HTTP(S) load balancers support only the
        /// urlRewrite action within a routeRule's routeAction.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("routeAction")]
        public virtual HttpRouteAction RouteAction { get; set; }

        /// <summary>
        /// The full or partial URL of the backend service resource to which traffic is directed if this rule is
        /// matched. If routeAction is additionally specified, advanced routing actions like URL Rewrites, etc. take
        /// effect prior to sending the request to the backend. However, if service is specified, routeAction cannot
        /// contain any weightedBackendService s. Conversely, if routeAction specifies any  weightedBackendServices,
        /// service must not be specified. Only one of urlRedirect, service or routeAction.weightedBackendService must
        /// be set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("service")]
        public virtual string Service { get; set; }

        /// <summary>
        /// When this rule is matched, the request is redirected to a URL specified by urlRedirect. If urlRedirect is
        /// specified, service or routeAction must not be set. Not supported when the URL map is bound to target gRPC
        /// proxy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("urlRedirect")]
        public virtual HttpRedirectAction UrlRedirect { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// HttpRouteRuleMatch specifies a set of criteria for matching requests to an HttpRouteRule. All specified criteria
    /// must be satisfied for a match to occur.
    /// </summary>
    public class HttpRouteRuleMatch : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// For satisfying the matchRule condition, the path of the request must exactly match the value specified in
        /// fullPathMatch after removing any query parameters and anchor that may be part of the original URL.
        /// fullPathMatch must be between 1 and 1024 characters. Only one of prefixMatch, fullPathMatch or regexMatch
        /// must be specified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fullPathMatch")]
        public virtual string FullPathMatch { get; set; }

        /// <summary>
        /// Specifies a list of header match criteria, all of which must match corresponding headers in the request.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("headerMatches")]
        public virtual System.Collections.Generic.IList<HttpHeaderMatch> HeaderMatches { get; set; }

        /// <summary>
        /// Specifies that prefixMatch and fullPathMatch matches are case sensitive. The default value is false.
        /// ignoreCase must not be used with regexMatch. Not supported when the URL map is bound to target gRPC proxy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ignoreCase")]
        public virtual System.Nullable<bool> IgnoreCase { get; set; }

        /// <summary>
        /// Opaque filter criteria used by Loadbalancer to restrict routing configuration to a limited set of xDS
        /// compliant clients. In their xDS requests to Loadbalancer, xDS clients present node metadata. When there is a
        /// match, the relevant routing configuration is made available to those proxies. For each metadataFilter in
        /// this list, if its filterMatchCriteria is set to MATCH_ANY, at least one of the filterLabels must match the
        /// corresponding label provided in the metadata. If its filterMatchCriteria is set to MATCH_ALL, then all of
        /// its filterLabels must match with corresponding labels provided in the metadata. If multiple metadataFilters
        /// are specified, all of them need to be satisfied in order to be considered a match. metadataFilters specified
        /// here will be applied after those specified in ForwardingRule that refers to the UrlMap this
        /// HttpRouteRuleMatch belongs to. metadataFilters only applies to Loadbalancers that have their
        /// loadBalancingScheme set to INTERNAL_SELF_MANAGED. Not supported when the URL map is bound to target gRPC
        /// proxy that has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("metadataFilters")]
        public virtual System.Collections.Generic.IList<MetadataFilter> MetadataFilters { get; set; }

        /// <summary>
        /// For satisfying the matchRule condition, the request's path must begin with the specified prefixMatch.
        /// prefixMatch must begin with a /. The value must be between 1 and 1024 characters. Only one of prefixMatch,
        /// fullPathMatch or regexMatch must be specified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("prefixMatch")]
        public virtual string PrefixMatch { get; set; }

        /// <summary>
        /// Specifies a list of query parameter match criteria, all of which must match corresponding query parameters
        /// in the request. Not supported when the URL map is bound to target gRPC proxy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("queryParameterMatches")]
        public virtual System.Collections.Generic.IList<HttpQueryParameterMatch> QueryParameterMatches { get; set; }

        /// <summary>
        /// For satisfying the matchRule condition, the path of the request must satisfy the regular expression
        /// specified in regexMatch after removing any query parameters and anchor supplied with the original URL. For
        /// regular expression grammar please see github.com/google/re2/wiki/Syntax  Only one of prefixMatch,
        /// fullPathMatch or regexMatch must be specified. Note that regexMatch only applies to Loadbalancers that have
        /// their loadBalancingScheme set to INTERNAL_SELF_MANAGED.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("regexMatch")]
        public virtual string RegexMatch { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a legacy HTTPS Health Check resource.  Legacy health checks are required by network load balancers.
    /// For more information, read Health Check Concepts.
    /// </summary>
    public class HttpsHealthCheck : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>How often (in seconds) to send a health check. The default value is 5 seconds.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("checkIntervalSec")]
        public virtual System.Nullable<int> CheckIntervalSec { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// A so-far unhealthy instance will be marked healthy after this many consecutive successes. The default value
        /// is 2.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthyThreshold")]
        public virtual System.Nullable<int> HealthyThreshold { get; set; }

        /// <summary>
        /// The value of the host header in the HTTPS health check request. If left empty (default value), the public IP
        /// on behalf of which this health check is performed will be used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("host")]
        public virtual string Host { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>Type of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The TCP port number for the HTTPS health check request. The default value is 443.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("port")]
        public virtual System.Nullable<int> Port { get; set; }

        /// <summary>The request path of the HTTPS health check request. The default value is "/".</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("requestPath")]
        public virtual string RequestPath { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// How long (in seconds) to wait before claiming failure. The default value is 5 seconds. It is invalid for
        /// timeoutSec to have a greater value than checkIntervalSec.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("timeoutSec")]
        public virtual System.Nullable<int> TimeoutSec { get; set; }

        /// <summary>
        /// A so-far healthy instance will be marked unhealthy after this many consecutive failures. The default value
        /// is 2.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unhealthyThreshold")]
        public virtual System.Nullable<int> UnhealthyThreshold { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of HttpsHealthCheck resources.</summary>
    public class HttpsHealthCheckList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of HttpsHealthCheck resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<HttpsHealthCheck> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents an Image resource.  You can use images to create boot disks for your VM instances. For more
    /// information, read Images. (== resource_for {$api_version}.images ==)
    /// </summary>
    public class Image : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Size of the image tar.gz archive stored in Google Cloud Storage (in bytes).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("archiveSizeBytes")]
        public virtual System.Nullable<long> ArchiveSizeBytes { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>The deprecation status associated with this image.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("deprecated")]
        public virtual DeprecationStatus Deprecated { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>Size of the image when restored onto a persistent disk (in GB).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskSizeGb")]
        public virtual System.Nullable<long> DiskSizeGb { get; set; }

        /// <summary>
        /// The name of the image family to which this image belongs. You can create disks by specifying an image family
        /// instead of a specific image name. The image family always returns its latest image that is not deprecated.
        /// The name of the image family must comply with RFC1035.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("family")]
        public virtual string Family { get; set; }

        /// <summary>
        /// A list of features to enable on the guest operating system. Applicable only for bootable images. Read
        /// Enabling guest operating system features to see a list of available options.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("guestOsFeatures")]
        public virtual System.Collections.Generic.IList<GuestOsFeature> GuestOsFeatures { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// Encrypts the image using a customer-supplied encryption key.  After you encrypt an image with a
        /// customer-supplied key, you must provide the same key if you use the image later (e.g. to create a disk from
        /// the image).  Customer-supplied encryption keys do not protect access to metadata of the disk.  If you do not
        /// provide an encryption key when creating the image, then the disk will be encrypted using an automatically
        /// generated key and you do not need to provide a key to use the image later.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("imageEncryptionKey")]
        public virtual CustomerEncryptionKey ImageEncryptionKey { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#image for images.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// A fingerprint for the labels being applied to this image, which is essentially a hash of the labels used for
        /// optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every request
        /// to modify or update labels. You must always provide an up-to-date fingerprint hash in order to update or
        /// change labels, otherwise the request will fail with error 412 conditionNotMet.  To see the latest
        /// fingerprint, make a get() request to retrieve an image.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labelFingerprint")]
        public virtual string LabelFingerprint { get; set; }

        /// <summary>Labels to apply to this image. These can be later modified by the setLabels method.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>Integer license codes indicating which licenses are attached to this image.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("licenseCodes")]
        public virtual System.Collections.Generic.IList<System.Nullable<long>> LicenseCodes { get; set; }

        /// <summary>Any applicable license URI.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("licenses")]
        public virtual System.Collections.Generic.IList<string> Licenses { get; set; }

        /// <summary>
        /// Name of the resource; provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The parameters of the raw disk image.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("rawDisk")]
        public virtual RawDiskData RawDisk { get; set; }

        /// <summary>[Output Only] Reserved for future use.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("satisfiesPzs")]
        public virtual System.Nullable<bool> SatisfiesPzs { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>Set the secure boot keys of shielded instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("shieldedInstanceInitialState")]
        public virtual InitialStateConfig ShieldedInstanceInitialState { get; set; }

        /// <summary>
        /// URL of the source disk used to create this image. This can be a full or valid partial URL. You must provide
        /// either this property or the rawDisk.source property but not both to create an image. For example, the
        /// following are valid values:   - https://www.googleapis.com/compute/v1/projects/project/zones/zone/disks/disk
        ///  - projects/project/zones/zone/disks/disk  - zones/zone/disks/disk
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceDisk")]
        public virtual string SourceDisk { get; set; }

        /// <summary>
        /// The customer-supplied encryption key of the source disk. Required if the source disk is protected by a
        /// customer-supplied encryption key.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceDiskEncryptionKey")]
        public virtual CustomerEncryptionKey SourceDiskEncryptionKey { get; set; }

        /// <summary>
        /// [Output Only] The ID value of the disk used to create this image. This value may be used to determine
        /// whether the image was taken from the current or a previous instance of a given disk name.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceDiskId")]
        public virtual string SourceDiskId { get; set; }

        /// <summary>
        /// URL of the source image used to create this image.  In order to create an image, you must provide the full
        /// or partial URL of one of the following:   - The selfLink URL   - This property   - The rawDisk.source URL
        /// - The sourceDisk URL
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceImage")]
        public virtual string SourceImage { get; set; }

        /// <summary>
        /// The customer-supplied encryption key of the source image. Required if the source image is protected by a
        /// customer-supplied encryption key.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceImageEncryptionKey")]
        public virtual CustomerEncryptionKey SourceImageEncryptionKey { get; set; }

        /// <summary>
        /// [Output Only] The ID value of the image used to create this image. This value may be used to determine
        /// whether the image was taken from the current or a previous instance of a given image name.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceImageId")]
        public virtual string SourceImageId { get; set; }

        /// <summary>
        /// URL of the source snapshot used to create this image.  In order to create an image, you must provide the
        /// full or partial URL of one of the following:   - The selfLink URL   - This property  - The sourceImage URL
        /// - The rawDisk.source URL   - The sourceDisk URL
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceSnapshot")]
        public virtual string SourceSnapshot { get; set; }

        /// <summary>
        /// The customer-supplied encryption key of the source snapshot. Required if the source snapshot is protected by
        /// a customer-supplied encryption key.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceSnapshotEncryptionKey")]
        public virtual CustomerEncryptionKey SourceSnapshotEncryptionKey { get; set; }

        /// <summary>
        /// [Output Only] The ID value of the snapshot used to create this image. This value may be used to determine
        /// whether the snapshot was taken from the current or a previous instance of a given snapshot name.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceSnapshotId")]
        public virtual string SourceSnapshotId { get; set; }

        /// <summary>The type of the image used to create this disk. The default and only value is RAW</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceType")]
        public virtual string SourceType { get; set; }

        /// <summary>
        /// [Output Only] The status of the image. An image can be used to create other resources, such as instances,
        /// only after the image has been successfully created and the status is set to READY. Possible values are
        /// FAILED, PENDING, or READY.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>Cloud Storage bucket storage location of the image (regional or multi-regional).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("storageLocations")]
        public virtual System.Collections.Generic.IList<string> StorageLocations { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>The parameters of the raw disk image.</summary>
        public class RawDiskData
        {
            /// <summary>
            /// The format used to encode and transmit the block device, which should be TAR. This is just a container
            /// and transmission format and not a runtime format. Provided by the client when the disk image is created.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("containerType")]
            public virtual string ContainerType { get; set; }

            /// <summary>
            /// [Deprecated] This field is deprecated. An optional SHA1 checksum of the disk image before unpackaging
            /// provided by the client when the disk image is created.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("sha1Checksum")]
            public virtual string Sha1Checksum { get; set; }

            /// <summary>
            /// The full Google Cloud Storage URL where the disk image is stored. You must provide either this property
            /// or the sourceDisk property but not both.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("source")]
            public virtual string Source { get; set; }
        }
    }

    /// <summary>Contains a list of images.</summary>
    public class ImageList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Image resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Image> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Initial State for shielded instance, these are public keys which are safe to store in public</summary>
    public class InitialStateConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The Key Database (db).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("dbs")]
        public virtual System.Collections.Generic.IList<FileContentBuffer> Dbs { get; set; }

        /// <summary>The forbidden key database (dbx).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("dbxs")]
        public virtual System.Collections.Generic.IList<FileContentBuffer> Dbxs { get; set; }

        /// <summary>The Key Exchange Key (KEK).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("keks")]
        public virtual System.Collections.Generic.IList<FileContentBuffer> Keks { get; set; }

        /// <summary>The Platform Key (PK).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("pk")]
        public virtual FileContentBuffer Pk { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents an Instance resource.  An instance is a virtual machine that is hosted on Google Cloud Platform. For
    /// more information, read Virtual Machine Instances. (== resource_for {$api_version}.instances ==)
    /// </summary>
    public class Instance : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Controls for advanced machine-related behavior features.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("advancedMachineFeatures")]
        public virtual AdvancedMachineFeatures AdvancedMachineFeatures { get; set; }

        /// <summary>
        /// Allows this instance to send and receive packets with non-matching destination or source IPs. This is
        /// required if you plan to use this instance to forward routes. For more information, see Enabling IP
        /// Forwarding.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("canIpForward")]
        public virtual System.Nullable<bool> CanIpForward { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("confidentialInstanceConfig")]
        public virtual ConfidentialInstanceConfig ConfidentialInstanceConfig { get; set; }

        /// <summary>[Output Only] The CPU platform used by this instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cpuPlatform")]
        public virtual string CpuPlatform { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>Whether the resource should be protected against deletion.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("deletionProtection")]
        public virtual System.Nullable<bool> DeletionProtection { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Array of disks associated with this instance. Persistent disks must be created before you can assign them.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("disks")]
        public virtual System.Collections.Generic.IList<AttachedDisk> Disks { get; set; }

        /// <summary>Enables display device for the instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("displayDevice")]
        public virtual DisplayDevice DisplayDevice { get; set; }

        /// <summary>
        /// Specifies a fingerprint for this resource, which is essentially a hash of the instance's contents and used
        /// for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every
        /// request to modify or update the instance. You must always provide an up-to-date fingerprint hash in order to
        /// update the instance.  To see the latest fingerprint, make get() request to the instance.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>A list of the type and count of accelerator cards attached to the instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("guestAccelerators")]
        public virtual System.Collections.Generic.IList<AcceleratorConfig> GuestAccelerators { get; set; }

        /// <summary>
        /// Specifies the hostname of the instance. The specified hostname must be RFC1035 compliant. If hostname is not
        /// specified, the default hostname is [INSTANCE_NAME].c.[PROJECT_ID].internal when using the global DNS, and
        /// [INSTANCE_NAME].[ZONE].c.[PROJECT_ID].internal when using zonal DNS.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("hostname")]
        public virtual string Hostname { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#instance for instances.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// A fingerprint for this request, which is essentially a hash of the label's contents and used for optimistic
        /// locking. The fingerprint is initially generated by Compute Engine and changes after every request to modify
        /// or update labels. You must always provide an up-to-date fingerprint hash in order to update or change
        /// labels.  To see the latest fingerprint, make get() request to the instance.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labelFingerprint")]
        public virtual string LabelFingerprint { get; set; }

        /// <summary>Labels to apply to this instance. These can be later modified by the setLabels method.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>[Output Only] Last start timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("lastStartTimestamp")]
        public virtual string LastStartTimestamp { get; set; }

        /// <summary>[Output Only] Last stop timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("lastStopTimestamp")]
        public virtual string LastStopTimestamp { get; set; }

        /// <summary>[Output Only] Last suspended timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("lastSuspendedTimestamp")]
        public virtual string LastSuspendedTimestamp { get; set; }

        /// <summary>
        /// Full or partial URL of the machine type resource to use for this instance, in the format:
        /// zones/zone/machineTypes/machine-type. This is provided by the client when the instance is created. For
        /// example, the following is a valid partial url to a predefined machine type:
        /// zones/us-central1-f/machineTypes/n1-standard-1   To create a custom machine type, provide a URL to a machine
        /// type in the following format, where CPUS is 1 or an even number up to 32 (2, 4, 6, ... 24, etc), and MEMORY
        /// is the total memory for this instance. Memory must be a multiple of 256 MB and must be supplied in MB (e.g.
        /// 5 GB of memory is 5120 MB): zones/zone/machineTypes/custom-CPUS-MEMORY   For example:
        /// zones/us-central1-f/machineTypes/custom-4-5120   For a full list of restrictions, read the Specifications
        /// for custom machine types.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("machineType")]
        public virtual string MachineType { get; set; }

        /// <summary>
        /// The metadata key/value pairs assigned to this instance. This includes custom metadata and predefined keys.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("metadata")]
        public virtual Metadata Metadata { get; set; }

        /// <summary>
        /// Specifies a minimum CPU platform for the VM instance. Applicable values are the friendly names of CPU
        /// platforms, such as minCpuPlatform: "Intel Haswell" or minCpuPlatform: "Intel Sandy Bridge".
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minCpuPlatform")]
        public virtual string MinCpuPlatform { get; set; }

        /// <summary>
        /// The name of the resource, provided by the client when initially creating the resource. The resource name
        /// must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long
        /// and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
        /// lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last
        /// character, which cannot be a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// An array of network configurations for this instance. These specify how interfaces are configured to
        /// interact with other network services, such as connecting to the internet. Multiple interfaces are supported
        /// per instance.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkInterfaces")]
        public virtual System.Collections.Generic.IList<NetworkInterface> NetworkInterfaces { get; set; }

        /// <summary>PostKeyRevocationActionType of the instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("postKeyRevocationActionType")]
        public virtual string PostKeyRevocationActionType { get; set; }

        /// <summary>
        /// The private IPv6 google access type for the VM. If not specified, use  INHERIT_FROM_SUBNETWORK as default.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("privateIpv6GoogleAccess")]
        public virtual string PrivateIpv6GoogleAccess { get; set; }

        /// <summary>Specifies the reservations that this instance can consume from.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("reservationAffinity")]
        public virtual ReservationAffinity ReservationAffinity { get; set; }

        /// <summary>Resource policies applied to this instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resourcePolicies")]
        public virtual System.Collections.Generic.IList<string> ResourcePolicies { get; set; }

        /// <summary>[Output Only] Reserved for future use.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("satisfiesPzs")]
        public virtual System.Nullable<bool> SatisfiesPzs { get; set; }

        /// <summary>Sets the scheduling options for this instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("scheduling")]
        public virtual Scheduling Scheduling { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// A list of service accounts, with their specified scopes, authorized for this instance. Only one service
        /// account per VM instance is supported.  Service accounts generate access tokens that can be accessed through
        /// the metadata server and used to authenticate applications on the instance. See Service Accounts for more
        /// information.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("serviceAccounts")]
        public virtual System.Collections.Generic.IList<ServiceAccount> ServiceAccounts { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("shieldedInstanceConfig")]
        public virtual ShieldedInstanceConfig ShieldedInstanceConfig { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("shieldedInstanceIntegrityPolicy")]
        public virtual ShieldedInstanceIntegrityPolicy ShieldedInstanceIntegrityPolicy { get; set; }

        /// <summary>
        /// [Output Only] Whether a VM has been restricted for start because Compute Engine has detected suspicious
        /// activity.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("startRestricted")]
        public virtual System.Nullable<bool> StartRestricted { get; set; }

        /// <summary>
        /// [Output Only] The status of the instance. One of the following values: PROVISIONING, STAGING, RUNNING,
        /// STOPPING, SUSPENDING, SUSPENDED, REPAIRING, and TERMINATED. For more information about the status of the
        /// instance, see  Instance life cycle.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>[Output Only] An optional, human-readable explanation of the status.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("statusMessage")]
        public virtual string StatusMessage { get; set; }

        /// <summary>
        /// Tags to apply to this instance. Tags are used to identify valid sources or targets for network firewalls and
        /// are specified by the client during instance creation. The tags can be later modified by the setTags method.
        /// Each tag within the list must comply with RFC1035. Multiple tags can be specified via the 'tags.items'
        /// field.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("tags")]
        public virtual Tags Tags { get; set; }

        /// <summary>
        /// [Output Only] URL of the zone where the instance resides. You must specify this field as part of the HTTP
        /// request URL. It is not settable as a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>An object that contains a list of instances scoped by zone.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, InstancesScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#instanceAggregatedList for aggregated lists of Instance
        /// resources.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents an Instance Group resource.  Instance Groups can be used to configure a target for load balancing.
    /// Instance groups can either be managed or unmanaged.  To create  managed instance groups, use the
    /// instanceGroupManager or regionInstanceGroupManager resource instead.  Use zonal unmanaged instance groups if you
    /// need to apply load balancing to groups of heterogeneous instances or if you need to manage the instances
    /// yourself. You cannot create regional unmanaged instance groups.  For more information, read Instance groups.
    /// (== resource_for {$api_version}.instanceGroups ==) (== resource_for {$api_version}.regionInstanceGroups ==)
    /// </summary>
    public class InstanceGroup : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The creation timestamp for this instance group in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The fingerprint of the named ports. The system uses this fingerprint to detect conflicts when
        /// multiple users change the named ports concurrently.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>[Output Only] A unique identifier for this instance group, generated by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute#instanceGroup for instance groups.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// The name of the instance group. The name must be 1-63 characters long, and comply with RFC1035.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// Assigns a name to a port number. For example: {name: "http", port: 80}  This allows the system to reference
        /// ports by the assigned name instead of a port number. Named ports can also contain multiple ports. For
        /// example: [{name: "http", port: 80},{name: "http", port: 8080}]   Named ports apply to all instances in this
        /// instance group.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("namedPorts")]
        public virtual System.Collections.Generic.IList<NamedPort> NamedPorts { get; set; }

        /// <summary>
        /// [Output Only] The URL of the network to which all instances in the instance group belong. If your instance
        /// has multiple network interfaces, then the network and subnetwork fields only refer to the network and subnet
        /// used by your primary interface (nic0).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>
        /// [Output Only] The URL of the region where the instance group is located (for regional resources).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] The URL for this instance group. The server generates this URL.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] The total number of instances in the instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("size")]
        public virtual System.Nullable<int> Size { get; set; }

        /// <summary>
        /// [Output Only] The URL of the subnetwork to which all instances in the instance group belong. If your
        /// instance has multiple network interfaces, then the network and subnetwork fields only refer to the network
        /// and subnet used by your primary interface (nic0).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("subnetwork")]
        public virtual string Subnetwork { get; set; }

        /// <summary>
        /// [Output Only] The URL of the zone where the instance group is located (for zonal resources).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of InstanceGroupsScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, InstanceGroupsScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute#instanceGroupAggregatedList for aggregated lists of
        /// instance groups.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>A list of InstanceGroup resources.</summary>
    public class InstanceGroupList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of InstanceGroup resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<InstanceGroup> Items { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute#instanceGroupList for instance group lists.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a Managed Instance Group resource.  An instance group is a collection of VM instances that you can
    /// manage as a single entity. For more information, read Instance groups.  For zonal Managed Instance Group, use
    /// the instanceGroupManagers resource.  For regional Managed Instance Group, use the regionInstanceGroupManagers
    /// resource. (== resource_for {$api_version}.instanceGroupManagers ==) (== resource_for
    /// {$api_version}.regionInstanceGroupManagers ==)
    /// </summary>
    public class InstanceGroupManager : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The autohealing policy for this managed instance group. You can specify only one value.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoHealingPolicies")]
        public virtual System.Collections.Generic.IList<InstanceGroupManagerAutoHealingPolicy> AutoHealingPolicies { get; set; }

        /// <summary>
        /// The base instance name to use for instances in this group. The value must be 1-58 characters long. Instances
        /// are named by appending a hyphen and a random four-character string to the base instance name. The base
        /// instance name must comply with RFC1035.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("baseInstanceName")]
        public virtual string BaseInstanceName { get; set; }

        /// <summary>
        /// [Output Only] The creation timestamp for this managed instance group in RFC3339 text format.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// [Output Only] The list of instance actions and the number of instances in this managed instance group that
        /// are scheduled for each of those actions.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("currentActions")]
        public virtual InstanceGroupManagerActionsSummary CurrentActions { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Policy specifying the intended distribution of managed instances across zones in a regional managed instance
        /// group.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("distributionPolicy")]
        public virtual DistributionPolicy DistributionPolicy { get; set; }

        /// <summary>
        /// Fingerprint of this resource. This field may be used in optimistic locking. It will be ignored when
        /// inserting an InstanceGroupManager. An up-to-date fingerprint must be provided in order to update the
        /// InstanceGroupManager, otherwise the request will fail with error 412 conditionNotMet.  To see the latest
        /// fingerprint, make a get() request to retrieve an InstanceGroupManager.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// [Output Only] A unique identifier for this resource type. The server generates this identifier.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] The URL of the Instance Group resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceGroup")]
        public virtual string InstanceGroup { get; set; }

        /// <summary>
        /// The URL of the instance template that is specified for this managed instance group. The group uses this
        /// template to create all new instances in the managed instance group. The templates for existing instances in
        /// the group do not change unless you run recreateInstances, run applyUpdatesToInstances, or set the group's
        /// updatePolicy.type to PROACTIVE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceTemplate")]
        public virtual string InstanceTemplate { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute#instanceGroupManager for managed instance groups.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// The name of the managed instance group. The name must be 1-63 characters long, and comply with RFC1035.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// Named ports configured for the Instance Groups complementary to this Instance Group Manager.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("namedPorts")]
        public virtual System.Collections.Generic.IList<NamedPort> NamedPorts { get; set; }

        /// <summary>
        /// [Output Only] The URL of the region where the managed instance group resides (for regional resources).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] The URL for this managed instance group. The server defines this URL.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>Stateful configuration for this Instanced Group Manager</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("statefulPolicy")]
        public virtual StatefulPolicy StatefulPolicy { get; set; }

        /// <summary>[Output Only] The status of this managed instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual InstanceGroupManagerStatus Status { get; set; }

        /// <summary>
        /// The URLs for all TargetPool resources to which instances in the instanceGroup field are added. The target
        /// pools automatically apply to all of the instances in the managed instance group.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetPools")]
        public virtual System.Collections.Generic.IList<string> TargetPools { get; set; }

        /// <summary>
        /// The target number of running instances for this managed instance group. You can reduce this number by using
        /// the instanceGroupManager deleteInstances or abandonInstances methods. Resizing the group also changes this
        /// number.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetSize")]
        public virtual System.Nullable<int> TargetSize { get; set; }

        /// <summary>The update policy for this managed instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("updatePolicy")]
        public virtual InstanceGroupManagerUpdatePolicy UpdatePolicy { get; set; }

        /// <summary>
        /// Specifies the instance templates used by this managed instance group to create instances.  Each version is
        /// defined by an instanceTemplate and a name. Every version can appear at most once per instance group. This
        /// field overrides the top-level instanceTemplate field. Read more about the relationships between these
        /// fields. Exactly one version must leave the targetSize field unset. That version will be applied to all
        /// remaining instances. For more information, read about canary updates.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("versions")]
        public virtual System.Collections.Generic.IList<InstanceGroupManagerVersion> Versions { get; set; }

        /// <summary>
        /// [Output Only] The URL of a zone where the managed instance group is located (for zonal resources).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagerActionsSummary : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] The total number of instances in the managed instance group that are scheduled to be
        /// abandoned. Abandoning an instance removes it from the managed instance group without deleting it.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("abandoning")]
        public virtual System.Nullable<int> Abandoning { get; set; }

        /// <summary>
        /// [Output Only] The number of instances in the managed instance group that are scheduled to be created or are
        /// currently being created. If the group fails to create any of these instances, it tries again until it
        /// creates the instance successfully.  If you have disabled creation retries, this field will not be populated;
        /// instead, the creatingWithoutRetries field will be populated.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creating")]
        public virtual System.Nullable<int> Creating { get; set; }

        /// <summary>
        /// [Output Only] The number of instances that the managed instance group will attempt to create. The group
        /// attempts to create each instance only once. If the group fails to create any of these instances, it
        /// decreases the group's targetSize value accordingly.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creatingWithoutRetries")]
        public virtual System.Nullable<int> CreatingWithoutRetries { get; set; }

        /// <summary>
        /// [Output Only] The number of instances in the managed instance group that are scheduled to be deleted or are
        /// currently being deleted.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("deleting")]
        public virtual System.Nullable<int> Deleting { get; set; }

        /// <summary>
        /// [Output Only] The number of instances in the managed instance group that are running and have no scheduled
        /// actions.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("none")]
        public virtual System.Nullable<int> None { get; set; }

        /// <summary>
        /// [Output Only] The number of instances in the managed instance group that are scheduled to be recreated or
        /// are currently being being recreated. Recreating an instance deletes the existing root persistent disk and
        /// creates a new disk from the image that is defined in the instance template.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("recreating")]
        public virtual System.Nullable<int> Recreating { get; set; }

        /// <summary>
        /// [Output Only] The number of instances in the managed instance group that are being reconfigured with
        /// properties that do not require a restart or a recreate action. For example, setting or removing target pools
        /// for the instance.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("refreshing")]
        public virtual System.Nullable<int> Refreshing { get; set; }

        /// <summary>
        /// [Output Only] The number of instances in the managed instance group that are scheduled to be restarted or
        /// are currently being restarted.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("restarting")]
        public virtual System.Nullable<int> Restarting { get; set; }

        /// <summary>
        /// [Output Only] The number of instances in the managed instance group that are being verified. See the
        /// managedInstances[].currentAction property in the listManagedInstances method documentation.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("verifying")]
        public virtual System.Nullable<int> Verifying { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagerAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of InstanceGroupManagersScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, InstanceGroupManagersScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute#instanceGroupManagerAggregatedList for an
        /// aggregated list of managed instance groups.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary></summary>
    public class InstanceGroupManagerAutoHealingPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The URL for the health check that signals autohealing.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthCheck")]
        public virtual string HealthCheck { get; set; }

        /// <summary>
        /// The number of seconds that the managed instance group waits before it applies autohealing policies to new
        /// instances or recently recreated instances. This initial delay allows instances to initialize and run their
        /// startup scripts before the instance group determines that they are UNHEALTHY. This prevents the managed
        /// instance group from recreating its instances prematurely. This value must be from range [0, 3600].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("initialDelaySec")]
        public virtual System.Nullable<int> InitialDelaySec { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>[Output Only] A list of managed instance groups.</summary>
    public class InstanceGroupManagerList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of InstanceGroupManager resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<InstanceGroupManager> Items { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute#instanceGroupManagerList for a list of managed
        /// instance groups.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class InstanceGroupManagerStatus : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The URL of the Autoscaler that targets this instance group manager.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoscaler")]
        public virtual string Autoscaler { get; set; }

        /// <summary>
        /// [Output Only] A bit indicating whether the managed instance group is in a stable state. A stable state means
        /// that: none of the instances in the managed instance group is currently undergoing any type of change (for
        /// example, creation, restart, or deletion); no future changes are scheduled for instances in the managed
        /// instance group; and the managed instance group itself is not being modified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("isStable")]
        public virtual System.Nullable<bool> IsStable { get; set; }

        /// <summary>[Output Only] Stateful status of the given Instance Group Manager.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("stateful")]
        public virtual InstanceGroupManagerStatusStateful Stateful { get; set; }

        /// <summary>
        /// [Output Only] A status of consistency of Instances' versions with their target version specified by version
        /// field on Instance Group Manager.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("versionTarget")]
        public virtual InstanceGroupManagerStatusVersionTarget VersionTarget { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagerStatusStateful : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] A bit indicating whether the managed instance group has stateful configuration, that is, if
        /// you have configured any items in a stateful policy or in per-instance configs. The group might report that
        /// it has no stateful config even when there is still some preserved state on a managed instance, for example,
        /// if you have deleted all PICs but not yet applied those deletions.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("hasStatefulConfig")]
        public virtual System.Nullable<bool> HasStatefulConfig { get; set; }

        /// <summary>[Output Only] Status of per-instance configs on the instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("perInstanceConfigs")]
        public virtual InstanceGroupManagerStatusStatefulPerInstanceConfigs PerInstanceConfigs { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagerStatusStatefulPerInstanceConfigs : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// A bit indicating if all of the group's per-instance configs (listed in the output of a
        /// listPerInstanceConfigs API call) have status EFFECTIVE or there are no per-instance-configs.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("allEffective")]
        public virtual System.Nullable<bool> AllEffective { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagerStatusVersionTarget : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] A bit indicating whether version target has been reached in this managed instance group, i.e.
        /// all instances are in their target version. Instances' target version are specified by version field on
        /// Instance Group Manager.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("isReached")]
        public virtual System.Nullable<bool> IsReached { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagerUpdatePolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The  instance redistribution policy for regional managed instance groups. Valid values are:   - PROACTIVE
        /// (default): The group attempts to maintain an even distribution of VM instances across zones in the region.
        /// - NONE: For non-autoscaled groups, proactive redistribution is disabled.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceRedistributionType")]
        public virtual string InstanceRedistributionType { get; set; }

        /// <summary>
        /// The maximum number of instances that can be created above the specified targetSize during the update
        /// process. This value can be either a fixed number or, if the group has 10 or more instances, a percentage. If
        /// you set a percentage, the number of instances is rounded up if necessary. The default value for maxSurge is
        /// a fixed value equal to the number of zones in which the managed instance group operates.  At least one of
        /// either maxSurge or maxUnavailable must be greater than 0. Learn more about maxSurge.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxSurge")]
        public virtual FixedOrPercent MaxSurge { get; set; }

        /// <summary>
        /// The maximum number of instances that can be unavailable during the update process. An instance is considered
        /// available if all of the following conditions are satisfied:    - The instance's status is RUNNING.  - If
        /// there is a health check on the instance group, the instance's health check status must be HEALTHY at least
        /// once. If there is no health check on the group, then the instance only needs to have a status of RUNNING to
        /// be considered available.  This value can be either a fixed number or, if the group has 10 or more instances,
        /// a percentage. If you set a percentage, the number of instances is rounded up if necessary. The default value
        /// for maxUnavailable is a fixed value equal to the number of zones in which the managed instance group
        /// operates.  At least one of either maxSurge or maxUnavailable must be greater than 0. Learn more about
        /// maxUnavailable.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxUnavailable")]
        public virtual FixedOrPercent MaxUnavailable { get; set; }

        /// <summary>
        /// Minimal action to be taken on an instance. You can specify either RESTART to restart existing instances or
        /// REPLACE to delete and create new instances from the target template. If you specify a RESTART, the Updater
        /// will attempt to perform that action only. However, if the Updater determines that the minimal action you
        /// specify is not enough to perform the update, it might perform a more disruptive action.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minimalAction")]
        public virtual string MinimalAction { get; set; }

        /// <summary>What action should be used to replace instances. See minimal_action.REPLACE</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("replacementMethod")]
        public virtual string ReplacementMethod { get; set; }

        /// <summary>
        /// The type of update process. You can specify either PROACTIVE so that the instance group manager proactively
        /// executes actions in order to bring instances to their target versions or OPPORTUNISTIC so that no action is
        /// proactively executed but the update will be performed as part of other actions (for example, resizes or
        /// recreateInstances calls).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagerVersion : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The URL of the instance template that is specified for this managed instance group. The group uses this
        /// template to create new instances in the managed instance group until the `targetSize` for this version is
        /// reached. The templates for existing instances in the group do not change unless you run recreateInstances,
        /// run applyUpdatesToInstances, or set the group's updatePolicy.type to PROACTIVE; in those cases, existing
        /// instances are updated until the `targetSize` for this version is reached.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceTemplate")]
        public virtual string InstanceTemplate { get; set; }

        /// <summary>
        /// Name of the version. Unique among all versions in the scope of this managed instance group.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// Specifies the intended number of instances to be created from the instanceTemplate. The final number of
        /// instances created from the template will be equal to:   - If expressed as a fixed number, the minimum of
        /// either targetSize.fixed or instanceGroupManager.targetSize is used.  - if expressed as a percent, the
        /// targetSize would be (targetSize.percent/100 * InstanceGroupManager.targetSize) If there is a remainder, the
        /// number is rounded up.  If unset, this version will update any remaining instances not updated by another
        /// version. Read Starting a canary update for more information.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetSize")]
        public virtual FixedOrPercent TargetSize { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagersAbandonInstancesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The URLs of one or more instances to abandon. This can be a full URL or a partial URL, such as
        /// zones/[ZONE]/instances/[INSTANCE_NAME].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<string> Instances { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>InstanceGroupManagers.applyUpdatesToInstances</summary>
    public class InstanceGroupManagersApplyUpdatesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Flag to update all instances instead of specified list of ?instances?. If the flag is set to true then the
        /// instances may not be specified in the request.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("allInstances")]
        public virtual System.Nullable<bool> AllInstances { get; set; }

        /// <summary>
        /// The list of URLs of one or more instances for which you want to apply updates. Each URL can be a full URL or
        /// a partial URL, such as zones/[ZONE]/instances/[INSTANCE_NAME].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<string> Instances { get; set; }

        /// <summary>
        /// The minimal action that you want to perform on each instance during the update:   - REPLACE: At minimum,
        /// delete the instance and create it again.  - RESTART: Stop the instance and start it again.  - REFRESH: Do
        /// not stop the instance.  - NONE: Do not disrupt the instance at all.  By default, the minimum action is NONE.
        /// If your update requires a more disruptive action than you set with this flag, the necessary action is
        /// performed to execute the update.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minimalAction")]
        public virtual string MinimalAction { get; set; }

        /// <summary>
        /// The most disruptive action that you want to perform on each instance during the update:   - REPLACE: Delete
        /// the instance and create it again.  - RESTART: Stop the instance and start it again.  - REFRESH: Do not stop
        /// the instance.  - NONE: Do not disrupt the instance at all.  By default, the most disruptive allowed action
        /// is REPLACE. If your update requires a more disruptive action than you set with this flag, the update request
        /// will fail.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("mostDisruptiveAllowedAction")]
        public virtual string MostDisruptiveAllowedAction { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>InstanceGroupManagers.createInstances</summary>
    public class InstanceGroupManagersCreateInstancesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Required] List of specifications of per-instance configs.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<PerInstanceConfig> Instances { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagersDeleteInstancesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The URLs of one or more instances to delete. This can be a full URL or a partial URL, such as
        /// zones/[ZONE]/instances/[INSTANCE_NAME].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<string> Instances { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>InstanceGroupManagers.deletePerInstanceConfigs</summary>
    public class InstanceGroupManagersDeletePerInstanceConfigsReq : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The list of instance names for which we want to delete per-instance configs on this managed instance group.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("names")]
        public virtual System.Collections.Generic.IList<string> Names { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagersListErrorsResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The list of errors of the managed instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<InstanceManagedByIgmError> Items { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagersListManagedInstancesResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The list of instances in the managed instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("managedInstances")]
        public virtual System.Collections.Generic.IList<ManagedInstance> ManagedInstances { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagersListPerInstanceConfigsResp : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The list of PerInstanceConfig.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<PerInstanceConfig> Items { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>InstanceGroupManagers.patchPerInstanceConfigs</summary>
    public class InstanceGroupManagersPatchPerInstanceConfigsReq : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The list of per-instance configs to insert or patch on this managed instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("perInstanceConfigs")]
        public virtual System.Collections.Generic.IList<PerInstanceConfig> PerInstanceConfigs { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagersRecreateInstancesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The URLs of one or more instances to recreate. This can be a full URL or a partial URL, such as
        /// zones/[ZONE]/instances/[INSTANCE_NAME].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<string> Instances { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagersScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] The list of managed instance groups that are contained in the specified project and zone.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceGroupManagers")]
        public virtual System.Collections.Generic.IList<InstanceGroupManager> InstanceGroupManagers { get; set; }

        /// <summary>
        /// [Output Only] The warning that replaces the list of managed instance groups when the list is empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] The warning that replaces the list of managed instance groups when the list is empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class InstanceGroupManagersSetInstanceTemplateRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The URL of the instance template that is specified for this managed instance group. The group uses this
        /// template to create all new instances in the managed instance group. The templates for existing instances in
        /// the group do not change unless you run recreateInstances, run applyUpdatesToInstances, or set the group's
        /// updatePolicy.type to PROACTIVE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceTemplate")]
        public virtual string InstanceTemplate { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupManagersSetTargetPoolsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The fingerprint of the target pools information. Use this optional property to prevent conflicts when
        /// multiple users change the target pools settings concurrently. Obtain the fingerprint with the
        /// instanceGroupManagers.get method. Then, include the fingerprint in your request to ensure that you do not
        /// overwrite changes that were applied from another concurrent request.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// The list of target pool URLs that instances in this managed instance group belong to. The managed instance
        /// group applies these target pools to all of the instances in the group. Existing instances and new instances
        /// in the group all receive these target pool settings.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetPools")]
        public virtual System.Collections.Generic.IList<string> TargetPools { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>InstanceGroupManagers.updatePerInstanceConfigs</summary>
    public class InstanceGroupManagersUpdatePerInstanceConfigsReq : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The list of per-instance configs to insert or patch on this managed instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("perInstanceConfigs")]
        public virtual System.Collections.Generic.IList<PerInstanceConfig> PerInstanceConfigs { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupsAddInstancesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The list of instances to add to the instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<InstanceReference> Instances { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupsListInstances : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of InstanceWithNamedPorts resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<InstanceWithNamedPorts> Items { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute#instanceGroupsListInstances for the list of
        /// instances in the specified instance group.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class InstanceGroupsListInstancesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// A filter for the state of the instances in the instance group. Valid options are ALL or RUNNING. If you do
        /// not specify this parameter the list includes all instances regardless of their state.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceState")]
        public virtual string InstanceState { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupsRemoveInstancesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The list of instances to remove from the instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<InstanceReference> Instances { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceGroupsScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The list of instance groups that are contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceGroups")]
        public virtual System.Collections.Generic.IList<InstanceGroup> InstanceGroups { get; set; }

        /// <summary>
        /// [Output Only] An informational warning that replaces the list of instance groups when the list is empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] An informational warning that replaces the list of instance groups when the list is empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class InstanceGroupsSetNamedPortsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The fingerprint of the named ports information for this instance group. Use this optional property to
        /// prevent conflicts when multiple users change the named ports settings concurrently. Obtain the fingerprint
        /// with the instanceGroups.get method. Then, include the fingerprint in your request to ensure that you do not
        /// overwrite changes that were applied from another concurrent request. A request with an incorrect fingerprint
        /// will fail with error 412 conditionNotMet.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>The list of named ports to set for this instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("namedPorts")]
        public virtual System.Collections.Generic.IList<NamedPort> NamedPorts { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of instances.</summary>
    public class InstanceList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Instance resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Instance> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#instanceList for lists of Instance resources.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of instance referrers.</summary>
    public class InstanceListReferrers : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Reference resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Reference> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#instanceListReferrers for lists of Instance referrers.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class InstanceManagedByIgmError : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Contents of the error.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("error")]
        public virtual InstanceManagedByIgmErrorManagedInstanceError Error { get; set; }

        /// <summary>
        /// [Output Only] Details of the instance action that triggered this error. May be null, if the error was not
        /// caused by an action on an instance. This field is optional.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceActionDetails")]
        public virtual InstanceManagedByIgmErrorInstanceActionDetails InstanceActionDetails { get; set; }

        /// <summary>[Output Only] The time that this error occurred. This value is in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("timestamp")]
        public virtual string Timestamp { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceManagedByIgmErrorInstanceActionDetails : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] Action that managed instance group was executing on the instance when the error occurred.
        /// Possible values:
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("action")]
        public virtual string Action { get; set; }

        /// <summary>
        /// [Output Only] The URL of the instance. The URL can be set even if the instance has not yet been created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instance")]
        public virtual string Instance { get; set; }

        /// <summary>
        /// [Output Only] Version this instance was created from, or was being created from, but the creation failed.
        /// Corresponds to one of the versions that were set on the Instance Group Manager resource at the time this
        /// instance was being created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("version")]
        public virtual ManagedInstanceVersion Version { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceManagedByIgmErrorManagedInstanceError : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Error code.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("code")]
        public virtual string Code { get; set; }

        /// <summary>[Output Only] Error message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("message")]
        public virtual string Message { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceMoveRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The URL of the destination zone to move the instance. This can be a full or partial URL. For example, the
        /// following are all valid URLs to a zone:   -
        /// https://www.googleapis.com/compute/v1/projects/project/zones/zone  - projects/project/zones/zone  -
        /// zones/zone
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("destinationZone")]
        public virtual string DestinationZone { get; set; }

        /// <summary>
        /// The URL of the target instance to move. This can be a full or partial URL. For example, the following are
        /// all valid URLs to an instance:   -
        /// https://www.googleapis.com/compute/v1/projects/project/zones/zone/instances/instance  -
        /// projects/project/zones/zone/instances/instance  - zones/zone/instances/instance
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetInstance")]
        public virtual string TargetInstance { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary></summary>
    public class InstanceProperties : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Controls for advanced machine-related behavior features.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("advancedMachineFeatures")]
        public virtual AdvancedMachineFeatures AdvancedMachineFeatures { get; set; }

        /// <summary>
        /// Enables instances created based on these properties to send packets with source IP addresses other than
        /// their own and receive packets with destination IP addresses other than their own. If these instances will be
        /// used as an IP gateway or it will be set as the next-hop in a Route resource, specify true. If unsure, leave
        /// this set to false. See the Enable IP forwarding documentation for more information.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("canIpForward")]
        public virtual System.Nullable<bool> CanIpForward { get; set; }

        /// <summary>Specifies the Confidential Instance options.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("confidentialInstanceConfig")]
        public virtual ConfidentialInstanceConfig ConfidentialInstanceConfig { get; set; }

        /// <summary>An optional text description for the instances that are created from these properties.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// An array of disks that are associated with the instances that are created from these properties.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("disks")]
        public virtual System.Collections.Generic.IList<AttachedDisk> Disks { get; set; }

        /// <summary>
        /// A list of guest accelerator cards' type and count to use for instances created from these properties.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("guestAccelerators")]
        public virtual System.Collections.Generic.IList<AcceleratorConfig> GuestAccelerators { get; set; }

        /// <summary>Labels to apply to instances that are created from these properties.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>The machine type to use for instances that are created from these properties.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("machineType")]
        public virtual string MachineType { get; set; }

        /// <summary>
        /// The metadata key/value pairs to assign to instances that are created from these properties. These pairs can
        /// consist of custom metadata or predefined keys. See Project and instance metadata for more information.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("metadata")]
        public virtual Metadata Metadata { get; set; }

        /// <summary>
        /// Minimum cpu/platform to be used by instances. The instance may be scheduled on the specified or newer
        /// cpu/platform. Applicable values are the friendly names of CPU platforms, such as minCpuPlatform: "Intel
        /// Haswell" or minCpuPlatform: "Intel Sandy Bridge". For more information, read Specifying a Minimum CPU
        /// Platform.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minCpuPlatform")]
        public virtual string MinCpuPlatform { get; set; }

        /// <summary>An array of network access configurations for this interface.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkInterfaces")]
        public virtual System.Collections.Generic.IList<NetworkInterface> NetworkInterfaces { get; set; }

        /// <summary>PostKeyRevocationActionType of the instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("postKeyRevocationActionType")]
        public virtual string PostKeyRevocationActionType { get; set; }

        /// <summary>
        /// The private IPv6 google access type for VMs. If not specified, use  INHERIT_FROM_SUBNETWORK as default.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("privateIpv6GoogleAccess")]
        public virtual string PrivateIpv6GoogleAccess { get; set; }

        /// <summary>Specifies the reservations that instances can consume from.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("reservationAffinity")]
        public virtual ReservationAffinity ReservationAffinity { get; set; }

        /// <summary>Resource policies (names, not ULRs) applied to instances created from these properties.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resourcePolicies")]
        public virtual System.Collections.Generic.IList<string> ResourcePolicies { get; set; }

        /// <summary>
        /// Specifies the scheduling options for the instances that are created from these properties.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("scheduling")]
        public virtual Scheduling Scheduling { get; set; }

        /// <summary>
        /// A list of service accounts with specified scopes. Access tokens for these service accounts are available to
        /// the instances that are created from these properties. Use metadata queries to obtain the access tokens for
        /// these instances.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("serviceAccounts")]
        public virtual System.Collections.Generic.IList<ServiceAccount> ServiceAccounts { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("shieldedInstanceConfig")]
        public virtual ShieldedInstanceConfig ShieldedInstanceConfig { get; set; }

        /// <summary>
        /// A list of tags to apply to the instances that are created from these properties. The tags identify valid
        /// sources or targets for network firewalls. The setTags method can modify this list of tags. Each tag within
        /// the list must comply with RFC1035.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("tags")]
        public virtual Tags Tags { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstanceReference : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The URL for a specific instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instance")]
        public virtual string Instance { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents an Instance Template resource.  You can use instance templates to create VM instances and managed
    /// instance groups. For more information, read Instance Templates. (== resource_for
    /// {$api_version}.instanceTemplates ==)
    /// </summary>
    public class InstanceTemplate : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The creation timestamp for this instance template in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] A unique identifier for this instance template. The server defines this identifier.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute#instanceTemplate for instance templates.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource; provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The instance properties for this instance template.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("properties")]
        public virtual InstanceProperties Properties { get; set; }

        /// <summary>[Output Only] The URL for this instance template. The server defines this URL.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// The source instance used to create the template. You can provide this as a partial or full URL to the
        /// resource. For example, the following are valid values:   -
        /// https://www.googleapis.com/compute/v1/projects/project/zones/zone/instances/instance  -
        /// projects/project/zones/zone/instances/instance
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceInstance")]
        public virtual string SourceInstance { get; set; }

        /// <summary>The source instance params to use to create this instance template.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceInstanceParams")]
        public virtual SourceInstanceParams SourceInstanceParams { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A list of instance templates.</summary>
    public class InstanceTemplateList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of InstanceTemplate resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<InstanceTemplate> Items { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute#instanceTemplatesListResponse for instance template
        /// lists.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class InstanceWithNamedPorts : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The URL of the instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instance")]
        public virtual string Instance { get; set; }

        /// <summary>[Output Only] The named ports that belong to this instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("namedPorts")]
        public virtual System.Collections.Generic.IList<NamedPort> NamedPorts { get; set; }

        /// <summary>[Output Only] The status of the instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstancesAddResourcePoliciesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Resource policies to be added to this instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resourcePolicies")]
        public virtual System.Collections.Generic.IList<string> ResourcePolicies { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstancesGetEffectiveFirewallsResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Effective firewalls from firewall policies.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("firewallPolicys")]
        public virtual System.Collections.Generic.IList<InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy> FirewallPolicys { get; set; }

        /// <summary>Effective firewalls on the instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("firewalls")]
        public virtual System.Collections.Generic.IList<Firewall> Firewalls { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The display name of the firewall policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("displayName")]
        public virtual string DisplayName { get; set; }

        /// <summary>[Output Only] The name of the firewall policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The rules that apply to the network.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("rules")]
        public virtual System.Collections.Generic.IList<FirewallPolicyRule> Rules { get; set; }

        /// <summary>[Output Only] The type of the firewall policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstancesRemoveResourcePoliciesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Resource policies to be removed from this instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resourcePolicies")]
        public virtual System.Collections.Generic.IList<string> ResourcePolicies { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstancesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of instances contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<Instance> Instances { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of instances when the list is empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of instances when the list is empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class InstancesSetLabelsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Fingerprint of the previous set of labels for this resource, used to prevent conflicts. Provide the latest
        /// fingerprint value when making a request to add or change labels.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labelFingerprint")]
        public virtual string LabelFingerprint { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstancesSetMachineResourcesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of the type and count of accelerator cards attached to the instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("guestAccelerators")]
        public virtual System.Collections.Generic.IList<AcceleratorConfig> GuestAccelerators { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstancesSetMachineTypeRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Full or partial URL of the machine type resource. See Machine Types for a full list of machine types. For
        /// example: zones/us-central1-f/machineTypes/n1-standard-1
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("machineType")]
        public virtual string MachineType { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstancesSetMinCpuPlatformRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Minimum cpu/platform this instance should be started at.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minCpuPlatform")]
        public virtual string MinCpuPlatform { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstancesSetServiceAccountRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Email address of the service account.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("email")]
        public virtual string Email { get; set; }

        /// <summary>The list of scopes to be made available for this service account.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("scopes")]
        public virtual System.Collections.Generic.IList<string> Scopes { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InstancesStartWithEncryptionKeyRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Array of disks associated with this instance that are protected with a customer-supplied encryption key.  In
        /// order to start the instance, the disk url and its corresponding key must be provided.  If the disk is not
        /// protected with a customer-supplied encryption key it should not be specified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("disks")]
        public virtual System.Collections.Generic.IList<CustomerEncryptionKeyProtectedDisk> Disks { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// HttpRouteRuleMatch criteria for field values that must stay within the specified integer range.
    /// </summary>
    public class Int64RangeMatch : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The end of the range (exclusive) in signed long integer format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("rangeEnd")]
        public virtual System.Nullable<long> RangeEnd { get; set; }

        /// <summary>The start of the range (inclusive) in signed long integer format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("rangeStart")]
        public virtual System.Nullable<long> RangeStart { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents an Interconnect resource.  An Interconnect resource is a dedicated connection between the GCP network
    /// and your on-premises network. For more information, read the  Dedicated Interconnect Overview. (== resource_for
    /// {$api_version}.interconnects ==)
    /// </summary>
    public class Interconnect : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Administrative status of the interconnect. When this is set to true, the Interconnect is functional and can
        /// carry traffic. When set to false, no packets can be carried over the interconnect and no BGP routes are
        /// exchanged over it. By default, the status is set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("adminEnabled")]
        public virtual System.Nullable<bool> AdminEnabled { get; set; }

        /// <summary>
        /// [Output Only] A list of CircuitInfo objects, that describe the individual circuits in this LAG.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("circuitInfos")]
        public virtual System.Collections.Generic.IList<InterconnectCircuitInfo> CircuitInfos { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// Customer name, to put in the Letter of Authorization as the party authorized to request a crossconnect.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("customerName")]
        public virtual string CustomerName { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>[Output Only] A list of outages expected for this Interconnect.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("expectedOutages")]
        public virtual System.Collections.Generic.IList<InterconnectOutageNotification> ExpectedOutages { get; set; }

        /// <summary>
        /// [Output Only] IP address configured on the Google side of the Interconnect link. This can be used only for
        /// ping tests.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("googleIpAddress")]
        public virtual string GoogleIpAddress { get; set; }

        /// <summary>
        /// [Output Only] Google reference ID to be used when raising support tickets with Google or otherwise to debug
        /// backend connectivity issues.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("googleReferenceId")]
        public virtual string GoogleReferenceId { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// [Output Only] A list of the URLs of all InterconnectAttachments configured to use this Interconnect.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("interconnectAttachments")]
        public virtual System.Collections.Generic.IList<string> InterconnectAttachments { get; set; }

        /// <summary>
        /// Type of interconnect, which can take one of the following values:  - PARTNER: A partner-managed
        /// interconnection shared between customers though a partner.  - DEDICATED: A dedicated physical
        /// interconnection with the customer. Note that a value IT_PRIVATE has been deprecated in favor of DEDICATED.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("interconnectType")]
        public virtual string InterconnectType { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#interconnect for interconnects.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Type of link requested, which can take one of the following values:  - LINK_TYPE_ETHERNET_10G_LR: A 10G
        /// Ethernet with LR optics  - LINK_TYPE_ETHERNET_100G_LR: A 100G Ethernet with LR optics. Note that this field
        /// indicates the speed of each of the links in the bundle, not the speed of the entire bundle.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("linkType")]
        public virtual string LinkType { get; set; }

        /// <summary>
        /// URL of the InterconnectLocation object that represents where this connection is to be provisioned.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("location")]
        public virtual string Location { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// Email address to contact the customer NOC for operations and maintenance notifications regarding this
        /// Interconnect. If specified, this will be used for notifications in addition to all other forms described,
        /// such as Stackdriver logs alerting and Cloud Notifications.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nocContactEmail")]
        public virtual string NocContactEmail { get; set; }

        /// <summary>
        /// [Output Only] The current status of this Interconnect's functionality, which can take one of the following
        /// values:  - OS_ACTIVE: A valid Interconnect, which is turned up and is ready to use. Attachments may be
        /// provisioned on this Interconnect.  - OS_UNPROVISIONED: An Interconnect that has not completed turnup. No
        /// attachments may be provisioned on this Interconnect.  - OS_UNDER_MAINTENANCE: An Interconnect that is
        /// undergoing internal maintenance. No attachments may be provisioned or updated on this Interconnect.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("operationalStatus")]
        public virtual string OperationalStatus { get; set; }

        /// <summary>
        /// [Output Only] IP address configured on the customer side of the Interconnect link. The customer should
        /// configure this IP address during turnup when prompted by Google NOC. This can be used only for ping tests.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerIpAddress")]
        public virtual string PeerIpAddress { get; set; }

        /// <summary>[Output Only] Number of links actually provisioned in this interconnect.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("provisionedLinkCount")]
        public virtual System.Nullable<int> ProvisionedLinkCount { get; set; }

        /// <summary>Target number of physical links in the link bundle, as requested by the customer.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("requestedLinkCount")]
        public virtual System.Nullable<int> RequestedLinkCount { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// [Output Only] The current state of Interconnect functionality, which can take one of the following values:
        /// - ACTIVE: The Interconnect is valid, turned up and ready to use. Attachments may be provisioned on this
        /// Interconnect.  - UNPROVISIONED: The Interconnect has not completed turnup. No attachments may be provisioned
        /// on this Interconnect.  - UNDER_MAINTENANCE: The Interconnect is undergoing internal maintenance. No
        /// attachments may be provisioned or updated on this Interconnect.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("state")]
        public virtual string State { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents an Interconnect Attachment (VLAN) resource.  You can use Interconnect attachments (VLANS) to connect
    /// your Virtual Private Cloud networks to your on-premises networks through an Interconnect. For more information,
    /// read  Creating VLAN Attachments. (== resource_for {$api_version}.interconnectAttachments ==)
    /// </summary>
    public class InterconnectAttachment : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Determines whether this Attachment will carry packets. Not present for PARTNER_PROVIDER.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("adminEnabled")]
        public virtual System.Nullable<bool> AdminEnabled { get; set; }

        /// <summary>
        /// Provisioned bandwidth capacity for the interconnect attachment. For attachments of type DEDICATED, the user
        /// can set the bandwidth. For attachments of type PARTNER, the Google Partner that is operating the
        /// interconnect must set the bandwidth. Output only for PARTNER type, mutable for PARTNER_PROVIDER and
        /// DEDICATED, and can take one of the following values:  - BPS_50M: 50 Mbit/s  - BPS_100M: 100 Mbit/s  -
        /// BPS_200M: 200 Mbit/s  - BPS_300M: 300 Mbit/s  - BPS_400M: 400 Mbit/s  - BPS_500M: 500 Mbit/s  - BPS_1G: 1
        /// Gbit/s  - BPS_2G: 2 Gbit/s  - BPS_5G: 5 Gbit/s  - BPS_10G: 10 Gbit/s  - BPS_20G: 20 Gbit/s  - BPS_50G: 50
        /// Gbit/s
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("bandwidth")]
        public virtual string Bandwidth { get; set; }

        /// <summary>
        /// Up to 16 candidate prefixes that can be used to restrict the allocation of cloudRouterIpAddress and
        /// customerRouterIpAddress for this attachment. All prefixes must be within link-local address space
        /// (169.254.0.0/16) and must be /29 or shorter (/28, /27, etc). Google will attempt to select an unused /29
        /// from the supplied candidate prefix(es). The request will fail if all possible /29s are in use on Google's
        /// edge. If not supplied, Google will randomly select an unused /29 from all of link-local space.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("candidateSubnets")]
        public virtual System.Collections.Generic.IList<string> CandidateSubnets { get; set; }

        /// <summary>
        /// [Output Only] IPv4 address + prefix length to be configured on Cloud Router Interface for this interconnect
        /// attachment.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cloudRouterIpAddress")]
        public virtual string CloudRouterIpAddress { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// [Output Only] IPv4 address + prefix length to be configured on the customer router subinterface for this
        /// interconnect attachment.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("customerRouterIpAddress")]
        public virtual string CustomerRouterIpAddress { get; set; }

        /// <summary>[Output Only] Dataplane version for this InterconnectAttachment.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("dataplaneVersion")]
        public virtual System.Nullable<int> DataplaneVersion { get; set; }

        /// <summary>An optional description of this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Desired availability domain for the attachment. Only available for type PARTNER, at creation time, and can
        /// take one of the following values:  - AVAILABILITY_DOMAIN_ANY  - AVAILABILITY_DOMAIN_1  -
        /// AVAILABILITY_DOMAIN_2 For improved reliability, customers should configure a pair of attachments, one per
        /// availability domain. The selected availability domain will be provided to the Partner via the pairing key,
        /// so that the provisioned circuit will lie in the specified domain. If not specified, the value will default
        /// to AVAILABILITY_DOMAIN_ANY.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("edgeAvailabilityDomain")]
        public virtual string EdgeAvailabilityDomain { get; set; }

        /// <summary>
        /// [Output Only] Google reference ID, to be used when raising support tickets with Google or otherwise to debug
        /// backend connectivity issues. [Deprecated] This field is not used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("googleReferenceId")]
        public virtual string GoogleReferenceId { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// URL of the underlying Interconnect object that this attachment's traffic will traverse through.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("interconnect")]
        public virtual string Interconnect { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#interconnectAttachment for interconnect attachments.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Maximum Transmission Unit (MTU), in bytes, of packets passing through this interconnect attachment. Only
        /// 1440 and 1500 are allowed. If not specified, the value will default to 1440.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("mtu")]
        public virtual System.Nullable<int> Mtu { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// [Output Only] The current status of whether or not this interconnect attachment is functional, which can
        /// take one of the following values:  - OS_ACTIVE: The attachment has been turned up and is ready to use.  -
        /// OS_UNPROVISIONED: The attachment is not ready to use yet, because turnup is not complete.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("operationalStatus")]
        public virtual string OperationalStatus { get; set; }

        /// <summary>
        /// [Output only for type PARTNER. Input only for PARTNER_PROVIDER. Not present for DEDICATED]. The opaque
        /// identifier of an PARTNER attachment used to initiate provisioning with a selected partner. Of the form
        /// "XXXXX/region/domain"
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("pairingKey")]
        public virtual string PairingKey { get; set; }

        /// <summary>
        /// Optional BGP ASN for the router supplied by a Layer 3 Partner if they configured BGP on behalf of the
        /// customer. Output only for PARTNER type, input only for PARTNER_PROVIDER, not available for DEDICATED.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("partnerAsn")]
        public virtual System.Nullable<long> PartnerAsn { get; set; }

        /// <summary>
        /// Informational metadata about Partner attachments from Partners to display to customers. Output only for for
        /// PARTNER type, mutable for PARTNER_PROVIDER, not available for DEDICATED.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("partnerMetadata")]
        public virtual InterconnectAttachmentPartnerMetadata PartnerMetadata { get; set; }

        /// <summary>
        /// [Output Only] Information specific to an InterconnectAttachment. This property is populated if the
        /// interconnect that this is attached to is of type DEDICATED.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("privateInterconnectInfo")]
        public virtual InterconnectAttachmentPrivateInfo PrivateInterconnectInfo { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the regional interconnect attachment resides. You must specify this
        /// field as part of the HTTP request URL. It is not settable as a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>
        /// URL of the Cloud Router to be used for dynamic routing. This router must be in the same region as this
        /// InterconnectAttachment. The InterconnectAttachment will automatically connect the Interconnect to the
        /// network &amp;amp; region within which the Cloud Router is configured.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("router")]
        public virtual string Router { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// [Output Only] The current state of this attachment's functionality. Enum values ACTIVE and UNPROVISIONED are
        /// shared by DEDICATED/PRIVATE, PARTNER, and PARTNER_PROVIDER interconnect attachments, while enum values
        /// PENDING_PARTNER, PARTNER_REQUEST_RECEIVED, and PENDING_CUSTOMER are used for only PARTNER and
        /// PARTNER_PROVIDER interconnect attachments. This state can take one of the following values:  - ACTIVE: The
        /// attachment has been turned up and is ready to use.  - UNPROVISIONED: The attachment is not ready to use yet,
        /// because turnup is not complete.  - PENDING_PARTNER: A newly-created PARTNER attachment that has not yet been
        /// configured on the Partner side.  - PARTNER_REQUEST_RECEIVED: A PARTNER attachment is in the process of
        /// provisioning after a PARTNER_PROVIDER attachment was created that references it.  - PENDING_CUSTOMER: A
        /// PARTNER or PARTNER_PROVIDER attachment that is waiting for a customer to activate it.  - DEFUNCT: The
        /// attachment was deleted externally and is no longer functional. This could be because the associated
        /// Interconnect was removed, or because the other side of a Partner attachment was deleted.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("state")]
        public virtual string State { get; set; }

        /// <summary>
        /// The type of interconnect attachment this is, which can take one of the following values:  - DEDICATED: an
        /// attachment to a Dedicated Interconnect.  - PARTNER: an attachment to a Partner Interconnect, created by the
        /// customer.  - PARTNER_PROVIDER: an attachment to a Partner Interconnect, created by the partner.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>
        /// The IEEE 802.1Q VLAN tag for this attachment, in the range 2-4094. Only specified at creation time.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("vlanTag8021q")]
        public virtual System.Nullable<int> VlanTag8021q { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InterconnectAttachmentAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of InterconnectAttachmentsScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, InterconnectAttachmentsScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#interconnectAttachmentAggregatedList for aggregated lists of
        /// interconnect attachments.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Response to the list request, and contains a list of interconnect attachments.</summary>
    public class InterconnectAttachmentList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of InterconnectAttachment resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<InterconnectAttachment> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#interconnectAttachmentList for lists of interconnect
        /// attachments.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Informational metadata about Partner attachments from Partners to display to customers. These fields are
    /// propagated from PARTNER_PROVIDER attachments to their corresponding PARTNER attachments.
    /// </summary>
    public class InterconnectAttachmentPartnerMetadata : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Plain text name of the Interconnect this attachment is connected to, as displayed in the Partner's portal.
        /// For instance "Chicago 1". This value may be validated to match approved Partner values.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("interconnectName")]
        public virtual string InterconnectName { get; set; }

        /// <summary>
        /// Plain text name of the Partner providing this attachment. This value may be validated to match approved
        /// Partner values.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("partnerName")]
        public virtual string PartnerName { get; set; }

        /// <summary>
        /// URL of the Partner's portal for this Attachment. Partners may customise this to be a deep link to the
        /// specific resource on the Partner portal. This value may be validated to match approved Partner values.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portalUrl")]
        public virtual string PortalUrl { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Information for an interconnect attachment when this belongs to an interconnect of type DEDICATED.
    /// </summary>
    public class InterconnectAttachmentPrivateInfo : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] 802.1q encapsulation tag to be used for traffic between Google and the customer, going to and
        /// from this network and region.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("tag8021q")]
        public virtual System.Nullable<long> Tag8021q { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InterconnectAttachmentsScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of interconnect attachments contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("interconnectAttachments")]
        public virtual System.Collections.Generic.IList<InterconnectAttachment> InterconnectAttachments { get; set; }

        /// <summary>Informational warning which replaces the list of addresses when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of addresses when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Describes a single physical circuit between the Customer and Google. CircuitInfo objects are created by Google,
    /// so all fields are output only.
    /// </summary>
    public class InterconnectCircuitInfo : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Customer-side demarc ID for this circuit.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("customerDemarcId")]
        public virtual string CustomerDemarcId { get; set; }

        /// <summary>Google-assigned unique ID for this circuit. Assigned at circuit turn-up.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("googleCircuitId")]
        public virtual string GoogleCircuitId { get; set; }

        /// <summary>
        /// Google-side demarc ID for this circuit. Assigned at circuit turn-up and provided by Google to the customer
        /// in the LOA.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("googleDemarcId")]
        public virtual string GoogleDemarcId { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Diagnostics information about interconnect, contains detailed and current technical information about Google's
    /// side of the connection.
    /// </summary>
    public class InterconnectDiagnostics : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// A list of InterconnectDiagnostics.ARPEntry objects, describing individual neighbors currently seen by the
        /// Google router in the ARP cache for the Interconnect. This will be empty when the Interconnect is not
        /// bundled.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("arpCaches")]
        public virtual System.Collections.Generic.IList<InterconnectDiagnosticsARPEntry> ArpCaches { get; set; }

        /// <summary>
        /// A list of InterconnectDiagnostics.LinkStatus objects, describing the status for each link on the
        /// Interconnect.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("links")]
        public virtual System.Collections.Generic.IList<InterconnectDiagnosticsLinkStatus> Links { get; set; }

        /// <summary>The MAC address of the Interconnect's bundle interface.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("macAddress")]
        public virtual string MacAddress { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Describing the ARP neighbor entries seen on this link</summary>
    public class InterconnectDiagnosticsARPEntry : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The IP address of this ARP neighbor.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipAddress")]
        public virtual string IpAddress { get; set; }

        /// <summary>The MAC address of this ARP neighbor.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("macAddress")]
        public virtual string MacAddress { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InterconnectDiagnosticsLinkLACPStatus : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>System ID of the port on Google's side of the LACP exchange.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("googleSystemId")]
        public virtual string GoogleSystemId { get; set; }

        /// <summary>System ID of the port on the neighbor's side of the LACP exchange.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("neighborSystemId")]
        public virtual string NeighborSystemId { get; set; }

        /// <summary>
        /// The state of a LACP link, which can take one of the following values:  - ACTIVE: The link is configured and
        /// active within the bundle.  - DETACHED: The link is not configured within the bundle. This means that the
        /// rest of the object should be empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("state")]
        public virtual string State { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InterconnectDiagnosticsLinkOpticalPower : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The status of the current value when compared to the warning and alarm levels for the receiving or
        /// transmitting transceiver. Possible states include:   - OK: The value has not crossed a warning threshold.  -
        /// LOW_WARNING: The value has crossed below the low warning threshold.  - HIGH_WARNING: The value has crossed
        /// above the high warning threshold.  - LOW_ALARM: The value has crossed below the low alarm threshold.  -
        /// HIGH_ALARM: The value has crossed above the high alarm threshold.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("state")]
        public virtual string State { get; set; }

        /// <summary>
        /// Value of the current receiving or transmitting optical power, read in dBm. Take a known good optical value,
        /// give it a 10% margin and trigger warnings relative to that value. In general, a -7dBm warning and a -11dBm
        /// alarm are good optical value estimates for most links.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("value")]
        public virtual System.Nullable<float> Value { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class InterconnectDiagnosticsLinkStatus : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// A list of InterconnectDiagnostics.ARPEntry objects, describing the ARP neighbor entries seen on this link.
        /// This will be empty if the link is bundled
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("arpCaches")]
        public virtual System.Collections.Generic.IList<InterconnectDiagnosticsARPEntry> ArpCaches { get; set; }

        /// <summary>The unique ID for this link assigned during turn up by Google.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("circuitId")]
        public virtual string CircuitId { get; set; }

        /// <summary>The Demarc address assigned by Google and provided in the LoA.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("googleDemarc")]
        public virtual string GoogleDemarc { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("lacpStatus")]
        public virtual InterconnectDiagnosticsLinkLACPStatus LacpStatus { get; set; }

        /// <summary>
        /// An InterconnectDiagnostics.LinkOpticalPower object, describing the current value and status of the received
        /// light level.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("receivingOpticalPower")]
        public virtual InterconnectDiagnosticsLinkOpticalPower ReceivingOpticalPower { get; set; }

        /// <summary>
        /// An InterconnectDiagnostics.LinkOpticalPower object, describing the current value and status of the
        /// transmitted light level.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("transmittingOpticalPower")]
        public virtual InterconnectDiagnosticsLinkOpticalPower TransmittingOpticalPower { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Response to the list request, and contains a list of interconnects.</summary>
    public class InterconnectList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Interconnect resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Interconnect> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#interconnectList for lists of interconnects.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents an Interconnect Attachment (VLAN) Location resource.  You can use this resource to find location
    /// details about an Interconnect attachment (VLAN). For more information about interconnect attachments, read
    /// Creating VLAN Attachments.
    /// </summary>
    public class InterconnectLocation : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] The postal address of the Point of Presence, each line in the address is separated by a
        /// newline character.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("address")]
        public virtual string Address { get; set; }

        /// <summary>
        /// [Output Only] Availability zone for this InterconnectLocation. Within a metropolitan area (metro),
        /// maintenance will not be simultaneously scheduled in more than one availability zone. Example: "zone1" or
        /// "zone2".
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("availabilityZone")]
        public virtual string AvailabilityZone { get; set; }

        /// <summary>
        /// [Output Only] Metropolitan area designator that indicates which city an interconnect is located. For
        /// example: "Chicago, IL", "Amsterdam, Netherlands".
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("city")]
        public virtual string City { get; set; }

        /// <summary>
        /// [Output Only] Continent for this location, which can take one of the following values:  - AFRICA  - ASIA_PAC
        ///  - EUROPE  - NORTH_AMERICA  - SOUTH_AMERICA
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("continent")]
        public virtual string Continent { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>[Output Only] An optional description of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>[Output Only] The name of the provider for this facility (e.g., EQUINIX).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("facilityProvider")]
        public virtual string FacilityProvider { get; set; }

        /// <summary>[Output Only] A provider-assigned Identifier for this facility (e.g., Ashburn-DC1).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("facilityProviderFacilityId")]
        public virtual string FacilityProviderFacilityId { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#interconnectLocation for interconnect locations.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>[Output Only] Name of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// [Output Only] The peeringdb identifier for this facility (corresponding with a netfac type in peeringdb).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peeringdbFacilityId")]
        public virtual string PeeringdbFacilityId { get; set; }

        /// <summary>
        /// [Output Only] A list of InterconnectLocation.RegionInfo objects, that describe parameters pertaining to the
        /// relation between this InterconnectLocation and various Google Cloud regions.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("regionInfos")]
        public virtual System.Collections.Generic.IList<InterconnectLocationRegionInfo> RegionInfos { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// [Output Only] The status of this InterconnectLocation, which can take one of the following values:  -
        /// CLOSED: The InterconnectLocation is closed and is unavailable for provisioning new Interconnects.  -
        /// AVAILABLE: The InterconnectLocation is available for provisioning new Interconnects.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Response to the list request, and contains a list of interconnect locations.</summary>
    public class InterconnectLocationList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of InterconnectLocation resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<InterconnectLocation> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#interconnectLocationList for lists of interconnect locations.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Information about any potential InterconnectAttachments between an Interconnect at a specific
    /// InterconnectLocation, and a specific Cloud Region.
    /// </summary>
    public class InterconnectLocationRegionInfo : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Expected round-trip time in milliseconds, from this InterconnectLocation to a VM in this region.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("expectedRttMs")]
        public virtual System.Nullable<long> ExpectedRttMs { get; set; }

        /// <summary>Identifies the network presence of this location.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("locationPresence")]
        public virtual string LocationPresence { get; set; }

        /// <summary>URL for the region of this location.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Description of a planned outage on this Interconnect.</summary>
    public class InterconnectOutageNotification : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// If issue_type is IT_PARTIAL_OUTAGE, a list of the Google-side circuit IDs that will be affected.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("affectedCircuits")]
        public virtual System.Collections.Generic.IList<string> AffectedCircuits { get; set; }

        /// <summary>A description about the purpose of the outage.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>Scheduled end time for the outage (milliseconds since Unix epoch).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("endTime")]
        public virtual System.Nullable<long> EndTime { get; set; }

        /// <summary>
        /// Form this outage is expected to take, which can take one of the following values:  - OUTAGE: The
        /// Interconnect may be completely out of service for some or all of the specified window.  - PARTIAL_OUTAGE:
        /// Some circuits comprising the Interconnect as a whole should remain up, but with reduced bandwidth. Note that
        /// the versions of this enum prefixed with "IT_" have been deprecated in favor of the unprefixed values.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("issueType")]
        public virtual string IssueType { get; set; }

        /// <summary>Unique identifier for this outage notification.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// The party that generated this notification, which can take the following value:  - GOOGLE: this notification
        /// as generated by Google. Note that the value of NSRC_GOOGLE has been deprecated in favor of GOOGLE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("source")]
        public virtual string Source { get; set; }

        /// <summary>Scheduled start time for the outage (milliseconds since Unix epoch).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("startTime")]
        public virtual System.Nullable<long> StartTime { get; set; }

        /// <summary>
        /// State of this notification, which can take one of the following values:  - ACTIVE: This outage notification
        /// is active. The event could be in the past, present, or future. See start_time and end_time for scheduling.
        /// - CANCELLED: The outage associated with this notification was cancelled before the outage was due to start.
        /// Note that the versions of this enum prefixed with "NS_" have been deprecated in favor of the unprefixed
        /// values.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("state")]
        public virtual string State { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Response for the InterconnectsGetDiagnosticsRequest.</summary>
    public class InterconnectsGetDiagnosticsResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("result")]
        public virtual InterconnectDiagnostics Result { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a License resource.  A License represents billing and aggregate usage data for public and marketplace
    /// images.  Caution This resource is intended for use only by third-party partners who are creating Cloud
    /// Marketplace images. (== resource_for {$api_version}.licenses ==)
    /// </summary>
    public class License : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] Deprecated. This field no longer reflects whether a license charges a usage fee.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("chargesUseFee")]
        public virtual System.Nullable<bool> ChargesUseFee { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional textual description of the resource; provided by the client when the resource is created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#license for licenses.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] The unique code used to attach this license to images, snapshots, and disks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("licenseCode")]
        public virtual System.Nullable<ulong> LicenseCode { get; set; }

        /// <summary>Name of the resource. The name must be 1-63 characters long and comply with RFC1035.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("resourceRequirements")]
        public virtual LicenseResourceRequirements ResourceRequirements { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// If false, licenses will not be copied from the source resource when creating an image from a disk, disk from
        /// snapshot, or snapshot from disk.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("transferable")]
        public virtual System.Nullable<bool> Transferable { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a License Code resource.  A License Code is a unique identifier used to represent a license resource.
    ///  Caution This resource is intended for use only by third-party partners who are creating Cloud Marketplace
    /// images. (== resource_for {$api_version}.licenseCodes ==)
    /// </summary>
    public class LicenseCode : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>[Output Only] Description of this License Code.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#licenseCode for licenses.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>[Output Only] URL and description aliases of Licenses with the same License Code.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("licenseAlias")]
        public virtual System.Collections.Generic.IList<LicenseCodeLicenseAlias> LicenseAlias { get; set; }

        /// <summary>
        /// [Output Only] Name of the resource. The name is 1-20 characters long and must be a valid 64 bit integer.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Current state of this License Code.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("state")]
        public virtual string State { get; set; }

        /// <summary>
        /// [Output Only] If true, the license will remain attached when creating images or snapshots from disks.
        /// Otherwise, the license is not transferred.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("transferable")]
        public virtual System.Nullable<bool> Transferable { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class LicenseCodeLicenseAlias : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Description of this License Code.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>[Output Only] URL of license corresponding to this License Code.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Commitment for a particular license resource.</summary>
    public class LicenseResourceCommitment : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The number of licenses purchased.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("amount")]
        public virtual System.Nullable<long> Amount { get; set; }

        /// <summary>Specifies the core range of the instance for which this license applies.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("coresPerLicense")]
        public virtual string CoresPerLicense { get; set; }

        /// <summary>Any applicable license URI.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("license")]
        public virtual string License { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class LicenseResourceRequirements : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Minimum number of guest cpus required to use the Instance. Enforced at Instance creation and Instance start.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minGuestCpuCount")]
        public virtual System.Nullable<int> MinGuestCpuCount { get; set; }

        /// <summary>
        /// Minimum memory required to use the Instance. Enforced at Instance creation and Instance start.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minMemoryMb")]
        public virtual System.Nullable<int> MinMemoryMb { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class LicensesListResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of License resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<License> Items { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class LocalDisk : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Specifies the number of such disks.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskCount")]
        public virtual System.Nullable<int> DiskCount { get; set; }

        /// <summary>Specifies the size of the disk in base-2 GB.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskSizeGb")]
        public virtual System.Nullable<int> DiskSizeGb { get; set; }

        /// <summary>
        /// Specifies the desired disk type on the node. This disk type must be a local storage type (e.g.: local-ssd).
        /// Note that for nodeTemplates, this should be the name of the disk type and not its URL.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskType")]
        public virtual string DiskType { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Configuration for location policy among multiple possible locations (e.g. preferences for zone selection among
    /// zones in a single region).
    /// </summary>
    public class LocationPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Location configurations mapped by location name. Currently only zone names are supported and must be
        /// represented as valid internal URLs, like: zones/us-central1-a.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("locations")]
        public virtual System.Collections.Generic.IDictionary<string, LocationPolicyLocation> Locations { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class LocationPolicyLocation : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("preference")]
        public virtual string Preference { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Specifies what kind of log the caller must write</summary>
    public class LogConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Cloud audit options.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cloudAudit")]
        public virtual LogConfigCloudAuditOptions CloudAudit { get; set; }

        /// <summary>Counter options.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("counter")]
        public virtual LogConfigCounterOptions Counter { get; set; }

        /// <summary>Data access options.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("dataAccess")]
        public virtual LogConfigDataAccessOptions DataAccess { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Write a Cloud Audit log</summary>
    public class LogConfigCloudAuditOptions : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Information used by the Cloud Audit Logging pipeline.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("authorizationLoggingOptions")]
        public virtual AuthorizationLoggingOptions AuthorizationLoggingOptions { get; set; }

        /// <summary>The log_name to populate in the Cloud Audit Record.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("logName")]
        public virtual string LogName { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Increment a streamz counter with the specified metric and field names.  Metric names should start with a '/',
    /// generally be lowercase-only, and end in "_count". Field names should not contain an initial slash. The actual
    /// exported metric names will have "/iam/policy" prepended.  Field names correspond to IAM request parameters and
    /// field values are their respective values.  Supported field names: - "authority", which is "[token]" if
    /// IAMContext.token is present, otherwise the value of IAMContext.authority_selector if present, and otherwise a
    /// representation of IAMContext.principal; or - "iam_principal", a representation of IAMContext.principal even if a
    /// token or authority selector is present; or - "" (empty string), resulting in a counter with no fields.
    /// Examples: counter { metric: "/debug_access_count" field: "iam_principal" } ==&amp;gt; increment counter
    /// /iam/policy/debug_access_count {iam_principal=[value of IAMContext.principal]}
    /// </summary>
    public class LogConfigCounterOptions : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Custom fields.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("customFields")]
        public virtual System.Collections.Generic.IList<LogConfigCounterOptionsCustomField> CustomFields { get; set; }

        /// <summary>The field value to attribute.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("field")]
        public virtual string Field { get; set; }

        /// <summary>The metric to update.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("metric")]
        public virtual string Metric { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Custom fields. These can be used to create a counter with arbitrary field/value pairs. See:
    /// go/rpcsp-custom-fields.
    /// </summary>
    public class LogConfigCounterOptionsCustomField : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Name is the field name.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// Value is the field value. It is important that in contrast to the CounterOptions.field, the value here is a
        /// constant that is not derived from the IAMContext.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("value")]
        public virtual string Value { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Write a Data Access (Gin) log</summary>
    public class LogConfigDataAccessOptions : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary></summary>
        [Newtonsoft.Json.JsonPropertyAttribute("logMode")]
        public virtual string LogMode { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Machine Type resource.  You can use specific machine types for your VM instances based on
    /// performance and pricing requirements. For more information, read Machine Types. (== resource_for
    /// {$api_version}.machineTypes ==)
    /// </summary>
    public class MachineType : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of accelerator configurations assigned to this machine type.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("accelerators")]
        public virtual System.Collections.Generic.IList<AcceleratorsData> Accelerators { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// [Output Only] The deprecation status associated with this machine type. Only applicable if the machine type
        /// is unavailable.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("deprecated")]
        public virtual DeprecationStatus Deprecated { get; set; }

        /// <summary>[Output Only] An optional textual description of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>[Output Only] The number of virtual CPUs that are available to the instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("guestCpus")]
        public virtual System.Nullable<int> GuestCpus { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// [Deprecated] This property is deprecated and will never be populated with any relevant values.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("imageSpaceGb")]
        public virtual System.Nullable<int> ImageSpaceGb { get; set; }

        /// <summary>
        /// [Output Only] Whether this machine type has a shared CPU. See Shared-core machine types for more
        /// information.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("isSharedCpu")]
        public virtual System.Nullable<bool> IsSharedCpu { get; set; }

        /// <summary>[Output Only] The type of the resource. Always compute#machineType for machine types.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>[Output Only] Maximum persistent disks allowed.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maximumPersistentDisks")]
        public virtual System.Nullable<int> MaximumPersistentDisks { get; set; }

        /// <summary>[Output Only] Maximum total persistent disks size (GB) allowed.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maximumPersistentDisksSizeGb")]
        public virtual System.Nullable<long> MaximumPersistentDisksSizeGb { get; set; }

        /// <summary>[Output Only] The amount of physical memory available to the instance, defined in MB.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("memoryMb")]
        public virtual System.Nullable<int> MemoryMb { get; set; }

        /// <summary>[Output Only] Name of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] A list of extended scratch disks assigned to the instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("scratchDisks")]
        public virtual System.Collections.Generic.IList<ScratchDisksData> ScratchDisks { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] The name of the zone where the machine type resides, such as us-central1-a.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] A list of accelerator configurations assigned to this machine type.</summary>
        public class AcceleratorsData
        {
            /// <summary>Number of accelerator cards exposed to the guest.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("guestAcceleratorCount")]
            public virtual System.Nullable<int> GuestAcceleratorCount { get; set; }

            /// <summary>The accelerator type resource name, not a full URL, e.g. 'nvidia-tesla-k80'.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("guestAcceleratorType")]
            public virtual string GuestAcceleratorType { get; set; }
        }

        /// <summary>[Output Only] A list of extended scratch disks assigned to the instance.</summary>
        public class ScratchDisksData
        {
            /// <summary>Size of the scratch disk, defined in GB.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("diskGb")]
            public virtual System.Nullable<int> DiskGb { get; set; }
        }
    }

    public class MachineTypeAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of MachineTypesScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, MachineTypesScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#machineTypeAggregatedList for aggregated lists of machine
        /// types.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of machine types.</summary>
    public class MachineTypeList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of MachineType resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<MachineType> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#machineTypeList for lists of machine types.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class MachineTypesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of machine types contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("machineTypes")]
        public virtual System.Collections.Generic.IList<MachineType> MachineTypes { get; set; }

        /// <summary>[Output Only] An informational warning that appears when the machine types list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] An informational warning that appears when the machine types list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>A Managed Instance resource.</summary>
    public class ManagedInstance : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] The current action that the managed instance group has scheduled for the instance. Possible
        /// values:  - NONE The instance is running, and the managed instance group does not have any scheduled actions
        /// for this instance.  - CREATING The managed instance group is creating this instance. If the group fails to
        /// create this instance, it will try again until it is successful.  - CREATING_WITHOUT_RETRIES The managed
        /// instance group is attempting to create this instance only once. If the group fails to create this instance,
        /// it does not try again and the group's targetSize value is decreased instead.  - RECREATING The managed
        /// instance group is recreating this instance.  - DELETING The managed instance group is permanently deleting
        /// this instance.  - ABANDONING The managed instance group is abandoning this instance. The instance will be
        /// removed from the instance group and from any target pools that are associated with this group.  - RESTARTING
        /// The managed instance group is restarting the instance.  - REFRESHING The managed instance group is applying
        /// configuration changes to the instance without stopping it. For example, the group can update the target pool
        /// list for an instance without stopping that instance.  - VERIFYING The managed instance group has created the
        /// instance and it is in the process of being verified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("currentAction")]
        public virtual string CurrentAction { get; set; }

        /// <summary>
        /// [Output only] The unique identifier for this resource. This field is empty when instance does not exist.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// [Output Only] The URL of the instance. The URL can exist even if the instance has not yet been created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instance")]
        public virtual string Instance { get; set; }

        /// <summary>[Output Only] Health state of the instance per health-check.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceHealth")]
        public virtual System.Collections.Generic.IList<ManagedInstanceInstanceHealth> InstanceHealth { get; set; }

        /// <summary>
        /// [Output Only] The status of the instance. This field is empty when the instance does not exist.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceStatus")]
        public virtual string InstanceStatus { get; set; }

        /// <summary>[Output Only] Information about the last attempt to create or delete the instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("lastAttempt")]
        public virtual ManagedInstanceLastAttempt LastAttempt { get; set; }

        /// <summary>[Output Only] Preserved state applied from per-instance config for this instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("preservedStateFromConfig")]
        public virtual PreservedState PreservedStateFromConfig { get; set; }

        /// <summary>[Output Only] Preserved state generated based on stateful policy for this instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("preservedStateFromPolicy")]
        public virtual PreservedState PreservedStateFromPolicy { get; set; }

        /// <summary>[Output Only] Intended version of this instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("version")]
        public virtual ManagedInstanceVersion Version { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ManagedInstanceInstanceHealth : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The current detailed instance health state.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("detailedHealthState")]
        public virtual string DetailedHealthState { get; set; }

        /// <summary>[Output Only] The URL for the health check that verifies whether the instance is healthy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthCheck")]
        public virtual string HealthCheck { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ManagedInstanceLastAttempt : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] Encountered errors during the last attempt to create or delete the instance.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("errors")]
        public virtual ErrorsData Errors { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] Encountered errors during the last attempt to create or delete the instance.
        /// </summary>
        public class ErrorsData
        {
            /// <summary>[Output Only] The array of errors encountered while processing this operation.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("errors")]
            public virtual System.Collections.Generic.IList<ErrorsDataSchema> Errors { get; set; }

            /// <summary>[Output Only] The array of errors encountered while processing this operation.</summary>
            public class ErrorsDataSchema
            {
                /// <summary>[Output Only] The error type identifier for this error.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("code")]
                public virtual string Code { get; set; }

                /// <summary>
                /// [Output Only] Indicates the field in the request that caused the error. This property is optional.
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("location")]
                public virtual string Location { get; set; }

                /// <summary>[Output Only] An optional, human-readable error message.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("message")]
                public virtual string Message { get; set; }
            }
        }
    }

    public class ManagedInstanceVersion : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] The intended template of the instance. This field is empty when current_action is one of {
        /// DELETING, ABANDONING }.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceTemplate")]
        public virtual string InstanceTemplate { get; set; }

        /// <summary>[Output Only] Name of the version.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A metadata key/value entry.</summary>
    public class Metadata : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Specifies a fingerprint for this request, which is essentially a hash of the metadata's contents and used
        /// for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every
        /// request to modify or update metadata. You must always provide an up-to-date fingerprint hash in order to
        /// update or change metadata, otherwise the request will fail with error 412 conditionNotMet.  To see the
        /// latest fingerprint, make a get() request to retrieve the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>Array of key/value pairs. The total size of all keys and values must be less than 512 KB.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<ItemsData> Items { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#metadata for metadata.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Array of key/value pairs. The total size of all keys and values must be less than 512 KB.</summary>
        public class ItemsData
        {
            /// <summary>
            /// Key for the metadata entry. Keys must conform to the following regexp: [a-zA-Z0-9-_]+, and be less than
            /// 128 bytes in length. This is reflected as part of a URL in the metadata server. Additionally, to avoid
            /// ambiguity, keys must not conflict with any other metadata keys for the project.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("key")]
            public virtual string Key { get; set; }

            /// <summary>
            /// Value for the metadata entry. These are free-form strings, and only have meaning as interpreted by the
            /// image running in the instance. The only restriction placed on values is that their size must be less
            /// than or equal to 262144 bytes (256 KiB).
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("value")]
            public virtual string Value { get; set; }
        }
    }

    /// <summary>
    /// Opaque filter criteria used by loadbalancers to restrict routing configuration to a limited set of loadbalancing
    /// proxies. Proxies and sidecars involved in loadbalancing would typically present metadata to the loadbalancers
    /// which need to match criteria specified here. If a match takes place, the relevant configuration is made
    /// available to those proxies. For each metadataFilter in this list, if its filterMatchCriteria is set to
    /// MATCH_ANY, at least one of the filterLabels must match the corresponding label provided in the metadata. If its
    /// filterMatchCriteria is set to MATCH_ALL, then all of its filterLabels must match with corresponding labels
    /// provided in the metadata. An example for using metadataFilters would be: if loadbalancing involves  Envoys, they
    /// will only receive routing configuration when values in metadataFilters match values supplied in &amp;lt;a
    /// href="https://www.envoyproxy.io/docs/envoy/latest/api-v2/api/v2/core/base.proto#envoy-api-msg-core-node" Node
    /// metadata of their XDS requests to loadbalancers.
    /// </summary>
    public class MetadataFilter : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The list of label value pairs that must match labels in the provided metadata based on filterMatchCriteria
        /// This list must not be empty and can have at the most 64 entries.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("filterLabels")]
        public virtual System.Collections.Generic.IList<MetadataFilterLabelMatch> FilterLabels { get; set; }

        /// <summary>
        /// Specifies how individual filterLabel matches within the list of filterLabels contribute towards the overall
        /// metadataFilter match. Supported values are:   - MATCH_ANY: At least one of the filterLabels must have a
        /// matching label in the provided metadata.  - MATCH_ALL: All filterLabels must have matching labels in the
        /// provided metadata.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("filterMatchCriteria")]
        public virtual string FilterMatchCriteria { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// MetadataFilter label name value pairs that are expected to match corresponding labels presented as metadata to
    /// the loadbalancer.
    /// </summary>
    public class MetadataFilterLabelMatch : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Name of metadata label. The name can have a maximum length of 1024 characters and must be at least 1
        /// character long.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// The value of the label must match the specified value. value can have a maximum length of 1024 characters.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("value")]
        public virtual string Value { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>The named port. For example: .</summary>
    public class NamedPort : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The name for this named port. The name must be 1-63 characters long, and comply with RFC1035.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The port number, which can be a value between 1 and 65535.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("port")]
        public virtual System.Nullable<int> Port { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a VPC Network resource.  Networks connect resources to each other and to the internet. For more
    /// information, read Virtual Private Cloud (VPC) Network. (== resource_for {$api_version}.networks ==)
    /// </summary>
    public class Network : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Deprecated in favor of subnet mode networks. The range of internal addresses that are legal on this network.
        /// This range is a CIDR specification, for example: 192.168.0.0/16. Provided by the client when the network is
        /// created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("IPv4Range")]
        public virtual string IPv4Range { get; set; }

        /// <summary>
        /// Must be set to create a VPC network. If not set, a legacy network is created.  When set to true, the VPC
        /// network is created in auto mode. When set to false, the VPC network is created in custom mode.  An auto mode
        /// VPC network starts with one subnet per region. Each subnet has a predetermined range as described in Auto
        /// mode VPC network IP ranges.  For custom mode VPC networks, you can add subnets using the subnetworks insert
        /// method.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoCreateSubnetworks")]
        public virtual System.Nullable<bool> AutoCreateSubnetworks { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this field when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The gateway address for default routing out of the network, selected by GCP.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("gatewayIPv4")]
        public virtual string GatewayIPv4 { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#network for networks.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Maximum Transmission Unit in bytes. The minimum value for this field is 1460 and the maximum value is 1500
        /// bytes.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("mtu")]
        public virtual System.Nullable<int> Mtu { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?`. The first character must be a lowercase letter, and all following
        /// characters (except for the last character) must be a dash, lowercase letter, or digit. The last character
        /// must be a lowercase letter or digit.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] A list of network peerings for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerings")]
        public virtual System.Collections.Generic.IList<NetworkPeering> Peerings { get; set; }

        /// <summary>
        /// The network-level routing configuration for this network. Used by Cloud Router to determine what type of
        /// network-wide routing behavior to enforce.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("routingConfig")]
        public virtual NetworkRoutingConfig RoutingConfig { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// [Output Only] Server-defined fully-qualified URLs for all subnetworks in this VPC network.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("subnetworks")]
        public virtual System.Collections.Generic.IList<string> Subnetworks { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>The network endpoint.</summary>
    public class NetworkEndpoint : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Metadata defined as annotations on the network endpoint.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("annotations")]
        public virtual System.Collections.Generic.IDictionary<string, string> Annotations { get; set; }

        /// <summary>
        /// Optional fully qualified domain name of network endpoint. This can only be specified when
        /// NetworkEndpointGroup.network_endpoint_type is NON_GCP_FQDN_PORT.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fqdn")]
        public virtual string Fqdn { get; set; }

        /// <summary>
        /// The name for a specific VM instance that the IP address belongs to. This is required for network endpoints
        /// of type GCE_VM_IP_PORT. The instance must be in the same zone of network endpoint group.  The name must be
        /// 1-63 characters long, and comply with RFC1035.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instance")]
        public virtual string Instance { get; set; }

        /// <summary>
        /// Optional IPv4 address of network endpoint. The IP address must belong to a VM in Compute Engine (either the
        /// primary IP or as part of an aliased IP range). If the IP address is not specified, then the primary IP
        /// address for the VM instance in the network that the network endpoint group belongs to will be used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipAddress")]
        public virtual string IpAddress { get; set; }

        /// <summary>
        /// Optional port number of network endpoint. If not specified, the defaultPort for the network endpoint group
        /// will be used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("port")]
        public virtual System.Nullable<int> Port { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a collection of network endpoints.  A network endpoint group (NEG) defines how a set of endpoints
    /// should be reached, whether they are reachable, and where they are located. For more information about using
    /// NEGs, see  Setting up external HTTP(S) Load Balancing with internet NEGs,  Setting up zonal NEGs, or  Setting up
    /// external HTTP(S) Load Balancing with serverless NEGs. (== resource_for {$api_version}.networkEndpointGroups ==)
    /// (== resource_for {$api_version}.globalNetworkEndpointGroups ==) (== resource_for
    /// {$api_version}.regionNetworkEndpointGroups ==)
    /// </summary>
    public class NetworkEndpointGroup : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Metadata defined as annotations on the network endpoint group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("annotations")]
        public virtual System.Collections.Generic.IDictionary<string, string> Annotations { get; set; }

        /// <summary>
        /// Only valid when networkEndpointType is "SERVERLESS". Only one of cloudRun, appEngine or cloudFunction may be
        /// set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("appEngine")]
        public virtual NetworkEndpointGroupAppEngine AppEngine { get; set; }

        /// <summary>
        /// Only valid when networkEndpointType is "SERVERLESS". Only one of cloudRun, appEngine or cloudFunction may be
        /// set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cloudFunction")]
        public virtual NetworkEndpointGroupCloudFunction CloudFunction { get; set; }

        /// <summary>
        /// Only valid when networkEndpointType is "SERVERLESS". Only one of cloudRun, appEngine or cloudFunction may be
        /// set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cloudRun")]
        public virtual NetworkEndpointGroupCloudRun CloudRun { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>The default port used if the port number is not specified in the network endpoint.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("defaultPort")]
        public virtual System.Nullable<int> DefaultPort { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#networkEndpointGroup for network endpoint group.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource; provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// The URL of the network to which all network endpoints in the NEG belong. Uses "default" project network if
        /// unspecified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>
        /// Type of network endpoints in this network endpoint group. Can be one of GCE_VM_IP_PORT,
        /// NON_GCP_PRIVATE_IP_PORT, INTERNET_FQDN_PORT, INTERNET_IP_PORT, or SERVERLESS.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkEndpointType")]
        public virtual string NetworkEndpointType { get; set; }

        /// <summary>[Output Only] The URL of the region where the network endpoint group is located.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output only] Number of network endpoints in the network endpoint group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("size")]
        public virtual System.Nullable<int> Size { get; set; }

        /// <summary>Optional URL of the subnetwork to which all network endpoints in the NEG belong.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("subnetwork")]
        public virtual string Subnetwork { get; set; }

        /// <summary>[Output Only] The URL of the zone where the network endpoint group is located.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NetworkEndpointGroupAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of NetworkEndpointGroupsScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, NetworkEndpointGroupsScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute#networkEndpointGroupAggregatedList for aggregated
        /// lists of network endpoint groups.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Configuration for an App Engine network endpoint group (NEG). The service is optional, may be provided
    /// explicitly or in the URL mask. The version is optional and can only be provided explicitly or in the URL mask
    /// when service is present.  Note: App Engine service must be in the same project and located in the same region as
    /// the Serverless NEG.
    /// </summary>
    public class NetworkEndpointGroupAppEngine : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Optional serving service.  The service name is case-sensitive and must be 1-63 characters long.  Example
        /// value: "default", "my-service".
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("service")]
        public virtual string Service { get; set; }

        /// <summary>
        /// A template to parse service and version fields from a request URL. URL mask allows for routing to multiple
        /// App Engine services without having to create multiple Network Endpoint Groups and backend services.  For
        /// example, the request URLs "foo1-dot-appname.appspot.com/v1" and "foo1-dot-appname.appspot.com/v2" can be
        /// backed by the same Serverless NEG with URL mask "-dot-appname.appspot.com/". The URL mask will parse them to
        /// { service = "foo1", version = "v1" } and { service = "foo1", version = "v2" } respectively.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("urlMask")]
        public virtual string UrlMask { get; set; }

        /// <summary>
        /// Optional serving version.  The version name is case-sensitive and must be 1-100 characters long.  Example
        /// value: "v1", "v2".
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("version")]
        public virtual string Version { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Configuration for a Cloud Function network endpoint group (NEG). The function must be provided explicitly or in
    /// the URL mask.  Note: Cloud Function must be in the same project and located in the same region as the Serverless
    /// NEG.
    /// </summary>
    public class NetworkEndpointGroupCloudFunction : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// A user-defined name of the Cloud Function.  The function name is case-sensitive and must be 1-63 characters
        /// long.  Example value: "func1".
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("function")]
        public virtual string Function { get; set; }

        /// <summary>
        /// A template to parse function field from a request URL. URL mask allows for routing to multiple Cloud
        /// Functions without having to create multiple Network Endpoint Groups and backend services.  For example,
        /// request URLs "mydomain.com/function1" and "mydomain.com/function2" can be backed by the same Serverless NEG
        /// with URL mask "/". The URL mask will parse them to { function = "function1" } and { function = "function2" }
        /// respectively.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("urlMask")]
        public virtual string UrlMask { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Configuration for a Cloud Run network endpoint group (NEG). The service must be provided explicitly or in the
    /// URL mask. The tag is optional, may be provided explicitly or in the URL mask.  Note: Cloud Run service must be
    /// in the same project and located in the same region as the Serverless NEG.
    /// </summary>
    public class NetworkEndpointGroupCloudRun : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Cloud Run service is the main resource of Cloud Run.  The service must be 1-63 characters long, and comply
        /// with RFC1035.  Example value: "run-service".
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("service")]
        public virtual string Service { get; set; }

        /// <summary>
        /// Optional Cloud Run tag represents the "named-revision" to provide additional fine-grained traffic routing
        /// information.  The tag must be 1-63 characters long, and comply with RFC1035.  Example value:
        /// "revision-0010".
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("tag")]
        public virtual string Tag { get; set; }

        /// <summary>
        /// A template to parse service and tag fields from a request URL. URL mask allows for routing to multiple Run
        /// services without having to create multiple network endpoint groups and backend services.  For example,
        /// request URLs "foo1.domain.com/bar1" and "foo1.domain.com/bar2" can be backed by the same Serverless Network
        /// Endpoint Group (NEG) with URL mask ".domain.com/". The URL mask will parse them to { service="bar1",
        /// tag="foo1" } and { service="bar2", tag="foo2" } respectively.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("urlMask")]
        public virtual string UrlMask { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NetworkEndpointGroupList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of NetworkEndpointGroup resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<NetworkEndpointGroup> Items { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute#networkEndpointGroupList for network endpoint group
        /// lists.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class NetworkEndpointGroupsAttachEndpointsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The list of network endpoints to be attached.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkEndpoints")]
        public virtual System.Collections.Generic.IList<NetworkEndpoint> NetworkEndpoints { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NetworkEndpointGroupsDetachEndpointsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The list of network endpoints to be detached.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkEndpoints")]
        public virtual System.Collections.Generic.IList<NetworkEndpoint> NetworkEndpoints { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NetworkEndpointGroupsListEndpointsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Optional query parameter for showing the health status of each network endpoint. Valid options are SKIP or
        /// SHOW. If you don't specify this parameter, the health status of network endpoints will not be provided.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthStatus")]
        public virtual string HealthStatus { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NetworkEndpointGroupsListNetworkEndpoints : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of NetworkEndpointWithHealthStatus resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<NetworkEndpointWithHealthStatus> Items { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute#networkEndpointGroupsListNetworkEndpoints for the
        /// list of network endpoints in the specified network endpoint group.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class NetworkEndpointGroupsScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The list of network endpoint groups that are contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkEndpointGroups")]
        public virtual System.Collections.Generic.IList<NetworkEndpointGroup> NetworkEndpointGroups { get; set; }

        /// <summary>
        /// [Output Only] An informational warning that replaces the list of network endpoint groups when the list is
        /// empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] An informational warning that replaces the list of network endpoint groups when the list is
        /// empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class NetworkEndpointWithHealthStatus : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output only] The health status of network endpoint;</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healths")]
        public virtual System.Collections.Generic.IList<HealthStatusForNetworkEndpoint> Healths { get; set; }

        /// <summary>[Output only] The network endpoint;</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkEndpoint")]
        public virtual NetworkEndpoint NetworkEndpoint { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A network interface resource attached to an instance.</summary>
    public class NetworkInterface : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// An array of configurations for this interface. Currently, only one access config, ONE_TO_ONE_NAT, is
        /// supported. If there are no accessConfigs specified, then this instance will have no external internet
        /// access.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("accessConfigs")]
        public virtual System.Collections.Generic.IList<AccessConfig> AccessConfigs { get; set; }

        /// <summary>
        /// An array of alias IP ranges for this network interface. You can only specify this field for network
        /// interfaces in VPC networks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("aliasIpRanges")]
        public virtual System.Collections.Generic.IList<AliasIpRange> AliasIpRanges { get; set; }

        /// <summary>
        /// Fingerprint hash of contents stored in this network interface. This field will be ignored when inserting an
        /// Instance or adding a NetworkInterface. An up-to-date fingerprint must be provided in order to update the
        /// NetworkInterface. The request will fail with error 400 Bad Request if the fingerprint is not provided, or
        /// 412 Precondition Failed if the fingerprint is out of date.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>[Output Only] An IPv6 internal network address for this network interface.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipv6Address")]
        public virtual string Ipv6Address { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#networkInterface for network interfaces.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] The name of the network interface, which is generated by the server. For network devices,
        /// these are eth0, eth1, etc.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// URL of the network resource for this instance. When creating an instance, if neither the network nor the
        /// subnetwork is specified, the default network global/networks/default is used; if the network is not
        /// specified but the subnetwork is specified, the network is inferred.  If you specify this property, you can
        /// specify the network as a full or partial URL. For example, the following are all valid URLs:   -
        /// https://www.googleapis.com/compute/v1/projects/project/global/networks/network  -
        /// projects/project/global/networks/network  - global/networks/default
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>
        /// An IPv4 internal IP address to assign to the instance for this network interface. If not specified by the
        /// user, an unused internal IP is assigned by the system.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkIP")]
        public virtual string NetworkIP { get; set; }

        /// <summary>The type of vNIC to be used on this interface. This may be gVNIC or VirtioNet.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nicType")]
        public virtual string NicType { get; set; }

        /// <summary>
        /// The URL of the Subnetwork resource for this instance. If the network resource is in legacy mode, do not
        /// specify this field. If the network is in auto subnet mode, specifying the subnetwork is optional. If the
        /// network is in custom subnet mode, specifying the subnetwork is required. If you specify this field, you can
        /// specify the subnetwork as a full or partial URL. For example, the following are all valid URLs:   -
        /// https://www.googleapis.com/compute/v1/projects/project/regions/region/subnetworks/subnetwork  -
        /// regions/region/subnetworks/subnetwork
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("subnetwork")]
        public virtual string Subnetwork { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of networks.</summary>
    public class NetworkList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Network resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Network> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#networkList for lists of networks.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// A network peering attached to a network resource. The message includes the peering name, peer network, peering
    /// state, and a flag indicating whether Google Compute Engine should automatically create routes for the peering.
    /// </summary>
    public class NetworkPeering : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// This field will be deprecated soon. Use the exchange_subnet_routes field instead. Indicates whether full
        /// mesh connectivity is created and managed automatically between peered networks. Currently this field should
        /// always be true since Google Compute Engine will automatically create and manage subnetwork routes between
        /// two networks when peering state is ACTIVE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoCreateRoutes")]
        public virtual System.Nullable<bool> AutoCreateRoutes { get; set; }

        /// <summary>
        /// Indicates whether full mesh connectivity is created and managed automatically between peered networks.
        /// Currently this field should always be true since Google Compute Engine will automatically create and manage
        /// subnetwork routes between two networks when peering state is ACTIVE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("exchangeSubnetRoutes")]
        public virtual System.Nullable<bool> ExchangeSubnetRoutes { get; set; }

        /// <summary>Whether to export the custom routes to peer network.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("exportCustomRoutes")]
        public virtual System.Nullable<bool> ExportCustomRoutes { get; set; }

        /// <summary>
        /// Whether subnet routes with public IP range are exported. The default value is true, all subnet routes are
        /// exported. The IPv4 special-use ranges (https://en.wikipedia.org/wiki/IPv4#Special_addresses) are always
        /// exported to peers and are not controlled by this field.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("exportSubnetRoutesWithPublicIp")]
        public virtual System.Nullable<bool> ExportSubnetRoutesWithPublicIp { get; set; }

        /// <summary>Whether to import the custom routes from peer network.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("importCustomRoutes")]
        public virtual System.Nullable<bool> ImportCustomRoutes { get; set; }

        /// <summary>
        /// Whether subnet routes with public IP range are imported. The default value is false. The IPv4 special-use
        /// ranges (https://en.wikipedia.org/wiki/IPv4#Special_addresses) are always imported from peers and are not
        /// controlled by this field.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("importSubnetRoutesWithPublicIp")]
        public virtual System.Nullable<bool> ImportSubnetRoutesWithPublicIp { get; set; }

        /// <summary>
        /// Name of this peering. Provided by the client when the peering is created. The name must comply with RFC1035.
        /// Specifically, the name must be 1-63 characters long and match regular expression
        /// `[a-z]([-a-z0-9]*[a-z0-9])?`. The first character must be a lowercase letter, and all the following
        /// characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// The URL of the peer network. It can be either full URL or partial URL. The peer network may belong to a
        /// different project. If the partial URL does not contain project, it is assumed that the peer network is in
        /// the same project as the current network.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>Maximum Transmission Unit in bytes.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerMtu")]
        public virtual System.Nullable<int> PeerMtu { get; set; }

        /// <summary>
        /// [Output Only] State for the peering, either `ACTIVE` or `INACTIVE`. The peering is `ACTIVE` when there's a
        /// matching configuration in the peer network.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("state")]
        public virtual string State { get; set; }

        /// <summary>[Output Only] Details about the current state of the peering.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("stateDetails")]
        public virtual string StateDetails { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// A routing configuration attached to a network resource. The message includes the list of routers associated with
    /// the network, and a flag indicating the type of routing behavior to enforce network-wide.
    /// </summary>
    public class NetworkRoutingConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The network-wide routing mode to use. If set to REGIONAL, this network's Cloud Routers will only advertise
        /// routes with subnets of this network in the same region as the router. If set to GLOBAL, this network's Cloud
        /// Routers will advertise routes with all subnets of this network, across regions.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("routingMode")]
        public virtual string RoutingMode { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NetworksAddPeeringRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// This field will be deprecated soon. Use exchange_subnet_routes in network_peering instead. Indicates whether
        /// full mesh connectivity is created and managed automatically between peered networks. Currently this field
        /// should always be true since Google Compute Engine will automatically create and manage subnetwork routes
        /// between two networks when peering state is ACTIVE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoCreateRoutes")]
        public virtual System.Nullable<bool> AutoCreateRoutes { get; set; }

        /// <summary>Name of the peering, which should conform to RFC1035.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// Network peering parameters. In order to specify route policies for peering using import and export custom
        /// routes, you must specify all peering related parameters (name, peer network, exchange_subnet_routes) in the
        /// network_peering field. The corresponding fields in NetworksAddPeeringRequest will be deprecated soon.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkPeering")]
        public virtual NetworkPeering NetworkPeering { get; set; }

        /// <summary>
        /// URL of the peer network. It can be either full URL or partial URL. The peer network may belong to a
        /// different project. If the partial URL does not contain project, it is assumed that the peer network is in
        /// the same project as the current network.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerNetwork")]
        public virtual string PeerNetwork { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NetworksGetEffectiveFirewallsResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Effective firewalls from firewall policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("firewallPolicys")]
        public virtual System.Collections.Generic.IList<NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy> FirewallPolicys { get; set; }

        /// <summary>Effective firewalls on the network.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("firewalls")]
        public virtual System.Collections.Generic.IList<Firewall> Firewalls { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The display name of the firewall policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("displayName")]
        public virtual string DisplayName { get; set; }

        /// <summary>[Output Only] The name of the firewall policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The rules that apply to the network.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("rules")]
        public virtual System.Collections.Generic.IList<FirewallPolicyRule> Rules { get; set; }

        /// <summary>[Output Only] The type of the firewall policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NetworksRemovePeeringRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Name of the peering, which should conform to RFC1035.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NetworksUpdatePeeringRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("networkPeering")]
        public virtual NetworkPeering NetworkPeering { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represent a sole-tenant Node Group resource.  A sole-tenant node is a physical server that is dedicated to
    /// hosting VM instances only for your specific project. Use sole-tenant nodes to keep your instances physically
    /// separated from instances in other projects, or to group your instances together on the same host hardware. For
    /// more information, read Sole-tenant nodes. (== resource_for {$api_version}.nodeGroups ==)
    /// </summary>
    public class NodeGroup : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Specifies how autoscaling should behave.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoscalingPolicy")]
        public virtual NodeGroupAutoscalingPolicy AutoscalingPolicy { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] The type of the resource. Always compute#nodeGroup for node group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// An opaque location hint used to place the Node close to other resources. This field is for use by internal
        /// tools that use the public API. The location hint here on the NodeGroup overrides any location_hint present
        /// in the NodeTemplate.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("locationHint")]
        public virtual string LocationHint { get; set; }

        /// <summary>
        /// Specifies how to handle instances when a node in the group undergoes maintenance. Set to one of: DEFAULT,
        /// RESTART_IN_PLACE, or MIGRATE_WITHIN_NODE_GROUP. The default value is DEFAULT. For more information, see
        /// Maintenance policies.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maintenancePolicy")]
        public virtual string MaintenancePolicy { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("maintenanceWindow")]
        public virtual NodeGroupMaintenanceWindow MaintenanceWindow { get; set; }

        /// <summary>
        /// The name of the resource, provided by the client when initially creating the resource. The resource name
        /// must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long
        /// and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
        /// lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last
        /// character, which cannot be a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>URL of the node template to create the node group from.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nodeTemplate")]
        public virtual string NodeTemplate { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] The total number of nodes in the node group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("size")]
        public virtual System.Nullable<int> Size { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>[Output Only] The name of the zone where the node group resides, such as us-central1-a.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NodeGroupAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of NodeGroupsScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, NodeGroupsScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource.Always compute#nodeGroupAggregatedList for aggregated lists of node groups.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class NodeGroupAutoscalingPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The maximum number of nodes that the group should have. Must be set if autoscaling is enabled. Maximum value
        /// allowed is 100.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxNodes")]
        public virtual System.Nullable<int> MaxNodes { get; set; }

        /// <summary>The minimum number of nodes that the group should have.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minNodes")]
        public virtual System.Nullable<int> MinNodes { get; set; }

        /// <summary>
        /// The autoscaling mode. Set to one of: ON, OFF, or ONLY_SCALE_OUT. For more information, see  Autoscaler
        /// modes.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("mode")]
        public virtual string Mode { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of nodeGroups.</summary>
    public class NodeGroupList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of NodeGroup resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<NodeGroup> Items { get; set; }

        /// <summary>[Output Only] Type of resource.Always compute#nodeGroupList for lists of node groups.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Time window specified for daily maintenance operations. GCE's internal maintenance will be performed within this
    /// window.
    /// </summary>
    public class NodeGroupMaintenanceWindow : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output only] A predetermined duration for the window, automatically chosen to be the smallest possible in
        /// the given scenario.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maintenanceDuration")]
        public virtual Duration MaintenanceDuration { get; set; }

        /// <summary>
        /// Start time of the window. This must be in UTC format that resolves to one of 00:00, 04:00, 08:00, 12:00,
        /// 16:00, or 20:00. For example, both 13:00-5 and 08:00 are valid.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("startTime")]
        public virtual string StartTime { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NodeGroupNode : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Accelerators for this node.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("accelerators")]
        public virtual System.Collections.Generic.IList<AcceleratorConfig> Accelerators { get; set; }

        /// <summary>CPU overcommit.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cpuOvercommitType")]
        public virtual string CpuOvercommitType { get; set; }

        /// <summary>Local disk configurations.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("disks")]
        public virtual System.Collections.Generic.IList<LocalDisk> Disks { get; set; }

        /// <summary>Instances scheduled on this node.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<string> Instances { get; set; }

        /// <summary>The name of the node.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The type of this node.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nodeType")]
        public virtual string NodeType { get; set; }

        /// <summary>[Output Only] Reserved for future use.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("satisfiesPzs")]
        public virtual System.Nullable<bool> SatisfiesPzs { get; set; }

        /// <summary>Binding properties for the physical server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("serverBinding")]
        public virtual ServerBinding ServerBinding { get; set; }

        /// <summary>Server ID associated with this node.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("serverId")]
        public virtual string ServerId { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NodeGroupsAddNodesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Count of additional nodes to be added to the node group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("additionalNodeCount")]
        public virtual System.Nullable<int> AdditionalNodeCount { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NodeGroupsDeleteNodesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Names of the nodes to delete.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nodes")]
        public virtual System.Collections.Generic.IList<string> Nodes { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NodeGroupsListNodes : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Node resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<NodeGroupNode> Items { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute.nodeGroupsListNodes for the list of nodes in the
        /// specified node group.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class NodeGroupsScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of node groups contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nodeGroups")]
        public virtual System.Collections.Generic.IList<NodeGroup> NodeGroups { get; set; }

        /// <summary>[Output Only] An informational warning that appears when the nodeGroup list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] An informational warning that appears when the nodeGroup list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class NodeGroupsSetNodeTemplateRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Full or partial URL of the node template resource to be updated for this node group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nodeTemplate")]
        public virtual string NodeTemplate { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represent a sole-tenant Node Template resource.  You can use a template to define properties for nodes in a node
    /// group. For more information, read Creating node groups and instances. (== resource_for
    /// {$api_version}.nodeTemplates ==)
    /// </summary>
    public class NodeTemplate : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("accelerators")]
        public virtual System.Collections.Generic.IList<AcceleratorConfig> Accelerators { get; set; }

        /// <summary>CPU overcommit.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cpuOvercommitType")]
        public virtual string CpuOvercommitType { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("disks")]
        public virtual System.Collections.Generic.IList<LocalDisk> Disks { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] The type of the resource. Always compute#nodeTemplate for node templates.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// The name of the resource, provided by the client when initially creating the resource. The resource name
        /// must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long
        /// and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
        /// lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last
        /// character, which cannot be a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>Labels to use for node affinity, which will be used in instance scheduling.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nodeAffinityLabels")]
        public virtual System.Collections.Generic.IDictionary<string, string> NodeAffinityLabels { get; set; }

        /// <summary>The node type to use for nodes group that are created from this template.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nodeType")]
        public virtual string NodeType { get; set; }

        /// <summary>
        /// The flexible properties of the desired node type. Node groups that use this node template will create nodes
        /// of a type that matches these properties.  This field is mutually exclusive with the node_type property; you
        /// can only define one or the other, but not both.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nodeTypeFlexibility")]
        public virtual NodeTemplateNodeTypeFlexibility NodeTypeFlexibility { get; set; }

        /// <summary>
        /// [Output Only] The name of the region where the node template resides, such as us-central1.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// Sets the binding properties for the physical server. Valid values include:   - [Default]
        /// RESTART_NODE_ON_ANY_SERVER: Restarts VMs on any available physical server  - RESTART_NODE_ON_MINIMAL_SERVER:
        /// Restarts VMs on the same physical server whenever possible    See Sole-tenant node options for more
        /// information.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("serverBinding")]
        public virtual ServerBinding ServerBinding { get; set; }

        /// <summary>
        /// [Output Only] The status of the node template. One of the following values: CREATING, READY, and DELETING.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>[Output Only] An optional, human-readable explanation of the status.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("statusMessage")]
        public virtual string StatusMessage { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NodeTemplateAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of NodeTemplatesScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, NodeTemplatesScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource.Always compute#nodeTemplateAggregatedList for aggregated lists of node
        /// templates.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of node templates.</summary>
    public class NodeTemplateList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of NodeTemplate resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<NodeTemplate> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource.Always compute#nodeTemplateList for lists of node templates.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class NodeTemplateNodeTypeFlexibility : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("cpus")]
        public virtual string Cpus { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("localSsd")]
        public virtual string LocalSsd { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("memory")]
        public virtual string Memory { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NodeTemplatesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of node templates contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nodeTemplates")]
        public virtual System.Collections.Generic.IList<NodeTemplate> NodeTemplates { get; set; }

        /// <summary>
        /// [Output Only] An informational warning that appears when the node templates list is empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] An informational warning that appears when the node templates list is empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represent a sole-tenant Node Type resource.  Each node within a node group must have a node type. A node type
    /// specifies the total amount of cores and memory for that node. Currently, the only available node type is
    /// n1-node-96-624 node type that has 96 vCPUs and 624 GB of memory, available in multiple zones. For more
    /// information read Node types. (== resource_for {$api_version}.nodeTypes ==)
    /// </summary>
    public class NodeType : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The CPU platform used by this node type.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cpuPlatform")]
        public virtual string CpuPlatform { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>[Output Only] The deprecation status associated with this node type.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("deprecated")]
        public virtual DeprecationStatus Deprecated { get; set; }

        /// <summary>[Output Only] An optional textual description of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>[Output Only] The number of virtual CPUs that are available to the node type.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("guestCpus")]
        public virtual System.Nullable<int> GuestCpus { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] The type of the resource. Always compute#nodeType for node types.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>[Output Only] Local SSD available to the node type, defined in GB.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("localSsdGb")]
        public virtual System.Nullable<int> LocalSsdGb { get; set; }

        /// <summary>[Output Only] The amount of physical memory available to the node type, defined in MB.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("memoryMb")]
        public virtual System.Nullable<int> MemoryMb { get; set; }

        /// <summary>[Output Only] Name of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] The name of the zone where the node type resides, such as us-central1-a.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NodeTypeAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of NodeTypesScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, NodeTypesScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource.Always compute#nodeTypeAggregatedList for aggregated lists of node types.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of node types.</summary>
    public class NodeTypeList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of NodeType resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<NodeType> Items { get; set; }

        /// <summary>[Output Only] Type of resource.Always compute#nodeTypeList for lists of node types.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class NodeTypesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of node types contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nodeTypes")]
        public virtual System.Collections.Generic.IList<NodeType> NodeTypes { get; set; }

        /// <summary>[Output Only] An informational warning that appears when the node types list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] An informational warning that appears when the node types list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a notification endpoint.  A notification endpoint resource defines an endpoint to receive
    /// notifications when there are status changes detected by the associated health check service.  For more
    /// information, see  Health checks overview. (== resource_for {$api_version}.notificationEndpoint ==) (==
    /// resource_for {$api_version}.regionNotificationEndpoints ==)
    /// </summary>
    public class NotificationEndpoint : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Settings of the gRPC notification endpoint including the endpoint URL and the retry duration.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("grpcSettings")]
        public virtual NotificationEndpointGrpcSettings GrpcSettings { get; set; }

        /// <summary>
        /// [Output Only] A unique identifier for this resource type. The server generates this identifier.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#notificationEndpoint for notification endpoints.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the notification endpoint resides. This field applies only to the
        /// regional resource. You must specify this field as part of the HTTP request URL. It is not settable as a
        /// field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a gRPC setting that describes one gRPC notification endpoint and the retry duration attempting to
    /// send notification to this endpoint.
    /// </summary>
    public class NotificationEndpointGrpcSettings : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Optional. If specified, this field is used to set the authority header by the sender of notifications. See
        /// https://tools.ietf.org/html/rfc7540#section-8.1.2.3
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("authority")]
        public virtual string Authority { get; set; }

        /// <summary>Endpoint to which gRPC notifications are sent. This must be a valid gRPCLB DNS name.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("endpoint")]
        public virtual string Endpoint { get; set; }

        /// <summary>Optional. If specified, this field is used to populate the "name" field in gRPC requests.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("payloadName")]
        public virtual string PayloadName { get; set; }

        /// <summary>
        /// Optional. This field is used to configure how often to send a full update of all non-healthy backends. If
        /// unspecified, full updates are not sent. If specified, must be in the range between 600 seconds to 3600
        /// seconds. Nanos are disallowed.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resendInterval")]
        public virtual Duration ResendInterval { get; set; }

        /// <summary>
        /// How much time (in seconds) is spent attempting notification retries until a successful response is received.
        /// Default is 30s. Limit is 20m (1200s). Must be a positive number.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("retryDurationSec")]
        public virtual System.Nullable<long> RetryDurationSec { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class NotificationEndpointList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of NotificationEndpoint resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<NotificationEndpoint> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#notificationEndpoint for notification endpoints.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents an Operation resource.  Google Compute Engine has three Operation resources:  *
    /// [Global](/compute/docs/reference/rest/{$api_version}/globalOperations) *
    /// [Regional](/compute/docs/reference/rest/{$api_version}/regionOperations) *
    /// [Zonal](/compute/docs/reference/rest/{$api_version}/zoneOperations)  You can use an operation resource to manage
    /// asynchronous API requests. For more information, read Handling API responses.  Operations can be global,
    /// regional or zonal.   - For global operations, use the `globalOperations` resource.  - For regional operations,
    /// use the `regionOperations` resource.  - For zonal operations, use the `zonalOperations` resource.    For more
    /// information, read  Global, Regional, and Zonal Resources. (== resource_for {$api_version}.globalOperations ==)
    /// (== resource_for {$api_version}.regionOperations ==) (== resource_for {$api_version}.zoneOperations ==)
    /// </summary>
    public class Operation : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] The value of `requestId` if you provided it in the request. Not present otherwise.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("clientOperationId")]
        public virtual string ClientOperationId { get; set; }

        /// <summary>[Deprecated] This field is deprecated.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// [Output Only] A textual description of the operation, which is set when the operation is created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The time that this operation was completed. This value is in RFC3339 text format.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("endTime")]
        public virtual string EndTime { get; set; }

        /// <summary>
        /// [Output Only] If errors are generated during processing of the operation, this field will be populated.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("error")]
        public virtual ErrorData Error { get; set; }

        /// <summary>
        /// [Output Only] If the operation fails, this field contains the HTTP error message that was returned, such as
        /// `NOT FOUND`.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("httpErrorMessage")]
        public virtual string HttpErrorMessage { get; set; }

        /// <summary>
        /// [Output Only] If the operation fails, this field contains the HTTP error status code that was returned. For
        /// example, a `404` means the resource was not found.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("httpErrorStatusCode")]
        public virtual System.Nullable<int> HttpErrorStatusCode { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the operation. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// [Output Only] The time that this operation was requested. This value is in RFC3339 text format.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("insertTime")]
        public virtual string InsertTime { get; set; }

        /// <summary>[Output Only] Type of the resource. Always `compute#operation` for Operation resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>[Output Only] Name of the operation.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// [Output Only] An ID that represents a group of operations, such as when a group of operations results from a
        /// `bulkInsert` API request.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("operationGroupId")]
        public virtual string OperationGroupId { get; set; }

        /// <summary>[Output Only] The type of operation, such as `insert`, `update`, or `delete`, and so on.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("operationType")]
        public virtual string OperationType { get; set; }

        /// <summary>
        /// [Output Only] An optional progress indicator that ranges from 0 to 100. There is no requirement that this be
        /// linear or support any granularity of operations. This should not be used to guess when the operation will be
        /// complete. This number should monotonically increase as the operation progresses.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("progress")]
        public virtual System.Nullable<int> Progress { get; set; }

        /// <summary>
        /// [Output Only] The URL of the region where the operation resides. Only applicable when performing regional
        /// operations.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// [Output Only] The time that this operation was started by the server. This value is in RFC3339 text format.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("startTime")]
        public virtual string StartTime { get; set; }

        /// <summary>
        /// [Output Only] The status of the operation, which can be one of the following: `PENDING`, `RUNNING`, or
        /// `DONE`.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>[Output Only] An optional textual description of the current status of the operation.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("statusMessage")]
        public virtual string StatusMessage { get; set; }

        /// <summary>
        /// [Output Only] The unique target ID, which identifies a specific incarnation of the target resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetId")]
        public virtual System.Nullable<ulong> TargetId { get; set; }

        /// <summary>
        /// [Output Only] The URL of the resource that the operation modifies. For operations related to creating a
        /// snapshot, this points to the persistent disk that the snapshot was created from.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetLink")]
        public virtual string TargetLink { get; set; }

        /// <summary>[Output Only] User who requested the operation, for example: `user@example.com`.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("user")]
        public virtual string User { get; set; }

        /// <summary>
        /// [Output Only] If warning messages are generated during processing of the operation, this field will be
        /// populated.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warnings")]
        public virtual System.Collections.Generic.IList<WarningsData> Warnings { get; set; }

        /// <summary>
        /// [Output Only] The URL of the zone where the operation resides. Only applicable when performing per-zone
        /// operations.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] If errors are generated during processing of the operation, this field will be populated.
        /// </summary>
        public class ErrorData
        {
            /// <summary>[Output Only] The array of errors encountered while processing this operation.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("errors")]
            public virtual System.Collections.Generic.IList<ErrorsData> Errors { get; set; }

            /// <summary>[Output Only] The array of errors encountered while processing this operation.</summary>
            public class ErrorsData
            {
                /// <summary>[Output Only] The error type identifier for this error.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("code")]
                public virtual string Code { get; set; }

                /// <summary>
                /// [Output Only] Indicates the field in the request that caused the error. This property is optional.
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("location")]
                public virtual string Location { get; set; }

                /// <summary>[Output Only] An optional, human-readable error message.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("message")]
                public virtual string Message { get; set; }
            }
        }

        /// <summary>
        /// [Output Only] If warning messages are generated during processing of the operation, this field will be
        /// populated.
        /// </summary>
        public class WarningsData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class OperationAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>[Output Only] A map of scoped operation lists.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, OperationsScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always `compute#operationAggregatedList` for aggregated lists of operations.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than `maxResults`, use the `nextPageToken` as a value for the query parameter `pageToken`
        /// in the next list request. Subsequent list requests will have their own `nextPageToken` to continue paging
        /// through the results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of Operation resources.</summary>
    public class OperationList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>[Output Only] A list of Operation resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Operation> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always `compute#operations` for Operations resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than `maxResults`, use the `nextPageToken` as a value for the query parameter `pageToken`
        /// in the next list request. Subsequent list requests will have their own `nextPageToken` to continue paging
        /// through the results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class OperationsScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of operations contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("operations")]
        public virtual System.Collections.Generic.IList<Operation> Operations { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of operations when the list is empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of operations when the list is empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Settings controlling the eviction of unhealthy hosts from the load balancing pool for the backend service.
    /// </summary>
    public class OutlierDetection : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The base time that a host is ejected for. The real ejection time is equal to the base ejection time
        /// multiplied by the number of times the host has been ejected. Defaults to 30000ms or 30s.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("baseEjectionTime")]
        public virtual Duration BaseEjectionTime { get; set; }

        /// <summary>
        /// Number of errors before a host is ejected from the connection pool. When the backend host is accessed over
        /// HTTP, a 5xx return code qualifies as an error. Defaults to 5.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("consecutiveErrors")]
        public virtual System.Nullable<int> ConsecutiveErrors { get; set; }

        /// <summary>
        /// The number of consecutive gateway failures (502, 503, 504 status or connection errors that are mapped to one
        /// of those status codes) before a consecutive gateway failure ejection occurs. Defaults to 3.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("consecutiveGatewayFailure")]
        public virtual System.Nullable<int> ConsecutiveGatewayFailure { get; set; }

        /// <summary>
        /// The percentage chance that a host will be actually ejected when an outlier status is detected through
        /// consecutive 5xx. This setting can be used to disable ejection or to ramp it up slowly. Defaults to 0.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enforcingConsecutiveErrors")]
        public virtual System.Nullable<int> EnforcingConsecutiveErrors { get; set; }

        /// <summary>
        /// The percentage chance that a host will be actually ejected when an outlier status is detected through
        /// consecutive gateway failures. This setting can be used to disable ejection or to ramp it up slowly. Defaults
        /// to 100.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enforcingConsecutiveGatewayFailure")]
        public virtual System.Nullable<int> EnforcingConsecutiveGatewayFailure { get; set; }

        /// <summary>
        /// The percentage chance that a host will be actually ejected when an outlier status is detected through
        /// success rate statistics. This setting can be used to disable ejection or to ramp it up slowly. Defaults to
        /// 100.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enforcingSuccessRate")]
        public virtual System.Nullable<int> EnforcingSuccessRate { get; set; }

        /// <summary>
        /// Time interval between ejection analysis sweeps. This can result in both new ejections as well as hosts being
        /// returned to service. Defaults to 1 second.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("interval")]
        public virtual Duration Interval { get; set; }

        /// <summary>
        /// Maximum percentage of hosts in the load balancing pool for the backend service that can be ejected. Defaults
        /// to 50%.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxEjectionPercent")]
        public virtual System.Nullable<int> MaxEjectionPercent { get; set; }

        /// <summary>
        /// The number of hosts in a cluster that must have enough request volume to detect success rate outliers. If
        /// the number of hosts is less than this setting, outlier detection via success rate statistics is not
        /// performed for any host in the cluster. Defaults to 5.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("successRateMinimumHosts")]
        public virtual System.Nullable<int> SuccessRateMinimumHosts { get; set; }

        /// <summary>
        /// The minimum number of total requests that must be collected in one interval (as defined by the interval
        /// duration above) to include this host in success rate based outlier detection. If the volume is lower than
        /// this setting, outlier detection via success rate statistics is not performed for that host. Defaults to 100.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("successRateRequestVolume")]
        public virtual System.Nullable<int> SuccessRateRequestVolume { get; set; }

        /// <summary>
        /// This factor is used to determine the ejection threshold for success rate outlier ejection. The ejection
        /// threshold is the difference between the mean success rate, and the product of this factor and the standard
        /// deviation of the mean success rate: mean - (stdev * success_rate_stdev_factor). This factor is divided by a
        /// thousand to get a double. That is, if the desired factor is 1.9, the runtime value should be 1900. Defaults
        /// to 1900.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("successRateStdevFactor")]
        public virtual System.Nullable<int> SuccessRateStdevFactor { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Packet Mirroring resource.  Packet Mirroring clones the traffic of specified instances in your
    /// Virtual Private Cloud (VPC) network and forwards it to a collector destination, such as an instance group of an
    /// internal TCP/UDP load balancer, for analysis or examination. For more information about setting up Packet
    /// Mirroring, see Using Packet Mirroring. (== resource_for {$api_version}.packetMirrorings ==)
    /// </summary>
    public class PacketMirroring : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The Forwarding Rule resource of type loadBalancingScheme=INTERNAL that will be used as collector for
        /// mirrored traffic. The specified forwarding rule must have isMirroringCollector set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("collectorIlb")]
        public virtual PacketMirroringForwardingRuleInfo CollectorIlb { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Indicates whether or not this packet mirroring takes effect. If set to FALSE, this packet mirroring policy
        /// will not be enforced on the network.  The default is TRUE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enable")]
        public virtual string Enable { get; set; }

        /// <summary>Filter for mirrored traffic. If unspecified, all traffic is mirrored.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("filter")]
        public virtual PacketMirroringFilter Filter { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#packetMirroring for packet mirrorings.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// PacketMirroring mirroredResourceInfos. MirroredResourceInfo specifies a set of mirrored VM instances,
        /// subnetworks and/or tags for which traffic from/to all VM instances will be mirrored.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("mirroredResources")]
        public virtual PacketMirroringMirroredResourceInfo MirroredResources { get; set; }

        /// <summary>
        /// Name of the resource; provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// Specifies the mirrored VPC network. Only packets in this network will be mirrored. All mirrored VMs should
        /// have a NIC in the given network. All mirrored subnetworks should belong to the given network.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual PacketMirroringNetworkInfo Network { get; set; }

        /// <summary>
        /// The priority of applying this configuration. Priority is used to break ties in cases where there is more
        /// than one matching rule. In the case of two rules that apply for a given Instance, the one with the
        /// lowest-numbered priority value wins.  Default value is 1000. Valid range is 0 through 65535.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("priority")]
        public virtual System.Nullable<long> Priority { get; set; }

        /// <summary>[Output Only] URI of the region where the packetMirroring resides.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of packetMirrorings.</summary>
    public class PacketMirroringAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of PacketMirroring resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, PacketMirroringsScopedList> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class PacketMirroringFilter : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Protocols that apply as filter on mirrored traffic. If no protocols are specified, all traffic that matches
        /// the specified CIDR ranges is mirrored. If neither cidrRanges nor IPProtocols is specified, all traffic is
        /// mirrored.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("IPProtocols")]
        public virtual System.Collections.Generic.IList<string> IPProtocols { get; set; }

        /// <summary>
        /// IP CIDR ranges that apply as filter on the source (ingress) or destination (egress) IP in the IP header.
        /// Only IPv4 is supported. If no ranges are specified, all traffic that matches the specified IPProtocols is
        /// mirrored. If neither cidrRanges nor IPProtocols is specified, all traffic is mirrored.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("cidrRanges")]
        public virtual System.Collections.Generic.IList<string> CidrRanges { get; set; }

        /// <summary>Direction of traffic to mirror, either INGRESS, EGRESS, or BOTH. The default is BOTH.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("direction")]
        public virtual string Direction { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class PacketMirroringForwardingRuleInfo : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the forwarding rule; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("canonicalUrl")]
        public virtual string CanonicalUrl { get; set; }

        /// <summary>
        /// Resource URL to the forwarding rule representing the ILB configured as destination of the mirrored traffic.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("url")]
        public virtual string Url { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of PacketMirroring resources.</summary>
    public class PacketMirroringList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of PacketMirroring resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<PacketMirroring> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#packetMirroring for packetMirrorings.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class PacketMirroringMirroredResourceInfo : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// A set of virtual machine instances that are being mirrored. They must live in zones contained in the same
        /// region as this packetMirroring.  Note that this config will apply only to those network interfaces of the
        /// Instances that belong to the network specified in this packetMirroring.  You may specify a maximum of 50
        /// Instances.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<PacketMirroringMirroredResourceInfoInstanceInfo> Instances { get; set; }

        /// <summary>
        /// A set of subnetworks for which traffic from/to all VM instances will be mirrored. They must live in the same
        /// region as this packetMirroring.  You may specify a maximum of 5 subnetworks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("subnetworks")]
        public virtual System.Collections.Generic.IList<PacketMirroringMirroredResourceInfoSubnetInfo> Subnetworks { get; set; }

        /// <summary>
        /// A set of mirrored tags. Traffic from/to all VM instances that have one or more of these tags will be
        /// mirrored.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("tags")]
        public virtual System.Collections.Generic.IList<string> Tags { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class PacketMirroringMirroredResourceInfoInstanceInfo : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the instance; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("canonicalUrl")]
        public virtual string CanonicalUrl { get; set; }

        /// <summary>Resource URL to the virtual machine instance which is being mirrored.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("url")]
        public virtual string Url { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class PacketMirroringMirroredResourceInfoSubnetInfo : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the subnetwork; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("canonicalUrl")]
        public virtual string CanonicalUrl { get; set; }

        /// <summary>
        /// Resource URL to the subnetwork for which traffic from/to all VM instances will be mirrored.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("url")]
        public virtual string Url { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class PacketMirroringNetworkInfo : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the network; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("canonicalUrl")]
        public virtual string CanonicalUrl { get; set; }

        /// <summary>URL of the network resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("url")]
        public virtual string Url { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class PacketMirroringsScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of packetMirrorings contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("packetMirrorings")]
        public virtual System.Collections.Generic.IList<PacketMirroring> PacketMirrorings { get; set; }

        /// <summary>Informational warning which replaces the list of packetMirrorings when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of packetMirrorings when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// A matcher for the path portion of the URL. The BackendService from the longest-matched rule will serve the URL.
    /// If no rule was matched, the default service will be used.
    /// </summary>
    public class PathMatcher : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// defaultRouteAction takes effect when none of the  pathRules or routeRules match. The load balancer performs
        /// advanced routing actions like URL rewrites, header transformations, etc. prior to forwarding the request to
        /// the selected backend. If defaultRouteAction specifies any weightedBackendServices, defaultService must not
        /// be set. Conversely if defaultService is set, defaultRouteAction cannot contain any  weightedBackendServices.
        /// Only one of defaultRouteAction or defaultUrlRedirect must be set. UrlMaps for external HTTP(S) load
        /// balancers support only the urlRewrite action within a pathMatcher's defaultRouteAction.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("defaultRouteAction")]
        public virtual HttpRouteAction DefaultRouteAction { get; set; }

        /// <summary>
        /// The full or partial URL to the BackendService resource. This will be used if none of the pathRules or
        /// routeRules defined by this PathMatcher are matched. For example, the following are all valid URLs to a
        /// BackendService resource:   -
        /// https://www.googleapis.com/compute/v1/projects/project/global/backendServices/backendService  -
        /// compute/v1/projects/project/global/backendServices/backendService  - global/backendServices/backendService
        /// If defaultRouteAction is additionally specified, advanced routing actions like URL Rewrites, etc. take
        /// effect prior to sending the request to the backend. However, if defaultService is specified,
        /// defaultRouteAction cannot contain any weightedBackendServices. Conversely, if defaultRouteAction specifies
        /// any weightedBackendServices, defaultService must not be specified. Only one of defaultService,
        /// defaultUrlRedirect  or defaultRouteAction.weightedBackendService must be set. Authorization requires one or
        /// more of the following Google IAM permissions on the specified resource default_service:   -
        /// compute.backendBuckets.use  - compute.backendServices.use
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("defaultService")]
        public virtual string DefaultService { get; set; }

        /// <summary>
        /// When none of the specified pathRules or routeRules match, the request is redirected to a URL specified by
        /// defaultUrlRedirect. If defaultUrlRedirect is specified, defaultService or defaultRouteAction must not be
        /// set. Not supported when the URL map is bound to target gRPC proxy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("defaultUrlRedirect")]
        public virtual HttpRedirectAction DefaultUrlRedirect { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Specifies changes to request and response headers that need to take effect for the selected backendService.
        /// HeaderAction specified here are applied after the matching HttpRouteRule HeaderAction and before the
        /// HeaderAction in the UrlMap  Note that headerAction is not supported for Loadbalancers that have their
        /// loadBalancingScheme set to EXTERNAL. Not supported when the URL map is bound to target gRPC proxy that has
        /// validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("headerAction")]
        public virtual HttpHeaderAction HeaderAction { get; set; }

        /// <summary>The name to which this PathMatcher is referred by the HostRule.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// The list of path rules. Use this list instead of routeRules when routing based on simple path matching is
        /// all that's required. The order by which path rules are specified does not matter. Matches are always done on
        /// the longest-path-first basis. For example: a pathRule with a path /a/b/c/* will match before /a/b/*
        /// irrespective of the order in which those paths appear in this list. Within a given pathMatcher, only one of
        /// pathRules or routeRules must be set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("pathRules")]
        public virtual System.Collections.Generic.IList<PathRule> PathRules { get; set; }

        /// <summary>
        /// The list of HTTP route rules. Use this list instead of pathRules when advanced route matching and routing
        /// actions are desired. routeRules are evaluated in order of priority, from the lowest to highest number.
        /// Within a given pathMatcher, you can set only one of pathRules or routeRules.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("routeRules")]
        public virtual System.Collections.Generic.IList<HttpRouteRule> RouteRules { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// A path-matching rule for a URL. If matched, will use the specified BackendService to handle the traffic arriving
    /// at this URL.
    /// </summary>
    public class PathRule : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The list of path patterns to match. Each must start with / and the only place a * is allowed is at the end
        /// following a /. The string fed to the path matcher does not include any text after the first ? or #, and
        /// those chars are not allowed here.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("paths")]
        public virtual System.Collections.Generic.IList<string> Paths { get; set; }

        /// <summary>
        /// In response to a matching path, the load balancer performs advanced routing actions like URL rewrites,
        /// header transformations, etc. prior to forwarding the request to the selected backend. If routeAction
        /// specifies any  weightedBackendServices, service must not be set. Conversely if service is set, routeAction
        /// cannot contain any  weightedBackendServices. Only one of routeAction or urlRedirect must be set. UrlMaps for
        /// external HTTP(S) load balancers support only the urlRewrite action within a pathRule's routeAction.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("routeAction")]
        public virtual HttpRouteAction RouteAction { get; set; }

        /// <summary>
        /// The full or partial URL of the backend service resource to which traffic is directed if this rule is
        /// matched. If routeAction is additionally specified, advanced routing actions like URL Rewrites, etc. take
        /// effect prior to sending the request to the backend. However, if service is specified, routeAction cannot
        /// contain any weightedBackendService s. Conversely, if routeAction specifies any  weightedBackendServices,
        /// service must not be specified. Only one of urlRedirect, service or routeAction.weightedBackendService must
        /// be set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("service")]
        public virtual string Service { get; set; }

        /// <summary>
        /// When a path pattern is matched, the request is redirected to a URL specified by urlRedirect. If urlRedirect
        /// is specified, service or routeAction must not be set. Not supported when the URL map is bound to target gRPC
        /// proxy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("urlRedirect")]
        public virtual HttpRedirectAction UrlRedirect { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class PerInstanceConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Fingerprint of this per-instance config. This field can be used in optimistic locking. It is ignored when
        /// inserting a per-instance config. An up-to-date fingerprint must be provided in order to update an existing
        /// per-instance config or the field needs to be unset.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// The name of a per-instance config and its corresponding instance. Serves as a merge key during
        /// UpdatePerInstanceConfigs operations, that is, if a per-instance config with the same name exists then it
        /// will be updated, otherwise a new one will be created for the VM instance with the same name. An attempt to
        /// create a per-instance config for a VM instance that either doesn't exist or is not part of the group will
        /// result in an error.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// The intended preserved state for the given instance. Does not contain preserved state generated from a
        /// stateful policy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("preservedState")]
        public virtual PreservedState PreservedState { get; set; }

        /// <summary>The status of applying this per-instance config on the corresponding managed instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// An Identity and Access Management (IAM) policy, which specifies access controls for Google Cloud resources.    A
    /// `Policy` is a collection of `bindings`. A `binding` binds one or more `members` to a single `role`. Members can
    /// be user accounts, service accounts, Google groups, and domains (such as G Suite). A `role` is a named list of
    /// permissions; each `role` can be an IAM predefined role or a user-created custom role.  For some types of Google
    /// Cloud resources, a `binding` can also specify a `condition`, which is a logical expression that allows access to
    /// a resource only if the expression evaluates to `true`. A condition can add constraints based on attributes of
    /// the request, the resource, or both. To learn which resources support conditions in their IAM policies, see the
    /// [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies).  **JSON example:**  {
    /// "bindings": [ { "role": "roles/resourcemanager.organizationAdmin", "members": [ "user:mike@example.com",
    /// "group:admins@example.com", "domain:google.com", "serviceAccount:my-project-id@appspot.gserviceaccount.com" ] },
    /// { "role": "roles/resourcemanager.organizationViewer", "members": [ "user:eve@example.com" ], "condition": {
    /// "title": "expirable access", "description": "Does not grant access after Sep 2020", "expression": "request.time
    /// &amp;lt; timestamp('2020-10-01T00:00:00.000Z')", } } ], "etag": "BwWWja0YfJA=", "version": 3 }  **YAML
    /// example:**  bindings: - members: - user:mike@example.com - group:admins@example.com - domain:google.com -
    /// serviceAccount:my-project-id@appspot.gserviceaccount.com role: roles/resourcemanager.organizationAdmin -
    /// members: - user:eve@example.com role: roles/resourcemanager.organizationViewer condition: title: expirable
    /// access description: Does not grant access after Sep 2020 expression: request.time &amp;lt;
    /// timestamp('2020-10-01T00:00:00.000Z') - etag: BwWWja0YfJA= - version: 3  For a description of IAM and its
    /// features, see the [IAM documentation](https://cloud.google.com/iam/docs/).
    /// </summary>
    public class Policy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Specifies cloud audit logging configuration for this policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("auditConfigs")]
        public virtual System.Collections.Generic.IList<AuditConfig> AuditConfigs { get; set; }

        /// <summary>
        /// Associates a list of `members` to a `role`. Optionally, may specify a `condition` that determines how and
        /// when the `bindings` are applied. Each of the `bindings` must contain at least one member.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("bindings")]
        public virtual System.Collections.Generic.IList<Binding> Bindings { get; set; }

        /// <summary>
        /// `etag` is used for optimistic concurrency control as a way to help prevent simultaneous updates of a policy
        /// from overwriting each other. It is strongly suggested that systems make use of the `etag` in the
        /// read-modify-write cycle to perform policy updates in order to avoid race conditions: An `etag` is returned
        /// in the response to `getIamPolicy`, and systems are expected to put that etag in the request to
        /// `setIamPolicy` to ensure that their change will be applied to the same version of the policy.
        /// **Important:** If you use IAM Conditions, you must include the `etag` field whenever you call
        /// `setIamPolicy`. If you omit this field, then IAM allows you to overwrite a version `3` policy with a version
        /// `1` policy, and all of the conditions in the version `3` policy are lost.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("etag")]
        public virtual string ETag { get; set; }

        /// <summary></summary>
        [Newtonsoft.Json.JsonPropertyAttribute("iamOwned")]
        public virtual System.Nullable<bool> IamOwned { get; set; }

        /// <summary>
        /// If more than one rule is specified, the rules are applied in the following manner: - All matching LOG rules
        /// are always applied. - If any DENY/DENY_WITH_LOG rule matches, permission is denied. Logging will be applied
        /// if one or more matching rule requires logging. - Otherwise, if any ALLOW/ALLOW_WITH_LOG rule matches,
        /// permission is granted. Logging will be applied if one or more matching rule requires logging. - Otherwise,
        /// if no rule applies, permission is denied.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("rules")]
        public virtual System.Collections.Generic.IList<Rule> Rules { get; set; }

        /// <summary>
        /// Specifies the format of the policy.  Valid values are `0`, `1`, and `3`. Requests that specify an invalid
        /// value are rejected.  Any operation that affects conditional role bindings must specify version `3`. This
        /// requirement applies to the following operations:  * Getting a policy that includes a conditional role
        /// binding * Adding a conditional role binding to a policy * Changing a conditional role binding in a policy *
        /// Removing any role binding, with or without a condition, from a policy that includes conditions
        /// **Important:** If you use IAM Conditions, you must include the `etag` field whenever you call
        /// `setIamPolicy`. If you omit this field, then IAM allows you to overwrite a version `3` policy with a version
        /// `1` policy, and all of the conditions in the version `3` policy are lost.  If a policy does not include any
        /// conditions, operations on that policy may specify any valid version or leave the field unset.  To learn
        /// which resources support conditions in their IAM policies, see the [IAM
        /// documentation](https://cloud.google.com/iam/help/conditions/resource-policies).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("version")]
        public virtual System.Nullable<int> Version { get; set; }
    }

    public class PreconfiguredWafSet : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>List of entities that are currently supported for WAF rules.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("expressionSets")]
        public virtual System.Collections.Generic.IList<WafExpressionSet> ExpressionSets { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Preserved state for a given instance.</summary>
    public class PreservedState : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Preserved disks defined for this instance. This map is keyed with the device names of the disks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("disks")]
        public virtual System.Collections.Generic.IDictionary<string, PreservedStatePreservedDisk> Disks { get; set; }

        /// <summary>Preserved metadata defined for this instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("metadata")]
        public virtual System.Collections.Generic.IDictionary<string, string> Metadata { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class PreservedStatePreservedDisk : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// These stateful disks will never be deleted during autohealing, update, instance recreate operations. This
        /// flag is used to configure if the disk should be deleted after it is no longer used by the group, e.g. when
        /// the given instance or the whole MIG is deleted. Note: disks attached in READ_ONLY mode cannot be
        /// auto-deleted.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoDelete")]
        public virtual string AutoDelete { get; set; }

        /// <summary>
        /// The mode in which to attach this disk, either READ_WRITE or READ_ONLY. If not specified, the default is to
        /// attach the disk in READ_WRITE mode.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("mode")]
        public virtual string Mode { get; set; }

        /// <summary>The URL of the disk resource that is stateful and should be attached to the VM instance.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("source")]
        public virtual string Source { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Project resource.  A project is used to organize resources in a Google Cloud Platform environment.
    /// For more information, read about the  Resource Hierarchy. (== resource_for {$api_version}.projects ==)
    /// </summary>
    public class Project : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Metadata key/value pairs available to all instances contained in this project. See Custom metadata for more
        /// information.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("commonInstanceMetadata")]
        public virtual Metadata CommonInstanceMetadata { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// This signifies the default network tier used for configuring resources of the project and can only take the
        /// following values: PREMIUM, STANDARD. Initially the default network tier is PREMIUM.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("defaultNetworkTier")]
        public virtual string DefaultNetworkTier { get; set; }

        /// <summary>[Output Only] Default service account used by VMs running in this project.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("defaultServiceAccount")]
        public virtual string DefaultServiceAccount { get; set; }

        /// <summary>An optional textual description of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>Restricted features enabled for use on this project.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enabledFeatures")]
        public virtual System.Collections.Generic.IList<string> EnabledFeatures { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server. This is not
        /// the project ID, and is just a unique ID used by Compute Engine to identify resources.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#project for projects.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// The project ID. For example: my-example-project. Use the project ID to make requests to Compute Engine.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] Quotas assigned to this project.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("quotas")]
        public virtual System.Collections.Generic.IList<Quota> Quotas { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// The naming prefix for daily usage reports and the Google Cloud Storage bucket where they are stored.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("usageExportLocation")]
        public virtual UsageExportLocation UsageExportLocation { get; set; }

        /// <summary>
        /// [Output Only] The role this project has in a shared VPC configuration. Currently, only projects with the
        /// host role, which is specified by the value HOST, are differentiated.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("xpnProjectStatus")]
        public virtual string XpnProjectStatus { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ProjectsDisableXpnResourceRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Service resource (a.k.a service project) ID.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("xpnResource")]
        public virtual XpnResourceId XpnResource { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ProjectsEnableXpnResourceRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Service resource (a.k.a service project) ID.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("xpnResource")]
        public virtual XpnResourceId XpnResource { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ProjectsGetXpnResources : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] Type of resource. Always compute#projectsGetXpnResources for lists of service resources (a.k.a
        /// service projects)
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>
        /// Service resources (a.k.a service projects) attached to this project as their shared VPC host.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resources")]
        public virtual System.Collections.Generic.IList<XpnResourceId> Resources { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ProjectsListXpnHostsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Optional organization ID managed by Cloud Resource Manager, for which to list shared VPC host projects. If
        /// not specified, the organization will be inferred from the project.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("organization")]
        public virtual string Organization { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ProjectsSetDefaultNetworkTierRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Default network tier to be set.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("networkTier")]
        public virtual string NetworkTier { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A quotas entry.</summary>
    public class Quota : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Quota limit for this metric.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("limit")]
        public virtual System.Nullable<double> Limit { get; set; }

        /// <summary>[Output Only] Name of the quota metric.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("metric")]
        public virtual string Metric { get; set; }

        /// <summary>[Output Only] Owning resource. This is the resource on which this quota is applied.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("owner")]
        public virtual string Owner { get; set; }

        /// <summary>[Output Only] Current usage of this metric.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("usage")]
        public virtual System.Nullable<double> Usage { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Represents a reference to a resource.</summary>
    public class Reference : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Type of the resource. Always compute#reference for references.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// A description of the reference type with no implied semantics. Possible values include:   - MEMBER_OF
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("referenceType")]
        public virtual string ReferenceType { get; set; }

        /// <summary>URL of the resource which refers to the target.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("referrer")]
        public virtual string Referrer { get; set; }

        /// <summary>URL of the resource to which this reference points.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("target")]
        public virtual string Target { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Region resource.  A region is a geographical area where a resource is located. For more
    /// information, read Regions and Zones. (== resource_for {$api_version}.regions ==)
    /// </summary>
    public class Region : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>[Output Only] The deprecation status associated with this region.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("deprecated")]
        public virtual DeprecationStatus Deprecated { get; set; }

        /// <summary>[Output Only] Textual description of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#region for regions.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>[Output Only] Name of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] Quotas assigned to this region.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("quotas")]
        public virtual System.Collections.Generic.IList<Quota> Quotas { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Status of the region, either UP or DOWN.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>[Output Only] Reserved for future use.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("supportsPzs")]
        public virtual System.Nullable<bool> SupportsPzs { get; set; }

        /// <summary>[Output Only] A list of zones available in this region, in the form of resource URLs.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zones")]
        public virtual System.Collections.Generic.IList<string> Zones { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of autoscalers.</summary>
    public class RegionAutoscalerList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Autoscaler resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Autoscaler> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class RegionDiskTypeList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of DiskType resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<DiskType> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#regionDiskTypeList for region disk types.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class RegionDisksAddResourcePoliciesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Resource policies to be added to this disk.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resourcePolicies")]
        public virtual System.Collections.Generic.IList<string> ResourcePolicies { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RegionDisksRemoveResourcePoliciesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Resource policies to be removed from this disk.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resourcePolicies")]
        public virtual System.Collections.Generic.IList<string> ResourcePolicies { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RegionDisksResizeRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The new size of the regional persistent disk, which is specified in GB.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sizeGb")]
        public virtual System.Nullable<long> SizeGb { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of InstanceGroup resources.</summary>
    public class RegionInstanceGroupList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of InstanceGroup resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<InstanceGroup> Items { get; set; }

        /// <summary>The resource type.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>RegionInstanceGroupManagers.deletePerInstanceConfigs</summary>
    public class RegionInstanceGroupManagerDeleteInstanceConfigReq : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The list of instance names for which we want to delete per-instance configs on this managed instance group.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("names")]
        public virtual System.Collections.Generic.IList<string> Names { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of managed instance groups.</summary>
    public class RegionInstanceGroupManagerList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of InstanceGroupManager resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<InstanceGroupManager> Items { get; set; }

        /// <summary>
        /// [Output Only] The resource type, which is always compute#instanceGroupManagerList for a list of managed
        /// instance groups that exist in th regional scope.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>RegionInstanceGroupManagers.patchPerInstanceConfigs</summary>
    public class RegionInstanceGroupManagerPatchInstanceConfigReq : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The list of per-instance configs to insert or patch on this managed instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("perInstanceConfigs")]
        public virtual System.Collections.Generic.IList<PerInstanceConfig> PerInstanceConfigs { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>RegionInstanceGroupManagers.updatePerInstanceConfigs</summary>
    public class RegionInstanceGroupManagerUpdateInstanceConfigReq : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The list of per-instance configs to insert or patch on this managed instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("perInstanceConfigs")]
        public virtual System.Collections.Generic.IList<PerInstanceConfig> PerInstanceConfigs { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RegionInstanceGroupManagersAbandonInstancesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The URLs of one or more instances to abandon. This can be a full URL or a partial URL, such as
        /// zones/[ZONE]/instances/[INSTANCE_NAME].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<string> Instances { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>RegionInstanceGroupManagers.applyUpdatesToInstances</summary>
    public class RegionInstanceGroupManagersApplyUpdatesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Flag to update all instances instead of specified list of ?instances?. If the flag is set to true then the
        /// instances may not be specified in the request.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("allInstances")]
        public virtual System.Nullable<bool> AllInstances { get; set; }

        /// <summary>
        /// The list of URLs of one or more instances for which you want to apply updates. Each URL can be a full URL or
        /// a partial URL, such as zones/[ZONE]/instances/[INSTANCE_NAME].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<string> Instances { get; set; }

        /// <summary>
        /// The minimal action that you want to perform on each instance during the update:   - REPLACE: At minimum,
        /// delete the instance and create it again.  - RESTART: Stop the instance and start it again.  - REFRESH: Do
        /// not stop the instance.  - NONE: Do not disrupt the instance at all.  By default, the minimum action is NONE.
        /// If your update requires a more disruptive action than you set with this flag, the necessary action is
        /// performed to execute the update.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minimalAction")]
        public virtual string MinimalAction { get; set; }

        /// <summary>
        /// The most disruptive action that you want to perform on each instance during the update:   - REPLACE: Delete
        /// the instance and create it again.  - RESTART: Stop the instance and start it again.  - REFRESH: Do not stop
        /// the instance.  - NONE: Do not disrupt the instance at all.  By default, the most disruptive allowed action
        /// is REPLACE. If your update requires a more disruptive action than you set with this flag, the update request
        /// will fail.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("mostDisruptiveAllowedAction")]
        public virtual string MostDisruptiveAllowedAction { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>RegionInstanceGroupManagers.createInstances</summary>
    public class RegionInstanceGroupManagersCreateInstancesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Required] List of specifications of per-instance configs.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<PerInstanceConfig> Instances { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RegionInstanceGroupManagersDeleteInstancesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The URLs of one or more instances to delete. This can be a full URL or a partial URL, such as
        /// zones/[ZONE]/instances/[INSTANCE_NAME].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<string> Instances { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RegionInstanceGroupManagersListErrorsResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The list of errors of the managed instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<InstanceManagedByIgmError> Items { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RegionInstanceGroupManagersListInstanceConfigsResp : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The list of PerInstanceConfig.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<PerInstanceConfig> Items { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class RegionInstanceGroupManagersListInstancesResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of managed instances.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("managedInstances")]
        public virtual System.Collections.Generic.IList<ManagedInstance> ManagedInstances { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RegionInstanceGroupManagersRecreateRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The URLs of one or more instances to recreate. This can be a full URL or a partial URL, such as
        /// zones/[ZONE]/instances/[INSTANCE_NAME].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<string> Instances { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RegionInstanceGroupManagersSetTargetPoolsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Fingerprint of the target pools information, which is a hash of the contents. This field is used for
        /// optimistic locking when you update the target pool entries. This field is optional.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// The URL of all TargetPool resources to which instances in the instanceGroup field are added. The target
        /// pools automatically apply to all of the instances in the managed instance group.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetPools")]
        public virtual System.Collections.Generic.IList<string> TargetPools { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RegionInstanceGroupManagersSetTemplateRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>URL of the InstanceTemplate resource from which all new instances will be created.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceTemplate")]
        public virtual string InstanceTemplate { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RegionInstanceGroupsListInstances : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of InstanceWithNamedPorts resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<InstanceWithNamedPorts> Items { get; set; }

        /// <summary>The resource type.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class RegionInstanceGroupsListInstancesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Instances in which state should be returned. Valid options are: 'ALL', 'RUNNING'. By default, it lists all
        /// instances.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceState")]
        public virtual string InstanceState { get; set; }

        /// <summary>
        /// Name of port user is interested in. It is optional. If it is set, only information about this ports will be
        /// returned. If it is not set, all the named ports will be returned. Always lists all instances.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portName")]
        public virtual string PortName { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RegionInstanceGroupsSetNamedPortsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The fingerprint of the named ports information for this instance group. Use this optional property to
        /// prevent conflicts when multiple users change the named ports settings concurrently. Obtain the fingerprint
        /// with the instanceGroups.get method. Then, include the fingerprint in your request to ensure that you do not
        /// overwrite changes that were applied from another concurrent request.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>The list of named ports to set for this instance group.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("namedPorts")]
        public virtual System.Collections.Generic.IList<NamedPort> NamedPorts { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of region resources.</summary>
    public class RegionList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Region resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Region> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#regionList for lists of regions.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class RegionSetLabelsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The fingerprint of the previous set of labels for this resource, used to detect conflicts. The fingerprint
        /// is initially generated by Compute Engine and changes after every request to modify or update labels. You
        /// must always provide an up-to-date fingerprint hash in order to update or change labels. Make a get() request
        /// to the resource to get the latest fingerprint.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labelFingerprint")]
        public virtual string LabelFingerprint { get; set; }

        /// <summary>The labels to set for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RegionSetPolicyRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Flatten Policy to create a backwacd compatible wire-format. Deprecated. Use 'policy' to specify bindings.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("bindings")]
        public virtual System.Collections.Generic.IList<Binding> Bindings { get; set; }

        /// <summary>
        /// Flatten Policy to create a backward compatible wire-format. Deprecated. Use 'policy' to specify the etag.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("etag")]
        public virtual string ETag { get; set; }

        /// <summary>
        /// REQUIRED: The complete policy to be applied to the 'resource'. The size of the policy is limited to a few
        /// 10s of KB. An empty policy is in general a valid policy but certain services (like Projects) might reject
        /// them.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("policy")]
        public virtual Policy Policy { get; set; }
    }

    public class RegionTargetHttpsProxiesSetSslCertificatesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// New set of SslCertificate resources to associate with this TargetHttpsProxy resource. Currently exactly one
        /// SslCertificate resource must be specified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sslCertificates")]
        public virtual System.Collections.Generic.IList<string> SslCertificates { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RegionUrlMapsValidateRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Content of the UrlMap to be validated.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resource")]
        public virtual UrlMap Resource { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// A policy that specifies how requests intended for the route's backends are shadowed to a separate mirrored
    /// backend service. Loadbalancer does not wait for responses from the shadow service. Prior to sending traffic to
    /// the shadow service, the host / authority header is suffixed with -shadow.
    /// </summary>
    public class RequestMirrorPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The full or partial URL to the BackendService resource being mirrored to.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("backendService")]
        public virtual string BackendService { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a reservation resource. A reservation ensures that capacity is held in a specific zone even if the
    /// reserved VMs are not running. For more information, read  Reserving zonal resources. (== resource_for
    /// {$api_version}.reservations ==)
    /// </summary>
    public class Reservation : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] Full or partial URL to a parent commitment. This field displays for reservations that are tied
        /// to a commitment.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("commitment")]
        public virtual string Commitment { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#reservations for reservations.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// The name of the resource, provided by the client when initially creating the resource. The resource name
        /// must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long
        /// and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
        /// lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last
        /// character, which cannot be a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] Reserved for future use.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("satisfiesPzs")]
        public virtual System.Nullable<bool> SatisfiesPzs { get; set; }

        /// <summary>[Output Only] Server-defined fully-qualified URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>Reservation for instances with specific machine shapes.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("specificReservation")]
        public virtual AllocationSpecificSKUReservation SpecificReservation { get; set; }

        /// <summary>
        /// Indicates whether the reservation can be consumed by VMs with affinity for "any" reservation. If the field
        /// is set, then only VMs that target the reservation by name can consume from this reservation.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("specificReservationRequired")]
        public virtual System.Nullable<bool> SpecificReservationRequired { get; set; }

        /// <summary>[Output Only] The status of the reservation.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>
        /// Zone in which the reservation resides. A zone must be provided if the reservation is created within a
        /// commitment.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Specifies the reservations that this instance can consume from.</summary>
    public class ReservationAffinity : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Specifies the type of reservation from which this instance can consume resources: ANY_RESERVATION (default),
        /// SPECIFIC_RESERVATION, or NO_RESERVATION. See  Consuming reserved instances for examples.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("consumeReservationType")]
        public virtual string ConsumeReservationType { get; set; }

        /// <summary>
        /// Corresponds to the label key of a reservation resource. To target a SPECIFIC_RESERVATION by name, specify
        /// googleapis.com/reservation-name as the key and specify the name of your reservation as its value.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("key")]
        public virtual string Key { get; set; }

        /// <summary>Corresponds to the label values of a reservation resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("values")]
        public virtual System.Collections.Generic.IList<string> Values { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of reservations.</summary>
    public class ReservationAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Allocation resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, ReservationsScopedList> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class ReservationList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>[Output Only] A list of Allocation resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Reservation> Items { get; set; }

        /// <summary>[Output Only] Type of resource.Always compute#reservationsList for listsof reservations</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class ReservationsResizeRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Number of allocated resources can be resized with minimum = 1 and maximum = 1000.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("specificSkuCount")]
        public virtual System.Nullable<long> SpecificSkuCount { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ReservationsScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of reservations contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("reservations")]
        public virtual System.Collections.Generic.IList<Reservation> Reservations { get; set; }

        /// <summary>Informational warning which replaces the list of reservations when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of reservations when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Commitment for a particular resource (a Commitment is composed of one or more of these).</summary>
    public class ResourceCommitment : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Name of the accelerator type resource. Applicable only when the type is ACCELERATOR.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("acceleratorType")]
        public virtual string AcceleratorType { get; set; }

        /// <summary>
        /// The amount of the resource purchased (in a type-dependent unit, such as bytes). For vCPUs, this can just be
        /// an integer. For memory, this must be provided in MB. Memory must be a multiple of 256 MB, with up to 6.5GB
        /// of memory per every vCPU.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("amount")]
        public virtual System.Nullable<long> Amount { get; set; }

        /// <summary>Type of resource for which this commitment applies. Possible values are VCPU and MEMORY</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ResourceGroupReference : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// A URI referencing one of the instance groups or network endpoint groups listed in the backend service.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("group")]
        public virtual string Group { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ResourcePoliciesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of resourcePolicies contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resourcePolicies")]
        public virtual System.Collections.Generic.IList<ResourcePolicy> ResourcePolicies { get; set; }

        /// <summary>Informational warning which replaces the list of resourcePolicies when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of resourcePolicies when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a Resource Policy resource. You can use resource policies to schedule actions for some Compute Engine
    /// resources. For example, you can use them to schedule persistent disk snapshots.  (== resource_for
    /// {$api_version}.resourcePolicies ==)
    /// </summary>
    public class ResourcePolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>Resource policy for instances for placement configuration.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("groupPlacementPolicy")]
        public virtual ResourcePolicyGroupPlacementPolicy GroupPlacementPolicy { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>Resource policy for scheduling instance operations.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceSchedulePolicy")]
        public virtual ResourcePolicyInstanceSchedulePolicy InstanceSchedulePolicy { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#resource_policies for resource policies.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// The name of the resource, provided by the client when initially creating the resource. The resource name
        /// must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long
        /// and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a
        /// lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last
        /// character, which cannot be a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] The system status of the resource policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resourceStatus")]
        public virtual ResourcePolicyResourceStatus ResourceStatus { get; set; }

        /// <summary>[Output Only] Server-defined fully-qualified URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>Resource policy for persistent disks for creating snapshots.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("snapshotSchedulePolicy")]
        public virtual ResourcePolicySnapshotSchedulePolicy SnapshotSchedulePolicy { get; set; }

        /// <summary>[Output Only] The status of resource policy creation.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of resourcePolicies.</summary>
    public class ResourcePolicyAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("etag")]
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of ResourcePolicy resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, ResourcePoliciesScopedList> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Time window specified for daily operations.</summary>
    public class ResourcePolicyDailyCycle : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Defines a schedule with units measured in months. The value determines how many months pass between the
        /// start of each cycle.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("daysInCycle")]
        public virtual System.Nullable<int> DaysInCycle { get; set; }

        /// <summary>
        /// [Output only] A predetermined duration for the window, automatically chosen to be the smallest possible in
        /// the given scenario.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("duration")]
        public virtual string Duration { get; set; }

        /// <summary>
        /// Start time of the window. This must be in UTC format that resolves to one of 00:00, 04:00, 08:00, 12:00,
        /// 16:00, or 20:00. For example, both 13:00-5 and 08:00 are valid.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("startTime")]
        public virtual string StartTime { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// A GroupPlacementPolicy specifies resource placement configuration. It specifies the failure bucket separation as
    /// well as network locality
    /// </summary>
    public class ResourcePolicyGroupPlacementPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The number of availability domains instances will be spread across. If two instances are in different
        /// availability domain, they will not be put in the same low latency network
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("availabilityDomainCount")]
        public virtual System.Nullable<int> AvailabilityDomainCount { get; set; }

        /// <summary>Specifies network collocation</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("collocation")]
        public virtual string Collocation { get; set; }

        /// <summary>Number of vms in this placement group</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("vmCount")]
        public virtual System.Nullable<int> VmCount { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Time window specified for hourly operations.</summary>
    public class ResourcePolicyHourlyCycle : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output only] Duration of the time window, automatically chosen to be smallest possible in the given
        /// scenario.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("duration")]
        public virtual string Duration { get; set; }

        /// <summary>
        /// Defines a schedule with units measured in hours. The value determines how many hours pass between the start
        /// of each cycle.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("hoursInCycle")]
        public virtual System.Nullable<int> HoursInCycle { get; set; }

        /// <summary>
        /// Time within the window to start the operations. It must be in format "HH:MM", where HH : [00-23] and MM :
        /// [00-00] GMT.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("startTime")]
        public virtual string StartTime { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// An InstanceSchedulePolicy specifies when and how frequent certain operations are performed on the instance.
    /// </summary>
    public class ResourcePolicyInstanceSchedulePolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The expiration time of the schedule. The timestamp is an RFC3339 string.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("expirationTime")]
        public virtual string ExpirationTime { get; set; }

        /// <summary>The start time of the schedule. The timestamp is an RFC3339 string.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("startTime")]
        public virtual string StartTime { get; set; }

        /// <summary>
        /// Specifies the time zone to be used in interpreting Schedule.schedule. The value of this field must be a time
        /// zone name from the tz database: http://en.wikipedia.org/wiki/Tz_database.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("timeZone")]
        public virtual string TimeZone { get; set; }

        /// <summary>Specifies the schedule for starting instances.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("vmStartSchedule")]
        public virtual ResourcePolicyInstanceSchedulePolicySchedule VmStartSchedule { get; set; }

        /// <summary>Specifies the schedule for stopping instances.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("vmStopSchedule")]
        public virtual ResourcePolicyInstanceSchedulePolicySchedule VmStopSchedule { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Schedule for an instance operation.</summary>
    public class ResourcePolicyInstanceSchedulePolicySchedule : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Specifies the frequency for the operation, using the unix-cron format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("schedule")]
        public virtual string Schedule { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ResourcePolicyList : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("etag")]
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>[Output Only] A list of ResourcePolicy resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<ResourcePolicy> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource.Always compute#resourcePoliciesList for listsof resourcePolicies
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Contains output only fields. Use this sub-message for all output fields set on ResourcePolicy. The internal
    /// structure of this "status" field should mimic the structure of ResourcePolicy proto specification.
    /// </summary>
    public class ResourcePolicyResourceStatus : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] Specifies a set of output values reffering to the instance_schedule_policy system status. This
        /// field should have the same name as corresponding policy field.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceSchedulePolicy")]
        public virtual ResourcePolicyResourceStatusInstanceSchedulePolicyStatus InstanceSchedulePolicy { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ResourcePolicyResourceStatusInstanceSchedulePolicyStatus : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] The last time the schedule successfully ran. The timestamp is an RFC3339 string.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("lastRunStartTime")]
        public virtual string LastRunStartTime { get; set; }

        /// <summary>
        /// [Output Only] The next time the schedule is planned to run. The actual time might be slightly different. The
        /// timestamp is an RFC3339 string.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextRunStartTime")]
        public virtual string NextRunStartTime { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// A snapshot schedule policy specifies when and how frequently snapshots are to be created for the target disk.
    /// Also specifies how many and how long these scheduled snapshots should be retained.
    /// </summary>
    public class ResourcePolicySnapshotSchedulePolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Retention policy applied to snapshots created by this resource policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("retentionPolicy")]
        public virtual ResourcePolicySnapshotSchedulePolicyRetentionPolicy RetentionPolicy { get; set; }

        /// <summary>
        /// A Vm Maintenance Policy specifies what kind of infrastructure maintenance we are allowed to perform on this
        /// VM and when. Schedule that is applied to disks covered by this policy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("schedule")]
        public virtual ResourcePolicySnapshotSchedulePolicySchedule Schedule { get; set; }

        /// <summary>Properties with which snapshots are created such as labels, encryption keys.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("snapshotProperties")]
        public virtual ResourcePolicySnapshotSchedulePolicySnapshotProperties SnapshotProperties { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Policy for retention of scheduled snapshots.</summary>
    public class ResourcePolicySnapshotSchedulePolicyRetentionPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Maximum age of the snapshot that is allowed to be kept.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("maxRetentionDays")]
        public virtual System.Nullable<int> MaxRetentionDays { get; set; }

        /// <summary>Specifies the behavior to apply to scheduled snapshots when the source disk is deleted.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("onSourceDiskDelete")]
        public virtual string OnSourceDiskDelete { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A schedule for disks where the schedueled operations are performed.</summary>
    public class ResourcePolicySnapshotSchedulePolicySchedule : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("dailySchedule")]
        public virtual ResourcePolicyDailyCycle DailySchedule { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("hourlySchedule")]
        public virtual ResourcePolicyHourlyCycle HourlySchedule { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("weeklySchedule")]
        public virtual ResourcePolicyWeeklyCycle WeeklySchedule { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Specified snapshot properties for scheduled snapshots created by this policy.</summary>
    public class ResourcePolicySnapshotSchedulePolicySnapshotProperties : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Chain name that the snapshot is created in.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("chainName")]
        public virtual string ChainName { get; set; }

        /// <summary>Indication to perform a 'guest aware' snapshot.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("guestFlush")]
        public virtual System.Nullable<bool> GuestFlush { get; set; }

        /// <summary>
        /// Labels to apply to scheduled snapshots. These can be later modified by the setLabels method. Label values
        /// may be empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>Cloud Storage bucket storage location of the auto snapshot (regional or multi-regional).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("storageLocations")]
        public virtual System.Collections.Generic.IList<string> StorageLocations { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Time window specified for weekly operations.</summary>
    public class ResourcePolicyWeeklyCycle : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Up to 7 intervals/windows, one for each day of the week.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("dayOfWeeks")]
        public virtual System.Collections.Generic.IList<ResourcePolicyWeeklyCycleDayOfWeek> DayOfWeeks { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ResourcePolicyWeeklyCycleDayOfWeek : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Defines a schedule that runs on specific days of the week. Specify one or more days. The following options
        /// are available: MONDAY, TUESDAY, WEDNESDAY, THURSDAY, FRIDAY, SATURDAY, SUNDAY.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("day")]
        public virtual string Day { get; set; }

        /// <summary>
        /// [Output only] Duration of the time window, automatically chosen to be smallest possible in the given
        /// scenario.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("duration")]
        public virtual string Duration { get; set; }

        /// <summary>
        /// Time within the window to start the operations. It must be in format "HH:MM", where HH : [00-23] and MM :
        /// [00-00] GMT.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("startTime")]
        public virtual string StartTime { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Route resource.  A route defines a path from VM instances in the VPC network to a specific
    /// destination. This destination can be inside or outside the VPC network. For more information, read the Routes
    /// overview. (== resource_for {$api_version}.routes ==)
    /// </summary>
    public class Route : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this field when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// The destination range of outgoing packets that this route applies to. Both IPv4 and IPv6 are supported.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("destRange")]
        public virtual string DestRange { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of this resource. Always compute#routes for Route resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?`. The first character must be a lowercase letter, and all following
        /// characters (except for the last character) must be a dash, lowercase letter, or digit. The last character
        /// must be a lowercase letter or digit.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>Fully-qualified URL of the network that this route applies to.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>
        /// The URL to a gateway that should handle matching packets. You can only specify the internet gateway using a
        /// full or partial valid URL:  projects/project/global/gateways/default-internet-gateway
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextHopGateway")]
        public virtual string NextHopGateway { get; set; }

        /// <summary>
        /// The URL to a forwarding rule of type loadBalancingScheme=INTERNAL that should handle matching packets or the
        /// IP address of the forwarding Rule. For example, the following are all valid URLs:   - 10.128.0.56  -
        /// https://www.googleapis.com/compute/v1/projects/project/regions/region/forwardingRules/forwardingRule  -
        /// regions/region/forwardingRules/forwardingRule
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextHopIlb")]
        public virtual string NextHopIlb { get; set; }

        /// <summary>
        /// The URL to an instance that should handle matching packets. You can specify this as a full or partial URL.
        /// For example: https://www.googleapis.com/compute/v1/projects/project/zones/zone/instances/
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextHopInstance")]
        public virtual string NextHopInstance { get; set; }

        /// <summary>
        /// The network IP address of an instance that should handle matching packets. Only IPv4 is supported.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextHopIp")]
        public virtual string NextHopIp { get; set; }

        /// <summary>The URL of the local network if it should handle matching packets.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextHopNetwork")]
        public virtual string NextHopNetwork { get; set; }

        /// <summary>
        /// [Output Only] The network peering name that should handle matching packets, which should conform to RFC1035.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextHopPeering")]
        public virtual string NextHopPeering { get; set; }

        /// <summary>The URL to a VpnTunnel that should handle matching packets.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextHopVpnTunnel")]
        public virtual string NextHopVpnTunnel { get; set; }

        /// <summary>
        /// The priority of this route. Priority is used to break ties in cases where there is more than one matching
        /// route of equal prefix length. In cases where multiple routes have equal prefix length, the one with the
        /// lowest-numbered priority value wins. The default value is `1000`. The priority value must be from `0` to
        /// `65535`, inclusive.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("priority")]
        public virtual System.Nullable<long> Priority { get; set; }

        /// <summary>[Output Only] Server-defined fully-qualified URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>A list of instance tags to which this route applies.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("tags")]
        public virtual System.Collections.Generic.IList<string> Tags { get; set; }

        /// <summary>
        /// [Output Only] If potential misconfigurations are detected for this route, this field will be populated with
        /// warning messages.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warnings")]
        public virtual System.Collections.Generic.IList<WarningsData> Warnings { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] If potential misconfigurations are detected for this route, this field will be populated with
        /// warning messages.
        /// </summary>
        public class WarningsData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of Route resources.</summary>
    public class RouteList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Route resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Route> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a Cloud Router resource.  For more information about Cloud Router, read the Cloud Router overview.
    /// </summary>
    public class Router : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>BGP information specific to this router.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("bgp")]
        public virtual RouterBgp Bgp { get; set; }

        /// <summary>
        /// BGP information that must be configured into the routing stack to establish BGP peering. This information
        /// must specify the peer ASN and either the interface name, IP address, or peer IP address. Please refer to
        /// RFC4273.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("bgpPeers")]
        public virtual System.Collections.Generic.IList<RouterBgpPeer> BgpPeers { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// Router interfaces. Each interface requires either one linked resource, (for example, linkedVpnTunnel), or IP
        /// address and IP address range (for example, ipRange), or both.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("interfaces")]
        public virtual System.Collections.Generic.IList<RouterInterface> Interfaces { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#router for routers.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>A list of NAT services created in this router.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nats")]
        public virtual System.Collections.Generic.IList<RouterNat> Nats { get; set; }

        /// <summary>URI of the network to which this router belongs.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>
        /// [Output Only] URI of the region where the router resides. You must specify this field as part of the HTTP
        /// request URL. It is not settable as a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Description-tagged IP ranges for the router to advertise.</summary>
    public class RouterAdvertisedIpRange : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>User-specified description for the IP range.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>The IP range to advertise. The value must be a CIDR-formatted string.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("range")]
        public virtual string Range { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of routers.</summary>
    public class RouterAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Router resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, RoutersScopedList> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class RouterBgp : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// User-specified flag to indicate which mode to use for advertisement. The options are DEFAULT or CUSTOM.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("advertiseMode")]
        public virtual string AdvertiseMode { get; set; }

        /// <summary>
        /// User-specified list of prefix groups to advertise in custom mode. This field can only be populated if
        /// advertise_mode is CUSTOM and is advertised to all peers of the router. These groups will be advertised in
        /// addition to any specified prefixes. Leave this field blank to advertise no custom groups.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("advertisedGroups")]
        public virtual System.Collections.Generic.IList<string> AdvertisedGroups { get; set; }

        /// <summary>
        /// User-specified list of individual IP ranges to advertise in custom mode. This field can only be populated if
        /// advertise_mode is CUSTOM and is advertised to all peers of the router. These IP ranges will be advertised in
        /// addition to any specified groups. Leave this field blank to advertise no custom IP ranges.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("advertisedIpRanges")]
        public virtual System.Collections.Generic.IList<RouterAdvertisedIpRange> AdvertisedIpRanges { get; set; }

        /// <summary>
        /// Local BGP Autonomous System Number (ASN). Must be an RFC6996 private ASN, either 16-bit or 32-bit. The value
        /// will be fixed for this router resource. All VPN tunnels that link to this router will have the same local
        /// ASN.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("asn")]
        public virtual System.Nullable<long> Asn { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RouterBgpPeer : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>User-specified flag to indicate which mode to use for advertisement.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("advertiseMode")]
        public virtual string AdvertiseMode { get; set; }

        /// <summary>
        /// User-specified list of prefix groups to advertise in custom mode, which can take one of the following
        /// options:  - ALL_SUBNETS: Advertises all available subnets, including peer VPC subnets.  - ALL_VPC_SUBNETS:
        /// Advertises the router's own VPC subnets.  - ALL_PEER_VPC_SUBNETS: Advertises peer subnets of the router's
        /// VPC network. Note that this field can only be populated if advertise_mode is CUSTOM and overrides the list
        /// defined for the router (in the "bgp" message). These groups are advertised in addition to any specified
        /// prefixes. Leave this field blank to advertise no custom groups.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("advertisedGroups")]
        public virtual System.Collections.Generic.IList<string> AdvertisedGroups { get; set; }

        /// <summary>
        /// User-specified list of individual IP ranges to advertise in custom mode. This field can only be populated if
        /// advertise_mode is CUSTOM and overrides the list defined for the router (in the "bgp" message). These IP
        /// ranges are advertised in addition to any specified groups. Leave this field blank to advertise no custom IP
        /// ranges.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("advertisedIpRanges")]
        public virtual System.Collections.Generic.IList<RouterAdvertisedIpRange> AdvertisedIpRanges { get; set; }

        /// <summary>
        /// The priority of routes advertised to this BGP peer. Where there is more than one matching route of maximum
        /// length, the routes with the lowest priority value win.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("advertisedRoutePriority")]
        public virtual System.Nullable<long> AdvertisedRoutePriority { get; set; }

        /// <summary>Name of the interface the BGP peer is associated with.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("interfaceName")]
        public virtual string InterfaceName { get; set; }

        /// <summary>IP address of the interface inside Google Cloud Platform. Only IPv4 is supported.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipAddress")]
        public virtual string IpAddress { get; set; }

        /// <summary>
        /// [Output Only] The resource that configures and manages this BGP peer.  - MANAGED_BY_USER is the default
        /// value and can be managed by you or other users  - MANAGED_BY_ATTACHMENT is a BGP peer that is configured and
        /// managed by Cloud Interconnect, specifically by an InterconnectAttachment of type PARTNER. Google
        /// automatically creates, updates, and deletes this type of BGP peer when the PARTNER InterconnectAttachment is
        /// created, updated, or deleted.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("managementType")]
        public virtual string ManagementType { get; set; }

        /// <summary>
        /// Name of this BGP peer. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the
        /// name must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means
        /// the first character must be a lowercase letter, and all following characters must be a dash, lowercase
        /// letter, or digit, except the last character, which cannot be a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>Peer BGP Autonomous System Number (ASN). Each BGP interface may use a different value.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerAsn")]
        public virtual System.Nullable<long> PeerAsn { get; set; }

        /// <summary>IP address of the BGP interface outside Google Cloud Platform. Only IPv4 is supported.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerIpAddress")]
        public virtual string PeerIpAddress { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RouterInterface : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// IP address and range of the interface. The IP range must be in the RFC3927 link-local IP address space. The
        /// value must be a CIDR-formatted string, for example: 169.254.0.1/30. NOTE: Do not truncate the address as it
        /// represents the IP address of the interface.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipRange")]
        public virtual string IpRange { get; set; }

        /// <summary>
        /// URI of the linked Interconnect attachment. It must be in the same region as the router. Each interface can
        /// have one linked resource, which can be a VPN tunnel, an Interconnect attachment, or a virtual machine
        /// instance.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("linkedInterconnectAttachment")]
        public virtual string LinkedInterconnectAttachment { get; set; }

        /// <summary>
        /// URI of the linked VPN tunnel, which must be in the same region as the router. Each interface can have one
        /// linked resource, which can be a VPN tunnel, an Interconnect attachment, or a virtual machine instance.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("linkedVpnTunnel")]
        public virtual string LinkedVpnTunnel { get; set; }

        /// <summary>
        /// [Output Only] The resource that configures and manages this interface.  - MANAGED_BY_USER is the default
        /// value and can be managed directly by users.  - MANAGED_BY_ATTACHMENT is an interface that is configured and
        /// managed by Cloud Interconnect, specifically, by an InterconnectAttachment of type PARTNER. Google
        /// automatically creates, updates, and deletes this type of interface when the PARTNER InterconnectAttachment
        /// is created, updated, or deleted.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("managementType")]
        public virtual string ManagementType { get; set; }

        /// <summary>
        /// Name of this interface entry. The name must be 1-63 characters long, and comply with RFC1035. Specifically,
        /// the name must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which
        /// means the first character must be a lowercase letter, and all following characters must be a dash, lowercase
        /// letter, or digit, except the last character, which cannot be a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of Router resources.</summary>
    public class RouterList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Router resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Router> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#router for routers.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a Nat resource. It enables the VMs within the specified subnetworks to access Internet without
    /// external IP addresses. It specifies a list of subnetworks (and the ranges within) that want to use NAT.
    /// Customers can also provide the external IPs that would be used for NAT. GCP would auto-allocate ephemeral IPs if
    /// no external IPs are provided.
    /// </summary>
    public class RouterNat : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// A list of URLs of the IP resources to be drained. These IPs must be valid static external IPs that have been
        /// assigned to the NAT. These IPs should be used for updating/patching a NAT only.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("drainNatIps")]
        public virtual System.Collections.Generic.IList<string> DrainNatIps { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("enableEndpointIndependentMapping")]
        public virtual System.Nullable<bool> EnableEndpointIndependentMapping { get; set; }

        /// <summary>Timeout (in seconds) for ICMP connections. Defaults to 30s if not set.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("icmpIdleTimeoutSec")]
        public virtual System.Nullable<int> IcmpIdleTimeoutSec { get; set; }

        /// <summary>Configure logging on this NAT.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("logConfig")]
        public virtual RouterNatLogConfig LogConfig { get; set; }

        /// <summary>
        /// Minimum number of ports allocated to a VM from this NAT config. If not set, a default number of ports is
        /// allocated to a VM. This is rounded up to the nearest power of 2. For example, if the value of this field is
        /// 50, at least 64 ports are allocated to a VM.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minPortsPerVm")]
        public virtual System.Nullable<int> MinPortsPerVm { get; set; }

        /// <summary>
        /// Unique name of this Nat service. The name must be 1-63 characters long and comply with RFC1035.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// Specify the NatIpAllocateOption, which can take one of the following values:  - MANUAL_ONLY: Uses only Nat
        /// IP addresses provided by customers. When there are not enough specified Nat IPs, the Nat service fails for
        /// new VMs.  - AUTO_ONLY: Nat IPs are allocated by Google Cloud Platform; customers can't specify any Nat IPs.
        /// When choosing AUTO_ONLY, then nat_ip should be empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("natIpAllocateOption")]
        public virtual string NatIpAllocateOption { get; set; }

        /// <summary>
        /// A list of URLs of the IP resources used for this Nat service. These IP addresses must be valid static
        /// external IP addresses assigned to the project.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("natIps")]
        public virtual System.Collections.Generic.IList<string> NatIps { get; set; }

        /// <summary>
        /// Specify the Nat option, which can take one of the following values:  - ALL_SUBNETWORKS_ALL_IP_RANGES: All of
        /// the IP ranges in every Subnetwork are allowed to Nat.  - ALL_SUBNETWORKS_ALL_PRIMARY_IP_RANGES: All of the
        /// primary IP ranges in every Subnetwork are allowed to Nat.  - LIST_OF_SUBNETWORKS: A list of Subnetworks are
        /// allowed to Nat (specified in the field subnetwork below) The default is
        /// SUBNETWORK_IP_RANGE_TO_NAT_OPTION_UNSPECIFIED. Note that if this field contains
        /// ALL_SUBNETWORKS_ALL_IP_RANGES or ALL_SUBNETWORKS_ALL_PRIMARY_IP_RANGES, then there should not be any other
        /// Router.Nat section in any Router for this network in this region.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceSubnetworkIpRangesToNat")]
        public virtual string SourceSubnetworkIpRangesToNat { get; set; }

        /// <summary>
        /// A list of Subnetwork resources whose traffic should be translated by NAT Gateway. It is used only when
        /// LIST_OF_SUBNETWORKS is selected for the SubnetworkIpRangeToNatOption above.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("subnetworks")]
        public virtual System.Collections.Generic.IList<RouterNatSubnetworkToNat> Subnetworks { get; set; }

        /// <summary>Timeout (in seconds) for TCP established connections. Defaults to 1200s if not set.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("tcpEstablishedIdleTimeoutSec")]
        public virtual System.Nullable<int> TcpEstablishedIdleTimeoutSec { get; set; }

        /// <summary>Timeout (in seconds) for TCP transitory connections. Defaults to 30s if not set.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("tcpTransitoryIdleTimeoutSec")]
        public virtual System.Nullable<int> TcpTransitoryIdleTimeoutSec { get; set; }

        /// <summary>Timeout (in seconds) for UDP connections. Defaults to 30s if not set.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("udpIdleTimeoutSec")]
        public virtual System.Nullable<int> UdpIdleTimeoutSec { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Configuration of logging on a NAT.</summary>
    public class RouterNatLogConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Indicates whether or not to export logs. This is false by default.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enable")]
        public virtual System.Nullable<bool> Enable { get; set; }

        /// <summary>
        /// Specify the desired filtering of logs on this NAT. If unspecified, logs are exported for all connections
        /// handled by this NAT. This option can take one of the following values:  - ERRORS_ONLY: Export logs only for
        /// connection failures.  - TRANSLATIONS_ONLY: Export logs only for successful connections.  - ALL: Export logs
        /// for all connections, successful and unsuccessful.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("filter")]
        public virtual string Filter { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Defines the IP ranges that want to use NAT for a subnetwork.</summary>
    public class RouterNatSubnetworkToNat : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>URL for the subnetwork resource that will use NAT.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// A list of the secondary ranges of the Subnetwork that are allowed to use NAT. This can be populated only if
        /// "LIST_OF_SECONDARY_IP_RANGES" is one of the values in source_ip_ranges_to_nat.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("secondaryIpRangeNames")]
        public virtual System.Collections.Generic.IList<string> SecondaryIpRangeNames { get; set; }

        /// <summary>
        /// Specify the options for NAT ranges in the Subnetwork. All options of a single value are valid except
        /// NAT_IP_RANGE_OPTION_UNSPECIFIED. The only valid option with multiple values is: ["PRIMARY_IP_RANGE",
        /// "LIST_OF_SECONDARY_IP_RANGES"] Default: [ALL_IP_RANGES]
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceIpRangesToNat")]
        public virtual System.Collections.Generic.IList<string> SourceIpRangesToNat { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RouterStatus : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Best routes for this router's network.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("bestRoutes")]
        public virtual System.Collections.Generic.IList<Route> BestRoutes { get; set; }

        /// <summary>Best routes learned by this router.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("bestRoutesForRouter")]
        public virtual System.Collections.Generic.IList<Route> BestRoutesForRouter { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("bgpPeerStatus")]
        public virtual System.Collections.Generic.IList<RouterStatusBgpPeerStatus> BgpPeerStatus { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("natStatus")]
        public virtual System.Collections.Generic.IList<RouterStatusNatStatus> NatStatus { get; set; }

        /// <summary>URI of the network to which this router belongs.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RouterStatusBgpPeerStatus : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Routes that were advertised to the remote BGP peer</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("advertisedRoutes")]
        public virtual System.Collections.Generic.IList<Route> AdvertisedRoutes { get; set; }

        /// <summary>IP address of the local BGP interface.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipAddress")]
        public virtual string IpAddress { get; set; }

        /// <summary>URL of the VPN tunnel that this BGP peer controls.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("linkedVpnTunnel")]
        public virtual string LinkedVpnTunnel { get; set; }

        /// <summary>Name of this BGP peer. Unique within the Routers resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>Number of routes learned from the remote BGP Peer.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("numLearnedRoutes")]
        public virtual System.Nullable<long> NumLearnedRoutes { get; set; }

        /// <summary>IP address of the remote BGP interface.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerIpAddress")]
        public virtual string PeerIpAddress { get; set; }

        /// <summary>BGP state as specified in RFC1771.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("state")]
        public virtual string State { get; set; }

        /// <summary>Status of the BGP peer: {UP, DOWN}</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>
        /// Time this session has been up. Format: 14 years, 51 weeks, 6 days, 23 hours, 59 minutes, 59 seconds
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("uptime")]
        public virtual string Uptime { get; set; }

        /// <summary>Time this session has been up, in seconds. Format: 145</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("uptimeSeconds")]
        public virtual string UptimeSeconds { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Status of a NAT contained in this router.</summary>
    public class RouterStatusNatStatus : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of IPs auto-allocated for NAT. Example: ["1.1.1.1", "129.2.16.89"]</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoAllocatedNatIps")]
        public virtual System.Collections.Generic.IList<string> AutoAllocatedNatIps { get; set; }

        /// <summary>
        /// A list of IPs auto-allocated for NAT that are in drain mode. Example: ["1.1.1.1", "179.12.26.133"].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("drainAutoAllocatedNatIps")]
        public virtual System.Collections.Generic.IList<string> DrainAutoAllocatedNatIps { get; set; }

        /// <summary>
        /// A list of IPs user-allocated for NAT that are in drain mode. Example: ["1.1.1.1", "179.12.26.133"].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("drainUserAllocatedNatIps")]
        public virtual System.Collections.Generic.IList<string> DrainUserAllocatedNatIps { get; set; }

        /// <summary>
        /// The number of extra IPs to allocate. This will be greater than 0 only if user-specified IPs are NOT enough
        /// to allow all configured VMs to use NAT. This value is meaningful only when auto-allocation of NAT IPs is
        /// *not* used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minExtraNatIpsNeeded")]
        public virtual System.Nullable<int> MinExtraNatIpsNeeded { get; set; }

        /// <summary>Unique name of this NAT.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>Number of VM endpoints (i.e., Nics) that can use NAT.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("numVmEndpointsWithNatMappings")]
        public virtual System.Nullable<int> NumVmEndpointsWithNatMappings { get; set; }

        /// <summary>A list of fully qualified URLs of reserved IP address resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("userAllocatedNatIpResources")]
        public virtual System.Collections.Generic.IList<string> UserAllocatedNatIpResources { get; set; }

        /// <summary>A list of IPs user-allocated for NAT. They will be raw IP strings like "179.12.26.133".</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("userAllocatedNatIps")]
        public virtual System.Collections.Generic.IList<string> UserAllocatedNatIps { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RouterStatusResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("result")]
        public virtual RouterStatus Result { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RoutersPreviewResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Preview of given router.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resource")]
        public virtual Router Resource { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class RoutersScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of routers contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("routers")]
        public virtual System.Collections.Generic.IList<Router> Routers { get; set; }

        /// <summary>Informational warning which replaces the list of routers when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of routers when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>A rule to be applied in a Policy.</summary>
    public class Rule : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Required</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("action")]
        public virtual string Action { get; set; }

        /// <summary>Additional restrictions that must be met. All conditions must pass for the rule to match.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("conditions")]
        public virtual System.Collections.Generic.IList<Condition> Conditions { get; set; }

        /// <summary>Human-readable description of the rule.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// If one or more 'in' clauses are specified, the rule matches if the PRINCIPAL/AUTHORITY_SELECTOR is in at
        /// least one of these entries.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ins")]
        public virtual System.Collections.Generic.IList<string> Ins { get; set; }

        /// <summary>
        /// The config returned to callers of tech.iam.IAM.CheckPolicy for any entries that match the LOG action.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("logConfigs")]
        public virtual System.Collections.Generic.IList<LogConfig> LogConfigs { get; set; }

        /// <summary>
        /// If one or more 'not_in' clauses are specified, the rule matches if the PRINCIPAL/AUTHORITY_SELECTOR is in
        /// none of the entries.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("notIns")]
        public virtual System.Collections.Generic.IList<string> NotIns { get; set; }

        /// <summary>
        /// A permission is a string of form '..' (e.g., 'storage.buckets.list'). A value of '*' matches all
        /// permissions, and a verb part of '*' (e.g., 'storage.buckets.*') matches all verbs.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("permissions")]
        public virtual System.Collections.Generic.IList<string> Permissions { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class SSLHealthCheck : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The TCP port number for the health check request. The default value is 443. Valid values are 1 through
        /// 65535.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("port")]
        public virtual System.Nullable<int> Port { get; set; }

        /// <summary>
        /// Port name as defined in InstanceGroup#NamedPort#name. If both port and port_name are defined, port takes
        /// precedence.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portName")]
        public virtual string PortName { get; set; }

        /// <summary>
        /// Specifies how port is selected for health checking, can be one of following values: USE_FIXED_PORT: The port
        /// number in port is used for health checking. USE_NAMED_PORT: The portName is used for health checking.
        /// USE_SERVING_PORT: For NetworkEndpointGroup, the port specified for each network endpoint is used for health
        /// checking. For other backends, the port or named port specified in the Backend Service is used for health
        /// checking.   If not specified, SSL health check follows behavior specified in port and portName fields.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portSpecification")]
        public virtual string PortSpecification { get; set; }

        /// <summary>
        /// Specifies the type of proxy header to append before sending data to the backend, either NONE or PROXY_V1.
        /// The default is NONE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("proxyHeader")]
        public virtual string ProxyHeader { get; set; }

        /// <summary>
        /// The application data to send once the SSL connection has been established (default value is empty). If both
        /// request and response are empty, the connection establishment alone will indicate health. The request data
        /// can only be ASCII.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("request")]
        public virtual string Request { get; set; }

        /// <summary>
        /// The bytes to match against the beginning of the response data. If left empty (the default value), any
        /// response will indicate health. The response data can only be ASCII.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("response")]
        public virtual string Response { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Sets the scheduling options for an Instance. NextID: 17</summary>
    public class Scheduling : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Specifies whether the instance should be automatically restarted if it is terminated by Compute Engine (not
        /// terminated by a user). You can only set the automatic restart option for standard instances. Preemptible
        /// instances cannot be automatically restarted.  By default, this is set to true so an instance is
        /// automatically restarted if it is terminated by Compute Engine.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("automaticRestart")]
        public virtual System.Nullable<bool> AutomaticRestart { get; set; }

        /// <summary>
        /// An opaque location hint used to place the instance close to other resources. This field is for use by
        /// internal tools that use the public API.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("locationHint")]
        public virtual string LocationHint { get; set; }

        /// <summary>
        /// The minimum number of virtual CPUs this instance will consume when running on a sole-tenant node.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minNodeCpus")]
        public virtual System.Nullable<int> MinNodeCpus { get; set; }

        /// <summary>
        /// A set of node affinity and anti-affinity configurations. Refer to Configuring node affinity for more
        /// information. Overrides reservationAffinity.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nodeAffinities")]
        public virtual System.Collections.Generic.IList<SchedulingNodeAffinity> NodeAffinities { get; set; }

        /// <summary>
        /// Defines the maintenance behavior for this instance. For standard instances, the default behavior is MIGRATE.
        /// For preemptible instances, the default and only possible behavior is TERMINATE. For more information, see
        /// Setting Instance Scheduling Options.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("onHostMaintenance")]
        public virtual string OnHostMaintenance { get; set; }

        /// <summary>
        /// Defines whether the instance is preemptible. This can only be set during instance creation or while the
        /// instance is stopped and therefore, in a `TERMINATED` state. See Instance Life Cycle for more information on
        /// the possible instance states.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("preemptible")]
        public virtual System.Nullable<bool> Preemptible { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Node Affinity: the configuration of desired nodes onto which this Instance could be scheduled.
    /// </summary>
    public class SchedulingNodeAffinity : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Corresponds to the label key of Node resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("key")]
        public virtual string Key { get; set; }

        /// <summary>
        /// Defines the operation of node selection. Valid operators are IN for affinity and NOT_IN for anti-affinity.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("operator")]
        public virtual string Operator__ { get; set; }

        /// <summary>Corresponds to the label values of Node resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("values")]
        public virtual System.Collections.Generic.IList<string> Values { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>An instance's screenshot.</summary>
    public class Screenshot : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The Base64-encoded screenshot data.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("contents")]
        public virtual string Contents { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#screenshot for the screenshots.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class SecurityPoliciesListPreconfiguredExpressionSetsResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("preconfiguredExpressionSets")]
        public virtual SecurityPoliciesWafConfig PreconfiguredExpressionSets { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class SecurityPoliciesWafConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("wafRules")]
        public virtual PreconfiguredWafSet WafRules { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Google Cloud Armor security policy resource.  Only external backend services that use load
    /// balancers can reference a security policy. For more information, see  Google Cloud Armor security policy
    /// overview. (== resource_for {$api_version}.securityPolicies ==)
    /// </summary>
    public class SecurityPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Specifies a fingerprint for this resource, which is essentially a hash of the metadata's contents and used
        /// for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every
        /// request to modify or update metadata. You must always provide an up-to-date fingerprint hash in order to
        /// update or change metadata, otherwise the request will fail with error 412 conditionNotMet.  To see the
        /// latest fingerprint, make get() request to the security policy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output only] Type of the resource. Always compute#securityPolicyfor security policies</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// A list of rules that belong to this policy. There must always be a default rule (rule with priority
        /// 2147483647 and match "*"). If no rules are provided when creating a security policy, a default rule with
        /// action "allow" will be added.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("rules")]
        public virtual System.Collections.Generic.IList<SecurityPolicyRule> Rules { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class SecurityPolicyList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of SecurityPolicy resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<SecurityPolicy> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#securityPolicyList for listsof securityPolicies
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class SecurityPolicyReference : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("securityPolicy")]
        public virtual string SecurityPolicy { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a rule that describes one or more match conditions along with the action to be taken when traffic
    /// matches this condition (allow or deny).
    /// </summary>
    public class SecurityPolicyRule : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The Action to preform when the client connection triggers the rule. Can currently be either "allow" or
        /// "deny()" where valid values for status are 403, 404, and 502.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("action")]
        public virtual string Action { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output only] Type of the resource. Always compute#securityPolicyRule for security policy rules
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// A match condition that incoming traffic is evaluated against. If it evaluates to true, the corresponding
        /// 'action' is enforced.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("match")]
        public virtual SecurityPolicyRuleMatcher Match { get; set; }

        /// <summary>If set to true, the specified action is not enforced.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("preview")]
        public virtual System.Nullable<bool> Preview { get; set; }

        /// <summary>
        /// An integer indicating the priority of a rule in the list. The priority must be a positive value between 0
        /// and 2147483647. Rules are evaluated from highest to lowest priority where 0 is the highest priority and
        /// 2147483647 is the lowest priority.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("priority")]
        public virtual System.Nullable<int> Priority { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a match condition that incoming traffic is evaluated against. Exactly one field must be specified.
    /// </summary>
    public class SecurityPolicyRuleMatcher : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The configuration options available when specifying versioned_expr. This field must be specified if
        /// versioned_expr is specified and cannot be specified if versioned_expr is not specified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("config")]
        public virtual SecurityPolicyRuleMatcherConfig Config { get; set; }

        /// <summary>
        /// User defined CEVAL expression. A CEVAL expression is used to specify match criteria such as origin.ip,
        /// source.region_code and contents in the request header.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("expr")]
        public virtual Expr Expr { get; set; }

        /// <summary>
        /// Preconfigured versioned expression. If this field is specified, config must also be specified. Available
        /// preconfigured expressions along with their requirements are: SRC_IPS_V1 - must specify the corresponding
        /// src_ip_range field in config.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("versionedExpr")]
        public virtual string VersionedExpr { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class SecurityPolicyRuleMatcherConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>CIDR IP address range. Maximum number of src_ip_ranges allowed is 10.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("srcIpRanges")]
        public virtual System.Collections.Generic.IList<string> SrcIpRanges { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>The authentication and authorization settings for a BackendService.</summary>
    public class SecuritySettings : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Optional. A URL referring to a networksecurity.ClientTlsPolicy resource that describes how clients should
        /// authenticate with this service's backends. clientTlsPolicy only applies to a global BackendService with the
        /// loadBalancingScheme set to INTERNAL_SELF_MANAGED. If left blank, communications are not encrypted. Note:
        /// This field currently has no impact.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("clientTlsPolicy")]
        public virtual string ClientTlsPolicy { get; set; }

        /// <summary>
        /// Optional. A list of Subject Alternative Names (SANs) that the client verifies during a mutual TLS handshake
        /// with an server/endpoint for this BackendService. When the server presents its X.509 certificate to the
        /// client, the client inspects the certificate's subjectAltName field. If the field contains one of the
        /// specified values, the communication continues. Otherwise, it fails. This additional check enables the client
        /// to verify that the server is authorized to run the requested service. Note that the contents of the server
        /// certificate's subjectAltName field are configured by the Public Key Infrastructure which provisions server
        /// identities. Only applies to a global BackendService with loadBalancingScheme set to INTERNAL_SELF_MANAGED.
        /// Only applies when BackendService has an attached clientTlsPolicy with clientCertificate (mTLS mode). Note:
        /// This field currently has no impact.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("subjectAltNames")]
        public virtual System.Collections.Generic.IList<string> SubjectAltNames { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>An instance's serial console output.</summary>
    public class SerialPortOutput : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] The contents of the console output.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("contents")]
        public virtual string Contents { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#serialPortOutput for serial port output.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] The position of the next byte of content, regardless of whether the content exists, following
        /// the output returned in the `contents` property. Use this value in the next request as the start parameter.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("next")]
        public virtual System.Nullable<long> Next { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// The starting byte position of the output that was returned. This should match the start parameter sent with
        /// the request. If the serial console output exceeds the size of the buffer (1 MB), older output is overwritten
        /// by newer content. The output start value will indicate the byte position of the output that was returned,
        /// which might be different than the `start` value that was specified in the request.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("start")]
        public virtual System.Nullable<long> Start { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ServerBinding : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A service account.</summary>
    public class ServiceAccount : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Email address of the service account.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("email")]
        public virtual string Email { get; set; }

        /// <summary>The list of scopes to be made available for this service account.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("scopes")]
        public virtual System.Collections.Generic.IList<string> Scopes { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A set of Shielded Instance options.</summary>
    public class ShieldedInstanceConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Defines whether the instance has integrity monitoring enabled. Enabled by default.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enableIntegrityMonitoring")]
        public virtual System.Nullable<bool> EnableIntegrityMonitoring { get; set; }

        /// <summary>Defines whether the instance has Secure Boot enabled. Disabled by default.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enableSecureBoot")]
        public virtual System.Nullable<bool> EnableSecureBoot { get; set; }

        /// <summary>Defines whether the instance has the vTPM enabled. Enabled by default.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enableVtpm")]
        public virtual System.Nullable<bool> EnableVtpm { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A shielded Instance identity entry.</summary>
    public class ShieldedInstanceIdentity : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// An Endorsement Key (EK) made by the RSA 2048 algorithm issued to the Shielded Instance's vTPM.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("encryptionKey")]
        public virtual ShieldedInstanceIdentityEntry EncryptionKey { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#shieldedInstanceIdentity for shielded Instance identity
        /// entry.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// An Attestation Key (AK) made by the RSA 2048 algorithm issued to the Shielded Instance's vTPM.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("signingKey")]
        public virtual ShieldedInstanceIdentityEntry SigningKey { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A Shielded Instance Identity Entry.</summary>
    public class ShieldedInstanceIdentityEntry : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A PEM-encoded X.509 certificate. This field can be empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ekCert")]
        public virtual string EkCert { get; set; }

        /// <summary>A PEM-encoded public key.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ekPub")]
        public virtual string EkPub { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>The policy describes the baseline against which Instance boot integrity is measured.</summary>
    public class ShieldedInstanceIntegrityPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Updates the integrity policy baseline using the measurements from the VM instance's most recent boot.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("updateAutoLearnPolicy")]
        public virtual System.Nullable<bool> UpdateAutoLearnPolicy { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Represents a customer-supplied Signing Key used by Cloud CDN Signed URLs</summary>
    public class SignedUrlKey : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Name of the key. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must
        /// be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first
        /// character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or
        /// digit, except the last character, which cannot be a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("keyName")]
        public virtual string KeyName { get; set; }

        /// <summary>
        /// 128-bit key value used for signing the URL. The key value must be a valid RFC 4648 Section 5 base64url
        /// encoded string.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("keyValue")]
        public virtual string KeyValue { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Persistent Disk Snapshot resource.  You can use snapshots to back up data on a regular interval.
    /// For more information, read  Creating persistent disk snapshots. (== resource_for {$api_version}.snapshots ==)
    /// </summary>
    public class Snapshot : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] Set to true if snapshots are automatically created by applying resource policy on the target
        /// disk.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoCreated")]
        public virtual System.Nullable<bool> AutoCreated { get; set; }

        /// <summary>
        /// Creates the new snapshot in the snapshot chain labeled with the specified name. The chain name must be 1-63
        /// characters long and comply with RFC1035. This is an uncommon option only for advanced service owners who
        /// needs to create separate snapshot chains, for example, for chargeback tracking. When you describe your
        /// snapshot resource, this field is visible only if it has a non-empty value.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("chainName")]
        public virtual string ChainName { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>[Output Only] Size of the source disk, specified in GB.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskSizeGb")]
        public virtual System.Nullable<long> DiskSizeGb { get; set; }

        /// <summary>[Output Only] Number of bytes downloaded to restore a snapshot to a disk.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("downloadBytes")]
        public virtual System.Nullable<long> DownloadBytes { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#snapshot for Snapshot resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// A fingerprint for the labels being applied to this snapshot, which is essentially a hash of the labels set
        /// used for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after
        /// every request to modify or update labels. You must always provide an up-to-date fingerprint hash in order to
        /// update or change labels, otherwise the request will fail with error 412 conditionNotMet.  To see the latest
        /// fingerprint, make a get() request to retrieve a snapshot.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labelFingerprint")]
        public virtual string LabelFingerprint { get; set; }

        /// <summary>
        /// Labels to apply to this snapshot. These can be later modified by the setLabels method. Label values may be
        /// empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>
        /// [Output Only] Integer license codes indicating which licenses are attached to this snapshot.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("licenseCodes")]
        public virtual System.Collections.Generic.IList<System.Nullable<long>> LicenseCodes { get; set; }

        /// <summary>
        /// [Output Only] A list of public visible licenses that apply to this snapshot. This can be because the
        /// original image had licenses attached (such as a Windows image).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("licenses")]
        public virtual System.Collections.Generic.IList<string> Licenses { get; set; }

        /// <summary>
        /// An opaque location hint used to place the snapshot close to other resources. This field is for use by
        /// internal tools that use the public API.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("locationHint")]
        public virtual string LocationHint { get; set; }

        /// <summary>
        /// Name of the resource; provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] Reserved for future use.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("satisfiesPzs")]
        public virtual System.Nullable<bool> SatisfiesPzs { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// Encrypts the snapshot using a customer-supplied encryption key.  After you encrypt a snapshot using a
        /// customer-supplied key, you must provide the same key if you use the snapshot later. For example, you must
        /// provide the encryption key when you create a disk from the encrypted snapshot in a future request.
        /// Customer-supplied encryption keys do not protect access to metadata of the snapshot.  If you do not provide
        /// an encryption key when creating the snapshot, then the snapshot will be encrypted using an automatically
        /// generated key and you do not need to provide a key to use the snapshot later.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("snapshotEncryptionKey")]
        public virtual CustomerEncryptionKey SnapshotEncryptionKey { get; set; }

        /// <summary>The source disk used to create this snapshot.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceDisk")]
        public virtual string SourceDisk { get; set; }

        /// <summary>
        /// The customer-supplied encryption key of the source disk. Required if the source disk is protected by a
        /// customer-supplied encryption key.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceDiskEncryptionKey")]
        public virtual CustomerEncryptionKey SourceDiskEncryptionKey { get; set; }

        /// <summary>
        /// [Output Only] The ID value of the disk used to create this snapshot. This value may be used to determine
        /// whether the snapshot was taken from the current or a previous instance of a given disk name.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceDiskId")]
        public virtual string SourceDiskId { get; set; }

        /// <summary>
        /// [Output Only] The status of the snapshot. This can be CREATING, DELETING, FAILED, READY, or UPLOADING.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>
        /// [Output Only] A size of the storage used by the snapshot. As snapshots share storage, this number is
        /// expected to change with snapshot creation/deletion.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("storageBytes")]
        public virtual System.Nullable<long> StorageBytes { get; set; }

        /// <summary>
        /// [Output Only] An indicator whether storageBytes is in a stable state or it is being adjusted as a result of
        /// shared storage reallocation. This status can either be UPDATING, meaning the size of the snapshot is being
        /// updated, or UP_TO_DATE, meaning the size of the snapshot is up-to-date.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("storageBytesStatus")]
        public virtual string StorageBytesStatus { get; set; }

        /// <summary>Cloud Storage bucket storage location of the snapshot (regional or multi-regional).</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("storageLocations")]
        public virtual System.Collections.Generic.IList<string> StorageLocations { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of Snapshot resources.</summary>
    public class SnapshotList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Snapshot resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Snapshot> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// A specification of the parameters to use when creating the instance template from a source instance.
    /// </summary>
    public class SourceInstanceParams : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Attached disks configuration. If not provided, defaults are applied: For boot disk and any other R/W disks,
        /// new custom images will be created from each disk. For read-only disks, they will be attached in read-only
        /// mode. Local SSD disks will be created as blank volumes.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("diskConfigs")]
        public virtual System.Collections.Generic.IList<DiskInstantiationConfig> DiskConfigs { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents an SSL Certificate resource.  Google Compute Engine has two SSL Certificate resources:  *
    /// [Global](/compute/docs/reference/rest/{$api_version}/sslCertificates) *
    /// [Regional](/compute/docs/reference/rest/{$api_version}/regionSslCertificates)    The sslCertificates are used
    /// by:   - external HTTPS load balancers  - SSL proxy load balancers    The regionSslCertificates are used by
    /// internal HTTPS load balancers.  Optionally, certificate file contents that you upload can contain a set of up to
    /// five PEM-encoded certificates. The API call creates an object (sslCertificate) that holds this data. You can use
    /// SSL keys and certificates to secure connections to a load balancer. For more information, read  Creating and
    /// using SSL certificates, SSL certificates quotas and limits, and  Troubleshooting SSL certificates. (==
    /// resource_for {$api_version}.sslCertificates ==) (== resource_for {$api_version}.regionSslCertificates ==)
    /// </summary>
    public class SslCertificate : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// A value read into memory from a certificate file. The certificate file must be in PEM format. The
        /// certificate chain must be no greater than 5 certs long. The chain must include at least one intermediate
        /// cert.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("certificate")]
        public virtual string Certificate { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>[Output Only] Expire time of the certificate. RFC3339</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("expireTime")]
        public virtual string ExpireTime { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#sslCertificate for SSL certificates.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>Configuration and status of a managed SSL certificate.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("managed")]
        public virtual SslCertificateManagedSslCertificate Managed { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// A value read into memory from a write-only private key file. The private key file must be in PEM format. For
        /// security, only insert requests include this field.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("privateKey")]
        public virtual string PrivateKey { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the regional SSL Certificate resides. This field is not applicable to
        /// global SSL Certificate.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>Configuration and status of a self-managed SSL certificate.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfManaged")]
        public virtual SslCertificateSelfManagedSslCertificate SelfManaged { get; set; }

        /// <summary>[Output Only] Domains associated with the certificate via Subject Alternative Name.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("subjectAlternativeNames")]
        public virtual System.Collections.Generic.IList<string> SubjectAlternativeNames { get; set; }

        /// <summary>
        /// (Optional) Specifies the type of SSL certificate, either "SELF_MANAGED" or "MANAGED". If not specified, the
        /// certificate is self-managed and the fields certificate and private_key are used.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class SslCertificateAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of SslCertificatesScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, SslCertificatesScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#sslCertificateAggregatedList for lists of SSL Certificates.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of SslCertificate resources.</summary>
    public class SslCertificateList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of SslCertificate resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<SslCertificate> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Configuration and status of a managed SSL certificate.</summary>
    public class SslCertificateManagedSslCertificate : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output only] Detailed statuses of the domains specified for managed certificate resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("domainStatus")]
        public virtual System.Collections.Generic.IDictionary<string, string> DomainStatus { get; set; }

        /// <summary>
        /// The domains for which a managed SSL certificate will be generated. Each Google-managed SSL certificate
        /// supports up to the [maximum number of domains per Google-managed SSL
        /// certificate](/load-balancing/docs/quotas#ssl_certificates).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("domains")]
        public virtual System.Collections.Generic.IList<string> Domains { get; set; }

        /// <summary>[Output only] Status of the managed certificate resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Configuration and status of a self-managed SSL certificate.</summary>
    public class SslCertificateSelfManagedSslCertificate : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// A local certificate file. The certificate must be in PEM format. The certificate chain must be no greater
        /// than 5 certs long. The chain must include at least one intermediate cert.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("certificate")]
        public virtual string Certificate { get; set; }

        /// <summary>A write-only private key in PEM format. Only insert requests will include this field.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("privateKey")]
        public virtual string PrivateKey { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class SslCertificatesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>List of SslCertificates contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sslCertificates")]
        public virtual System.Collections.Generic.IList<SslCertificate> SslCertificates { get; set; }

        /// <summary>Informational warning which replaces the list of backend services when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of backend services when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class SslPoliciesList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of SslPolicy resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<SslPolicy> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#sslPoliciesList for lists of sslPolicies.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class SslPoliciesListAvailableFeaturesResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("features")]
        public virtual System.Collections.Generic.IList<string> Features { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents an SSL Policy resource.  Use SSL policies to control the SSL features, such as versions and cipher
    /// suites, offered by an HTTPS or SSL Proxy load balancer. For more information, read  SSL Policy Concepts. (==
    /// resource_for {$api_version}.sslPolicies ==)
    /// </summary>
    public class SslPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// A list of features enabled when the selected profile is CUSTOM. The - method returns the set of features
        /// that can be specified in this list. This field must be empty if the profile is not CUSTOM.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("customFeatures")]
        public virtual System.Collections.Generic.IList<string> CustomFeatures { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>[Output Only] The list of features enabled in the SSL policy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enabledFeatures")]
        public virtual System.Collections.Generic.IList<string> EnabledFeatures { get; set; }

        /// <summary>
        /// Fingerprint of this resource. A hash of the contents stored in this object. This field is used in optimistic
        /// locking. This field will be ignored when inserting a SslPolicy. An up-to-date fingerprint must be provided
        /// in order to update the SslPolicy, otherwise the request will fail with error 412 conditionNotMet.  To see
        /// the latest fingerprint, make a get() request to retrieve an SslPolicy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output only] Type of the resource. Always compute#sslPolicyfor SSL policies.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// The minimum version of SSL protocol that can be used by the clients to establish a connection with the load
        /// balancer. This can be one of TLS_1_0, TLS_1_1, TLS_1_2.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("minTlsVersion")]
        public virtual string MinTlsVersion { get; set; }

        /// <summary>
        /// Name of the resource. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name
        /// must be 1-63 characters long and match the regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the
        /// first character must be a lowercase letter, and all following characters must be a dash, lowercase letter,
        /// or digit, except the last character, which cannot be a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// Profile specifies the set of SSL features that can be used by the load balancer when negotiating SSL with
        /// clients. This can be one of COMPATIBLE, MODERN, RESTRICTED, or CUSTOM. If using CUSTOM, the set of SSL
        /// features to enable must be specified in the customFeatures field.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("profile")]
        public virtual string Profile { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// [Output Only] If potential misconfigurations are detected for this SSL policy, this field will be populated
        /// with warning messages.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warnings")]
        public virtual System.Collections.Generic.IList<WarningsData> Warnings { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] If potential misconfigurations are detected for this SSL policy, this field will be populated
        /// with warning messages.
        /// </summary>
        public class WarningsData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class SslPolicyReference : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// URL of the SSL policy resource. Set this to empty string to clear any existing SSL policy associated with
        /// the target proxy resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sslPolicy")]
        public virtual string SslPolicy { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class StatefulPolicy : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("preservedState")]
        public virtual StatefulPolicyPreservedState PreservedState { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Configuration of preserved resources.</summary>
    public class StatefulPolicyPreservedState : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Disks created on the instances that will be preserved on instance delete, update, etc. This map is keyed
        /// with the device names of the disks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("disks")]
        public virtual System.Collections.Generic.IDictionary<string, StatefulPolicyPreservedStateDiskDevice> Disks { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class StatefulPolicyPreservedStateDiskDevice : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// These stateful disks will never be deleted during autohealing, update or VM instance recreate operations.
        /// This flag is used to configure if the disk should be deleted after it is no longer used by the group, e.g.
        /// when the given instance or the whole group is deleted. Note: disks attached in READ_ONLY mode cannot be
        /// auto-deleted.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("autoDelete")]
        public virtual string AutoDelete { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Subnetwork resource.  A subnetwork (also known as a subnet) is a logical partition of a Virtual
    /// Private Cloud network with one primary IP range and zero or more secondary IP ranges. For more information, read
    ///  Virtual Private Cloud (VPC) Network. (== resource_for {$api_version}.subnetworks ==)
    /// </summary>
    public class Subnetwork : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource. This field can
        /// be set only at resource creation time.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Whether to enable flow logging for this subnetwork. If this field is not explicitly set, it will not appear
        /// in get listings. If not set the default behavior is to disable flow logging. This field isn't supported with
        /// the purpose field set to INTERNAL_HTTPS_LOAD_BALANCER.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enableFlowLogs")]
        public virtual System.Nullable<bool> EnableFlowLogs { get; set; }

        /// <summary>
        /// Fingerprint of this resource. A hash of the contents stored in this object. This field is used in optimistic
        /// locking. This field will be ignored when inserting a Subnetwork. An up-to-date fingerprint must be provided
        /// in order to update the Subnetwork, otherwise the request will fail with error 412 conditionNotMet.  To see
        /// the latest fingerprint, make a get() request to retrieve a Subnetwork.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// [Output Only] The gateway address for default routes to reach destination addresses outside this subnetwork.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("gatewayAddress")]
        public virtual string GatewayAddress { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// The range of internal addresses that are owned by this subnetwork. Provide this property when you create the
        /// subnetwork. For example, 10.0.0.0/8 or 100.64.0.0/10. Ranges must be unique and non-overlapping within a
        /// network. Only IPv4 is supported. This field is set at resource creation time. The range can be any range
        /// listed in the Valid ranges list. The range can be expanded after creation using expandIpCidrRange.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipCidrRange")]
        public virtual string IpCidrRange { get; set; }

        /// <summary>[Output Only] The range of internal IPv6 addresses that are owned by this subnetwork.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipv6CidrRange")]
        public virtual string Ipv6CidrRange { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#subnetwork for Subnetwork resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// This field denotes the VPC flow logging options for this subnetwork. If logging is enabled, logs are
        /// exported to Cloud Logging.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("logConfig")]
        public virtual SubnetworkLogConfig LogConfig { get; set; }

        /// <summary>
        /// The name of the resource, provided by the client when initially creating the resource. The name must be 1-63
        /// characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the
        /// regular expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter,
        /// and all following characters must be a dash, lowercase letter, or digit, except the last character, which
        /// cannot be a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// The URL of the network to which this subnetwork belongs, provided by the client when initially creating the
        /// subnetwork. Only networks that are in the distributed mode can have subnetworks. This field can be set only
        /// at resource creation time.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>
        /// Whether the VMs in this subnet can access Google services without assigned external IP addresses. This field
        /// can be both set at resource creation time and updated using setPrivateIpGoogleAccess.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("privateIpGoogleAccess")]
        public virtual System.Nullable<bool> PrivateIpGoogleAccess { get; set; }

        /// <summary>
        /// The private IPv6 google access type for the VMs in this subnet. This is an expanded field of
        /// enablePrivateV6Access. If both fields are set, privateIpv6GoogleAccess will take priority.  This field can
        /// be both set at resource creation time and updated using patch.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("privateIpv6GoogleAccess")]
        public virtual string PrivateIpv6GoogleAccess { get; set; }

        /// <summary>
        /// The purpose of the resource. This field can be either PRIVATE_RFC_1918 or INTERNAL_HTTPS_LOAD_BALANCER. A
        /// subnetwork with purpose set to INTERNAL_HTTPS_LOAD_BALANCER is a user-created subnetwork that is reserved
        /// for Internal HTTP(S) Load Balancing. If unspecified, the purpose defaults to PRIVATE_RFC_1918. The
        /// enableFlowLogs field isn't supported with the purpose field set to INTERNAL_HTTPS_LOAD_BALANCER.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("purpose")]
        public virtual string Purpose { get; set; }

        /// <summary>
        /// URL of the region where the Subnetwork resides. This field can be set only at resource creation time.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>
        /// The role of subnetwork. Currently, this field is only used when purpose = INTERNAL_HTTPS_LOAD_BALANCER. The
        /// value can be set to ACTIVE or BACKUP. An ACTIVE subnetwork is one that is currently being used for Internal
        /// HTTP(S) Load Balancing. A BACKUP subnetwork is one that is ready to be promoted to ACTIVE or is currently
        /// draining. This field can be updated with a patch request.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("role")]
        public virtual string Role { get; set; }

        /// <summary>
        /// An array of configurations for secondary IP ranges for VM instances contained in this subnetwork. The
        /// primary IP of such VM must belong to the primary ipCidrRange of the subnetwork. The alias IPs may belong to
        /// either primary or secondary ranges. This field can be updated with a patch request.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("secondaryIpRanges")]
        public virtual System.Collections.Generic.IList<SubnetworkSecondaryRange> SecondaryIpRanges { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// [Output Only] The state of the subnetwork, which can be one of the following values: READY: Subnetwork is
        /// created and ready to use DRAINING: only applicable to subnetworks that have the purpose set to
        /// INTERNAL_HTTPS_LOAD_BALANCER and indicates that connections to the load balancer are being drained. A
        /// subnetwork that is draining cannot be used or modified until it reaches a status of READY CREATING:
        /// Subnetwork is provisioning DELETING: Subnetwork is being deleted UPDATING: Subnetwork is being updated
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("state")]
        public virtual string State { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class SubnetworkAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of SubnetworksScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, SubnetworksScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#subnetworkAggregatedList for aggregated lists of subnetworks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of Subnetwork resources.</summary>
    public class SubnetworkList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Subnetwork resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Subnetwork> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#subnetworkList for lists of subnetworks.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>The available logging options for this subnetwork.</summary>
    public class SubnetworkLogConfig : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Can only be specified if VPC flow logging for this subnetwork is enabled. Toggles the aggregation interval
        /// for collecting flow logs. Increasing the interval time will reduce the amount of generated flow logs for
        /// long lasting connections. Default is an interval of 5 seconds per connection.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("aggregationInterval")]
        public virtual string AggregationInterval { get; set; }

        /// <summary>
        /// Whether to enable flow logging for this subnetwork. If this field is not explicitly set, it will not appear
        /// in get listings. If not set the default behavior is to disable flow logging.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("enable")]
        public virtual System.Nullable<bool> Enable { get; set; }

        /// <summary>
        /// Can only be specified if VPC flow logs for this subnetwork is enabled. Export filter used to define which
        /// VPC flow logs should be logged.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("filterExpr")]
        public virtual string FilterExpr { get; set; }

        /// <summary>
        /// Can only be specified if VPC flow logging for this subnetwork is enabled. The value of the field must be in
        /// [0, 1]. Set the sampling rate of VPC flow logs within the subnetwork where 1.0 means all collected logs are
        /// reported and 0.0 means no logs are reported. Default is 0.5, which means half of all collected logs are
        /// reported.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("flowSampling")]
        public virtual System.Nullable<float> FlowSampling { get; set; }

        /// <summary>
        /// Can only be specified if VPC flow logs for this subnetwork is enabled. Configures whether all, none or a
        /// subset of metadata fields should be added to the reported VPC flow logs. Default is INCLUDE_ALL_METADATA.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("metadata")]
        public virtual string Metadata { get; set; }

        /// <summary>
        /// Can only be specified if VPC flow logs for this subnetwork is enabled and "metadata" was set to
        /// CUSTOM_METADATA.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("metadataFields")]
        public virtual System.Collections.Generic.IList<string> MetadataFields { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Represents a secondary IP range of a subnetwork.</summary>
    public class SubnetworkSecondaryRange : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The range of IP addresses belonging to this subnetwork secondary range. Provide this property when you
        /// create the subnetwork. Ranges must be unique and non-overlapping with all primary and secondary IP ranges
        /// within a network. Only IPv4 is supported. The range can be any range listed in the Valid ranges list.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipCidrRange")]
        public virtual string IpCidrRange { get; set; }

        /// <summary>
        /// The name associated with this subnetwork secondary range, used when adding an alias IP range to a VM
        /// instance. The name must be 1-63 characters long, and comply with RFC1035. The name must be unique within the
        /// subnetwork.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("rangeName")]
        public virtual string RangeName { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class SubnetworksExpandIpCidrRangeRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The IP (in CIDR format or netmask) of internal addresses that are legal on this Subnetwork. This range
        /// should be disjoint from other subnetworks within this network. This range can only be larger than (i.e. a
        /// superset of) the range previously defined before the update.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipCidrRange")]
        public virtual string IpCidrRange { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class SubnetworksScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of subnetworks contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("subnetworks")]
        public virtual System.Collections.Generic.IList<Subnetwork> Subnetworks { get; set; }

        /// <summary>An informational warning that appears when the list of addresses is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>An informational warning that appears when the list of addresses is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class SubnetworksSetPrivateIpGoogleAccessRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("privateIpGoogleAccess")]
        public virtual System.Nullable<bool> PrivateIpGoogleAccess { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TCPHealthCheck : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The TCP port number for the health check request. The default value is 80. Valid values are 1 through 65535.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("port")]
        public virtual System.Nullable<int> Port { get; set; }

        /// <summary>
        /// Port name as defined in InstanceGroup#NamedPort#name. If both port and port_name are defined, port takes
        /// precedence.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portName")]
        public virtual string PortName { get; set; }

        /// <summary>
        /// Specifies how port is selected for health checking, can be one of following values: USE_FIXED_PORT: The port
        /// number in port is used for health checking. USE_NAMED_PORT: The portName is used for health checking.
        /// USE_SERVING_PORT: For NetworkEndpointGroup, the port specified for each network endpoint is used for health
        /// checking. For other backends, the port or named port specified in the Backend Service is used for health
        /// checking.   If not specified, TCP health check follows behavior specified in port and portName fields.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("portSpecification")]
        public virtual string PortSpecification { get; set; }

        /// <summary>
        /// Specifies the type of proxy header to append before sending data to the backend, either NONE or PROXY_V1.
        /// The default is NONE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("proxyHeader")]
        public virtual string ProxyHeader { get; set; }

        /// <summary>
        /// The application data to send once the TCP connection has been established (default value is empty). If both
        /// request and response are empty, the connection establishment alone will indicate health. The request data
        /// can only be ASCII.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("request")]
        public virtual string Request { get; set; }

        /// <summary>
        /// The bytes to match against the beginning of the response data. If left empty (the default value), any
        /// response will indicate health. The response data can only be ASCII.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("response")]
        public virtual string Response { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A set of instance tags.</summary>
    public class Tags : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Specifies a fingerprint for this request, which is essentially a hash of the tags' contents and used for
        /// optimistic locking. The fingerprint is initially generated by Compute Engine and changes after every request
        /// to modify or update tags. You must always provide an up-to-date fingerprint hash in order to update or
        /// change tags.  To see the latest fingerprint, make get() request to the instance.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>An array of tags. Each tag must be 1-63 characters long, and comply with RFC1035.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<string> Items { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Target gRPC Proxy resource.  A target gRPC proxy is a component of load balancers intended for load
    /// balancing gRPC traffic. Only global forwarding rules with load balancing scheme INTERNAL_SELF_MANAGED can
    /// reference a target gRPC proxy. The target gRPC Proxy references a URL map that specifies how traffic is routed
    /// to gRPC backend services. (== resource_for {$api_version}.targetGrpcProxies ==)
    /// </summary>
    public class TargetGrpcProxy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Fingerprint of this resource. A hash of the contents stored in this object. This field is used in optimistic
        /// locking. This field will be ignored when inserting a TargetGrpcProxy. An up-to-date fingerprint must be
        /// provided in order to patch/update the TargetGrpcProxy; otherwise, the request will fail with error 412
        /// conditionNotMet. To see the latest fingerprint, make a get() request to retrieve the TargetGrpcProxy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource type. The server generates this identifier.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#targetGrpcProxy for target grpc proxies.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Server-defined URL with id for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLinkWithId")]
        public virtual string SelfLinkWithId { get; set; }

        /// <summary>
        /// URL to the UrlMap resource that defines the mapping from URL to the BackendService. The protocol field in
        /// the BackendService must be set to GRPC.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("urlMap")]
        public virtual string UrlMap { get; set; }

        /// <summary>
        /// If true, indicates that the BackendServices referenced by the urlMap may be accessed by gRPC applications
        /// without using a sidecar proxy. This will enable configuration checks on urlMap and its referenced
        /// BackendServices to not allow unsupported features. A gRPC application must use "xds:///" scheme in the
        /// target URI of the service it is connecting to. If false, indicates that the BackendServices referenced by
        /// the urlMap will be accessed by gRPC applications via a sidecar proxy. In this case, a gRPC application must
        /// not use "xds:///" scheme in the target URI of the service it is connecting to
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("validateForProxyless")]
        public virtual System.Nullable<bool> ValidateForProxyless { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetGrpcProxyList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of TargetGrpcProxy resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<TargetGrpcProxy> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of the resource. Always compute#targetGrpcProxy for target grpc proxies.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class TargetHttpProxiesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of TargetHttpProxies contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetHttpProxies")]
        public virtual System.Collections.Generic.IList<TargetHttpProxy> TargetHttpProxies { get; set; }

        /// <summary>Informational warning which replaces the list of backend services when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of backend services when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a Target HTTP Proxy resource.  Google Compute Engine has two Target HTTP Proxy resources:  *
    /// [Global](/compute/docs/reference/rest/{$api_version}/targetHttpProxies) *
    /// [Regional](/compute/docs/reference/rest/{$api_version}/regionTargetHttpProxies)  A target HTTP proxy is a
    /// component of GCP HTTP load balancers.  * targetHttpProxies are used by external HTTP load balancers and Traffic
    /// Director. * regionTargetHttpProxies are used by internal HTTP load balancers.  Forwarding rules reference a
    /// target HTTP proxy, and the target proxy then references a URL map. For more information, read Using Target
    /// Proxies and  Forwarding rule concepts. (== resource_for {$api_version}.targetHttpProxies ==) (== resource_for
    /// {$api_version}.regionTargetHttpProxies ==)
    /// </summary>
    public class TargetHttpProxy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Fingerprint of this resource. A hash of the contents stored in this object. This field is used in optimistic
        /// locking. This field will be ignored when inserting a TargetHttpProxy. An up-to-date fingerprint must be
        /// provided in order to patch/update the TargetHttpProxy; otherwise, the request will fail with error 412
        /// conditionNotMet. To see the latest fingerprint, make a get() request to retrieve the TargetHttpProxy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#targetHttpProxy for target HTTP proxies.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// This field only applies when the forwarding rule that references this target proxy has a loadBalancingScheme
        /// set to INTERNAL_SELF_MANAGED.  When this field is set to true, Envoy proxies set up inbound traffic
        /// interception and bind to the IP address and port specified in the forwarding rule. This is generally useful
        /// when using Traffic Director to configure Envoy as a gateway or middle proxy (in other words, not a sidecar
        /// proxy). The Envoy proxy listens for inbound requests and handles requests when it receives them.  The
        /// default is false.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("proxyBind")]
        public virtual System.Nullable<bool> ProxyBind { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the regional Target HTTP Proxy resides. This field is not applicable
        /// to global Target HTTP Proxies.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>URL to the UrlMap resource that defines the mapping from URL to the BackendService.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("urlMap")]
        public virtual string UrlMap { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetHttpProxyAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of TargetHttpProxiesScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, TargetHttpProxiesScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#targetHttpProxyAggregatedList for lists of Target HTTP
        /// Proxies.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A list of TargetHttpProxy resources.</summary>
    public class TargetHttpProxyList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of TargetHttpProxy resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<TargetHttpProxy> Items { get; set; }

        /// <summary>Type of resource. Always compute#targetHttpProxyList for lists of target HTTP proxies.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class TargetHttpsProxiesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of TargetHttpsProxies contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetHttpsProxies")]
        public virtual System.Collections.Generic.IList<TargetHttpsProxy> TargetHttpsProxies { get; set; }

        /// <summary>Informational warning which replaces the list of backend services when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of backend services when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class TargetHttpsProxiesSetQuicOverrideRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>QUIC policy for the TargetHttpsProxy resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("quicOverride")]
        public virtual string QuicOverride { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetHttpsProxiesSetSslCertificatesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// New set of SslCertificate resources to associate with this TargetHttpsProxy resource. Currently exactly one
        /// SslCertificate resource must be specified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sslCertificates")]
        public virtual System.Collections.Generic.IList<string> SslCertificates { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Target HTTPS Proxy resource.  Google Compute Engine has two Target HTTPS Proxy resources:  *
    /// [Global](/compute/docs/reference/rest/{$api_version}/targetHttpsProxies) *
    /// [Regional](/compute/docs/reference/rest/{$api_version}/regionTargetHttpsProxies)  A target HTTPS proxy is a
    /// component of GCP HTTPS load balancers.  * targetHttpsProxies are used by external HTTPS load balancers. *
    /// regionTargetHttpsProxies are used by internal HTTPS load balancers.  Forwarding rules reference a target HTTPS
    /// proxy, and the target proxy then references a URL map. For more information, read Using Target Proxies and
    /// Forwarding rule concepts. (== resource_for {$api_version}.targetHttpsProxies ==) (== resource_for
    /// {$api_version}.regionTargetHttpsProxies ==)
    /// </summary>
    public class TargetHttpsProxy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Optional. A URL referring to a networksecurity.AuthorizationPolicy resource that describes how the proxy
        /// should authorize inbound traffic. If left blank, access will not be restricted by an authorization policy.
        /// Refer to the AuthorizationPolicy resource for additional details. authorizationPolicy only applies to a
        /// global TargetHttpsProxy attached to globalForwardingRules with the loadBalancingScheme set to
        /// INTERNAL_SELF_MANAGED. Note: This field currently has no impact.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("authorizationPolicy")]
        public virtual string AuthorizationPolicy { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Fingerprint of this resource. A hash of the contents stored in this object. This field is used in optimistic
        /// locking. This field will be ignored when inserting a TargetHttpsProxy. An up-to-date fingerprint must be
        /// provided in order to patch the TargetHttpsProxy; otherwise, the request will fail with error 412
        /// conditionNotMet. To see the latest fingerprint, make a get() request to retrieve the TargetHttpsProxy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#targetHttpsProxy for target HTTPS proxies.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// This field only applies when the forwarding rule that references this target proxy has a loadBalancingScheme
        /// set to INTERNAL_SELF_MANAGED.  When this field is set to true, Envoy proxies set up inbound traffic
        /// interception and bind to the IP address and port specified in the forwarding rule. This is generally useful
        /// when using Traffic Director to configure Envoy as a gateway or middle proxy (in other words, not a sidecar
        /// proxy). The Envoy proxy listens for inbound requests and handles requests when it receives them.  The
        /// default is false.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("proxyBind")]
        public virtual System.Nullable<bool> ProxyBind { get; set; }

        /// <summary>
        /// Specifies the QUIC override policy for this TargetHttpsProxy resource. This setting determines whether the
        /// load balancer attempts to negotiate QUIC with clients. You can specify NONE, ENABLE, or DISABLE.   - When
        /// quic-override is set to NONE, Google manages whether QUIC is used.  - When quic-override is set to ENABLE,
        /// the load balancer uses QUIC when possible.  - When quic-override is set to DISABLE, the load balancer
        /// doesn't use QUIC.  - If the quic-override flag is not specified, NONE is implied.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("quicOverride")]
        public virtual string QuicOverride { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the regional TargetHttpsProxy resides. This field is not applicable to
        /// global TargetHttpsProxies.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// Optional. A URL referring to a networksecurity.ServerTlsPolicy resource that describes how the proxy should
        /// authenticate inbound traffic. serverTlsPolicy only applies to a global TargetHttpsProxy attached to
        /// globalForwardingRules with the loadBalancingScheme set to INTERNAL_SELF_MANAGED. If left blank,
        /// communications are not encrypted. Note: This field currently has no impact.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("serverTlsPolicy")]
        public virtual string ServerTlsPolicy { get; set; }

        /// <summary>
        /// URLs to SslCertificate resources that are used to authenticate connections between users and the load
        /// balancer. At least one SSL certificate must be specified. Currently, you may specify up to 15 SSL
        /// certificates.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sslCertificates")]
        public virtual System.Collections.Generic.IList<string> SslCertificates { get; set; }

        /// <summary>
        /// URL of SslPolicy resource that will be associated with the TargetHttpsProxy resource. If not set, the
        /// TargetHttpsProxy resource has no SSL policy configured.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sslPolicy")]
        public virtual string SslPolicy { get; set; }

        /// <summary>
        /// A fully-qualified or valid partial URL to the UrlMap resource that defines the mapping from URL to the
        /// BackendService. For example, the following are all valid URLs for specifying a URL map:   -
        /// https://www.googleapis.compute/v1/projects/project/global/urlMaps/url-map  -
        /// projects/project/global/urlMaps/url-map  - global/urlMaps/url-map
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("urlMap")]
        public virtual string UrlMap { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetHttpsProxyAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of TargetHttpsProxiesScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, TargetHttpsProxiesScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#targetHttpsProxyAggregatedList for lists of Target HTTP
        /// Proxies.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of TargetHttpsProxy resources.</summary>
    public class TargetHttpsProxyList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of TargetHttpsProxy resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<TargetHttpsProxy> Items { get; set; }

        /// <summary>Type of resource. Always compute#targetHttpsProxyList for lists of target HTTPS proxies.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a Target Instance resource.  You can use a target instance to handle traffic for one or more
    /// forwarding rules, which is ideal for forwarding protocol traffic that is managed by a single source. For
    /// example, ESP, AH, TCP, or UDP. For more information, read Target instances. (== resource_for
    /// {$api_version}.targetInstances ==)
    /// </summary>
    public class TargetInstance : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// A URL to the virtual machine instance that handles traffic for this target instance. When creating a target
        /// instance, you can provide the fully-qualified URL or a valid partial URL to the desired virtual machine. For
        /// example, the following are all valid URLs:  -
        /// https://www.googleapis.com/compute/v1/projects/project/zones/zone/instances/instance  -
        /// projects/project/zones/zone/instances/instance  - zones/zone/instances/instance
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instance")]
        public virtual string Instance { get; set; }

        /// <summary>
        /// [Output Only] The type of the resource. Always compute#targetInstance for target instances.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// NAT option controlling how IPs are NAT'ed to the instance. Currently only NO_NAT (default value) is
        /// supported.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("natPolicy")]
        public virtual string NatPolicy { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// [Output Only] URL of the zone where the target instance resides. You must specify this field as part of the
        /// HTTP request URL. It is not settable as a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("zone")]
        public virtual string Zone { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetInstanceAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of TargetInstance resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, TargetInstancesScopedList> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of TargetInstance resources.</summary>
    public class TargetInstanceList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of TargetInstance resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<TargetInstance> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class TargetInstancesScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of target instances contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetInstances")]
        public virtual System.Collections.Generic.IList<TargetInstance> TargetInstances { get; set; }

        /// <summary>Informational warning which replaces the list of addresses when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of addresses when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a Target Pool resource.  Target pools are used for network TCP/UDP load balancing. A target pool
    /// references member instances, an associated legacy HttpHealthCheck resource, and, optionally, a backup target
    /// pool. For more information, read Using target pools. (== resource_for {$api_version}.targetPools ==)
    /// </summary>
    public class TargetPool : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The server-defined URL for the resource. This field is applicable only when the containing target pool is
        /// serving a forwarding rule as the primary pool, and its failoverRatio field is properly set to a value
        /// between [0, 1].  backupPool and failoverRatio together define the fallback behavior of the primary target
        /// pool: if the ratio of the healthy instances in the primary pool is at or below failoverRatio, traffic
        /// arriving at the load-balanced IP will be directed to the backup pool.  In case where failoverRatio and
        /// backupPool are not set, or all the instances in the backup pool are unhealthy, the traffic will be directed
        /// back to the primary pool in the "force" mode, where traffic will be spread to the healthy instances with the
        /// best effort, or to all instances when no instance is healthy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("backupPool")]
        public virtual string BackupPool { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// This field is applicable only when the containing target pool is serving a forwarding rule as the primary
        /// pool (i.e., not as a backup pool to some other target pool). The value of the field must be in [0, 1].  If
        /// set, backupPool must also be set. They together define the fallback behavior of the primary target pool: if
        /// the ratio of the healthy instances in the primary pool is at or below this number, traffic arriving at the
        /// load-balanced IP will be directed to the backup pool.  In case where failoverRatio is not set or all the
        /// instances in the backup pool are unhealthy, the traffic will be directed back to the primary pool in the
        /// "force" mode, where traffic will be spread to the healthy instances with the best effort, or to all
        /// instances when no instance is healthy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("failoverRatio")]
        public virtual System.Nullable<float> FailoverRatio { get; set; }

        /// <summary>
        /// The URL of the HttpHealthCheck resource. A member instance in this pool is considered healthy if and only if
        /// the health checks pass. Only legacy HttpHealthChecks are supported. Only one health check may be specified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthChecks")]
        public virtual System.Collections.Generic.IList<string> HealthChecks { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// A list of resource URLs to the virtual machine instances serving this pool. They must live in zones
        /// contained in the same region as this pool.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<string> Instances { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#targetPool for target pools.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] URL of the region where the target pool resides.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// Session affinity option, must be one of the following values: NONE: Connections from the same client IP may
        /// go to any instance in the pool. CLIENT_IP: Connections from the same client IP will go to the same instance
        /// in the pool while that instance remains healthy. CLIENT_IP_PROTO: Connections from the same client IP with
        /// the same IP protocol will go to the same instance in the pool while that instance remains healthy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sessionAffinity")]
        public virtual string SessionAffinity { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetPoolAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of TargetPool resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, TargetPoolsScopedList> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#targetPoolAggregatedList for aggregated lists of target
        /// pools.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class TargetPoolInstanceHealth : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("healthStatus")]
        public virtual System.Collections.Generic.IList<HealthStatus> HealthStatus { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#targetPoolInstanceHealth when checking the health of an
        /// instance.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of TargetPool resources.</summary>
    public class TargetPoolList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of TargetPool resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<TargetPool> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#targetPoolList for lists of target pools.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class TargetPoolsAddHealthCheckRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The HttpHealthCheck to add to the target pool.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthChecks")]
        public virtual System.Collections.Generic.IList<HealthCheckReference> HealthChecks { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetPoolsAddInstanceRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// A full or partial URL to an instance to add to this target pool. This can be a full or partial URL. For
        /// example, the following are valid URLs:   -
        /// https://www.googleapis.com/compute/v1/projects/project-id/zones/zone/instances/instance-name  -
        /// projects/project-id/zones/zone/instances/instance-name  - zones/zone/instances/instance-name
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<InstanceReference> Instances { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetPoolsRemoveHealthCheckRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Health check URL to be removed. This can be a full or valid partial URL. For example, the following are
        /// valid URLs:   -
        /// https://www.googleapis.com/compute/beta/projects/project/global/httpHealthChecks/health-check  -
        /// projects/project/global/httpHealthChecks/health-check  - global/httpHealthChecks/health-check
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("healthChecks")]
        public virtual System.Collections.Generic.IList<HealthCheckReference> HealthChecks { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetPoolsRemoveInstanceRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>URLs of the instances to be removed from target pool.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instances")]
        public virtual System.Collections.Generic.IList<InstanceReference> Instances { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetPoolsScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of target pools contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetPools")]
        public virtual System.Collections.Generic.IList<TargetPool> TargetPools { get; set; }

        /// <summary>Informational warning which replaces the list of addresses when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of addresses when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class TargetReference : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("target")]
        public virtual string Target { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetSslProxiesSetBackendServiceRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The URL of the new BackendService resource for the targetSslProxy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("service")]
        public virtual string Service { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetSslProxiesSetProxyHeaderRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The new type of proxy header to append before sending data to the backend. NONE or PROXY_V1 are allowed.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("proxyHeader")]
        public virtual string ProxyHeader { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetSslProxiesSetSslCertificatesRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// New set of URLs to SslCertificate resources to associate with this TargetSslProxy. Currently exactly one ssl
        /// certificate must be specified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sslCertificates")]
        public virtual System.Collections.Generic.IList<string> SslCertificates { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Target SSL Proxy resource.  A target SSL proxy is a component of a SSL Proxy load balancer. Global
    /// forwarding rules reference a target SSL proxy, and the target proxy then references an external backend service.
    /// For more information, read Using Target Proxies. (== resource_for {$api_version}.targetSslProxies ==)
    /// </summary>
    public class TargetSslProxy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#targetSslProxy for target SSL proxies.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// Specifies the type of proxy header to append before sending data to the backend, either NONE or PROXY_V1.
        /// The default is NONE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("proxyHeader")]
        public virtual string ProxyHeader { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>URL to the BackendService resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("service")]
        public virtual string Service { get; set; }

        /// <summary>
        /// URLs to SslCertificate resources that are used to authenticate connections to Backends. At least one SSL
        /// certificate must be specified. Currently, you may specify up to 15 SSL certificates.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sslCertificates")]
        public virtual System.Collections.Generic.IList<string> SslCertificates { get; set; }

        /// <summary>
        /// URL of SslPolicy resource that will be associated with the TargetSslProxy resource. If not set, the
        /// TargetSslProxy resource will not have any SSL policy configured.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sslPolicy")]
        public virtual string SslPolicy { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of TargetSslProxy resources.</summary>
    public class TargetSslProxyList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of TargetSslProxy resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<TargetSslProxy> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class TargetTcpProxiesSetBackendServiceRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The URL of the new BackendService resource for the targetTcpProxy.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("service")]
        public virtual string Service { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetTcpProxiesSetProxyHeaderRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The new type of proxy header to append before sending data to the backend. NONE or PROXY_V1 are allowed.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("proxyHeader")]
        public virtual string ProxyHeader { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Target TCP Proxy resource.  A target TCP proxy is a component of a TCP Proxy load balancer. Global
    /// forwarding rules reference target TCP proxy, and the target proxy then references an external backend service.
    /// For more information, read TCP Proxy Load Balancing overview. (== resource_for {$api_version}.targetTcpProxies
    /// ==)
    /// </summary>
    public class TargetTcpProxy : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#targetTcpProxy for target TCP proxies.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// This field only applies when the forwarding rule that references this target proxy has a loadBalancingScheme
        /// set to INTERNAL_SELF_MANAGED.  When this field is set to true, Envoy proxies set up inbound traffic
        /// interception and bind to the IP address and port specified in the forwarding rule. This is generally useful
        /// when using Traffic Director to configure Envoy as a gateway or middle proxy (in other words, not a sidecar
        /// proxy). The Envoy proxy listens for inbound requests and handles requests when it receives them.  The
        /// default is false.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("proxyBind")]
        public virtual System.Nullable<bool> ProxyBind { get; set; }

        /// <summary>
        /// Specifies the type of proxy header to append before sending data to the backend, either NONE or PROXY_V1.
        /// The default is NONE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("proxyHeader")]
        public virtual string ProxyHeader { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>URL to the BackendService resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("service")]
        public virtual string Service { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of TargetTcpProxy resources.</summary>
    public class TargetTcpProxyList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of TargetTcpProxy resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<TargetTcpProxy> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a Target VPN Gateway resource.  The target VPN gateway resource represents a Classic Cloud VPN
    /// gateway. For more information, read the the Cloud VPN Overview. (== resource_for
    /// {$api_version}.targetVpnGateways ==)
    /// </summary>
    public class TargetVpnGateway : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] A list of URLs to the ForwardingRule resources. ForwardingRules are created using
        /// compute.forwardingRules.insert and associated with a VPN gateway.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("forwardingRules")]
        public virtual System.Collections.Generic.IList<string> ForwardingRules { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#targetVpnGateway for target VPN gateways.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// URL of the network to which this VPN gateway is attached. Provided by the client when the VPN gateway is
        /// created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the target VPN gateway resides. You must specify this field as part of
        /// the HTTP request URL. It is not settable as a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// [Output Only] The status of the VPN gateway, which can be one of the following: CREATING, READY, FAILED, or
        /// DELETING.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>
        /// [Output Only] A list of URLs to VpnTunnel resources. VpnTunnels are created using the
        /// compute.vpntunnels.insert method and associated with a VPN gateway.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("tunnels")]
        public virtual System.Collections.Generic.IList<string> Tunnels { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TargetVpnGatewayAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of TargetVpnGateway resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, TargetVpnGatewaysScopedList> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#targetVpnGateway for target VPN gateways.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of TargetVpnGateway resources.</summary>
    public class TargetVpnGatewayList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of TargetVpnGateway resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<TargetVpnGateway> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#targetVpnGateway for target VPN gateways.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class TargetVpnGatewaysScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of target VPN gateways contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetVpnGateways")]
        public virtual System.Collections.Generic.IList<TargetVpnGateway> TargetVpnGateways { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of addresses when the list is empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of addresses when the list is empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class TestFailure : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The actual output URL evaluated by load balancer containing the scheme, host, path and query parameters.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("actualOutputUrl")]
        public virtual string ActualOutputUrl { get; set; }

        /// <summary>Actual HTTP status code for rule with `urlRedirect` calculated by load balancer</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("actualRedirectResponseCode")]
        public virtual System.Nullable<int> ActualRedirectResponseCode { get; set; }

        /// <summary>BackendService or BackendBucket returned by load balancer.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("actualService")]
        public virtual string ActualService { get; set; }

        /// <summary>
        /// The expected output URL evaluated by load balancer containing the scheme, host, path and query parameters.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("expectedOutputUrl")]
        public virtual string ExpectedOutputUrl { get; set; }

        /// <summary>Expected HTTP status code for rule with `urlRedirect` calculated by load balancer</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("expectedRedirectResponseCode")]
        public virtual System.Nullable<int> ExpectedRedirectResponseCode { get; set; }

        /// <summary>Expected BackendService or BackendBucket resource the given URL should be mapped to.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("expectedService")]
        public virtual string ExpectedService { get; set; }

        /// <summary>HTTP headers of the request.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("headers")]
        public virtual System.Collections.Generic.IList<UrlMapTestHeader> Headers { get; set; }

        /// <summary>Host portion of the URL.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("host")]
        public virtual string Host { get; set; }

        /// <summary>Path portion including query parameters in the URL.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("path")]
        public virtual string Path { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TestPermissionsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The set of permissions to check for the 'resource'. Permissions with wildcards (such as '*' or 'storage.*')
        /// are not allowed.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("permissions")]
        public virtual System.Collections.Generic.IList<string> Permissions { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class TestPermissionsResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A subset of `TestPermissionsRequest.permissions` that the caller is allowed.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("permissions")]
        public virtual System.Collections.Generic.IList<string> Permissions { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a URL Map resource.  Google Compute Engine has two URL Map resources:  *
    /// [Global](/compute/docs/reference/rest/{$api_version}/urlMaps) *
    /// [Regional](/compute/docs/reference/rest/{$api_version}/regionUrlMaps)  A URL map resource is a component of
    /// certain types of GCP load balancers and Traffic Director.  * urlMaps are used by external HTTP(S) load balancers
    /// and Traffic Director. * regionUrlMaps are used by internal HTTP(S) load balancers.  For a list of supported URL
    /// map features by load balancer type, see the  Load balancing features: Routing and traffic management table.  For
    /// a list of supported URL map features for Traffic Director, see the  Traffic Director features: Routing and
    /// traffic management table.  This resource defines mappings from host names and URL paths to either a backend
    /// service or a backend bucket.  To use the global urlMaps resource, the backend service must have a
    /// loadBalancingScheme of either EXTERNAL or INTERNAL_SELF_MANAGED. To use the regionUrlMaps resource, the backend
    /// service must have a loadBalancingScheme of INTERNAL_MANAGED. For more information, read URL Map Concepts.
    /// </summary>
    public class UrlMap : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// defaultRouteAction takes effect when none of the  hostRules match. The load balancer performs advanced
        /// routing actions like URL rewrites, header transformations, etc. prior to forwarding the request to the
        /// selected backend. If defaultRouteAction specifies any weightedBackendServices, defaultService must not be
        /// set. Conversely if defaultService is set, defaultRouteAction cannot contain any  weightedBackendServices.
        /// Only one of defaultRouteAction or defaultUrlRedirect must be set. UrlMaps for external HTTP(S) load
        /// balancers support only the urlRewrite action within defaultRouteAction. defaultRouteAction has no effect
        /// when the URL map is bound to target gRPC proxy that has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("defaultRouteAction")]
        public virtual HttpRouteAction DefaultRouteAction { get; set; }

        /// <summary>
        /// The full or partial URL of the defaultService resource to which traffic is directed if none of the hostRules
        /// match. If defaultRouteAction is additionally specified, advanced routing actions like URL Rewrites, etc.
        /// take effect prior to sending the request to the backend. However, if defaultService is specified,
        /// defaultRouteAction cannot contain any weightedBackendServices. Conversely, if routeAction specifies any
        /// weightedBackendServices, service must not be specified. Only one of defaultService, defaultUrlRedirect  or
        /// defaultRouteAction.weightedBackendService must be set. defaultService has no effect when the URL map is
        /// bound to target gRPC proxy that has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("defaultService")]
        public virtual string DefaultService { get; set; }

        /// <summary>
        /// When none of the specified hostRules match, the request is redirected to a URL specified by
        /// defaultUrlRedirect. If defaultUrlRedirect is specified, defaultService or defaultRouteAction must not be
        /// set. Not supported when the URL map is bound to target gRPC proxy.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("defaultUrlRedirect")]
        public virtual HttpRedirectAction DefaultUrlRedirect { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// Fingerprint of this resource. A hash of the contents stored in this object. This field is used in optimistic
        /// locking. This field will be ignored when inserting a UrlMap. An up-to-date fingerprint must be provided in
        /// order to update the UrlMap, otherwise the request will fail with error 412 conditionNotMet.  To see the
        /// latest fingerprint, make a get() request to retrieve a UrlMap.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("fingerprint")]
        public virtual string Fingerprint { get; set; }

        /// <summary>
        /// Specifies changes to request and response headers that need to take effect for the selected backendService.
        /// The headerAction specified here take effect after headerAction specified under pathMatcher. Note that
        /// headerAction is not supported for Loadbalancers that have their loadBalancingScheme set to EXTERNAL. Not
        /// supported when the URL map is bound to target gRPC proxy that has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("headerAction")]
        public virtual HttpHeaderAction HeaderAction { get; set; }

        /// <summary>The list of HostRules to use against the URL.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("hostRules")]
        public virtual System.Collections.Generic.IList<HostRule> HostRules { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#urlMaps for url maps.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>The list of named PathMatchers to use against the URL.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("pathMatchers")]
        public virtual System.Collections.Generic.IList<PathMatcher> PathMatchers { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the regional URL map resides. This field is not applicable to global
        /// URL maps. You must specify this field as part of the HTTP request URL. It is not settable as a field in the
        /// request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// The list of expected URL mapping tests. Request to update this UrlMap will succeed only if all of the test
        /// cases pass. You can specify a maximum of 100 tests per UrlMap. Not supported when the URL map is bound to
        /// target gRPC proxy that has validateForProxyless field set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("tests")]
        public virtual System.Collections.Generic.IList<UrlMapTest> Tests { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of UrlMap resources.</summary>
    public class UrlMapList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of UrlMap resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<UrlMap> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class UrlMapReference : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("urlMap")]
        public virtual string UrlMap { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Message for the expected URL mappings.</summary>
    public class UrlMapTest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Description of this test case.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// The expected output URL evaluated by load balancer containing the scheme, host, path and query parameters.
        /// For rules that forward requests to backends, the test passes only when expectedOutputUrl matches the request
        /// forwarded by load balancer to backends. For rules with urlRewrite, the test verifies that the forwarded
        /// request matches hostRewrite and pathPrefixRewrite in the urlRewrite action. When service is specified,
        /// expectedOutputUrl`s scheme is ignored. For rules with urlRedirect, the test passes only if expectedOutputUrl
        /// matches the URL in the load balancer's redirect response. If urlRedirect specifies https_redirect, the test
        /// passes only if the scheme in expectedOutputUrl is also set to https. If urlRedirect specifies strip_query,
        /// the test passes only if expectedOutputUrl does not contain any query parameters. expectedOutputUrl is
        /// optional when service is specified.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("expectedOutputUrl")]
        public virtual string ExpectedOutputUrl { get; set; }

        /// <summary>
        /// For rules with urlRedirect, the test passes only if expectedRedirectResponseCode matches the HTTP status
        /// code in load balancer's redirect response. expectedRedirectResponseCode cannot be set when service is set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("expectedRedirectResponseCode")]
        public virtual System.Nullable<int> ExpectedRedirectResponseCode { get; set; }

        /// <summary>
        /// HTTP headers for this request. If headers contains a host header, then host must also match the header
        /// value.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("headers")]
        public virtual System.Collections.Generic.IList<UrlMapTestHeader> Headers { get; set; }

        /// <summary>
        /// Host portion of the URL. If headers contains a host header, then host must also match the header value.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("host")]
        public virtual string Host { get; set; }

        /// <summary>Path portion of the URL.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("path")]
        public virtual string Path { get; set; }

        /// <summary>
        /// Expected BackendService or BackendBucket resource the given URL should be mapped to. service cannot be set
        /// if expectedRedirectResponseCode is set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("service")]
        public virtual string Service { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>HTTP headers used in UrlMapTests.</summary>
    public class UrlMapTestHeader : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Header name.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>Header value.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("value")]
        public virtual string Value { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Message representing the validation result for a UrlMap.</summary>
    public class UrlMapValidationResult : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("loadErrors")]
        public virtual System.Collections.Generic.IList<string> LoadErrors { get; set; }

        /// <summary>
        /// Whether the given UrlMap can be successfully loaded. If false, 'loadErrors' indicates the reasons.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("loadSucceeded")]
        public virtual System.Nullable<bool> LoadSucceeded { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("testFailures")]
        public virtual System.Collections.Generic.IList<TestFailure> TestFailures { get; set; }

        /// <summary>
        /// If successfully loaded, this field indicates whether the test passed. If false, 'testFailures's indicate the
        /// reason of failure.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("testPassed")]
        public virtual System.Nullable<bool> TestPassed { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class UrlMapsAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of UrlMapsScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, UrlMapsScopedList> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class UrlMapsScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of UrlMaps contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("urlMaps")]
        public virtual System.Collections.Generic.IList<UrlMap> UrlMaps { get; set; }

        /// <summary>Informational warning which replaces the list of backend services when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of backend services when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class UrlMapsValidateRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Content of the UrlMap to be validated.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("resource")]
        public virtual UrlMap Resource { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class UrlMapsValidateResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("result")]
        public virtual UrlMapValidationResult Result { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>The spec for modifying the path before sending the request to the matched backend service.</summary>
    public class UrlRewrite : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Prior to forwarding the request to the selected service, the request's host header is replaced with contents
        /// of hostRewrite. The value must be between 1 and 255 characters.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("hostRewrite")]
        public virtual string HostRewrite { get; set; }

        /// <summary>
        /// Prior to forwarding the request to the selected backend service, the matching portion of the request's path
        /// is replaced by pathPrefixRewrite. The value must be between 1 and 1024 characters.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("pathPrefixRewrite")]
        public virtual string PathPrefixRewrite { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Subnetwork which the current user has compute.subnetworks.use permission on.</summary>
    public class UsableSubnetwork : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The range of internal addresses that are owned by this subnetwork.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipCidrRange")]
        public virtual string IpCidrRange { get; set; }

        /// <summary>Network URL.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>Secondary IP ranges.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("secondaryIpRanges")]
        public virtual System.Collections.Generic.IList<UsableSubnetworkSecondaryRange> SecondaryIpRanges { get; set; }

        /// <summary>Subnetwork URL.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("subnetwork")]
        public virtual string Subnetwork { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Secondary IP range of a usable subnetwork.</summary>
    public class UsableSubnetworkSecondaryRange : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The range of IP addresses belonging to this subnetwork secondary range.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipCidrRange")]
        public virtual string IpCidrRange { get; set; }

        /// <summary>
        /// The name associated with this subnetwork secondary range, used when adding an alias IP range to a VM
        /// instance. The name must be 1-63 characters long, and comply with RFC1035. The name must be unique within the
        /// subnetwork.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("rangeName")]
        public virtual string RangeName { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class UsableSubnetworksAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>[Output] A list of usable subnetwork URLs.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<UsableSubnetwork> Items { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#usableSubnetworksAggregatedList for aggregated lists of
        /// usable subnetworks.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// The location in Cloud Storage and naming method of the daily usage report. Contains bucket_name and report_name
    /// prefix.
    /// </summary>
    public class UsageExportLocation : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The name of an existing bucket in Cloud Storage where the usage report object is stored. The Google Service
        /// Account is granted write access to this bucket. This can either be the bucket name by itself, such as
        /// example-bucket, or the bucket name with gs:// or https://storage.googleapis.com/ in front of it, such as
        /// gs://example-bucket.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("bucketName")]
        public virtual string BucketName { get; set; }

        /// <summary>
        /// An optional prefix for the name of the usage report object stored in bucketName. If not supplied, defaults
        /// to usage. The report is stored as a CSV file named report_name_prefix_gce_YYYYMMDD.csv where YYYYMMDD is the
        /// day of the usage according to Pacific Time. If you supply a prefix, it should conform to Cloud Storage
        /// object naming conventions.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("reportNamePrefix")]
        public virtual string ReportNamePrefix { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contain information of Nat mapping for a VM endpoint (i.e., NIC).</summary>
    public class VmEndpointNatMappings : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>Name of the VM instance which the endpoint belongs to</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("instanceName")]
        public virtual string InstanceName { get; set; }

        [Newtonsoft.Json.JsonPropertyAttribute("interfaceNatMappings")]
        public virtual System.Collections.Generic.IList<VmEndpointNatMappingsInterfaceNatMappings> InterfaceNatMappings { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contain information of Nat mapping for an interface of this endpoint.</summary>
    public class VmEndpointNatMappingsInterfaceNatMappings : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// List of all drain IP:port-range mappings assigned to this interface. These ranges are inclusive, that is,
        /// both the first and the last ports can be used for NAT. Example: ["2.2.2.2:12345-12355",
        /// "1.1.1.1:2234-2234"].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("drainNatIpPortRanges")]
        public virtual System.Collections.Generic.IList<string> DrainNatIpPortRanges { get; set; }

        /// <summary>
        /// A list of all IP:port-range mappings assigned to this interface. These ranges are inclusive, that is, both
        /// the first and the last ports can be used for NAT. Example: ["2.2.2.2:12345-12355", "1.1.1.1:2234-2234"].
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("natIpPortRanges")]
        public virtual System.Collections.Generic.IList<string> NatIpPortRanges { get; set; }

        /// <summary>
        /// Total number of drain ports across all NAT IPs allocated to this interface. It equals to the aggregated port
        /// number in the field drain_nat_ip_port_ranges.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("numTotalDrainNatPorts")]
        public virtual System.Nullable<int> NumTotalDrainNatPorts { get; set; }

        /// <summary>
        /// Total number of ports across all NAT IPs allocated to this interface. It equals to the aggregated port
        /// number in the field nat_ip_port_ranges.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("numTotalNatPorts")]
        public virtual System.Nullable<int> NumTotalNatPorts { get; set; }

        /// <summary>
        /// Alias IP range for this interface endpoint. It will be a private (RFC 1918) IP range. Examples:
        /// "10.33.4.55/32", or "192.168.5.0/24".
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceAliasIpRange")]
        public virtual string SourceAliasIpRange { get; set; }

        /// <summary>Primary IP of the VM for this NIC.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sourceVirtualIp")]
        public virtual string SourceVirtualIp { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of VmEndpointNatMappings.</summary>
    public class VmEndpointNatMappingsList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>
        /// [Output Only] Type of resource. Always compute#vmEndpointNatMappingsList for lists of Nat mappings of VM
        /// endpoints.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] A list of Nat mapping information of VM endpoints.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("result")]
        public virtual System.Collections.Generic.IList<VmEndpointNatMappings> Result { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a HA VPN gateway.  HA VPN is a high-availability (HA) Cloud VPN solution that lets you securely
    /// connect your on-premises network to your Google Cloud Virtual Private Cloud network through an IPsec VPN
    /// connection in a single region. For more information about Cloud HA VPN solutions, see  Cloud VPN topologies .
    /// (== resource_for {$api_version}.vpnGateways ==)
    /// </summary>
    public class VpnGateway : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#vpnGateway for VPN gateways.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// A fingerprint for the labels being applied to this VpnGateway, which is essentially a hash of the labels set
        /// used for optimistic locking. The fingerprint is initially generated by Compute Engine and changes after
        /// every request to modify or update labels. You must always provide an up-to-date fingerprint hash in order to
        /// update or change labels, otherwise the request will fail with error 412 conditionNotMet.  To see the latest
        /// fingerprint, make a get() request to retrieve an VpnGateway.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labelFingerprint")]
        public virtual string LabelFingerprint { get; set; }

        /// <summary>
        /// Labels for this resource. These can only be added or modified by the setLabels method. Each label key/value
        /// pair must comply with RFC1035. Label values may be empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// URL of the network to which this VPN gateway is attached. Provided by the client when the VPN gateway is
        /// created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("network")]
        public virtual string Network { get; set; }

        /// <summary>[Output Only] URL of the region where the VPN gateway resides.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>A list of interfaces on this VPN gateway.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("vpnInterfaces")]
        public virtual System.Collections.Generic.IList<VpnGatewayVpnGatewayInterface> VpnInterfaces { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class VpnGatewayAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of VpnGateway resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, VpnGatewaysScopedList> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#vpnGateway for VPN gateways.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of VpnGateway resources.</summary>
    public class VpnGatewayList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of VpnGateway resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<VpnGateway> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#vpnGateway for VPN gateways.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class VpnGatewayStatus : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>List of VPN connection for this VpnGateway.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("vpnConnections")]
        public virtual System.Collections.Generic.IList<VpnGatewayStatusVpnConnection> VpnConnections { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Describes the high availability requirement state for the VPN connection between this Cloud VPN gateway and a
    /// peer gateway.
    /// </summary>
    public class VpnGatewayStatusHighAvailabilityRequirementState : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Indicates the high availability requirement state for the VPN connection. Valid values are
        /// CONNECTION_REDUNDANCY_MET, CONNECTION_REDUNDANCY_NOT_MET.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("state")]
        public virtual string State { get; set; }

        /// <summary>
        /// Indicates the reason why the VPN connection does not meet the high availability redundancy
        /// criteria/requirement. Valid values is INCOMPLETE_TUNNELS_COVERAGE.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unsatisfiedReason")]
        public virtual string UnsatisfiedReason { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains some information about a VPN tunnel.</summary>
    public class VpnGatewayStatusTunnel : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The VPN gateway interface this VPN tunnel is associated with.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("localGatewayInterface")]
        public virtual System.Nullable<long> LocalGatewayInterface { get; set; }

        /// <summary>
        /// The peer gateway interface this VPN tunnel is connected to, the peer gateway could either be an external VPN
        /// gateway or GCP VPN gateway.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerGatewayInterface")]
        public virtual System.Nullable<long> PeerGatewayInterface { get; set; }

        /// <summary>URL reference to the VPN tunnel.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("tunnelUrl")]
        public virtual string TunnelUrl { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// A VPN connection contains all VPN tunnels connected from this VpnGateway to the same peer gateway. The peer
    /// gateway could either be a external VPN gateway or GCP VPN gateway.
    /// </summary>
    public class VpnGatewayStatusVpnConnection : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// URL reference to the peer external VPN gateways to which the VPN tunnels in this VPN connection are
        /// connected. This field is mutually exclusive with peer_gcp_gateway.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerExternalGateway")]
        public virtual string PeerExternalGateway { get; set; }

        /// <summary>
        /// URL reference to the peer side VPN gateways to which the VPN tunnels in this VPN connection are connected.
        /// This field is mutually exclusive with peer_gcp_gateway.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerGcpGateway")]
        public virtual string PeerGcpGateway { get; set; }

        /// <summary>HighAvailabilityRequirementState for the VPN connection.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("state")]
        public virtual VpnGatewayStatusHighAvailabilityRequirementState State { get; set; }

        /// <summary>List of VPN tunnels that are in this VPN connection.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("tunnels")]
        public virtual System.Collections.Generic.IList<VpnGatewayStatusTunnel> Tunnels { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>A VPN gateway interface.</summary>
    public class VpnGatewayVpnGatewayInterface : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>The numeric ID of this VPN gateway interface.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<long> Id { get; set; }

        /// <summary>[Output Only] The external IP address for this VPN gateway interface.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ipAddress")]
        public virtual string IpAddress { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class VpnGatewaysGetStatusResponse : Google.Apis.Requests.IDirectResponseSchema
    {
        [Newtonsoft.Json.JsonPropertyAttribute("result")]
        public virtual VpnGatewayStatus Result { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class VpnGatewaysScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] A list of VPN gateways contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("vpnGateways")]
        public virtual System.Collections.Generic.IList<VpnGateway> VpnGateways { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of addresses when the list is empty.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>
        /// [Output Only] Informational warning which replaces the list of addresses when the list is empty.
        /// </summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>
    /// Represents a Cloud VPN Tunnel resource.  For more information about VPN, read the  the Cloud VPN Overview. (==
    /// resource_for {$api_version}.vpnTunnels ==)
    /// </summary>
    public class VpnTunnel : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>
        /// An optional description of this resource. Provide this property when you create the resource.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>[Output Only] Detailed status message for the VPN tunnel.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("detailedStatus")]
        public virtual string DetailedStatus { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>
        /// IKE protocol version to use when establishing the VPN tunnel with the peer VPN gateway. Acceptable IKE
        /// versions are 1 or 2. The default version is 2.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("ikeVersion")]
        public virtual System.Nullable<int> IkeVersion { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#vpnTunnel for VPN tunnels.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// Local traffic selector to use when establishing the VPN tunnel with the peer VPN gateway. The value should
        /// be a CIDR formatted string, for example: 192.168.0.0/16. The ranges must be disjoint. Only IPv4 is
        /// supported.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("localTrafficSelector")]
        public virtual System.Collections.Generic.IList<string> LocalTrafficSelector { get; set; }

        /// <summary>
        /// Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters
        /// long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular
        /// expression `[a-z]([-a-z0-9]*[a-z0-9])?` which means the first character must be a lowercase letter, and all
        /// following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be
        /// a dash.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>
        /// URL of the peer side external VPN gateway to which this VPN tunnel is connected. Provided by the client when
        /// the VPN tunnel is created. This field is exclusive with the field peerGcpGateway.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerExternalGateway")]
        public virtual string PeerExternalGateway { get; set; }

        /// <summary>
        /// The interface ID of the external VPN gateway to which this VPN tunnel is connected. Provided by the client
        /// when the VPN tunnel is created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerExternalGatewayInterface")]
        public virtual System.Nullable<int> PeerExternalGatewayInterface { get; set; }

        /// <summary>
        /// URL of the peer side HA GCP VPN gateway to which this VPN tunnel is connected. Provided by the client when
        /// the VPN tunnel is created. This field can be used when creating highly available VPN from VPC network to VPC
        /// network, the field is exclusive with the field peerExternalGateway. If provided, the VPN tunnel will
        /// automatically use the same vpnGatewayInterface ID in the peer GCP VPN gateway.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerGcpGateway")]
        public virtual string PeerGcpGateway { get; set; }

        /// <summary>IP address of the peer VPN gateway. Only IPv4 is supported.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("peerIp")]
        public virtual string PeerIp { get; set; }

        /// <summary>
        /// [Output Only] URL of the region where the VPN tunnel resides. You must specify this field as part of the
        /// HTTP request URL. It is not settable as a field in the request body.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>
        /// Remote traffic selectors to use when establishing the VPN tunnel with the peer VPN gateway. The value should
        /// be a CIDR formatted string, for example: 192.168.0.0/16. The ranges should be disjoint. Only IPv4 is
        /// supported.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("remoteTrafficSelector")]
        public virtual System.Collections.Generic.IList<string> RemoteTrafficSelector { get; set; }

        /// <summary>URL of the router resource to be used for dynamic routing.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("router")]
        public virtual string Router { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>
        /// Shared secret used to set the secure session between the Cloud VPN gateway and the peer VPN gateway.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sharedSecret")]
        public virtual string SharedSecret { get; set; }

        /// <summary>Hash of the shared secret.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("sharedSecretHash")]
        public virtual string SharedSecretHash { get; set; }

        /// <summary>
        /// [Output Only] The status of the VPN tunnel, which can be one of the following:  - PROVISIONING: Resource is
        /// being allocated for the VPN tunnel.  - WAITING_FOR_FULL_CONFIG: Waiting to receive all VPN-related configs
        /// from the user. Network, TargetVpnGateway, VpnTunnel, ForwardingRule, and Route resources are needed to setup
        /// the VPN tunnel.  - FIRST_HANDSHAKE: Successful first handshake with the peer VPN.  - ESTABLISHED: Secure
        /// session is successfully established with the peer VPN.  - NETWORK_ERROR: Deprecated, replaced by
        /// NO_INCOMING_PACKETS  - AUTHORIZATION_ERROR: Auth error (for example, bad shared secret).  -
        /// NEGOTIATION_FAILURE: Handshake failed.  - DEPROVISIONING: Resources are being deallocated for the VPN
        /// tunnel.  - FAILED: Tunnel creation has failed and the tunnel is not ready to be used.  -
        /// NO_INCOMING_PACKETS: No incoming packets from peer.  - REJECTED: Tunnel configuration was rejected, can be
        /// result of being blacklisted.  - ALLOCATING_RESOURCES: Cloud VPN is in the process of allocating all required
        /// resources.  - STOPPED: Tunnel is stopped due to its Forwarding Rules being deleted for Classic VPN tunnels
        /// or the project is in frozen state.  - PEER_IDENTITY_MISMATCH: Peer identity does not match peer IP, probably
        /// behind NAT.  - TS_NARROWING_NOT_ALLOWED: Traffic selector narrowing not allowed for an HA-VPN tunnel.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>
        /// URL of the Target VPN gateway with which this VPN tunnel is associated. Provided by the client when the VPN
        /// tunnel is created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("targetVpnGateway")]
        public virtual string TargetVpnGateway { get; set; }

        /// <summary>
        /// URL of the VPN gateway with which this VPN tunnel is associated. Provided by the client when the VPN tunnel
        /// is created. This must be used (instead of target_vpn_gateway) if a High Availability VPN gateway resource is
        /// created.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("vpnGateway")]
        public virtual string VpnGateway { get; set; }

        /// <summary>The interface ID of the VPN gateway with which this VPN tunnel is associated.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("vpnGatewayInterface")]
        public virtual System.Nullable<int> VpnGatewayInterface { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class VpnTunnelAggregatedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of VpnTunnelsScopedList resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IDictionary<string, VpnTunnelsScopedList> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#vpnTunnel for VPN tunnels.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Unreachable resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("unreachables")]
        public virtual System.Collections.Generic.IList<string> Unreachables { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Contains a list of VpnTunnel resources.</summary>
    public class VpnTunnelList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of VpnTunnel resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<VpnTunnel> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#vpnTunnel for VPN tunnels.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class VpnTunnelsScopedList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>A list of VPN tunnels contained in this scope.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("vpnTunnels")]
        public virtual System.Collections.Generic.IList<VpnTunnel> VpnTunnels { get; set; }

        /// <summary>Informational warning which replaces the list of addresses when the list is empty.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>Informational warning which replaces the list of addresses when the list is empty.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class WafExpressionSet : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// A list of alternate IDs. The format should be: - E.g. XSS-stable Generic suffix like "stable" is
        /// particularly useful if a policy likes to avail newer set of expressions without having to change the policy.
        /// A given alias name can't be used for more than one entity set.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("aliases")]
        public virtual System.Collections.Generic.IList<string> Aliases { get; set; }

        /// <summary>List of available expressions.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("expressions")]
        public virtual System.Collections.Generic.IList<WafExpressionSetExpression> Expressions { get; set; }

        /// <summary>Google specified expression set ID. The format should be: - E.g. XSS-20170329</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class WafExpressionSetExpression : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Expression ID should uniquely identify the origin of the expression. E.g. owasp-crs-v020901-id973337
        /// identifies Owasp core rule set version 2.9.1 rule id 973337. The ID could be used to determine the
        /// individual attack definition that has been detected. It could also be used to exclude it from the policy in
        /// case of false positive.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// In contrast to a single BackendService in  HttpRouteAction to which all matching traffic is directed to,
    /// WeightedBackendService allows traffic to be split across multiple BackendServices. The volume of traffic for
    /// each BackendService is proportional to the weight specified in each WeightedBackendService
    /// </summary>
    public class WeightedBackendService : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The full or partial URL to the default BackendService resource. Before forwarding the request to
        /// backendService, the loadbalancer applies any relevant headerActions specified as part of this
        /// backendServiceWeight.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("backendService")]
        public virtual string BackendService { get; set; }

        /// <summary>
        /// Specifies changes to request and response headers that need to take effect for the selected backendService.
        /// headerAction specified here take effect before headerAction in the enclosing HttpRouteRule, PathMatcher and
        /// UrlMap. Note that headerAction is not supported for Loadbalancers that have their loadBalancingScheme set to
        /// EXTERNAL. Not supported when the URL map is bound to target gRPC proxy that has validateForProxyless field
        /// set to true.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("headerAction")]
        public virtual HttpHeaderAction HeaderAction { get; set; }

        /// <summary>
        /// Specifies the fraction of traffic sent to backendService, computed as weight / (sum of all
        /// weightedBackendService weights in routeAction) . The selection of a backend service is determined only for
        /// new traffic. Once a user's request has been directed to a backendService, subsequent requests will be sent
        /// to the same backendService as determined by the BackendService's session affinity policy. The value must be
        /// between 0 and 1000
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("weight")]
        public virtual System.Nullable<long> Weight { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class XpnHostList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>[Output Only] A list of shared VPC host project URLs.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Project> Items { get; set; }

        /// <summary>[Output Only] Type of resource. Always compute#xpnHostList for lists of shared VPC hosts.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    /// <summary>Service resource (a.k.a service project) ID.</summary>
    public class XpnResourceId : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The ID of the service resource. In the case of projects, this field supports project id (e.g.,
        /// my-project-123) and project number (e.g. 12345678).
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>The type of the service resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("type")]
        public virtual string Type { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>
    /// Represents a Zone resource.  A zone is a deployment area. These deployment areas are subsets of a region. For
    /// example the zone us-east1-a is located in the us-east1 region. For more information, read Regions and Zones. (==
    /// resource_for {$api_version}.zones ==)
    /// </summary>
    public class Zone : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Available cpu/platform selections for the zone.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("availableCpuPlatforms")]
        public virtual System.Collections.Generic.IList<string> AvailableCpuPlatforms { get; set; }

        /// <summary>[Output Only] Creation timestamp in RFC3339 text format.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("creationTimestamp")]
        public virtual string CreationTimestamp { get; set; }

        /// <summary>[Output Only] The deprecation status associated with this zone.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("deprecated")]
        public virtual DeprecationStatus Deprecated { get; set; }

        /// <summary>[Output Only] Textual description of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("description")]
        public virtual string Description { get; set; }

        /// <summary>
        /// [Output Only] The unique identifier for the resource. This identifier is defined by the server.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual System.Nullable<ulong> Id { get; set; }

        /// <summary>[Output Only] Type of the resource. Always compute#zone for zones.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>[Output Only] Name of the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("name")]
        public virtual string Name { get; set; }

        /// <summary>[Output Only] Full URL reference to the region which hosts the zone.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("region")]
        public virtual string Region { get; set; }

        /// <summary>[Output Only] Server-defined URL for the resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Status of the zone, either UP or DOWN.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("status")]
        public virtual string Status { get; set; }

        /// <summary>[Output Only] Reserved for future use.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("supportsPzs")]
        public virtual System.Nullable<bool> SupportsPzs { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    /// <summary>Contains a list of zone resources.</summary>
    public class ZoneList : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>[Output Only] Unique identifier for the resource; defined by the server.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("id")]
        public virtual string Id { get; set; }

        /// <summary>A list of Zone resources.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("items")]
        public virtual System.Collections.Generic.IList<Zone> Items { get; set; }

        /// <summary>Type of resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("kind")]
        public virtual string Kind { get; set; }

        /// <summary>
        /// [Output Only] This token allows you to get the next page of results for list requests. If the number of
        /// results is larger than maxResults, use the nextPageToken as a value for the query parameter pageToken in the
        /// next list request. Subsequent list requests will have their own nextPageToken to continue paging through the
        /// results.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("nextPageToken")]
        public virtual string NextPageToken { get; set; }

        /// <summary>[Output Only] Server-defined URL for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("selfLink")]
        public virtual string SelfLink { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("warning")]
        public virtual WarningData Warning { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }

        /// <summary>[Output Only] Informational warning message.</summary>
        public class WarningData
        {
            /// <summary>
            /// [Output Only] A warning code, if applicable. For example, Compute Engine returns NO_RESULTS_ON_PAGE if
            /// there are no results in the response.
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("code")]
            public virtual string Code { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            [Newtonsoft.Json.JsonPropertyAttribute("data")]
            public virtual System.Collections.Generic.IList<DataData> Data { get; set; }

            /// <summary>[Output Only] A human-readable description of the warning code.</summary>
            [Newtonsoft.Json.JsonPropertyAttribute("message")]
            public virtual string Message { get; set; }

            /// <summary>
            /// [Output Only] Metadata about this warning in key: value format. For example: "data": [ { "key": "scope",
            /// "value": "zones/us-east1-d" }
            /// </summary>
            public class DataData
            {
                /// <summary>
                /// [Output Only] A key that provides more detail on the warning being returned. For example, for
                /// warnings where there are no results in a list request for a particular zone, this key might be scope
                /// and the key value might be the zone name. Other examples might be a key indicating a deprecated
                /// resource and a suggested replacement, or a warning about invalid network settings (for example, if
                /// an instance attempts to perform IP forwarding but is not enabled for IP forwarding).
                /// </summary>
                [Newtonsoft.Json.JsonPropertyAttribute("key")]
                public virtual string Key { get; set; }

                /// <summary>[Output Only] A warning data value corresponding to the key.</summary>
                [Newtonsoft.Json.JsonPropertyAttribute("value")]
                public virtual string Value { get; set; }
            }
        }
    }

    public class ZoneSetLabelsRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// The fingerprint of the previous set of labels for this resource, used to detect conflicts. The fingerprint
        /// is initially generated by Compute Engine and changes after every request to modify or update labels. You
        /// must always provide an up-to-date fingerprint hash in order to update or change labels. Make a get() request
        /// to the resource to get the latest fingerprint.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labelFingerprint")]
        public virtual string LabelFingerprint { get; set; }

        /// <summary>The labels to set for this resource.</summary>
        [Newtonsoft.Json.JsonPropertyAttribute("labels")]
        public virtual System.Collections.Generic.IDictionary<string, string> Labels { get; set; }

        /// <summary>The ETag of the item.</summary>
        public virtual string ETag { get; set; }
    }

    public class ZoneSetPolicyRequest : Google.Apis.Requests.IDirectResponseSchema
    {
        /// <summary>
        /// Flatten Policy to create a backwacd compatible wire-format. Deprecated. Use 'policy' to specify bindings.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("bindings")]
        public virtual System.Collections.Generic.IList<Binding> Bindings { get; set; }

        /// <summary>
        /// Flatten Policy to create a backward compatible wire-format. Deprecated. Use 'policy' to specify the etag.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("etag")]
        public virtual string ETag { get; set; }

        /// <summary>
        /// REQUIRED: The complete policy to be applied to the 'resource'. The size of the policy is limited to a few
        /// 10s of KB. An empty policy is in general a valid policy but certain services (like Projects) might reject
        /// them.
        /// </summary>
        [Newtonsoft.Json.JsonPropertyAttribute("policy")]
        public virtual Policy Policy { get; set; }
    }
}
